#/*Makefile.inc
# *
# *---------------------------------------------------------------------------
# *                                                                      
# *                  I N T E L   P R O P R I E T A R Y                   
# *                                                                      
# *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
# *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
# *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
# *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
# *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
# *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
# *     THE PRIOR WRITTEN PERMISSION OF :                                
# *                                                                      
# *                        INTEL  CORPORATION                            
# *                                                                     
# *                     2200 MISSION COLLEGE BLVD                        
# *                                                                      
# *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
# *                                                                      
# *---------------------------------------------------------------------------
# *
# *
# *  system: IXP2400
# *  subsystem: DIAG
# *  author: ccm, May 16, 02
# * 
# * --------------------------------------------------------------------------
# */


######################
# Complilation flags #
######################

B_ENDIAN = 1			#comment out for little endian and make mods to hal_platform_setup.h
INT_TEST_FLAG = 1		#comment out to exclude internal test functions
EMI_TEST_FLAG = 1		#comment out to compile normal instead of for EMI testing
#QDR = -DQDR1			#comment out for QDR2

ifdef B_ENDIAN
	ENDIAN = -mbig-endian -D__ARMEB__
endif

OTHER_FLAGS = $(QDR) $(ENDIAN)

ifdef INT_TEST_FLAG
	OTHER_FLAGS += -DINTERNAL_TEST
endif

ifdef EMI_TEST_FLAG
	OTHER_FLAGS += -DEMI
endif

ifdef NPU_SCREEN
	OTHER_FLAGS += -DNPU_SCREEN
endif

TOPDIR = C:/phase9rel/diag
LIB_DIR = C:/cygwin/xscale-010827/H-i686-pc-cygwin

PREFIX = xscale-elf
CC = $(PREFIX)-gcc
AS = $(PREFIX)-as
LD = $(PREFIX)-ld
OBJ_DUMP = $(PREFIX)-objdump
OBJ_COPY = $(PREFIX)-objcopy

SWAP = ./swapbytes_x86-win32

INCLUDE = \
-I$(TOPDIR)/include \
-I$(TOPDIR)/bic/include \
-I$(TOPDIR)/media/battery_dw/driver/src \
-I$(TOPDIR)/media/battery_dw/appl/src \
-I$(TOPDIR)/media/ptlone/src/include \
-I$(TOPDIR)/include/microcode

CFLAGS = -Wall -Wpointer-arith -Winline -Woverloaded-virtual \
		 -mcpu=xscale -mapcs-frame -g -O2 \
		 -fno-rtti -fno-exceptions -fvtable-gc -finit-priority \
		 $(OTHER_FLAGS)
LFLAGS = --gc-sections -static -g -O2 -nostdlib
#missing -Wstrict-prototypes -Wundef
