#ifndef ONCE_HAL_IXDP2400_H
#define ONCE_HAL_IXDP2400_H
@@ hal_ixdp2400_arm.h
@@ ---------------------------------------------------------------------------
@@                 Copyright (c) 2002, 2003 Intel Corporation
@@						 All rights reserved.
@@ Redistribution and use in source and binary forms, with or without
@@ modification, are permitted provided that the following conditions are met:
@@ * Redistributions of source code must retain the above copyright notice,
@@ this list of conditions and the following disclaimer. 
@@ * Redistributions in binary form must reproduce the above copyright notice,
@@ this list of conditions and the following disclaimer in the documentation
@@ and/or other materials provided with the distribution. 
@@ * Neither the name of Intel Corporation nor the names of its contributors
@@ may be used to endorse or promote products derived from this software
@@ without specific prior written permission. 
@@ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
@@ "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
@@ TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
@@ PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
@@ CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
@@ EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
@@ PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
@@ OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
@@ WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
@@ OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
@@ ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                      
@@ ---------------------------------------------------------------------------
@@ system: IXP2400
@@ subsystem: DIAG
@@ author: lagarwal, Feb 13, 02
@@ revisions:
@@ --------------------------------------------------------------------------

.equ BOOT_THRU_BM			,		(1 << 31)
.equ BOOT_DONT_INIT_PCI		,		(1 << 30)

.equ RAM_BASE				,		0x0
.equ RAM_SIZE				,		(256 * 1024 * 1024)
.equ SLAVE_POST_FLAG_LOC	,		0x1FFFFC
.equ POST_INCOMPLETE		,		0x0
.equ POST_COMPLETE			,		0x1

.equ SRAM_BASE				,		0x80000000
.equ MIN_SRAM_SIZE			,		(4 * 1024 * 1024) /* 4MB SRAM */
.equ MAX_SRAM_SIZE			,		(32 * 1024 * 1024) /* 32MB SRAM */
.equ MAX_SRAM_SIZE_CSR_VAL	,		(5 << 7)
.equ SRAM_COMPARE_LOCATION	,		0x101000
.equ SRAM_TEST_LOCATION		,		0x1000
.equ SRAM_SIZE_LOOPS		,		4
.equ TEST_PAT				,		0x12345678
.equ COMPARISON_PAT			,		0xAA55AA55
.equ MAX_QDR_CHANNEL		,		2

.equ PCI_MEM_PAGE_MASK		,		0xE0000000

.equ SLOW_PORT_BASE			,		0xC4000000

.equ SCRATCHPAD_BASE		,		0xCA000000




.equ CSR_BAR				,		0
.equ SRAM_BAR				,		1
.equ SDRAM_BAR				,		2

.equ CPLD_CSR_BASE			,		(SLOW_PORT_BASE + 0x3000000)

.equ SYSTEM_LED_REG_OFF		,		0x0
.equ ALPHANUM_DIS_DATA_OFF	,		0x4
.equ SYS_CLOCK_SPEED_OFF	,		0x8
.equ CPLD_INT_OFF			,		0xC
.equ CPLD_REV_OFF			,		0x10
.equ SYS_CLK_M_OFF			,		0x14
.equ SYS_CLK_N_OFF			,		0x18
.equ CPLD_INT_MASK_OFF		,		0x48

.equ SYSTEM_LED				,		(CPLD_CSR_BASE + SYSTEM_LED_REG_OFF)
.equ ALPHANUM_DIS_DATA		,		(CPLD_CSR_BASE + ALPHANUM_DIS_DATA_OFF)
.equ SYS_CLOCK_SPEED		,		(CPLD_CSR_BASE + SYS_CLOCK_SPEED_OFF)
.equ CPLD_INT				,		(CPLD_CSR_BASE + CPLD_INT_OFF)
.equ CPLD_REV				,		(CPLD_CSR_BASE + CPLD_REV_OFF)
.equ SYS_CLK_M				,		(CPLD_CSR_BASE + SYS_CLK_M_OFF)
.equ SYS_CLK_N				,		(CPLD_CSR_BASE + SYS_CLK_N_OFF)
.equ CPLD_INT_MASK			,		(CPLD_CSR_BASE + CPLD_INT_MASK_OFF)

@@ encodings for the 4 char alphanum display

.equ WRITE_TO_CHAR_RAM		,		0x48
.equ DISPLAY_ASCII			,		0x18

.equ USE_8_BIT_DATA			,		0x1
.equ USE_32_BIT_DATA		,		0x0

.equ WR_HD					,		0x1
.equ WR_PW					,		0x2
.equ WR_SU					,		0x0
.equ SP_WTC1_VAL			,		(WR_SU << 6 | WR_PW << 2 | WR_HD)

.equ NO_BOOT_ROM			,		0x0
.equ CFG_PCI_BOOT_HOST		,		(1 << 2)
.equ CFG_PROM_BOOT			,		(1 << 1)

.equ IXP2400_VENDOR_ID		,		0x8086
.equ IXP2400_DEVICE_ID		,		0x9001

.equ WDOG_RST_ENABLE		,		(1 << 24)
.equ INIT_COMP				,		(1 << 21)
.equ RSTALL					,		(1 << 16)
.equ PCIRST					,		(1 << 2)
.equ RESET_PCI				,		(1 << 1)
.equ RESET_XSCALE			,		(1 << 0)
.equ NOT_RESET_PCI			,		~(PCIRST | RESET_PCI)

.equ PCI_CONTROL_BE_DEO		,		(1 << 22) /* PCI Big Endian Data Enable Out */
.equ PCI_CONTROL_BE_DEI		,		(1 << 21) /* PCI Big Endian Data Enable In */
.equ PCI_CONTROL_BE_BEO		,		(1 << 20) /* PCI Big Endian Byte Enable Out */
.equ PCI_CONTROL_BE_BEI		,		(1 << 19) /* PCI Big Endian Byte Enable In */

.equ SRAM_200MHZ_DIVISOR	,		0x3
.equ SRAM_150MHZ_DIVISOR	,		0x4
.equ SDRAM_DIVISOR			,		0x4		@@ 4:150Mhz, 6:100Mhz

.equ PIPELINE				,		(1 << 10)
.equ PARITY_ENABLE			,		(1 << 3)

.equ FLASH_WRITE_ENABLE		,		(1 << 9)
.equ FLASH_ALIAS_DISABLE	,		(1 << 8)

.equ DDR_RX_DLL_VAL			,		0x11
.equ DDR_RX_DESKEW_VAL		,		0x11
.equ DDR_RDDLYSEL_RECEN_VAL	,		0x11
.equ DDR_RCOMP_IO_CONFIG_VAL,		0x0

.equ TCL					,		(1 << 2)
.equ TRC					,		(1 << 6)
.equ TWTR					,		(1 << 10)
.equ REF_EN					,		(1 << 14)
.equ REF_COUNT				,		(10 << 15)
.equ NUM_ROW_COL_32_8		,		(3 << 23)
.equ NUM_ROW_COL_64_8		,		(4 << 23)
.equ NUM_SIDES				,		(1 << 26)
.equ TRRD					,		(1 << 28)
.equ DU_CONTROL_VAL			,		(TRRD | NUM_SIDES | NUM_ROW_COL_32_8 | REF_COUNT | REF_EN | TWTR | TRC | TCL)
.equ DU_CONTROL_VAL_1G		,		(TRRD | NUM_SIDES | NUM_ROW_COL_64_8 | REF_COUNT | REF_EN | TWTR | TRC | TCL)

.equ RESET_DLL				,		0x100
.equ LOAD_MODE_NORMAL		,		0x62
.equ PRECHARGE_ALL			,		(1 << 10)
.equ EXT_LD_MODE			,		(1 << 12)
.equ SIDE0					,		(1 << 14)
.equ SIDE1					,		(1 << 15)
.equ CKE					,		(1 << 16)
.equ PRECHARGE				,		(1 << 29)
.equ REFRESH				,		(1 << 30)
.equ  LD_MODE_REG			,		(1 << 31)

.equ DISABLE_CHK			,		(1 << 8)

.equ SOFT_INT				,		(1 << 0)
.equ ERROR_SUM				,		(1 << 1)
.equ UART_INT				,		(1 << 2)
.equ GPIO_INT				,		(1 << 3)
.equ TIMER_UFLOW			,		(0xF << 4)
.equ SP_INT					,		(1 << 8)
.equ PCI_INT				,		(1 << 15)
.equ PCI_DOORBELL			,		(1 << 13)

.equ IRQ_ENABLE_SET_VAL		,		(PCI_DOORBELL | SP_INT | TIMER_UFLOW | GPIO_INT | UART_INT | ERROR_SUM | SOFT_INT)

.equ PCIIM					,		(1 << 25)
.equ PILM					,		(3 << 26)

.equ XSCALE_INT_ENABLE_VAL	,		(PILM | PCIIM)

.equ ACTIVATE_TIMER			,		(1 << 7)

.equ T1_CTL_VAL				,		ACTIVATE_TIMER

.equ CLEAR_INT				,		1

.equ T1_CLR_VAL				,		CLEAR_INT

.equ IO_SPACE_ENABLE		,		(1 << 0)
.equ MEM_SPACE_ENABLE		,		(1 << 1)
.equ BUS_MASTER_ENABLE		,		(1 << 2)
.equ WR_INV_ENABLE			,		(1 << 4)

.equ PCI_CMD_STAT_VAL		,		(WR_INV_ENABLE | BUS_MASTER_ENABLE | MEM_SPACE_ENABLE | IO_SPACE_ENABLE)

.equ XSIM					,		~(1 << 1)

.equ PCI_ADDR_EXT_VAL		,		0xD800E000

/* Global control registers */
.equ GLOBAL_CONTROL_BASE	,		0xC0004A00

.equ PRODUCT_ID_OFF         ,       0x0
.equ MISC_CONTROL_OFF		,		0x4
.equ IXP_RESET0_OFF			,		0xC
.equ CCR_OFF				,		0x14
.equ STRAP_OPTIONS_OFF		,		0x18

.equ PRODUCT_ID				,       (GLOBAL_CONTROL_BASE + PRODUCT_ID_OFF)
.equ MISC_CONTROL			,		(GLOBAL_CONTROL_BASE + MISC_CONTROL_OFF)
.equ IXP_RESET0				,		(GLOBAL_CONTROL_BASE + IXP_RESET0_OFF)
.equ CCR					,		(GLOBAL_CONTROL_BASE + CCR_OFF)
.equ STRAP_OPTIONS			,		(GLOBAL_CONTROL_BASE + STRAP_OPTIONS_OFF)

/* Timer registers */
.equ TIMER_CSR_BASE			,		0xC0020000

.equ T1_CTL_OFF				,		0x0
.equ T1_CLD_OFF				,		0x10
.equ T1_CSR_OFF				,		0x20
.equ T1_CLR_OFF				,		0x30

/* slowport registers */
.equ SLOWPORT_REGISTER_BASE	,		0xC0080000

.equ SP_CCR_OFF				,		0x0
.equ SP_WTC1_OFF			,		0x4
.equ SP_WTC2_OFF			,		0x8
.equ SP_RTC1_OFF			,		0xC
.equ SP_RTC2_OFF			,		0x10
.equ SP_FAC_OFF				,		0x20
.equ SP_FRM_OFF				,		0x24

.equ SP_CCR					,		(SLOWPORT_REGISTER_BASE + SP_CCR_OFF)
.equ SP_WTC1				,		(SLOWPORT_REGISTER_BASE + SP_WTC1_OFF)
.equ SP_WTC2				,		(SLOWPORT_REGISTER_BASE + SP_WTC2_OFF)
.equ SP_RTC1				,		(SLOWPORT_REGISTER_BASE + SP_RTC1_OFF)
.equ SP_RTC2				,		(SLOWPORT_REGISTER_BASE + SP_RTC2_OFF)
.equ SP_FAC					,		(SLOWPORT_REGISTER_BASE + SP_FAC_OFF)
.equ SP_FRM					,		(SLOWPORT_REGISTER_BASE + SP_FRM_OFF)

/* sram registers */
.equ QDR_CH_CSR_BASE			,	0xCC010000

.equ QDR_CH_CONTROL_OFF			,	0x0
.equ QDR_RX_DLL_OFF				,	0x228
.equ QDR_RD_PTR_OFF				,	0x240
.equ QDR_RX_DESKEW_OFF			,	0x244
.equ QDR_RCMP_SETUP_CONTROL_OFF	,	0x300 
.equ QDR_RCMP_PMOS_OVER_OFF		,	0x30C 
.equ QDR_RCMP_NMOS_OVER_OFF		,	0x310
.equ QDR_RCMP_PMOS_NMOS_OVER_OFF,	0x314

/* dram registers */
.equ DRAM_CSR_BASE			,		0xD0009000

.equ DU_CONTROL_OFF			,		0x0
.equ DU_ERROR_STATUS_1_OFF	,		0x8
.equ DU_ERROR_STATUS_2_OFF	,		0x10
.equ DU_ECC_TEST_OFF		,		0x18
.equ DU_INIT_OFF			,		0x20
.equ DU_CONTROL2_OFF		,		0x28
.equ DDR_RCOMP_IO_CONFIG_OFF,		0x3C0
.equ DDR_RDDLYSEL_RECEN_OFF	,		0x3C8
.equ DDR_RX_DLL_OFF			,		0x650
.equ DDR_RX_DESKEW_OFF		,		0x688

.equ CR0_FRCSMRCOMP_OFF		,		0x100
.equ CR0_DSTRENGTHSEL_OFF	,		0x130
.equ CR0_DDQRCOMP_OFF		,		0x148
.equ CR0_DCTLRCOMP_OFF		,		0x190
.equ CR0_DRCVRCOMP_OFF		,		0x1D8
.equ CR0_DCKERCOMP_OFF		,		0x228
.equ CR0_DCSRCOMP_OFF		,		0x2B0
.equ CR0_DCKRCOMP_OFF		,		0x338
.equ CR0_DX8X16CKECSCKSEL_OFF,		0x220
.equ CR0_RCOMPPRD_OFF		,		0x108
.equ CR0_DIGFIL_OFF			,		0x118

.equ CR0_SLEWPROGRAMMED_OFF	,		0x128
.equ CR0_OVRRIDEH_OFF		,		0x138
.equ CR0_OVRRIDEV_OFF		,		0x140
.equ CR0_JT_CONFIG_OFF		,		0x3C0

.equ DU_CONTROL				,		(DRAM_CSR_BASE + DU_CONTROL_OFF)
.equ DU_ERROR_STATUS_1		,		(DRAM_CSR_BASE + DU_ERROR_STATUS_1_OFF)
.equ DU_ERROR_STATUS_2		,		(DRAM_CSR_BASE + DU_ERROR_STATUS_2_OFF)
.equ DU_ECC_TEST			,		(DRAM_CSR_BASE + DU_ECC_TEST_OFF)
.equ DU_INIT				,		(DRAM_CSR_BASE + DU_INIT_OFF)
.equ DU_CONTROL2			,		(DRAM_CSR_BASE + DU_CONTROL2_OFF)
.equ DDR_RCOMP_IO_CONFIG	,		(DRAM_CSR_BASE + DDR_RCOMP_IO_CONFIG_OFF)
.equ DDR_RDDLYSEL_RECEN		,		(DRAM_CSR_BASE + DDR_RDDLYSEL_RECEN_OFF)
.equ DDR_RX_DLL				,		(DRAM_CSR_BASE + DDR_RX_DLL_OFF)
.equ DDR_RX_DESKEW			,		(DRAM_CSR_BASE + DDR_RX_DESKEW_OFF)

.equ CR0_FRCSMRCOMP			,		(DRAM_CSR_BASE + CR0_FRCSMRCOMP_OFF)
.equ CR0_DSTRENGTHSEL		,		(DRAM_CSR_BASE + CR0_DSTRENGTHSEL_OFF)
.equ CR0_DDQRCOMP			,		(DRAM_CSR_BASE + CR0_DDQRCOMP_OFF)
.equ CR0_DCTLRCOMP			,		(DRAM_CSR_BASE + CR0_DCTLRCOMP_OFF)
.equ CR0_DRCVRCOMP			,		(DRAM_CSR_BASE + CR0_DRCVRCOMP_OFF)
.equ CR0_DCKERCOMP			,		(DRAM_CSR_BASE + CR0_DCKERCOMP_OFF)
.equ CR0_DCSRCOMP			,		(DRAM_CSR_BASE + CR0_DCSRCOMP_OFF)
.equ CR0_DCKRCOMP			,		(DRAM_CSR_BASE + CR0_DCKRCOMP_OFF)
.equ CR0_DX8X16CKECSCKSEL	,		(DRAM_CSR_BASE + CR0_DX8X16CKECSCKSEL_OFF)
.equ CR0_RCOMPPRD			,		(DRAM_CSR_BASE + CR0_RCOMPPRD_OFF)
.equ CR0_DIGFIL				,		(DRAM_CSR_BASE + CR0_DIGFIL_OFF)

.equ CR0_SLEWPROGRAMMED		,		(DRAM_CSR_BASE + CR0_SLEWPROGRAMMED_OFF)
.equ CR0_OVRRIDEH			,		(DRAM_CSR_BASE + CR0_OVRRIDEH_OFF)
.equ CR0_OVRRIDEV			,		(DRAM_CSR_BASE + CR0_OVRRIDEV_OFF)
.equ CR0_JT_CONFIG			,		(DRAM_CSR_BASE + CR0_JT_CONFIG_OFF)

/* interrupt registers */
.equ INTERRUPT_CONTROLLER_BASE,		0xD6000000

.equ IRQ_STATUS_OFF			,		0x8
.equ IRQ_ENABLE_OFF			,		0x10
.equ IRQ_ENABLE_SET_OFF		,		0x10

/* pci config registers */
.equ PCI_CFG_REG_BASE		,		0xDE000000

.equ PCI_CMD_STAT_OFF		,		0x4
.equ PCI_CSR_BAR_OFF		,		0x10
.equ PCI_SRAM_BAR_OFF		,		0x14
.equ PCI_DRAM_BAR_OFF		,		0x18
.equ PCI_RCOMP_OVER_OFF		,		0x60

.equ PCI_CMD_STAT			,		(PCI_CFG_REG_BASE + PCI_CMD_STAT_OFF)
.equ PCI_CSR_BAR			,		(PCI_CFG_REG_BASE + PCI_CSR_BAR_OFF)
.equ PCI_SRAM_BAR			,		(PCI_CFG_REG_BASE + PCI_SRAM_BAR_OFF)
.equ PCI_DRAM_BAR			,		(PCI_CFG_REG_BASE + PCI_DRAM_BAR_OFF)
.equ PCI_RCOMP_OVER			,		(PCI_CFG_REG_BASE + PCI_RCOMP_OVER_OFF)

/* pci local csrs */
.equ PCI_LOCAL_CSR_BASE		,		0xDF000000

.equ PCI_OUT_INT_MASK_OFF	,		0x34
.equ MAILBOX_1_OFF			,		0x54
.equ SRAM_BASE_ADDR_MASK_OFF,		0xFC
.equ DRAM_BASE_ADDR_MASK_OFF,		0x100
.equ PCI_CONTROL_OFF		,		0x13C
.equ PCI_ADDR_EXT_OFF		,		0x140
.equ XSCALE_INT_STATUS_OFF	,		0x158
.equ XSCALE_INT_ENABLE_OFF	,		0x15C

/* csr addresses as seen from PCI */
.equ GLOBAL_CONTROL_BASE_FRM_PCI,	0x4A00

.equ IXP_RESET0_FRM_PCI			,	(GLOBAL_CONTROL_BASE_FRM_PCI + IXP_RESET0_OFF)
.equ CCR_FRM_PCI				,	(GLOBAL_CONTROL_BASE_FRM_PCI + CCR_OFF)
.equ STRAP_OPTIONS_FRM_PCI		,	(GLOBAL_CONTROL_BASE_FRM_PCI + STRAP_OPTIONS_OFF)

.equ SLOW_PORT_CSR_BASE_FRM_PCI	,	0x80000

.equ SCRATCH_BASE_FRM_PCI		,	0xF0000

.equ QDR_CH_BASE_FRM_PCI		,	0xF9C00

.equ DRAM_CH0_BASE_FRM_PCI		,	0xFD800

.equ DU_CONTROL_FRM_PCI			,	(DRAM_CH0_BASE_FRM_PCI + DU_CONTROL_OFF)
.equ DU_ECC_TEST_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + DU_ECC_TEST_OFF)
.equ DU_INIT_FRM_PCI			,	(DRAM_CH0_BASE_FRM_PCI + DU_INIT_OFF)
.equ DU_CONTROL2_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + DU_CONTROL2_OFF)
.equ DDR_RCOMP_IO_CONFIG_FRM_PCI,	(DRAM_CH0_BASE_FRM_PCI + DDR_RCOMP_IO_CONFIG_OFF)
.equ DDR_RDDLYSEL_RECEN_FRM_PCI	,	(DRAM_CH0_BASE_FRM_PCI + DDR_RDDLYSEL_RECEN_OFF)
.equ DDR_RX_DLL_FRM_PCI			,	(DRAM_CH0_BASE_FRM_PCI + DDR_RX_DLL_OFF)
.equ DDR_RX_DESKEW_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + DDR_RX_DESKEW_OFF)

.equ CR0_FRCSMRCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_FRCSMRCOMP_OFF)
.equ CR0_DSTRENGTHSEL_FRM_PCI	,	(DRAM_CH0_BASE_FRM_PCI + CR0_DSTRENGTHSEL_OFF)
.equ CR0_DDQRCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_DDQRCOMP_OFF)
.equ CR0_DCTLRCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_DCTLRCOMP_OFF)
.equ CR0_DRCVRCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_DRCVRCOMP_OFF)
.equ CR0_DCKERCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_DCKERCOMP_OFF)
.equ CR0_DCSRCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_DCSRCOMP_OFF)
.equ CR0_DCKRCOMP_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_DCKRCOMP_OFF)
.equ CR0_DX8X16CKECSCKSEL_FRM_PCI,	(DRAM_CH0_BASE_FRM_PCI + CR0_DX8X16CKECSCKSEL_OFF)
.equ CR0_RCOMPPRD_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_RCOMPPRD_OFF)
.equ CR0_DIGFIL_FRM_PCI			,	(DRAM_CH0_BASE_FRM_PCI + CR0_DIGFIL_OFF)

.equ CR0_SLEWPROGRAMMED_FRM_PCI	,	(DRAM_CH0_BASE_FRM_PCI + CR0_SLEWPROGRAMMED_OFF)
.equ CR0_OVRRIDEH_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_OVRRIDEH_OFF)
.equ CR0_OVRRIDEV_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_OVRRIDEV_OFF)
.equ CR0_JT_CONFIG_FRM_PCI		,	(DRAM_CH0_BASE_FRM_PCI + CR0_JT_CONFIG_OFF)

.equ PCI_CSR_BASE_FRM_PCI		,	0xFE000

.equ PCI_OUT_INT_MASK_FRM_PCI	,	(PCI_CSR_BASE_FRM_PCI + PCI_OUT_INT_MASK_OFF)
.equ PCI_CONTROL_FRM_PCI		,	(PCI_CSR_BASE_FRM_PCI + PCI_CONTROL_OFF)
.equ PCI_ADDR_EXT_FRM_PCI		,	(PCI_CSR_BASE_FRM_PCI + PCI_ADDR_EXT_OFF)

.equ TB_VENDOR_ID				,	0x8086
.equ TB_DEVICE_ID				,	0xB154

/* 21154 PCI-to-PCI Bridge register offset */
.equ VIDR_OFF	,					0x0
.equ DIDR_OFF	,					0x2
.equ PCR_OFF	,					0x4
.equ PSR_OFF	,					0x6
.equ RIDR_OFF	,					0x8
.equ PIR_OFF	,					0x9
.equ CLSR_OFF	,					0xC
.equ PLTR_OFF	,					0xD
.equ HTR_OFF	,					0xE
.equ PBNR_OFF	,					0x18
.equ SBNR_OFF	,					0x19
.equ SUBBNR_OFF	,					0x1A
.equ SLTR_OFF	,					0x1B
.equ IOBR_OFF	,					0x1C
.equ IOLR_OFF	,					0x1D
.equ SSR_OFF	,					0x1E
.equ MBR_OFF	,					0x20
.equ MLR_OFF	,					0x22
.equ PMBR_OFF	,					0x24
.equ PMLR_OFF	,					0x26
.equ ECPPR_OFF	,					0x34
.equ SUBIDR_OFF	,					0x36
.equ BCR_OFF	,					0x3E

@@ UART defines start 
.equ DEFAULT_BAUD,	        57600
.equ DEFAULT_BAUD_DIVISOR,        (50000000 / (16 * DEFAULT_BAUD)) 

.equ UARTLCR_DivisorLatchAccess, 	0x80
.equ UART_LineControl          , 	0x0C     @@reg addr
.equ UART_DivisorLatchLSB      , 	0x00	    @@reg addr DLAB=0
.equ UART_DivisorLatchMSB      , 	0x04	    @@reg addr DLAB=1
.equ UARTLCR_CharLength8       , 	0x03  
.equ UARTLCR_StopBits1         ,	 0x00  
.equ UART_InterruptEnable      ,	 0x04     @@reg addr DLAB=0
.equ UARTFCR_Enable            ,	 (1<<0)
.equ UART_FIFOControl          , 	0x08     @@reg addr
.equ UARTFCR_RXReset           , 	(1<<1)
.equ ARTFCR_TXReset            , 	(1<<2)
.equ UARTFCR_Mode0RXRDYTXRDY   , 	(0<<3)
.equ UARTFCR_RXTrigger1        ,	(0<<6)
.equ UART_LineStatus           ,	0x14     @@reg addr
.equ UART_Transmit             ,	0        @@reg addr
.equ UART_Receive              ,	0        @@reg addr
.equ UARTLSR_TXHoldingEmpty    ,	(1<<5)
.equ IXP2400_UART_ADDR		   ,	0xC0030000

@@end of UART defines

@@ GPIO defines start
.equ GPIO_BASE,  0xC0010000
@@The are offsets GPIO registers are from GPIO _BASE
.equ GPIO_PLR , (GPIO_BASE + 0x00) @@ GPIO Pin level register
.equ GPIO_PDPR,	(GPIO_BASE + 0x04) @@ GPIO Pin direction programmable register
.equ GPIO_PDSR,	(GPIO_BASE + 0x08) @@ GPIO Pin direction set register
.equ GPIO_PDCR,	(GPIO_BASE + 0x0C) @@ GPIO Pin direction clear register
.equ GPIO_POPR,	(GPIO_BASE + 0x10) @@ GPIO Output data programmable register
.equ GPIO_POSR,	(GPIO_BASE + 0x14) @@ GPIO Output data set register
.equ GPIO_POCR,	(GPIO_BASE + 0x18) @@ GPIO Output data clear register
.equ GPIO_REDR,	(GPIO_BASE + 0x1C) @@ GPIO Rising edge detect enable register
.equ GPIO_FEDR,	(GPIO_BASE + 0x20) @@ GPIO Falling edge detect enable register
.equ GPIO_EDSR,	(GPIO_BASE + 0x24) @@ GPIO Edge detect status register
.equ GPIO_LSHR,	(GPIO_BASE + 0x28) @@ GPIO level sensitive high enable register
.equ GPIO_LSLR,	(GPIO_BASE + 0x2C) @@ GPIO level sensitive low enable register
.equ GPIO_LDSR,	(GPIO_BASE + 0x30) @@ GPIO level detect status register
.equ GPIO_INER,	(GPIO_BASE + 0x34) @@ GPIO Interrupt Enable register
.equ GPIO_INSR,	(GPIO_BASE + 0x38) @@ GPIO Interrupt Set register
.equ GPIO_INCR,	(GPIO_BASE + 0x3C) @@ GPIO Interrupt Reset register
.equ GPIO_INST,	(GPIO_BASE + 0x40) @@ GPIO Interrupt Status Register

@@end of GPIO defines
#endif /* ONCE_HAL_IXDP2400_H */
