@@==========================================================================
@@####COPYRIGHTBEGIN####
@@                                                                          
@@ -------------------------------------------                              
@@ The contents of this file are subject to the Red Hat eCos Public License 
@@ Version 1.1 (the "License"); you may not use this file except in         
@@ compliance with the License.  You may obtain a copy of the License at    
@@ <http:@@www.redhat.com/>                                                   
@@                                                                          
@@ Software distributed under the License is distributed on an "AS IS"      
@@ basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
@@ License for the specific language governing rights and limitations under 
@@ the License.                                                             
@@                                                                          
@@ The Original Code is eCos - Embedded Configurable Operating System,      
@@ released September 30, 1998.                                             
@@                                                                          
@@ The Initial Developer of the Original Code is Red Hat.                   
@@ Portions created by Red Hat are                                          
@@ Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
@@ All Rights Reserved.                                                     
@@ -------------------------------------------                              
@@                                                                          
@@####COPYRIGHTEND####
@@==========================================================================

#ifndef ONCE_HAL_MMU_H
#define ONCE_HAL_MMU_H

.equ MMU_L1_TYPE        , 0x03  @@ Descriptor type
.equ MMU_L1_TYPE_Fault  , 0x00  @@ Invalid
.equ MMU_L1_TYPE_Page   , 0x11  @@ Individual page mapping
.equ MMU_L1_TYPE_Section, 0x12  @@ Mapping for 1M segment

.equ MMU_L2_TYPE        , 0x03  @@ Descriptor type
.equ MMU_L2_TYPE_Fault  , 0x00  @@ Invalid data
.equ MMU_L2_TYPE_Large  , 0x01  @@ Large page (64K)
.equ MMU_L2_TYPE_Small  , 0x02  @@ Small page (4K)

.equ MMU_Bufferable     , 0x04  @@ Data can use write-buffer
.equ MMU_Cacheable      , 0x08  @@ Data can use cache

.equ MMU_AP_Limited     ,0x000  @@ Limited access
.equ MMU_AP_Supervisor  ,0x400  @@ Supervisor RW, User none
.equ MMU_AP_UserRead    ,0x800  @@ Supervisor RW, User read only
.equ MMU_AP_Any         ,0xC00  @@ Supervisor RW, User RW

.equ MMU_AP_ap0_Any     ,0x030
.equ MMU_AP_ap1_Any     ,0x0C0
.equ MMU_AP_ap2_Any     ,0x300
.equ MMU_AP_ap3_Any     ,0xC00
.equ MMU_AP_All ,(MMU_AP_ap0_Any|MMU_AP_ap1_Any|MMU_AP_ap2_Any|MMU_AP_ap3_Any)

@@.equ MMU_DOMAIN(x)      ,((x)<<5)

.equ MMU_PAGE_SIZE      ,0x1000
.equ MMU_SECTION_SIZE   ,0x100000

.equ MMU_CP              , p15      @@ Co-processor ID 
.equ MMU_Control         , c1       @@ Control register
.equ MMU_Base            , c2       @@ Page tables base
.equ MMU_DomainAccess    , c3       @@ Domain access control
.equ MMU_FaultStatus     , c5       @@ Fault status register
.equ MMU_FaultAddress    , c6       @@ Fault Address
.equ MMU_InvalidateCache , c7       @@ Invalidate cache data
.equ MMU_TLB             , c8       @@ Translation Lookaside Buffer

@@ These seem to be 710 specific
.equ MMU_FlushTLB        , c5
.equ MMU_FlushIDC        , c7

.equ MMU_Control_M  ,0x001    @@ Enable MMU
.equ MMU_Control_A  ,0x002    @@ Enable address alignment faults
.equ MMU_Control_C  ,0x004    @@ Enable cache
.equ MMU_Control_W  ,0x008    @@ Enable write-buffer
.equ MMU_Control_P  ,0x010    @@ Compatability: 32 bit code
.equ MMU_Control_D  ,0x020    @@ Compatability: 32 bit data
.equ MMU_Control_L  ,0x040    @@ Compatability:
.equ MMU_Control_B  ,0x080    @@ Enable Big-Endian
.equ MMU_Control_S  ,0x100    @@ Enable system protection
.equ MMU_Control_R  ,0x200    @@ Enable ROM protection
.equ MMU_Control_I  ,0x1000   @@ Enable Instruction cache
.equ MMU_Control_X  ,0x2000   @@ Set interrupt vectors at 0xFFFF0000
.equ MMU_Control_Init, (MMU_Control_P|MMU_Control_D|MMU_Control_L)

@@-----------------------------------------------------------------------------

#endif @@ ONCE_HAL_MMU_H
@@ End of hal_mmu.h
