//==========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// <http://www.redhat.com/>                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//==========================================================================

#include "hal_intr.h"
#include "i2c.h"
#include "cfg_utility.h"
#include "mlt_arm_ixdp2400_romram.h"
#include "hal_ixdp2400.h"
#include "flash_io.h"
#include "common.h"
#include "led.h"

externC UINT32 strap_options_val;

extern void eprintf(char *f, ...);

extern void Test_Mngr(void);
extern void hal_plf_pci_init(void);

//eeprom_config *config_data = (eeprom_config *)SCRATCHPAD_BASE;

//
// This is the main entry point for RedBoot
//
void c_start(void)
{
    int i, stat;

	// Initialize PCI
	Set_LED("PCII");
	hal_plf_pci_init();

	// Initialize flash
	if((stat = flash_init()))
	{
		eprintf("FLASH: driver init failed: %s\n", flash_errmsg(stat));
	}


	if(strap_options_val & CFG_PCI_BOOT_HOST)	// if master
	{
		for(i = 0; i < 6; i++)
		{
#ifdef I2C_LOOK_FOR_DEVICE
			char dev_id;
			unsigned char slave_addr[] = {0xA0, 0xA2, 0xA4, 0xA6, 0xA8, 0xAA};

			i2c_read(slave_addr[i], DEV_ID_ADDR, &dev_id);
			switch(dev_id)
			{
				case KI_DEV_ID:
					eprintf("found kent island at addr = %d\n", i);
					break;
				case BI_DEV_ID:
					eprintf("found bird island at addr = %d\n", i);
					break;
				case MI_DEV_ID:
					eprintf("found marin island at addr = %d\n", i);
					break;
				case BD_DEV_ID:
					eprintf("found battery drew at addr = %d\n", i);
					break;
				case BW_DEV_ID:
					eprintf("found battery wallace at addr = %d\n", i);
					break;
				case PL_DEV_ID:
					eprintf("found point lone at addr = %d\n", i);
					break;
				case TC_DEV_ID:
					eprintf("found TCAM at addr = %d\n", i);
					break;
				default:
					eprintf("unrecognized hardware at addr = %d\n", i);
					break;
			}
#endif
		}
	}

	// display system good on system LED.
	*(SYSTEM_LED_REG) = 0x0;

	Test_Mngr();
}
