// *************************************************************************
// *
// * LIST_EXTRACTOR.C : uCode .list to C header file translator utility..
// *					for IXP2400 (Sausalito)
// * 
// *
// * ---------------------------------------------------------------------	
// *                                                                      
// *                  I N T E L   P R O P R I E T A R Y                   
// *                                                                      
// *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
// *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
// *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
// *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
// *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
// *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
// *     THE PRIOR WRITTEN PERMISSION OF :                                
// *                                                                      
// *                        INTEL  CORPORATION                            
// *                                                                     
// *                     2200 MISSION COLLEGE BLVD                        
// *                                                                      
// *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
// *                                                                      
// * ---------------------------------------------------------------------
// *
// * System: IXP2400
// * Subsystem:
// * Author: dalsraja - Feb 2002
// * Revisions: 
// *
// *************************************************************************

#include "stdio.h"
#include "stdlib.h"

int main (argc, argv)
int argc;
char *argv[];

{
	int maxlin = 80;
	int i, j, k;
	char inlinebuf[80];

	char entrystart0[] =	"/*****************************************************************************\n \
*                            Intel Proprietary\n \
*\n \
* Copyright (c) 2003 By Intel Corporation.  All rights reserved.\n \
* No part of this program or publication may be reproduced, transmitted,\n \
* transcribed, stored in a retrieval system, or translated into any language\n \
* or computer language in any form or by any means, electronic, mechanical,\n \
* magnetic, optical, chemical, manual, or otherwise, without the prior\n \
* written permission of:\n \
*                        Intel Corporation\n \
*                        2200 Mission College Blvd.\n \
*                        Santa Clara, CA  95052-8119\n \
*\n \
*******************************************************************************/\n";
	char entrystart1[] =	"const int ";
	char entrystart2[] =	"[] = {\n";
	char entryprefix[] =	"		0x";
	char entrypostfix[] =	",\n";
	char enddir[] =			"		};\n";

	FILE *fp_infile;
	FILE *fp_outfile;

	printf("\nIntel .LIST File to .H File Translator Utility Version 1.0 for IXP2X00\n");
	printf("Copyright (c) Intel Corporation 2002. All rights reserved.\n");

	if ((argc != 4))		// Original code was: if ((argc != 3))
	{
		printf("\nlist_ext utility syntax: \n");
		printf("	list_ext input_file output_file array_namee\n\n");
		printf("	where\n");
		printf("	input_file = path and name of source file\n");
		printf("	output_file = path and name of output file\n");
		printf("	array_name = name of array in output file to store the extracted data\n");
	}
	else 
	{
		printf("Opening input file [%s]...\n", argv[1]);

		if ((fp_infile = fopen(argv[1], "r")) == NULL)
		{
			printf("Input file [%s] open failed\n", argv[1]);
			// return(1);
		}
		else
		{
			printf("Opening output file [%s]...\n", argv[2]);
			if ((fp_outfile = fopen(argv[2], "w")) == NULL)
			{
				printf("Output file [%s] open failed\n", argv[2]);
				fclose(fp_infile);
				// return(2);
			}
			else
			{
				fputs(entrystart0, fp_outfile); 
				fputs(entrystart1, fp_outfile);

				i=0;
// Line below changed- original code was: while((argv[2][i]!='.') && (argv[2][i]!='\0'))//label array =outfilename less ext
				while((argv[3][i]!='.') && (argv[3][i]!='\0'))//label array =outfilename less ext
				{
					fputc(argv[3][i],fp_outfile);
					i++;
				};

				fputs( entrystart2, fp_outfile);
		
				k=0;
				while (fgets( inlinebuf, maxlin, fp_infile) != NULL)
				{	
					//printf("Scanning one line of input file [%s]...\n", argv[1]);
					
					// check for "." at start of line and that it is followed by a decimal number
					if((inlinebuf[0] == '.')&&(inlinebuf[1] <= '9')&&(inlinebuf[1] >= '0'))
					{
						//printf("Found leading .\n");

						k++;	//keep track of number of opcodes found

						i = 1;
						while (inlinebuf[i] != ' ')	// fast forward to " "
						{
							//printf("Searching for ascii space.\n");
							i++;
						} //while
						
						while (inlinebuf[i] == ' ')	// fast forward past " "
						{
						//printf("Searching for end of ascii space.\n");
							i++;
						} //while

						//printf("end of ascii space found.\n");
					
						fputs( entryprefix, fp_outfile);

						for( j = i + 2; j < i + 10; j++)	// copy the last eight chars for opcode
						{
							//printf("Copy opcode from input buf to output buf i= %d, j=%d.\n", i, j);
							fputc(inlinebuf[j],fp_outfile);
						} //for

						fputs( entrypostfix, fp_outfile);

						fputs( entryprefix, fp_outfile);

						for( j = i; j < i + 2; j++)	// then copy the first two chars for opcode
						{
							//printf("Copy opcode from input buf to output buf i= %d, j=%d.\n", i, j);
							fputc(inlinebuf[j],fp_outfile);
						} //for

						fputs( entrypostfix, fp_outfile);
					
					} //if

				} // while

				fputs( enddir, fp_outfile);
				//printf("Closing input file [%s]...\n", argv[1]);
				fclose(fp_infile);
				//printf("Closing output file [%s]...\n", argv[2]);
				fclose(fp_outfile);

				if(k==0) printf("\nERROR! ");
				printf("%d opcodes found in input file.\n", k);
		
			} //else
		
		} //else
					
	 } //else
  exit(0);
} //main
