/* common.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, Mar 13, 02
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef _COMMON_H
#define _COMMON_H

#include "type.h"

extern void eprintf(char *f, ...);
extern void hal_delay_us(unsigned int delay);

#define FALSE 0
#define TRUE 1

#ifndef false
	#define false 0
#endif

#ifndef true
	#define true (!false)
#endif

#ifndef OK
	#define OK 0
#endif
#ifndef ERROR
	#define ERROR (!OK)
#endif
#ifndef LINK_UP
	#define LINK_UP 100
#endif

#ifndef LINK_DN
	#define LINK_DN (!LINK_UP)
#endif
#define USER_ABORT 0x2

#define ENABLED 1
#define DISABLED 0

#ifdef __ARMEB__
#define GET8(address)  		*((volatile unsigned char *)((UINT32)(address)^3))
#define PUT8(address,val)  	(*((volatile unsigned char *)((UINT32)(address)^3)) = (val))

#define GET16(address)  	*((volatile unsigned short *)((UINT32)(address)^3))
#define PUT16(address,val)  (*((volatile unsigned short *)((UINT32)(address)^3)) = (val))

#define GET32(address)  	(*(volatile unsigned int *)(address))
#define PUT32(address,val)  (*(volatile unsigned int *)(address) = (val))

#else	// Little Endian
#define GET8(address)  		(*(volatile unsigned char *)(address))
#define PUT8(address,val)  	(*(volatile unsigned char *)(address) = (val))

#define GET16(address)  	(*(volatile unsigned short *)(address))
#define PUT16(address,val)  (*(volatile unsigned short *)(address) = (val))

#define GET32(address)  	(*(volatile unsigned int *)(address))
#define PUT32(address,val)  (*(volatile unsigned int *)(address) = (val))

#define GET64(address)  	(*(volatile unsigned long long *)(address))
#define PUT64(address,val)  (*(volatile unsigned long long *)(address) = (val))
#endif

#define B_TO_LW_SHF		2

#endif
