/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * --------------------------------------------------------------------------
 */
#ifndef __DUAL_MEDIA_H__
#define __DUAL_MEDIA_H__

#include "./microcode/dual_bd_in_rx.h"
#include "./microcode/dual_bd_in_tx.h"
#include "./microcode/dual_bd_eg_rx.h"
#include "./microcode/dual_bd_eg_tx.h"

#include "./microcode/dual_bw_in_rx.h"
#include "./microcode/dual_bw_in_tx.h"
#include "./microcode/dual_bw_eg_rx.h"
#include "./microcode/dual_bw_eg_tx.h"

#include "./microcode/dual_pl_in_rx.h"
#include "./microcode/dual_pl_in_tx.h"
#include "./microcode/dual_pl_eg_rx.h"
#include "./microcode/dual_pl_eg_tx.h"

#include "./microcode/media_lb_bd_on_sf_iface_rx.h"
#include "./microcode/media_lb_bd_on_sf_iface_tx.h"

#include "./microcode/media_lb_bw_on_sf_iface_rx.h"
#include "./microcode/media_lb_bw_on_sf_iface_tx.h"

#include "./microcode/media_lb_pl_on_sf_iface_rx.h"
#include "./microcode/media_lb_pl_on_sf_iface_tx.h"

#define DRAM_BASE_OFFSET	0x1000000
#define PACKET_SIZE			64
#define CELL_SIZE			52
#define CARD_OPTION_ADDR	0x0
#define SCRATCH_MSG_BASE	0x1000

#define SIGNAL_TX_ADDR0		0x800000
#define SIGNAL_TX_ADDR1		0x800100
#define SIGNAL_TX_ADDR2		0x800200
#define SIGNAL_TX_ADDR3		0x800300
#define STOP_TX				0x0
#define START_TX			0x3C	// 64 bytes to tx

#define EXT_LPBK		'e'
#define INT_LPBK		'i'

#define MEDIA_BD		'd'
#define MEDIA_BW		'w'
#define MEDIA_PL		'p'

#define NOT_RCVD	0x0
#define RCVD		0x1

#define EGRESS_TO_TX_OFFSET		0x0
#define EGRESS_FOR_RX_OFFSET	0x100000

#define MASTER_COMPLETE_INIT	0xFAFA
#define SLAVE_READY_TO_RX_TX	0xBABA

#define PORT_OFFSET		0x80


#endif // __DUAL_MEDIA_H__
