/* gpio.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, Mar 13, 02
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef _GPIO_H
#define _GPIO_H

#define EDGE_LEVEL_GPIO_TO_TEST	(1 << 6)

#define GPIO_BASE  0xC0010000
//The are offsets GPIO registers are from GPIO _BASE
#define GPIO_PLR	GPIO_BASE + 0x00 // GPIO Pin level register
#define GPIO_PDPR	GPIO_BASE + 0x04 // GPIO Pin direction programmable register
#define GPIO_PDSR	GPIO_BASE + 0x08 // GPIO Pin direction set register
#define GPIO_PDCR	GPIO_BASE + 0x0C // GPIO Pin direction clear register
#define GPIO_POPR	GPIO_BASE + 0x10 // GPIO Output data programmable register
#define GPIO_POSR	GPIO_BASE + 0x14 // GPIO Output data set register
#define GPIO_POCR	GPIO_BASE + 0x18 // GPIO Output data clear register
#define GPIO_REDR	GPIO_BASE + 0x1C // GPIO Rising edge detect enable register
#define GPIO_FEDR	GPIO_BASE + 0x20 // GPIO Falling edge detect enable register
#define GPIO_EDSR	GPIO_BASE + 0x24 // GPIO Edge detect status register
#define GPIO_LSHR	GPIO_BASE + 0x28 // GPIO level sensitive high enable register
#define GPIO_LSLR	GPIO_BASE + 0x2C // GPIO level sensitive low enable register
#define GPIO_LDSR	GPIO_BASE + 0x30 // GPIO level detect status register
#define GPIO_INER	GPIO_BASE + 0x34 // GPIO Interrupt Enable register
#define GPIO_INSR	GPIO_BASE + 0x38 // GPIO Interrupt Set register
#define GPIO_INCR	GPIO_BASE + 0x3C // GPIO Interrupt Reset register
#define GPIO_INST	GPIO_BASE + 0x40 // GPIO Interrupt Status Register

/* non-static function prototypes */
void GPIO_Test(void);

#endif
