/* me_xscale_sync.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, April 3, 02
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef _ME_XSCALE_SYNC_H
#define _ME_XSCALE_SYNC_H

// COMMON
#define PASS					0x0
#define COMPLETE 				0x1

// USED BY CONTEXT TEST
//======================
#define THD_DID_NOT_SLEEP 		0x2		// use by ctx sleep test


// USED BY CONTROL STORE TEST
//============================
#define ALTERNATIVE 1
#define NUM_OF_LINES_TO_GEN 	4096

#if (ALTERNATIVE == 1)
// number of lines in the while loop is 4, therefore divide by 4
#define CONTROL_STORE_EXP_VAL (NUM_OF_LINES_TO_GEN/4 - 2)
#else
// number of lines in the while loop is 1, therefore no division is necessary
#define CONTROL_STORE_EXP_VAL (NUM_OF_LINES_TO_GEN - 12)
#endif


// USED BY TIMER AND COUNTERS TEST
//=================================
#define ME_TIMER_COUNTER_VAL			0x4
#define ME_TIMER_COUNTER_VAL_EXPECTED	ME_TIMER_COUNTER_VAL

#endif
