/* memory.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2000
 *  subsystem: DIAG
 *  author: ccm, Mar 31, 02
 *  revisions: dalsraja, May 7, 02
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef _MEMORY_H
#define _MEMORY_H

#define CAP_CSR_BASE			0xC0004800
#define SCR_RING_INSTR_ADDR		0xCB400000
#define SCRATCH_SIZE			0x4000				// Scratch size=16k bytes
#define SCRATCH_SIZE_LW			(SCRATCH_SIZE>>2)	// Total num of long words in scratch

#define RING_BASE(num)			(CAP_CSR_BASE + (0x00+(num<<4)))
#define RING_HEAD(num)			(CAP_CSR_BASE + (0x04+(num<<4)))
#define RING_TAIL(num)			(CAP_CSR_BASE + (0x08+(num<<4)))

#define SRAM_RW_BEGIN			0x80000000	// to be removed
#define SRAM_RW_END				0x84000000	// to be removed

#define QDR_CHAN0_BEGIN			0x80000000
#define QDR_CHAN0_END			0x84000000
#define QDR_CHAN1_BEGIN			0x90000000
#define QDR_CHAN1_END			0x94000000

#define I2C_SRAM_BYTES			128

#define	SDRAM_PREFETCH_BEGIN  	0x00200000 // to be removed
#define	SDRAM_PREFETCH_END  	0x3FFFFFFF // to be removed

#define SDRAM_BASE				0x0
#define SDRAM_USER_SPACE_BEGIN	0x00200000 // start at 2mb onwards
#define SDRAM_END				0x3FFFFFFF

// Flags for test
#define WALK_0		0x1
#define WALK_1		0x2
#define WALK		(WALK_0 | WALK_1)
#define CHECKER_5A	0x4
#define CHECKER_A5	0x8
#define CHECKER		(CHECKER_5A | CHECKER_A5)
#define UNIQUE		0x10
#define ADDR_BUS	0x20
#define USER_DEFINE	0x40
#define DRAM_ECC	0x80
#define MULTI_PATRN	0x100
#define INCREMENTAL 0x200
#define ALL_TEST	0xFF

/* non-static Function prototype */
void Memory_Test(void);

#endif
