/* pci_diag.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2400
 *  subsystem: DIAG
 *  author: dalsraja, Feb 2002
 * 
 * --------------------------------------------------------------------------
 */

#ifndef PCI_DIAG_H
#define PCI_DIAG_H

#define SET_BIT(bit_no)			(0xFFFFFFFF & (1 << bit_no))
#define RESET_BIT(bit_no)		~(0xFFFFFFFF & (1 << bit_no))
#define XSCALE_PCI_REG_BASE		PCI_CFG_REG_BASE
#define XSCALE_DOORBELL			(XSCALE_PCI_REG_BASE + 0x60)
#define XSCALE_SRAM_BASE		SRAM_BASE
#define STRAP_OPTION			STRAP_OPTIONS
#define PATTERN1				0xCAFE

#define VENDOR_INTEL			0x8086
#define DEVICE_21555			0xB555
#define DEVICE_21154			0xB154
#define DEVICE_NIC				0x1209
#define DEVICE_NPU				0x9001

#define DB_BIT					0
#define MSF_U_BIT				1
#define MSF_C_BIT				2
#define SF_LB_BIT				3
#define MEDIA_LB_BIT			4
#define SYS_LB_BIT				5
#define LINERATE_BIT			6
#define SYS_LB2_BIT				7
#define SYS_LB3_BIT				8
#define DUAL_MEDIA_BIT			9
#define MEDIA_SF_BIT			10

#define PTLONE_MEDIA_LPBK 		11
#define PTLONE_MPHY_LPBK		12
#define PTLONE_SYS_LPBK			13
#define PTLONE_SYS_LPBK2		14

#define NIC_RECV_BIT			15
#define BDW_MEDIA_LB_BIT		16
#define PTLONE_SYS_LPBK3		17



void Find_i21555(void);
int i21555SromReprogramAll(UINT8 *newData);
int i21555SromDump(UINT8 *data);
void Find_i21154(void);
void Pci_Doorbell_Test(void);
void Doorbell_Intr_Received(void);
void Set_Pci_Doorbell(int bit_num, int db_intr_addr);
void Pci_Dma_Test(void);
void Find_All_Pci(void);

#endif
