/* sys_loopback.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2400
 *  subsystem: DIAG
 *  author: dalsraja, April, 2002
 *  revisions: dalsraja, May 7, 2002
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef SYS_LB_H
#define SYS_LB_H

// Function Declarations
//=======================
void Sys_Loopback_Test(void);
void Sys_Loopback_Test_Slave(void);

void Sys_Loopback2_Test(void);
void Sys_Loopback2_Test_Slave(void);

void Sys_Loopback3_Test(void);
void Sys_Loopback3_Test_Slave(void);

// Constants defitiontions
//=========================
#define DRAM_BASE_SRC			0x1000000
#define DRAM_BASE_DEST			0x2000000
#define SCRATCH_ADDR_OFF		0x200
#define RX_SRAM_BASE			0x400000
#define CARD_OPTION_ADDR		0x0
#define SCRATCH_MSG_BASE		0x1000
#define SYS_LB2_MSG_ADDR		0x1500
#define SYS_LB3_MSG_ADDR		0x1500

#define FUTURE_COUNT_STEP_ADDR	0x1600
#define LOOP_COUNT_ADDR			0x1604
#define BURST_COUNT_ADDR		0x1608
#define ME_TO_XSCALE_MSG_ADDR	0x160C
#define XSCALE_MSG_ADDR			0x1610
#define END_TEST_ADDR			0x1620

#define ME_FUTURE_COUNT_VALUE	22

#define PKTS_RX_OFFSET			0x4
#define PKTS_TX_OFFSET			0x8

#define SYS_LOOPBACK_IN_RX_ME	0
#define SYS_LOOPBACK_IN_TX_ME	1
#define SYS_LOOPBACK_EG_RX_ME	0
#define SYS_LOOPBACK_EG_TX_ME	1

#define SYS_LB2_BD_IN_RX_ME		0
#define SYS_LB2_BD_IN_TX_ME		1
#define SYS_LB2_BD_EG_TX_ME		0
#define SYS_LB2_BD_EG_RX_ME		1

#define SYS_LB3_BD_IN_RX_ME		0
#define SYS_LB3_BD_IN_TX_ME		1
#define SYS_LB3_BD_EG_TX_ME		0
#define SYS_LB3_BD_EG_RX_ME		1

#define SYS_LB2_BW_IN_RX_ME0	0
#define SYS_LB2_BW_IN_RX_ME1	1
#define SYS_LB2_BW_IN_RX_ME2	2
#define SYS_LB2_BW_IN_RX_ME3	3
#define SYS_LB2_BW_IN_TX_ME		16
#define SYS_LB2_BW_EG_TX_ME0	0
#define SYS_LB2_BW_EG_TX_ME1	1
#define SYS_LB2_BW_EG_TX_ME2	2
#define SYS_LB2_BW_EG_TX_ME3	3
#define SYS_LB2_BW_EG_RX_ME		16

#define SYS_LB3_BW_IN_RX_ME0	0
#define SYS_LB3_BW_IN_RX_ME1	1
#define SYS_LB3_BW_IN_RX_ME2	2
#define SYS_LB3_BW_IN_RX_ME3	3
#define SYS_LB3_BW_IN_TX_ME		16
#define SYS_LB3_BW_EG_TX_ME0	0
#define SYS_LB3_BW_EG_TX_ME1	1
#define SYS_LB3_BW_EG_TX_ME2	2
#define SYS_LB3_BW_EG_TX_ME3	3
#define SYS_LB3_BW_EG_RX_ME		16

#define RING_DATA_48_0			0x0000002A
#define RING_DATA_64_0			0x0002003A
#define RING_DATA_138_0			0x00040084
#define RING_DATA_48_1			0x0010002A
#define RING_DATA_64_1			0x0012003A
#define RING_DATA_138_1			0x00140084
#define RING_DATA_48_2			0x0020002A
#define RING_DATA_64_2			0x0022003A
#define RING_DATA_138_2			0x00240084
#define RING_DATA_48_3			0x0030002A
#define RING_DATA_64_3			0x0032003A
#define RING_DATA_138_3			0x00340084

#define TBUF_BASE				0xC8002000
#define TBUF_ELEM_SIZE			0x80
#define TOT_TBUF_ELEM			(0x2000 / TBUF_ELEM_SIZE)
#define SYS_LB2_DATA_SIZE		48
#define SYS_LB3_DATA_SIZE		48
#define ELEM_IN_ARRAY			(SYS_LB2_DATA_SIZE / 4)

#endif
