/* temperature.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, Apr 18, 02
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef _TEMPERATURE_H
#define _TEMPERATURE_H

#define ADUC812_SLAVE_ADDR 0xAA

#define ADUC812_ID_OFF			0x0
#define TEMPERATURE_ID_OFF		0x29
#define EGRESS_TEMP_MON_OFF		0x2A
#define EGRESS_TEMP_HIGH_OFF	0x2B
#define EGRESS_TEMP_LOW_OFF		0x2C
#define INGRESS_TEMP_MON_OFF	0x2D	
#define INGRESS_TEMP_HIGH_OFF	0x2E
#define INGRESS_TEMP_LOW_OFF	0x2F
#define ADUC812_INTERRUPT_OFF	0x30


#define ADUC812_ID_EXPECTED			0x8C
#define TEMPERATURE_ID_EXPECTED		0x31

#define HIGH_TEMP_LIMIT		55
#define LOW_TEMP_LIMIT		5

// non-static function prototypes
void TMon_Test(void);
void TMon_Read(void);
void TMon_Set_Limits(void);
void Usr_Temp_Ctrl_ISR(void);

#endif
