/* timer.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, Mar 13, 02
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef _TIMER_H
#define _TIMER_H

#define TIMERS_BASE				0xC0020000
#define TIMERS_TIMER1_CTL		TIMERS_BASE+0x00
#define TIMERS_TIMER2_CTL		TIMERS_BASE+0x04
#define TIMERS_TIMER3_CTL		TIMERS_BASE+0x08
#define TIMERS_TIMER4_CTL		TIMERS_BASE+0x0C
#define TIMERS_TIMER1_CLD		TIMERS_BASE+0x10
#define TIMERS_TIMER2_CLD		TIMERS_BASE+0x14
#define TIMERS_TIMER3_CLD		TIMERS_BASE+0x18
#define TIMERS_TIMER4_CLD		TIMERS_BASE+0x1C
#define TIMERS_TIMER1_CSR		TIMERS_BASE+0x20
#define TIMERS_TIMER2_CSR		TIMERS_BASE+0x24
#define TIMERS_TIMER3_CSR		TIMERS_BASE+0x28
#define TIMERS_TIMER4_CSR		TIMERS_BASE+0x2C
#define TIMERS_TIMER1_CLR		TIMERS_BASE+0x30
#define TIMERS_TIMER2_CLR		TIMERS_BASE+0x34
#define TIMERS_TIMER3_CLR		TIMERS_BASE+0x38
#define TIMERS_TIMER4_CLR		TIMERS_BASE+0x3C
#define TIMERS_TWDE				TIMERS_BASE+0x40


#define IRQ_TIMER1_BIT		0x10
#define IRQ_TIMER2_BIT		0x20
#define IRQ_TIMER3_BIT		0x40
#define IRQ_TIMER4_BIT		0x80

#define ACTIVATE_TIMER		(1 << 7)
#define DEACTIVATE_TIMER	0
#define CLEAR_INTERRUPT		1

/* non-static Function prototype */
void Timer_Test(void);
void Timer_Interrupt_Handler(void);

#endif
