/* uart.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, Mar 13, 02
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef _UART_H
#define _UART_H

#define UART_BASE	0xC0030000
#define UART_RBR	UART_BASE + 0x00	//UART Receive Buffer Reg  RO, accessed if  UART__LCR[7] (DLAB) set 0
#define UART_THR	UART_BASE + 0x00	//UART Transmit Holding Reg  WO,  accessed if UART_LCR[7] (DLAB) set 0
#define UART_DLRL	UART_BASE + 0x00	//UART Divisor Latch Reg Low RW, accessed if UART_LCR[7] (DLAB) set 1
#define UART_IER	UART_BASE + 0x04	//UART Interrupt Enable Reg, accessed if UART_LCR[7] (DLAB) set 0
#define UART_DLRH	UART_BASE + 0x04	//UART Divisor Latch Reg High RW, accessed if UART_LCR[7] (DLAB) set 1
#define UART_IIR	UART_BASE + 0x08	//UART Interrupt Identification Register, RO
#define UART_FCR	UART_BASE + 0x08	//UART FIFO Control Register, WO
#define UART_LCR	UART_BASE + 0x0C	//UART Line Control Register
#define UART_LSR	UART_BASE + 0x14	//UART Line Status Register
#define UART_SPR	UART_BASE + 0x1C	//UART Scratch Pad Register


#define ENABLE_UART	(1 << 6)
#define WRITE_INT			0x1
#define READ_INT			0x2
#define READ_TIMEOUT_INT	0x3

#define MAX_CHARS 256

#define LSR_DR 		0x01
#define LSR_OE 		0x02
#define LSR_PE 		0x04
#define LSR_FE 		0x08
#define LSR_BI 		0x10
#define LSR_TDRQ 	0x20
#define LSR_TEMT 	0x40
#define LSR_FERR 	0x80

#define IIR_FIFOES	0xC0
#define FIFO_MODE	0xC0
#define NON_FIFO_MODE 0x00

#define IIR_IID		0x06

#define KEYPRESS (Charav())

/* non-static Function prototype */
void UART_Test(void);
int Charav(void);
char GetChar(void);
void PutChar(char c);

#endif
