/* uc_load.h
 *
 *------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------
 *
 *
 *  system: IXDP2400
 *  subsystem: DIAG
 *  author: dalsraja, March, 2002
 *  revisions: dalsraja, 1 May 2002 - incorporated code review comment changes
 * 
 * 
 * -----------------------------------------------------------------------------
 */

#ifndef UE_H
#define UE_H

#define XSCALE_UE_CSR_BASE	0xC0018000

//*********************************************************
// Macro which computes micrengine 0-15 base address
//*********************************************************
#define UENG_CSR_BASE_ADDR(me_num)		(XSCALE_UE_CSR_BASE + (me_num<<10))


//*********************************************************


//********************************
// Microengine CSR registers
//********************************
#define USTORE_ADDR			0x000
#define USTORE_DATA_L		0x004
#define USTORE_DATA_U		0x008
#define CTX_ARB_CNTL		0x014
#define CTX_ENABLES			0x018
#define CC_ENABLE			0x01c
#define CSR_CTX_POINTER		0x020
#define CTX_STS_IND			0x040
#define ACTIVE_CTX_STS		0x044
#define CTX_SIG_EVNT_IND	0x048
#define CTX_WAKEUP_EVNT_IND	0x050
//********************************


//********************************
// Flags used in the code
//********************************
#define UENG_SUCCESS					0x0
#define UENG_NOT_RESET					0x1
#define UENG_INVALID					0x2
#define UENG_INACTIVE					0x3
#define UENG_ACTIVE						0x4
#define UENG_BADSIZE					0x5
#define UENG_RESET						0x6
#define UENG_USTORE_ERROR				0x7

#define ADDR_EN_BITPOS		0x80000000

#define CUR_COND_CODE_EN	(1 << 13)		// Current Condition Code enable bit for CC_ENABLE

#define GLOBAL_CHASSIS_BASE	0xC0004A00
#define	RESET_1_REG			(GLOBAL_CHASSIS_BASE + 0x10)

#define	CTX_ENABLE_MASK		(0xFF << 8)

int DownLoadUcode(unsigned short Uengine, unsigned short SizeUcode, unsigned int *Ucode);
void Clear_ME(unsigned short Uengine);
void Clear_All_ME(void);

#endif		// UE_H
