/* voltage.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP2400
 *  subsystem: DIAG
 *  author: ccm, Apr 18, 02
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef _VOLTAGE_H
#define _VOLTAGE_H

#define ADUC812_SLAVE_ADDR 0xAA 

#define ADUC_2_5V_REF_RES	610		//2.5*1000000/4095 uV
#define ADUC_5V_REF_RES		1221	//5*1000000/4095 uV

#define MAIN_3_3V_OFF	0x1
#define MAIN_2_5V_OFF	0x3
#define MON_3_3V_OFF	0x5
#define HIGH_3_3V_OFF	0x7
#define LOW_3_3V_OFF	0x9
#define MON_2_5V_OFF	0xB
#define HIGH_2_5V_OFF	0xD
#define LOW_2_5V_OFF	0xF
#define MON_1_8V_OFF	0x11
#define HIGH_1_8V_OFF	0x13
#define LOW_1_8V_OFF	0x15
#define MON_1_5V_OFF	0x17
#define HIGH_1_5V_OFF	0x19
#define LOW_1_5V_OFF	0x1B
#define MON_1_3V_OFF	0x1D
#define HIGH_1_3V_OFF	0x1F
#define LOW_1_3V_OFF	0x21
#define MON_1_25V_OFF	0x23
#define HIGH_1_25V_OFF	0x25
#define LOW_1_25V_OFF	0x27


// non-static function prototypes
void VMon_Test(void);
void VMon_Set_Limits(void);
void VMon_Read(void);

#endif
