/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: lagarwal $
 *   DATE:           $Date: 2003/05/01 20:42:51 $
 *   LAST MODIFIED:  $Modtime: 5/20/02 4:49p $
 *   REV#:           $Revision: 1.2 $
 *   LOGFILE:        $Logfile: /Embedded/source/linecards/batteryDW/appl.c $
 *   WORKFILE:       $Workfile: appl.c $
 *
 * --------------------------------------------------------------------------
 * Project: ALL
 *
 * Purpose: 
 *
 * Notes:
 *			
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log:
 * --------------------------------------------------------------------------
 */

#include "common_types.h"
#include "common_def.h"
#include "common.h"
#include "diag_utils.h"
#include "diagstruct.h"
#include "bdw.h"
#include "ixf_api_d.h"
#include "bdwcommon.h"

#ifdef MENU_DRIVEN
#include "ixf_api.h"
#endif

extern void PrintBanner();
extern void getCommands();

volatile UINT32 t_all_verbose = MAXIMUM;

void sp_config(void)
{

	unsigned long *ptr = (unsigned long *) BDW_CCR;
	*ptr = 3;

	ptr = (unsigned long *) BDW_WTC2;
	*ptr = 0x91;

	ptr = (unsigned long *) BDW_RTC2;
	*ptr = 0x91;

	ptr = (unsigned long *) BDW_PCR;
	*ptr = 0x3;

	ptr = (unsigned long *) BDW_ADC;
	*ptr = 0x13;

	ptr = (unsigned long *) BDW_FAC;
	*ptr = 0x2;

}

int Test_Mngr()
{
#ifdef MENU_DRIVEN
	bb_ChipData_t pChipData;

	sp_config();

	/* Init the driver */
	IxfApiInit((bb_RegPointer_type) IXF6048_BASE_ADDRESS, bb_6048_CHIP, &pChipData);

	Enable_CPSR_Int();

	DiagStructInit((void*) &pChipData);

	PrintBanner();


	while (1)
	{
		getCommands();
	}
#else
	ulong myId;

	sp_config();

	myId = BatteryConfigChip();

	BatteryIntInit(myId);

	BatteryExtInit(myId);

	BatteryEnableChannel(myId, 0);

	BatteryDisableChannel(myId, 0);

	BatterySetPayloadType(myId, 0, POS);
	eprintf("DBG : APPL COMPLETE\n");

	BatteryReset(myId, 0, bdw_RESET_RX_CHAN);
#endif
	return 1;
}


