/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: lagarwal $
*   DATE:           $Date: 2002/11/15 17:47:44 $
*   LAST MODIFIED:  $Modtime: 5/17/02 7:12a $
*   REV#:           $Revision: 1.1.1.1 $
*   LOGFILE:        $Logfile: /Embedded/source/linecards/batteryDW/bdwtests.h $
*   WORKFILE:       $Workfile: bdwtests.h $
*
* --------------------------------------------------------------------------
* Project: ALL
*
* Purpose: 
*
* Notes:
*			
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log:
* --------------------------------------------------------------------------
*/ 

#ifndef __BDWTESTS_H_ 
#define __BDWTESTS_H_

/******************************************************************
* Function : BdwLoopbackTest
*-----------------------------------------------------------------
* Description  : This routine performs the media plus NPU loopback
*                test.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid chip handle pointer.
*           loopBackMode : Specifies either INTERNAL or EXTERNAL
*           payLoadType : Specifies the SONET payload type.
*           cfg : Specifies the Utopia configuration.
*           chanNum : Specifies the channel number
*           loops : Specifices the number of loops to iterate thru.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : Status
*-----------------------------------------------------------------
* Access Globals : eduCommon structure
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern BDW_Status_t
BdwLoopbackTest(bb_ChipData_t *pChipData, LoopBackMode_t loopbackmode,
                PayloadTypes_t payloadtype, Utopia_Cnfg_t cfg,
                int chanNum, int loops);

/******************************************************************
* Function : BdwPRBSLoopbackTest
*-----------------------------------------------------------------
* Description  : This routine performs a media loopback test by
*                generating a PRBS test pattern and then analyzing
*                the pattern.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid chip handle pointer.
*           chanNum : Specifies the channel number.
*           mode : Specifies INTERNAL or EXTERNAL loopback
*           timeOut : Time in seconds to perform the test.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : Status
*-----------------------------------------------------------------
* Access Globals : eduCommon structure
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern BDW_Status_t 
BdwPRBSLoopbackTest(bb_ChipData_t *pChipData, int chanNum,
                    LoopBackMode_t mode, int timeOut);

/******************************************************************
* Function : BdwRegisterAccessTest
*-----------------------------------------------------------------
* Description  : This routine performs a read and write test on
*                device to make sure the basics are working.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid chip handle pointer.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : Status
*-----------------------------------------------------------------
* Access Globals : eduCommon structure
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern BDW_Status_t 
BdwRegisterAccessTest(bb_ChipData_t *pChipData);

/******************************************************************
* Function : BdwUnit_Test
*-----------------------------------------------------------------
* Description  : This routine calls the specific unit test given
*                the parsed command line instruction
*-----------------------------------------------------------------
* Inputs  : None.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : None.
*-----------------------------------------------------------------
* Access Globals : eduCommon structure.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern void 
BdwUnit_Test();

/******************************************************************
* Function : BdwSystem_Test
*-----------------------------------------------------------------
* Description  : This routine calls the specific system test given
*                the parsed command line instruction
*-----------------------------------------------------------------
* Inputs  : None.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : None.
*-----------------------------------------------------------------
* Access Globals : eduCommon structure.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern void 
BdwSystem_Test();
#endif
