/* ixf6048.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXP1200
 *  subsystem: EDU
 *  author: jjd, Apr 11, 01  Created
 * 
 * --------------------------------------------------------------------------
 */
#ifndef __IXF6048_H__
#define __IXF6048_H__

/* 
 * register map/definitions for ixf6048 (AMAZON)....
 */


#define HCO(chan)		(0x400+((chan)<<8))
#define LCO(chan)		(chan << 8)
/* globals */
#define MACNF		(0x001)
#define CHIP_ID		(0x002)
#define SRESET		(0x003)
#define BUF_ACNTS	(0x004)
#define SDH_GIS		(0x005)
#define ATMPOS_GIS	(0x006)
#define S_AIS		(0x007)
#define GOCNF		(0x008)
#define COCNF(x)	(0x009+LCO(x))
#define R_COCNF(x)	(0x00a+LCO(x))
#define T_COCNF(x)	(0x00b+LCO(x))
#define OHPCNF		(0x00c)
#define R_FPCNF		(0x00d)
#define T_FPCNF		(0x00e)
#define OCPCNF		(0x00f)
#define ICPCNF1		(0x010)
#define ICPCNF2		(0x011)
#define ICMR1		(0x012)
#define ICMR2		(0x013)
#define NCMODECNF	(0x014)
#define TESTCNF		(0x015)
#define TESTRAM_0	(0x016)
#define TESTRAM_1	(0x017)
#define TESTRAM_2	(0x018)
#define TESTRAM_3	(0x019)
#define PRBSINT		(0x01a)
#define PRBSINTEN	(0x01b)
#define TALBINT		(0x01c)
#define TALBINTEN	(0x01d)
#define LSPCNF		(0x01e)
#define LSPINT		(0x01f)
#define LSPINTEN	(0x020)
#define MISC_GIS	(0x021)

/* UTOPIA i/f */
#define R_UICNF			(0x070)
#define R_UIIML			(0x071)
#define R_UICHCNF(x)	(0x060+LCO(x))
#define R_PWM(x)		(0x061+LCO(x))
#define T_UICNF			(0x050)
#define T_UIIML			(0x051)
#define T_UICHCNF(x)	(0x040+LCO(x))
#define T_UIFDP(x)		(0x041+LCO(x))
#define T_NFPWM(x)		(0x042+LCO(x))
#define T_NEWWM(x)		(0x043+LCO(x))
#define R_UTOINT		(0x072)
#define T_UTOINT		(0x052)
#define R_UTOINTEN		(0x073)
#define T_UTOINTEN		(0x053)

/* SONET/SDH RX Regenerator Section Termination (per channel) */
#define R_RSTC(x)		(0x080+HCO(x))
#define LOF_LMN(x)		(0x081+HCO(x))
#define OOF_ECNT(x)		(0x082+HCO(x))
#define B1_ERRCNT(x)	(0x083+HCO(x))
#define R_J0_ERRCNT(x)	(0x085+HCO(x))
#define R_J0_ASTRA(x)	(0x086+HCO(x))
#define J0_RSTC(x)		(0x087+HCO(x))
#define IS_RG(x)		(0x0d0+HCO(x))
#define IE_RG(x)		(0x0d4+HCO(x))
#define S_RG(x)			(0x0d8+HCO(x))

/* SONET/SDH RX MUX Section Termination (per channel) */
#define	R_MST_C(x)			(0x090+HCO(x))
#define B2_BLKCNT_LO(x)		(0x095+HCO(x))
#define B2_BLKCNT_HI(x)		(0x096+HCO(x))
#define B2_BIPCNT_LO(x)		(0x097+HCO(x))
#define B2_BIPCNT_HI(x)		(0x098+HCO(x))
#define MR_BLKCNT_LO(x)		(0x099+HCO(x))
#define MR_BLKCNT_HI(x)		(0x09a+HCO(x))
#define MR_BIPCNT_LO(x)		(0x09b+HCO(x))
#define MR_BIPCNT_HI(x)		(0x09c+HCO(x))
#define R_K2K1(x) 			(0x09d+HCO(x))
#define R_S1(x)				(0x09f+HCO(x))
#define WINSZ_SB2(x)		(0x0b0+HCO(x))
#define CWIN_SB2(x)			(0x0b1+HCO(x))
#define E_EXCWIN(x)			(0x0b2+HCO(x))
#define WINSZ_CB2(x)		(0x0b3+HCO(x))
#define CWIN_CB2(x)			(0x0b4+HCO(x))
#define E_NEXCWIN_CB2(x)	(0x0b5+HCO(x))
#define WINSZ_SDEGB2_LO(x)	(0x0b6+HCO(x))
#define WINSZ_SDEGB2_HI(x)	(0x0b7+HCO(x))
#define CWIN_SDEGB2(x)		(0x0b8+HCO(x))
#define E_DEGWIN(x)			(0x0b9+HCO(x))
#define WINSZ_CDEGB2_LO(x)	(0x0ba+HCO(x))
#define WINSZ_CDEGB2_HI(x)	(0x0bb+HCO(x))
#define CWIN_CDEGB2(x)		(0x0bc+HCO(x))
#define E_NDEGWIN_CB2(x)	(0x0bd+HCO(x))
#define IS_MUX(x)			(0x0d1+HCO(x))
#define IE_MUX(x)			(0x0d5+HCO(x))
#define S_MUX(x)			(0x0d9+HCO(x))

/* SONET/SDH Receive MUX Section Adaptation Registers (per channel) */
#define R_MSA_C(x)		(0x0a0+HCO(x))
#define R_AU_NCNT(x)	(0x0a1+HCO(x))
#define R_AU_PCNT(x)	(0x0a2+HCO(x))
#define IS_ADP(x)		(0x0d2+HCO(x))
#define IE_ADP(x)		(0x0d6+HCO(x))
#define S_ADP(x)		(0x0da+HCO(x))

/* SONET/SDH Receive High Order Path Termination Registers (per channel) */
#define R_HPT_C1(x)		(0x0a4+HCO(x))
#define R_HPT_C2(x)		(0x0a5+HCO(x))
#define EXP_C2(x)		(0x0a6+HCO(x))
#define R_C2(x)			(0x0a7+HCO(x))
#define R_HPT_RDI(x)	(0x0a8+HCO(x))
#define B3_ECNT(x)		(0x0a9+HCO(x))
#define HPTREI_CNT(x)	(0x0aa+HCO(x))
#define R_J1_ASTRA(x)	(0x0ad+HCO(x))
#define R_J1_ESTRA(x)	(0x0af+HCO(x))
#define IS_HPT(x)		(0x0d3+HCO(x))
#define IE_HPT(x)		(0x0d7+HCO(x))
#define S_HPT(x)		(0x0db+HCO(x))

/* SONET/SDH Transmit Regenerator and MUX Section Termination (per channel) */
#define T_RMST_OP(x)	(0x0e0+HCO(x))
#define T_SC_RSOH(x)	(0x0e1+HCO(x))
#define T_SC_MSOH(x)	(0x0e2+HCO(x))
#define T_J0_STRA(x)	(0x0e4+HCO(x))
#define MP_TK2K1(x)		(0x0e5+HCO(x))
#define MP_TS1(x)		(0x0e6+HCO(x))

/* SONET/SDH Transmit MUX Section Adaptation Registers (per channel) */
#define T_AU_PTS(x)		(0x0e9+HCO(x))
#define T_CAU_PT(x)		(0x0ea+HCO(x))

/* SONET/SDH Transmit High Order Path Termination Registers (per channel) */
#define T_HPT_C(x)		(0x0e8+HCO(x))
#define MP_TC2(x)		(0x0eb+HCO(x))
#define MP_THPTRDI(x)	(0x0ec+HCO(x))
#define T_J1_STRA(x)	(0x0ee+HCO(x))
#define T_HPT_OPC(x)	(0x0ef+HCO(x))

/* ATM Rx channel Registers */
#define R_ACPCNF(x)			(0x020+HCO(x))
#define R_IUCFLTR(x)		(0x021+HCO(x))
#define R_LCDFLTR_LO(x)		(0x022+HCO(x))
#define R_LCDFLTR_HI(x)		(0x023+HCO(x))
#define R_ACELLCNT_LO(x)	(0x024+HCO(x))
#define R_ACELLCNT_HI(x)	(0x025+HCO(x))
#define R_ICELLCNT_LO(x)	(0x026+HCO(x))
#define R_ICELLCNT_HI(x)	(0x027+HCO(x))
#define R_CHECNT(x)			(0x028+HCO(x))
#define R_UHECNT(x)			(0x029+HCO(x))
#define R_CFOCNT(x)			(0x02a+HCO(x))
#define R_ATMINT(x)			(0x02b+HCO(x))
#define R_ATMINTEN(x)		(0x02c+HCO(x))

/* ATM Tx channel Registers */
#define T_ACPCNF(x)			(0x010+HCO(x))
#define T_ICELLP(x)			(0x011+HCO(x))
#define T_ACELLCNT_LO(x)	(0x012+HCO(x))
#define T_ACELLCNT_HI(x)	(0x013+HCO(x))
#define T_ICELLCNT_LO(x)	(0x014+HCO(x))
#define T_ICELLCNT_HI(x)	(0x015+HCO(x))
#define T_ATMINT(x)			(0x016+HCO(x))
#define T_ATMINTEN(x)		(0x017+HCO(x))

/* POS Rx Channel Registers */
#define R_PHCCNF(x)			(0x060+HCO(x))
#define R_MINPL(x)			(0x061+HCO(x))
#define R_MAXPL(x)			(0x062+HCO(x))
#define R_FRMCNT_LO(x)		(0x063+HCO(x))
#define R_FRMCNT_HI(x)		(0x064+HCO(x))
#define R_BYTECNT_LO(x)		(0x065+HCO(x))
#define R_BYTECNT_HI(x)		(0x066+HCO(x))
#define R_AFCNT_LO(x)		(0x067+HCO(x))
#define R_AFCNT_HI(x)		(0x068+HCO(x))
#define R_FCSECNT_LO(x)		(0x069+HCO(x))
#define R_FCSECNT_HI(x)		(0x06a+HCO(x))
#define R_PFOCNT(x)			(0x06b+HCO(x))
#define R_MINPLECNT_LO(x)	(0x06c+HCO(x))
#define R_MINPLECNT_HI(x)	(0x06d+HCO(x))
#define R_MAXPLECNT(x)		(0x06e+HCO(x))
#define R_POSINT(x)			(0x06f+HCO(x))
#define R_POSINTEN(x)		(0x070+HCO(x))

/* POS Tx channel Registers */
#define T_PHCCNF(x)		(0x040+HCO(x))
#define T_IPGCTRL(x)	(0x041+HCO(x))
#define T_FRMCNT_LO(x)	(0x042+HCO(x))
#define T_FRMCNT_HI(x)	(0x043+HCO(x))
#define T_BYTECNT_LO(x)	(0x044+HCO(x))
#define T_BYTECNT_HI(x)	(0x045+HCO(x))
#define T_AFCNT_LO(x)	(0x046+HCO(x))
#define T_AFCNT_HI(x)	(0x047+HCO(x))
#define T_PFUCNT(x)		(0x048+HCO(x))
#define T_POSINT(x)		(0x049+HCO(x))
#define T_POSINTEN(x)	(0x04a+HCO(x))

#endif /* __IXF6048_H__ */

