/* 
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: lagarwal $
 *   DATE:           $Date: 2003/01/29 00:04:33 $
 *   LAST MODIFIED:  $Modtime: 5/14/02 4:12p $
 *   REV#:           $Revision: 1.2 $
 *   LOGFILE:        $Logfile: /Embedded/source/drivers/ixf/devlib.h $
 *   WORKFILE:       $Workfile: devlib.h $
 *
 * --------------------------------------------------------------------------
 * Project: ALL
 *
 * Purpose: Defines the function pointers for the device libraries.
 *          The function pointers depeneds on the bb_ChipType_e type
 *          numbering.
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: devlib.h,v $
 *   Revision 1.2  2003/01/29 00:04:33  lagarwal
 *   no message
 *
 *   Revision 1.1.1.1  2002/11/15 17:51:11  lagarwal
 *   rename dir
 *
 *   Revision 1.4  2002/09/09 21:49:20  cmah1
 *   no message
 *
 *   Revision 1.2  2002/08/07 17:30:50  machambe
 *   no message
 *
 *   Revision 1.1  2002/05/22 00:05:41  machambe
 *   Initial update
 *
 * 
 * 48    5/14/02 4:14p Machambe
 * Added InitChip 2nd Param.
 * 
 * 47    5/03/02 1:34p Srodrig1
 * 
 * 46    4/24/02 2:03p Rcordova
 * Code changes for debugging  generic driver code
 * 
 * 45    4/24/02 10:39a Srodrig1
 * 
 * 44    4/18/02 11:31a Jaalliso
 * Fixing parameter type for GetOpMode
 * 
 * 43    4/17/02 2:07p Srodrig1
 * 
 * 42    4/16/02 2:43p Jaalliso
 * Renaming ixf_api_xgmac include files
 * 
 * 41    4/15/02 4:53p Jaalliso
 * Removing #if 0 code
 * 
 * 40    4/03/02 9:49a Machambe
 * Taking out unnecessary include header files for IXF6192
 * 
 * 39    2/14/02 4:04p Rcordova
 * Added Ixf16121 pointers and adding 2 new functions to the ixf6192.
 * 
 * 38    2/13/02 2:00p Rcordova
 * 
 * 37    2/07/02 5:04p Skadrix
 * Added a section (ChipSegment) parameter to the TestCfg API function.
 * Added a new API function  - IxfApiSetBERThreshold
 * 
 * 36    1/19/02 2:41p Machambe
 * 
 * 35    1/15/02 2:23p Rsood
 * 
 * 34    1/02/02 5:44p Machambe
 * Taking XgmacFunctionPointers_t out of #if 0
 * 
 * 33    12/12/01 4:04p Machambe
 * Added IxfApiMapframe related functions.
 * 
 * 32    12/05/01 3:26p Pkjain2
 * 
 * 31    12/05/01 2:36p Srodrig1
 * 
 * 30    12/04/01 4:22p Pkjain2
 * 
 * 29    11/29/01 4:46p Srodrig1
 * 
 * 28    11/28/01 12:03p Machambe
 * 
 * 27    11/18/01 10:48p Machambe
 * 
 * 26    11/16/01 8:44p Pkjain2
 * moved data structures to devlib.c
 * 
 * 25    11/15/01 6:40p Machambe
 * 
 * 24    11/14/01 3:08p Rsood
 * 
 * 23    11/14/01 2:06p Machambe
 * Changing the chip to device relationship
 * 
 * 22    11/09/01 4:29p Jaalliso
 * Debugging shadow directory stuff.  Added blank space to line 1
 * 
 * 21    11/09/01 2:07p Pkjain2
 * 
 * 20    11/06/01 2:01p Pkjain2
 * 
 * 19    8/02/01 9:38a Rfranz
 * adding support for Calypso
 * All changes made withing 'INCLUDE_18100_LIB' blocks, so this doesn't 
 * affect other devices.
 * 
 * 18    7/20/01 9:11a Machambe
 * Adding IxfApiGetBuildVersion
 * 
 * 17    7/03/01 4:09p Machambe
 * 
 * 16    6/25/01 10:54a Machambe
 * 
 * 15    6/18/01 4:10p Machambe
 * 
 * 14    6/11/01 4:11p Machambe
 * 
 * 13    5/18/01 5:03p Machambe
 * Uncommenting ixf6048 pointers
 * 
 * 12    5/03/01 3:54p Machambe
 * 
 * --------------------------------------------------------------------------
 */ 

#ifndef __DEVLIB_H_ /* Include file contents only once per compilation */
#define __DEVLIB_H_



/* Common API related include's */
#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h" /* General data structures for entire API */
#include "ixf_api_sonet_d.h" /* Sonet related data structures */
#include "ixf_api.h"   /* Prototypes */
#include "ixf_api_ether_d.h"

#ifdef INCLUDE_6192_LIB
/* IXF6192 related include's */
#include "ixf6192f.h" /* Prototypes for the IXF6192 */
#endif

#ifdef INCLUDE_18100_LIB
#include "ixf18100.h"
#include "ixf18100_sonet_d.h"
#include "ixf18100_sonet.h"
#include "ixf18100_xgmac.h"
#endif

#ifdef INCLUDE_6048_LIB
/* IXF6048 related include's */
#include "bkcompat.h"
#endif

#ifdef INCLUDE_16121_LIB
/* IXF16121 related include's */
#include "ixf16121_global_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_global_interrupts_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_hpt_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_msa_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_rmst_b.h" /* Bit definitions for IXF16121 */

#include "ixf16121.h" /* Prototypes for the IXF16121 */
#include "ixf16121_d.h" /* Data definitions for IXF16121 */
#include "ixf16121_cnfg_d.h"
#include "ixf16121_counters_d.h"
#include "ixf16121_jn_trace_d.h"
#include "ixf16121_oht_d.h"
#include "ixf16121_tests_d.h"
#include "ixf16121_ber_d.h"
#include "ixf16121_cnfg.h"
#include "ixf16121_counters.h"
#include "ixf16121_jn_trace.h"
#include "ixf16121_oht.h"
#include "ixf16121_tests.h"
#include "ixf16121_ber.h"
#endif

#ifdef INCLUDE_GENERIC_LIB
#include "genericdriver.h"  /*Prototypes for the Generic */
#endif

/* The types below define the common api prototypes */
typedef bb_Error_e (*IxfInitChip_t)(bb_ChipData_t *pChipData,
                                    InitRegTable_t *pTable);

typedef bb_Error_e (*IxfAllocMem_t)(bb_ChipData_t *pChipData);

typedef bb_Error_e (*IxfDeAllocMem_t)(bb_ChipData_t *pChipData);

typedef bb_Error_e (*IxfGetStatus_t)(bb_ChipData_t *pChipData,
                                     bb_ChipSegment_t *section,
                                     bb_SelStatus_e selStatus,
                                     void *pStatus);

typedef bb_Error_e (*IxfGetOpMode_t)(bb_ChipData_t *pChipData,
                                     bb_ChipSegment_t *section,
                                     bb_OperMode_e *opMode,
                                     void *pModeCfg);

typedef bb_Error_e (*IxfSetOpMode_t)(bb_ChipData_t *pChipData,
                                     bb_ChipSegment_t *section,
                                     bb_OperMode_e opMode,
                                     void *pModeCfg);

typedef  bb_Error_e (*IxfReset_t)(bb_ChipData_t *pChipData, 
                                  bb_ChipSegment_t *section,
                                  bb_SelResetType_e resetType);

typedef bb_Error_e (*IxfInitAlarmCallback_t)(bb_ChipData_t *pChipData,
                                             AlarmCallBack pAlarmCallbackArg); 

typedef bb_Error_e (*IxfChipIsr_t)(bb_ChipData_t *pChipData);

typedef bb_Error_e (*IxfCfgTest_t)(bb_ChipData_t *pChipData, 
                                   bb_ChipSegment_t *section,
                                   bb_TestType_e testType, void *pTestCfg);

typedef bb_Error_e (*IxfGetCounters_t)(bb_ChipData_t *pChipData, 
                                       bb_ChipSegment_t *section, 
                                       bb_SelCounters_e SelCounters, 
                                       void *pCounters);

typedef bb_Error_e (*IxfGetChipInfo_t)(bb_ChipData_t *pChipData, bb_ChipInfo_t *pChipInfo);

typedef bb_Error_e (*IxfSetChipOnline_t)(bb_ChipData_t *pChipData, bb_ChipSegment_t *section);

typedef bb_Error_e (*IxfSetChipOffline_t)(bb_ChipData_t *pChipData,
                                          bb_ChipSegment_t *section);

typedef bb_Error_e (*IxfSetAlarmCfg_t)(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                                       bb_AlarmType_e AlarmType, void *pAlarmCfg);

typedef bb_Error_e (*IxfGetBuildVersion_t) (bb_ChipData_t *pChipData,
                                            char *drvName, char *date,
                                            ushort *buildVer, ushort *buildRev);

typedef bb_Error_e (*IxfRead_t)(bb_ChipData_t *pChipData, bb_Word_Size_t wordSize,
                                ulong address, ushort length, void *buffer);

typedef bb_Error_e (*IxfWrite_t)(bb_ChipData_t *pChipData, bb_Word_Size_t wordSize,
                                 ulong address, ushort length, void *buffer);

typedef bb_Error_e (*IxfApiGetCfg_t)(bb_ChipData_t *ptChipData, 
                                     bb_ChipSegment_t *ptSegment,
                                     bb_SelConfig_e SelCfg);

typedef bb_Error_e (*IxfApiSetCfg_t)(bb_ChipData_t *ptChipData,
                                     bb_ChipSegment_t *ptSegment,
                                     bb_SelConfig_e SelCfg);


/* The types below define the SONET prototypes */
typedef bb_Error_e (*IxfGetWindowSize_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section,
                                         bb_WindowSizeMode_e mode,
                                         ulong *value);

typedef bb_Error_e (*IxfSetWindowSize_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section,
                                         bb_WindowSizeMode_e mode,
                                         ulong value);

typedef bb_Error_e (*IxfSetBERThreshold_t)(bb_ChipData_t *pChipData, 
                                           bb_ChipSegment_t *section,
                                           bb_BerThresholdSel_e berThresholdSel, 
                                           bb_STSMode_e mode, 
                                           short expNum);

typedef bb_Error_e (*IxfGetTrace_t)(bb_ChipData_t *pChipData,
                                    bb_ChipSegment_t *section,
                                    bb_TraceType_e TraceType,
                                    char *pTrace,
                                    ushort *pLength);

typedef bb_Error_e (*IxfSetTrace_t)(bb_ChipData_t *pChipData, 
                                    bb_ChipSegment_t *section,
                                    bb_TraceType_e TraceType, 
                                    bb_TraceFormat_e TraceFormat, 
                                    char *pTrace);

typedef bb_Error_e (*IxfGetOhBytes_t)(bb_ChipData_t *pChipData, 
                                      bb_ChipSegment_t *section,
                                      bb_SelOhBytes_e  SelOhBytes, 
                                      void *pOhBytes);

typedef bb_Error_e (*IxfSetOhByte_t)(bb_ChipData_t *pChipData, 
                                     bb_ChipSegment_t *section,
                                     bb_SelOhBytes_e SelOhByte, 
                                     ushort OhByte);

typedef bb_Error_e (*IxfMapFrame_t)(bb_ChipData_t *pChipData,
                                    MapFrame_t type,
                                    bb_SignalType_e sigType,
                                    ulong src,
                                    ulong dest,
                                    ulong srcFrameNum,
                                    ulong destFrameNum,
                                    ulong numOfFrames);

typedef bb_Error_e (*IxfGetMappedFrame_t)(bb_ChipData_t *pChipData,
                                          bb_SignalType_e sigType,
                                          ulong src,
                                          ulong destFrameNum,
                                          ulong numOfFrames,
                                          ushort *address);

typedef bb_Error_e (*IxfGetAuPointer_t)(bb_ChipData_t *pChipData,
                                        ulong src,
                                        bb_SignalType_e sigType,
                                        ulong srcFrameNum,
                                        ulong numOfFrames,
                                        ushort *AuPtrValue);


typedef bb_Error_e (*IxfSetRmstSourceBytes_t)(bb_ChipData_t *pChipData,
                                              bb_ChipSegment_t *section);

typedef bb_Error_e (*IxfGetRmstSourceBytes_t)(bb_ChipData_t *pChipData,
                                              bb_ChipSegment_t *section);

/* The types below define the XGMAC prototypes */
typedef bb_Error_e (*IxfGetMacAddress_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section, IxfApi_MacAddress_t *address);

typedef bb_Error_e (*IxfSetMacAddress_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section, IxfApi_MacAddress_t *address);


/* All Common API routines definition */
typedef struct 
{
    IxfInitChip_t           InitChipFuncPtr;
    IxfAllocMem_t           AllocFuncPtr;
    IxfDeAllocMem_t         DeAllocFuncPtr;
    IxfGetStatus_t          GetStatusFuncPtr;
    IxfGetOpMode_t          GetOpModeFuncPtr;
    IxfSetOpMode_t          SetOpModeFuncPtr;
    IxfReset_t              ResetFuncPtr;
    IxfInitAlarmCallback_t  InitAlarmCallbackFuncPtr;
    IxfChipIsr_t            ChipIsrFuncPtr;
    IxfCfgTest_t            CfgTestFuncPtr;
    IxfGetCounters_t        GetCountersFuncPtr;
    IxfGetChipInfo_t        ChipInfoFuncPtr;
    IxfSetChipOnline_t      ChipOnlineFuncPtr;
    IxfSetChipOffline_t     ChipOfflineFuncPtr;
    IxfSetAlarmCfg_t        SetAlarmCfgFuncPtr;
    IxfGetBuildVersion_t    GetBuildVersionFuncPtr;
    IxfRead_t               ReadFuncPtr;
    IxfWrite_t              WriteFuncPtr;
    IxfApiGetCfg_t          GetCfgFuncPtr;
    IxfApiSetCfg_t          SetCfgFuncPtr;
} CommonFunctionPointers_t;


/* All SONET API routines definition */
typedef struct 
{
    IxfGetWindowSize_t      GetWindowSizeFuncPtr;
    IxfSetWindowSize_t      SetWindowSizeFuncPtr;
    IxfSetBERThreshold_t    SetBERThresholdFuncPtr;
    IxfGetTrace_t           GetTraceFuncPtr;
    IxfSetTrace_t           SetTraceFuncPtr;
    IxfGetOhBytes_t         GetOhBytesFuncPtr;
    IxfSetOhByte_t          SetOhBytesFuncPtr;
    IxfSetRmstSourceBytes_t SetRmstSourceFuncPtr;
    IxfGetRmstSourceBytes_t GetRmstSourceFuncPtr;
    IxfMapFrame_t           MapFramesFuncPtr;
    IxfGetMappedFrame_t     GetMappedFramesFuncPtr;
    IxfGetAuPointer_t       GetFramesAuPointerFuncPtr;
} SonetFunctionPointers_t;

/* All XGMAC API routines definition */
typedef struct 
{                                               
    IxfGetMacAddress_t          GetMacAddressPtr;
    IxfSetMacAddress_t          SetMacAddressPtr;
} XgmacFunctionPointers_t;

typedef struct
{
    CommonFunctionPointers_t    *tCommonFuncPtr;
    SonetFunctionPointers_t     *tSonetFuncPtr;
    XgmacFunctionPointers_t     *tXgmacFuncPtr;
} ChipFunctionPointers_t;


#ifdef INCLUDE_6192_LIB
/* Function Pointers for the Ixf6192 Chip */

extern const ChipFunctionPointers_t ixf6192FuncPtrs;
#endif /* INCLUDE_6192_LIB */

#ifdef INCLUDE_6048_LIB
/* Function Pointers for the Ixf6048 Chip */

extern const ChipFunctionPointers_t ixf6048FuncPtrs;
#endif /* INCLUDE_6048_LIB */

#ifdef INCLUDE_18100_LIB
/* Function Pointers for the Ixf18100 Chip */

extern const ChipFunctionPointers_t ixf18100FuncPtrs;
#endif /* INCLUDE_18100_LIB */

#ifdef INCLUDE_16121_LIB
/* Function Pointers for the Ixf16121 Chip */

extern const ChipFunctionPointers_t ixf16121FuncPtrs;
#endif /* INCLUDE_16121_LIB */


#ifdef INCLUDE_GENERIC_LIB
extern const ChipFunctionPointers_t genericFuncPtrs;
#endif


extern const ChipFunctionPointers_t *chipArrayFuncPtrs[];

extern ChipFunctionPointers_t* getChipFuncPtr(bb_ChipType_e chipType);
extern bb_ChipType_e checkChipType(bb_ChipType_e chipType);
#endif   /* __DEVLIB_H_ */
