/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__DP_PROTO_H__)
#define __DP_PROTO_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


#include "diag.h"


/**
 * NAME: rx_tx_path_test
 *
 * DESCRIPTION: This function is a Rx/Tx data path 
 *              diagnostic test routine. 
 * 
 * @Param:  - IN    : None
 * @Param:  - INOUT : None 
 * @Param:  - OUT   : None  
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 rx_tx_path_test(void);

/**
 * NAME: lpbk_test
 *
 * DESCRIPTION: This function is the loopback 
 *              diagnostic test routine.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 lpbk_test(void);

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__DP_PROTO_H__) */

