/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__ERROR_MAP_H__)
#define __ERROR_MAP_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#include "type.h"
#include "error_code.h"
/**
 * Pre-processor symbol and macro definitions.
 * 
 */


/**
 * Type definitions.
 */

typedef struct _diag_error
{
        UINT32 err_code;        /* error code */

            /* the string to be displayeed/logged on the
               occurance of this error */
        char *err_string;
} diag_error;

/**
 * Prototypes for interface functions.
 */

    void make_ErrorMap(void);
/**
 * Exported variables.
 */
#if 0
diag_error aErrorMap[ ] =  { 
MAC_INIT_FAIL,			"Mac initialization failed!",
DEVICE_NOT_FOUND,		"Pt. Lone Device not found!",
MICROENGINE_INIT_FAIL,		"Microengine initialization failed!",
MICROENGINE_LOAD_FAIL,		"Microengine image load failure!",
MEM_WRITE_ERR,			"Memory write failed!",		
ABORT,				"Diagnostic routine aborted!",
RXOCTETSTOTALOK_ERR,	 	"Bad value in RxOctetsTotalOK register",
RXOCTETSTOTALBAD_ERR,		"Bad value in RxOctetsBAD register",
RXUCPKTS_ERR,		 	"Bad value in RxUCPckts register",
RXMCPKTS_ERR,			"Bad value in RxMCPkts register",
RXBCPKTS_ERR,			"Bad value in RxBCPkts register",
RXPKTS64OCTETS_ERR,		"Bad value in RxPkts64Octets register",
RXPKTS65TO127OCTETS_ERR,	"Bad value in RxPkts65to127Octets register",
RXPKTS128TO255OCTETS_ERR,	"Bad value in RxPkts128to255Octets register",	
RXPKTS256TO511OCTETS_ERR,	"Bad value in RxPkts256to511Octets register",
RXPKTS512TO1023OCTETS_ERR,	"Bad value in RxPkts512to1023Octets register",
RXPKTS1024TO1518OCTETS_ERR,	"Bad value in RxPkts1024to1518Octets register",
RXPKTS1519TOMAXOCTETS_ERR,	"Bad value in RxPkts1519toMaxOctets register",
RX_TAGGED_ERR,			"Bad value in Tagged register",
RXDATAERROR_ERR,		"Bad value in RxDataError register",
ALIGNERRORS_ERR,		"Bad value in Align Errors register",
LONGERRORS_ERR,			"Bad value in LongErrors register",
JABBERERRORS_ERR,		"Bad value in JabberErrors register",
RX_PAUSEMACCONTROL_ERR,		"Bad value in PauseMacControlReceivedCounter register",
RX_BAD_PAUSE_FRAME_ERR,		"Bad value in UnknownMacControlFrameCounter register",
SHORTERRORS_ERR,		"Bad value in ShortErrors register",
RUNTERRORS_ERR,			"Bad value in RuntErrors register",
VERYLONGERRORS_ERR,		"Bad value in VeryLongErrors register",
SYMBOL_ERR,			"Bad value in symbol errors register", 
SEQUENCE_ERR,			"Bad value in sequence error register",
RX_FCS_ERROR,			"FCS error in Rx ",
OCTETSTRANSMITTEDOK_ERR,	"Bad value in OctetsTransmittedOK register",
OCTETSTRANSMITTEDBAD_ERR,	"Bad value in OctetsTransmittedBad register",
TXUCPKTS_ERR,			"Bad value in TxUCPkts register",
TXMCPKTS_ERR,			"Bad value in TxMCPkts register",
TXBCPKTS_ERR,			"Bad value in TxBCPkts register",
TXPKTS64OCTETS_ERR,		"Bad value in TxPkts64Octets register",
TXPKTS65TO127OCTETS_ERR,	"Bad value in TxPkts65to127Octets register",
TXPKTS128TO255OCTETS_ERR,	"Bad value in TxPkts128to255Octets register",
TXPKTS256TO511OCTETS_ERR,	"Bad value in TxPkts256to511Octets register",
TXPKTS512TO1023OCTETS_ERR,	"Bad value in TxPkts512to1023Octets register",
TXPKTS1024TO1518OCTETS_ERR,	"Bad value in TxPkts1024to1518Octets register",
TXPKTS1519TOMAXOCTETS_ERR,	"Bad value in TxPkts1519toMaxOctets register",
TX_TAGGED_ERR,			"Bad value in Tx Tagged register",
TX_PAUSEMACCONTROL_ERR,		"Bad value in TxPauseFrames register",
TXEXCESSIVELENGTHDROP_ERR,	"Bad value in TxExcessiveLengthDrop register",
CRCERROR,			"Bad value in CRCError register",
TXUNDERRUN_ERR,			"Bad value in TxUnderrun register",
DEFFERED_TX_ERR,                "Bad value in Deferred register",
SINGLE_COLLISION_ERR,		"Bad value in SingleCollision register",
TXMUL_COLLISIONS_ERR,		"Bad value in MultipleCollision register",
TXEXCV_COLLISIONS_ERR,		"Bad value in ExcessiveCollisions register",
TXLATE_COLLISIONS_ERR,		"Bad value in LateCollisions register",
TXEXCV_DEFERRALS_ERR,		"Bad value in ExcessiveDeferrals register",
PERPORT_ERR,			"Per Port Register Diagnostics Failed",
AUTOSCAN_ERR,			"Autoscan Feature Failure",
MDIO_ERR,			"MDIO Interface configuration failure",
MDC_SPEED_ERR,			"MDC Speed diagnostics failure",
AUTONEG_ERR,			"Auto-negotiation failed",
WATERMARK_ERR,			"Watermark feature failure",
NO_TX_LED_ERR,			"LED glowing on no transmission",
TX_LED_ERR,			"Incorrect LED output on data transmission",
AMBER_LED_ERR,			"Incorrect output on Amber LED on Rx of erroneous data", 
LED_ERR,			"Bad LED output",
I2C_ERR,			"I2C bus read/write failed",
SPI_BUS_4x8_ERR,		"Bus width test failed in 4x8 mode",
SPI_BUS_32_ERR,			"Bus width test failed in 32 bit MPHY mode",
SPI_TENB_ERR,			"TENB verification failure",
SPI_TERR_ERR,			"TERR verification failure",
SPI_TPA_ERR,			"TPA verification failure",
UNI_FIL_ERR,			"Unicast filtering failure",
MULTI_FIL_ERR,			"Multicast filtering failure",
BRD_FIL_ERR,			"Broadcast filtering failure",
VLAN_FIL_ERR,			"VLAN filtering failure",
PAUSE_FIL_ERR,			"Pause filtering failure",
CRC_STRIP_ERR,			"CRC Stripping failure",
CRC_ADD_ERR,			"Failure of CRC Addition",
POWER_DN_ERR,			"Rx/Tx Power down feature failure",
TXFIFO_PAD_ERR,			"Tx FIFO Padding failure",
RXFIFO_PAD_ERR,			"Rx FIFO Padding failure",
FRAME_SZ_ERR,			"Error in transmission of frames with varying sizes",
RXFIFO_RESET_ERR,		"RxFIFO Reset failure",
TXFIFO_RESET_ERR,		"TxFIFO Reset failure",
RXTX_PATH_ERR,			"Error in data path",
INTNL_LPBK_ERR,			"Internal loopback failure at SPI-3 interface",
EXTNL_LPBK_ERR,			"External loopback failure at MAC FIFO/Wire",
LINERATE_ERR,			"Non conformance to expected line rate",
PLL_LOCK_ERR,			"PLL Lock failed to set on MAC reset."
};


#endif /* if 0 */

extern diag_error *p_aErrorMap;
#define ERR_INDEX(x) (x-MAC_INIT_FAIL)
#define ERR_STR(y) (p_aErrorMap[ERR_INDEX(y)].err_string)

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__ERROR_MAP_H__) */



