/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__I2C_DIAG_H__)
#define __I2C_DIAG_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


#define USER 			1
#define EEPROM_PASSWD_LEN	6
#define IXF_1104_MAC_VENDOR_ID  0	/** TBD **/

#define MAN_ID_LEN        12    /*bytes*/
#define MODEL_ID_LEN      12    /*bytes*/
#define PARTNUM_LEN       10    /*bytes*/
#define PARTREV_LEN        2    /*bytes*/
#define SERIAL_NUM_LEN    10    /*bytes*/
#define RSVD1_LEN          8    /*bytes*/
#define RSVD2_LEN          4    /*bytes*/
#define PASSWD_LEN         8    /*bytes*/
#define MAC_ADDR_LEN       6    /*bytes*/
#define RSVD3_LEN          12   /*bytes*/

typedef struct _s_ptLone_eeprom_content {
        unsigned char   prom_fmt;
        unsigned char   dev_id;
        unsigned char   man_id[12];
        unsigned char   part_rev [2];

        unsigned char   part_num[10];
        unsigned char   serial_num[10];
        unsigned char   model_id[12];

        //unsigned char   rsvd1[8];
        unsigned char   ether_mac_addr_port_0[6];
        unsigned char   ether_mac_addr_port_1[6];
		unsigned char   ether_mac_addr_port_2[6];
        unsigned char   ether_mac_addr_port_3[6];
		unsigned char	passwd[8];

        //unsigned char   rsvd2[4];


       // unsigned char   rsvd3[4];
}ptLone_eeprom_content ;

#define EEPROM_CONFIG_DATA_SIZE sizeof(ptLone_eeprom_content)


/*** i2c_utility function prototypes ***/
void ixf1104_config_wr();
int ixf1104_get_mac_addr(ptLone_eeprom_content *data, ptLone_eeprom_content *curr_data,int user);
void ixf1104_read_config_data(ptLone_eeprom_content *data);
void ixf1104_write_config_data(ptLone_eeprom_content *data,int user);
void ixf1104_display_config_data(ptLone_eeprom_content *data);
int ixf1104_get_data(ptLone_eeprom_content *data, int user);
//unsigned long from_hex(unsigned char *buf, int size);
//unsigned int _is_hex(char c);
void ixf1104_show_config(void);

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__I2C_DIAG_H__) */

