/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__MAC_INIT_H__)
#define __MAC_INIT_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#include "type.h"

/**
 * Pre-processor symbol and macro definitions.
 *
 */


/**
 * Type definitions.
 */

/**
 * Prototypes for interface functions.
 */

/**
 * NAME: mac_test
 *
 * DESCRIPTION: This function is the main diagnostic routine to be called on 
 *              invocation of MAC diagnostics. This function will perform the
 *              system initialization (MAC,microengines) and NPU synchronization.
 *              It will invoke the 'do_mac_test" routine, which is the handler for
 *              all the diagnostics routines.
 *              
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */
void mac_test (void);


/**
 * NAME: do_mac_test
 *
 * DESCRIPTION: This function is the main diagnostic routine to be called on
 *              invocation of MAC diagnostics. This function will perform the
 *              system initialization (MAC,microengines) and NPU synchronization.
 *              It will invoke the 'do_mac_test" routine, which is the handler for
 *              all the diagnostics routines.
 *
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */
UINT32 do_mac_test(void);


/**
 * NAME: init_packet_pool
 *
 * DESCRIPTION: This function is the main diagnostic routine to be called on
 *              invocation of MAC diagnostics. This function will perform the
 *              system initialization (MAC,microengines) and NPU synchronization.
 *              It will invoke the 'do_mac_test" routine, which is the handler for
 *              all the diagnostics routines.
 *
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */
UINT32 init_packet_pool(void);


/**
 * Exported variables.
 */

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__MAC_INIT_H__) */

