/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__MAC_INIT_H__)
#define __MAC_INIT_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


#include "diag.h"


/**
 * Pre-processor symbol and macro definitions.
 * 
 */


/**
 * Type definitions.
 */

/* this structure holds MAC device specific info.,
   such as type, port count etc.
   This structure is inherited from the IXP1200 diagnostics code. */

typedef struct _MacDat {
	int 	DevType;	/* device type */
	char 	*Descstr;	/* descriptor string */
	int 	PortCnt;	/* port count */
	int	IOBase;		/* IO Base address */
	int	PortIOSz;	/* per port memory */
	int	MCPortMsk;	
	int	MCPortBase;
	int	MCPortMax;
/*	int	bytesToSend; */
	int	MCPortRxMsk;
} MacDat;

/**
 * Prototypes for interface functions.
 */

/**
 * NAME: init_mac_dev
 *
 * DESCRIPTION: This function will initialize the MAC device and bring it 
 *              in an operational state. 
 * 
 * @Param:  - IN    : None
 * @Param:  - INOUT : None 
 * @Param:  - OUT   : None  
 *
 * @Return: 0 if successful or a valid error token for failure.
 */
UINT32 init_mac_dev (UINT32);

/**
 * NAME: macScan
 *
 * DESCRIPTION: This function will scan for the MAC device.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */
UINT32 macScan(void);

/**
 * Exported variables.
 */


#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__MAC_INIT_H__) */



