/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */
#if !defined(__MAC_UTIL_H)
#define __MAC_UTIL_H

#include "diag.h"


#define DRAM_BASE_SRC			0x1000000
#define DRAM_BASE_DEST			0x2000000
#define SCRATCH_ADDR_OFF		0x200
#define RX_SRAM_BASE			0x400000
#define CARD_OPTION_ADDR		0x0
#define SCRATCH_MSG_BASE		0x1000



#define PL_SYS_LOOPBACK_IN_RX_ME	0
#define PL_SYS_LOOPBACK_IN_TX_ME	1
#define PL_SYS_LOOPBACK_EG_RX_ME	0
#define PL_SYS_LOOPBACK_EG_TX_ME	1

#define MPHY_LOOPBACK_IN_RX_ME	0
#define MPHY_LOOPBACK_IN_TX_ME	1
#define MPHY_LOOPBACK_EG_RX_ME	0
#define MPHY_LOOPBACK_EG_TX_ME	1

#define RING_DATA_4_0			0x00000004
#define RING_DATA_4_1			0x00100004
#define RING_DATA_4_2			0x00200004
#define RING_DATA_4_3			0x00300004

#define RING_DATA_48_0			0x0000002C
#define RING_DATA_48_1			0x0010002C
#define RING_DATA_48_2			0x0020002C
#define RING_DATA_48_3			0x0030002C

#define RING_DATA_64_0			0x0002003C
#define RING_DATA_64_1			0x0012003C
#define RING_DATA_64_2			0x0022003C
#define RING_DATA_64_3			0x0032003C

#define RING_DATA_138_0			0x00040084
#define RING_DATA_138_1			0x00140084
#define RING_DATA_138_2			0x00240084
#define RING_DATA_138_3			0x00340084

#define RING_DATA_96_0			0x0000005C
#define RING_DATA_96_1			0x0010005C
#define RING_DATA_96_2			0x0020005C
#define RING_DATA_96_3			0x0030005C

#define RING_DATA_256_0			0x00050100
#define RING_DATA_256_1			0x00150100
#define RING_DATA_256_2			0x00250100
#define RING_DATA_256_3			0x00350100

#define RING_DATA_512_0			0x00060200
#define RING_DATA_512_1			0x00160200
#define RING_DATA_512_2			0x00260200
#define RING_DATA_512_3			0x00360200

#define RING_DATA_1024_0		0x00090400
#define RING_DATA_1024_1		0x00190400
#define RING_DATA_1024_2		0x00290400
#define RING_DATA_1024_3		0x00390400

#define RING_DATA_1520_0		0x000005F0
#define RING_DATA_1520_1		0x001005F0
#define RING_DATA_1520_2		0x002005F0
#define RING_DATA_1520_3		0x003005F0

#define RING_DATA_5K_0			0x00061400
#define RING_DATA_5K_1			0x00161400
#define RING_DATA_5K_2			0x00261400
#define RING_DATA_5K_3			0x00361400

#define RING_DATA_10K_0			0x000B2C00
#define RING_DATA_10K_1			0x001B2c00
#define RING_DATA_10K_2			0x002B2c00
#define RING_DATA_10K_3			0x003B2c00


#define FS_RING_DATA_64_0			0x0000003C
#define FS_RING_DATA_64_1			0x0000003C
#define FS_RING_DATA_64_2			0x0000003C
#define FS_RING_DATA_64_3			0x0000003C

#define FS_RING_DATA_138_0			0x00000084
#define FS_RING_DATA_138_1			0x00000084
#define FS_RING_DATA_138_2			0x00000084
#define FS_RING_DATA_138_3			0x00000084

#define FS_RING_DATA_96_0			0x0000005C
#define FS_RING_DATA_96_1			0x0000005C
#define FS_RING_DATA_96_2			0x0000005C
#define FS_RING_DATA_96_3			0x0000005C



#endif

