/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__PACKETPOOL_H__)
#define __PACKETPOOL_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#include "type.h"

/**
 * Pre-processor symbol and macro definitions.
 */

#define FRAME_64                0x1
#define FRAME_512               0x2
#define FRAME_1518              0x3
#define FRAME_10K               0x4
#define FRAME_60_NOCRC          0x5
#define FRAME_SHORT		0x6

#define SDRAM_FRAME_BASE	0x00 	/* TBD : Frame base must be known */


/**
 * Type definitions.
 */


/**
 * Prototypes for interface functions.
 */

/**
 * NAME: init_packet_pool
 *
 * DESCRIPTION: This function will create the test frame in DRAM memory.
 *              
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: DONE if successful or a valid error token for failure.
 */

UINT32 init_packet_pool(void);


/**
 * Exported variables.
 */

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__PACKETPOOL_H__) */

