/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__PROTOTYPES_H__)
#define __PROTOTYPES_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#include "diag.h"


/**
 * NAME: spi3_interface_buswidth_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for  
 *              SPI-3 interface buswidth. 
 * 
 * @Param:  - IN    : None
 * @Param:  - INOUT : None 
 * @Param:  - OUT   : None  
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 spi3_interface_buswidth_test(void);

/**
 * NAME: spi3_inband_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              SPI-3 inband addressing.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 spi3_inband_test(void);

/**
 * NAME: spi3_Tenb_TPA_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              SPI-3 signals: TENB and TPA.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 spi3_Tenb_TPA_test(void);

/**
 * NAME: spi3_tx_err_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              SPI-3 signal: TEEE
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 spi3_tx_err_test(void);

/**
 * NAME: per_port_reg_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              per port register read/write test.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 per_port_reg_test(void);

/**
 * NAME: autoscan_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              Autoscan operation.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 autoscan_test(void);

/**
 * NAME: mdio_config_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              MDIO configuration.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 mdio_config_test(void);

/**
 * NAME: mdc_speed_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              MDC Speed.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 mdc_speed_test(void);

/**
 * NAME: auto_neg_test
 *
 * DESCRIPTION: This function is a diagnostic test routine for
 *              auto-negotiation functionality.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 auto_neg_test(void);

UINT32 mdc_speed_test(void);

/**
 * NAME: Rx_tx_watermark_test
 *
 * DESCRIPTION: This function is a Rx/Tx Watermark
 *              diagnostic test routine. 
 *              
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 Rx_tx_watermark_test(void);

/**
 * NAME: i2c_test
 *
 * DESCRIPTION: This function is a Rx/Tx Watermark
 *              diagnostic test routine.
 *
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 i2c_test(void);

/**
 * NAME: led_test
 *
 * DESCRIPTION: This function is a LED
 *              diagnostic test routine.
 *
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 led_test(void);

/**
 * NAME: mac_address_filter_test
 *
 * DESCRIPTION: This function performs diagnostics of 
 *              unicast address filtering, 
 *              multicast address filtering,
 *              broadcast address filtering.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 mac_address_filter_test(void);


/**
 * NAME: vlan_pause_filter_test
 *
 * DESCRIPTION: This function performs diagnostics of
 *              VLAN frame filtering,
 *              PAUSE frame filtering.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 vlan_pause_filter_test(void);

/**
 * NAME: crc_test
 *
 * DESCRIPTION: This function performs diagnostics of
 *              (1) CRC stripping feature.
 *              (2) Detection of invalid CRC
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 crc_test(void);

/**
 * NAME: powerDown_test
 *
 * DESCRIPTION: This function performs diagnostics of
 *              (1) RxFIFO and TxFIFO Powerdown feature.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 powerDown_test(void);

/**
 * NAME: padding_test
 *
 * DESCRIPTION: This function performs diagnostics of
 *              (1) RxFIFO and TxFIFO padding feature.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 padding_test(void);

/**
 * NAME: frame_size_test
 *
 * DESCRIPTION: This function performs diagnostic
 *              test for different frame sizes.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 reset_test(void);

/**
 * NAME: frame_size_test
 *
 * DESCRIPTION: This function performs diagnostic
 *              test for RxFIFO and TxFIFO resets.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 0 if successful or a valid error token for failure.
 */

UINT32 reset_test(void);

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__PROTOTYPES_H__) */



