/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

#if !defined(__REGAPI_H__)
#define __REGAPI_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */



#include "type.h"

/**
 * Pre-processor symbol and macro definitions.
 * 
 */


/**
 * Type definitions.
 */

/**
 * Prototypes for interface functions.
 */

/**
 * NAME: reg_write
 *
 * DESCRIPTION: This function performs a write operation on a register.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: void
 */

void reg_write( volatile UINT32 offset, UINT32 val);

/**
 * NAME: reg_read
 *
 * DESCRIPTION: This function performs a read operation on a register.
 *
 * @Param:  - IN    : None
 * @Param:  - INOUT : None
 * @Param:  - OUT   : None
 *
 * @Return: 32 bit value 
 */

UINT32 reg_read( volatile UINT32 offset);

/**
 * register api definitions 
 */


/**
 * Exported variables.
 */

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__REGAPI_H__) */



