/* crc_diag.c
 *
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *-------------------------------------------------------------------------------
 *
 *
 *  system: IXDP2400
 *  subsystem: DIAG
 *  author: chinmay, NOVEMBER, 2002
 * 
 * 
 * ------------------------------------------------------------------------------
 */

typedef unsigned long ulong;
typedef unsigned short ushort;

#include "common.h"
#include "memory.h"
#include "msf_common.h"
#include "diagstruct.h"
#include "led.h"
#include "uc_load.h"
#include "pci_diag.h"
#include "pci.h"
#include "hal_ixdp2400.h"
#include "memory.h"
#include "syslog.h"
#include "uart.h"
#include "msf_init.h"
#include "diag_utils.h"

#include "error_code.h"
#include "error_map.h"
#include "reg_api.h"
#include "register_map.h"
#include "diag.h"
#include "dp_proto.h"
#include "mac_util.h"

#define LEN64_PKTS			3		/* expected 64 byte packets, per port */
#define LEN96_PKTS			3		/* expected 96 byte packets, per port */
#define LEN138_PKTS			3		/* expected 138 packets, per port */
#define EXP_BAD_PKTS		0		/* expected dropped packets, per port */
#define CHECK64				0x00	/* This is the 1st byte of the unicast frame */
#define CHECK96				0xB1	/* This is the 1st byte of the multicast frame */
#define CHECK138			0xFF	/* This is the 1st byte of the broadcast frame */
#define ILLEGAL_CRC_APPEND  0xBAD6	
#define ILLEGAL_CRC_STRIP	0xBAD7	
#define CRC_STRIP_FAILED	0xBAD8	
#define CRC_APPEND_FAILED	0xBAD9	

extern const int pl_sys_loopback_eg_rx[];
extern const int pl_sys_loopback_eg_tx[];
extern const int pl_sys_loopback_in_rx[];
extern const int pl_sys_loopback_in_tx[];

extern pci_device slave_dev_info;		// for slave npu info.
extern UINT32 PKT_96_SZ,PKT_64_SZ,PKT_138_SZ;
extern UINT32 PKT_SEQ_SZ,ALL_PORT_PKT_SEQ_SZ;

extern UINT32 Sz_pl_sys_loopback_eg_rx;
extern UINT32 Sz_pl_sys_loopback_eg_tx;
extern UINT32 Sz_pl_sys_loopback_in_rx;
extern UINT32 Sz_pl_sys_loopback_in_tx;

extern  UINT32 *pl_sys_lb_data96_0;
extern  UINT32 *pl_sys_lb_data64_0;
extern  UINT32 *pl_sys_lb_data138_0;
extern  UINT32 *pl_sys_lb_data96_1;
extern  UINT32 *pl_sys_lb_data64_1;
extern  UINT32 *pl_sys_lb_data138_1;
extern  UINT32 *pl_sys_lb_data96_2;
extern  UINT32 *pl_sys_lb_data64_2;
extern  UINT32 *pl_sys_lb_data138_2;
extern  UINT32 *pl_sys_lb_data96_3;
extern  UINT32 *pl_sys_lb_data64_3;
extern  UINT32 *pl_sys_lb_data138_3;

extern UINT32 tx_data_pl[];
extern UINT32 tx_data_pl_0[];
extern UINT32 tx_data_pl_1[];
extern UINT32 tx_data_pl_2[];
extern UINT32 tx_data_pl_3[];

extern UINT32 data64_0[];
extern UINT32 data64_1[];
extern UINT32 data64_2[];
extern UINT32 data64_3[];
extern UINT32 data96_0[];
extern UINT32 data96_1[];
extern UINT32 data96_2[];
extern UINT32 data96_3[];
extern UINT32 data138_0[];
extern UINT32 data138_1[];
extern UINT32 data138_2[];
extern UINT32 data138_3[];
extern UINT32 rxport[4];
/** globals **/
extern UINT32 total_args,loop,ports,speed;  
extern char channel,test_opt;
extern UINT8 test_param;

extern UINT32 validate_params(void);
extern UINT32 init_mac_dev(UINT32);
extern void clear_stat_regs();

extern void spConfig(void);
extern void spRestore(void);
extern void get_stats(void);
extern void Set_Pci_Doorbell(int bit_num, int db_intr_addr);
extern void get_packets_for_filter_test();

short Count64[4],Count96[4],Count138[4];
int get_crctest_stats(short);

// ******************************************************************************
// Function: void crc_test(void)
//
// This function is called by the Test Manager when the user invokes the
// point Lone system crc test
// ******************************************************************************
UINT32 crc_test(void)
{
	UINT32 ctr, flag, slave_mailbox0_addr, pkt_size, status, tx_count=0, rx_count=0;
	UINT32 scratch_ring_tx_count, scratch_ring_rx;
	UINT32 dcache_status, forever = 0, combination, port_num, rx_port_num;
	UINT32 loop_count=0;
	UINT32 *pl_sys_lb_data=0;
	UINT32 scratch_read_value=0, dram_addr, orig_data_size=0;
	volatile int mailbox_value, temp;
	register PDiagCommon acL = (PDiagCommon) ACADDRESS;
	short crcError=0;

	UINT32 pass_port[4],rxflag[4];
	UINT32 expected_num_pkts = 0,iteration = 0, port_ctr=0, pnum=0, *pktptr=0;
	UINT32 exp_pkt_sz = 0,cflag = 0;
	UINT32 bad_pkt_size = 0;
	UINT32 counter=0;

    channel = 'f';		

	total_args = acL->argc;
	test_opt = acL->argv[2][0];
	test_param = acL->argv[3][0];
	channel = acL->argv[4][0]; 		   	
	speed = acL->decArg[5];	
	ports = acL->decArg[6];
	loop = acL->decArg[7];

	if (validate_params() == INVALID_PARAMETERS)
	{
		eprintf("Invalid parameters. \n");
		return INVALID_PARAMETERS;
	}

	if (channel == 'c')
	{
		cflag = 1;
	}

	if (total_args <= 7)
	{
		loop = 1;
	}

	if (loop == 0)
	{
		forever = 1;
	}
	else
	{
		forever = 0;
	}
	
	/* initialize port array to 0 */
	for (ctr = 0;ctr<4;ctr++)
	{
		pass_port[ctr] = 0;
		rxflag[ctr] = ERROR;
		/* initialize packet counts to 0 */
		Count64[ctr]=0;
		Count96[ctr]=0;
		Count138[ctr]=0;
	}

	/* get the packet data used specifically for the test */
	get_packets_for_filter_test();

				switch(ports)
				{
					case 0: pktptr = tx_data_pl_0;
							pnum = PKT_SEQ_SZ/4; 
							iteration = 1;
							break;
					case 1: pktptr = tx_data_pl_1;
							pnum = PKT_SEQ_SZ/4;
							iteration = 1;
							break;
					case 2: pktptr = tx_data_pl_2;
							pnum = PKT_SEQ_SZ/4;
							iteration = 1;
							break;
					case 3: pktptr = tx_data_pl_3;
							pnum = PKT_SEQ_SZ/4;
							iteration = 1;
							break;
					case 4: pktptr = tx_data_pl;
							pnum = ALL_PORT_PKT_SEQ_SZ/(4*4);
							if (cflag)
								iteration = 2;
							else
								iteration = 4;
							break;
				}


	scratch_ring_rx = SCR_RING_INSTR_ADDR + (5 << 2);
	scratch_ring_tx_count = SCR_RING_INSTR_ADDR + (4 << 2);

	if(acL->HostType == MASTER)		// if master NPU
	{
		flag = OK;

		Msf_OutOfReset();
		status = Msf_PLL();
		if (status == ERROR)
		{
			return ABORT;
		}

		eprintf("Initialising media card. Please wait...\n");
		status = init_mac_dev(0);	
		if (status != DONE)
		{
			eprintf("Aborting Test\n");
			return ABORT;
		}
	
		clear_stat_regs();
		spConfig();

		switch(test_param)
		{
		case 'a':	/* test for CRC Append */
			    eprintf("Testing CRC append ...\n");
				//reg_write((RXFIFO_DROP_ENABLE),0xF);  
				for(port_ctr=0; port_ctr<NUM_PORTS;port_ctr++)
				{
					/*enable CRC append */
					reg_write((DIV_CONFIG_WORD+(port_ctr*PORTSZ)),0x114D); 
					/* enable CRC strip */
					reg_write(RXFIFO_PAD_CRCSTRIP_ENB, 0xF0);
				}
				
				break;
		case 'd':	/* disable crc append and crc strip */
		case '4':	/* test for RMON regs: Rx FCSErrors and Tx CRC Errors */
				//reg_write((RXFIFO_DROP_ENABLE),0xF);  
				for(port_ctr=0; port_ctr<NUM_PORTS;port_ctr++)
				{
					if (!cflag)
						/*disable CRC append */
						reg_write((DIV_CONFIG_WORD+(port_ctr*PORTSZ)),0x112D); 
					else
						reg_write((DIV_CONFIG_WORD+(port_ctr*PORTSZ)),0x110D);
					/* disable CRC strip */
					reg_write(RXFIFO_PAD_CRCSTRIP_ENB, 0x00);
				}
				
				break;

		default :
			eprintf("Invalid parameters. \n");
			return INVALID_PARAMETERS;
		}

		spRestore();
		eprintf("Media card initialisation completed.\n");

		dcache_status = get_CP15() & DCACHE_BIT;
		if(dcache_status != 0)	// if dcache ON
		{
			dcache_off();
		}

		*(PCI_ADDR_EXT_REG) = (slave_dev_info.base_address[CSR_BAR] & 0xE0000000) >> 16;
		slave_mailbox0_addr = slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_0_OFF;
		PUT32(slave_mailbox0_addr, 0);

#ifdef __ARMEB__
			PUT32((slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_3_OFF), SWAP32(1));
#else
			PUT32((slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_3_OFF), 1);
#endif

		PUT32((SCRATCHPAD_BASE + SCRATCH_MSG_BASE), DRAM_BASE_SRC);
		// Write packet data to DRAM for microcode to use
		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_0 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_0[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_0 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_0[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_0 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_0[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_1 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_1[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_1 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_1[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_1 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_1[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_2 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_2[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_2 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_2[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_2 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_2[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_3 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_3[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_3 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_3[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_3 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_3[(ctr / 4)]);
		}

		PUT32((PCI_LOCAL_CSR_BASE + MAILBOX_0_OFF), 0);

//		pkt_size = PACKET_SIZE;

		// Invoke the slave's PCI doorbell
		Set_Pci_Doorbell(PTLONE_SYS_LPBK, (slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + XSCALE_DOORBELL_OFF));

		ctr = 0;

		// Wait for a signal that slave NPU has completed loading of ucode and init
		do
		{
			if (ctr == 1500)	// After 10 seconds
			{
				eprintf("\nTimed out...Slave NPU was not able to load microcode and init.\n");
				mailbox_value = INIT_ERROR;
				flag = ERROR;
				break;
			}

			temp = GET32(slave_mailbox0_addr);

			hal_delay_us(10000);
			ctr++;
		}
		while (temp == 0);
		
		if (flag == OK)	// If slave completed microcode loading successfully
		{
			// Load Master's NPU with ucode and init
			DownLoadUcode(PL_SYS_LOOPBACK_EG_TX_ME, Sz_pl_sys_loopback_eg_tx, (UINT32 *)pl_sys_loopback_eg_tx);
			DownLoadUcode(PL_SYS_LOOPBACK_EG_RX_ME, Sz_pl_sys_loopback_eg_rx, (UINT32 *)pl_sys_loopback_eg_rx);

			hal_delay_us(1000000);

			do
			{
				for (combination = 0; combination < pnum; combination++)
				{
					for (port_ctr = 0; port_ctr < iteration; port_ctr++)
					{
						if (ports != 4)
						{
							port_num = ports;
							PUT32((SCR_RING_INSTR_ADDR + (port_num << 2)), pktptr[combination]);
						}
						else
						{
							if (cflag)
								port_num = port_ctr*2;
							else
								port_num = port_ctr;

							PUT32((SCR_RING_INSTR_ADDR + (port_num << 2)), tx_data_pl[((combination * 4) + port_num)]);
						}
					}
				}

				for (combination = 0; combination < pnum; combination++)
				{
					flag = OK;
					for (port_ctr = 0; port_ctr < iteration; port_ctr++)
					{
						if (ports != 4)
							port_num = ports;
						else
						{
							if (cflag)
								port_num = port_ctr*2;
							else
								port_num = port_ctr;
						}

						ctr = 0;

						do			// Do while waiting for all the packets to be transmitted
						{
							if (ctr == 1000)	// After 1 second
							{
								eprintf("\nTimed out...No indication from scratch ring that all packets were transmitted\n");
								mailbox_value = NOT_SENT;
								flag = ERROR;
								break;
							}

							// Poll on scratch ring to check if the packets have been transmitted
							if ((scratch_read_value = GET32(scratch_ring_tx_count)) == 0)
							{
								hal_delay_us(2);
								ctr++;
							}
							else
							{
								switch(ports)
								{
									case 0 : 
									case 1 : 
									case 2 : 
									case 3 : 
											eprintf("Transmitted on port %d: %d\r", ports,(scratch_read_value));
											
											break;
    
									case 4 : // all ports 
											if (!cflag)
											{
												eprintf("Transmitted on ports 0-3 : %d\r", (scratch_read_value)/4);
												iteration = 4;
											}
											else
											{
												eprintf("Transmitted on ports 0 and 2 : %d\r", (scratch_read_value)/2);
												iteration = 2;
											}
											break;
								}

								tx_count++;
							}
						}
						while (scratch_read_value == 0);

						PUT32(scratch_ring_tx_count, 0);

						tx_count =  scratch_read_value;
						if (flag == ERROR)
						{
							break;
						}
					}

					if (flag == ERROR)
					{
						break;
					}
				}

				if (flag == ERROR)
				{
					break;
				}
				
				for (combination = 0; combination < pnum; combination++)
				{
					for (port_ctr = 0; port_ctr < iteration; port_ctr++)
					{
						if (!cflag)
						{
							if (ports != 4)
								port_num = ports;
							else
								port_num = port_ctr;
						}
						else
						{
							if (ports != 4)
								port_num = rxport[ports];
							else
								port_num = port_ctr*2 + 1;
						}

						ctr = 0;

						do			// Do while waiting for a signal that a packet has been received
						{
							if (ctr == 300)	// After 1 second
							{
								//eprintf("\nTimed out...No indication from scratch ring that all packets were received\n");
								mailbox_value = NOT_RECEIVED;
								flag = ERROR;
								break;
							}

							// Poll on scratch ring to check if packets have been received
							if ((scratch_read_value = GET32(scratch_ring_rx)) == 0)
							{
								hal_delay_us(100);
								ctr++;
							}
						}
						while (scratch_read_value == 0);

						if (flag == ERROR)
						{
							break;
						}


						rx_count++;
						pkt_size = scratch_read_value & MASK_8BIT;
						rx_port_num = (scratch_read_value >> 8) & MASK_8BIT;
						dram_addr = DRAM_BASE_DEST + ((scratch_read_value >> 16) << 8);
						// set the port on which packet was received.
						pass_port[rx_port_num]++;
						rxflag[rx_port_num] = OK;

						if (ports == 4)
						{
							exp_pkt_sz = tx_data_pl[((combination * 4) + port_num)] & 0xFFFF;
						}
						else
						{
							exp_pkt_sz = pktptr[combination] & 0xFFFF;
						}

						switch (test_param)
						{
						case 'a':

							if ( ((exp_pkt_sz == 0x5C) && (pkt_size == 0x5C-4)) ||
								 ((exp_pkt_sz == 0x3C) && (pkt_size == 0x3C-4)) ||
								 ((exp_pkt_sz == 0x84) && (pkt_size == 0x84-4)) )
							{
								eprintf("\nActual packet size = 0x%x\n",pkt_size);
								eprintf("Expected packet size = 0x%x\n",exp_pkt_sz);
								eprintf("Illegal CRC Append !\n");
								mailbox_value = CRC_APPEND_FAILED;
								crcError = ERROR;
							}

							if ( ((exp_pkt_sz == 0x5C) && (pkt_size == 0x5C+4)) ||
								 ((exp_pkt_sz == 0x3C) && (pkt_size == 0x3C+4)) ||
								 ((exp_pkt_sz == 0x84) && (pkt_size == 0x84+4)) )
							{
								eprintf("\nActual packet size = 0x%x\n",pkt_size);
								eprintf("Expected packet size: 0x%x\n",exp_pkt_sz);
								eprintf("CRC Strip FAILED !\n");
								mailbox_value = CRC_STRIP_FAILED;
								crcError = ERROR;
							}

							break;
					

						case 'd':
						case '4':

							if ( ((exp_pkt_sz == 0x5C) && (pkt_size == 0x5C+4)) ||
								 ((exp_pkt_sz == 0x3C) && (pkt_size == 0x3C+4)) ||
								 ((exp_pkt_sz == 0x84) && (pkt_size == 0x84+4)) )
							{
								eprintf("\nActual packet size = 0x%x\n",pkt_size);
								eprintf("Expected packet size: 0x%x\n",exp_pkt_sz);
								eprintf("Illegal CRC Append !\n");
								mailbox_value = ILLEGAL_CRC_APPEND;
								crcError = ERROR;
							}
							if ( ((exp_pkt_sz == 0x5C) && (pkt_size == 0x5C-4)) ||
								 ((exp_pkt_sz == 0x3C) && (pkt_size == 0x3C-4)) ||
								 ((exp_pkt_sz == 0x84) && (pkt_size == 0x84-4)) )
							{
								eprintf("\nActual packet size = 0x%x\n",pkt_size);
								eprintf("Expected packet size: 0x%x\n",exp_pkt_sz);
								mailbox_value = ILLEGAL_CRC_STRIP;
								crcError = ERROR;
							}

							break;
						}


						if (crcError == ERROR)
							break;
			
						if (pkt_size != exp_pkt_sz)
						{
							eprintf("\nActual packet size = 0x%x\n",pkt_size);
							eprintf("Expected packet size: 0x%x\n",exp_pkt_sz);
							mailbox_value = INCORRECT_SIZE;
							flag = ERROR;		// Set flag as error
							rxflag[rx_port_num] = ERROR;
							break;
						}

						if (cflag)
						{
							switch(rx_port_num)
							{
								case 0:  // rx on port 0 , check for pkt transmitted from port 1
									if (pkt_size == (RING_DATA_96_1 & MASK_16BIT) )
									{
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_1;
									}
									else if (pkt_size == (RING_DATA_64_1 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_1;
									}
									else if (pkt_size == (RING_DATA_138_1 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_1;
									}
									else
										bad_pkt_size = 1;
									break;

								case 1:  // rx on port 1 , check for pkt transmitted from port 0
									if (pkt_size == (RING_DATA_96_0 & MASK_16BIT))
									{
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_0;
									}
									else if (pkt_size == (RING_DATA_64_0 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_0;
									}
									else if (pkt_size == (RING_DATA_138_0 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_0;
									}
									else 
										bad_pkt_size = 1;
									break;
								case 2:  // rx on port 2 , check for pkt transmitted from port 3
									if (pkt_size == (RING_DATA_96_3 & MASK_16BIT))
									{
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_3;
									}
									else if (pkt_size == (RING_DATA_64_3 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_3;
									}
									else if (pkt_size == (RING_DATA_138_3 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_3;
									}
									else
										bad_pkt_size = 1;

									break;
								case 3:  // rx on port 2 , check for pkt transmitted from port 2
									if (pkt_size == (RING_DATA_96_2 & MASK_16BIT))
									{
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_2;
									}
									else if (pkt_size == (RING_DATA_64_2 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_2;
									}
									else if (pkt_size == (RING_DATA_138_2 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_2;
									}
									else 
										bad_pkt_size = 1;

									break;
							}
							if (bad_pkt_size ==1)
							{
								eprintf("pkt size mismatch !! port = %d\n",rx_port_num);
								mailbox_value = NOT_COMPLETE;
								flag = ERROR;		// Set flag as error
								rxflag[rx_port_num] = ERROR;
								break;
							}
						}
						else  // cflag = 0 -> fiber mode
						{

							if ((pkt_size == (RING_DATA_96_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_0 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_0;
							}
							else if ((pkt_size == (RING_DATA_64_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_0 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_0;
							}
							else if ((pkt_size == (RING_DATA_138_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_0 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_0;
							}
							else if ((pkt_size == (RING_DATA_96_1 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_1 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_1;
							}
							else if ((pkt_size == (RING_DATA_64_1 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_1 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_1;
							}
							else if ((pkt_size == (RING_DATA_138_1 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_1 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_1;
							}
							else if ((pkt_size == (RING_DATA_96_2 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_2 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_2;
							}
							else if ((pkt_size == (RING_DATA_64_2 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_2 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_2;
							}
							else if ((pkt_size == (RING_DATA_138_2 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_2 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_2;
							}
							else if ((pkt_size == (RING_DATA_96_3 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_3 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_3;
							}
							else if ((pkt_size == (RING_DATA_64_3 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_3 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_3;
							}
							else if ((pkt_size == (RING_DATA_138_3 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_3 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_3;
							}
							else
							{
								eprintf("pkt size mismatch !! port = %d\n",rx_port_num);
								mailbox_value = NOT_COMPLETE;
								flag = ERROR;		// Set flag as error
								rxflag[rx_port_num] = ERROR;
								break;
							}
						}

						for (ctr = 0; ctr < orig_data_size; ctr+=4)
						{
							// Read the DRAM for the longword that was received
							temp = GET32(dram_addr + ctr);
							if (temp != pl_sys_lb_data[(ctr / 4)])
							{
								mailbox_value = ERROR_PATTERN;
								eprintf("Packet:%d Longword:%d Expected:0x%X  Received:0x%X\n", (rx_count + 1), (ctr / 4), pl_sys_lb_data[(ctr / 4)], temp);
								flag = ERROR;		// Set flag as error
								rxflag[rx_port_num] = ERROR;
								break;
							}
							if (ctr == 0)
							{
								if (((temp >>24) & 0xFF)== CHECK64)
									Count64[rx_port_num]++;  
								if (((temp >>24) & 0xFF)== CHECK96)
									Count138[rx_port_num]++;  
								if (((temp >>24) & 0xFF) == CHECK138)
									Count96[rx_port_num]++;  
							}
						}

						if (flag == ERROR)
						{
							break;
						}

						hal_delay_us(800);
					}

					if (flag == ERROR)
					{
						if ((test_param == '4') || (test_param == 'd'))
							;
						else
						{
							break;
						}
					}
				}

				if (flag == ERROR)
				{
					if ((test_param == '4') || (test_param == 'd'))
						;
				 	else
					{
						break;
					}
				}

				loop_count++;

				if (forever && KEYPRESS)
				{
					break;
				}
			}
			while ((loop_count != loop) || forever);
			
			if (loop == 0)
			{
				expected_num_pkts = loop_count * 9;
				counter = loop_count;
			}
			else
			{
				expected_num_pkts = loop * 9;
				counter = loop;
			}
			MSG("\nexpected_num_pkts = %d\n",expected_num_pkts,0,0);

			switch(ports)
			{
		       case 0:
		       case 1:
		       case 2:
		       case 3:  if (!cflag) 
						{ 
							if ((pass_port[ports] != expected_num_pkts) || (pass_port[ports] == 0))
							{
								//eprintf("\nDid not Receive expected number of packets on port %d\n", ports);
								eprintf("Packets Received = %d\n",pass_port[ports]);
								flag = ERROR;
								rxflag[ports] = ERROR;
							}
							else
							{
								eprintf("\nReceived on Port %d : %d\n",ports,pass_port[ports]);
								flag = OK;
							}
						}
						else
						{
							if ((pass_port[rxport[ports]] != expected_num_pkts) || (pass_port[rxport[ports]] == 0))
							{
								//eprintf("\nDid not Receive expected number of packets on port %d\n", rxport[ports]);
								eprintf("Packets Received on port %d = %d\n",rxport[ports],pass_port[rxport[ports]]);
								flag = ERROR;
								rxflag[ports] = ERROR;
							}
							else
							{
								eprintf("\nReceived on Port %d : %d\n",rxport[ports],pass_port[rxport[ports]]);
								flag = OK;
							}
						}
						break;

		       case 4:  eprintf("\n");
						if (!cflag)
						{
							for (ctr=0; ctr<4; ctr++)
							{
								if ((pass_port[ctr] != expected_num_pkts) || (pass_port[ports] == 0))
								{
									//eprintf("\nDid not Receive expected number of packets on port %d\n", ctr);
									eprintf("Packets Received = %d\n",pass_port[ctr]);
									rxflag[ctr] = ERROR;
									flag = ERROR;
								}
								if (pass_port[ctr] == expected_num_pkts)
								{
									eprintf("Received %d packets on Port %d\n",pass_port[ctr],ctr);
									//flag = OK;
								}
							}
						}
						else
						{
							for (ctr=0; ctr<2; ctr++)
							{
								if ((pass_port[ctr*2+1] != expected_num_pkts) || (pass_port[ports] == 0))
								{
									//eprintf("\nDid not Receive expected number of packets on port %d\n", ctr*2+1);
									eprintf("Packets Received = %d\n",pass_port[ctr*2+1]);
									rxflag[ctr*2+1] = ERROR;
									flag = ERROR;
								}
								if (pass_port[ctr*2+1] == expected_num_pkts)
								{
									eprintf("Received %d packets on Port %d\n",pass_port[ctr*2+1],ctr*2+1);
								}
							}
						}
						
						break;
						
			   default:   eprintf("This is bad value for port number \n");
								return INVALID_PARAMETERS;
			}

		}
		eprintf("\n");

		if(dcache_status != 0)	// if dcache was originally ON
		{
			dcache_on();
		}

		if (loop == 0)
			loop = loop_count;

			
		
		if (get_crctest_stats(cflag) && !crcError)
		{
			switch(test_param)
			{
			case 'a':
			case 'd':
				eprintf("\nCRC test PASSED !\n");
				break;
			case '4':
				eprintf("\nRMON: FCSError/CRCError stat. Reg. test PASSED !\n");
				break;
			}

				Set_LED("PASS");
				slowport_code[0] = SP_XSC;
				slowport_code[1] = SP_PASS;
				dump_slowport(slowport_code, 2, SP_NON_FATAL);
		} 
		else
		{
			if (mailbox_value == INIT_ERROR)
			{
				eprintf("The slave NPU did not succeed in loading the microcode to its microengines\n");
			}
			else if (mailbox_value == NOT_RECEIVED)
			{
				eprintf("There was no sign that the expected packet was received\n");
			}
			else if (mailbox_value == ERROR_PATTERN)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("The packet received was not the same as the packet transmitted.\n");
			}
			else if (mailbox_value == INCORRECT_SIZE)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("The packet received was not the same size as the packet transmitted.\n");
			}
			if (mailbox_value == ILLEGAL_CRC_APPEND)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("\nCRC appended, when append disabled.\n");
			}
			if (mailbox_value == ILLEGAL_CRC_STRIP)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("\nCRC stripped, when CRC strip disabled.\n");
			}
			if (mailbox_value == CRC_STRIP_FAILED)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("\nCRC stripping failed..\n");
			}
			if (mailbox_value == CRC_APPEND_FAILED)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("\nCRC append failed.\n");
			}

  					
			// prepare structure for dumping
			syslog.type = TYPE_ERROR;
			syslog.source_comp = MASTER_DIAG;	// Determine master/slave
			switch(test_param)
			{
			case 'a':
			case 'd':
				strcpy(syslog.desc, "CRC test FAILED!");
				eprintf("CRC test FAILED!\n");
				break;
			case '4':
				strcpy(syslog.desc, "RMON: FCSError/CRCError stat. Reg. test FAILED !");
				eprintf("RMON: FCSError/CRCError stat. Reg. test FAILED !\n");
				break;
			}
			// write to syslog
			syslog_dump(&syslog, sizeof(SYSLOG_DATA));
			
			Set_LED("FAIL");
			slowport_code[0] = SP_XSC;
			slowport_code[1] = SP_FAIL;
			dump_slowport(slowport_code, 2, SP_NON_FATAL);
			acL->Err = ERROR;
		}		

		Clear_All_ME();
		Msf_OutOfReset();

	}
	else
	{
		eprintf("\nThis test cannot be run directly on the Slave console\n");
		return DONE;	// To indicate that the slave does not do this.
	}
	return DONE;
}


int get_crctest_stats(short cflag)
{
	int port=0,ctr=0,port_ctr=0,test_passed=1;
	UINT32 rx64pkts[4],	rx96pkts[4], rx138pkts[4];
	UINT32 tx64pkts[4],	tx96pkts[4], tx138pkts[4];
	UINT32 RxfcsErrors[4],TxcrcErrors[4];
	short rxok=0,txok=0;

	spConfig();
    for(port=0; port<4;port++)
    {
		if (cflag)
			port=rxport[port];

		/* Reading the total packets received */
		rx64pkts[port]=reg_read(((port*PORTSZ)+RX_PKTS_64));  
		rx96pkts[port]=reg_read(((port*PORTSZ)+RX_PKTS_65_127));  
		rx138pkts[port]=reg_read(((port*PORTSZ)+RX_PKTS_128_255));  
		RxfcsErrors[port] = reg_read(((port*PORTSZ)+RX_FCS_ERR));  

		if (cflag)
			port=rxport[port];

		tx64pkts[port]=reg_read(((port*PORTSZ)+TX_PKTS_64));  
		tx96pkts[port]=reg_read(((port*PORTSZ)+TX_PKTS_65_127));  
		tx138pkts[port]=reg_read(((port*PORTSZ)+TX_PKTS_128_255));  
		TxcrcErrors[port] = reg_read(((port*PORTSZ)+TX_CRC_ERR));  

	}
	spRestore();

	if (ports == 4)
		if (!cflag)
			ctr = 4;
		else
			ctr = 2;
	else
		ctr = 1;

	for(port_ctr=0; port_ctr<ctr;port_ctr++)
	{
		if ((!cflag) && (ports == 4))
			port = port_ctr;
		if ((cflag) && (ports == 4))
		{
			port = port_ctr*2;
			port = rxport[port];
		}
		if ((!cflag) && (ports != 4))
			port = ports;
		if ((cflag) && (ports != 4))
			port = rxport[ports];

		eprintf("PORT = %d\n",port);	
		eprintf("Port %d: 64 byte packets received=0x%x\n",port,rx64pkts[port]);
		eprintf("Port %d: 96 byte packets received=0x%x\n",port,rx96pkts[port]);
		eprintf("Port %d: 138 byte packets received=0x%x\n",port,rx138pkts[port]);
		eprintf("Port %d: Packets received with FCS Errors = 0x%x\n",port,RxfcsErrors[port]);

		if (cflag)
			port=rxport[port];

		eprintf("\nPort %d: 64 byte packets transmitted=0x%x\n",port,tx64pkts[port]);
		eprintf("Port %d: 96 byte packets transmitted=0x%x\n",port,tx96pkts[port]);
		eprintf("Port %d: 138 byte packets transmitted=0x%x\n",port,tx138pkts[port]);
		eprintf("Port %d: Packets transmitted with CRC Errors = 0x%x\n",port,TxcrcErrors[port]);

		if (cflag)
			port=rxport[port];

		switch(test_param)
		{
		case 'a':
			eprintf("port = %d\n",port);
			if ((Count64[port] != (loop*LEN64_PKTS)) || 
				(Count96[port] != (loop*LEN96_PKTS)) ||
				(Count138[port] != (loop*LEN138_PKTS)))
			{
				eprintf("All packets are not received.\n");
				test_passed = 0;
			}

			if (cflag)
				port=rxport[port];
			if (RxfcsErrors[port] != (loop *EXP_BAD_PKTS))
			{
				eprintf("Received frames with CRC Errors on port %d\n",port);
				test_passed = 0;
			}
			if (test_passed)	
				rxok |= 1<<port_ctr;

			if (cflag)
				port=rxport[port];
			if (TxcrcErrors[port] != (loop *EXP_BAD_PKTS))
			{	
				eprintf("Transmitted frames with CRC Errors on port %d\n",port);
				test_passed = 0;
			}
			else
				txok |= 1<<port_ctr;

			break;

        case 'd':
		case '4':

			if (cflag)
				port=rxport[port];
			if (RxfcsErrors[port] == (loop *6))
			{
				eprintf("Received frames with CRC Errors on port %d\n",port);
				rxok |= 1<<port_ctr;
			}

			if (cflag)
				port=rxport[port];
			if (TxcrcErrors[port] == (loop *9))
			{
				eprintf("Transmitted rames with CRC Errors on port %d\n",port);
				txok |= 1<<port_ctr;
			}
						
			break;
		}
	}

	if((rxok == 0xF) && (txok == 0xF) && (ports == 0x4) && (!cflag))
		test_passed = 1;
	else
		if((rxok == 0x3) && (txok == 0x3) && (ports == 0x4) && cflag)
			test_passed = 1;
		else
			if((rxok == 0x1) && (txok == 0x1) && (ports != 0x4))
				test_passed = 1;
			else
				test_passed = 0;

	return test_passed;
}
