/* frsize_diag.c
 *
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *-------------------------------------------------------------------------------
 *
 *
 *  system: IXDP2400
 *  subsystem: DIAG
 *  author: chinmay, NOVEMBER, 2002
 * 
 * 
 * ------------------------------------------------------------------------------
 */

#include "diag_utils.h"
#include "syslog.h"
#include "led.h"
#include "diagstruct.h"
#include "msf_common.h"
#include "misc_func.h"
#include "memory.h"
#include "uc_load.h"
#include "media_loopback.h"

#include "mac_util.h"
#include "error_code.h"
#include "error_map.h"
#include "reg_api.h"
#include "register_map.h"
#include "uart.h"
#include "diag.h"
#include "dp_proto.h"
#include "hal_platform_ints.h"
#include "pci_diag.h"
#include "pci.h"
#include "pl_media_lpbk_jumboFrame_tx.h"
#include "pl_media_lpbk_jumboFrame_rx.h"

extern pci_device slave_dev_info;		// for slave npu info.
extern const int pl_media_lpbk_jumboFrame_tx[];
extern const int pl_media_lpbk_jumboFrame_rx[];

extern UINT32 data64_0[];
extern UINT32 data96_0[];
extern UINT32 data138_0[];
extern UINT32 data64_1[];
extern UINT32 data96_1[];
extern UINT32 data138_1[];
extern UINT32 data64_2[];
extern UINT32 data96_2[];
extern UINT32 data138_2[];
extern UINT32 data64_3[];
extern UINT32 data96_3[];
extern UINT32 data138_3[];
extern UINT32 data256_0[];
extern UINT32 data512_0[];
extern UINT32 data1024_0[];
extern UINT32 data1520_0[];
extern UINT32 data5K_0[];
extern UINT32 data10K_0[];

extern UINT32 fs_tx_data_pl[];
extern UINT32 fs_tx_data_pl_0[];
extern UINT32 fs_tx_data_pl_1[];
extern UINT32 fs_tx_data_pl_2[];
extern UINT32 fs_tx_data_pl_3[];

extern UINT32 tx_data_pl[];
extern UINT32 tx_data_pl_0[];
extern UINT32 tx_data_pl_1[];
extern UINT32 tx_data_pl_2[];
extern UINT32 tx_data_pl_3[];

extern void Msf_OutOfReset(void);
extern int Msf_PLL(void);
extern void spConfig(void);
extern void spRestore(void);
extern void Set_Rcomp(void);
extern int DownLoadUcode(unsigned short Uengine, unsigned short SizeUcode, unsigned int *Ucode);
extern UINT32 init_mac_dev(UINT32);
extern UINT32 validate_params(void);
extern unsigned int htoi(char *s);
extern unsigned int stoi(char *s);
extern void get_stats(void);
extern void clear_stat_regs();

#define DRAM_BASE_OFFSET		0x1000000 
#define PKT_SIZE				60
#define SCRATCH_MSG_BASE		0x1000
#define CHANNEL1_BASE_ADDRESS	0x90000000
#define RING1					SCR_RING_INSTR_ADDR+0x4
#define SRAM_DESC_BASE			0x200000

/** globals **/
extern UINT32 total_args,loop,speed,ports;  
extern UINT8 test_param;
extern char channel,test_opt;
extern UINT32 PKT_96_SZ,PKT_64_SZ,PKT_138_SZ;
extern UINT32 PKT_256_SZ,PKT_512_SZ,PKT_1024_SZ;
extern UINT32 PKT_1520_SZ,PKT_5K_SZ,PKT_10K_SZ;
extern UINT32 PKT_SEQ_SZ,ALL_PORT_PKT_SEQ_SZ;
extern UINT32 rxport[4];


UINT32 Sz_pl_media_lpbk_jumboFrame_tx = sizeof(pl_media_lpbk_jumboFrame_tx);
UINT32 Sz_pl_media_lpbk_jumboFrame_rx = sizeof(pl_media_lpbk_jumboFrame_rx);


void write_pkt_to_dram();
void verify_frame(UINT32 pkt_size, UINT32*ds, UINT32*media_lb_data, UINT32 rx_port_num);
UINT32 get_pkt_seq(UINT32 **pktptr, UINT32 *num_frames,UINT32 cflag,UINT32 ports);
void makePkt(UINT32 size);
short verify_stats(short cflag);
short verify_error(short cflag);

// ******************************************************************************
// Function: void lpbk_test(void)
//
// This function is called by the Test Manager when the user invokes the
// media loopback test
// ******************************************************************************
UINT32 frame_size_test(void)
{
	UINT32 ctr, flag, status,port;
	UINT32 slave_mailbox0_addr, slave_mailbox1_addr, slave_mailbox2_addr, slave_mailbox3_addr;
	volatile int mailbox_value, temp, stop = 0;
	UINT32 dcache_status, test_passed=0;
	UINT32 loop_count, forever = 0, packet_num = 0;
	register PDiagCommon acL = (PDiagCommon) ACADDRESS;
	UINT32 put_ring_base, get_ring_addr;
	UINT32 *pktptr=0, fail_port=0xFF;
	UINT32 port_ctr = 0,msg=0, txok = 0,pnum=0;
	short iteration = 1, port_num=0,txpkts = 0,per_port_pkts = 0;
	short cflag = 0,combination=0,port_number=0;

    channel = 'f';		

	total_args = acL->argc;
	test_opt = acL->argv[2][0];
	channel = acL->argv[4][0]; 		   	
	speed = acL->decArg[5];	
	port_number = acL->decArg[6];
	loop = acL->decArg[7];
	ports = port_number;

	test_param = acL->argv[3][0];

	if (validate_params() == INVALID_PARAMETERS)
	{
		eprintf("Invalid parameters. \n");
		return INVALID_PARAMETERS;
	}

	if (total_args <= 7)
	{
		loop = 1;
	}
		
	if (channel == 'c')
	{
		cflag = 1;
	}

	if (loop == 0)
	{
		forever = 1;
	}
	else
	{
		forever = 0;
	}

	put_ring_base = SCR_RING_INSTR_ADDR;
	get_ring_addr = SCR_RING_INSTR_ADDR + (4 << 2);

	if(acL->HostType == MASTER)		// if master NPU
	{
		flag = OK;

		Msf_OutOfReset();
		status = Msf_PLL();
		if (status == ERROR)
		{
			return ABORT;
		}

		// initializing media card
		status=init_mac_dev(0);	
		if (status != DONE)
		{
			eprintf("Aborting Test\n");
			return ABORT;
		}

		spConfig();
	    reg_write(0x5b2,0x0);
		switch(test_param)
		{
		case 'c': /* Frame size test */
		case 'j':
			for(ctr=0;ctr<4;ctr++)
			{
				/* Configure max frame size to 12K*/
				reg_write((0xF + 0x80*ctr), 0x3000);
			}
			break;
		case 'l':  /* Rmon Long Error test */
			for(ctr=0;ctr<4;ctr++)
			{
				/* Configure max frame size to >5K */
				reg_write((0xF + 0x80*ctr), 0x1410);
			}
			break;
		case 'b':   /* Rmon jabber error test*/
			for(ctr=0;ctr<4;ctr++)
			{
				/* Configure max frame size to >5K */
				reg_write((0xF + 0x80*ctr), 0x1410);
				/* disable CRC addition/strip*/
				reg_write((0x18 + 0x80*ctr), 0x114D);
			}
			reg_write(0x5B3, 0x0);	
			break;
		}
	    spRestore();

		clear_stat_regs();

		dcache_status = get_CP15() & DCACHE_BIT;
		if(dcache_status != 0)	// if dcache ON
		{
			dcache_off();
		}

		makePkt(256);
		makePkt(512);
		makePkt(1024);
		makePkt(1520);
		makePkt(5*1024);
		//makePkt(10*1024);
		makePkt(11*1024);

		// write packet to be transmitted on each port, into DRAM.
		write_pkt_to_dram();
		iteration=get_pkt_seq(&pktptr, &pnum,cflag,port_number);

		*(PCI_ADDR_EXT_REG) = (slave_dev_info.base_address[CSR_BAR] & 0xE0000000) >> 16;
		slave_mailbox0_addr = slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_0_OFF;
		slave_mailbox1_addr = slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_1_OFF;
		slave_mailbox2_addr = slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_2_OFF;
		slave_mailbox3_addr = slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_3_OFF;

		// Init master's mailbox0 to 0
		PUT32((PCI_LOCAL_CSR_BASE + MAILBOX_0_OFF), 0);

		// Init slave's mailbox0 and mailbox2 to 0
		PUT32(slave_mailbox0_addr, 0);
		PUT32(slave_mailbox3_addr, 0);
		
		loop_count = loop;
		msg = (cflag << 31) | ((loop & 0x7FFF)<<16) | port_number;

#ifdef __ARMEB__
		PUT32(slave_mailbox2_addr, SWAP32(msg));
#else
		PUT32(slave_mailbox2_addr, msg);
#endif

		Set_Pci_Doorbell(PTLONE_MEDIA_LPBK, (slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + XSCALE_DOORBELL_OFF));

		ctr = 0;
		do		// Wait for a signal that slave NPU has completed loading of ucode and init
		{
			if (ctr == 1500)	// After 15 seconds
			{
				mailbox_value = INIT_ERROR;
				flag = ERROR;
				break;
			}

			temp = swap32(GET32(slave_mailbox3_addr));

			hal_delay_us(10000);
			ctr++;
		}
		while (temp == 0);

		if (temp != INIT_COMPLETE)
		{
			eprintf("MSF init failure on Ingress ...\n");
			return ABORT;
		}
			
        status = DownLoadUcode(PTLONE_MEDIA_LOOPBACK_TX_ME, sizeof(pl_media_lpbk_jumboFrame_tx), (UINT32 *)(pl_media_lpbk_jumboFrame_tx));
		if (status != OK)
		{
			eprintf("Error downloading microcode on Master NPU ...\n");
			return ABORT;
		}

		hal_delay_us(1000);

		if (loop_count == 0)
		{
		    forever = 1;
		}
		while ((9*loop_count != per_port_pkts) || forever)
		{

		    if (forever && KEYPRESS)
		    {
				stop = 1;
				PUT32(slave_mailbox2_addr, stop);
		    }

			// put byte count in the scratch ring locations for all the 4 ports.	

			for (combination = 0; combination < pnum; combination++)
			{
				for (port = 0; port < iteration; port++)
				{
					if (port_number != 4)
					{
						port_num = port_number;
						PUT32((SCR_RING_INSTR_ADDR + (port_num << 2)), pktptr[combination]);
						//eprintf("location = 0x%08X pktptr[%d] = 0x%x \n",(SCR_RING_INSTR_ADDR + (port_num << 2)),combination,pktptr[combination]);
					}
					else
					{
						if (cflag)
							port_num = port*2;
						else
							port_num = port;
							PUT32((SCR_RING_INSTR_ADDR + (port_num << 2)), fs_tx_data_pl[((combination * 4) + port_num)]);
					}
				}
			}


		   //hal_delay_us(100000);

			for (combination = 0; combination < pnum; combination++)
			{
				//for (port_num = 0; port_num < 4; port_num++)
				for (port_ctr = 0; port_ctr < iteration; port_ctr++)
				{
					if (port_number != 4)
						port_num = port_number;
					else
					{
						if (cflag)
							port_num = port_ctr*2;
						else
							port_num = port_ctr;
					}

					ctr = 0;
					do	// check if the packet was transmitted by master NPU
					{
		   				if (ctr == 700000)	// After 3 seconds
						{
							mailbox_value = NOT_SENT;
							flag = ERROR;
							break;
						}

						// Poll on scratch ring to check if packet was transmitted
						mailbox_value = GET32(get_ring_addr);

						hal_delay_us(1);
						ctr++;
					}
					while (mailbox_value != 0);
					txpkts = mailbox_value;
					if (flag == ERROR)
					{
			            fail_port = port_ctr;		
						break;
			        }
					packet_num++;
				}  // end of port for loop

				if (flag == ERROR)
					break;
			}

	        if (flag == OK)		// If master has successfully transmitted packets
  		    {
				txok = 1;	
				eprintf("Transmitted : %d\r",packet_num);
				ctr = 0;
				mailbox_value = 0;
				do	// Wait for a signal from the slave for indication of completion of test
				{
 		            if (ctr == 500000)	// After 3 seconds
					{
			            mailbox_value = SLAVE_MAILBOX1_NO_SIG;
			            flag = ERROR;
			            break;
					}

		            // Poll on slave's MAILBOX1 to check if packet was received by slave
			        mailbox_value = GET32(slave_mailbox1_addr);

 			        hal_delay_us(10);
			        ctr++;
				}
				while (mailbox_value == 0);

				PUT32(slave_mailbox1_addr, 0);
			}
			if (port_number == 4)
			{
				if (cflag)
					per_port_pkts = packet_num/2;
				else
					per_port_pkts = packet_num/4;
			}
			else
				per_port_pkts = packet_num;

			
			if ((flag == ERROR) || (stop == 1))
			{
			    break;
			}
				
	    }  // end of while loop_count 
		if (loop == 0)
			loop = loop_count;

	    eprintf("\n");
		if ((flag == OK) || (txok))
		{

			switch(port_number)
			{
				case 0 : 
				case 1 : 
				case 2 : 
				case 3 : 
						eprintf("\nTransmitted on port %d: %d\n", port_number,packet_num);
						break;
    
				case 4 : // all ports 
						if (!cflag)
							eprintf("\nTransmitted on ports 0-3 : %d\n", packet_num/4);
						else
							eprintf("\nTransmitted on ports 0 and 2 : %d\n", packet_num/2);
						break;
			}
		}
		if (flag == OK)
		{
			ctr = 0;
			do	// Wait for a signal from the slave for indication of completion of test
			{
				if (ctr == 900000)	// After 3 seconds
				{
					mailbox_value = SLAVE_MAILBOX0_NO_SIG;
					flag = ERROR;
					break;
				}

				// Poll on slave's MAILBOX1 to check if packet was received by slave
#ifdef __ARMEB__
				mailbox_value = SWAP32(GET32(slave_mailbox0_addr));
#else
				mailbox_value = GET32(slave_mailbox0_addr);
#endif
				hal_delay_us(100);
				ctr++;
			}
			while (mailbox_value == 0);
		}

		if(dcache_status != 0)	// if dcache was originally ON
		{
			dcache_on();
		}

		switch(test_param)
		{
		case 'j':
				if (verify_stats(cflag))
					test_passed = 1;	
				else
				{
					strcpy(syslog.desc, "\nRMON Big packets stat. test FAILED\n!");
					eprintf("\nRMON Big packets stat. test FAILED\n!");
					test_passed = 0;
				}
				break;
		case 'l':
				if (verify_error(cflag))
					test_passed = 1;	
				else
				{
					strcpy(syslog.desc, "\nRMON LongError Register test FAILED\n!");
					eprintf("\nRMON LongError Register test FAILED\n!");
					test_passed = 0;
				}
				break;
		case 'b':
				if (verify_error(cflag))
					test_passed = 1;	
				else
				{
					strcpy(syslog.desc, "\nRMON JabberError Register test FAILED\n!");
					eprintf("\nRMON BLongError Register test FAILED\n!");
					test_passed = 0;
				}
				break;

		case 'c':
			if (mailbox_value == TEST_COMPLETE)
			{
				test_passed = 1;
				eprintf("Frame Size test...PASSED\n");
			}
			else
			{
				eprintf("\nFrame Size test...FAILED\n");
				strcpy(syslog.desc, "Frame Size test FAIL!");
			}
			break;
		default: eprintf("Invalid test parameter\n");
				 return ABORT;

		}

		if (!test_passed)
		{
			if (mailbox_value == SLAVE_MAILBOX0_NO_SIG)
			{
				eprintf("No signal was received from slave NPU to indicate completion\n");
			}
			else if (mailbox_value == ERROR_PATTERN)
			{
				eprintf("The packet received was not the same as the packet transmitted\n");
			}
			else if (mailbox_value == INCORRECT_SIZE)
			{
				eprintf("The packet received was not the same size as the packet transmitted\n");
			}
			else if (mailbox_value == SLAVE_MAILBOX1_NO_SIG)
			{
				eprintf("Slave NPU did not indicate that it received a packet\n");
			}
			else if (mailbox_value == NOT_SENT)
			{
				eprintf("Master NPU did not manage to transmit a packet\n");
			}
			else if (mailbox_value == NOT_RECEIVED)
			{
				eprintf("Slave NPU did not receive a packet\n");
			}
			else if (mailbox_value == RECEIVE_ERROR)
			{
				eprintf("Slave NPU receive a packet with an error\n");
			}
			else if (mailbox_value == INIT_ERROR)
			{
				eprintf("Slave NPU could not load its microcode and init\n");
			}

			// prepare structure for dumping
			syslog.type = TYPE_ERROR;
			syslog.source_comp = MASTER_DIAG;	// Determine master/slave
			// write to syslog
			syslog_dump(&syslog, sizeof(SYSLOG_DATA));

			Set_LED("LbkF");
			slowport_code[0] = SP_XSC;
			slowport_code[1] = SP_FAIL;
			dump_slowport(slowport_code, 2, SP_NON_FATAL);
			acL->Err = ERROR;
		}
		else
		{
				Set_LED("PASS");
				slowport_code[0] = SP_XSC;
				slowport_code[1] = SP_PASS;
				dump_slowport(slowport_code, 2, SP_NON_FATAL);
		}

		Clear_All_ME();
	}
	else
	{
		eprintf("\nThis test cannot be run directly on the Slave console\n");
		return DONE;	// To indicate that the slave does not do this.
	}	
	return DONE;
}


// ******************************************************************************
// Function: void PL_Media_Loopback_Slave(void)
//
// This function will be called by the PCI Doorbell Interrupt handler after the
// Master NPU initiates a PCI Doorbell Interrupt on the Slave NPU
// ******************************************************************************
void PL_Media_Loopback_Slave(void)
{
	UINT32 ctr, port_ctr, flag, status, loop_count, forever, packet_num = 0, error=0, rx_port_num=0;
	UINT32 dram_addr, lw1;
	UINT32 packet_len, mailbox_value=0;
	UINT32 get_ring_addr=0;
	UINT dcache_status;
	UINT32 *media_lb_data=0;
	UINT32 pass_port[4],ports=0;
	UINT32 mailbox2_val = 0,data=0;
	UINT32 rxflag[4], temp =0,exp_pkt_sz=0;
	UINT32 iteration = 0,port_num=0, per_port_pkts = 0,freebuffer = 0;
	/***************************************************************************
	** The rxport is to be indexed by the txport and the value is the corresponding rxport.
	** Tx port	  Rxport
	**	0			1
	**  1			0
	**  2			3
	**  3			2
	*********************************************************************************/
	UINT32 rxport[4] = {1, 0, 3, 2};
	UINT32 msg,orig_data_size=0,pnum=0, *pktptr=0;
	short cflag = 0,combination=0;

	flag = OK;
	get_ring_addr = SCR_RING_INSTR_ADDR + (0 << 2);

	Msf_OutOfReset();
	status = Msf_PLL();
	if (status == ERROR)
	{
		return;
	}

	dcache_status = get_CP15() & DCACHE_BIT;
	if(dcache_status != 0)	// if dcache ON
	{
		dcache_off();
	}
	

	/* initialize port array to 0 */
	for (ctr = 0;ctr<4;ctr++)
	{
		pass_port[ctr] = 0;
		rxflag[ctr] = ERROR;
	}

	msg = GET32(PCI_LOCAL_CSR_BASE + MAILBOX_2_OFF);
	ports = msg & 0xFF;
	cflag = msg >> 31;
	loop_count = (msg >> 16) & 0x7FFF;
	if (loop_count == 0)
	{
		forever = 1;
	}
	else
	{
		forever = 0;
	}


	flag = DownLoadUcode(PTLONE_MEDIA_LOOPBACK_RX_ME, sizeof(pl_media_lpbk_jumboFrame_rx), (UINT32 *)(pl_media_lpbk_jumboFrame_rx));
	
	if (flag != OK)
		eprintf("Error downloading microcode on slave on ME 0!\n");

	hal_delay_us(1000);

	makePkt(256);
	makePkt(512);
	makePkt(1024);
	makePkt(1520);
	makePkt(5*1024);
	//makePkt(10*1024);
	makePkt(11*1024);

	iteration=get_pkt_seq(&pktptr, &pnum,cflag,ports);
	
	while ((9*loop_count != per_port_pkts) || forever)
	{
		for (combination = 0; combination < pnum; combination++)
		{	
			//for (port_num = 0; port_num < 4; port_num++)
			for (port_ctr = 0; port_ctr < iteration; port_ctr++)
			{
				if (!cflag)
				{
					if (ports != 4)
						port_num = ports;
					else
						port_num = port_ctr;
				}
					else
				{
					if (ports != 4)
						port_num = rxport[ports];
					else
						port_num = port_ctr*2 + 1;
				}

		
				ctr = 0;
				mailbox_value = 0;
				do		// Poll for completion of receive by ME
				{
					if (ctr == 50000)	// After 3 seconds
					{
			    		eprintf("\nTimed out...packet not received on port %d\n",port_num);
						mailbox_value = NOT_RECEIVED;
						flag = ERROR;
						rxflag[port_num] = ERROR;
						break;
					}	

					mailbox_value = GET32(get_ring_addr);

					hal_delay_us(100);
					ctr++;
				}
				while (mailbox_value == 0);

				if (flag == ERROR)
				{
					break;
				}

				/* mailbox value =  sram descriptor */
				freebuffer = mailbox_value << 2;

				data = GET32(freebuffer+CHANNEL1_BASE_ADDRESS);
				rx_port_num = data >> 24;
				packet_len = data & 0xFFFF;
				//eprintf("Rx port = %d, packet length = 0x%x\n",rx_port_num,packet_len);

				pass_port[rx_port_num] = 1;
				rxflag[rx_port_num] = OK;
				packet_num++;
				//error = (mailbox_value >> 16) & 0xFF;
				//packet_len = mailbox_value & MASK_16BIT;

				if (error > 0)
				{
					if (error & 1)
					{
						eprintf("\nBit 10 (ABORT ERROR) of Receive Status Word set\n");
					}
					else if ((error >> 1) & 1)
					{
						eprintf("\nBit 11 (LENGTH ERROR) of Receive Status Word set\n");
					}
					else if ((error >> 2) & 1)
					{
						eprintf("\nBit 12 (PARITY ERROR) of Receive Status Word set\n");
					}
	
					mailbox_value = RECEIVE_ERROR;
	
					flag = ERROR;
					rxflag[rx_port_num] = ERROR;
					break;
				}
				if (ports == 4)
				{
					exp_pkt_sz = fs_tx_data_pl[((combination * 4) + port_num)] & 0xFFFF;
				}
				else
				{
					exp_pkt_sz = pktptr[combination] & 0xFFFF;
				}
				dram_addr =  ((freebuffer - SRAM_DESC_BASE) << 12) + DRAM_BASE_OFFSET;

				if (packet_len != exp_pkt_sz)
				{
					eprintf("Received packet length = 0x%x\n",packet_len);
					eprintf("Expected packet length = 0x%x\n",exp_pkt_sz);
					mailbox_value = INCORRECT_SIZE;
					flag = ERROR;
					rxflag[rx_port_num] = ERROR;
					break;
				}

				/* In this test, the same packet is used on all the 4 ports. 
				   Hence a chack on cflag is not required. */

				if ((packet_len == (RING_DATA_96_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_96_SZ;
					media_lb_data = (UINT32 *)data96_0;
				}
				else if ((packet_len == (RING_DATA_64_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_64_SZ;
					media_lb_data = (UINT32 *)data64_0;
				}
				else if ((packet_len == (RING_DATA_138_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_138_SZ;
					media_lb_data = (UINT32 *)data138_0;
				}
				else if ((packet_len == (RING_DATA_256_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_256_SZ;
					media_lb_data = (UINT32 *)data256_0;
				}
				else if ((packet_len == (RING_DATA_512_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_512_SZ;
					media_lb_data = (UINT32 *)data512_0;
				}
				else if ((packet_len == (RING_DATA_1024_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_1024_SZ;
					media_lb_data = (UINT32 *)data1024_0;
				}
				else if ((packet_len == (RING_DATA_1520_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_1520_SZ;
					media_lb_data = (UINT32 *)data1520_0;
				}
				else if ((packet_len == (RING_DATA_5K_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_5K_SZ;
					media_lb_data = (UINT32 *)data5K_0;
				}
				else if ((packet_len == (RING_DATA_10K_0 & MASK_16BIT)) && ((rx_port_num == 0) || (rx_port_num == 1)||(rx_port_num == 2)||(rx_port_num == 3)))
				{
					orig_data_size = PKT_10K_SZ;
					media_lb_data = (UINT32 *)data10K_0;
					
				}
				else
				{
					eprintf("pkt size mismatch !! port = %d, packet len = 0x%x\n",rx_port_num,packet_len);
					mailbox_value = NOT_COMPLETE;
					flag = ERROR;		// Set flag as error
					rxflag[rx_port_num] = ERROR;
					break;
				}
				
				for (ctr = 0; ctr < packet_len; ctr+=4)
				{
					lw1 = GET32(dram_addr + ctr);
					//eprintf("2. dram_addr = 0x%08X   val = 0x%08X\n",dram_addr, *((unsigned int *)(dram_addr)));

					if (lw1 != media_lb_data[(ctr / 4)])
					{
						eprintf("ERROR: ctr=%d Orig=0x%08X Received=0x%08X\n", ctr, media_lb_data[(ctr / 4)], lw1);
						eprintf("packet len = 0x%x\n",packet_len);
						mailbox_value = ERROR_PATTERN;
						flag = ERROR;
						rxflag[rx_port_num] = ERROR;
						break;
					}
				}

				if(mailbox_value == ERROR_PATTERN)
				{
					eprintf("Port %d received a packet with pattern errors\n", rx_port_num);
					break;
				}
			}	// end of per port processing
			if (flag == ERROR)
				break;
		}	  // combinations

		switch(ports)
		{
		   case 0:
		   case 1:
		   case 2:
		   case 3:   
					if (!cflag)
					{
						if (pass_port[ports] == 0)
						{
							eprintf("Did not Receive packet on port %d\n", ports);
							flag = ERROR;
							rxflag[ports] = ERROR;
						}
					}
					else
					{
						if (pass_port[rx_port_num] == 0)
						{
							eprintf("Did not Receive packet on port %d\n", rx_port_num);
							flag = ERROR;
							rxflag[rxport[ports]] = ERROR;
						}
					}


						break;

		   case 4:  
					if (!cflag)
					{
						for (ctr=0; ctr<4; ctr++)
						{
							if (pass_port[ctr] == 0)
							{
								eprintf("Did not Receive packet on port %d\n", ctr);
								rxflag[ctr] = ERROR;
							}
						}
					}
					else
					{
						for (ctr=0; ctr<2; ctr++)
						{
							if (pass_port[ctr*2+1] == 0)
							{
								eprintf("Did not Receive packet on port %d\n", ctr*2+1);
								rxflag[ctr*2+1] = ERROR;
							}
						}
					}
					
					break;
					
		   default:   eprintf("This is bad value for port number \n");
							break;

		}

		if (flag == ERROR)
			break;
		
		for (ctr =0;ctr <4; ctr ++)
		{
			if (rxflag[ctr] == OK)
				temp ++;
		}

		if ((ports >=0) && (ports <=3))
		{
			if (!cflag)
			{
				if (rxflag[ports] == OK)
				{	
					flag = OK;
				}
				else 
				{
					flag = ERROR;
				}
			}
			else
			{
				if (rxflag[rxport[ports]] == OK)
				{
					flag = OK;
				}
				else 
				{
					flag = ERROR;
				}
			}
		}

		if ((ports == 4) && (temp == 2))
		{
			flag = OK;		
		}	

		if((ports == 4) && (cflag))
			per_port_pkts = packet_num/2;
		else if((ports == 4) && (!cflag))
			per_port_pkts = packet_num/4;
		else 
			per_port_pkts = packet_num;
		
		eprintf("Received : %d\r",packet_num);

		PUT32((PCI_LOCAL_CSR_BASE + MAILBOX_1_OFF), PACKET_RECEIVED);
		// mailbox 2 has  : loop_count (31:16) and port (15:0)
		mailbox2_val = GET32(PCI_LOCAL_CSR_BASE + MAILBOX_2_OFF);
		mailbox2_val = (mailbox2_val >> 16) & 0x7FFF;
		
		if ((forever && mailbox2_val) || (flag == ERROR))
		{
			break;
		}

	}	// end of while loop

	eprintf("\n");
	
	switch(ports)
	{
		case 0:
		case 1:
		case 2:
		case 3:
				if (!cflag)
				{
					if (pass_port[ports] == 1)
					{	
						eprintf("Received %d packets on Port %d\n",packet_num,ports);
					}
				}
				else
				{
					if (pass_port[rxport[ports]] == 1)
					{	
						eprintf("Received %d packets on Port %d\n",packet_num,rxport[ports]);
					}
				}
				break;
		case 4:
				if (!cflag)
				{
					for (ctr=0; ctr<4; ctr++)
					{
						if (pass_port[ctr] == 1)
						{
							eprintf("Received: %d on port %d\n", packet_num/4, ctr);
						}
						
					}
				}
				else
				{
					for (ctr=0; ctr<2; ctr++)
					{
						if (pass_port[ctr*2+1] == 1)
						{
							eprintf("Received: %d on port %d\n", packet_num/2, ctr*2+1);
						}
						
					}
				}

				break;
	}
	
	if (flag == OK)
	{
		eprintf("Slave writing Test Complete \n"); 	
		PUT32((PCI_LOCAL_CSR_BASE + MAILBOX_0_OFF), TEST_COMPLETE);
	}
	else
	{
		eprintf("Slave writing : 0x%x\n",mailbox_value);
		PUT32((PCI_LOCAL_CSR_BASE + MAILBOX_0_OFF), mailbox_value);
	}

	if(dcache_status != 0)	// if dcache was originally ON
	{
		dcache_on();
	}

	Clear_All_ME();
}

void write_pkt_to_dram()
{
	int ctr=0;
	UINT32 addr=0;


	if ((ports == 0) || (ports == 1) || (ports == 2) || (ports == 3)|| (ports == 4))
	{
		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_0 >> 8) & (MASK_16BIT << 8)) + ctr), data96_0[(ctr / 4)]);
		}
	
		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_0 >> 8) & (MASK_16BIT << 8)) + ctr), data64_0[(ctr / 4)]);
		}
	
		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_0 >> 8) & (MASK_16BIT << 8)) + ctr), data138_0[(ctr / 4)]);
		}
		for (ctr = 0; ctr < PKT_256_SZ; ctr+=4)
		{
			addr = (RING_DATA_256_0 >> 16) << 8;
			PUT32((DRAM_BASE_SRC + addr + ctr), data256_0[(ctr / 4)]);
		}
		for (ctr = 0; ctr < PKT_512_SZ; ctr+=4)
		{
			addr = (RING_DATA_512_0 >> 16) << 8;
			PUT32((DRAM_BASE_SRC + addr + ctr), data512_0[(ctr / 4)]);
		}
		for (ctr = 0; ctr < PKT_1024_SZ; ctr+=4)
		{
			addr = (RING_DATA_1024_0 >> 16) << 8;
			PUT32((DRAM_BASE_SRC + addr + ctr), data1024_0[(ctr / 4)]);
		}
		for (ctr = 0; ctr < PKT_1520_SZ; ctr+=4)
		{
			addr = (RING_DATA_1520_0 >> 16) << 8;
			PUT32((DRAM_BASE_SRC + 0x1000 + addr + ctr), data1520_0[(ctr / 4)]);
		}
		for (ctr = 0; ctr < PKT_5K_SZ; ctr+=4)
		{
			addr = (RING_DATA_5K_0 >> 16) << 8;
			PUT32((DRAM_BASE_SRC + addr + 0x1000 + ctr), data5K_0[(ctr / 4)]);
		}
		for (ctr = 0; ctr < PKT_10K_SZ; ctr+=4)
		{
			addr = (RING_DATA_10K_0 >> 16) << 8;
			PUT32((DRAM_BASE_SRC + addr + 0x2000 + ctr), data10K_0[(ctr / 4)]);
		}

	}
}

void verify_frame(UINT32 pkt_size, UINT32*ds, UINT32*media_lb_data, UINT32 rx_port_num)
{
	UINT32 orig_data_size=0;

	if ((pkt_size == (RING_DATA_96_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_0 >> 20) & MASK_8BIT)))
	{
		orig_data_size = PKT_96_SZ;
		media_lb_data = (UINT32 *)data96_0;
	}
	else if ((pkt_size == (RING_DATA_64_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_0 >> 20) & MASK_8BIT)))
	{
		orig_data_size = PKT_64_SZ;
		media_lb_data = (UINT32 *)data64_0;
	}
	else if ((pkt_size == (RING_DATA_138_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_0 >> 20) & MASK_8BIT)))
	{
		orig_data_size = PKT_138_SZ;
		media_lb_data = (UINT32 *)data138_0;
	}

	*ds = orig_data_size;

}

UINT32 get_pkt_seq(UINT32 **pktptr, UINT32 *num_frames,UINT32 cflag,UINT32 port)
{
	UINT32 iteration=0,pnum = *num_frames;
	UINT32 **ptr = pktptr;
	
	switch(port)
	{
		case 0: *ptr = fs_tx_data_pl_0;
				pnum = PKT_SEQ_SZ/4; 
				iteration = 1;
				break;
		case 1: *ptr = fs_tx_data_pl_0;
				pnum = PKT_SEQ_SZ/4;
				iteration = 1;
				break;
		case 2: *ptr = fs_tx_data_pl_0;
				pnum = PKT_SEQ_SZ/4;
				iteration = 1;
				break;
		case 3: *ptr = fs_tx_data_pl_0;
				pnum = PKT_SEQ_SZ/4;
				iteration = 1;
				break;
		case 4: *ptr = fs_tx_data_pl;
				pnum = ALL_PORT_PKT_SEQ_SZ/(4*4);
				if (cflag)
					iteration = 2;
				else
					iteration = 4;
				break;
	}

	*num_frames = pnum;
	return iteration;
}



void makePkt(UINT32 size)
{

	int i=0;
	UINT32 WORD = 0x00101010;

	switch (size)
	{
	case 0x100 : 
		for (i=0;i<=size/4;i++)
		{
			data256_0[i] = WORD;
			WORD+=0x10;
		}
		break;
	case 0x200 : 
		WORD = 0x00101010;
		for (i=0;i<=size/4;i++)
		{
			data512_0[i] = WORD;
			WORD+=0x10;
		}
		break;
	case 0x400 : 
		WORD = 0x00101010;
		for (i=0;i<=size/4;i++)
		{
			data1024_0[i] = WORD;
			WORD+=0x10;
		}
		break;
	case 0x5F0 : 
		WORD = 0x00101010;
		for (i=0;i<=size/4;i++)
		{
			data1520_0[i] = WORD;
			WORD+=0x10;
		}
		break;

	case 0x1400 : 
		WORD = 0x00101010;
		for (i=0;i<=size/4;i++)
		{
			data5K_0[i] = WORD;
			WORD+=0x10;
		}

		break;
	case 0x2800 : 
		WORD = 0x00101010;
		for (i=0;i<=size/4;i++)
		{
			data10K_0[i] = WORD;
			WORD+=0x5;
		}

		data5K_0[0] = 0x00101010;
		break;

	case 0x2C00 : 
		WORD = 0x00202020;
		for (i=0;i<=size/4;i++)
		{
			data10K_0[i] = WORD;
			WORD+=0x5;
		}

		data5K_0[0] = 0x00101010;
		break;

	default:
		eprintf("Invalid size \n");
		return;
	}
}

short verify_error(short cflag)
{
	UINT32 rxLongError[4],rxJabberError[4];
	short test_passed = 0,iteration,port,port_ctr;
	short rxok=0;

	if (ports == 4)
		if (!cflag)
			iteration = 4;
		else
			iteration = 2;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<4;port++)
    {	
		/* Reading Rx Stat regs */
		rxLongError[port] = reg_read(((port*PORTSZ)+0x30));  
		rxJabberError[port] = reg_read(((port*PORTSZ)+0x31)); 
	}

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{
		if ((!cflag) && (ports == 4))
			port = port_ctr;
		if ((cflag) && (ports == 4))
		{
			port = port_ctr*2;
			port = rxport[port];
		}
		if ((!cflag) && (ports != 4))
			port = ports;
		if ((cflag) && (ports != 4))
			port = rxport[ports];

		switch(test_param)
		{
		case 'l':
				eprintf("RX LongErrors = \t%d on port %d\n",rxLongError[port],port);
				if (rxLongError[port] == loop)
				{
					eprintf("Rx LongError Register test, OK , Port %d\n",port);
					rxok ++ ;
				}
				else
				{
					eprintf("Rx LongError Register test, FAILED , Port %d\n",port);
				}

				break;
		case 'b':
				eprintf("RX LongErrors = \t%d on port %d\n",rxJabberError[port],port);
				if (rxJabberError[port] == loop)
				{
					eprintf("Rx JabberError Register test, OK , Port %d\n",port);
					rxok ++ ;
				}
				else
				{
					eprintf("Rx JabberError Register test, FAILED , Port %d\n",port);
				}
				break;
		}
	}
	if (((iteration == 1) && rxok)  ||
		((iteration == 2) && (rxok == 2) ) ||
		((iteration == 4) && (rxok==4) ))
	{
		eprintf("\nRMON stat test PASSED. \n");
		test_passed = 1;
	}

	return test_passed;
}

short verify_stats(short cflag)
{
	UINT32 rx256pkts[4],rx512pkts[4],rx1024pkts[4],rxBigpkts[4]; 
	UINT32 tx256pkts[4],tx512pkts[4],tx1024pkts[4],txBigpkts[4]; 

	short test_passed = 0,iteration,port,port_ctr;
	short rxok=0,txok=0;

	if (ports == 4)
		if (!cflag)
			iteration = 4;
		else
			iteration = 2;
	else
		iteration = 1;

	spConfig();

    for(port=0; port<4;port++)
    {	
		/* Reading Rx Stat regs */
		rx256pkts[port] = reg_read(((port*PORTSZ)+RX_PKTS_256_511));  
		rx512pkts[port] = reg_read(((port*PORTSZ)+RX_PKTS_512_1023));  
		rx1024pkts[port] = reg_read(((port*PORTSZ)+RX_PKTS_1024_1518));  
		rxBigpkts[port] = reg_read(((port*PORTSZ)+RX_PKTS_1519_MAX)); 

		/* Reading Tx stat */
		tx256pkts[port] = reg_read(((port*PORTSZ)+TX_PKTS_256_511));  
		tx512pkts[port] = reg_read(((port*PORTSZ)+TX_PKTS_512_1023));  
		tx1024pkts[port] = reg_read(((port*PORTSZ)+TX_PKTS_1024_1518));  
		txBigpkts[port] = reg_read(((port*PORTSZ)+TX_PKTS_1519_MAX));  		
	}

	spRestore();

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{
		if ((!cflag) && (ports == 4))
			port = port_ctr;
		if ((cflag) && (ports == 4))
		{
			port = port_ctr*2;
			port = rxport[port];
		}
		if ((!cflag) && (ports != 4))
			port = ports;
		if ((cflag) && (ports != 4))
			port = rxport[ports];

		eprintf("RX 256 byte pkts = \t%d on port %d\n",rx256pkts[port],port);
		eprintf("RX 512 byte pkts = \t%d on port %d\n",rx512pkts[port],port);
		eprintf("RX 1024 byte pkts = \t%d on port %d\n",rx1024pkts[port],port);
		eprintf("RX Big pkts = \t%d on port %d\n",rxBigpkts[port],port);

		if ((rx256pkts[port] == loop) &&
			(rx512pkts[port] == loop) &&
			(rx1024pkts[port] == loop) &&
			(rxBigpkts[port] == 3*loop))
		{
			eprintf("RMON Rx stat test, OK , Port %d\n",port);
			rxok ++ ;
		}
		else
		{
			eprintf("RMON Rx stat test, FAILED , Port %d\n",port);
		}

		if (cflag)
			port=rxport[port];

		eprintf("TX 256 byte pkts = \t%d on port %d\n",tx256pkts[port],port);
		eprintf("TX 512 byte pkts = \t%d on port %d\n",tx512pkts[port],port);
		eprintf("TX 1024 byte pkts = \t%d on port %d\n",tx1024pkts[port],port);
		eprintf("TX Big pkts = \t%d on port %d\n",txBigpkts[port],port);

		if ((tx256pkts[port] == loop) &&
			(tx512pkts[port] == loop) &&
			(tx1024pkts[port] == loop) &&
			(txBigpkts[port] == 3*loop))
		{
			eprintf("RMON Tx stat test, OK , Port %d\n",port);
			txok++ ;
		}
		else
		{
			eprintf("RMON Tx stat test, FAILED , Port %d\n",port);
		}

	}

	if (((iteration == 1) && rxok && txok) ||
		((iteration == 2) && (rxok == 2) && (txok==2)) ||
		((iteration == 4) && (rxok==4) && (txok==4)))
	{
		eprintf("\nRMON stat test passed. \n");
		test_passed = 1;
	}

	return test_passed;
}



