/*
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------------
 */

typedef unsigned long ulong;
typedef unsigned short ushort;

#include "common.h"
#include "memory.h"
#include "msf_common.h"
#include "diagstruct.h"
#include "led.h"
#include "uc_load.h"
#include "pci_diag.h"
#include "pci.h"
#include "hal_ixdp2400.h"
#include "memory.h"
#include "syslog.h"
#include "uart.h"
#include "msf_init.h"
#include "diag_utils.h"

#include "error_code.h"
#include "error_map.h"
#include "reg_api.h"
#include "register_map.h"
#include "diag.h"
#include "dp_proto.h"
#include "mac_util.h"

#define UNI_PKTFILCTRL	0x1
#define MUL_PKTFILCTRL	0x2
#define BRD_PKTFILCTRL	0x4
#define HI_MUL_ADDR	0xA1B0C0D0
#define LO_MUL_ADDR	0xE0F0

extern const int pl_sys_loopback_eg_rx[];
extern const int pl_sys_loopback_eg_tx[];
extern const int pl_sys_loopback_in_rx[];
extern const int pl_sys_loopback_in_tx[];

extern UINT32 Sz_pl_sys_loopback_eg_rx;
extern UINT32 Sz_pl_sys_loopback_eg_tx;
extern UINT32 Sz_pl_sys_loopback_in_rx;
extern UINT32 Sz_pl_sys_loopback_in_tx;


extern pci_device slave_dev_info;		// for slave npu info.
extern UINT32 PKT_96_SZ,PKT_64_SZ,PKT_138_SZ;
extern UINT32 PKT_SEQ_SZ,ALL_PORT_PKT_SEQ_SZ;

extern  UINT32 *pl_sys_lb_data96_0;
extern  UINT32 *pl_sys_lb_data64_0;
extern  UINT32 *pl_sys_lb_data138_0;
extern  UINT32 *pl_sys_lb_data96_1;
extern  UINT32 *pl_sys_lb_data64_1;
extern  UINT32 *pl_sys_lb_data138_1;
extern  UINT32 *pl_sys_lb_data96_2;
extern  UINT32 *pl_sys_lb_data64_2;
extern  UINT32 *pl_sys_lb_data138_2;
extern  UINT32 *pl_sys_lb_data96_3;
extern  UINT32 *pl_sys_lb_data64_3;
extern  UINT32 *pl_sys_lb_data138_3;

extern UINT32 tx_data_pl[];
extern UINT32 tx_data_pl_0[];
extern UINT32 tx_data_pl_1[];
extern UINT32 tx_data_pl_2[];
extern UINT32 tx_data_pl_3[];

extern UINT32 data64_0[];
extern UINT32 data64_1[];
extern UINT32 data64_2[];
extern UINT32 data64_3[];
extern UINT32 data96_0[];
extern UINT32 data96_1[];
extern UINT32 data96_2[];
extern UINT32 data96_3[];
extern UINT32 data138_0[];
extern UINT32 data138_1[];
extern UINT32 data138_2[];
extern UINT32 data138_3[];



#define UC_PKTS			3	 /* expected unicast packets, per port */
#define MC_PKTS			3	 /* expected multicast packets, per port */
#define BC_PKTS			3	 /* expected broadcast packets, per port */
#define EXP_DROPPED_PKTS	3	 /* expected dropped packets, per port */



/** globals **/
extern UINT32 total_args,loop,ports,speed;  
extern char channel,test_opt;
extern UINT8 test_param, dplx;

extern UINT32 validate_params(void);
extern UINT32 init_mac_dev(UINT32);
extern void spConfig(void);
extern void spRestore(void);
extern void get_stats(void);
extern void get_packets_for_filter_test();
extern void clear_stat_regs();
extern void mac_reset_config(void);
extern void mac_disable_reset(void);
extern void config_phy_for_line_lpbk(void);
extern UINT32 mac_address_filter_test();
extern UINT32 vlan_pause_filter_test();
extern UINT32 frame_size_test();
extern UINT32 crc_test();
extern UINT32 padding_test();
extern void gets(char *str, int len);

/* local functions */
int get_TX_collisions();
int get_Rx_DataError();
UINT32 collision_test(void);
int get_Rx_AlignError();
int get_Rx_SeqError();
int get_Rx_SymError();
int get_Rx_LongError();
int get_Rx_JabberError();

// ******************************************************************************
// Function: void spi3_test(void)
//
// This function is called by the Test Manager when the user invokes the
// point Lone system loopback test
// ******************************************************************************

UINT32 rmon_test(void)
{
	register PDiagCommon acL = (PDiagCommon) ACADDRESS;

	test_param = acL->argv[3][0];


	switch(test_param)
	{
	
	case '1': 
			mac_address_filter_test();
			break;
	case '2': 
	case '3':
			vlan_pause_filter_test();
			break;
	case '4': 
			crc_test();
			break;
	case '5': 
	case '6':
			padding_test();
			break;
	case 'j':
			frame_size_test();
			break;
	case 'c': 
	case 'd': 
	case 'l':
	case 'b':
	case 'a': 
	case 's': 
	case 'y': 
			collision_test();
			break;
	}

	return DONE;
}

UINT32 collision_test(void)
{
	UINT32 ctr, flag, slave_mailbox0_addr, status, tx_count=0;
	UINT32 scratch_ring_tx_count, scratch_ring_rx;
	UINT32 dcache_status, forever = 0, combination, port_num;
	UINT32 loop_count=0;
	UINT32 scratch_read_value=0;
	volatile int mailbox_value, temp;
	register PDiagCommon acL = (PDiagCommon) ACADDRESS;
	UINT32 pass_port[4],rxflag[4];
	UINT32 iteration = 0, port_ctr=0, pnum=0, *pktptr=0;
	UINT32 cflag = 0;
	char c[2];
	short rmon_flag=0;
	
    channel = 'f';		

	total_args = acL->argc;
	test_opt = acL->argv[2][0];
	test_param = acL->argv[3][0];
	channel = acL->argv[4][0]; 		   	
	speed = acL->decArg[5];	
	ports = acL->decArg[6];
	loop = acL->decArg[7];

	if (validate_params() == INVALID_PARAMETERS)
	{
		eprintf("Invalid parameters. \n");
		return INVALID_PARAMETERS;
	}
	eprintf("THIS TEST REQUIRES PACKET GENERATOR !\n");
	eprintf("-------------------------------------\n");
	eprintf("\n");
	eprintf("Is the setup ready (y/n) ? \n");
	gets(c,2);
	eprintf("c: %c %c \n",c[0], c[1]);

	if (c[0] != 'y')
	{
		eprintf("Setup not ready. Aborting test. \n");
		return ABORT;
	}

	if (channel == 'c')
	{
		cflag = 1;
	}

	if (total_args <= 7)
	{
		loop = 1;
	}

	if (loop == 0)
	{
		forever = 1;
	}
	else
	{
		forever = 0;
	}
	
	/* initialize port array to 0 */
	for (ctr = 0;ctr<4;ctr++)
	{
		pass_port[ctr] = 0;
		rxflag[ctr] = ERROR;
	}

	/* get the packet data used specifically for the test */
	get_packets_for_filter_test();

				switch(ports)
				{
					case 0: pktptr = tx_data_pl_0;
							pnum = PKT_SEQ_SZ/4; 
							iteration = 1;
							break;
					case 1: pktptr = tx_data_pl_1;
							pnum = PKT_SEQ_SZ/4;
							iteration = 1;
							break;
					case 2: pktptr = tx_data_pl_2;
							pnum = PKT_SEQ_SZ/4;
							iteration = 1;
							break;
					case 3: pktptr = tx_data_pl_3;
							pnum = PKT_SEQ_SZ/4;
							iteration = 1;
							break;
					case 4: pktptr = tx_data_pl;
							pnum = ALL_PORT_PKT_SEQ_SZ/(4*4);
							iteration = 4;
							break;
				}


	scratch_ring_rx = SCR_RING_INSTR_ADDR + (5 << 2);
	scratch_ring_tx_count = SCR_RING_INSTR_ADDR + (4 << 2);

	if(acL->HostType == MASTER)		// if master NPU
	{
		flag = OK;

		Msf_OutOfReset();
		status = Msf_PLL();
		if (status == ERROR)
		{
			return ABORT;
		}

		/* collsion will occur only in half duplex mode */
		dplx = 'h';
		eprintf("Initialising media card. Please wait...\n");
		status = init_mac_dev(0);	
		if (status != DONE)
		{
			eprintf("Aborting Test\n");
			return ABORT;
		}
	
		clear_stat_regs();
		spConfig();
		switch(test_param)
		{
		case 'c':
			    eprintf("Testing Collisions...\n");
				eprintf("Please configure Packet Generator to force Collisions on line...\n");

				for(port_ctr=0; port_ctr<NUM_PORTS;port_ctr++)
				{
					/* force half duplex */
					reg_write((DESIRED_DUPLEX+(port_ctr*PORTSZ)),0); 
				}
				break;
		case 'd':
			    eprintf("Testing Rx DataError...\n");
				eprintf("Please configure Packet Generator to force DATA ERROR on line...\n");
				break;
		case 'a':
			    eprintf("Testing Rx AlignError...\n");
				eprintf("Please configure Packet Generator to force ALIGN ERROR on line...\n");
				break;

		case 's':
			    eprintf("Testing Rx Sequence Error...\n");
				eprintf("Please configure Packet Generator to force SEQUENCE ERROR on line...\n");
				break;
		case 'y':
			    eprintf("Testing Rx Symbol Error...\n");
				eprintf("Please configure Packet Generator to force Symbol ERROR on line...\n");
				break;
		case 'l':
			    eprintf("Testing Rx Long Error...\n");
				eprintf("Please configure Packet Generator to force Long ERROR on line...\n");
				break;
		case 'b':
			    eprintf("Testing Rx Jabber Error...\n");
				eprintf("Please configure Packet Generator to force Jabber ERROR on line...\n");
				break;

		default :
			eprintf("Invalid parameters. \n");
			return INVALID_PARAMETERS;
		}
		eprintf("Enter 'y' to start test ..\n");
		gets(c,2);
		if (c[0] != 'y')
			return ABORT;
		/* configure phy to auto-negotiate */
		config_phy_for_line_lpbk();

		spRestore();
		eprintf("Media card initialisation completed.\n");

		dcache_status = get_CP15() & DCACHE_BIT;
		if(dcache_status != 0)	// if dcache ON
		{
			dcache_off();
		}

		*(PCI_ADDR_EXT_REG) = (slave_dev_info.base_address[CSR_BAR] & 0xE0000000) >> 16;
		slave_mailbox0_addr = slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_0_OFF;
		PUT32(slave_mailbox0_addr, 0);

#ifdef __ARMEB__
			PUT32((slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_3_OFF), SWAP32(1));
#else
			PUT32((slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_3_OFF), 1);
#endif

		PUT32((SCRATCHPAD_BASE + SCRATCH_MSG_BASE), DRAM_BASE_SRC);
		// Write packet data to DRAM for microcode to use
		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_0 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_0[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_0 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_0[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_0 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_0[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_1 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_1[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_1 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_1[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_1 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_1[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_2 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_2[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_2 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_2[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_2 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_2[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_96_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_96_3 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data96_3[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_64_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_64_3 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data64_3[(ctr / 4)]);
		}

		for (ctr = 0; ctr < PKT_138_SZ; ctr+=4)
		{
			PUT32((DRAM_BASE_SRC + ((RING_DATA_138_3 >> 8) & (MASK_16BIT << 8)) + ctr), pl_sys_lb_data138_3[(ctr / 4)]);
		}

		PUT32((PCI_LOCAL_CSR_BASE + MAILBOX_0_OFF), 0);

//		pkt_size = PACKET_SIZE;

		// Invoke the slave's PCI doorbell
		Set_Pci_Doorbell(PTLONE_SYS_LPBK, (slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + XSCALE_DOORBELL_OFF));

		ctr = 0;

		// Wait for a signal that slave NPU has completed loading of ucode and init
		do
		{
			if (ctr == 1500)	// After 10 seconds
			{
				eprintf("\nTimed out...Slave NPU was not able to load microcode and init.\n");
				mailbox_value = INIT_ERROR;
				flag = ERROR;
				break;
			}

			temp = GET32(slave_mailbox0_addr);

			hal_delay_us(10000);
			ctr++;
		}
		while (temp == 0);
		
		if (flag == OK)	// If slave completed microcode loading successfully
		{
			// Load Master's NPU with ucode and init
			DownLoadUcode(PL_SYS_LOOPBACK_EG_TX_ME, Sz_pl_sys_loopback_eg_tx, (UINT32 *)pl_sys_loopback_eg_tx);
			DownLoadUcode(PL_SYS_LOOPBACK_EG_RX_ME, Sz_pl_sys_loopback_eg_rx, (UINT32 *)pl_sys_loopback_eg_rx);

			hal_delay_us(1000000);

//			eprintf("DEBUG: (sizeof(tx_data_pl) / sizeof(UINT32)) / 4 = %d\n", ((sizeof(tx_data_pl) / sizeof(UINT32)) / 4));

			do
			{
				//for (combination = 0; combination < ((sizeof(tx_data_pl) / sizeof(UINT32)) / 4); combination++)
				for (combination = 0; combination < pnum; combination++)
				{
					//for (port_num = 0; port_num < 4; port_num++)
					for (port_ctr = 0; port_ctr < iteration; port_ctr++)
					{
						if (ports != 4)
						{
							port_num = ports;
							PUT32((SCR_RING_INSTR_ADDR + (port_num << 2)), pktptr[combination]);
						}
						else
						{
							port_num = port_ctr;
							PUT32((SCR_RING_INSTR_ADDR + (port_num << 2)), tx_data_pl[((combination * 4) + port_num)]);
						}
					}
				}

//					data_to_send = tx_data_pl[internal_loop_count];
//					eprintf("DEBUG: internal_loop_count = %d\n", internal_loop_count);
//					eprintf("DEBUG: data_to_send = 0x%08X\n", data_to_send);
//					PUT32(scratch_ring_tx, data_to_send);

				//for (combination = 0; combination < ((sizeof(tx_data_pl) / sizeof(UINT32)) / 4); combination++)
				for (combination = 0; combination < pnum; combination++)
				{
					flag = OK;
					//for (port_num = 0; port_num < 4; port_num++)
					for (port_ctr = 0; port_ctr < iteration; port_ctr++)
					{
						if (ports != 4)
							port_num = ports;
						else
						{
							port_num = port_ctr;
						}
						//eprintf("iteration = %d, port = %d\n",iteration,port_num);

						ctr = 0;
						//scratch_read_value = 0;

						do			// Do while waiting for all the packets to be transmitted
						{
							if (ctr == 1000)	// After 1 second
							{
								eprintf("\nTimed out...No indication from scratch ring that all packets were transmitted\n");
								mailbox_value = NOT_SENT;
								flag = ERROR;
								break;
							}

							// Poll on scratch ring to check if the packets have been transmitted
							if ((scratch_read_value = GET32(scratch_ring_tx_count)) == 0)
							{
								hal_delay_us(2);
								ctr++;
							}
							else
							{
								switch(ports)
								{
									case 0 : 
									case 1 : 
									case 2 : 
									case 3 : 
											eprintf("Transmitted on port %d: %d\r", ports,(scratch_read_value));
											
											break;
    
									case 4 : // all ports 
											if (!cflag)
											{
												eprintf("Transmitted on ports 0-3 : %d\r", (scratch_read_value)/4);
												iteration = 4;
											}
											else
											{
												eprintf("Transmitted on ports 0 and 2 : %d\r", (scratch_read_value)/2);
												iteration = 2;
											}
											break;
								}
								//eprintf("Transmitted Packets (total): %d\r", scratch_read_value);
								tx_count++;
								  
							}
						}
						while (scratch_read_value == 0);

						PUT32(scratch_ring_tx_count, 0);

						tx_count =  scratch_read_value;
						if (flag == ERROR)
						{
							    //eprintf("Tx break.\n");
								break;
						}
					}

					if (flag == ERROR)
					{
						//eprintf("4. tx break\n");
						break;
					}
				}

				if (flag == ERROR)
				{
					//eprintf("5. tx break\n");
					break;
				}
				
#if 0 // Do not process receive.

				for (combination = 0; combination < pnum; combination++)
				{
					//for (port_num = 0; port_num < 4; port_num++)
					for (port_ctr = 0; port_ctr < iteration; port_ctr++)
					{
						if (!cflag)
						{
							if (ports != 4)
								port_num = ports;
							else
								port_num = port_ctr;
						}
						else
						{
							if (ports != 4)
								port_num = rxport[ports];
							else
								port_num = port_ctr*2 + 1;
						}


						//eprintf("Port = %d\n",port_num);
						ctr = 0;

						do			// Do while waiting for a signal that a packet has been received
						{
							if (ctr == 300)	// After 1 second
							{
								eprintf("\nTimed out...No indication from scratch ring that all packets were received\n");
								mailbox_value = NOT_RECEIVED;
								flag = ERROR;
								//eprintf(" 1. port : %d flag = ERROR\n",port_num);
								break;
							}

							// Poll on scratch ring to check if packets have been received
							if ((scratch_read_value = GET32(scratch_ring_rx)) == 0)
							//if ((scratch_read_value = swap32(GET32(slave_dev_info.base_map[CSR_BAR] + PCI_CSR_BASE_FRM_PCI + MAILBOX_0_OFF))) != 0xF8F8)
							{
								hal_delay_us(100);
								ctr++;
							}
							//eprintf("port %d  scratch_read_value = 0x%x\n",port_num,scratch_read_value);
						}
						while (scratch_read_value == 0);
						//eprintf("a. flag = %d port = %d\n",flag,port_num);

						if (flag == ERROR)
						{
							break;
						}

						//eprintf("DEBUG: scratch_read_value = 0x%08X\n", scratch_read_value);

						rx_count++;
						pkt_size = scratch_read_value & MASK_8BIT;
						rx_port_num = (scratch_read_value >> 8) & MASK_8BIT;
						dram_addr = DRAM_BASE_DEST + ((scratch_read_value >> 16) << 8);
						// set the port on which packet was received.
						pass_port[rx_port_num]++;
						rxflag[rx_port_num] = OK;
						//eprintf("port : %d   pkt size = 0x%x\n",rx_port_num, pkt_size);
						
//						eprintf("DEBUG: pkt_size=0x%08X\tdram_addr=0x%08X\n\n", pkt_size, dram_addr);

						//eprintf("DEBUG: pkt_size=%d\ttx_data_pl=%d\n", pkt_size, (tx_data_pl[((combination * 4) + port_num)] & 0xFFFF));


					/* Vallejo WORKAROUND : Vallejo is not stripping of the CRC 
											for 96 byte packets in gig/half duplex mode */
						if ((pkt_size == 0x60) || (pkt_size == 0x40) || (pkt_size == 0x8A))
						{
							eprintf("\npacket size = 0x%x\n",pkt_size);
							pkt_size = pkt_size - 4;
						}
						/****** end of Workaround *******/

						if (ports == 4)
						{
							exp_pkt_sz = tx_data_pl[((combination * 4) + port_num)] & 0xFFFF;
							//eprintf("pkt size from pktptr: %d\n",exp_pkt_sz);
						}
						else
						{
							exp_pkt_sz = pktptr[combination] & 0xFFFF;

							//eprintf("Expected pkt size: 0x%x\n",exp_pkt_sz);
						}

						
						//if (pkt_size != (tx_data_pl[((combination * 4) + port_num)] & 0xFFFF))
						if (pkt_size != exp_pkt_sz)
						{
							eprintf("\npacket size = 0x%x\n",pkt_size);
							eprintf("pkt size from pktptr: 0x%x\n",exp_pkt_sz);
							//eprintf("combination = %d   port = %d\n",combination,port_num);	 

							mailbox_value = INCORRECT_SIZE;
							flag = ERROR;		// Set flag as error
							rxflag[rx_port_num] = ERROR;
							break;
						}

						if (cflag)
						{
							switch(rx_port_num)
							{
								case 0:  // rx on port 0 , check for pkt transmitted from port 1
									if (pkt_size == (RING_DATA_96_1 & MASK_16BIT) )
									{
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_1;
									}
									else if (pkt_size == (RING_DATA_64_1 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_1;
									}
									else if (pkt_size == (RING_DATA_138_1 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_1;
									}
									else
										bad_pkt_size = 1;
									break;

								case 1:  // rx on port 1 , check for pkt transmitted from port 0
									if (pkt_size == (RING_DATA_96_0 & MASK_16BIT))
									{
										//eprintf("received 96 byte on port 1\n");
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_0;
									}
									else if (pkt_size == (RING_DATA_64_0 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_0;
									}
									else if (pkt_size == (RING_DATA_138_0 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_0;
									}
									else 
										bad_pkt_size = 1;
									break;
								case 2:  // rx on port 2 , check for pkt transmitted from port 3
									if (pkt_size == (RING_DATA_96_3 & MASK_16BIT))
									{
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_3;
									}
									else if (pkt_size == (RING_DATA_64_3 & MASK_16BIT))
									{
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_3;
									}
									else if (pkt_size == (RING_DATA_138_3 & MASK_16BIT))
									{
										orig_data_size = PKT_138_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_3;
									}
									else
										bad_pkt_size = 1;

									break;
								case 3:  // rx on port 2 , check for pkt transmitted from port 2
									if (pkt_size == (RING_DATA_96_2 & MASK_16BIT))
									{
										//eprintf("received 96  bytes on port 3\n");
										orig_data_size = PKT_96_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_2;
									}
									else if (pkt_size == (RING_DATA_64_2 & MASK_16BIT))
									{
										//eprintf("received 64 bytes on port 3\n");
										orig_data_size = PKT_64_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_2;
									}
									else if (pkt_size == (RING_DATA_138_2 & MASK_16BIT))
									{
										//eprintf("received 138 bytes on port 3\n");
										orig_data_size = PKT_138_SZ ;
										pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_2;
									}
									else 
										bad_pkt_size = 1;

									break;
							}
							if (bad_pkt_size ==1)
							{
								eprintf("pkt size mismatch !! port = %d\n",rx_port_num);
								mailbox_value = NOT_COMPLETE;
								flag = ERROR;		// Set flag as error
								rxflag[rx_port_num] = ERROR;
								break;
							}
							//eprintf("orig data size = 0x%08X\n",orig_data_size);
						}
						else  // cflag = 0 -> fiber mode
						{

							if ((pkt_size == (RING_DATA_96_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_0 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_0;
							}
							else if ((pkt_size == (RING_DATA_64_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_0 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_0;
							}
							else if ((pkt_size == (RING_DATA_138_0 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_0 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_0;
							}
							else if ((pkt_size == (RING_DATA_96_1 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_1 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_1;
							}
							else if ((pkt_size == (RING_DATA_64_1 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_1 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_1;
							}
							else if ((pkt_size == (RING_DATA_138_1 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_1 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_1;
							}
							else if ((pkt_size == (RING_DATA_96_2 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_2 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_2;
							}
							else if ((pkt_size == (RING_DATA_64_2 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_2 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_2;
							}
							else if ((pkt_size == (RING_DATA_138_2 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_2 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_2;
							}
							else if ((pkt_size == (RING_DATA_96_3 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_96_3 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_96_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data96_3;
							}
							else if ((pkt_size == (RING_DATA_64_3 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_64_3 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_64_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data64_3;
							}
							else if ((pkt_size == (RING_DATA_138_3 & MASK_16BIT)) && (rx_port_num == ((RING_DATA_138_3 >> 20) & MASK_8BIT)))
							{
								orig_data_size = PKT_138_SZ;
								pl_sys_lb_data = (UINT32 *)pl_sys_lb_data138_3;
							}
							else
							{
								eprintf("pkt size mismatch !! port = %d\n",rx_port_num);
								mailbox_value = NOT_COMPLETE;
								flag = ERROR;		// Set flag as error
								rxflag[rx_port_num] = ERROR;
								break;
							}
						}

						//eprintf("packet ******\n");
						for (ctr = 0; ctr < orig_data_size; ctr+=4)
						{
							// Read the DRAM for the longword that was received
							temp = GET32(dram_addr + ctr);
							//eprintf("dram data = 0x%08X\n",temp);
							//eprintf("pkt data = 0x%08X\n",pl_sys_lb_data[(ctr / 4)]);	
							// Compare with original value
							if (temp != pl_sys_lb_data[(ctr / 4)])
							{
								mailbox_value = ERROR_PATTERN;
								eprintf("Packet:%d Longword:%d Expected:0x%X  Received:0x%X\n", (rx_count + 1), (ctr / 4), pl_sys_lb_data[(ctr / 4)], temp);
								flag = ERROR;		// Set flag as error
								rxflag[rx_port_num] = ERROR;
								break;
							}
						}

						if (flag == ERROR)
						{
							eprintf("1. break. \n");
							break;
						}

						hal_delay_us(800);
					}

					if (flag == ERROR)
					{
						break;
					}
				}
#endif // skip receive process.

				if (flag == ERROR)
				{
					break;
				}

				loop_count++;

				if (forever && KEYPRESS)
				{
					break;
				}
			
			}
			while ((loop_count != loop) || forever);
		}

		eprintf("\n");

		if(dcache_status != 0)	// if dcache was originally ON
		{
			dcache_on();
		}

		if (loop == 0)
			loop = loop_count;


		rmon_flag = ERROR;
		switch(test_param)
		{
		case 'c' :
					if (get_TX_collisions())
					{
						rmon_flag = OK;
						eprintf("\nTx Collisions Test PASSED..\n");
					}
					break;
		case 'd':
					if(get_Rx_DataError())
					{
						rmon_flag = OK;
						eprintf("\nRx DataError Test PASSED..\n");
					}
					break;
		case 'a':
					if(get_Rx_AlignError())
					{
						rmon_flag = OK;
						eprintf("\nRx AlignError Test PASSED..\n");
					}
		case 's':
					if(get_Rx_SeqError())
					{
						rmon_flag = OK;
						eprintf("\nRx Sequence Error Test PASSED..\n");
					}
					break;
		case 'y':
					if(get_Rx_SymError())
					{
						rmon_flag = OK;
						eprintf("\nRx Symbol Error Test PASSED..\n");
					}
					break;
		case 'l':
					if(get_Rx_LongError())
					{
						rmon_flag = OK;
						eprintf("\nRx Long Error Test PASSED..\n");
					}
					break;
		case 'b':
					if(get_Rx_JabberError())
					{
						rmon_flag = OK;
						eprintf("\nRx Jabber Error Test PASSED..\n");
					}
					break;

		}

		if (rmon_flag==OK)
		{
			Set_LED("PASS");
			slowport_code[0] = SP_XSC;
			slowport_code[1] = SP_PASS;
			dump_slowport(slowport_code, 2, SP_NON_FATAL);
		} 
		else
		{
			if (mailbox_value == INIT_ERROR)
			{
				eprintf("The slave NPU did not succeed in loading the microcode to its microengines\n");
			}
			else if (mailbox_value == NOT_RECEIVED)
			{
				eprintf("There was no sign that the expected packet was received\n");
			}
			else if (mailbox_value == ERROR_PATTERN)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("The packet received was not the same as the packet transmitted.\n");
			}
			else if (mailbox_value == INCORRECT_SIZE)
			{
				eprintf("mailbox = 0x%x\n",mailbox_value);
				eprintf("The packet received was not the same size as the packet transmitted.\n");
			}
				
			/* get statistics from Vallejo */
			//get_stats();
			
			// prepare structure for dumping
			syslog.type = TYPE_ERROR;
			syslog.source_comp = MASTER_DIAG;	// Determine master/slave
			switch(test_param)
			{
			case 'c' :
						eprintf("\nTx Collisions Test FAILED..\n");
						strcpy(syslog.desc, "Tx Collisions Test FAILED");
						break;
			case 'd':
						eprintf("\nRx DataError Test FAILED..\n");
						strcpy(syslog.desc, "Rx DataError Test FAILED..");
						break;
			case 'a':
						eprintf("\nRx AlignError Test FAILED..\n");
						strcpy(syslog.desc, "Rx AlignError Test FAILED..");
						break;
			case 's':
						eprintf("\nRx Sequence Error Test FAILED..\n");
						strcpy(syslog.desc, "Rx Sequence Error Test FAILED..");
						break;
			case 'y':
						eprintf("\nRx Symbol Error Test FAILED..\n");
						strcpy(syslog.desc, "Rx Symbol Error Test FAILED..");
						break;
			case 'l':
						eprintf("\nRx Long Error Test FAILED..\n");
						strcpy(syslog.desc, "Rx Long Error Test FAILED..");
						break;
			case 'b':
						eprintf("\nRx Jabber Error Test FAILED..\n");
						strcpy(syslog.desc, "Rx Jabber Error Test FAILED..");
						break;
			}

			// write to syslog
			syslog_dump(&syslog, sizeof(SYSLOG_DATA));

			Set_LED("FAIL");
			slowport_code[0] = SP_XSC;
			slowport_code[1] = SP_FAIL;
			dump_slowport(slowport_code, 2, SP_NON_FATAL);
			acL->Err = ERROR;
		}		
		Clear_All_ME();
	}
	else
	{
		eprintf("\nThis test cannot be run directly on the Slave console\n");
		return DONE;	// To indicate that the slave does not do this.
	}
	return DONE;
}

int get_TX_collisions()
{

	int port=0,res=0;
	UINT32 txSingleCollisions[4];
	UINT32 txMultipleCollisions[4];
	UINT32 txTotalCollisions[4];
	UINT32 txExcvCollisions[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {

		txSingleCollisions[port] = reg_read((port*PORTSZ)+TX_SINGLE_COLLISION);
		txMultipleCollisions[port] = reg_read((port*PORTSZ)+TX_MUL_COLLISION);
		txTotalCollisions[port] = reg_read((port*PORTSZ)+TX_TOTAL_COLLISION);
		txExcvCollisions[port] = reg_read((port*PORTSZ)+TX_EXCV_COLLISION);

		/* Reading the total packets received */
		eprintf("Total UC pkts : %x\n",reg_read((port*PORTSZ+TX_UC_PKTS)));  
		eprintf("Total MC pkts : %x\n",reg_read(((port*PORTSZ)+TX_MC_PKTS)));  
		eprintf("Total BC pkts : %x\n",reg_read(((port*PORTSZ)+TX_BC_PKTS)));  
		eprintf("Port: %d  Total collisions : %x\n",port,txTotalCollisions[port]);  
		eprintf("Tx deferred : %x\n",reg_read(((port*PORTSZ)+TX_DEFERRED_ERR)));  
		eprintf("Port: %d  Tx Single collisions : %x\n",port,txSingleCollisions[port]);  
		eprintf("Port: %d  Tx multiple collisions : %x\n",port,txMultipleCollisions[port]);  
		eprintf("Late collisons : %x\n",reg_read(((port*PORTSZ)+LATE_COLLISION)));  
		eprintf("Excessive collisions : %x\n",reg_read(((port*PORTSZ)+TX_EXCV_COLLISION)));  
		eprintf("Excessive deferred : %x\n",reg_read(((port*PORTSZ)+TX_EXCV_DEFERRED_ERR)));  
	}
	spRestore();

	port = 0;
	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;
		
		if ((txSingleCollisions[port] > 0) || (txMultipleCollisions[port] > 0) || (txTotalCollisions[port] > 0) || (txExcvCollisions[port] > 0))
			res |= 1<< port;
	}
	
	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;
}

int get_Rx_DataError()
{

	int port=0,res=0;
	UINT32 rxdataError[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {
		/* Reading the total packets received */
		rxdataError[port] = reg_read(port*PORTSZ+RX_DATA_ERR);
		eprintf("Port %d: Rx Data Error: %x\n",port, rxdataError[port]);  
	}
	spRestore();
	port = 0;
	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;
		if (rxdataError[port] > 0)
			res|=1<<port;
	}

	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;

}

int get_Rx_AlignError()
{

	int port=0,res=0;
	UINT32 rxAlignError[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {
		/* Reading the total packets received */
		rxAlignError[port] = reg_read(port*PORTSZ+RX_ALIGN_ERR);
		eprintf("Port %d: Rx Data Error: %x\n",port, rxAlignError[port]);  
	}
	spRestore();
	port = 0;

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;

		if (rxAlignError[port] > 0)
			res|=1<<port;
	}
	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;
}

int get_Rx_SeqError()
{

	int port=0,res=0;
	UINT32 rxSeqError[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {
		/* Reading the total packets received */
		rxSeqError[port] = reg_read(port*PORTSZ+RX_ALIGN_ERR);
		eprintf("Port %d: Rx Data Error: %x\n",port, rxSeqError[port]);  
	}
	spRestore();
	port = 0;

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;

		if (rxSeqError[port] > 0)
			res|=1<<port;
	}

	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;
}

int get_Rx_SymError()
{

	int port=0,res=0;
	UINT32 rxSeqError[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {
		/* Reading the total packets received */
		rxSeqError[port] = reg_read(port*PORTSZ+RX_ALIGN_ERR);
		eprintf("Port %d: Rx Data Error: %x\n",port, rxSeqError[port]);  
	}
	spRestore();
	port = 0;

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;
		if (rxSeqError[port] > 0)
			res|=1<<port;
	}

	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;

}

int get_Rx_LongError()
{

	int port=0,res=0;
	UINT32 rxLongError[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {
		/* Reading the total packets received */
		rxLongError[port] = reg_read(port*PORTSZ+RX_LONG_ERR);
		eprintf("Port %d: Rx Data Error: %x\n",port, rxLongError[port]);  
	}
	spRestore();
	port =0;

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;

		if (rxLongError[port] > 0)
			res|=1<<port;
	}

	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;
}

int get_Rx_JabberError()
{

	int port=0,res=0;
	UINT32 rxJabError[4];
	short test_passed = 0,iteration,port_ctr;

	if (ports == 4)
		iteration = 4;
	else
		iteration = 1;

	spConfig();
    for(port=0; port<=3;port++)
    {
		/* Reading the total packets received */
		rxJabError[port] = reg_read(port*PORTSZ+RX_JABBER_ERR);
		eprintf("Port %d: Rx Data Error: %x\n",port, rxJabError[port]);  
	}
	spRestore();
	port = 0;

	for(port_ctr=0; port_ctr<iteration;port_ctr++)
	{  
		if (ports == 4)
			port = port_ctr;
		else
			port = ports;

		if (rxJabError[port] > 0)
			res|=1<<port;
	}
	if ((res == 0xF) || (res & (1<<ports)))
		test_passed = 1;

	return test_passed;

}




