/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * --------------------------------------------------------------------------
 */
 #include "common_uc.h"

#define TX_ENABLE_MASK					0x1
#define TX_MODE							MSF_POS_UTOPIA
#define TX_WIDTH						MSF_WIDTH_1x32
#define TX_SINGLE_PHY					MSF_SINGLE_PHY
#define TX_ELEMENTSIZE					MSF_ELEMENTSIZE_128

#define ME_NUMBER_RX					0
#define RX_THD_NUM						0
#define INTER_ME_SIG_NUM				15

.reg temp
.reg MsfAddress MsfAddress0 MsfAddress1
.reg TxConfigData0
.reg $TxConfigData0
.sig msf_sig

br!=ctx[0, end#]

Init_Tx#:

//****************************************************
// Configure TX Control
//****************************************************
	immed[MsfAddress, MSF_TX_CONTROL]
	immed[TxConfigData0, 0/*(TX_ELEMENTSIZE << 2)*/]
	immed_w1[TxConfigData0, ((TX_ENABLE_MASK << 12)/* | (TX_ENABLE_MASK << 8) | (TX_MODE << 6) | (TX_WIDTH << 4) | (TX_SINGLE_PHY << 3) | (0<<1)|(1<<0)*/)]
	alu[$TxConfigData0, --, B, TxConfigData0]
	msf[write, $TxConfigData0, MsfAddress, 0, 1], ctx_swap[msf_sig]

	immed[temp, ((0 << 7) | (RX_THD_NUM << 4) | (INTER_ME_SIG_NUM << 0))]
	alu[--, --, B, temp]
	cap[fast_wr, ALU, interthread_sig]	// to signal Rx ME that Tx has finished its init

end#:
ctx_arb[kill]
//br[end#]