/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: nmafzal $
 *   DATE:           $Date: 2002/10/31 00:56:05 $
 *   LAST MODIFIED:  $Modtime: 5/16/02 4:01p $
 *   REV#:           $Revision: 1.1.1.1 $
 *   LOGFILE:        $Logfile: /Embedded/source/drivers/ixf/devlib.c $
 *   WORKFILE:       $Workfile: devlib.c $
 *
 * --------------------------------------------------------------------------
 * Project: IXF6192
 *
 * Purpose: Provides the definition of the chip array function pointer table.
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: devlib.c,v $
 *   Revision 1.1.1.1  2002/10/31 00:56:05  nmafzal
 *   putting it in proper place
 *
 *   Revision 1.1  2002/10/30 13:00:01  machambe
 *   Initial CVS checkin
 *
 * 
 * 25    5/16/02 6:08p Machambe
 * Adding SetOpMode to ixf6048
 * 
 * 24    5/03/02 1:39p Srodrig1
 * 
 * 23    5/02/02 4:47p Srodrig1
 * Added Generic Lib.
 * 
 * 22    4/25/02 12:54p Rcordova
 * Changes for Generic Chip
 * 
 * 21    4/24/02 2:18p Srodrig1
 * Adding the new types for the Hailey DVBoard
 * 
 * 20    4/24/02 2:03p Rcordova
 * Code changes for debugging  generic driver code
 * 
 * 19    4/24/02 10:39a Srodrig1
 * 
 * 18    4/17/02 2:07p Srodrig1
 * 
 * 17    4/15/02 4:53p Jaalliso
 * Removing #if 0 code
 * 
 * 16    4/05/02 12:34p Machambe
 * Adding more IXF6048 routines support
 * 
 * 15    3/26/02 6:22p Machambe
 * Added 6048 GetBuildVersion
 * 
 * 14    2/14/02 4:04p Rcordova
 * Added Ixf16121 pointers and adding 2 new functions to Ixf6192.
 * 
 * 13    2/13/02 2:00p Rcordova
 * 
 * 12    2/08/02 3:57p Jaalliso
 * Connecting GetChipInfo, GetBuildVersion, GetOpMode, SetOpMode for
 * ixf18100, removed tab characters & cleaned up file formatting
 * 
 * 11    2/07/02 5:04p Skadrix
 * Added a section (ChipSegment) parameter to the TestCfg API function.
 * Added a new API function  - IxfApiSetBERThreshold
 * 
 * 10    1/24/02 12:34p Rsood
 * Updated ixf18100 initilaization structure
 * 
 * 9     1/18/02 11:29a Jjfreema
 * Added Ixf18100GetStatus
 * 
 * 8     1/02/02 5:44p Machambe
 * Adding comments
 * 
 * 7     12/18/01 3:32p Jjchin
 * Added Calypso Read/Write.
 * 
 * 6     12/12/01 4:04p Machambe
 * Added IxfApiMapframe related functions.
 * 
 * 5     12/01/01 6:34p Machambe
 * Adding Get/Set CFG for ixf6192
 * 
 * 4     11/28/01 12:03p Machambe
 * 
 * 3     11/20/01 4:15p Pkjain2
 * 
 * 2     11/16/01 8:44p Pkjain2
 * moved data structures to devlib.c
 * 
 * 1     11/16/01 10:00a Machambe
 * Initial checkin.  File needed when multiple .c files referenced
 * devlib.h
 * 
 * --------------------------------------------------------------------------
 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "devlib.h"
#include "common_def.h"

/*****************************************************************************
****                             IXF6192                                  ****
*****************************************************************************/
#ifdef INCLUDE_6192_LIB
/* Function Pointers for the Ixf6192 Chip */
CommonFunctionPointers_t ixf6192CommonFuncPtrs = {
  Ixf6192InitChip,              /* InitChip */
  Ixf6192InitAllocMemory,       /* InitAllocMemory */
  Ixf6192DeAllocMemory,         /* DeAllocMemory */
  NULL,                         /* GetStatus */
  NULL,                         /* GetOpMode */
  NULL,                         /* SetOpMode */
  Ixf6192Reset,                 /* Reset */
  Ixf6192InitAlarmCallback,     /* InitAlarmCallback */
  Ixf6192ChipIsr,               /* ChipIsr */
  Ixf6192CfgTest,               /* CfgTest */
  Ixf6192GetCounters,           /* GetCounters */
  Ixf6192GetChipInfo,           /* GetChipInfo */
  Ixf6192SetChipOnline,         /* SetChipOnline */
  Ixf6192SetChipOffline,        /* SetChipOffline */
  Ixf6192SetAlarmCfg,           /* SetAlarmCfg */
  Ixf6192GetBuildVersion,       /* GetBuildVersion */
  Ixf6192Read,                  /* Read */
  Ixf6192Write,                 /* Write */
  Ixf6192GetCfg,                /* GetCfg */
  Ixf6192SetCfg                 /* SetCfg */
};


SonetFunctionPointers_t ixf6192SonetFuncPtrs = {

  Ixf6192GetWindowSize,         /* GetWindow */
  Ixf6192SetWindowSize,         /* SetWindow */
  NULL,                         /* SetBERThreshold */
  Ixf6192GetTrace,              /* GetTrace */
  Ixf6192SetTrace,              /* SetTrace */
  Ixf6192GetOhBytes,            /* GetOhBytes */
  Ixf6192SetOhByte,             /* SetOhBytes */
  Ixf6192SetRmstSourceBytes,    /* SetRmstSourceBytes */
  Ixf6192GetRmstSourceBytes,    /* GetRmstSourceBytes */
  Ixf6192MapFrames,             /* MapFrame */
  Ixf6192GetMappedFrames,       /* GetMappedFrame */
  Ixf6192GetFramesAuPointer     /* GetAuPointer */
};


ChipFunctionPointers_t ixf6192FuncPtrs = {
  &ixf6192CommonFuncPtrs,       /* COMMON routines */
  &ixf6192SonetFuncPtrs,        /* SONET routines */
  NULL                          /* XGMAC routines */
};
#endif /* INCLUDE_6192_LIB */


/*****************************************************************************
****                             IXF6048                                  ****
*****************************************************************************/
#ifdef INCLUDE_6048_LIB
/* Function Pointers for the Ixf6048 Chip */
CommonFunctionPointers_t ixf6048CommonFuncPtrs = {
  Ixf6048InitChip,              /* InitChip */
  Ixf6048InitAllocMemory,       /* InitAllocMemory */
  Ixf6048DeAllocMemory,         /* DeAllocMemory */
  Ixf6048GetStatus,             /* GetStatus */
  Ixf6048GetOpMode,             /* GetOpMode */
  Ixf6048SetOpMode,             /* SetOpMode */
  Ixf6048Reset,                 /* Reset */
  Ixf6048InitAlarmCallback,     /* InitAlarmCallback */
  Ixf6048ChipIsr,               /* ChipIsr */
  Ixf6048CfgTest,               /* CfgTest */
  Ixf6048GetCounters,           /* GetCounters */
  Ixf6048GetChipInfo,           /* GetChipInfo */
  Ixf6048SetChipOnline,         /* SetChipOnline */
  Ixf6048SetChipOffline,        /* SetChipOffline */
  Ixf6048SetAlarmCfg,           /* SetAlarmCfg */
  Ixf6048GetBuildVersion,       /* GetBuildVersion */
  Ixf6048Read,                  /* Read */
  Ixf6048Write,                 /* Write */
  NULL,                         /* GetCfg */
  NULL                          /* SetCfg */
};


SonetFunctionPointers_t ixf6048SonetFuncPtrs = {
  Ixf6048GetWindowSize,         /* GetWindow */
  Ixf6048SetWindowSize,         /* SetWindow */
  NULL,                         /* Set BER Threshold */
  Ixf6048GetTrace,              /* GetTrace */
  Ixf6048SetTrace,              /* SetTrace */
  Ixf6048GetOhBytes,            /* GetOhBytes */
  Ixf6048SetOhByte,             /* SetOhBytes */
  NULL,                         /* SetRmstSourceBytes */
  NULL,                         /* GetRmstSourceBytes */
  NULL,                         /* MapFrame */
  NULL,                         /* GetMappedFrame */
  NULL                          /* GetAuPointer */
};


ChipFunctionPointers_t ixf6048FuncPtrs = {
  &ixf6048CommonFuncPtrs,       /* COMMON routines */
  &ixf6048SonetFuncPtrs,        /* SONET routines */
  NULL
};
#endif /* INCLUDE_6048_LIB */


/*****************************************************************************
****                             IXF18100                                 ****
*****************************************************************************/
#ifdef INCLUDE_18100_LIB
/* Function Pointers for the Ixf18100 Chip */
CommonFunctionPointers_t ixf18100CommonFuncPtrs = {
  Ixf18100InitChip,             /* InitChip */
  Ixf18100InitAllocMemory,      /* InitAllocMemory */
  Ixf18100DeAllocMemory,        /* DeAllocMemory */
  Ixf18100GetStatus,            /* GetStatus */
  Ixf18100GetOpMode,            /* GetOpMode */
  Ixf18100SetOpMode,            /* SetOpMode */
  Ixf18100Reset,                /* Reset */
  Ixf18100InitAlarmCallback,    /* InitAlarmCallback */
  Ixf18100ChipIsr,              /* ChipIsr */
  Ixf18100CfgTest,              /* CfgTest */
  Ixf18100GetCounters,          /* GetCounters */
  Ixf18100GetChipInfo,          /* GetChipInfo */
  NULL,                         /* SetChipOnline */
  NULL,                         /* SetChipOffline */
  Ixf18100SetAlarmCfg,          /* SetAlarmCfg */
  Ixf18100GetBuildVersion,      /* GetBuildVersion */
  Ixf18100Read,                 /* Read */
  Ixf18100Write,                /* Write */
  Ixf18100GetCfg,               /* GetCfg */
  Ixf18100SetCfg                /* SetCfg */
};

SonetFunctionPointers_t ixf18100SonetFuncPtrs = {

  Ixf18100SonetGetWindowSize,   /* GetWindow */
  Ixf18100SonetSetWindowSize,   /* SetWindow */
  NULL,                         /* Set BER Threshold */
  Ixf18100SonetGetTrace,        /* GetTrace */
  Ixf18100SonetSetTrace,        /* SetTrace */
  Ixf18100SonetGetOhBytes,      /* GetOhBytes */
  Ixf18100SonetSetOhBytes,      /* SetOhBytes */
  NULL,                         /* SetRmstSourceBytes */
  NULL,                         /* GetRmstSourceBytes */
  NULL,                         /* MapFrame */
  NULL,                         /* GetMappedFrame */
  NULL                          /* GetAuPointer */
};


XgmacFunctionPointers_t ixf18100XgmacFuncPtrs = {
  Ixf18100XgmacGetAddress,      /* GetMACAddress */
  Ixf18100XgmacSetAddress       /* SetMACAddress */
};


ChipFunctionPointers_t ixf18100FuncPtrs = {
  &ixf18100CommonFuncPtrs,      /* COMMON routines */
  &ixf18100SonetFuncPtrs,       /* SONET routines */
  &ixf18100XgmacFuncPtrs        /* XGMAC routines */
};
#endif /* INCLUDE_18100_LIB */

/*****************************************************************************
****                             IXF16121                                  ****
*****************************************************************************/
#ifdef INCLUDE_16121_LIB
/* Function Pointers for the Ixf16121 Chip */
CommonFunctionPointers_t ixf16121CommonFuncPtrs = {
  Ixf16121InitChip,             /* InitChip */
  Ixf16121InitAllocMemory,      /* InitAllocMemory */
  Ixf16121DeAllocMemory,        /* DeAllocMemory */
  NULL,                         /* GetStatus */
  NULL,                         /* GetOpMode */
  NULL,                         /* SetOpMode */
  Ixf16121Reset,                /* Reset */
  Ixf16121InitAlarmCallback,    /* InitAlarmCallback */
  Ixf16121ChipIsr,              /* ChipIsr */
  Ixf16121CfgTest,              /* CfgTest */
  Ixf16121GetCounters,          /* GetCounters */
  Ixf16121GetChipInfo,          /* GetChipInfo */
  Ixf16121SetChipOnline,        /* SetChipOnline */
  Ixf16121SetChipOffline,       /* SetChipOffline */
  Ixf16121SetAlarmCfg,          /* SetAlarmCfg */
  Ixf16121GetBuildVersion,      /* GetBuildVersion */
  Ixf16121Read,                 /* Read */
  Ixf16121Write,                /* Write */
  Ixf16121GetCfg,               /* GetCfg */
  Ixf16121SetCfg                /* SetCfg */
};


SonetFunctionPointers_t ixf16121SonetFuncPtrs = {

  Ixf16121GetWindowSize,        /* GetWindow */
  Ixf16121SetWindowSize,        /* SetWindow */
  Ixf16121SetBERThreshold,      /* Set BER Threshold */
  Ixf16121GetTrace,             /* GetTrace */
  Ixf16121SetTrace,             /* SetTrace */
  Ixf16121GetOhBytes,           /* GetOhBytes */
  Ixf16121SetOhByte,            /* SetOhBytes */
  Ixf16121SetRmstSourceBytes,   /* SetRmstSourceBytes */
  Ixf16121GetRmstSourceBytes,   /* GetRmstSourceBytes */
  Ixf16121MapFrames,            /* MapFrame */
  Ixf16121GetMappedFrames,      /* GetMappedFrame */
  Ixf16121GetFramesAuPointer    /* GetAuPointer */
};


ChipFunctionPointers_t ixf16121FuncPtrs = {
  &ixf16121CommonFuncPtrs,      /* COMMON routines */
  &ixf16121SonetFuncPtrs,       /* SONET routines */
  NULL                          /* XGMAC routines */
};
#endif /* INCLUDE_16121_LIB */


#ifdef INCLUDE_GENERIC_LIB

/* Function Pointers for the Generic Chip */
CommonFunctionPointers_t genericCommonFuncPtrs = {
  NULL,                         /* InitChip */
  NULL,                         /* InitAllocMemory */
  NULL,                         /* DeAllocMemory */
  NULL,                         /* GetStatus */
  NULL,                         /* GetOpMode */
  NULL,                         /* SetOpMode */
  NULL,                         /* Reset */
  NULL,                         /* InitAlarmCallback */
  NULL,                         /* ChipIsr */
  NULL,                         /* CfgTest */
  NULL,                         /* GetCounters */
  NULL,                         /* GetChipInfo */
  NULL,                         /* SetChipOnline */
  NULL,                         /* SetChipOffline */
  NULL,                         /* SetAlarmCfg */
  GenericDriverGetBuildVersion, /* GetBuildVersion */
  GenericDriverRead,            /* Read */
  GenericDriverWrite,           /* Write */
  NULL,                         /* GetCfg */
  NULL                          /* SetCfg */
};



ChipFunctionPointers_t genericFuncPtrs = {
  &genericCommonFuncPtrs,       /* COMMON routines */
  NULL,                         /* SONET routines */
  NULL                          /* XGMAC routines */
};
#endif /* INCLUDE_GENERIC_LIB */
/*****************************************************************************
***********        CHIP ARRAY FUNCTION POINTER DEFINITION            *********
*****************************************************************************/

typedef struct
{
  bb_ChipType_e chipType;
  ChipFunctionPointers_t *funcPtr;
}
ChipFuncTableItem_t;


static const ChipFuncTableItem_t chipFuncTable[] = {
#ifdef INCLUDE_6048_LIB
  {bb_6048_CHIP, &ixf6048FuncPtrs},
#endif

#ifdef INCLUDE_6192_LIB
  {bb_6192_CHIP, &ixf6192FuncPtrs},
#endif

#ifdef INCLUDE_18100_LIB
  {bb_18100_CHIP, &ixf18100FuncPtrs},
#endif

#ifdef INCLUDE_16121_LIB
  {bb_16121_CHIP, &ixf16121FuncPtrs},
#endif

#ifdef INCLUDE_GENERIC_LIB
  {bb_DVBOARD_16121, &genericFuncPtrs},
  {bb_GENERIC_CHIP, &genericFuncPtrs}   /* THIS MUST BE ALWAYS AT THE END */
#else
  {bb_GENERIC_CHIP, NULL}
#endif
};

ChipFunctionPointers_t *
getChipFuncPtr (bb_ChipType_e chipType)
{
  int i = 0;

  while (chipFuncTable[i].chipType != bb_GENERIC_CHIP)
    {
      if (chipFuncTable[i].chipType == chipType)
        break;
      else
        i++;
    }
  return (chipFuncTable[i].funcPtr);

}

bb_ChipType_e
checkChipType (bb_ChipType_e chipType)
{
  int i = 0;

  while (chipFuncTable[i].chipType != bb_GENERIC_CHIP)
    {
      if (chipFuncTable[i].chipType == chipType)
        break;
      else
        i++;
    }
  return (chipFuncTable[i].chipType);

}

/* Table of all valid chips with API Function Pointers initialized */
ChipFunctionPointers_t *chipArrayFuncPtrs[] = {
  NULL,
  NULL,
  NULL,
#ifdef INCLUDE_6048_LIB
  &ixf6048FuncPtrs,
#else
  NULL,
#endif

  NULL,
#ifdef INCLUDE_6192_LIB
  &ixf6192FuncPtrs,
#else
  NULL,
#endif
  NULL,
  NULL,
#ifdef INCLUDE_18100_LIB
  &ixf18100FuncPtrs,
#else
  NULL,
#endif
  NULL,
  NULL,
  NULL,
  NULL,
#ifdef INCLUDE_16121_LIB
  &ixf16121FuncPtrs,
#else
  NULL,
#endif
  NULL,
  NULL,
  NULL,
  NULL,                         /* OIF/Misc. board control logical FPGA for 1810x */
  NULL,                         /* STB SOH Insertion FPGA for IXF 16121 */
  NULL,                         /* STB SOH Extraction FPGA for IXF 16121 */
  NULL,                         /* STB SAL/PAL Insertion FPGA for IXF 16121 */
  NULL,                         /* STB SAL/PAL Extraction FPGA for IXF 16121 */
  NULL,                         /* DV Board for IXF 16121 */
#ifdef INCLUDE_GENERIC_LIB
  &genericFuncPtrs,
#else
  NULL,
#endif
};
