 /*
    *---------------------------------------------------------------------------
    *                                                                      
    *                  I N T E L   P R O P R I E T A R Y                   
    *                                                                      
    *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
    *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
    *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
    *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
    *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
    *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
    *     THE PRIOR WRITTEN PERMISSION OF :                                
    *                                                                      
    *                        INTEL  CORPORATION                            
    *                                                                     
    *                     2200 MISSION COLLEGE BLVD                        
    *                                                                      
    *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
    *                                                                      
    *---------------------------------------------------------------------------
    *
    *
    *   AUTHOR:         $Author: nmafzal $
    *   DATE:           $Date: 2002/10/31 00:56:05 $
    *   LAST MODIFIED:  $Modtime: 4/18/02 7:43a $
    *   REV#:           $Revision: 1.1.1.1 $
    *   LOGFILE:        $Logfile: /Embedded/source/drivers/ixf/ixf_api_d.h $
    *   WORKFILE:       $Workfile: ixf_api_d.h $
    *
    * --------------------------------------------------------------------------
    * Project: OCD API
    *
    * Purpose: This file defines types that are common to all OCD API modules
    *          
    * Notes:
    *          
    * --------------------------------------------------------------------------
    * CompilerFlags: 
    * --------------------------------------------------------------------------
    * --------------------------------------------------------------------------
    *   $Log: ixf_api_d.h,v $
    *   Revision 1.1.1.1  2002/10/31 00:56:05  nmafzal
    *   putting it in proper place
    *
    *   Revision 1.1  2002/10/30 13:00:01  machambe
    *   Initial CVS checkin
    *
    * 
    * 40    4/18/02 4:47p Machambe
    * Adding Reset type to support ixf6048
    * 
    * 39    4/16/02 2:43p Jaalliso
    * Renaming IXF_API_XGMAC_BASE
    * 
    * 38    4/15/02 4:54p Jaalliso
    * Removing GFP_MODE enum
    * 
    * 37    4/05/02 12:33p Machambe
    * Adding ATM enum counters 
    * 
    * 36    2/12/02 11:11a Jaalliso
    * Renaming SIF loopback enums to be more generic
    * 
    * 35    2/11/02 4:07p Srodrig1
    * 
    * 34    2/08/02 12:45p Jaalliso
    * Adding line loopback modes to bb_TestType_e
    * 
    * 33    2/07/02 4:38p Jaalliso
    * Adding modes to bb_OperMode_e
    * 
    * 32    2/06/02 4:17p Srodrig1
    * 
    * 31    1/30/02 10:38a Machambe
    * 
    * 30    1/29/02 2:41p Skadrix
    * 
    * 29    1/29/02 12:55p Skadrix
    * Added Test Types in bb_TestType_e
    * 
    * 28    1/25/02 11:04a Srodrig1
    * 
    * 27    1/16/02 4:28p Skadrix
    * Added new counter type 
    * bb_ALL_16121_COUNTERS   
    * 
    * 26    1/14/02 10:20a Srodrig1
    * 
    * 25    1/10/02 2:45p Rcordova
    * Added Reset options used in hailey Chip
    * 
    * 24    1/09/02 2:19p Srodrig1
    * 
    * 23    1/02/02 6:25p Rcordova
    * 
    * 22    1/02/02 6:20p Rcordova
    * Added PathOhByteAndSrc Struct and changed union generic for struct
    * generic (added also Source parameter)
    * 
    * 21    12/12/01 3:49p Srodrig1
    * 
    * 20    12/06/01 4:32p Jaalliso
    * Taking out AlarmCallBack type
    * 
    * 19    12/06/01 2:12p Jaalliso
    * Toke out bb_WordSize_t
    * 
    * 18    12/05/01 9:34a Machambe
    * Moving Error Codes over to common_def.h
    * 
    * 17    12/05/01 9:30a Rsood
    * Added APS block
    * 
    * 16    12/04/01 1:38p Jaalliso
    * Split out common_types.h and common_def.h
    * 
    * 15    12/03/01 4:12p Pkjain2
    * 
    * 14    11/19/01 2:11p Srodrig1
    * 
    * 13    11/18/01 10:49p Machambe
    * 
    * 12    11/16/01 8:45p Pkjain2
    * 
    * 11    11/16/01 11:31a Machambe
    * 
    * 10    11/15/01 6:40p Machambe
    * 
    * 9     11/14/01 9:32a Pkjain2
    * 
    * 8     11/10/01 11:26a Pkjain2
    * 
    * 7     11/06/01 2:01p Pkjain2
    * 
    * 6     11/02/01 5:10p Pkjain2
    * 
    * 5     9/12/01 12:01p Srodrig1
    * 
    * 4     8/08/01 3:51p Rfranz
    * Moved more definitions from bb_util and oht_data
    * 
    * 3     7/27/01 4:05p Rfranz
    * Calypso sonet api module compiles without warnings or errors.  (initial
    * test compile)
    * 
    * 2     7/27/01 2:11p Rfranz
    * Check in before first attempt to compile
    * 
    * 1     7/18/01 11:16a Rfranz
    * Intitial checkin
    * 
    * --------------------------------------------------------------------------
  */
#ifndef __IXF_API_D_H__
#define __IXF_API_D_H__

/* Delimiter to mark the end of an InitRegTable_t */
#define IXF_INIT_DATA_DELIMITER 0xA5A5

/* Set and clr bit macros used by amazon and eiffel */
#define SetBit(Reg, Bit) ((Reg) = (Bit | Reg))
#define ClrBit(Reg, Bit) ((Reg) = (~(Bit) & Reg))
#define IXF_BIT(bitShift) (0x1 << bitShift)

#define IXF_API_SONET_BASE 0x0100
#define IXF_API_POS_BASE   0x0200
#define IXF_API_SPI4_BASE  0x0300
#define IXF_API_ETHER_BASE 0x0400
#define IXF_API_PCS_BASE   0x0500
#define IXF_API_GFP_BASE   0x0600
#define IXF_API_ATM_BASE   0x0700

typedef enum                    /* Identifies signal type */
{
  STS_TYPE,
  STM_TYPE
}
bb_SignalType_e;

typedef enum                    /* Identifies the two sides of a chip */
{
  LINE,
  SYSTEM,
  BOTH_SIDES
}
bb_ChipSide_t;

typedef enum                    /* Identifies the different flows of a chip */
{
  RX,
  TX,
  BOTH_FLOWS
}
bb_ChipFlow_t;

typedef enum                    /* Identifies the different paths of a chip */
{
  INGRESS,
  EGRESS,
  BOTH_PATHS
}
bb_ChipPath_t;

typedef enum
{
  ixf_eSONET,
  ixf_eSPI4,
  ixf_ePCS,
  ixf_eETHERNET,
  ixf_ePOS,
  ixf_eGFP,
  ixf_eOIF,
  ixf_eAPS,
  ixf_XGMAC
}
bb_eChipBlock_t;

typedef struct                  /* Used as a generic parameter for many API routines */
{
  struct                        /* Denotes which block of the chip (chipSection_t) */
  {
    ulong block;
    bb_ChipSide_t side;
    bb_ChipFlow_t flow;
    bb_ChipPath_t path;
  }
  block;

  union u_group                 /* Denotes the section within the block */
  {
    unsigned short group;
    unsigned short channel;
    unsigned short tributary;
  }
  group;

  union u_indirect              /* Denotes a location within the group */
  {
    uchar slot;
  }
  indirect;

  struct                        /* Misc. variables used for varies function parameters */
  {
    ushort source;
    uchar autoIncrement;
    uchar bitOrBlock;
    uchar flag;
  }
  generic;

  ulong value;

}
bb_ChipSegment_t;

typedef struct                  /* Complete Data for a Chip */
{
  bb_RegPointer_type BaseAddress;       /* Base Address of chip */
  bb_ChipType_e ChipType;       /* Type of Chip */
  void *pChipCfg;               /* Pointer to Chip Specific Configuration */
  void *pAlarmCfg;              /* Pointer to Chip Specific Alarm Config */
  void *funcPtr;                /* Pointer to the chip's api func's */
}
bb_ChipData_t;


/***********************************************************************
 * Chip Information 
 **********************************************************************/

typedef struct                  /* Information set by the hardware */
{
  uchar ChipVersion;            /* Chip Version */
  ushort ChipId;                /* Chip ID */

}
bb_ChipInfo_t;

typedef enum
{
  TEST_LOOPBACKS,
  TEST_OHT,
  TEST_SDH,
  TEST_PTRS,
  TEST_PRBS,
  bb_SYSTEM_LOCAL_LOOPBACK,
  bb_SYSTEM_REMOTE_LOOPBACK,
  bb_SPI4_TX_LOCK_DIS,
  bb_SPI4_TX_FIFO_STATUS,
  bb_LINE_LOCAL_LOOPBACK,
  bb_LINE_REMOTE_LOOPBACK,
  bb_APS_INTF_LOCAL,
  bb_APS_INTF_REMOTE,

}
bb_TestType_e;


/***********************************************************************
* Data for Functions which get or set the Operation Mode(s)
**********************************************************************/

typedef enum                    /* Operational Modes */
{
  /* Op Modes for Chip: */
  bb_CHIP_OFFLINE,              /* All I/O busses & Interrupts disabled */
  bb_CHIP_ONLINE,               /* Operational: Traffic & Interrupts enabled */

  /* Extra Operational Mode for an OHT Chip: */
  bb_OHT_CHIP_TEST,             /* OHT Chip in test mode */

  /* Operational Modes for an ATM or POS Channel: */
  bb_ATM_POS_CHAN_HALT,         /* Traffic gracefully stopped; I/O enabled */
  bb_ATM_POS_CHAN_ONLINE,       /* Channel Operational: Traffic enabled */
  bb_ATM_POS_CHAN_TEST          /* Channel Operational, in Test Mode */
}
bb_OpMode_e;

/* Identifies the Type of Alarm Condition or Status Change */
typedef enum
{
  bb_6051_OHT_ALARM,
  bb_6048_OHT_ALARM,
  bb_6048_UTOPIA_ALARM,
  bb_6048_ATM_ALARM,
  bb_6048_POS_ALARM,
  bb_6048_MISC_ALARM,
  bb_6192_OHT_ALARM,
  bb_6192_GLOBAL_ALARM,
  bb_6192_RL_LOCK_ALARM,
  bb_6192_TT_LOCK_ALARM,
  bb_6192_LOFP_ALARM,
  bb_6192_LOFP_SYS_ALARM,
  bb_6192_PRBS_ALARM,
  bb_6192_LINE_SAL_ALARM,
  bb_6192_TRIB_SAL_CRC_ALARM,
  bb_6192_TRIB_SAL_BUS_ALARM,
  bb_6192_LINE_RST_ALARM,
  bb_6192_LINE_MST_ALARM,
  bb_6192_LINE_HPM_ALARM,
  bb_6192_LINE_MSA_ALARM,
  bb_6192_TRIB_RST_ALARM,
  bb_6192_TRIB_MST_ALARM,
  bb_6192_TRIB_HPM_ALARM,
  bb_6192_TRIB_MSA_ALARM,
  bb_6192_RX_LINE_RST_ALARM,
  bb_6192_RX_LINE_MST_ALARM,
  bb_6192_RX_LINE_HPM_ALARM,
  bb_6192_RX_LINE_MSA_ALARM,
  bb_6192_TX_TRIB_RST_ALARM,
  bb_6192_TX_TRIB_MST_ALARM,
  bb_6192_TX_TRIB_HPM_ALARM,
  bb_6192_TX_TRIB_MSA_ALARM,

  bb_18100_GLOBAL_CHIP_ALARM,
  bb_18100_GLOBAL_ALARM,
  bb_18100_GLOBAL_CLK_ALARM,
  bb_18100_POS_RCV_ALARM,
  bb_18100_POS_XMT_ALARM,
  bb_18100_SIF_ALARM,
  bb_18100_PCS_ALARM,
  bb_18100_GFP_ALARM,
  bb_18100_XGMAC_ALARM,
  bb_18100_WIS_ALARM,
  bb_18100_APS_WIS_ALARM,
  bb_18100_RL_POH_ALARM,
  bb_18100_RL_J1_ALARM,
  bb_18100_RL_PTR_ALARM,
  bb_18100_RL_LOH_ALARM,
  bb_18100_RL_SOH_ALARM,
  bb_18100_APS_RL_LOH_ALARM,
  bb_18100_APS_RL_SOH_ALARM,
  bb_18100_FRM_AL_ALARM,
  bb_18100_TX_TIM_AL_ALARM,
  bb_18100_SER_AL_ALARM,
  bb_18100_TT_SER_PRTS_ALARM,
  bb_18100_TT_SER_PRT1_ALARM,
  bb_18100_TT_SER_PRT2_ALARM
}
bb_AlarmType_e;

/* Enumeration of counter types */

/***********************************************************************
* Used by Function to Get Counters
**********************************************************************/

typedef enum                    /* To select set of Counters to Get */
{
  /* Individual counters */
  bb_OOF_CNT = IXF_API_SONET_BASE,      /* Out of Frame Event Counter */
  bb_B1_BIP_ERR_CNT,            /* B1 Bip errors */
  bb_B1_BLOCK_ERR_CNT,          /* B1 Block errors */
  bb_B2_BIP_ERR_CNT,            /* B2 Bip errors */
  bb_B2_BLOCK_ERR_CNT,          /* B2 Block errors */
  bb_MST_REI_BIP_ERR_CNT,       /* REI Bit errors */
  bb_MST_REI_BLOCK_ERR_CNT,     /* REI Block errors */
  bb_HPM_REI_BIP_CNT,           /* HPM Bit REI count */
  bb_HPM_REI_BLOCK_CNT,         /* HPM Block REI count */
  bb_B3_BIP_ERR_CNT,            /* B3 Bit Error count */
  bb_B3_BLOCK_ERR_CNT,          /* B3 Block Error count */
  bb_IN_AU_NCNT,                /* Count of Incoming Negative AU Ptr Justifications */
  bb_IN_AU_PCNT,                /* Count of Incoming Positive AU Ptr Justifications */
  bb_OUT_AU_NCNT,               /* Count of Outgoing Negative AU Ptr Justifications */
  bb_OUT_AU_PCNT,               /* Count of Outgoing Positive AU Ptr Justifications */

  /* Group couters */
  bb_RST_COUNTERS,              /* Counters for RST */
  bb_MST_COUNTERS,              /* Counters for MST */
  bb_HPM_COUNTERS,              /* Counters for HPM */
  bb_MSA_COUNTERS,              /* Counters for MSA */
  bb_OHT_COUNTERS,              /* Counters for OHT */
  bb_RX_RST_COUNTERS,           /* Receive RST Counters */
  bb_RX_MST_COUNTERS,           /* Counters for Rx MST */
  bb_RX_HPT_COUNTERS,           /* Counters for Rx HPT */
  bb_RX_MSA_COUNTERS,           /* Counters for Tx MSA */
  bb_TX_MSA_COUNTERS,           /* Counters for Tx MSA */
  bb_SONET_COUNTERS,            /* All SONET counters. */

  bb_ATM_COUNTERS = IXF_API_ATM_BASE,   /* Counters for ATM */
  bb_ATM_RX_CELL_CNT,           /* Receive Cell Count */
  bb_ATM_RX_IDLE_CELL_CNT,      /* Receive Idle Cell Count */
  bb_ATM_RX_COR_HEC_ERR_CNT,    /* Receive Correctable HEC Err Count */
  bb_ATM_RX_UNCOR_HEC_ERR_CNT,  /* Receive UnCorrect. HEC Err Count */
  bb_ATM_RX_OVFL_CELL_CNT,      /* Receive Overflow Cell Count */
  bb_ATM_TX_CELL_CNT,           /* Transmit Cell Count */
  bb_ATM_TX_IDLE_CELL_CNT,      /* Transmit Idle Cell Count */

  bb_ALL_6048_COUNTERS,         /* Catch all counters for 6048 */
  bb_ALL_6192_COUNTERS,         /* Catch all counters for 6192 */
  bb_ALL_16121_COUNTERS,        /* Catch all counters for 16121 */

  bb_POS_RX_GOOD_FRM_CNT = IXF_API_POS_BASE,
  bb_POS_RX_GOOD_BYTE_CNT,
  bb_POS_RX_ABORTED_FRM_CNT,
  bb_POS_RX_ABORTED_BYTE_CNT,
  bb_POS_RX_FCS_ERR_FRM_CNT,
  bb_POS_RX_FCS_ERR_BYTE_CNT,
  bb_POS_RX_FIFO_OVERFLOW_CNT,
  bb_POS_RX_MIN_PLE_CNT,
  bb_POS_RX_MAX_PLE_CNT,
  bb_POS_RX_COUNTERS,
  bb_POS_TX_FRM_CNT,
  bb_POS_TX_BYTE_CNT,
  bb_POS_TX_ABORTED_FRAME_CNT,
  bb_POS_TX_FIFO_UFLOW_CNT,
  bb_POS_TX_COUNTERS,
  bb_POS_COUNTERS,              /* Counters for POS */

  bb_GFP_RX_FRM_SBC_HEC_FAIL_CNT = IXF_API_GFP_BASE,
  bb_GFP_RX_FRM_MBC_HEC_CNT,
  bb_GFP_RX_FRM_SBT_HEC_FAIL_CNT,
  bb_GFP_RX_FRM_MBT_HEC_CNT,
  bb_GFP_RX_FRM_EHEC_CNT,
  bb_GFP_RX_CTRL_FRM_CRC_ERR_CNT,
  bb_GFP_RX_FRM_FCS_ERR_CNT,
  bb_GFP_RX_CTRL_FRM_CNT,
  bb_GFP_RX_LARGE_FRM_CNT,
  bb_GFP_RX_GOOD_FRM_CNT,
  bb_GFP_RX_CTRL_INT_CNT,
  bb_GFP_RX_THEC_ERR_INT_CNT,
  bb_GFP_RX_EHEC_ERR_INT_CNT,
  bb_GFP_RX_FCS_ERR_INT_CNT,
  bb_GFP_RX_COUNTERS,
  bb_GFP_TX_GOOD_FRM_CNT,
  bb_GFP_TX_ERR_FRM_CNT,
  bb_GFP_TX_COUNTERS,
  bb_GFP_COUNTERS,

  bb_SPI4_RX_BUS_ERR_CNT = IXF_API_SPI4_BASE,
  bb_SPI4_RX_FULL_ERR_CNT,
  bb_SPI4_RX_DIP2_ERR_CNT,
  bb_SPI4_RX_NO_EOP_ERR_CNT,
  bb_SPI4_RX_COUNTERS,
  bb_SPI4_TX_BUS_ERR_CNT,
  bb_SPI4_TX_PAR_ERR_CNT,
  bb_SPI4_TX_FULL_ERR_CNT,
  bb_SPI4_TX_NO_EOP_ERR_CNT,
  bb_SPI4_TX_COUNTERS,
  bb_SPI4_COUNTERS,

  bb_PCS_BER_CNT = IXF_API_PCS_BASE,
  bb_PCS_ERR_BLK_CNT,
  bb_PCS_JITTER_ERR_CNT,
  bb_PCS_COUNTERS,

  bb_XGMAC_TX_OK_OCTS_CNT = IXF_API_ETHER_BASE,
  bb_XGMAC_TX_OK_MLTCAST_FRM_CNT,
  bb_XGMAC_TX_OK_BRDCAST_FRM_CNT,
  bb_XGMAC_TX_OK_FRM_CNT,
  bb_XGMAC_TX_64_OCT_FRM_CNT,
  bb_XGMAC_TX_65_TO_127_OCT_FRM_CNT,
  bb_XGMAC_TX_128_TO_255_FRM_CNT,
  bb_XGMAC_TX_256_TO_511_FRM_CNT,
  bb_XGMAC_TX_OK_512_TO_1023_CNT,
  bb_XGMAC_TX_OK_1024_TO_15XX_CNT,
  bb_XGMAC_TX_OK_15XX_TO_MAX_CNT,
  bb_XGMAC_TX_VLAN_FRM_CNT,
  bb_XGMAC_TX_PAUSE_CTRL_FRM_CNT,
  bb_XGMAC_TX_UNICAST_FRM_CNT,
  bb_XGMAC_TX_MAC_CTRL_FRM_CNT,

  bb_XGMAC_RX_OK_OCTS_CNT,
  bb_XGMAC_RX_OK_MLTCAST_FRM_CNT,
  bb_XGMAC_RX_OK_BRDCAST_FRM_CNT,
  bb_XGMAC_RX_OK_FRM_CNT,
  bb_XGMAC_RX_64_OCT_FRM_CNT,
  bb_XGMAC_RX_65_TO_127_OCT_FRM_CNT,
  bb_XGMAC_RX_128_TO_255_FRM_CNT,
  bb_XGMAC_RX_256_TO_511_FRM_CNT,
  bb_XGMAC_RX_OK_512_TO_1023_CNT,
  bb_XGMAC_RX_OK_1024_TO_15XX_CNT,
  bb_XGMAC_RX_OK_15XX_TO_MAX_CNT,
  bb_XGMAC_RX_VLAN_FRM_CNT,
  bb_XGMAC_RX_PAUSE_CTRL_FRM_CNT,
  bb_XGMAC_RX_UNICAST_FRM_CNT,
  bb_XGMAC_RX_MAC_CTRL_FRM_CNT,
  bb_XGMAC_RX_ETHER_STATS_USIZE_PKTS_CNT,
  bb_XGMAC_RX_ETHER_STATS_OSIZE_PKTS_CNT,
  bb_XGMAC_RX_ETHER_STATS_OCTS_CNT,
  bb_XGMAC_RX_ETHER_STATS_PKTS_CNT,
  bb_XGMAC_RX_ETHER_STATS_FRGMNTS_CNT,
  bb_XGMAC_RX_ETHER_STATS_JABBERS_CNT,
  bb_XGMAC_RX_FRM_CHK_SEQ_ERR_CNT,
  bb_XGMAC_TX_COUNTERS,
  bb_XGMAC_RX_COUNTERS,
  bb_XGMAC_COUNTERS,
  bb_MAX_SELCOUNTERS            /* Always make this one last */
}
bb_SelCounters_e;


typedef enum                    /* Identifies which layer of software to retrieve the build
                                   build information */
{
  bb_SW_VERSION_API_TYPE,
  bb_SW_VERSION_CHIP_TYPE,
  bb_MAX_SW_VER                 /* Always make this one last */
}
bb_SoftwareVersion_e;




/* Dummy defines to allow us to not change ixf_api.h for now.... */
typedef enum
{
  CLEARING,
  SETTING,
  CLEARING_DEG_B2 = CLEARING,
  SETTING_DEG_B2 = SETTING,
  CLEARING_EXC_B2,
  SETTING_EXC_B2,
  MAX_WINDOWSIZEMODE            /* Always make this one last */
}
bb_WindowSizeMode_e;

typedef enum
{
  CONFIG_MODE,
  NORMAL_MODE,
  TEST_MODE,
  ETHERNET_MODE,
  WAN_PHY_MODE,
  POS_MODE,
  GFP_SONET_MODE,
  GFP_FIBER_MODE,
  GFP_CLIENT_MODE,
  ATM_MODE,                     /*rammj:Added for compilation. Remove if wrong */
  TRANSPARENT_MODE,
  MAX_OPER_MODE                 /* Always make this one last */
}
bb_OperMode_e;

typedef enum
{
  bb_RX_AIS_STATUS = 5,         /* Starting from 5 so not to overlap legacy code */
  bb_IN_CLK_STATUS,
  bb_FAR_END_GFC_ROLE,
  MAX_SELSTATUS                 /* Always make this one last */
}
bb_SelStatus_e;


/**********************************************************************
 * For Reset Function
 **********************************************************************/

typedef enum                    /* Specifies Chip or Channel Reset */
{
  bb_RESET_CHIP = 10,           /* Reset entire chip; then reconfig chip */
  /* Starting from 10 so not to overlap legacy code */
  bb_RESET_RX_CHAN,             /* Reset Rx side of Channel; then recfg Rx Side */
  bb_RESET_TX_CHAN,             /* Reset Tx side of Channel; then recfg Tx Side */
  bb_RESET_CHAN,                /* Reset Channel */
  bb_RESET_RL_MSA_FIFO,         /* Reset the receive FIFO */
  bb_RESET_TT_MSA_FIFO,         /* Reset the transmit FIFO */
  bb_RESET_HPC,                 /* Reset the HPC */
  bb_RESET_TL_SKEW_FIFO,        /* Reset the Transmit Line Skew Compensation FIFO */
  bb_RESET_RT_SKEW_FIFO,        /* Reset the Receive Tributary Skew Compensation FIFO */
  bb_RESET_RX_CNTR_INT_SRC,     /* Reset all the performance Counters and Interrupt Sources in the Rx Side */
  bb_RESET_TX_CNTR_INT_SRC,     /* Reset all the performance Counters and Interrupt Sources in the Tx Side */
  bb_RESET_LINE_INTF,
  bb_RESET_SPI_INTF,
  bb_RESET_APS_INTF,

  bb_RESET_GFP_TX_INTF = IXF_API_GFP_BASE,
  bb_RESET_GFP_RX_INTF,
  bb_RESET_GFP_CPU_INTF,
  bb_RESET_GFP_TX_FCS,
  bb_RESET_GFP_RX_FCS,
  bb_RESET_GFP_RX_FSM,
  bb_RESET_GFP,
  bb_MAX_SELRESET               /* Always make this one last */
}
bb_SelResetType_e;


/***********************************************************************
 * For SetCfg GetCfg Function
 **********************************************************************/

typedef enum
{
  e_GLOBAL_CONFIG,
  e_RX_CONFIG,
  e_TX_CONFIG,
  e_ALL_CONFIG,
  e_TX_DSK_CONFIG,
  e_OHT_CONFIG,
  e_CLOCK_TIMING_CONFIG,
  e_SERIAL_PORT_CONFIG,
  e_POINTER_CONFIG,
  e_HPT_CONFIG,
  e_MAX_SEL_CONFIG              /* Always make this one last */
}
bb_SelConfig_e;


/***********************************************************************
 * Support data for the DebugCfg routines
 **********************************************************************/
typedef enum                    /* Determine bb_Sysfail action,
                                   after displaying fatal error msg */
{
  bb_DEVELOPMENT_BUILD = 1,     /* Sysfail hangs to preserve debug info */
  bb_PRODUCTION_BUILD,          /* Sysfail exits thru Exit callback, to reset */
  bb_APPL_HANDLES_ERRS          /* Sysfail returns; Appl looks at return code */
}
bb_BuildType_e;


/***********************************************************************
 * Error reporting functions used by the Driver
 **********************************************************************/
void bb_InsertCRC7              /* Calculate & insert CRC7 byte,
                                   at start of work string */
  (uchar * pWorkString);        /* -> Work String, from function above, with
                                   dummy byte at start of string, for CRC7 */


void bb_Sysfail                 /* Fatal Error Handler supplied by driver */
  (char *pFormat,               /* Format string, suitable for printf call */
   ...);                        /* 0-n pieces of specific data, as appropriate
                                   for the specified format */
                           /* Note:
                              This function puts out a Fatal Error Banner,
                              then displays the error message, with formatted
                              data, if present.
                              Whether this function returns or not, is
                              specified by BuildType */

void bb_Warning                 /* Warning Handler supplied by driver */
  (char *pFormat,               /* Format string, suitable for printf call */
   ...);                        /* 0-n pieces of specific data, as appropriate
                                   for the specified format */
                           /* Note:
                              This function puts out an Warning Banner,
                              then displays the error message, with formatted
                              data, if present
                              Returns after printing the msg */

/***********************************************************************
 * Useful common suppport functions provided for Debug Printing
 **********************************************************************/
void bb_HexDump (char *pVar, uint VarLen);      /* Dump VarLen bytes at pVar */

void bb_BinByte (uchar Byte);   /* Dump byte in binary */

void bb_PrintReg                /* Print 1 8-bit reg, with title */
  (char *pTitle,                /* e.g.: "InitOht: OCR1" */
   bb_RegPointer_type pReg);    /* -> Reg */

void bb_Print2RegsBE            /* Print 2 8-bit regs (Big Endian) (MSB in low byte) */
  (char *pTitle,                /* e.g.: "LOF_LMN" */
   bb_RegPointer_type pMsbReg); /* -> MSB Reg */

void bb_Print2RegsLE            /* Print 2 8-bit regs (Little Endian) (MSB in High byte) */
  (char *pTitle,                /* e.g.: "B2_SET_WIN_SIZE" */
   bb_RegPointer_type pMsbReg); /* -> MSB Reg */

#endif /* __IXF_API_D_H__ */
