/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: nmafzal $
 *   DATE:           $Date: 2002/10/31 00:56:05 $
 *   LAST MODIFIED:  $Modtime: 5/14/02 4:02p $
 *   REV#:           $Revision: 1.1.1.1 $
 *   LOGFILE:        $Logfile: /Embedded/source/drivers/ixf/ixf_api_ether.h $
 *   WORKFILE:       $Workfile: ixf_api.h $
 *
 * --------------------------------------------------------------------------
 * Project: ALL
 *
 * Purpose: Provides the API for the Ethernet feature set.
 *         
 * Notes:
 *         
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: ixf_api_ether.h,v $
 *   Revision 1.1.1.1  2002/10/31 00:56:05  nmafzal
 *   putting it in proper place
 *
 *   Revision 1.1  2002/10/30 13:00:01  machambe
 *   Initial CVS checkin
 *
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF_API_ETHER_H__
#define __IXF_API_ETHER_H__

/******************************************************************
* Function : IxfApiGetMacAddress
*-----------------------------------------------------------------
* Description  : 
*-----------------------------------------------------------------
* Inputs  : 
* Outputs : 
*-----------------------------------------------------------------
* Returns : 
*-----------------------------------------------------------------
* Access Globals : 
*-----------------------------------------------------------------
* Comments : 
******************************************************************/

/* The types below define the XGMAC prototypes */
extern bb_Error_e IxfApiGetMacAddress (bb_ChipData_t * pChipData,
                                       bb_ChipSegment_t * section,
                                       IxfApi_MacAddress_t * address);



/******************************************************************
* Function : IxfApiSetMacAddress
*-----------------------------------------------------------------
* Description  : 
*-----------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) to set the
*  						window size.
*           mode      : The clearing/setting mode.
*           
* Outputs : None.
*-----------------------------------------------------------------
* Returns : Status
*-----------------------------------------------------------------
* Access Globals : None.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern bb_Error_e IxfApiSetMacAddress (bb_ChipData_t * pChipData,
                                       bb_ChipSegment_t * section,
                                       IxfApi_MacAddress_t * address);

#endif
