/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: nmafzal $
 *   DATE:           $Date: 2002/10/31 00:56:05 $
 *   LAST MODIFIED:  $Modtime: 5/14/02 4:02p $
 *   REV#:           $Revision: 1.1.1.1 $
 *   LOGFILE:        $Logfile: /Embedded/source/drivers/ixf/ixf_bitfield_macros.h $
 *   WORKFILE:       $Workfile: ixf_api.h $
 *
 * --------------------------------------------------------------------------
 * Project: ALL
 *
 * Purpose: Provides the data definition for bit field macros.
 *         
 * Notes:
 *         
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: ixf_bitfield_macros.h,v $
 *   Revision 1.1.1.1  2002/10/31 00:56:05  nmafzal
 *   putting it in proper place
 *
 *   Revision 1.1  2002/10/30 13:00:01  machambe
 *   Initial CVS checkin
 *
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __BITFIELD_H__
#define __BITFIELD_H__

#define LITTLE_ENDIAN_BITFIELD 1

/*#define BIG_ENDIAN_BITFIELD  1*/

#ifdef LITTLE_ENDIAN_BITFIELD

#define BITFIELD_2(a,b) a; b;

#define BITFIELD_3(a,b,c) a; b; c;

#define BITFIELD_4(a,b,c,d) a; b; c; d;

#define BITFIELD_5(a,b,c,d,e) a; b; c; d; e;

#define BITFIELD_6(a,b,c,d,e,f) a; b; c; d; e; f;

#define BITFIELD_7(a,b,c,d,e,f,g) a; b; c; d; e; f; g;

#define BITFIELD_8(a,b,c,d,e,f,g,h) a; b; c; d; e; f; g; h;

#define BITFIELD_9(a,b,c,d,e,f,g,h,i) a; b; c; d; e; f; g; h; i;

#define BITFIELD_10(a,b,c,d,e,f,g,h,i,j) a; b; c; d; e; f; g; h; i; j;

#define BITFIELD_11(a,b,c,d,e,f,g,h,i,j,k) a; b; c; d; e; f; g; h; i; j; k;

#define BITFIELD_12(a,b,c,d,e,f,g,h,i,j,k,l) a; b; c; d; e; f; g; h; i; j; k; \
                                             l;

#define BITFIELD_13(a,b,c,d,e,f,g,h,i,j,k,l,m) a; b; c; d; e; f; g; h; i; j; \
                                             k; l; m;

#define BITFIELD_14(a,b,c,d,e,f,g,h,i,j,k,l,m,n) a; b; c; d; e; f; g; h; i; \
                                                 j; k; l; m; n;

#define BITFIELD_15(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) a; b; c; d; e; f; g; h; \
                                                   i; j; k; l; m; n; o;

#define BITFIELD_16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) a; b; c; d; e; f; g; h; \
                                                     i; j; k; l; m; n; o; p;

#elif   BIG_ENDIAN_BITFIELD

#define BITFIELD_2(a,b) b; a;

#define BITFIELD_3(a,b,c) c; b; a;

#define BITFIELD_4(a,b,c,d) d; c; b; a;

#define BITFIELD_5(a,b,c,d,e) e; d; c; b; a;

#define BITFIELD_6(a,b,c,d,e,f) f; e; d; c; b; a;

#define BITFIELD_7(a,b,c,d,e,f,g) g; f; e; d; c; b; a;

#define BITFIELD_8(a,b,c,d,e,f,g,h) h; g; f; e; d; c; b; a;

#define BITFIELD_9(a,b,c,d,e,f,g,h,i) i; h; g; f; e; d; c; b; a;

#define BITFIELD_10(a,b,c,d,e,f,g,h,i,j) j; i; h; g; f; e; d; c; b; a;

#define BITFIELD_11(a,b,c,d,e,f,g,h,i,j,k) k; j; i; h; g; f; e; d; c; b; a;

#define BITFIELD_12(a,b,c,d,e,f,g,h,i,j,k,l) l; k; j; i; h; g; f; e; d; c; b; \
                                             a;

#define BITFIELD_13(a,b,c,d,e,f,g,h,i,j,k,l,m) m; l; k; j; i; h; g; f; e; d; \
                                               c; b; a;

#define BITFIELD_14(a,b,c,d,e,f,g,h,i,j,k,l,m,n) n; m; l; k; j; i; h; g; f; \
                                                 e; d; c; b; a;

#define BITFIELD_15(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) o; n; m; l; k; j; i; h; g; \
                                                   f; e; d; c; b; a;

#define BITFIELD_16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) p; o; n; m; l; k; j; i; \
                                                     h; g; f; e; d; c; b; a;
#else
#error PLEASE DEFINE WHETER BIG ENDIAN OR LITTLE ENDIAN BITFIELD.

#endif /* __LITTLE_ENDIAN_BITFIELD__ */

#endif /*__BITFIELD_H__ */
