/*
 * ============================================================================
 *
 * Author:      Mark Chambers <mark.a.chambers@intel.com>
 * Copyright (C) 2002 Intel Corporation. All rights reserved.
 *
 * This software is supplied under the terms of a licence agreement or
 * nondisclosure agreement with Intel Corporation and may not be copied
 * or disclosed except in accordance with the terms in that agreement.
 *
 * Register and other defines for Ixf6048 Interrupt handler
 * ixf6048_irq.h
 *
 * ============================================================================
 */
#ifndef IXF6048_IRQ_H
#define IXF6048_IRQ_H


#define SWAPNTOHS(x)    ((((x) & 0x00ff) << 8) |  (((x) & 0xff00) >> 8))
#define MEDIA_CARD_BASE 0xC6000000
#define MEDIA_CARD_LENGTH 8
#define MASTER_INTERRUPT_ENABLE 0xC6000002
#define MASTER_INTERRUPT_ENABLE_SWAP 0xC6000000

/*---------------------------------------------------
 *IXP2400 Register access Macros
 * --------------------------------------------------*/

#define IXP2400_REG_READ(reg,result) \
                ((result) = *(volatile unsigned int *)(reg))
#define IXP2400_REG_WRITE(reg,data)  \
                (*((volatile unsigned int *)(reg)) = (data))

#define I2S_MAJOR       251 /* for now */
#define I2S_MINOR       35 /* for now */

int ixf6048irq_init (void);
void ixf6048irq_exit (void);
void ixf6048irq_isr (int, void *, struct pt_regs *);

#endif /* IXF6048_IRQ_H */
