/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: nmafzal $
 *   DATE:           $Date: 2002/10/31 00:56:06 $
 *   LAST MODIFIED:  $Modtime: 5/18/01 4:59p $
 *   REV#:           $Revision: 1.1.1.1 $
 *   LOGFILE:        $Logfile: /Eiffel/Embedded Sockets/Source/ixf6048/ixf6048s.h $
 *   WORKFILE:       $Workfile: ixf6048s.h $
 *
 * --------------------------------------------------------------------------
 * Project: IXF6048
 *
 * Purpose: Provides common data structures for the IXF6048 Socket layer code.
 *
 * Notes:
 *			
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log:
 * --------------------------------------------------------------------------
 */


#ifndef __IXF6048S_H_
#define __IXF6048S_H_

/* Type of Interrupt or status Bit to Report -- These are a SuperSet of 
   The Alarm  Types defined in ixf6048d.h */
typedef enum
{                               /* Global Registers */
  e6048_GLOB_ALARM,
  /* Interrupt Registers */
  e6048_UTOPIA_ALARM,
  e6048_MISC_ALARM,
  e6048_OHT_ALARM,
  e6048_ATM_ALARM,
  e6048_POS_ALARM,
  /* Status Bits and Counters */
  e6048_OHT_STATUS,
  e6048_ATM_STATUS,
  e6048_POS_STATUS
}
AlarmCallbackType_e;

/* Type of Counter to Report -- These are a SuperSet of 
   The Counter Types (bb_SelCounters_e) defined in bb_util.h */
typedef enum
{                               /* Global Registers */
  e6048_OHT_COUNTERS,

  e6048_ATM_COUNTERS,
  e6048_POS_COUNTERS,
  e6048_ALL_6048_COUNTERS       /* Unused at this Point */
}
CounterCallbackType_e;


#endif /* __IXF6048S_H_ */
