/*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
* --------------------------------------------------------------------------
*/

#if !defined(__IXF1104CE_IOCTL_H__)
#define __IXF1104CE_IOCTL_H__

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

/**
 * Pre-processor symbol and macro definitions.
 */

#define GET_IOCTL       0xE300  /* GET type IOCTLs starts from 0xE300 */
#define SET_IOCTL       0xE200  /* SET type IOCTLs starts from 0xE200 */

#define TRUE            1
#define FALSE           0 

/**
 * Type definitions.
 */

/**
 * TYPENAME: gbe_mac_error
 *
 * DESCRIPTION: Error code enumerator defines the error string
 *              associated.
 *
 */
typedef enum gbe_mac_e_error {
#if defined(__VXWORKS__)
    SUCCESS = 0x0000,
    ISR_ENABLE_FAILED = 0x0400,
    ERROR_DEVICE_ALREADY_INITIALIZED,
    PLL_NOT_LOCKED,
    ISR_REGISTERTATION_FAILED,
    ISR_DISABLE_FAILED,
    IOCLT_ERROR_INPUT_REG_VALUE_OUT_OF_RANGE,
    IOCLT_ERROR_INPUT_PORT_NUMBER_INVALID,
    IOCTL_ERROR_UNKNOWN_IOCTL_CODE,
    IOCTL_BUFFER_POINTER_NULL,
    IOCTL_BUFFER_POINTER_INVALID,
    IOCTL_PORT_NOT_OPEN,
    MODE_ALREADY_SET_IN_SPECIFIED_DUPLEX_MODE,
    ERROR_INVALID_DUPLEX_MODE,
    FAIL_RX_FIFO_ERRORED_FRAME_DROP_IS_DISABLE,
    ERROR_CONFLICT_WITH_HIGH_WATERMARK,
    ERROR_VALID_ONLY_FOR_COPPER_MODE,
    ERROR_VALID_ONLY_FOR_FIBER_MODE,
    ERROR_MDI_ENABLE_BIT_IS_RESET_IN_MDI_CONTROL_REG,
    ERROR_CONFLICT_WITH_LOW_WATERMARK,
    ERROR_NOT_ALLOWED_IN_LOOPBACK_MODE,
    ERROR_CONFLICT_WITH_JUMBO_FRAME_SIZE,
    PLL_TRANSMIT_LOCK_STATUS_FAILED,
    IOCTL_READ_VALUE_OUT_OF_RANGE,
    ERROR_NPU_IS_INGRESS,
    PCI_ERROR_COULD_NOT_GRAB_SEMAPHORE,
    ERROR_MAC_NOT_INITIALIZED,
    ERROR_GET_RMON_STAT_TASK_COULD_NOT_SPAWNED,
    MEMORY_ALLOCATION_FAILS,
    ERROR_INT_LOCK_FAILED,
    ERROR_TASK_LOCK_FAILED,
    SEMAPHORE_COULD_NOT_CREATED,
    ERROR_PT_LONE_MEDIA_CARD_IS_NOT_PRESENT_ON_MEDIA_INTERFACE,
    ERROR_PT_LONE_MEDIA_CARD_IS_NOT_PRESENT_ON_SWITCH_FABRIC_INTERFACE,
    EEPROM_OF_PT_LONE_MEDIA_CARD_ON_MEDIA_INTERFACE_IS_NOT_PROGRAMMED,
    EEPROM_OF_PT_LONE_MEDIA_CARD_ON_SWITCH_FABRIC_INTERFACE_IS_NOT_PROGRAMMED,
    ERROR_INVALID_HANDLE,
    ERROR_PREVIOUS_MDI_COMMAND_STILL_NOT_COMPLETED,
    ERROR_COULD_NOT_PERFORM_MDIO_READ,
    ERROR_MDI_RD_WR_DISABLE,
    ERROR_COULD_NOT_PERFORM_MDIO_WRITE,
    SPI3_TX_LOCK_FAILED,
    NO_MORE_CALLBACK_FOR_INTERRUPT,
    CALLBACK_OVER_WRITTEN,
    CALLBACK_REGISTERED,
    INTERRUPT_TYPE_COULD_NOT_RECOGNIZED,

    WARNING_ONLY_LOWER_FOUR_BYTES_ARE_WRITABLE = 0x430,
    WARNING_ONLY_LOWER_THREE_BITS_ARE_WRITABLE
#else  /* defined(__LINUX__) */
    SUCCESS = 0x0000,
    REGISTRATION_FAILED = 0x0400,
    ERROR_DEVICE_ALREADY_INITIALIZED,
    PLL_NOT_LOCKED,
    INTERRUPT_INSTALLATION_FAILED,
    INTERRUPT_FREEING_FAILED,
    IOCLT_ERROR_INPUT_REG_VALUE_OUT_OF_RANGE,
    IOCLT_ERROR_INPUT_PORT_NUMBER_INVALID,
    IOCTL_ERROR_UNKNOWN_IOCTL_CODE,
    IOCTL_BUFFER_POINTER_NULL,
    IOCTL_BUFFER_POINTER_INVALID,
    IOCTL_PORT_NOT_OPEN,
    MODE_ALREADY_SET_IN_SPECIFIED_DUPLEX_MODE,
    ERROR_INVALID_DUPLEX_MODE,
    FAIL_RX_FIFO_ERRORED_FRAME_DROP_IS_DISABLE,
    ERROR_CONFLICT_WITH_HIGH_WATERMARK,
    ERROR_VALID_ONLY_FOR_COPPER_MODE,
    ERROR_VALID_ONLY_FOR_FIBER_MODE,
    ERROR_MDI_ENABLE_BIT_IS_RESET_IN_MDI_CONTROL_REG,
    ERROR_CONFLICT_WITH_LOW_WATERMARK,
    ERROR_NOT_ALLOWED_IN_LOOPBACK_MODE,
    ERROR_CONFLICT_WITH_JUMBO_FRAME_SIZE,
    PLL_TRANSMIT_LOCK_STATUS_FAILED,
    IOCTL_READ_VALUE_OUT_OF_RANGE,
    ERROR_NPU_IS_INGRESS,
    PCI_ERROR_COULD_NOT_GRAB_SEMAPHORE,
    ERROR_MAC_NOT_INITIALIZED,
    ERROR_GET_RMON_STAT_TASK_COULD_NOT_SPAWNED,
    MEMORY_ALLOCATION_FAILS,
    ERROR_INT_LOCK_FAILED,
    ERROR_TASK_LOCK_FAILED,
    SEMAPHORE_COULD_NOT_CREATED,
    ERROR_PT_LONE_MEDIA_CARD_IS_NOT_PRESENT_ON_MEDIA_INTERFACE,
    ERROR_PT_LONE_MEDIA_CARD_IS_NOT_PRESENT_ON_SWITCH_FABRIC_INTERFACE,
    EEPROM_OF_PT_LONE_MEDIA_CARD_ON_MEDIA_INTERFACE_IS_NOT_PROGRAMMED,
    EEPROM_OF_PT_LONE_MEDIA_CARD_ON_SWITCH_FABRIC_INTERFACE_IS_NOT_PROGRAMMED,
    ERROR_INVALID_HANDLE,
    ERROR_PREVIOUS_MDI_COMMAND_STILL_NOT_COMPLETED,
    ERROR_COULD_NOT_PERFORM_MDIO_READ,
    ERROR_MDI_RD_WR_DISABLE,
    ERROR_COULD_NOT_PERFORM_MDIO_WRITE,
    SPI3_TX_LOCK_FAILED,

    WARNING_ONLY_LOWER_FOUR_BYTES_ARE_WRITABLE = 0x430,
    WARNING_ONLY_LOWER_THREE_BITS_ARE_WRITABLE
#endif /* end __LINUX__ */
} gbe_mac_error;

/**
 * TYPENAME: gbe_mac_e_IOCTL_CMD
 * 
 * DESCRIPTION: 
 *
 */
typedef enum gbe_mac_e_IOCTL_CMD {
/**
 * MAC Control SET IOCTL Commands
 */
    SET_STN_ADDR = 0xE200,
    SET_DUPLEX_MODE,
    SET_FDFC_TYPE,
    SET_COLLISION_DIST,
    SET_COLLISION_THLD,
    SET_FCTX_TIMER,	/*0xe205 */
    SET_FDFC_ADDR,
    SET_IPG_RECEIVE_TIME1,
    SET_IPG_RECEIVE_TIME2,
    SET_IPG_TRANSMIT_TIME,
    SET_PAUSE_THRESHOLD,	/*0xe20A */
    SET_MAX_FRAME_SIZE,
    SET_MAC_IF_MODE,
    SET_FLUSH_TX,
    SET_FC_MODE,
    SET_FC_BACK_PRESSURE_LEN,
    SET_SHORT_RUNT_TH,		/*0xe210 */
    SET_UNKNOWN_FRAME_STT,
    SET_TX_CONFIG_WORD,
    SET_DIV_CONFIG_WORD,
    SET_PKT_FILTER_CTL,
    SET_MUL_PORT_ADD,		/*0xe215 */

/**
 * SET IOCTL Commands for configuring Global registers
 */
    SET_PORT_STATUS,     /* 0xE216 */ /*-- this is not e219 ...but e216 --remove comment*/
    SET_INTERFACE_MODE,
    SET_MAC_SOFT_RESET,
    SET_MDIO_RESET,
    SET_UI_ENDIAN_MODE,	/* e21a*/
    SET_LED_MODE,
    SET_LED_FLASH_RATE,
    SET_LED_FAULT_ACTION,	/* e21d */

/**
 * SET IOCTLs used to configure the RX FIFO
 */
    SET_RFIFO_HIGH_WATERMARK,   /* e21e*/
    SET_RFIFO_LOW_WATERMARK,
    SET_RX_FIFO_PORT_RESET,	/*e220*/
    SET_RX_FIFO_FRAME_DROP,
    SET_INDIRECT_ADR_CTL,
    SET_CAPTURE_ENABLE_RX_FIFO,	
    SET_PRE_PENDING_CRC_ENABLE,
    SET_MATCHING_PATTERN,
    SET_JUMBO_PKT_SIZE,		/*e226*/

/**
 * SET IOCTL list to configure the TX FIFO
 */
    SET_TX_FIFO_HIGH_WATERMARK,  
    SET_TX_FIFO_LOW_WATERMARK,
    SET_MAC_THRESHOLD,
    SET_LOOP_RX_TX,
    SET_TX_FIFO_PORT_RESET,
    SET_TX_INSERT_DATA,
    SET_TX_FIFO_INFO_ADR,
    SET_TX_FIFO_DROP_INSERT,
    SET_TX_MINI_FRAME_SIZE,

/**
 * SET IOCTLs to configure MDIO interface
 */
    SET_MDIO_CMD_ADDR,
    SET_MDIO_SINGLE_RW_DATA,
    SET_AS_PHY_ADDR,
    SET_MDIO_CTL,

/**
 * SET IOCTLS to configure SPI-3 Interface
 */
    SET_SPI3_TX_CONFIG,
    SET_SPI3_RX_CONFIG,
    SET_CLOCK_IF_MODE,

/**
 * SET IOCTLs used to configure SERDES Interface
 */
    SET_ACDC_COUPLING,
    SET_SERDES_TX_DRV_COEFF,
    SET_TX_DRV_POW_LEVEL,
    SET_TX_LINK_VALIDATION,
    SET_TX_RX_POW_DOWN,
    SET_RX_DATA_SYNC,

/**
 * SET IOCTLs to control GBIC module 
 */
    SET_GBIC_CTL,
    SET_I2C_CTL_DATA,
    SET_PLL_TUNE_1,
    SET_PLL_TUNE_2,
    SET_PLL_TUNE_3,

/**
 * Used in Driver API 
 */
    SET_PORT_INIT_ENABLE,
/**
 * Configuring the Copper PHY register
 */
    SET_PHY_REGISTER,          
/**
 * Change the configuration to different operating scenario 
 */
    SET_CHANGE_CONFIG,

/**
 * MAC Control GET IOCTL Commands
 */
    GET_STN_ADDR = 0xE300,
    GET_DUPLEX_MODE,
    GET_FDFC_TYPE,
    GET_COLLISION_DIST,
    GET_COLLISION_THLD,
    GET_FCTX_TIMER,
    GET_FDFC_ADDR,
    GET_IPG_RECEIVE_TIME_1,
    GET_IPG_RECEIVE_TIME_2,
    GET_IPG_TRANSMIT_TIME,
    GET_PAUSE_THRESHOLD,
    GET_MAX_FRAME_SIZE,
    GET_MAC_IF_MODE,
    GET_FLUSH_TX,
    GET_FC_MODE,
    GET_FC_BACK_PRESSURE_LEN,
    GET_SHORT_RUNT_TH,
    GET_UNKNOWN_FRAME_STT,
    GET_RX_CONFIG_WORD,
    GET_TX_CONFIG_WORD,
    GET_DIV_CONFIG_WORD,
    GET_PKT_FILTER_CTL,
    GET_MUL_PORT_ADD,           /* 0xe316 */

/**
 * GET IOCTLS for MAC Receive Statistics Counters.
 */
    GET_RX_OCTETS_OK,		/* 0xe317 */
    GET_RX_OCTETS_BAD,
    GET_RX_UC_PKTS,
    GET_RX_MC_PKTS,
    GET_RX_BC_PKTS,
    GET_RX_PKTS_64,
    GET_RX_PKTS_65_127,
    GET_RX_PKTS_128_255,
    GET_RX_PKTS_256_511,
    GET_RX_PKTS_512_1023,
    GET_RX_PKTS_1024_1518,
    GET_RX_PKTS_1519_MAX,
    GET_RX_FCS_ERR,
    GET_VLAN_TAG,
    GET_RX_DATA_ERR,
    GET_RX_ALLIGN_ERR,
    GET_RX_LONG_ERR,
    GET_RX_JABBER_ERR,
    GET_RX_PAUSE_MAC_CTL,
    GET_RX_UNKNOWN_CTL_FRAME,
    GET_VLONG_ERR,
    GET_RUNT_ERR,
    GET_SHORT_ERR,
    GET_SEQ_ERR,
    GET_SYMBOL_ERR,    /* e32f */

/**
 * GET IOCTLS for MAC Transmit Statistics Counters.
 */
    GET_TX_OCTETS_OK,   /* e330 */
    GET_TX_OCTETS_BAD,
    GET_TX_UC_PKTS,
    GET_TX_MC_PKTS,
    GET_TX_BC_PKTS,
    GET_TX_PKTS_64,
    GET_TX_PKTS_65_127,
    GET_TX_PKTS_128_255,
    GET_TX_PKTS_256_511,
    GET_TX_PKTS_512_1023,
    GET_TX_PKTS_1024_1518,
    GET_TX_PKTS_1519_MAX,
    GET_TX_DEFERRED_ERR,
    GET_TX_TOTAL_COLLISION,
    GET_TX_SINGLE_COLLISION,
    GET_TX_MUL_COLLISION,
    GET_LATE_COLLISION,
    GET_TX_EXCV_COLLISION,
    GET_TX_EXCV_DEFERRED_ERR,
    GET_TX_EXCV_LEN_DROP,
    GET_TX_UNDERRUN,
    GET_TX_VLAN_TAG,
    GET_TX_CRC_ERR,
    GET_TX_PAUSE_FRAME,
    GET_FC_COLLISION_SEND,    /* e348 */

/**
 * GET IOCTL Commands for accessing Global Status and Configuration registers
 */
    GET_PORT_STATUS,   /* e349 */           /* 0xE34C for the global GET IOCTL COmmands */
    GET_INTERFACE_MODE,
    GET_LINK_UP_STATUS,
    GET_RESET_CORE_CLOCK,
    GET_PAUSE_BEHAVIOR,
    GET_MAC_SOFT_RESET,
    GET_MDIO_RESET,
    GET_UI_ENDIAN_MODE,
    GET_LED_MODE,
    GET_LED_FLASH_RATE,
    GET_LED_FAULT_ACTION,
    GET_JTAG_ID,               /* e354 */

/**
 * GET IOCTLs commands to monitor the configuration of the RX FIFO
 */
    GET_RX_FIFO_HIGH_WATERMARK,    /* e355 */
    GET_RX_FIFO_LOW_WATERMARK,
    GET_RX_FRAME_REMOVED,
    GET_RX_FIFO_PORT_RESET,
    GET_RX_FIFO_FRAME_DROP,
    GET_RX_FIFO_OVERFLOW_STT,
    GET_OUT_SEQUENCE_INFO,
    GET_DROPPED_PKTS,
    GET_RW_PTR_RX_FIFO,
    GET_OCCUPANCY_RX_FIFO,
    GET_CAPTURED_PKT_LEN,
    GET_INDIRECT_ADR_CTL,
    GET_READ_DATA,
    GET_CAPTURE_ENABLE_RX_FIFO,
    GET_PRE_PENDING_CRC_ENABLE,
    GET_MATCHING_PATTERN,
    GET_JUMBO_PKT_SIZE,
    GET_PKT_DROP_CAP_FIFO,        /* e366 */

/**
 * GET IOCTL commands to monitor the TX FIFO
 */
    GET_TX_FIFO_HIGH_WATERMARK,   /* e367 */
    GET_TX_FIFO_LOW_WATERMARK,
    GET_MAC_THRESHOLD,
    GET_TX_FIFO_OVERFLOW_STT,
    GET_LOOP_RX_TX_STT,
    GET_TX_FIFO_PORT_RESET,
    GET_TX_DROP_FRAME,
    GET_TX_DROP_PKTS,
    GET_TX_RW_PTR,
    GET_TX_OCCUPANCY,
    GET_TX_INSERT_DATA,
    GET_TX_FIFO_INFO_ADR,
    GET_TX_FIFO_DROP_INSERT,
    GET_TX_MINI_FRAME_SIZE,       /* e374 */

/**
 * GET IOCTLs to monitor MDIO interface
 */
    GET_MDIO_CMD_ADDR,         /* e375 */
    GET_MDIO_SINGLE_RW_DATA,
    GET_AS_PHY_ADDR,
    GET_MDIO_CTL,		/* e378 */

/**
 * GET IOCTLS to monitor SPI-3 Interface
 */
    GET_SPI3_TX_CONFIG,        /* e379 */
    GET_SPI3_RX_CONFIG,
    GET_SPI3_TX_INT_STATUS,
    GET_SPI3_ADR_PARITY_ERROR,
    GET_SPI3_PKT_DISABLE_PORT,
    GET_SPI3_PKT_SYNC_ERR,
    GET_SPI3_PKT_SHORT_DROP,    /* e37f */

/**
 * GET IOCTLs to monitor SERDES Interface
 */
    GET_ACDC_COUPLING,           /* e380 */
    GET_SERDES_TX_DRV_COEFF,
    GET_TX_DRV_POW_LEVEL,
    GET_TX_LINK_VALIDATION,
    GET_TX_RX_POW_DOWN_STT,
    GET_RX_DATA_SYNC,
    GET_RX_LINK_VALIDATION,
    GET_RX_LINK_STT,
    GET_RX_PHASE_ROT,
    GET_RX_PHASE_ROT_BUS,
    GET_RX_LATCH_OBSRV_01,
    GET_RX_LATCH_OBSRV_23,
    GET_RX_SIGNAL_LEVEL,
    GET_CLOCK_INTERFACE_MODE,
    GET_SERDES_TX_CONFIG,
    GET_SERDES_RX_CONFIG,
    GET_PLL_LOCK,               /* e390 */

/**
 * GET IOCTLs to monitor GBIC module 
 */
    GET_GBIC_STAUS,            /* e391 */
    GET_GBIC_CTL,
    GET_I2C_CTL_DATA,
    GET_PLL_TUNE_1,
    GET_PLL_TUNE_2,
    GET_PLL_TUNE_3,            /* e396 */

/**
 * Get RMON statistics.
 */
    GET_RMON_STAT,             /* e397 */
    GET_PHY_REGISTER           /* e398*/

} gbe_mac_IOCTL_CMD;


#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* #ifndef __IXF1104CE_IOCTL_H__ */
