/*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
* --------------------------------------------------------------------------
*/


/**
 * System defined include files required.
 */

#if defined(__VXWORKS__)
#include <vxworks.h>
#include <logLib.h>
#include <fioLib.h>
#include <stdlib.h>
#include <taskLib.h>
#include <intLib.h>
#include <semLib.h>
#include <objLib.h>
#include <sysLib.h>
#include <memLib.h>
                  
#else /* end __VXWORKS__ and defined(__LINUX__) */
#include <stdio.h>
#include <stdlib.h>
#include <linux/kernel.h>
#endif /* end __LINUX__ */

/**
 * User defined include files required.
 */
#if defined(__VXWORKS__)
#include "../include/ixf1104ce_ioctl.h"
#include "../include/ixf1104ce_internal.h"

#include "ixdp2400.h"        
#include "ixdp2400misc.h"    
#else/* end __VXWORKS__ and defined(__LINUX__) */
#include "../include/ixf1104ce_ioctl.h"
#include "../include/ixf1104ce_internal.h"
#endif/* end __LINUX__ */


/**
 * Types definitions whose scope is limited to this file.
 */
#define PORT_MASK               0xF
#define HIGH_BIT                0x1
#define LOW_BIT                 0x0

#define DEFAULT_SET             0x1
 
#define INT_MASK_SPI3           0x000001FF
#define INT_MASK_GBIC           0x00F03C0F

#define INT_PART_SYNC           0x00000100 
#define INT_FULL_SYNC           0x00000080 
#define INT_DATA_PARITY         0x00000040 
#define INT_ADDR_PARITY         0x00000020 
#define INT_DISABLE_PORT        0x00000010 
#define INT_TX_ERR              0x00000008 
#define INT_SSOP_ERR            0x00000004 
#define INT_SMALL_PKT_0_8       0x00000002 
#define INT_SMALL_PKT_9_14      0x00000001 

#define INT_RX_LOST_3           0x00800000 
#define INT_RX_LOST_2           0x00400000 
#define INT_RX_LOST_1           0x00200000 
#define INT_RX_LOST_0           0x00100000 

#define INT_TX_FAULT_3          0x00002000
#define INT_TX_FAULT_2          0x00001000
#define INT_TX_FAULT_1          0x00000800
#define INT_TX_FAULT_0          0x00000400


#define INT_MOD_DEF_3           0x00000008
#define INT_MOD_DEF_2           0x00000004
#define INT_MOD_DEF_1           0x00000002
#define INT_MOD_DEF_0           0x00000001

#define RXLOS_MASK		0x00F00000
#define TXLOS_MASK		0x00003C00
#define MODDEF_MASK		0x0000000F

#define MAKE_AND                0x7FFFFFFF
#define SHIFT_RIGHT             31


#define MII_MODE_STATUS          0x4
#define MDI_PROGRESS_STATUS      0x8
#define MDI_CONTROL_VAL          0x6
#define MDI_AUTOSCAN_ENABLE      0xF
#define MDI_INT_STATUS_OFFSET    0x1A
#define MDI_LINK_STATUS          0x01

#define MDI_ENABLE               0x04
#define PHY_REG_ADDRESS          0x1F
#define PHY_DEVICE_ADDRESS       0x03
#define PHY_DEVICE_SHIFT         0x08
#define PHY_READ                 0x120000
#define PHY_WRITE                0x110000
#define MDI_STATUS_SHIFT         0x03
#define MDIO_CMD_STATUS          0x14
#define SHIFT_WORD               0x10

#define CARD_ON_MEDIA_IF         0x0
#define CARD_ON_SF_IF            0x1

#define SHIFT_BYTE               0x08
#define SHIFT_NIBBLE             0x04

#define PLL1_AFTER_RESET        0x534
#define PLL2_AFTER_RESET        0x534
#define PLL3_AFTER_RESET        0x5BE

#define SPI3_TX_INT_STATUS	0x702
#define PORTSZ			0x80

#define SPI3_BLOCK_MODE         0x10
#define SPI3_PARITY_MODE        0x08
#define SPI3_4x8_MODE           0x0020AA0F
#define SPI3_MPHY_MODE          0x0000AA0F
#define ODD_PARITY              0x0
#define EVEN_PARITY             0x1
#define SPI3_RX_CORE_ENABLE 		0x00000080
#define SPI3_RX_PORT_ENABLE   		0x00AA0f80
#define SPI3_RX_EVEN_PARITY_MASK 	0x0000f000


#define DEVICE_0                  0x01
#define DEVICE_1                  0x02

#define NUM_PORT_2410             0x4
/**
 * defined while using the taskDelay
 */
#define SLEEP_TIME             2
#define PLL_LOCK_TIMER         20

/** Variable declarations global to this file only.  Externs are followed by
 * static variables.
 */
static uint32 s_RmonStatFlag = TRUE;
extern gbe_mac_global_data gbeMacGlobalData[2];
extern gbe_mac_global_struct gbeMacGlobalStruct[2]; /* Each one structure for each Pt Lone Media Card */
extern gbe_mac_mac_address gbeMacAddress[2];             /* For the two Pt Lone cards */

/**
 * Array of function pointers holding the pointer for the callback functions
 */
extern gbe_mac_callback gbeMacCallback[32];

extern uint32 gbeMacCallbackTaskFiber[2];
extern uint32 gbeMacCallbackTaskCopper[2];

extern SEM_ID g_SemBCreateFiber[2];
extern SEM_ID g_SemBCreateCopper[2];

/**
 * offset per port 
 */
extern uint32 g_PerPortOffset[4];

/**
 * structure corresponds to the slowport registers 
 */
#if defined(__VXWORKS__)
struct SPCfg spCfgOld;
struct SPCfg spCfgPLone = {      
                           0x06,
                           0x62,
                           0x62,
                           0x03,
                           0x33
                          };


#else/* end __VXWORKS__ and defined(__LINUX__) */
/* define for Linux */
#endif/* end __LINUX__ */

unsigned int gbic_status = 0x1234;
unsigned int g_gbic_port_int_status = 0;
static unsigned int phy_int_status[4] = {0,0,0,0};
unsigned int g_CuLinkStatusMI = 0,g_CuLinkStatusSF = 0;

uint32 spi3_status_port[] = {0,0,0,0};

/**
 * Static function prototypes.
 */
/**
 * NAME: gbe_mac_get_rmon_stat
 *
 * DESCRIPTION:
 *      This function is called by the gbe_mac_configure configuration function
 *      after all the initialization has been done properly.  which intern calls
 *      the gbe_mac_evaluate_rmon_stat periodically after the specified time.
 *
 * @Param: -IN    :  arg_DeviceNumber
 * @Param: -INOUT :
 * @Param: -OUT   :
 *
 * @Return: gbe_mac_error token.
 */
static gbe_mac_error gbe_mac_get_rmon_stat(
                                           uint32 arg_DeviceNumber
                                          );

/**
 * NAME: gbe_mac_callback_dispatcher_fiber_0
 *
 * DESCRIPTION:
 *      This function is called by basic configuration through spawning the task.
 *      this function actually waits on a binary semaphore, which is released by
 *      the ISR whenever an interrupt occurs.
 *      for PtLone card on the Media interface for Fiber
 *
 * @Param: -IN    : 
 * @Param: -INOUT :
 * @Param: -OUT   :
 *
 * @Return: NONE.
 */
static void gbe_mac_callback_dispatcher_fiber_0(
                                                 void
                                              );

/**
 * NAME: gbe_mac_callback_dispatcher_fiber_1
 *
 * DESCRIPTION:
 *      This function is called by basic configuration through spawning the task.
 *      this function actually waits on a binary semaphore, which is released by
 *      the ISR whenever an interrupt occurs.
 *      for PtLone card on the Switch Fabric Interface for Fiber
 *
 * @Param: -IN    : 
 * @Param: -INOUT :
 * @Param: -OUT   :
 *
 * @Return: NONE.
 */
static void gbe_mac_callback_dispatcher_fiber_1(
                                                void
                                               );

/**
 * NAME: gbe_mac_callback_dispatcher_copper_0
 *
 * DESCRIPTION:
 *      This function is called by basic configuration through spawning the task.
 *      this function actually waits on a binary semaphore, which is released by
 *      the ISR whenever an interrupt occurs.
 *      for PtLone card on the Media interface for Copper
 *
 * @Param: -IN    :
 * @Param: -INOUT :
 * @Param: -OUT   :
 *
 * @Return: NONE.
 */
static void gbe_mac_callback_dispatcher_copper_0(
                                          void
                                         );

/**
 * NAME: gbe_mac_callback_dispatcher_copper_1
 *
 * DESCRIPTION:
 *      This function is called by basic configuration through spawning the task.
 *      this function actually waits on a binary semaphore, which is released by
 *      the ISR whenever an interrupt occurs.
 *      for PtLone card on the Switch Fabric Interface for Copper
 *
 * @Param: -IN    :
 * @Param: -INOUT :
 * @Param: -OUT   :
 *
 * @Return: NONE.
 */
static void gbe_mac_callback_dispatcher_copper_1(
                                          void
                                         );



/**
 * NAME: gbe_mac_evaluate_rmon_stat
 *
 * DESCRIPTION
 *       This function reads the RMON Statistics register values and accumulates
 *       in a saperate structure, which maintains the 64-bit counter for holding 
 *       the RMON Statistics values.
 *
 * @Param: -IN    :arg_DeviceNumber
 *                :Port Number
 * @Param: -INOUT :
 * @Param: -OUT   :
 *
 * @Return: gbe_mac_error token.
 */
static gbe_mac_error gbe_mac_evaluate_rmon_stat(
                                                uint32 arg_DeviceNumber,
                                                uint32 arg_PortNumber
                                               );


/**
 * NAME: gbe_mac_add_two_lword
 *
 * DESCRIPTION:
 *       This function reads the specified RMON statistics register, and add it to
 *       its corresponding 64-bit counter, and updates the add_structure fields.
 *
 * @Param: -IN    : arg_DeviceNumber
 *                : uint32 arg_Low     Low 32-bit value of the 64-bit counter register
 *                : uint32 arg_High    High 16-bit value of the 64-bit counter register
 *                : uint32 arg_Value   RMON register value
 * @Param: -INOUT
 * @Param: -OUT
 *
 * @Return: gbe_mac_error.
 */
gbe_mac_error gbe_mac_add_two_lword(
                                           uint32 arg_DeviceNumber,
                                           uint32 arg_Low,
                                           uint32 arg_High,
                                           uint32 arg_Value
                                          );
/**
 * NAME: convert_to_BE
 *
 * DESCRIPTION:
 *                 This function converts the read value, which is in the Little Endian,
 *                 to the Big Endian.
 *
 * @Param: -IN    : 
 * @Param: -INOUT :  arg_Value : Value, that needs the endian conversion
 * @Param: -OUT
 *
 * @Return: gbe_mac_error.
 */
void convert_to_BE(
                   uint32 *arg_Value
                  );


/**
 * NAME: set_mode_and_duplex
 *
 * DESCRIPTION:
 *                 This function configures the Vallejo in the specified configuration of 
 *                 the media, duplex mode, speed and SPI3 configuration.
 *
 * @Param: -IN    :  arg_DeviceNumber   Card number
 *                   arg_PortMask       Ports to be activated
 *                   mode               The mode specification.        
 * @Param: -INOUT :  
 * @Param: -OUT
 *
 * @Return: void
 */
void set_mode_and_duplex(
                         uint32 arg_DeviceNumber,
                         uint32 arg_PortMask, 
                         short mode
                        );

void config_phy(
                uint32 arg_DeviceNumber, 
	 	uint32 speed, 
		uint32 duplex , 	
		uint32 arg_PortMask
	   );

void mac_reset(uint32 arg_DeviceNumber);

void mac_disable_reset(uint32 arg_DeviceNumber);

void gbe_mac_basic_configuration(
                                 uint32 arg_DeviceNumber,
                                 uint32 arg_portMask,
                                 uint32 arg_mode
                                  );
void basic_phy_configuration(
			      uint32 arg_DeviceNumber,
                              uint32 arg_PortMask,
                              uint32 arg_Val_19,
                              uint32 arg_Val_17,
                              uint32 arg_Val_4,
                              uint32 arg_Val_9,
                              uint32 arg_Val_0
                             );

void basic_diverse_config(
 		           uint32 arg_DeviceNumber,
                           uint32 arg_PortMask,
                           uint32 s_DiverseConfigValue
                         );

void basic_duplex_configuration(
			         uint32 arg_DeviceNumber,
                                 uint32 arg_portMask,
                                 uint32 s_DuplexModeValue
                               );
void mac_change_reset(
                      uint32 arg_DeviceNumber, 
                      uint32 arg_portMask
                     );

void basic_interface_mode(
                          uint32 arg_DeviceNumber,
                          uint32 arg_PortMask, 
                          uint32 arg_IFMode
                         );

void gbe_mac_change_configuration(
                                 uint32 arg_DeviceNumber,
                                 uint32 arg_PortMask,
                                 uint32 arg_mode
                                  );

void check_autoneg_status(uint32 arg_DeviceNumber, uint32 speed, uint32 arg_PortNumber);

void basic_enable_mode(uint32 arg_DeviceNumber, uint32 arg_PortMask);

/**
 * Function definitions.
 */
/**
 * This function is the patch to the A0 version of the board, in which the 
 * slowport read is in the little endian, and slowport write is in the Big 
 * endian.
 */
void convert_to_BE(
                   uint32 *arg_Value
                  )
{
    uint32 s_Array[4] = {0,0,0,0};
    uint32 s_Count = 0;
    uint32 s_Value = 0;

    s_Value = *arg_Value;

    for(s_Count=0;s_Count<4;s_Count++)
    {
        s_Array[s_Count] = (s_Value & 0xFF);
        s_Value = s_Value >> SHIFT_BYTE;
    }

    s_Value = 0;
    for(s_Count=0;s_Count<3;s_Count++)
    {
        s_Value = s_Value | s_Array[s_Count];
        s_Value = s_Value << SHIFT_BYTE;
    }

    s_Value = s_Value | s_Array[3];
    *arg_Value = s_Value;
    return;
}

/** 
 * This function reads the 64bits value, two 32-bit registers, from the 
 * register map at one shot.
 */
void gbe_mac_read_64_bits(
                          uint32 arg_DeviceNumber,
                          uint32 arg_Offset,
                          uint32 *arg_pValue1,
                          uint32 *arg_pValue2
                         )
{
    uint32 s_RegOffset=0;
#if defined(__VXWORKS__)
    uint32 s_LockKey=0;
#endif

    if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
    {
        s_RegOffset = PT_LONE_REG_BASE_0 + (4*arg_Offset);       
    }
    else
    {
        s_RegOffset = PT_LONE_REG_BASE_1 + (4*arg_Offset);
    }

#if defined(__VXWORKS__)
    if (taskLock() == OK)
    {
#endif
        /**
         * Save the current slow port structure configuration.
         */
        ixdp2400SPCfgSave(&spCfgOld); 
        /**
         * Change the slow port configuration for the Pt Lone regmap access
         */
        ixdp2400SPCfgRestore(&spCfgPLone);

	s_LockKey = intLock();
        REG_READ(s_RegOffset, arg_pValue1);
        REG_READ((s_RegOffset+4), arg_pValue2);
	intUnlock(s_LockKey);

        ixdp2400SPCfgRestore(&spCfgOld);
    
#if defined(__A0__)
        convert_to_BE(arg_pValue1);
        convert_to_BE(arg_pValue2);
#endif
#if defined(__VXWORKS__)
        taskUnlock();
    }
    else
    {
        MESSAGE("ERROR_TASK_LOCK_FAILED\n",0,0,0,0,0,0);
    }   
#endif    
    return;
}

/** 
 * This function reads the 32bits register from the register map at one shot.
 */
void gbe_mac_read_32_bits(
                          uint32 arg_DeviceNumber,
                          uint32 arg_Offset,
                          uint32 *arg_pValue
                         )
{
    uint32 s_RegOffset=0;
#if defined(__VXWORKS__)    
    uint32 s_LockKey=0;
#endif
    
    if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
    {
        s_RegOffset = PT_LONE_REG_BASE_0 + (4*arg_Offset);
    }
    else
    {
        s_RegOffset = PT_LONE_REG_BASE_1 + (4*arg_Offset);
    }

#if defined(__VXWORKS__)
    if (taskLock() == OK)
    {
#endif
        /**
         * Save the current slow port structure configuration.
         */
        ixdp2400SPCfgSave(&spCfgOld);
        /**
         * Change the slow port configuration for the Pt Lone regmap access 
         */
        ixdp2400SPCfgRestore(&spCfgPLone);
	
	s_LockKey = intLock();
        REG_READ(s_RegOffset, arg_pValue);
	intUnlock(s_LockKey);

        ixdp2400SPCfgRestore(&spCfgOld);
        
#if defined(__A0__)
        convert_to_BE(arg_pValue);
#endif
#if defined(__VXWORKS__)
        taskUnlock();

    }
    else
    {
        MESSAGE("ERROR_TASK_LOCK_FAILED\n",0,0,0,0,0,0);
    }
#endif

    return;
}


/** 
 * This function writes the 64bits value, two 32-bit registers, to the 
 * register map at one shot.
 */
void gbe_mac_write_64_bits(
                          uint32 arg_DeviceNumber,
                          uint32 arg_Offset,
                          uint32 arg_pValue1,
                          uint32 arg_pValue2
                         )
{
    uint32 s_RegOffset=0;
#if defined(__VXWORKS__)
    uint32 s_LockKey=0;
#endif
    
    if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
    {
        s_RegOffset = PT_LONE_REG_BASE_0 + (4*arg_Offset);
    }
    else
    {
        s_RegOffset = PT_LONE_REG_BASE_1 + (4*arg_Offset);
    }

#if defined(__VXWORKS__)
    if (taskLock() == OK)
    {
#endif
        /**
         * Save the current slow port structure configuration.
         */
        ixdp2400SPCfgSave(&spCfgOld);
        /**
         * Change the slow port configuration for the Pt Lone regmap access 
         */
        ixdp2400SPCfgRestore(&spCfgPLone);

	s_LockKey = intLock();
        REG_WRITE(s_RegOffset, arg_pValue1);
        REG_WRITE((s_RegOffset+4), arg_pValue2);
	intUnlock(s_LockKey);

        ixdp2400SPCfgRestore(&spCfgOld);
#if defined(__VXWORKS__)
        taskUnlock();
    }
    else
    {
        MESSAGE("ERROR_TASK_LOCK_FAILED\n",0,0,0,0,0,0);
    }
#endif
    return;
}


/** 
 * This function writes the 32bits registers, to the register map at one shot.
 */
void gbe_mac_write_32_bits(
                          uint32 arg_DeviceNumber,
                          uint32 arg_Offset,
                          uint32 arg_pValue
                         )
{
    uint32 s_RegOffset=0;
#if defined(__VXWORKS__)    
    uint32 s_LockKey=0;
#endif

    if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
    {
        s_RegOffset = PT_LONE_REG_BASE_0 + (4*arg_Offset);
    }
    else
    {
        s_RegOffset = PT_LONE_REG_BASE_1 + (4*arg_Offset);
    }

#if defined(__VXWORKS__)
    if (taskLock() == OK)
    {
#endif
        /**
         * Save the current slow port structure configuration.
         */

        ixdp2400SPCfgSave(&spCfgOld);
        /**
         * Change the slow port configuration for the Pt Lone regmap access
         */
        ixdp2400SPCfgRestore(&spCfgPLone);
    
        s_LockKey = intLock();
        REG_WRITE(s_RegOffset, arg_pValue);
	intUnlock(s_LockKey);

        ixdp2400SPCfgRestore(&spCfgOld);
#if defined(__VXWORKS__)        
        taskUnlock();
    }
    else
    {
        MESSAGE("ERROR_TASK_LOCK_FAILED\n",0,0,0,0,0,0);
    }
#endif
    return;
}

/** 
 * This function writes the 32bits register, to the register map at one shot.
 * This function is basically called from the ISR.
 */
void write_32_bits_from_isr(
                          uint32 arg_DeviceNumber,
                          uint32 arg_Offset,
                          uint32 arg_pValue
                         )
{
    uint32 s_RegOffset=0;
#if defined(__VXWORKS__)    
    uint32 s_LockKey=0;
#endif
    


    if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
    {
        s_RegOffset = PT_LONE_REG_BASE_0 + (4*arg_Offset);
    }
    else
    {
        s_RegOffset = PT_LONE_REG_BASE_1 + (4*arg_Offset);
    }

    /**
     * Save the current slow port structure configuration.
     */
    ixdp2400SPCfgSave(&spCfgOld);
    /**
     * Change the slow port configuration for the Pt Lone regmap access
     */
    ixdp2400SPCfgRestore(&spCfgPLone);

    s_LockKey = intLock();
    REG_WRITE(s_RegOffset, arg_pValue);
    intUnlock(s_LockKey);

    ixdp2400SPCfgRestore(&spCfgOld);

    return;
}

/** 
 * This function reads the 32bits register, from the register map at one shot.
 * This function is basically called from the ISR.
 */
void read_32_bits_from_isr(
                          uint32 arg_DeviceNumber,
                          uint32 arg_Offset,
                          uint32 *arg_pValue
                         )
{
    uint32 s_RegOffset=0;
#if defined(__VXWORKS__)    
    uint32 s_LockKey=0;
#endif
    
    if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
    {
        s_RegOffset = PT_LONE_REG_BASE_0 + (4*arg_Offset);
    }
    else
    {
        s_RegOffset = PT_LONE_REG_BASE_1 + (4*arg_Offset);
    }

    /**
     * Save the current slow port structure configuration.
     */
    ixdp2400SPCfgSave(&spCfgOld);
    /**
     * Change the slow port configuration for the Pt Lone regmap access 
     */
    ixdp2400SPCfgRestore(&spCfgPLone);
	
    s_LockKey = intLock();
    REG_READ(s_RegOffset, arg_pValue);
    intUnlock(s_LockKey);

    ixdp2400SPCfgRestore(&spCfgOld);
        
#if defined(__A0__)
        convert_to_BE(arg_pValue);
#endif

    return;
}

/** 
 * This function reads one 16-bit PHY register, through MDIO.
 * This function is basically called from the ISR.
 */
void gbe_mac_phy_read_from_isr(
                               uint32 arg_DeviceNumber,
                               uint32 arg_PhyAddress,
                               uint32 arg_RegAddress,
                               uint32 *arg_ReadValue
                              )
{
    uint32 s_ReadValue=0;
    uint32 s_WriteValue = 0;
    uint32 s_Count = 0;
    uint32 s_RegAddress=0, s_PhyAddress=0, s_Delay=0;

    uint32 s_MdioDone = 1;

    /* Enable autoscan */
    write_32_bits_from_isr(arg_DeviceNumber,\
                         AS_PHY_ADDR, 0xF);

    /* Enable MDI to perform single rd/wr operation */
    read_32_bits_from_isr(arg_DeviceNumber,\
                         MDIO_CTL, &s_ReadValue);
    s_WriteValue = s_ReadValue | MDI_ENABLE;
    write_32_bits_from_isr(arg_DeviceNumber,\
                          MDIO_CTL, s_WriteValue);

    /* Read the MDIO Command and Address register */
    /* Check from the MDIO command register */

    read_32_bits_from_isr(arg_DeviceNumber,\
                         MDIO_SNGL_CMD, &s_ReadValue);
    s_MdioDone = s_ReadValue >> MDIO_CMD_STATUS;

    if(s_MdioDone == LOW_BIT)
    {/* MDI Ready to perform operation */
        s_RegAddress = arg_RegAddress & PHY_REG_ADDRESS;
        s_PhyAddress = arg_PhyAddress & PHY_DEVICE_ADDRESS;
        s_PhyAddress = s_PhyAddress << PHY_DEVICE_SHIFT;

        s_WriteValue = s_PhyAddress | s_RegAddress;
        s_WriteValue = s_WriteValue | PHY_READ;

        /* Write to MDIO Command */
        write_32_bits_from_isr(arg_DeviceNumber,\
                             MDIO_SNGL_CMD, s_WriteValue);

#if defined(__VXWORKS__)
    s_Delay = 0;
    while(s_Delay < 10000)
        s_Delay++;
#else
            /* introduce delay in case of Linux */
#endif

        /* Read the control register to check for the command completion */
        read_32_bits_from_isr(arg_DeviceNumber,\
                             MDIO_SNGL_CMD, &s_ReadValue);
        s_ReadValue = s_ReadValue >> MDIO_CMD_STATUS;
        s_MdioDone = s_ReadValue & DEFAULT_SET;

        while(s_MdioDone == DEFAULT_SET)
        {
            s_Count++;
#if defined(__VXWORKS__)
    s_Delay = 0;
    while(s_Delay < 10000)
        s_Delay++;
#else
            /* introduce delay in case of Linux */
#endif
            if(s_Count > 5)
            {
                MESSAGE("ERROR_COULD_NOT_PERFORM_MDIO_READ\n",0,0,0,0,0,0);
                break;
            }

            read_32_bits_from_isr(arg_DeviceNumber,\
                                 MDIO_SNGL_CMD, &s_ReadValue);
            s_ReadValue = s_ReadValue >> MDIO_CMD_STATUS;
            s_MdioDone = s_ReadValue & DEFAULT_SET;
        }

        if(s_Count < 6)
        {/* MDIO Read operation completes */
            read_32_bits_from_isr(arg_DeviceNumber,\
                                 MDIO_SINGLE_RW_DATA,\
                                 &s_ReadValue);
            s_ReadValue = s_ReadValue >> SHIFT_WORD;
            *arg_ReadValue = s_ReadValue;
        }/* end-if MDIO Completes */

    }/* end-if MDI ready to perform operation */
    else
    {
        MESSAGE("ERROR_PREVIOUS_MDI_COMMAND_STILL_NOT_COMPLETED\n",0,0,0,0,0,0);
    }

    return;
}

/** 
 * This function reads one 16-bit PHY register, through MDIO.
 */
gbe_mac_error gbe_mac_phy_read(
                               uint32 arg_DeviceNumber,
                               uint32 arg_PhyAddress,
                               uint32 arg_RegAddress,
                               uint32 *arg_ReadValue
                              )
{
    uint32 s_ReadValue=0;
    uint32 s_WriteValue = 0;
    uint32 s_Count = 0;
    uint32 s_RegAddress=0, s_PhyAddress=0;
    uint32 s_ReturnValue = SUCCESS;
    uint32 s_MdioDone = 1;

    /* Enable autoscan */
    gbe_mac_write_32_bits(arg_DeviceNumber,\
                         AS_PHY_ADDR, 0xF);

    /* Enable MDI to perform single rd/wr operation */
    gbe_mac_read_32_bits(arg_DeviceNumber,\
                         MDIO_CTL, &s_ReadValue);
    s_WriteValue = s_ReadValue | MDI_ENABLE;
    gbe_mac_write_32_bits(arg_DeviceNumber,\
                          MDIO_CTL, s_WriteValue);

    /* Read the MDIO Command and Address register */
    /* Check from the MDIO command register */

    gbe_mac_read_32_bits(arg_DeviceNumber,\
                         MDIO_CTL, &s_ReadValue);
    s_MdioDone = s_ReadValue >> 3;
	s_MdioDone &= 1;
	while(s_MdioDone != 0)
	{
		s_Count++;
		#if defined(__VXWORKS__)
            taskDelay(MDI_COMMAND_DELAY);                   
#else
            /* introduce delay in case of Linux */
#endif
		if(s_Count>5)
		{
		MESSAGE("ERROR_COULD_NOT_PERFORM_MDIO_READ\n",0,0,0,0,0,0);
			return ERROR_PREVIOUS_MDI_COMMAND_STILL_NOT_COMPLETED;
		}
			gbe_mac_read_32_bits(arg_DeviceNumber,MDIO_CTL, &s_ReadValue);
    		s_MdioDone = s_ReadValue >> 3;
    		s_MdioDone &= 1;
	}
    /* MDI Ready to perform operation */
    s_RegAddress = arg_RegAddress & PHY_REG_ADDRESS;
    s_PhyAddress = arg_PhyAddress & PHY_DEVICE_ADDRESS;
    s_PhyAddress = s_PhyAddress << PHY_DEVICE_SHIFT;

    s_WriteValue = s_PhyAddress | s_RegAddress;
    s_WriteValue = s_WriteValue | PHY_READ;

        /* Write to MDIO Command */
        gbe_mac_write_32_bits(arg_DeviceNumber,\
                             MDIO_SNGL_CMD, s_WriteValue);

#if defined(__VXWORKS__)
            taskDelay(MDI_COMMAND_DELAY);                   
#else
            /* introduce delay in case of Linux */
#endif

        /* Read the control register to check for the command completion */
        gbe_mac_read_32_bits(arg_DeviceNumber,\
                             MDIO_SNGL_CMD, &s_ReadValue);
        s_ReadValue = s_ReadValue >> MDIO_CMD_STATUS;
        s_MdioDone = s_ReadValue & DEFAULT_SET;

		s_Count =0;
        while(s_MdioDone == DEFAULT_SET)
        {
            s_Count++;
#if defined(__VXWORKS__)
            taskDelay(MDI_COMMAND_DELAY);                
#else
            /* introduce delay in case of Linux */
#endif
            if(s_Count > 5)
            {
                MESSAGE("ERROR_COULD_NOT_PERFORM_MDIO_READ\n",0,0,0,0,0,0);
                s_ReturnValue = ERROR_COULD_NOT_PERFORM_MDIO_READ;
                break;
            }

            gbe_mac_read_32_bits(arg_DeviceNumber,\
                                 MDIO_SNGL_CMD, &s_ReadValue);
            s_ReadValue = s_ReadValue >> MDIO_CMD_STATUS;
            s_MdioDone = s_ReadValue & DEFAULT_SET;
        }

        if(s_Count < 6)
        {/* MDIO Read operation completes */
            gbe_mac_read_32_bits(arg_DeviceNumber,\
                                 MDIO_SINGLE_RW_DATA,\
                                 &s_ReadValue);
            s_ReadValue = s_ReadValue >> SHIFT_WORD;
            *arg_ReadValue = s_ReadValue;
        }/* end-if MDIO Completes */

   /* end-if MDI ready to perform operation */
   

    return s_ReturnValue;
}

            
/** 
 * This function writes one 16-bit PHY register, through MDIO.
 */
gbe_mac_error gbe_mac_phy_write(
                               uint32 arg_DeviceNumber,
                               uint32 arg_PhyAddress,
                               uint32 arg_RegAddress,
                               uint32 arg_WriteValue
                              )
{
    uint32 s_ReadValue=0;
    uint32 s_WriteValue = 0;
    uint32 s_Count = 0;
    uint32 s_RegAddress=0, s_PhyAddress=0;
    uint32 s_ReturnValue = SUCCESS;
    uint32 s_MdioDone = 1;


    /* Enable autoscan */
    gbe_mac_write_32_bits(arg_DeviceNumber,\
                         AS_PHY_ADDR, 0xF);
    
    /* Enable MDI to perform single rd/wr operation */
    gbe_mac_read_32_bits(arg_DeviceNumber,\
                         MDIO_CTL, &s_ReadValue);
    s_WriteValue = s_ReadValue | MDI_ENABLE;
    gbe_mac_write_32_bits(arg_DeviceNumber,\
                          MDIO_CTL, s_WriteValue);

    /* Read the MDIO Command and Address register */
    /* Check from the MDIO command register */

    gbe_mac_read_32_bits(arg_DeviceNumber,\
                         MDIO_CTL, &s_ReadValue);
    s_MdioDone = s_ReadValue >> 3;
	s_MdioDone &=1;
	while(s_MdioDone !=0)
	{		s_Count++;
	#if defined(__VXWORKS__)
            taskDelay(MDI_COMMAND_DELAY);                   
#else
            /* introduce delay in case of Linux */
#endif
	if(s_Count >5)
	{
			MESSAGE("ERROR_COULD_NOT_PERFORM_MDIO_READ\n",0,0,0,0,0,0);
			return ERROR_PREVIOUS_MDI_COMMAND_STILL_NOT_COMPLETED;
	}
	gbe_mac_read_32_bits(arg_DeviceNumber,\
                         MDIO_CTL, &s_ReadValue);
    s_MdioDone = s_ReadValue >> 3;
	s_MdioDone &=1;
	}

    /* MDI Ready */
    s_RegAddress = arg_RegAddress & PHY_REG_ADDRESS;
    s_PhyAddress = arg_PhyAddress & PHY_DEVICE_ADDRESS;
    s_PhyAddress = s_PhyAddress << PHY_DEVICE_SHIFT;

    s_WriteValue = s_PhyAddress | s_RegAddress;
    s_WriteValue = s_WriteValue | PHY_WRITE;


    /* write value to be programmed in PHY */
     gbe_mac_write_32_bits(arg_DeviceNumber,\
                              MDIO_SINGLE_RW_DATA,\
                              arg_WriteValue);

     /* write command to MDIO */
     gbe_mac_write_32_bits(arg_DeviceNumber,\
                              MDIO_SNGL_CMD, s_WriteValue);

#if defined(__VXWORKS__)
            taskDelay(MDI_COMMAND_DELAY);              
#else
            /* introduce delay in case of Linux */
#endif

        /* Read the control register to check for the command completion */
        gbe_mac_read_32_bits(arg_DeviceNumber,\
                             MDIO_SNGL_CMD, &s_ReadValue);
        s_ReadValue = s_ReadValue >> MDIO_CMD_STATUS;
        s_MdioDone = s_ReadValue & DEFAULT_SET;

        while(s_MdioDone == DEFAULT_SET)
        {
            s_Count++;
#if defined(__VXWORKS__)
            taskDelay(MDI_COMMAND_DELAY);              
#else
            /* introduce delay in case of Linux */
#endif
            gbe_mac_read_32_bits(arg_DeviceNumber,\
                                 MDIO_SNGL_CMD, &s_ReadValue);
            s_ReadValue = s_ReadValue >> MDIO_CMD_STATUS;
            s_MdioDone = s_ReadValue & DEFAULT_SET;

            if(s_Count > 5)
            {
                MESSAGE("ERROR_COULD_NOT_PERFORM_MDIO_WRITE\n",0,0,0,0,0,0);
                s_ReturnValue = ERROR_COULD_NOT_PERFORM_MDIO_WRITE;
                break;
            }
        } 	
    /*end-if MDI ready to perform operation */
   
    return s_ReturnValue;
}

/**
 * This function is called by the GbEMAC_Ioctl API, to parse the ioctl command,
 * and call the appropriate IOCTL handler.
 */
gbe_mac_error gbe_mac_config_handler(
                                     uint32 arg_DeviceNumber,
                                     gbe_mac_IOCTL_CMD arg_Cmd, 
                                     void *arg_pIoctlStruct
                                    )
{
    uint32 s_IoctlType=0;
    uint32 s_RetValue;

    MESSAGE("Config Handler function gbe_mac_config_handler is invoked\n",0,0,0,0,0,0);
    MESSAGE("Device number is %d\n",arg_DeviceNumber,0,0,0,0,0);

    /**
     * AND the arg_Cmd with the GET_IOCTL, ie 0xE300, which results same in case of GET 
     * type ioctl, ans changes to 0xE200 in case of SET type IOCTLs.
     */
    s_IoctlType = arg_Cmd & GET_IOCTL;
    MESSAGE("IOCTL Command value is %d\n",arg_Cmd,0,0,0,0,0);

    /* Initializes the return value to SUCCESS */
    s_RetValue = SUCCESS;

    switch(s_IoctlType)
    {
        case GET_IOCTL:
            /* ioctl is of GET type */
            MESSAGE("Command is GET ioctl, and GET IOCTL handler function is called\n",0,0,0,0,0,0);
            MESSAGE("called ioctl command value is %x\n",arg_Cmd,0,0,0,0,0);
            s_RetValue = gbe_mac_get_config_handler(arg_DeviceNumber,arg_Cmd,arg_pIoctlStruct);
            break;

        case SET_IOCTL:
            /* ioctl is of SET type */
            MESSAGE("Command is SET ioctl, and SET IOCTL handler function is called\n",0,0,0,0,0,0);
            MESSAGE("called ioctl command value is %x\n",arg_Cmd,0,0,0,0,0);
            s_RetValue = gbe_mac_set_config_handler(arg_DeviceNumber,arg_Cmd,arg_pIoctlStruct);
            break;

        default:
            /* Invalid ioctl command */
            MESSAGE("IOCTL_ERROR_UNKNOWN_IOCTL_CODE\n",0,0,0,0,0,0);
            s_RetValue = IOCTL_ERROR_UNKNOWN_IOCTL_CODE;
            break;
    };/* end-switch(s_IoctlType) */
    MESSAGE("Returning from the Config Handler Function gbe_mac_config_handler.\n",0,0,0,0,0,0);
    return s_RetValue;
}


/**
 * This function is called by the GbEMAC_DeviceStart() to perform the basic 
 * Vallejo configurstion, while opening the device.
 */
gbe_mac_error gbe_mac_config(
                             uint32 arg_DeviceNumber,
                             uint32 arg_PortMask,
			     short arg_mode	
                           )
{

   uint32 s_Count=0;
   uint32 s_ConfigFlag = TRUE,s_ReturnValue=0;
   uint32 s_ResourceCount = 0;
   uint32 s_PllTune1=0,s_PllTune2=0,s_PllTune3=0,s_PllLock=0;
   uint32 s_ReadValue=0, s_PortCount=0;


   MESSAGE("CONFIGURING ->gbe_mac_config... ",0,0,0,0,0,0);
   MESSAGE(" -Device[0x%x] ",arg_DeviceNumber,0,0,0,0,0);
 
   /* Initialize the return value to SUCCESS */
   s_ReturnValue = SUCCESS; 

   g_PerPortOffset[0] = MAC_CTL_REG_PORT0;
   g_PerPortOffset[1] = MAC_CTL_REG_PORT1;
   g_PerPortOffset[2] = MAC_CTL_REG_PORT2;
   g_PerPortOffset[3] = MAC_CTL_REG_PORT3;



   /**
    * Take the Mutex Semaphore for doing Inititial Configuration.
    */
#if defined(__VXWORKS__)

    MESSAGE("\nTrying to grab the Mutex Semaphore g_MutexSemaphore... ",0,0,0,0,0,0);

    if(semTake(gbeMacGlobalData[arg_DeviceNumber].g_MutexSemaphore,WAIT_FOR_SEMAPHORE) == OK)
    { /* Grab the Mutex Semaphore */

        s_ResourceCount++;
        MESSAGE("-Taken",0,0,0,0,0,0);     
 
        MESSAGE("\n Initializing ...",0,0,0,0,0,0);
        if(gbeMacGlobalData[arg_DeviceNumber].g_MacStatus != INITIALIZED)
        /* Device is not initialized earlier, so initialization starts */
#else
        if(s_ReturnValue == SUCCESS)                   /* For Linux Environment.consider succes here */
        MESSAGE("NO need of semaphore in Kernel Mode driver\n",0,0,0,0,0,0);
#endif
        {
            /**
             * Check for the SPI-3 Transmit PLL Lock Status registers. 
             */
            MESSAGE("\nSPI-3 Transmit PLL Lock Status registers ...",0,0,0,0,0,0);
            gbe_mac_read_32_bits(arg_DeviceNumber,PLL1_TUNE_REG,&s_PllTune1);
            gbe_mac_read_32_bits(arg_DeviceNumber,PLL2_TUNE_REG,&s_PllTune2);
            gbe_mac_read_32_bits(arg_DeviceNumber,PLL3_TUNE_REG,&s_PllTune3);

            if((s_PllTune1 == PLL1_AFTER_RESET) &&
               (s_PllTune2 == PLL2_AFTER_RESET) &&
               (s_PllTune3 == PLL3_AFTER_RESET))
            { /* SPI-3 Transmit lock has been achieved. */
                /**
                 * Check whether PLL lock has been achieved?
                 */
                MESSAGE(" -LOCKED",0,0,0,0,0,0);
                MESSAGE("\nPLL lock ...",0,0,0,0,0,0);
                gbe_mac_read_32_bits(arg_DeviceNumber,SERDES_PLL_LOCK_STATUS,&s_PllLock);
                if(s_PllLock == 0x3)
                { /* PLL Lock has been achieved. */
                    /** 
                     * Perform Configuration sequence, if no error occurs earlier.
                     */
                    MESSAGE(" -Achieved",0,0,0,0,0,0);
                    MESSAGE("\n Configuring the MAC Registers ... ",0,0,0,0,0,0);
                 
                    gbe_mac_write_32_bits(arg_DeviceNumber,0x500,0x0);

	  	    /* Disable all interrupts */
                    gbe_mac_phy_write(arg_DeviceNumber,0x0, 0x19, 0x0);
                    gbe_mac_phy_write(arg_DeviceNumber,0x1, 0x19, 0x0);
                    gbe_mac_phy_write(arg_DeviceNumber,0x2, 0x19, 0x0);
                    gbe_mac_phy_write(arg_DeviceNumber,0x3, 0x19, 0x0);

                    gbe_mac_basic_configuration(arg_DeviceNumber,arg_PortMask,arg_mode);

                    /* Enable autoscan */
                    gbe_mac_write_32_bits(arg_DeviceNumber,\
                                          AS_PHY_ADDR, 0xF); 

                    MESSAGE(" -Configured",0,0,0,0,0,0);
                }
                else
                { /* PLL lock has failed */
                    s_ConfigFlag = FALSE;
                    MESSAGE(" -PLL_TRANSMIT_LOCK_STATUS_FAILED",0,0,0,0,0,0);
                    s_ReturnValue = PLL_TRANSMIT_LOCK_STATUS_FAILED;
                } /* end-if PLL lock */
            }
            else
            { /* SPI-3 Transmit Lock failed */
                s_ConfigFlag = FALSE;
                MESSAGE(" -SPI3_TX_LOCK_FAILED",0,0,0,0,0,0);
                s_ReturnValue = SPI3_TX_LOCK_FAILED;
            } /* end-if SPI-3 Transmit lock */ 
       }/* end-if device is not initialized earlier */
#if defined(__VXWORKS__)
       else
       { /* Device is already initialized */
           s_ConfigFlag = FALSE;
           MESSAGE(" -ERROR_DEVICE_ALREADY_INITIALIZED",0,0,0,0,0,0);
           s_ReturnValue = ERROR_DEVICE_ALREADY_INITIALIZED;
       } /* end-if gbeMacGlobalData[arg_DeviceNumber].g_MacStatus */
#endif

#if defined(__VXWORKS__)
       if(s_ConfigFlag)
       { /* if Configuration has been completed successfully */
           MESSAGE("\nSpawning TASK ...",0,0,0,0,0,0);
           if(arg_DeviceNumber == 0)
           { /* PtLone Card is on  the Media Interface */
               MESSAGE(" -MI.. -RMON_STAT_TASK.. ",0,0,0,0,0,0);
               gbeMacGlobalData[0].g_TaskID = taskSpawn("s_Task1",90,0x100,2000,\
                                                         (FUNCPTR)gbe_mac_get_rmon_stat,\
                                                         arg_DeviceNumber,0,0,0,0,0,0,0,0,0);
               if(gbeMacGlobalData[arg_DeviceNumber].g_TaskID == ERROR)
               { /* Task could not spawned */
                   MESSAGE(" -ERROR_GET_RMON_STAT_TASK_COULD_NOT_SPAWNED",0,0,0,0,0,0);
                   s_ConfigFlag = FALSE;
                   s_ReturnValue = ERROR_GET_RMON_STAT_TASK_COULD_NOT_SPAWNED;
               } /* end-if taskSpawn() */
               else
               { /* RMON Task spawned successfully */
                   /**
                    * Spawinig a task, gbe_mac_callback_dispatcher_fiber_0.  This task actually wait
                    * onto a semaphore which is actually
                    * released by the ISR.  this intern call the callback functions.
                    */
                   MESSAGE(" -Spawned",0,0,0,0,0,0);
                   MESSAGE("\n   -CallbackDispatcher_FIBER_0...",0,0,0,0,0,0);

                   gbeMacCallbackTaskFiber[0] = taskSpawn("s_TaskCallbackFiber_0",150,0x100,2000,\
                                                           (FUNCPTR)gbe_mac_callback_dispatcher_fiber_0,\
                                                           0,0,0,0,0,0,0,0,0,0);

                   if(gbeMacCallbackTaskFiber[0] == ERROR)
                   { /* Error in Spawning the Task */
                       MESSAGE(" -ERROR",0,0,0,0,0,0);
                       s_ConfigFlag = FALSE;
                   }
                   else
                   { /* Earlier Task Spawned successfully */
                     /**
                      * Spawn a task gbe_mac_callback_dispatcher_copper_0, that continuousouly pools the PHY 
                      * iterrupt register, to check the occurrance of the interrupt.
                      */
                       MESSAGE(" -Spawned",0,0,0,0,0,0);
                       MESSAGE("\n   -CallbackDispatcher_COPPER_0...",0,0,0,0,0,0);
                       gbeMacCallbackTaskCopper[0] = taskSpawn("s_TaskCallbackCopper_0",150,0x100,2000,\
                                                                (FUNCPTR)gbe_mac_callback_dispatcher_copper_0,\
                                                                0,0,0,0,0,0,0,0,0,0);
                       if(gbeMacCallbackTaskCopper[0] == ERROR)
                       { /* Error in Spawning the Task */
                           MESSAGE(" -ERROR..Deleting CallbackDispatcher_FIBER_0",0,0,0,0,0,0);
                           s_ConfigFlag = FALSE;
                           /* Delete the earlier spawned task */
                           taskDelete(gbeMacCallbackTaskFiber[0]);
                       }
                       else
                       {
                           /**
                            * Create binary semaphore for card 0
                            */
                           MESSAGE(" -Spawned",0,0,0,0,0,0);
                           g_SemBCreateFiber[0] = semBCreate(SEM_FULL,SEM_Q_FIFO);
                           if(g_SemBCreateFiber[0] == NULL)
                           {
                               MESSAGE("SEMAPHORE_COULD_NOT_CREATED\n",0,0,0,0,0,0);
                               s_ConfigFlag = FALSE;
                               taskDelete(gbeMacCallbackTaskFiber[arg_DeviceNumber]);
                               taskDelete(gbeMacCallbackTaskCopper[arg_DeviceNumber]);
                               s_ReturnValue = SEMAPHORE_COULD_NOT_CREATED;
                           }
                           else
                           {
                               g_SemBCreateCopper[0] = semBCreate(SEM_FULL,SEM_Q_FIFO);
                               if(g_SemBCreateCopper[0] == NULL)
                               {
                                   MESSAGE("SEMAPHORE_COULD_NOT_CREATED\n",0,0,0,0,0,0);
                                   s_ConfigFlag = FALSE;
                                   taskDelete(gbeMacCallbackTaskFiber[arg_DeviceNumber]);
                                   taskDelete(gbeMacCallbackTaskCopper[arg_DeviceNumber]);
                                   semDelete(g_SemBCreateFiber[arg_DeviceNumber]);
                                   s_ReturnValue = SEMAPHORE_COULD_NOT_CREATED;
                               }
                           }
                       }
                   }
               }
           }
           else if(arg_DeviceNumber == 1)
                {
   
               gbeMacGlobalData[1].g_TaskID = taskSpawn("s_Task2",90,0x100,2000,\
                                                             (FUNCPTR)gbe_mac_get_rmon_stat,arg_DeviceNumber,\
                                                             0,0,0,0,0,0,0,0,0);

                   if(gbeMacGlobalData[arg_DeviceNumber].g_TaskID == ERROR)
                   { /* Task could not spawned */
                       MESSAGE("ERROR_GET_RMON_STAT_TASK_COULD_NOT_SPAWNED\n",0,0,0,0,0,0);
                       s_ConfigFlag = FALSE;
                       s_ReturnValue = ERROR_GET_RMON_STAT_TASK_COULD_NOT_SPAWNED;
                   } /* end-if taskSpawn() */
                   else
                   {
                       /**
                        * Spawinig a task, gbe_mac_callback_dispatcher_fiber_1.  This task actually wait
                        * onto a semaphore which is actually
                        * released by the ISR.  this intern call the callback functions.
                        */

                       gbeMacCallbackTaskFiber[1] = taskSpawn("s_TaskCallbackFiber_1",150,0x100,2000,\
                                                               (FUNCPTR)gbe_mac_callback_dispatcher_fiber_1,\
                                                               0,0,0,0,0,0,0,0,0,0);

                       if(gbeMacCallbackTaskFiber[1] == ERROR)
                       { /*Error in Spawning the Task */
                           MESSAGE("Task Could not be spawned for Callback related functionality\n",0,0,0,0,0,0);
                           s_ConfigFlag = FALSE;
                       }
                       else
                       { /* Earlier Task Spawned successfully */
                         /**
                          * Spawn a task gbe_mac_callback_dispatcher_copper_0, that continuousouly pools the PHY                                        * iterrupt register, to check the occurrance of the interrupt.
                          */

                           gbeMacCallbackTaskCopper[1] = taskSpawn("s_TaskCallbackCopper_1",150,0x100,2000,\
                                                                    (FUNCPTR)gbe_mac_callback_dispatcher_copper_1,\
                                                                    0,0,0,0,0,0,0,0,0,0);

                           if(gbeMacCallbackTaskCopper[1] == ERROR)
                           {
                               MESSAGE("Task Could not be spawned for Callback related functionality\n",0,0,0,0,0,0);
                               s_ConfigFlag = FALSE;
                              /* Delete the earlier spawned task */
                              taskDelete(gbeMacCallbackTaskFiber[1]);
                           }
                           else
                           {
                              /**
                               * Create binary semaphore for card 0
                               */
                              g_SemBCreateFiber[1] = semBCreate(SEM_FULL,SEM_Q_FIFO);
                              if(g_SemBCreateFiber[1] == NULL)
                              {
                                  MESSAGE("SEMAPHORE_COULD_NOT_CREATED\n",0,0,0,0,0,0);
                                  s_ConfigFlag = FALSE;
                                  taskDelete(gbeMacCallbackTaskFiber[arg_DeviceNumber]);
                                  taskDelete(gbeMacCallbackTaskCopper[arg_DeviceNumber]);
                                  s_ReturnValue = SEMAPHORE_COULD_NOT_CREATED;
                              }
                              else
                              {
                                  g_SemBCreateCopper[1] = semBCreate(SEM_FULL,SEM_Q_FIFO);
                                  if(g_SemBCreateCopper[1] == NULL)
                                  {
                                       MESSAGE("SEMAPHORE_COULD_NOT_CREATED\n",0,0,0,0,0,0);
                                       s_ConfigFlag = FALSE;
                                       taskDelete(gbeMacCallbackTaskFiber[arg_DeviceNumber]);
                                       taskDelete(gbeMacCallbackTaskCopper[arg_DeviceNumber]);
                                       semDelete(g_SemBCreateFiber[arg_DeviceNumber]);
                                       s_ReturnValue = SEMAPHORE_COULD_NOT_CREATED;
                                   }
                               }
                          }
                       }
                   }
                }
                else
                {
                    MESSAGE("Invalid Device number\n",0,0,0,0,0,0);
                }

	/* Enable all interrupts */
        gbe_mac_read_32_bits(arg_DeviceNumber,INTERFACE_MODE,&s_ReadValue);
        for(s_PortCount=0;s_PortCount<4;s_PortCount++)
        {
            if(((s_ReadValue >> s_PortCount) & 0x1) == 0x1)
            {
                gbe_mac_phy_write(arg_DeviceNumber,s_PortCount, 0x19, 0xB400);
            }
         }
       }
#else
       MESSAGE("Create the Process which updates the RMON Statistics\n",0,0,0,0,0,0);
#endif

       /**
        * Check whether the memory is allocated or not.
        */
       if(s_RmonStatFlag == FALSE)
       { /* Memory Allocation fails */
           s_ConfigFlag = FALSE;
           s_ReturnValue = MEMORY_ALLOCATION_FAILS;
       }
                                                                       /* Wait for clock to stable */
       if(s_ConfigFlag)
       { /* The complete configuration has done successfully */
           gbe_mac_write_32_bits(arg_DeviceNumber,PORT_ENABLE,arg_PortMask);
           for(s_Count=0; s_Count<PT_LONE_GBE_PORT_MAX;s_Count++)
           { /* Set the status of each port to OPENED */
               if((arg_PortMask & HIGH_BIT) == HIGH_BIT)
               {
                   gbeMacGlobalData[arg_DeviceNumber].g_PortState[s_Count] = OPENED;
                   gbeMacGlobalData[arg_DeviceNumber].g_PortUsageCount[s_Count]++;
                   MESSAGE("Port %d is OPENED\n",s_Count,0,0,0,0,0);
               }
               arg_PortMask = arg_PortMask >> HIGH_BIT;
           }
           /* Set the Mac Status as Initialized */
#if defined(__VXWORKS__)
           gbeMacGlobalData[arg_DeviceNumber].g_MacStatus = INITIALIZED;
#endif
       }
#if defined(__VXWORKS__)
    }
    else
    { /* Could not grab the Mutex Semaphore in estimated time due to time out */
        s_ConfigFlag = FALSE;
        MESSAGE("S_objLib_OBJ_TIMEOUT\n",0,0,0,0,0,0);
        s_ReturnValue = S_objLib_OBJ_TIMEOUT;
    } /* end-if semTake() */
#endif

    if(s_ResourceCount == 1)
    {
        /**
         * Release the Mutex Semaphore.
         */
#if defined(__VXWORKS__)
        semGive(gbeMacGlobalData[arg_DeviceNumber].g_MutexSemaphore);
#else
        MESSAGE("No need of semaphore in Linux Kernel Mode driver\n",0,0,0,0,0,0);
#endif                                                                          /* Releasing Semaphore */
        MESSAGE("Config Handler has released the semaphore\n",0,0,0,0,0,0);
    }

    if(s_ConfigFlag)
    {
        MESSAGE("Basic Configuration is performed successfully\n",0,0,0,0,0,0);
        MESSAGE("GbEMAC_DeviceStart ->gbe_mac_config Function completes the requisite configuration\n",0,0,0,0,0,0);
    }
    else
    {
        MESSAGE("Basic Configuration is FAILED\n",0,0,0,0,0,0);
        MESSAGE("GbEMAC_DeviceStart ->gbe_mac_config Function could not complete the requisite configuration\n",0,0,0,0,0,0);
    }
    return s_ReturnValue;
}


/**
 * This function is used to change the basic configuration from the IOCTL command.
 * it is called from the gbe_mac_set_config_handler() routine.
 */
gbe_mac_error gbe_mac_reconfig_handler(
                                       uint32 arg_DeviceNumber,
                                       gbe_mac_IOCTL_CMD arg_Cmd,
                                       void *arg_pIoctlStruct
                                      )
{
    uint32 s_GetStatus=0; 
    uint32 s_PortNumber=0;
    uint32 s_PortMaskHigh=0, s_PortMaskLow=0;
    gbe_mac_ioctl_ptr *p_IoctlPtr;
    uint32 s_MacSoftReadValue=0,s_TxFifoResetReadValue=0,s_PortEnableReadValue=0,s_ClkIfModeReadValue=0;
    uint32 s_WriteValue, s_ReturnValue;
    uint32 s_ReconfigFlag = TRUE;
    
    /* Initialize the s_returnValue to SUCCESS */
    s_ReturnValue = SUCCESS;
    
    p_IoctlPtr = (gbe_mac_ioctl_ptr *)arg_pIoctlStruct;
    s_PortNumber = p_IoctlPtr->portIndex;
    s_WriteValue = p_IoctlPtr->value;

    MESSAGE("Changing the present configuration gbe_mac_reconfig_handler...\n",0,0,0,0,0,0);

    /**
     * Take the Mutex Semaphore for doing Inititial Configuration.
     */
#if defined(__VXWORKS__)
    if(semTake(gbeMacGlobalData[arg_DeviceNumber].g_MutexSemaphore,WAIT_FOR_SEMAPHORE) == OK)
    { /* Takes the Mutex Semaphore Successfully */
#else
#endif
        /**
         * When the chip is changed between Copper and Fiber mode, it should be done with MAC and 
         * Transmit FIFO under soft Reset and port enable de-asserted. Also it is required that 
         * there is no packet transfer in progress, as they will be dropped then. Follow these steps
         * for the same
         *    -Apply soft reset to MAC and Transmit FIFO blocks
         *    -De-assert the port enable
         *    -Reset the clock mode change enable bit
         *    -Change the mode
         *    -Set clock mode change enable bit
         *    -Wait for about 1us
         *    -Release Soft reset
         *    -Assert the port enable
         *    -Wait for Auto-negotiation completion in case of SERDES mode selection
        */

        gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0x0);
        gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0xf);

        s_GetStatus = HIGH_BIT << s_PortNumber;
        s_PortMaskHigh = s_GetStatus;
        s_PortMaskLow = (PORT_MASK ^ s_GetStatus) & PORT_MASK;

        gbe_mac_read_32_bits(arg_DeviceNumber,MAC_SOFT_RESET,&s_MacSoftReadValue);
        s_MacSoftReadValue &= PORT_MASK;
        s_MacSoftReadValue |= s_PortMaskHigh;
        gbe_mac_write_32_bits(arg_DeviceNumber,MAC_SOFT_RESET,s_MacSoftReadValue);

        gbe_mac_read_32_bits(arg_DeviceNumber,TXFIFO_PORT_RESET,&s_TxFifoResetReadValue);
        s_TxFifoResetReadValue &= PORT_MASK;
        s_TxFifoResetReadValue |= s_PortMaskHigh;
        gbe_mac_write_32_bits(arg_DeviceNumber,TXFIFO_PORT_RESET,s_TxFifoResetReadValue);        

        gbe_mac_read_32_bits(arg_DeviceNumber,PORT_ENABLE,&s_PortEnableReadValue);
        s_PortEnableReadValue &= PORT_MASK;
        s_PortEnableReadValue &= s_PortMaskLow;
        gbe_mac_write_32_bits(arg_DeviceNumber,PORT_ENABLE,s_PortEnableReadValue);

        gbe_mac_read_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,&s_ClkIfModeReadValue);  
        s_ClkIfModeReadValue &= PORT_MASK;
        s_ClkIfModeReadValue &= s_PortMaskLow;
        gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,s_ClkIfModeReadValue);

        switch(arg_Cmd)
        {
            case SET_DUPLEX_MODE:
                gbe_mac_write_32_bits(arg_DeviceNumber,\
                                      (g_PerPortOffset[s_PortNumber]+DESIRED_DUPLEX),s_WriteValue);
                break;             

            case SET_INTERFACE_MODE:
                gbe_mac_write_32_bits(arg_DeviceNumber,INTERFACE_MODE,s_WriteValue);
                break;

            case SET_MAC_IF_MODE:
                gbe_mac_write_32_bits(arg_DeviceNumber,\
                                      (g_PerPortOffset[s_PortNumber]+MAC_IF_MODE),s_WriteValue);
                break;
    
            case SET_SPI3_TX_CONFIG:
                gbe_mac_write_32_bits(arg_DeviceNumber,\
                                      SPI3_TX_GLOBAL_CONFIG,s_WriteValue);
                break;

            default:
                MESSAGE("IOCTL_ERROR_UNKNOWN_IOCTL_CODE\n",0,0,0,0,0,0);
                s_ReturnValue = IOCTL_ERROR_UNKNOWN_IOCTL_CODE;
                break;
        }; /* end-switch(arg_Cmd) */
 
        s_ClkIfModeReadValue |= s_PortMaskHigh;
        gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,s_ClkIfModeReadValue);   

#if defined(__VXWORKS__)
        taskDelay(1);
#else
                                                                  /* Introduce the requisite delay for the Linux. */
#endif /* Introduce delay to clock to be stable */

        s_MacSoftReadValue &= s_PortMaskLow;
        gbe_mac_write_32_bits(arg_DeviceNumber,MAC_SOFT_RESET,s_MacSoftReadValue);

        s_TxFifoResetReadValue &= s_PortMaskLow;
        gbe_mac_write_32_bits(arg_DeviceNumber,TXFIFO_PORT_RESET,s_TxFifoResetReadValue);

        s_PortEnableReadValue |= s_PortMaskHigh;
        gbe_mac_write_32_bits(arg_DeviceNumber,PORT_ENABLE,s_PortEnableReadValue);  

        gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0x0);
        gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0xf);


#if defined(__VXWORKS__)
    }
    else
    { /* Could not grab the Mutex semaphore */
        MESSAGE("S_objLib_OBJ_TIMEOUT\n",0,0,0,0,0,0);
        s_ReconfigFlag = FALSE;
        s_ReturnValue = S_objLib_OBJ_TIMEOUT;
    } /* end-if-else semTake() */
#else
#endif
 
    if(s_ReconfigFlag)
    { /* Re-Configuration successfully completed. */
        /**
         * Release the Mutex Semaphore.
         */
#if defined(__VXWORKS__)
        semGive(gbeMacGlobalData[arg_DeviceNumber].g_MutexSemaphore);
#else                                                             /* For Linux Environment. */
#endif
        MESSAGE("Present configurationis changed to desired one in gbe_mac_reconfig_handler Function.\n",0,0,0,0,0,0);
    }
    else
    { /* Re-Configuration fails */
        MESSAGE("Could not reconfigure\n",0,0,0,0,0,0);
    } 
    return s_ReturnValue;
}


/**
 * The ISR will simply release the respective semaphore, on which the
 * callback dispatcher task is waiting.
 *
 * In this ISR the Interrupt Status register is read irrespective 
 * of the Port Configuration.  It has been observed that the interrupt has
 * come, if the cable has been removed, though the respective port is not 
 * configured.  So we need to read the Interrupt status register to clear
 * the interrupt bit.  Not reading the Interrupt status register could 
 * cause in system hang-up.  So the Interrupt register for the Fiber, and 
 * copper has been read in the ISR.
 */
void gbe_mac_isr(
                 uint32 arg_DeviceNumber
                )
{
    /**
     * release the semaphore for the corresponding port
     */
#if defined(__VXWORKS__)
    uint32 locKey=0;
#endif
    uint32 readVal=0;
    uint32 s_ReadValue=0,s_PortCount=0;

    locKey = intLock();
    read_32_bits_from_isr(arg_DeviceNumber,GBIC_STATUS_REG,&readVal);

    if(gbic_status != readVal)
    {
            g_gbic_port_int_status = gbic_status ^ readVal;     
            semGive(g_SemBCreateFiber[arg_DeviceNumber]);
            gbic_status = readVal;
    }
    else
    {
        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
        {
            gbe_mac_phy_read_from_isr(arg_DeviceNumber,s_PortCount,MDI_INT_STATUS_OFFSET,\
                                      &s_ReadValue);
            phy_int_status[s_PortCount] = s_ReadValue & 0x3400;
        }
        semGive(g_SemBCreateCopper[arg_DeviceNumber]);
    } 
    intUnlock(locKey);
    return;
}    

/**
 * Callback Handler function for GBIC interrupt in the Fiber Mode for the PtLone card
 * on the Media Interface
 */
void gbe_mac_callback_dispatcher_fiber_0(
                                         void
                                        )
{
    uint32 s_Count, s_DeviceNumber = 0;
    uint32 s_LinkStatus=0;
    uint32 s_TempPortMask  = 0;
    uint32 s_TempCount=0;


    for(;;)
    {
        semTake(g_SemBCreateFiber[s_DeviceNumber],WAIT_FOREVER);
        MESSAGE("INTERRUPT Occured for PtLone card on Media Interface in FIBER\n",0,0,0,0,0,0);

        /**
         * Read the status of the Rx input in relation to the level of the signal
         * being received from the line, to check whether the line is up or down.
         */
        read_32_bits_from_isr(s_DeviceNumber,SERDES_RX_SIGNAL_LEVEL,&s_LinkStatus);
        s_LinkStatus = s_LinkStatus & PORT_MASK;

        for(s_Count=0; s_Count<MAX_APP_SUPPORTED;s_Count++)
        {
            if((gbeMacCallback[s_Count].appHandle & DEVICE_0) == DEVICE_0)
            {
                s_TempPortMask = g_gbic_port_int_status >> 20;
                for(s_TempCount=0;s_TempCount<NUM_PORT_2410;s_TempCount++)
                {
                    if ((s_TempPortMask) & (0x1<<s_TempCount))    
                    {
                        (gbeMacCallback[s_Count].p_CallbackFn)\
                            (gbeMacCallback[s_Count].p_UserContext,s_TempCount,s_LinkStatus);
                    }
                }
            }
        }
        taskDelay(2);
    }
    return;
}

/**
 * Callback Handler function for GBIC interrupt in the Fiber Mode for the PtLone card
 * on the Switch Fabric Interface.
 */
void gbe_mac_callback_dispatcher_fiber_1(
                                         void
                                        )
{
    uint32 s_Count, s_DeviceNumber = 1;
    uint32 s_LinkStatus=0;
    uint32 s_TempPortMask  = 0;
    uint32 s_TempCount=0;


    for(;;)
    {
        semTake(g_SemBCreateFiber[s_DeviceNumber],WAIT_FOREVER);
        MESSAGE("INTERRUPT Occured for PtLone card on Switch Fabric Interface in FIBER\n",0,0,0,0,0,0);
        /**
         * Read the status of the Rx input in relation to the level of the signal
         * being received from the line, to check whether the line is up or down.
         */
        read_32_bits_from_isr(s_DeviceNumber,SERDES_RX_SIGNAL_LEVEL,&s_LinkStatus);
        s_LinkStatus = s_LinkStatus & PORT_MASK;
        s_LinkStatus = s_LinkStatus << SHIFT_NIBBLE;


        for(s_Count=0; s_Count<MAX_APP_SUPPORTED;s_Count++)
        {
            if((gbeMacCallback[s_Count].appHandle & DEVICE_1) == DEVICE_1)
            {
                s_TempPortMask = g_gbic_port_int_status >> 20;
                for(s_TempCount=0;s_TempCount<NUM_PORT_2410;s_TempCount++)
                {
                    if ((s_TempPortMask) & (0x1<<s_TempCount))    
                    {
                        (gbeMacCallback[s_Count].p_CallbackFn)\
                         (gbeMacCallback[s_Count].p_UserContext,s_TempCount,s_LinkStatus);
                    }
                }
            }
        }
        taskDelay(2);
    }
    return;
}

/**
 * Callback Handler function for MDI interrupt in the Copper Mode for the PtLone card
 * on the Media Interface.
 */
void gbe_mac_callback_dispatcher_copper_0(
                                          void
                                         )
{
    uint32 s_Count, s_DeviceNumber = 0;
    short s_LinkStatus;
    uint32 s_TempPortMask  = 0;
    uint32 s_TempCount=0;
    uint32 s_PortCount=0;
    uint32 s_ReadValue=0, s_Temp=0;
    uint32 s_PortLinkStatus[4] = {2,2,2,2}; /*  0  :  Link Goes Down
						1  :  Link Goes UP
						2  :  Link Remains Unchanged  */

    for(;;)
    {
        semTake(g_SemBCreateCopper[s_DeviceNumber],WAIT_FOREVER);
        s_LinkStatus = 0;

	/* Initializes the array as the Link Unchanged status */
        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
		s_PortLinkStatus[s_PortCount] = 2;
	
        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
        {
            s_Temp = phy_int_status[s_PortCount];
            if(s_Temp != 0)
            {
                gbe_mac_phy_read(s_DeviceNumber,s_PortCount,MDI_LINK_STATUS,&s_ReadValue);

                MESSAGE("MDI_LINK_STATUS [0x%x] \n",s_ReadValue,0,0,0,0,0);
                if((s_ReadValue & 0x4) == 0x4)
                {
                    MESSAGE("LINK UP .....PORT %d\n",s_PortCount,0,0,0,0,0);
                    s_PortLinkStatus[s_PortCount] = 1;
                }
                else
                {
                    MESSAGE("LINK DOWN .....PORT %d\n",s_PortCount,0,0,0,0,0);
                    s_PortLinkStatus[s_PortCount] = 0;
                }
            }
        }

        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
        {
            gbe_mac_phy_read(s_DeviceNumber,s_PortCount,MDI_LINK_STATUS,&s_ReadValue);
	    s_Temp = 0;
            if((s_ReadValue & 0x4) == 0x4)
            {
                    s_Temp = (0x1) << s_PortCount;
            }
            s_LinkStatus = s_LinkStatus | s_Temp;
        }
        s_LinkStatus = s_LinkStatus & PORT_MASK;
        g_CuLinkStatusMI = s_LinkStatus;
        MESSAGE("g_CuLinkStatusMI [0x%x]\n",g_CuLinkStatusMI,0,0,0,0,0);

        for(s_Count=0; s_Count<MAX_APP_SUPPORTED;s_Count++)
        {
            if((gbeMacCallback[s_Count].appHandle & DEVICE_0) == DEVICE_0)
            {
                for(s_TempCount=0;s_TempCount<NUM_PORT_2410;s_TempCount++)
	        {			
                    if (s_PortLinkStatus[s_TempCount] != 2)
		    {
                        (gbeMacCallback[s_Count].p_CallbackFn)\
			    (gbeMacCallback[s_Count].p_UserContext,s_TempCount,s_LinkStatus);
	            }
	        }			
            }
        }
        taskDelay(2);
    }
    return;
}


/**
 * Callback Handler function for MDI interrupt in the Copper Mode for the PtLone card
 * on the Switch Fabric Interface.
 */
void gbe_mac_callback_dispatcher_copper_1(
                                          void
                                         )
{
    uint32 s_Count, s_DeviceNumber = 1;
    short s_LinkStatus;
    uint32 s_TempPortMask  = 0;
    uint32 s_TempCount=0;
    uint32 s_ReadValue=0, s_Temp=0;
    uint32 s_PortCount=0;
    uint32 s_PortLinkStatus[4] = {2,2,2,2}; /*  0  :  Link Goes Down
                                                1  :  Link Goes UP
                                                2  :  Link Remains Unchanged  */
    

    MESSAGE("CU-CALLBACK-DISPATCHER-1...",0,0,0,0,0,0);

    for(;;)
    {
        semTake(g_SemBCreateCopper[s_DeviceNumber],WAIT_FOREVER);
        s_LinkStatus = 0;

	/* Initializes the array as the Link Unchanged status */
        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
                s_PortLinkStatus[s_PortCount] = 2;

        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
        {
            s_Temp = phy_int_status[s_PortCount];
            if(s_Temp != 0)
            {
                gbe_mac_phy_read(s_DeviceNumber,s_PortCount,MDI_LINK_STATUS,&s_ReadValue);

                MESSAGE("MDI_LINK_STATUS [0x%x] \n",s_ReadValue,0,0,0,0,0);
                if((s_ReadValue & 0x4) == 0x4)
                {
                    MESSAGE("LINK UP .....PORT %d\n",s_PortCount,0,0,0,0,0);
		    s_PortLinkStatus[s_PortCount] = 1;
                }
                else
                {
                    MESSAGE("LINK DOWN .....PORT %d\n",s_PortCount,0,0,0,0,0);
		    s_PortLinkStatus[s_PortCount] = 0;
                }
            }
	}

        for(s_PortCount=0; s_PortCount<PT_LONE_GBE_PORT_MAX; s_PortCount++)
        {
            gbe_mac_phy_read(s_DeviceNumber,s_PortCount,MDI_LINK_STATUS,&s_ReadValue);
	    s_Temp = 0;
            if((s_ReadValue & 0x4) == 0x4)
            {
                    s_Temp = (0x1) << s_PortCount;
            }
            s_LinkStatus = s_LinkStatus | s_Temp;
        }

        s_LinkStatus = s_LinkStatus & PORT_MASK;
        g_CuLinkStatusSF = s_LinkStatus;
        MESSAGE("g_CuLinkStatusSF [0x%x]\n",g_CuLinkStatusSF,0,0,0,0,0);
        s_LinkStatus = s_LinkStatus << SHIFT_NIBBLE;

        for(s_Count=0; s_Count<MAX_APP_SUPPORTED;s_Count++)
        {
            if((gbeMacCallback[s_Count].appHandle & DEVICE_1) == DEVICE_1)
            {
                for(s_TempCount=0;s_TempCount<NUM_PORT_2410;s_TempCount++)
                {		    
                    if(s_PortLinkStatus[s_TempCount] != 2)    
	            {
                        (gbeMacCallback[s_Count].p_CallbackFn)\
			    (gbeMacCallback[s_Count].p_UserContext,s_TempCount,s_LinkStatus);
    		    }
                }
   	    }
	}

        taskDelay(2);
    }
    return;
}

/**
 * This function repeatedly calls the device respective function to upfdate the RMON
 * statistics.
 */
gbe_mac_error gbe_mac_get_rmon_stat(
                                    uint32 arg_DeviceNumber
                                   )
{
    uint32 s_ReturnValue=0;
    uint32 s_PortNumber=0;
    uint32 s_Count;
    uint32 s_RmonCount=0;
    s_ReturnValue = SUCCESS;

    MESSAGE("\ngbe_mac_get_rmon_stat ***  \n",0,0,0,0,0,0);
    	
    for(s_Count = 0; s_Count < PT_LONE_GBE_PORT_MAX; s_Count++)
    { /* Initialize the array to 0 */
        for(s_RmonCount=0;s_RmonCount < 102;s_RmonCount++)
        {/* for all the RMON registers */
            gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_Count][s_RmonCount] = 0;
        }/* end-for RMON stats */
    } /* end-for All 4-ports */
    
    /*initialize the array to zero, that is being used for adding two 32-bit values.*/
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0] = 0;
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1] = 0;
    
#if defined(__VXWORKS__)
    while(1) 
    {/* countinuous, till the driver is active */

        taskDelay(900);
        for(s_PortNumber = 0;s_PortNumber<PT_LONE_GBE_PORT_MAX;s_PortNumber++)
        { /* update the RMON statistics registers for each port */
            s_ReturnValue = gbe_mac_evaluate_rmon_stat(arg_DeviceNumber, s_PortNumber);
        } /* end-for loop */
        /* wait for 30 Seconds to read the RMON registers again.*/
    } /* end-while */
#else
#endif
    return s_ReturnValue;
}


/**
 * This function reads the RMON registers and updates the locally maintained 
 * counter.
 */
gbe_mac_error gbe_mac_evaluate_rmon_stat(
                                         uint32 arg_DeviceNumber,
                                         uint32 arg_PortNumber
                                        )
{
    uint32 s_ReturnValue; 
    uint32 s_PortNumber=0;
    uint32 s_ReadValue=0;
   
    s_ReturnValue = SUCCESS;
    s_PortNumber = arg_PortNumber;

    /**
     * MAC RX Statistics Registers
     */

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_OCTETS_OK),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][0],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][1],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][0] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][1] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_OCTETS_BAD),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][2],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][3],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][2] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][3] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_UC_PKTS),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][4],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][5],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][4] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][5] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];


    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_MC_PKTS),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][6],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][7],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][6] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][7] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_BC_PKTS),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][8],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][9],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][8] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][9] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_64),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][10],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][11],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][10] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][11] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_65_127),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][12],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][13],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][12] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][13] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_128_255),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][14],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][15],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][14] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][15] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_256_511),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][16],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][17],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][16] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][17] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_512_1023),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][18],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][19],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][18] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][19] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_1024_1518),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][20],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][21],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][20] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][21] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PKTS_1519_MAX),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][22],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][23],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][22] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][23] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_FCS_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][24],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][25],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][24] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][25] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + VLAN_TAG),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][26],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][27],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][26] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][27] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_DATA_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][28],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][29],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][28] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][29] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_ALIGN_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][30],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][31],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][30] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][31] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_LONG_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][32],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][33],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][32] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][33] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_JABBER_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][34],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][35],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][34] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][35] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_PAUSE_MAC_CTL),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][36],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][37],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][36] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][37] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RX_UNKNOWN_CTL_FRAME),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][38],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][39],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][38] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][39] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + VLONG_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][40],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][41],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][40] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][41] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + RUNT_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][42],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][43],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][42] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][43] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + SHORT_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][44],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][45],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][44] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][45] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + CARRIER_EXTEND_ERROR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][46],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][47],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][46] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][47] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + SEQ_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][48],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][49],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][48] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][49] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + SYMBOL_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][50],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][51],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][50] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][51] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    /**
     * MAC TX Statistics Registers
     */
    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_OCTETS_OK),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][52],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][53],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][52] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][53] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];


    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_OCTETS_BAD),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][54],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][55],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][54] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][55] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_UC_PKTS),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][56],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][57],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][56] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][57] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_MC_PKTS),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][58],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][59],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][58] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][59] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_BC_PKTS),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][60],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][61],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][60] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][61] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_64),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][62],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][63],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][62] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][63] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_65_127),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][64],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][65],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][64] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][65] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_128_255),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][66],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][67],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][66] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][67] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_256_511),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][68],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][69],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][68] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][69] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_512_1023),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][70],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][71],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][70] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][71] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_1024_1518),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][72],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][73],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][72] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][73] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PKTS_1519_MAX),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][74],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][75],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][74] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][75] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_DEFERRED_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][76],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][77],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][76] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][77] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_TOTAL_COLLISION),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][78],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][79],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][78] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][79] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_SINGLE_COLLISION),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][80],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][81],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][80] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][81] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_MUL_COLLISION),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][82],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][83],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][82] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][83] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + LATE_COLLISION),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][84],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][85],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][84] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][85] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_EXCV_COLLISION),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][86],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][87],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][86] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][87] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_EXCV_DEFERRED_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][88],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][89],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][88] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][89] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_EXCV_LEN_DROP),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][90],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][91],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][90] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][91] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_UNDERRUN),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][92],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][93],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][92] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][93] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_VLAN_TAG),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][94],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][95],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][94] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][95] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_CRC_ERR),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][96],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][97],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][96] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][97] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + TX_PAUSE_FRAME),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][98],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][99],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][98] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][99] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    gbe_mac_read_32_bits(arg_DeviceNumber,((0x80 *s_PortNumber) + FC_COLLISION_SEND),&s_ReadValue);
    s_ReturnValue = gbe_mac_add_two_lword(arg_DeviceNumber,\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][100],\
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][101],\
                                          s_ReadValue);
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][100] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0];
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacRmonStat[s_PortNumber][101] = \
                                          gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1];

    return s_ReturnValue;
}

/**
 * his function adds the two 32-bit register value, and updates the 64-bit 
 * counter
 */
gbe_mac_error gbe_mac_add_two_lword(
                                    uint32 arg_DeviceNumber,
                                    uint32 arg_Low,
                                    uint32 arg_High,
                                    uint32 arg_Value
                                   )
{
    uint32 s_ReturnValue=0;
    uint32 s_ResultLow = 0, s_ResultHigh = arg_High;
    uint32 s_LowValue=0, s_LowCarry=0;
    uint32 s_Value=0, s_ValueCarry=0;
    uint32 s_Add=0,s_AddCarry=0;
    uint32 temp=0,carry=0;

    s_ReturnValue = SUCCESS;

    s_LowValue = arg_Low & MAKE_AND;
    s_LowCarry = arg_Low >> SHIFT_RIGHT;

    s_Value = arg_Value & MAKE_AND;
    s_ValueCarry = arg_Value >> SHIFT_RIGHT;

    s_Add = s_LowValue + s_Value;

    s_AddCarry = s_Add >> SHIFT_RIGHT;
    s_Add = s_Add & MAKE_AND;

    temp = s_LowCarry + s_ValueCarry + s_AddCarry;

    s_ResultLow = temp & 0x1;

    s_ResultLow = s_ResultLow << SHIFT_RIGHT;
    s_ResultLow = s_ResultLow | s_Add;

    carry = temp >> 0x1;

    s_ResultHigh = s_ResultHigh + carry;

    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[0] = s_ResultLow;
    gbeMacGlobalStruct[arg_DeviceNumber].gbeMacAddResult[1] = s_ResultHigh;

    return s_ReturnValue;
}

/**
 * This function configures the PHY registers as per the specified
 * mode, passed by the application.
 */
void config_phy(
                uint32 arg_DeviceNumber, 
	 	uint32 speed, 
		uint32 duplex , 	
		uint32 arg_PortMask
	   )
{
    int s_PortCount =0;
    int s_Port=0;

    s_Port = arg_PortMask & 0x0F;

    for(s_PortCount=0; s_PortCount<4;s_PortCount++)
    {		
	gbe_mac_phy_write(arg_DeviceNumber,s_PortCount, 0x17, 0x1300);
        if(speed == 1000)
		{
    	    gbe_mac_phy_write(arg_DeviceNumber,s_PortCount, 0x9, 0x0300);
			gbe_mac_phy_write(arg_DeviceNumber,s_PortCount, 0x16, 0x18);
			gbe_mac_phy_write(arg_DeviceNumber,s_PortCount, 0x18, 0x3240);

		}
	gbe_mac_phy_write(arg_DeviceNumber,s_PortCount, 0x0, 0x1240);        
    }

    for(s_PortCount=0; s_PortCount<4;s_PortCount++)
    {		
        if(((s_Port >> s_PortCount) & 0x01) == 0x00)
        {
            MESSAGE("SKIPing PORT [%d]\n",s_PortCount,0,0,0,0,0);
 	    continue;
        }

        check_autoneg_status(arg_DeviceNumber,speed,s_PortCount);
    }
}

/**
 * This function performs the MAC reset.
 */
void mac_reset(uint32 arg_DeviceNumber)
{
	gbe_mac_write_32_bits(arg_DeviceNumber,MAC_SOFT_RESET,0xF);
	gbe_mac_write_32_bits(arg_DeviceNumber,TXFIFO_PORT_RESET,0xF);
	gbe_mac_write_32_bits(arg_DeviceNumber,RXFIFO_PORT_RESET,0xF);
	gbe_mac_write_32_bits(arg_DeviceNumber,SPI3_TX_GLOBAL_CONFIG,0x00E00000);
	gbe_mac_write_32_bits(arg_DeviceNumber,MDIO_RESET,0x1);
}

/** 
 * This function disables the MAC reset. 
 */
void mac_disable_reset(uint32 arg_DeviceNumber)
{
	gbe_mac_write_32_bits(arg_DeviceNumber,MAC_SOFT_RESET,0x0);
	gbe_mac_write_32_bits(arg_DeviceNumber,TXFIFO_PORT_RESET,0x0);
	gbe_mac_write_32_bits(arg_DeviceNumber,RXFIFO_PORT_RESET,0x0);
	gbe_mac_write_32_bits(arg_DeviceNumber,MDIO_RESET,0x0);
}

/**
 * This function writes the Diverse configuration value to the respective port,
 * whose mask is passed in arg_PortMask. 
 */
void basic_diverse_config(
 		           uint32 arg_DeviceNumber,
                           uint32 arg_PortMask,
                           uint32 s_DiverseConfigValue
                         )
{
    uint32 s_Count;

    MESSAGE("Configuring the Diverse Configuration ...\n",0,0,0,0,0,0);
    for(s_Count=0;s_Count<4;s_Count++)
    {
        if(((arg_PortMask >> s_Count) & 0x1) == 0x1)
        {
            MESSAGE("**** Diverse Config [0x%x] for PORT [0x%x] \n",s_DiverseConfigValue,arg_PortMask,0,0,0,0);
            gbe_mac_write_32_bits(arg_DeviceNumber,((0x80 * s_Count) + 0x18),s_DiverseConfigValue);
        }
    }

    MESSAGE(" Configured\n",0,0,0,0,0,0);
    return;
}

/**
 * This function writes the interface mode value to the respective port,
 * whose mask is passed in arg_PortMask. 
 */
void basic_interface_mode(uint32 arg_DeviceNumber, uint32 arg_PortMask, uint32 arg_IFMode)
{
    uint32 s_Count;

    MESSAGE("Configuring the IF Mode ...",0,0,0,0,0,0);
    for(s_Count=0;s_Count<4;s_Count++)
    {
        if(((arg_PortMask >> s_Count) & 0x1) == 0x1)
        {
            MESSAGE("**** MAC_IF_MODE[0x%x] Port[0x%x] \n",arg_IFMode,arg_PortMask,0,0,0,0);
            gbe_mac_write_32_bits(arg_DeviceNumber,((0x80 * s_Count) + MAC_IF_MODE),arg_IFMode);
        }
    }

    MESSAGE(" Configured\n",0,0,0,0,0,0);
    return;
}

/**
 * This function updates the Interface mode register.
 */
void basic_channel_mode(uint32 arg_DeviceNumber, uint32 arg_PortMask, uint32 arg_mode)
{

    uint32 readVal,s_WriteVal,s_Count;

    MESSAGE("Configuring the FIBER/COPPER Mode ...PORT [0x%x]\n",arg_PortMask,0,0,0,0,0);

    gbe_mac_read_32_bits(arg_DeviceNumber,INTERFACE_MODE, &readVal);
 
    arg_mode = arg_mode & 0x7;
       
    if(arg_mode != 0)
    {
        s_WriteVal = arg_PortMask | readVal;
        MESSAGE("------[0x%x] ...\n",s_WriteVal,0,0,0,0,0);        
    }
    else
    {
        s_WriteVal = arg_PortMask ^ 0xF;
        s_WriteVal &= readVal;
        MESSAGE("------[0x%x] ...\n",s_WriteVal,0,0,0,0,0);        
    }         

    MESSAGE("------[0x%x] ...\n",s_WriteVal,0,0,0,0,0);
    gbe_mac_write_32_bits(arg_DeviceNumber,INTERFACE_MODE,s_WriteVal);

    if(arg_mode != 0)
    {
        for(s_Count=0;s_Count <4; s_Count++)
        {
            if((( arg_PortMask >> s_Count) & 0x1) == 0x1)
            {
                gbe_mac_phy_write(arg_DeviceNumber,s_Count, 0x19, 0xB400);
            }
        }
    }
    else
    {
        for(s_Count=0;s_Count <4; s_Count++)
        {
            if((( arg_PortMask >> s_Count) & 0x1) == 0x1)
            {
                gbe_mac_phy_write(arg_DeviceNumber,s_Count, 0x19, 0x00);
            }
        }
    } 
    MESSAGE(" Configured\n",0,0,0,0,0,0);
    return;
}


void basic_enable_mode(uint32 arg_DeviceNumber, uint32 arg_PortMask)
{

    uint32 readVal,s_WriteVal=0;

    gbe_mac_read_32_bits(arg_DeviceNumber,PORT_ENABLE, &readVal);

    s_WriteVal = arg_PortMask | readVal;       

    gbe_mac_write_32_bits(arg_DeviceNumber,PORT_ENABLE,s_WriteVal);

    MESSAGE(" Configured\n",0,0,0,0,0,0);
    return;
}


/**
 * This function writes the duplex configuration value to the respective port,
 * whose mask is passed in arg_PortMask. 
 */
void basic_duplex_configuration(
  			         uint32 arg_DeviceNumber,
                                 uint32 arg_PortMask,
                                 uint32 s_DuplexModeValue
                               )
{
    uint32 s_Count;
    uint32 s_AddArray[] = {0,0x80,0x100,0x180};
    MESSAGE("Configuring the DUPLEX Mode ...",0,0,0,0,0,0);

    for(s_Count=0;s_Count<4;s_Count++)
    {
        if(((arg_PortMask >> s_Count) & 0x1) == 0x1)
        {
            MESSAGE("**** DESIRED_DUPLEX[0x%x] \n",s_DuplexModeValue,0,0,0,0,0);
            gbe_mac_write_32_bits(arg_DeviceNumber,(s_AddArray[s_Count]+DESIRED_DUPLEX),s_DuplexModeValue);
        }
    }
    MESSAGE("..Configured\n",0,0,0,0,0,0);
    return ;
}

/**
 * This function enables the MAC reset for individual ports.
 */
void mac_change_reset(uint32 arg_DeviceNumber, uint32 arg_PortMask)
{
	gbe_mac_write_32_bits(arg_DeviceNumber,MAC_SOFT_RESET,arg_PortMask);
	gbe_mac_write_32_bits(arg_DeviceNumber,TXFIFO_PORT_RESET,arg_PortMask);
	gbe_mac_write_32_bits(arg_DeviceNumber,RXFIFO_PORT_RESET,arg_PortMask);
	gbe_mac_write_32_bits(arg_DeviceNumber,SPI3_TX_GLOBAL_CONFIG,0x00E00000);
}

/**
 * This function perfoerms the basic configuration, and configures the 
 * Vallejo in the specified mode, given by the user in the open API.
 */
void gbe_mac_basic_configuration(
                                 uint32 arg_DeviceNumber,
                                 uint32 arg_PortMask,
                                 uint32 arg_mode
                                  )
{
    uint32 s_StationAddressLow, s_StationAddressHigh;
    short pmask = arg_PortMask;
    short ifmode = 0, duplex = 0,speed = 0;
    short spi3_block_mode, spi3_parity_mode, spi3_parity_mask = 0x00;
    uint32 s_WriteSpi3Value,s_PortNumber,s_ReturnValue;
    uint32 s_rgmiiConf, s_DiverseConfig,mode = arg_mode;
    uint32 s_WriteSpi3RxValue,spi3_rx_parity_mask, s_Temp;

        spi3_block_mode = mode & SPI3_BLOCK_MODE;
        if(spi3_block_mode == 0)
        { /* When 0, indicates that SPI-3 block operates in 32-bit MPHY mode */
            s_WriteSpi3Value = SPI3_MPHY_MODE;
            s_WriteSpi3RxValue = SPI3_RX_PORT_ENABLE; 
            MESSAGE("MPHY-",0,0,0,0,0,0);
        }
        else
        { /* When 1, indicates that the SPI-3 block operates in 4x8 mode. */
            s_WriteSpi3Value = SPI3_4x8_MODE;
            s_WriteSpi3RxValue = SPI3_RX_PORT_ENABLE ; 
            MESSAGE("SPHY-",0,0,0,0,0,0);
        }
 
        spi3_parity_mode = mode & SPI3_PARITY_MODE;
        if(spi3_parity_mode == SPI3_PARITY_MODE) /* Even parity*/
        {
            if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
            {
                spi3_parity_mask = arg_PortMask & 0x0F;
                spi3_parity_mask = spi3_parity_mask << SHIFT_NIBBLE;

                s_Temp = arg_PortMask & 0x0F;
                spi3_rx_parity_mask = (s_Temp << 12) & SPI3_RX_EVEN_PARITY_MASK;
            }
            else
            {
                spi3_parity_mask = arg_PortMask & 0xF0;
            }
            MESSAGE("EVEN-",0,0,0,0,0,0); 
        }
        else
        {
            MESSAGE("ODD-",0,0,0,0,0,0);
        }
        s_WriteSpi3Value = s_WriteSpi3Value | spi3_parity_mask;
	MESSAGE("SPI-3 TX Config write value = 0x%x",s_WriteSpi3Value,0,0,0,0,0);

        s_WriteSpi3RxValue = s_WriteSpi3RxValue | spi3_rx_parity_mask;
	MESSAGE("SPI-3 RX Config write value = 0x%x",s_WriteSpi3RxValue,0,0,0,0,0);

        MESSAGE("MODE ===== [0x%x]\n",mode,0,0,0,0,0);

	s_DiverseConfig = 0x114D;
        pmask = arg_PortMask;
        mode = mode & 0x07;
	switch(mode)
	{
		case 0 :   duplex = 1;
			   ifmode = 0;
			   speed = 1000;
                           s_DiverseConfig = 0x11ED;
 			   s_rgmiiConf = 0x3;
                           MESSAGE("FB-FD-1000\n",0,0,0,0,0,0);
			   break;
	
		case 1 :   duplex = 0;
			   ifmode = 1;
			   speed = 1000;
 			   s_rgmiiConf = 0x6;
                           MESSAGE("CU-HD-1000\n",0,0,0,0,0,0);
			   break; 

		case 2 :   duplex = 1;
			   ifmode = 1;
			   speed = 1000;
 			   s_rgmiiConf = 0x6;
                           MESSAGE("CU-FD-1000\n",0,0,0,0,0,0);
			   break; 

		case 3 :   duplex = 0;
			   ifmode = 1;
			   speed = 100;
 			   s_rgmiiConf = 0x5;
                           MESSAGE("CU-HD-100\n",0,0,0,0,0,0);
			   break; 

		case 4 :   duplex = 1;
			   ifmode = 1;
			   speed = 100;
 			   s_rgmiiConf = 0x5;
                           MESSAGE("CU-FD-100\n",0,0,0,0,0,0);
			   break; 
		case 5 :   duplex = 0;
			   ifmode = 1;
			   speed = 10;
 			   s_rgmiiConf = 0x4;
                           MESSAGE("CU-HD-10\n",0,0,0,0,0,0);
			   break; 

		case 6 :   duplex = 1;
			   ifmode = 1;
			   speed = 10;
 			   s_rgmiiConf = 0x4;
                           MESSAGE("CU-FD-10\n",0,0,0,0,0,0);
			   break; 

		
		default:   MESSAGE("Illegal configuration attempt ..\n",0,0,0,0,0,0);
			   MESSAGE("Default configuration ..\n",0,0,0,0,0,0);
		           return;
		}

	
    if(mode != 0)
    {
        MESSAGE("Configuring the PHY ....",0,0,0,0,0,0);
        config_phy(arg_DeviceNumber, speed, duplex ,arg_PortMask);
    }

    mac_reset(arg_DeviceNumber); 
    gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0x0);
    gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0xf);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0xf);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0x0);

    /**
     * Set Station Address for Port 0.
     */
    MESSAGE("\nConfiguring MAC Address ...",0,0,0,0,0,0);
    s_StationAddressLow = gbeMacAddress[arg_DeviceNumber].macAddressPort_0[0];
    s_StationAddressHigh = gbeMacAddress[arg_DeviceNumber].macAddressPort_0[1];
    gbe_mac_write_64_bits(arg_DeviceNumber,(MAC_CTL_REG_PORT0+STATION_ADDR_LOW),\
                                           s_StationAddressLow, s_StationAddressHigh);

    /**
     * Set station address for port 1.
     */
    s_StationAddressLow = gbeMacAddress[arg_DeviceNumber].macAddressPort_1[0];
    s_StationAddressHigh = gbeMacAddress[arg_DeviceNumber].macAddressPort_1[1];
    gbe_mac_write_64_bits(arg_DeviceNumber,(MAC_CTL_REG_PORT1+STATION_ADDR_LOW),\
    s_StationAddressLow, s_StationAddressHigh);

    /**
     * Set station address for port 2.
     */
    s_StationAddressLow = gbeMacAddress[arg_DeviceNumber].macAddressPort_2[0];
    s_StationAddressHigh = gbeMacAddress[arg_DeviceNumber].macAddressPort_2[1];
    gbe_mac_write_64_bits(arg_DeviceNumber,(MAC_CTL_REG_PORT2+STATION_ADDR_LOW),\
                          s_StationAddressLow, s_StationAddressHigh);

    /**
     * Set station address for port 3.
     */
    s_StationAddressLow = gbeMacAddress[arg_DeviceNumber].macAddressPort_3[0];
    s_StationAddressHigh = gbeMacAddress[arg_DeviceNumber].macAddressPort_3[1];
    gbe_mac_write_64_bits(arg_DeviceNumber,(MAC_CTL_REG_PORT3+STATION_ADDR_LOW),\
    			  s_StationAddressLow, s_StationAddressHigh);
    MESSAGE(" -Configured",0,0,0,0,0,0);

    /**
     * Set the various configurations likes CRC enable, AN enable, padding enable etc.
     */
    MESSAGE("\nConfiguring Diverse Config Registers...",0,0,0,0,0,0);
    basic_diverse_config(arg_DeviceNumber,arg_PortMask,s_DiverseConfig);
    MESSAGE(" -Configured",0,0,0,0,0,0);
			
    MESSAGE("\nConfiguring Other requisite Vallejo Registers, PLS WAIT...",0,0,0,0,0,0);
    /**
     * Enable packets for short packets, and set minimal number of bytes in each packets 
     * equals to 0x50 (for all the ports)
     */
    gbe_mac_write_32_bits(arg_DeviceNumber,TXFIFO_PAD_ENB,0x0000AAAA);

    /** set FC_MODE to 0x0 **/
    gbe_mac_write_32_bits(arg_DeviceNumber,MAC_CTL_REG_PORT0+FC_MODE,0x0);			
    gbe_mac_write_32_bits(arg_DeviceNumber,MAC_CTL_REG_PORT1+FC_MODE,0x0);			
    gbe_mac_write_32_bits(arg_DeviceNumber,MAC_CTL_REG_PORT2+FC_MODE,0x0);			
    gbe_mac_write_32_bits(arg_DeviceNumber,MAC_CTL_REG_PORT3+FC_MODE,0x0);			
		

    /**
     *  Enable padding and CRC stripping
     */
    gbe_mac_write_32_bits(arg_DeviceNumber,RXFIFO_PAD_CRCSTRIP_ENB,0xF0);


    /**
     *  Enable Dropping of packets on error for all the 4 ports. 
     *  Jumbo pkts are not dropped in any case. 	
     */
     gbe_mac_write_32_bits(arg_DeviceNumber,RXFIFO_DROP_ENABLE,0xF);

    			
    /**
     *  Set SPI-3 Transmit and global configuration register
     *   1). 4x8 Mode configuration
     *   2). TX Burst Size - 128 Bytes maximum burst size
     *   3). TX Parity Sense - ODD
     */
    /* set SPI-3 TX config Register */
    gbe_mac_write_32_bits(arg_DeviceNumber,SPI3_TX_GLOBAL_CONFIG,s_WriteSpi3Value);
    /* set SPI-3 RX config Register */
    gbe_mac_write_32_bits(arg_DeviceNumber,SPI3_RX_CONFIG,s_WriteSpi3RxValue);

    gbe_mac_write_32_bits(arg_DeviceNumber,MDIO_RESET,0x0);

    /** enable GBIC interrupts **/
    gbe_mac_write_32_bits(arg_DeviceNumber,GBIC_CTRL_REG,0x1FC00);		      
    gbe_mac_read_32_bits(arg_DeviceNumber,GBIC_STATUS_REG,&gbic_status);
    g_gbic_port_int_status = gbic_status;
 		 
    /**
     * Assert the Port Enable.
     */
    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0x0);
    MESSAGE("Configuring the Interface Mode ....",0,0,0,0,0,0);
    basic_interface_mode(arg_DeviceNumber,arg_PortMask, s_rgmiiConf);
    MESSAGE("Configured\n",0,0,0,0,0,0);

    MESSAGE("Configuring the Duplex Mode ....",0,0,0,0,0,0);
    basic_duplex_configuration(arg_DeviceNumber,arg_PortMask,duplex);
    MESSAGE("Configured\n",0,0,0,0,0,0);

    basic_channel_mode(arg_DeviceNumber,arg_PortMask,arg_mode);

    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0xf);

    mac_disable_reset(arg_DeviceNumber);

    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0x0);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0xf);

    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0xf);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0x0);

    return;
}

/**
 * This function perfoerms the change configuration, and configures the 
 * Vallejo in the specified mode, given by the user in the change ioctl command.
 */
void gbe_mac_change_configuration(
                                 uint32 arg_DeviceNumber,
                                 uint32 arg_PortMask,
                                 uint32 arg_mode
                                  )
{
    short pmask = arg_PortMask;
    short ifmode = 0, duplex = 0,speed = 0;
    short spi3_block_mode, spi3_parity_mode, spi3_parity_mask = 0x00;
    uint32 s_WriteSpi3Value;
    uint32 readVal=0;
    uint32 s_ReturnValue=0,s_PortNumber;
    uint32 s_WriteSpi3RxValue,spi3_rx_parity_mask, s_Temp;
    uint32 s_rgmiiConf, s_DiverseConfig,mode = arg_mode;


        spi3_block_mode = mode & SPI3_BLOCK_MODE;
        if(spi3_block_mode == 0)
        { /* When 0, indicates that SPI-3 block operates in 32-bit MPHY mode */
            s_WriteSpi3Value = SPI3_MPHY_MODE;
            s_WriteSpi3RxValue = SPI3_RX_PORT_ENABLE; 
            MESSAGE("MPHY-",0,0,0,0,0,0);
        }
        else
        { /* When 1, indicates that the SPI-3 block operates in 4x8 mode. */
            s_WriteSpi3Value = SPI3_4x8_MODE;
            s_WriteSpi3RxValue = SPI3_RX_PORT_ENABLE; 
            MESSAGE("SPHY-",0,0,0,0,0,0);
        }
 
        spi3_parity_mode = mode & SPI3_PARITY_MODE;
        gbe_mac_read_32_bits(arg_DeviceNumber,0x700,&readVal);
        if(spi3_parity_mode == SPI3_PARITY_MODE) /* Even parity*/
        {
            if(arg_DeviceNumber == CARD_ON_MEDIA_IF)
            {
                /* Configuring the SPI3 TX config register */
                readVal = readVal & 0xF0;
                spi3_parity_mask = arg_PortMask & 0x0F;
                spi3_parity_mask = spi3_parity_mask << SHIFT_NIBBLE;
                spi3_parity_mask |= readVal;    

                /* Configuring the SPI3 RX config register */
                gbe_mac_read_32_bits(arg_DeviceNumber,0x701,&readVal);
                readVal = readVal & 0xFF80;
                s_Temp = arg_PortMask & 0x0F;
                spi3_rx_parity_mask = s_Temp << 12;
                spi3_rx_parity_mask |= readVal;    
            }
            else
            {
                /* Configuring the SPI3 TX config register - EVEN Parity */
                spi3_parity_mask = arg_PortMask & 0xF0;
                readVal &= 0xF0;
                spi3_parity_mask |= readVal;

                /* Configuring the SPI3 RX config register - EVEN Parity */
                gbe_mac_read_32_bits(arg_DeviceNumber,0x701,&readVal);
                readVal = readVal & 0xFF80;
                s_Temp = arg_PortMask & 0x0F0;
                spi3_rx_parity_mask = s_Temp << 8;
                spi3_rx_parity_mask |= readVal;    

            }
            MESSAGE("EVEN-",0,0,0,0,0,0); 
        }
        else
        {
            MESSAGE("ODD-",0,0,0,0,0,0);
        }
        s_WriteSpi3Value = s_WriteSpi3Value | spi3_parity_mask;
	MESSAGE("SPI-3 write value = 0x%x",s_WriteSpi3Value,0,0,0,0,0);

        s_WriteSpi3RxValue = s_WriteSpi3RxValue | spi3_rx_parity_mask;
	MESSAGE("SPI-3 RX Config write value = 0x%x",s_WriteSpi3RxValue,0,0,0,0,0);

        MESSAGE("MODE ===== [0x%x]\n",mode,0,0,0,0,0);

	s_DiverseConfig = 0x114D;
        pmask = arg_PortMask;
        mode = mode & 0x07;
	switch(mode)
	{
		case 0 :   duplex = 1;
			   ifmode = 0;
			   speed = 1000;
                           s_DiverseConfig = 0x116D;
 			   s_rgmiiConf = 0x3;
                           MESSAGE("FB-FD-1000\n",0,0,0,0,0,0);
			   break;
	
		case 1 :   duplex = 0;
			   ifmode = 1;
			   speed = 1000;
 			   s_rgmiiConf = 0x6;
                           MESSAGE("CU-HD-1000\n",0,0,0,0,0,0);
			   break; 

		case 2 :   duplex = 1;
			   ifmode = 1;
			   speed = 1000;
 			   s_rgmiiConf = 0x6;
                           MESSAGE("CU-FD-1000\n",0,0,0,0,0,0);
			   break; 

		case 3 :   duplex = 0;
			   ifmode = 1;
			   speed = 100;
 			   s_rgmiiConf = 0x5;
                           MESSAGE("CU-HD-100\n",0,0,0,0,0,0);
			   break; 

		case 4 :   duplex = 1;
			   ifmode = 1;
			   speed = 100;
 			   s_rgmiiConf = 0x5;
                           MESSAGE("CU-FD-100\n",0,0,0,0,0,0);
			   break; 
		case 5 :   duplex = 0;
			   ifmode = 1;
			   speed = 10;
 			   s_rgmiiConf = 0x4;
                           MESSAGE("CU-HD-10\n",0,0,0,0,0,0);
			   break; 

		case 6 :   duplex = 1;
			   ifmode = 1;
			   speed = 10;
 			   s_rgmiiConf = 0x4;
                           MESSAGE("CU-FD-10\n",0,0,0,0,0,0);
			   break; 

		
		default:   MESSAGE("Illegal configuration attempt ..\n",0,0,0,0,0,0);
			   MESSAGE("Default configuration ..\n",0,0,0,0,0,0);
		           return;
		}

	
    if(mode != 0)
    {
        MESSAGE("Configuring the PHY ....",0,0,0,0,0,0);
        config_phy(arg_DeviceNumber, speed, duplex ,arg_PortMask);
        MESSAGE("Configured \n",0,0,0,0,0,0);
    }

    mac_change_reset(arg_DeviceNumber, arg_PortMask);

    gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0x0);
    gbe_mac_write_32_bits(arg_DeviceNumber,SERDES_CLKMODE_REG,0xf);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0xf);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0x0);

    /**
     * Set the various configurations likes CRC enable, AN enable, padding enable etc.
     */
    MESSAGE("\nConfiguring Diverse Config Registers...",0,0,0,0,0,0);
    basic_diverse_config(arg_DeviceNumber,arg_PortMask,s_DiverseConfig);
    MESSAGE(" -Configured",0,0,0,0,0,0);
			
    MESSAGE("\nConfiguring Other requisite Vallejo Registers, PLS WAIT...",0,0,0,0,0,0);

    /**
     *  Set SPI-3 Transmit and global configuration register
     *   1). 4x8 Mode configuration
     *   2). TX Burst Size - 128 Bytes maximum burst size
     *   3). TX Parity Sense - ODD
     */
    /* set SPI-3 TX config Register */
    gbe_mac_write_32_bits(arg_DeviceNumber,SPI3_TX_GLOBAL_CONFIG,s_WriteSpi3Value);
    /* set SPI-3 RX config Register */
    gbe_mac_write_32_bits(arg_DeviceNumber,SPI3_RX_CONFIG,s_WriteSpi3RxValue);

    /**
     * Assert the Port Enable.
     */
    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0x0);
    MESSAGE("Configuring the Interface Mode ....",0,0,0,0,0,0);
    basic_interface_mode(arg_DeviceNumber,arg_PortMask, s_rgmiiConf);
    MESSAGE("Configured\n",0,0,0,0,0,0);

    MESSAGE("Configuring the Duplex Mode ....",0,0,0,0,0,0);
    basic_duplex_configuration(arg_DeviceNumber,arg_PortMask,duplex);
    MESSAGE("Configured\n",0,0,0,0,0,0);

    basic_channel_mode(arg_DeviceNumber,arg_PortMask,arg_mode);

    basic_enable_mode(arg_DeviceNumber, arg_PortMask);

    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0xf);

    mac_disable_reset(arg_DeviceNumber);

    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0x0);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x794,0xf);

    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0xf);
    gbe_mac_write_32_bits(arg_DeviceNumber,0x505,0x0);

    return;
}


void check_autoneg_status(uint32 arg_DeviceNumber, uint32 speed, uint32 arg_PortNumber)
{
        uint32 s_PortCount = 0, flag = 0, ctr = 0, done = 0;
        UINT32 regval = 0, link=0,receiver_status=0, autoneg_complete=0;
        short port;

        port = arg_PortNumber;

        s_PortCount = arg_PortNumber;
        MESSAGE("Waiting for auto-negotiation to complete ....\n",0,0,0,0,0,0);
        do
        {
            gbe_mac_phy_read(arg_DeviceNumber,s_PortCount,0x1,&autoneg_complete);
            if (((autoneg_complete >> 5) & 1) == 0x1)
            {
                flag = 0;
                MESSAGE("autoneg for port %d is ok !\n",s_PortCount,0,0,0,0,0);
                MESSAGE("link for port %d is = 0x%x\n",s_PortCount,link,0,0,0,0);
                break;
            }
            else
            {
                ctr ++;
                flag = -1;
            }
        }while (ctr < 500);
        if (flag == -1)
        {
            MESSAGE("Auto-negotiation failed for port [0x%x]\n",autoneg_complete,0,0,0,0,0);
        }

        return ;
}
