/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: gdvaddad $
*   DATE:           $Date: 2003/02/15 01:56:48 $
*   LAST MODIFIED:  $Modtime: 5/14/02 4:06p $
*   REV#:           $Revision: 1.5 $
*   LOGFILE:        $Logfile:  $
*   WORKFILE:       $Workfile: ixf_api.c $
*
* --------------------------------------------------------------------------
* Project: Angel Island
*
* Purpose: Provides the implementation to the common API for IXF chips.
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: slowport.c,v $
*   Revision 1.5  2003/02/15 01:56:48  gdvaddad
*   b0 fixes ai_phase7
*
*   Revision 1.4  2002/11/18 22:57:25  gdvaddad
*   b0 changes
*
*   Revision 1.3  2002/10/25 20:24:49  machambe
*   no message
*
* --------------------------------------------------------------------------
*/
#ifdef VXWORKS
#include <vxWorks.h>
#include <intLib.h>
#endif

#include "common_types.h"
#include "common_def.h"
#include "ixdp2400Misc.h"
#include "ixdp2400.h"
extern void sp_config(void);
extern void save_sp_config(void);
extern void restore_sp_config(void);
extern     int getProductID (unsigned int mask);

#define SWAPNTOHS(x)    ((((x) & 0x00ff) << 8) |  (((x) & 0xff00) >> 8))     

#ifdef SLOW_PORT 

ushort                                                                          
SlowPortRead(bb_RegPointer_type addr)
{
    int key;
    ushort val;

    key = intLock();

    save_sp_config();
    sp_config();

    intUnlock(key);
    
    val =  SWAPNTOHS(*addr);
    
    restore_sp_config();

    return val;
}


ushort                                                                          
SlowPortWrite(bb_RegPointer_type addr, ushort val)
{
    int key;

    key = intLock();


    save_sp_config();
    sp_config();
 /* the following piece of code which swaps the addr bytes fixes the IXP2400 
   slow port write bug.This routine should not be called in the B0 silicon */    
    if(getProductID(MAJ_REV) ==0) /*A1 silicon*/
    {
        if ((ulong)addr & 0x2)                                                  
            (ulong) addr &= 0xFFFFFFFD;
        else
            (ulong) addr |= 0x00000002;
    }
   
    *addr = val;
    restore_sp_config();

    intUnlock(key);

    return bb_NO_ERROR;
}

#endif /* SLOW_PORT */  

