/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: gdvaddad $
*   DATE:           $Date: 2003/02/15 01:56:40 $
*   LAST MODIFIED:  $Modtime: 5/14/02 4:06p $
*   REV#:           $Revision: 1.4 $
*   LOGFILE:        $Logfile:  $
*   WORKFILE:       $Workfile: ixf_api.c $
*
* --------------------------------------------------------------------------
* Project: Angel Island
*
* Purpose: Provides the implementation to the common API for IXF chips.
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: sp.c,v $
*   Revision 1.4  2003/02/15 01:56:40  gdvaddad
*   b0 fixes ai_phase7
*
*   Revision 1.3  2002/10/25 20:24:49  machambe
*   no message
*
* --------------------------------------------------------------------------
*/
#include <vxWorks.h>
#include <stdio.h>

#define CCR 	0xc0080000
#define WTC1 	0xc0080004
#define WTC2 	0xc0080008
#define RTC1 	0xc008000c
#define RTC2 	0xc0080010
#define PCR 	0xc0080018
#define ADC		0xc008001c
#define FAC		0xc0080020
#define FIN		0xc0080028

unsigned long appl_ccr;
unsigned long appl_wtc1;
unsigned long appl_wtc2;
unsigned long appl_rtc1;
unsigned long appl_rtc2;
unsigned long appl_pcr;
unsigned long appl_adc;
unsigned long appl_fac;
unsigned long appl_fin;

void sp_config(void)
{

    unsigned long *ptr = (unsigned long *) CCR;
    *ptr = 5;

    ptr = (unsigned long *) WTC2;
    *ptr = 0x91;

    ptr = (unsigned long *) RTC2;
    *ptr = 0x91;

    ptr = (unsigned long *) PCR;
    *ptr = 0x3;

    ptr = (unsigned long *) ADC;
    *ptr = 0x13;

    ptr = (unsigned long *) FAC;
    *ptr = 0x2;

}

void save_sp_config(void)
{
    unsigned long *ptr = (unsigned long *) CCR;
    appl_ccr = *ptr;
    ptr = (unsigned long *) WTC1;
    appl_wtc1 = *ptr;
    ptr = (unsigned long *) WTC2;
    appl_wtc2 = *ptr;
    ptr = (unsigned long *) RTC1;
    appl_rtc1 = *ptr;
    ptr = (unsigned long *) RTC2;
    appl_rtc2 = *ptr;
    ptr = (unsigned long *) PCR;
    appl_pcr = *ptr;
    ptr = (unsigned long *) ADC;
    appl_adc = *ptr;
    ptr = (unsigned long *) FAC;
    appl_fac = *ptr;
}

void restore_sp_config(void)
{

    unsigned long *ptr = (unsigned long *) CCR;
    *ptr = appl_ccr;

    ptr = (unsigned long *) WTC1;
    *ptr = appl_wtc1;

    ptr = (unsigned long *) WTC2;
    *ptr = appl_wtc2;

    ptr = (unsigned long *) RTC1;
    *ptr = appl_rtc1;

    ptr = (unsigned long *) RTC2;
    *ptr = appl_rtc2;

    ptr = (unsigned long *) PCR;
    *ptr = appl_pcr;

    ptr = (unsigned long *) ADC;
    *ptr = appl_adc;

    ptr = (unsigned long *) FAC;
    *ptr = appl_fac;

}


int compare_sp_config(void)
{

    int flag = 1;
    unsigned long *ptr = (unsigned long *) CCR;

    if (*ptr != 0x00000003)
    {
        flag = 0;
    }
    ptr = (unsigned long *) WTC2;
    if (*ptr != 0x000000091)
    {
        flag = 0;
    }

    ptr = (unsigned long *) RTC2;
    if (*ptr != 0x000000091)
    {
        flag = 0;
    }

    ptr = (unsigned long *) PCR;
    if (*ptr != 0x00000003)
    {
        flag = 0;
    }

    ptr = (unsigned long *) ADC;
    if (*ptr != 0x00000013)
    {
        flag = 0;
    }

    ptr = (unsigned long *) FAC;
    if (*ptr != 0x00000002)
    {
        flag = 0;
    }

    return flag;
}
