/***************************************************************************
*
* Module:      vdiag.h
*
* Description: vWare Diagnostic Executive Header File 
*
* Project:     EST VisionWare -- vWare
*
* Notes:        
*
* History:      See Visual SourceSafe History
*
* Disclaimer:    Copyright (c) 1995, 2000, EST Corporation
*    This program is confidential and proprietary to EST Corporation
*  and, without the express prior written permission of an officer of
*  EST Corporation, may not be copied, reproduced, disclosed to others
*  published  or  used, in  whole or in part, for any purpose other than
*  that for which it is being  made available. This program is protected
*  pursuant to applicable copyright laws, including the U.S. Copyright Act.
*  This program is to be returned to EST Corporation upon the earlier of
*  demand and the accomplishment of the purpose for which it was provided.
****************************************************************************/

#ifndef _VDIAGH_			    
#define _VDIAGH_

#ifdef __cplusplus
extern "C" {
#endif

//  Includes
#include "vm.h"



//  Defines

#define STRING_MATCH 0

#define ENABLE    TRUE
#define DISABLE  !ENABLE


#define ENDLOOP         2000
#define ERROR_FILE      "ErrorLog.txt"
#define DEFAULT_CMD_FILE  "vDiag.cmd"

// Macros


// Edit Commands

#ifndef CR
#define CR 0x0d
#endif

#ifndef LF
#define LF 0x0a
#endif

#ifndef LTERM              // visionClick does not return LF/CR ???
#define LTERM NULL         
#endif

#define VW_CONSOLE_AVAIL_FOR_LOGGING  1
#define VW_AVAIL_FOR_LOGGING  2

//  Prototypes

void vdiag(void *pIn, void *pOut);
BOOL vdgIsErrorLogging(BOOL state);
void vdgErrorLogging(BOOL enableErrorLogging);
BOOL vdgIsConsoleErrorLogging(BOOL state);
void vdgConsoleErrorLogging(BOOL enableErrorLogging);
BOOL vdgIsFileErrorLogging(BOOL state);
void vdgFileErrorLogging(BOOL enableErrorLogging);
BOOL vdgIsVerboseMode(BOOL state);
void vdgVerboseMode(BOOL enableVerbose);
BOOL vdgIsHaltOnError(BOOL state);
void vdgHaltOnError(BOOL enableHaltOnError);

#ifdef __cplusplus
}
#endif

#endif  /* _VDIAGH_ */
