/* vdlog.h - Log Header */

/* Copyright 1984-1999 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,25jan02, pgp  created
01b,06feb02, pgp  Removed Function name from log
*/

/*
DESCRIPTION

Logging Header File

INCLUDE FILES:
*/

#ifndef __INCvdlogh
#define __INCvdlogh

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*  includes */


/* forward declartions */

void vdLog( char * log, char * filename, UINT32 lineNo, UINT32 param_a, UINT32 param_b );

/* defines */

/* VWARE_PARAMS_BEGIN */
#define	LOG_ENBL		ON		/* Logging Enabled	CHOICE	ON|OFF */
#define LOG_ENTRIES	50			/* Number of Log Entries	UINT32 */
#define MAX_FILE_NAME	20		/* Max File Name Length	UINT32 */
#define MAX_LOG_LGTH	3500	/* Max Log String Length	UINT32 */
/* VWARE_PARAMS_END */

/* VFILE_PARAMS_BEGIN */
#ifdef FFS_ON
#define LOG_FILENAME	"Log.txt"			/* Log FFS Filename STRING */
#endif
/* VFILE_PARAMS_END */

#if (LOG_ENBL==ON)
#define  vLOG(log,paramA,paramB) \
			vdLog (log, __FILE__, __LINE__, (UINT32)paramA, (UINT32)paramB)
#else
#define  vLOG(logNum,paramA,paramB)
#endif

/* typedefs */

typedef struct log				/* LOG - Log Type */
	{
	UINT32      idx;							/* Log Index */
	UINT8       fileName[MAX_FILE_NAME];		/* File Name */
	UINT32      line;							/* Line Number */
	UINT8       log[MAX_LOG_LGTH];				/* Max Log Length */
	UINT32      param_a;						/* Parameter A */
	UINT32      param_b;						/* Parameter B */
	} LOG;

/* locals */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __INCvdlogh */	   
