#include "vm.h"
#include "cmd.h"

/////////////////////////////////////////
// Input Structure for Diagnostic
/////////////////////////////////////////

typedef struct _mcmpIn
{
	UINT32 nSizeSuffix; // Size Suffix
	UINT32	Address;	// Address in memory for compare
	UINT32	Value;	// Value to compare
} mcmpIn;

/////////////////////////////////////////
// Definition for mcmp Diagnostic
/////////////////////////////////////////

void memCompare(mcmpIn* pIn, void* pOut)
{
	UINT32	*pMem;
	UINT32	Status;

	pMem = (UINT32 *)pIn->Address;

	switch(pIn->nSizeSuffix)
	{
		case 1:
			Status = (*(UINT8 *)pMem == pIn->Value);
			break;
		case 2:
			Status = (*(UINT16 *)pMem == pIn->Value);
			break;
		case 4:
			Status = (*(UINT32 *)pMem == pIn->Value);
			break;
		default:
			Result(2, "unsupported width");
			return;
	}

	if (Status)
		Result(0, "Same");
	else
		Result(1, "Different");
}

Command(CMD_MCMP,"mcmp",memCompare,SIZESUFFIX|DIAGNOSTIC,"memCompare","memory compare");
Arg(UINT32ARG,"address","address in memory for compare");
Arg(UINT32ARG,"value","value to compare");
CommandEnd();