/******************************************************************************
*
* Module: eed.h
*
* Description: Ethernet Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __EED_H__
#define __EED_H__

#include "estdriver.h"
#include "estack.h"
#include "shell.h"
#include "eedriver.h"
#include "allocunits.h"

class EED : public ESTDriver
{
public:
	EED();
	
	DSTATUS Open(HANDLE *pHandle, void *pArgs = 0);
	DSTATUS Close(HANDLE dev);
	DSTATUS Write(HANDLE dev, char *buffer, unsigned int nBytes);
	DSTATUS Ioctl(HANDLE dev, unsigned int funcCode, void *pArgs);
	UINT8 *GetTxBuffer(UINT32 Length);
	void FreeBuffer(UINT8 *pData);
	void AssignBuffer(UINT8 *pData, UINT32 ID);
	void Send(UINT8 *, UINT32);
	void Send(UINT8 *, UINT32, UINT8 *, UINT32);
	void Send(UINT8 *, UINT32, UINT8 *, UINT32, UINT8 *, UINT32);
	HANDLE hDevice;

protected:
	void *pAllocationUnits, *pAllocationUnitsEnd, *pNextAllocationUnit;
};

#endif			// #ifdef __EED_H__
