/***************************************************************************
*
* Module:		eedriver.h
*
* Description:  vWare spec ethernet driver interface
*
* Project:		HSI VisionWare -- vWare
*
* Notes:
*
* History:      See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/

#ifndef _EEDRIVER_H_
#define _EEDRIVER_H_

#include "estdriver.h"

#ifdef __cplusplus
extern "C" {
#endif

//  Includes
#include "estack.h"

//  Defines
#define	STATUS_OK		0
#define NOT_IMPLEMENTED	1

// Typedefs
typedef struct tEEDRIVER
{
	HANDLE (*Open)(struct tEEDRIVER *);
	DSTATUS (*Close)(HANDLE);
	DSTATUS (*Write)(HANDLE, UINT8 *, unsigned int, UINT8 *, unsigned int, UINT8 *, unsigned int);
	DSTATUS (*Ioctl)(HANDLE, int, void *);
	int (*IsFreeBuffer)(HANDLE, UINT32);
} tEEDRIVER;

typedef HANDLE (*EEDRIVEROpen)(struct tEEDRIVER *);
typedef DSTATUS (*EEDRIVERClose)(HANDLE);
typedef DSTATUS (*EEDRIVERWrite)(HANDLE, UINT8 *, unsigned int, UINT8 *, unsigned int, UINT8 *, unsigned int);
typedef DSTATUS (*EEDRIVERIoctl)(HANDLE, int, void *);
typedef DSTATUS (*EEDRIVERIsFreeBuffer)(HANDLE, UINT32);

//  Prototypes
extern void EedriverAssignBuffer(UINT8 *, UINT32);
extern void EedriverFreeBuffer(UINT8 *);
extern void EedriverProcessPacket(UINT8 *, unsigned int);

#ifdef __cplusplus
}
#endif

#endif  /* _EEDRIVER_H_ */
