/******************************************************************************
*
* Module: esdriver.h
*
* Description: vWARE Serial Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef _ESDRIVER_H_				
#define _ESDRIVER_H_

#include "estdriver.h"

#ifdef __cplusplus
extern "C" {
#endif

//  Includes

//  Defines
#define	STATUS_OK		0
#define NOT_IMPLEMENTED	1

#include "vTypes.h"

// Typedefs
//typedef int DSTATUS;

typedef struct tESDRIVER
{
	HANDLE (*Open)(struct tESDRIVER *);
	DSTATUS (*Close)(HANDLE);
	DSTATUS (*Write)(HANDLE, UINT8 *, unsigned int);
	DSTATUS (*Ioctl)(HANDLE, int, void *);
} tESDRIVER;

typedef HANDLE (*ESDRIVEROpen)(struct tESDRIVER *);
typedef DSTATUS (*ESDRIVERClose)(HANDLE);
typedef DSTATUS (*ESDRIVERWrite)(HANDLE, UINT8 *, unsigned int);
typedef DSTATUS (*ESDRIVERIoctl)(HANDLE, int, void *);

//  Prototypes
void EsdriverProcessCharacters(UINT8 *pBuffer, UINT32 chars);

#ifdef __cplusplus
}
#endif

#endif  /* _ESDRIVER_H_ */
