/******************************************************************************
*
* Module: estdriver.h
*
* Description: Driver Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __ESTDRIVER__
#define __ESTDRIVER__

// Typedefs
typedef int DSTATUS;

// Return Codes
#define	STATUS_OK		0
#define NOT_IMPLEMENTED	1

// Used by child drivers to add more return 
// codes to the end of the basics
#define END_OF_RETURN_CODES	20

#define DEFAULTSERIAL	0
#define DEFAULTETHERNET	1
#define DEFAULTTMD		2

/////////////////////////////////////////////////////////////////////////////
// ESTDriver Class
#ifdef __cplusplus

class ESTDriver
{
protected:
	unsigned int OpenCount;

public:
	ESTDriver();		// standard constructor

	virtual DSTATUS Open(HANDLE *pHandle, void *pArgs=0);
	virtual DSTATUS Close(HANDLE dev);

	virtual DSTATUS Read(HANDLE dev, char *buffer, unsigned int nBytes, unsigned int *BytesRead);
	virtual DSTATUS Peek(HANDLE dev, char *buffer, unsigned int nBytes, unsigned int *BytesRead);
	virtual DSTATUS Write(HANDLE dev, char *buffer, unsigned int nBytes);
	
	virtual DSTATUS Ioctl(HANDLE dev, unsigned int funcCode, void *pArgs);

};

extern void ConsoleInit(ESTDriver *);
extern ESTDriver *pCommandChannel;
extern ESTDriver *pDataChannel;
extern void *hCommandChannel;
extern void *hDataChannel;
extern int DefaultCommandChannel(void);

#endif		// __cplusplus
#endif		// __ESTDRIVER__
