/******************************************************************************
*
* Module:		pci.h
*
* Description: GENERIC PCI Access Definitions (architecture non-specific???)
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __PCI_H__
#define __PCI_H__

//  Includes
#include "pcihdr.h"
#include "pciconfiglib.h"

#define	ON	1
#define OFF	2

// VPCI_PARAMS_BEGIN
#define PCI_AUTO		ON		// PCI Auto Config ON/OFF	CORE|CHOICE		ON	OFF
// VPCI_PARAMS_END	

#if (PCI_AUTO == ON)
#define PCI_AUTO_ON
#else
#undef PCI_AUTO_ON
#endif

typedef enum reg_size {
    REG_8BIT  = 1,
    REG_16BIT = 2,
    REG_32BIT = 4
} REG_SIZE;

#ifdef PCI_AUTO_ON
  #include "pciautoconfig.h"
#endif

#if 0
typedef struct pciloc {
    short	bus;
    char	dev;
    char	func;
    USHORT	cfg;
    USHORT	intrVec;	/* Interrupt vector          */
    ULONG	dev_vend;
    ULONG	hdrType;
    ULONG	hostBridge;	/* Host/PCI bridge number    */
    UCHAR	class;
    UCHAR	subclass;
} PCI_LOC;
#endif

UINT32	PciPrimaryPCIInit();
UINT32	PciSecondaryPCIInit();
void	PciCfgWrite(UINT32 PciDevice, UINT32 Offset, UINT32 Data, int Size);
UINT32	PciCfgRead(UINT32 PciDevice, UINT32 Offset, int Size);
UINT32	PciEncode(unsigned int BusNumber, unsigned int DeviceNumber, unsigned int Function);
void	PciWrite32(UINT32 Reg, UINT32 Data);
void	PciWrite16(UINT32 Reg, UINT16 Data);
void	PciWrite8(UINT32 Reg, UINT8 Data);
UINT32	PciRead32(UINT32 Reg);
UINT16	PciRead16(UINT32 Reg);
UINT8	PciRead8(UINT32 Reg);

#ifdef PCI_AUTO_ON
void	PciCfgWriteX(PCI_LOC *pci_loc, ULONG offset, ULONG wdata, REG_SIZE regSize);
ULONG	PciCfgReadX(PCI_LOC *pci_loc, ULONG offset, REG_SIZE regSize);
ULONG	PciCfgProbeRead(PCI_LOC * pci_loc, ULONG byteOffset);
#endif


#define PciCfgWrite32(Device, Offset, Data)	PciCfgWrite(Device, Offset, Data, 4)
#define PciCfgWrite16(Device, Offset, Data)	PciCfgWrite(Device, Offset, Data, 2)
#define PciCfgWrite8(Device, Offset, Data)	PciCfgWrite(Device, Offset, Data, 1)
#define PciCfgRead32(Device, Offset)		PciCfgRead(Device, Offset, 4)
#define PciCfgRead16(Device, Offset)		PciCfgRead(Device, Offset, 2)
#define PciCfgRead8(Device, Offset)			PciCfgRead(Device, Offset, 1)

#endif				// #ifndef __PCI_H__

