/* pciHeaderDefs.h - PCI bus config space header definitions */

/* Copyright 1984-1998 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,04mar98,tm   adapted from pciIomapLib.h v01j
*/

#ifndef __INCpciHeaderDefsh
#define __INCpciHeaderDefsh

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _ASMLANGUAGE

/* structure for the device & bridge header */

typedef struct pciHeaderDevice
    {
    UINT16	vendorId;	/* vendor ID */
    UINT16	deviceId;	/* device ID */
    UINT16	command;	/* command register */
    UINT16	status;		/* status register */
    char	revisionId;	/* revision ID */
    char	classCode;	/* class code */
    char	subClass;	/* sub class code */
    char	progIf;		/* programming interface */
    char	cacheLine;	/* cache line */
    char	latency;	/* latency time */
    char	headerType;	/* header type */
    char	bist;		/* BIST */
    UINT32		base0;		/* base address 0 */
    UINT32		base1;		/* base address 1 */
    UINT32		base2;		/* base address 2 */
    UINT32		base3;		/* base address 3 */
    UINT32		base4;		/* base address 4 */
    UINT32		base5;		/* base address 5 */
    UINT32		cis;		/* cardBus CIS pointer */
    UINT16	subVendorId;	/* sub system vendor ID */
    UINT16	subSystemId;	/* sub system ID */
    UINT32		romBase;	/* expansion ROM base address */
    UINT32		reserved0;	/* reserved */
    UINT32		reserved1;	/* reserved */
    char	intLine;	/* interrupt line */
    char	intPin;		/* interrupt pin */
    char	minGrant;	/* min Grant */
    char	maxLatency;	/* max Latency */
    } PCI_HEADER_DEVICE;

typedef struct pciHeaderBridge
    {
    UINT16	vendorId;	/* vendor ID */
    UINT16	deviceId;	/* device ID */
    UINT16	command;	/* command register */
    UINT16	status;		/* status register */
    char	revisionId;	/* revision ID */
    char	classCode;	/* class code */
    char	subClass;	/* sub class code */
    char	progIf;		/* programming interface */
    char	cacheLine;	/* cache line */
    char	latency;	/* latency time */
    char	headerType;	/* header type */
    char	bist;		/* BIST */
    UINT32		base0;		/* base address 0 */
    UINT32		base1;		/* base address 1 */
    char	priBus;		/* primary bus number */
    char	secBus;		/* secondary bus number */
    char	subBus;		/* subordinate bus number */
    char	secLatency;	/* secondary latency timer */
    char	ioBase;		/* IO base */
    char	ioLimit;	/* IO limit */
    UINT16	secStatus;	/* secondary status */
    UINT16	memBase;	/* memory base */
    UINT16	memLimit;	/* memory limit */
    UINT16	preBase;	/* prefetchable memory base */
    UINT16	preLimit;	/* prefetchable memory limit */
    UINT32		preBaseUpper;	/* prefetchable memory base upper 32 bits */
    UINT32		preLimitUpper;	/* prefetchable memory base upper 32 bits */
    UINT16	ioBaseUpper;	/* IO base upper 16 bits */
    UINT16	ioLimitUpper;	/* IO limit upper 16 bits */
    UINT32		reserved;	/* reserved */
    UINT32		romBase;	/* expansion ROM base address */
    char	intLine;	/* interrupt line */
    char	intPin;		/* interrupt pin */
    UINT16	control;	/* bridge control */
    } PCI_HEADER_BRIDGE;

#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCpciHeaderDefsh */
