/******************************************************************************
*
* Module: circular.h
*
* Description: Stack Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __CIRCULAR_H__
#define __CIRCULAR_H__

typedef struct
{
	UINT8 *pFirst;
	UINT8 *pEnd;
	UINT8 *pRead;
	UINT8 *pWrite;
	UINT8 *pAckked;
	UINT16 Size;
	UINT16 Flags;
} CIRCULARBUFFER;

#define WRAPFLAG	1
// wrap flag is set when the write pointer wraps around;
// and cleared when the read pointer wraps around

global void cbInit(CIRCULARBUFFER *pCB, UINT8 *pBuffer, UINT32 Size);
global void cbClear(CIRCULARBUFFER *pCB);
global UINT32 cbBytesUnackked(CIRCULARBUFFER *pCB);
global UINT32 cbAck(CIRCULARBUFFER *pCB, UINT32 n);
global UINT32 cbBytesFree(CIRCULARBUFFER *pCB);
global UINT32 cbBytesUsed(CIRCULARBUFFER *pCB);
global UINT32 cbContiguousReadBytes(CIRCULARBUFFER *pCB, UINT8* pData);
global UINT32 cbWrite(CIRCULARBUFFER *pCB, UINT8 *pBuffer, UINT32 nBytes);
global void cbDiscard(CIRCULARBUFFER *pCB, UINT32 nBytes);
global UINT32 cbRead(CIRCULARBUFFER *pCB, UINT8 *pBuffer, UINT32 nBytes);

#endif			// __CIRCULAR_H__