/******************************************************************************
*
* Module: daemon.h
*
* Description: Stack Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __DAEMON_H__
#define __DAEMON_H__

#include "estack.h"
#include "eed.h"

extern "C" void BlockTimers(void);
extern "C" void AllowTimers(void);

#define BufferMyMAC()		BufferCpy(&MyMAC, sizeof(MAC))
#define BufferMyIPADDR()	BufferWord(MyIPADDR)
#define BufferIPADDR(x)		BufferWord(x)
#define BufferMAC(x)		BufferCpy(x, sizeof(MAC))

class daemon
{
protected:
	UINT8 *TxBuffer;
	UINT8 *TxBufferPtr;
public:
	daemon(UINT8 Protocol, UINT16 TargetPort, UINT8 Flags);
	~daemon();
	ESTACKEVENT EthernetEvent;
	static EED *EthernetDriver;
	virtual void Vector(void *v, UINT32 Length) = 0;
	void DefaultVector(void *v, UINT32 Length);
	UINT8 *GetTxBuffer(MAC *TargetMAC, UINT32 Protocol, UINT32 Length);
	void SendTxBuffer(void);
	void SendInPlace(UINT8 *pBuffer, UINT32 Length);
	void BufferByte(UINT8);
	void BufferHalfword(UINT16);
	void BufferWord(UINT32);
	void BufferCpy(void *, UINT32);
	void InstallEvent(ESTACKEVENT *pE);
	void RemoveEvent(ESTACKEVENT *pE);
};

#endif			// #ifdef __DAEMON_H__