/******************************************************************************
*
* Module: daemons.h
*
* Description: Stack Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __DAEMONS_H__
#define __DAEMONS_H__

#include "daemon.h"
#include "ip.h"

class ArpRequestClass : public daemon
{
public:
	ArpRequestClass(UINT8 Protocol, UINT16 TargetPort, UINT8 Flags);
	void Vector(void *v, UINT32 Length);
};

typedef union
{
	ETHERNETPACKET *pEthernet;
	ARPPACKET *pARP;
	UINT8 *pByte;
	void *pVoid;
} ARPUNION;

class EchoReplyClass : public IPSocket
{
	TIMEOUT EchoTimer;
public:
	EchoReplyClass(UINT8 Protocol, UINT16 TargetPort, UINT8 Flags);
	void Receive(void *v, UINT32 Length);
	void Timeout(TIMEOUT *);
	void ping(IPADDR TargetIP, UINT32 Count);
	volatile UINT32 State;
};

class EchoRequestClass : public IPSocket
{
public:
	EchoRequestClass(UINT8 Protocol, UINT16 TargetPort, UINT8 Flags);
	void Receive(void *v, UINT32 Length);
};

#endif			// #ifndef __DAEMONS_H__