/******************************************************************************
*
* Module: estackobjects.c
*
* Description: Stack Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#include "vm.h"
#include "daemons.h"
#include "cmd.h"
#include "tcp.h"
#include "shell.h"

ArpRequestClass ArpRequestDaemon(99, 1, 0);
EchoReplyClass EchoReplyDaemon(1, 0, 0);
EchoRequestClass EchoRequestDaemon(1, 8, 0);

typedef struct in_ping
{
	IPADDR IP;
	UINT32 Count;
} in_ping;

extern "C" void Ping(in_ping *pIn, void *pOut)
{
	EchoReplyDaemon.ping(pIn->IP, pIn->Count);
}

Command(CMD_PING, "ping", Ping, 0, "", "ping a remote system");
Arg(IPARG, "target", "");
OptArg(UINT32ARG, "count", "", 1);
CommandEnd();

TelnetClass Port1234Daemon(6, 1234, 0, 4096, 1024, TCPSTATE_LISTEN);
TelnetClass Port1235Daemon(6, 1235, 0, 4096, 4096, TCPSTATE_LISTEN);
TelnetClass Port1236Daemon(6, 1236, 0, 4096, 4096, TCPSTATE_LISTEN);

