/******************************************************************************
*
* Module: tftp.h
*
* Description: TFTP Module Definitions
*
* Project:     HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*	BL - Added TFTPSTATE_SEQERROR
*
* Disclaimer: Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __TFTP_H__
#define __TFTP_H__

#include "udp.h"

#define ERRORMSGSIZE	64

extern UINT32 ProcessMode;

enum
{
	TFTPERROR_SERVERABORT = FIRST_STACK_ERROR
};
	 
enum TFTPSTATE
{
	TFTPSTATE_CLOSED,
	TFTPSTATE_GOTMAC,
	TFTPSTATE_ARPTIMEOUT,
	TFTPSTATE_WORKING,
	TFTPSTATE_COMPLETE,
	TFTPSTATE_TIMEDOUT,
	TFTPSTATE_WRITEPROTECT,
	TFTPSTATE_FILEERROR,
	TFTPSTATE_SERVERERROR,
	TFTPSTATE_SEQERROR
};

class TFTPClient : public UDPSocket
{
private:
	UINT32 BlockSize;
	UINT16 LastBlock;
	UINT16 EOF;
	UINT16 Tries;
	TIMEOUT t;
	UINT32 (*DataVector)(UINT8 *pBuffer, UINT32 Length);
	UINT8 Buffer[516];
	void SendBlock(void);
	void PrepareForTransfer(UINT32 HostIP, UINT8 *Filename, UINT16 Opcode);

public:
	TFTPClient(UINT8 Protocol, UINT16 TargetPort, UINT8 Flags, UINT16 LocalPort);
	void Vector(UDPPACKET *pUDP, UINT8 *pData, UINT32 DataLength);
	void GetFile(IPADDR HostIP, UINT8 *Filename, UINT32 (*Vec)(UINT8 *, UINT32));
	void PutFile(IPADDR HostIP, UINT8 *Filename);
	void Ack(UINT16 BlockNumber);
	void Send(UINT8 *pData1 = 0, UINT32 Length1 = 0, UINT8 *pData2 = 0, UINT32 Length2 = 0);
	volatile TFTPSTATE State;
	HANDLE Handle;
	void Timeout(TIMEOUT *p);
	FFS *pFfs;
	UINT32 ErrorCode;
	char ErrorMsg[ERRORMSGSIZE];
};

#endif			// #ifndef __TFTP_H__
