/* vFlashLib.c - boot Flash File System */

/* Copyright 2001-2002 Wind River Systems, Inc. */

/*
 * DESCRIPTION
 * This library is the Flash File System entry point to connect from an external application.
 */

#define YES	1
#define NO	0
/* VWARE_PARAMS_BEGIN */
#define	vFLASH_EXT_INTERFACE		NO		/* Expose API	CHOICE	NO|YES */
/* VWARE_PARAMS_END */

#if vFLASH_EXT_INTERFACE
/* includes */

#define __VFLASHLIB_C__

#include "vm.h"
#include "ffs.h"
#include "vFlashLib.h"

void dir(char *pIn, void *pOut);

FFSFF pFF;

/**************************************************************************
*
* vFlashCreate - create a file on the Flash File System
*
* This routine creates a file whose name is passed as parameter on the
* Flash File System.
*
* RETURNS: Handle to the created file.
*/

UINT32 vFlashCreate
	(
	char *	name	/* file name to create */  
	)
	{
	return (UINT32) CreateFile (name, 0xffffffff & ~ATTRIBTYPE, 0xffffffff, 0xffffffff);
	} 

/**************************************************************************
*
* vFlashLs - Print a directory of the Flash File System
*
* RETURNS: Zero
*/

int vFlashLs
	(
	unsigned char *	dirMask		/* directory mask */  
	)
	{
	dir(dirMask, NULL);
	return 0;
	} 

/*  Define BSD compatible functions  */
VWARELIB (FLASHLIB_OPEN,		OpenFile,		"UINT32 vFlashOpen(char *)");
VWARELIB (FLASHLIB_CLOSE,		CloseFile,		"UINT32 vFlashClose(UINT32)");
VWARELIB (FLASHLIB_READ,		ReadFile,		"UINT32 vFlashRead(UINT32, UINT32, UINT8 *, UINT32, UINT32 *)");
VWARELIB (FLASHLIB_WRITE,		WriteFile,		"UINT32 vFlashWrite(UINT32, UINT8 *, UINT32, UINT32 *)");
VWARELIB (FLASHLIB_STAT,		Filesize,		"UINT32 vFlashStat(UINT32)");
VWARELIB (FLASHLIB_LS,			vFlashLs,		"int vFlashLs(unsigned char *)");
VWARELIB (FLASHLIB_CREATE,		vFlashCreate,	"UINT32 vFlashCreate(char *)");
VWARELIB (FLASHLIB_DELETE,		DeleteFile,		"UINT32 vFlashDelete(char *)");

/*  Define additional functionality  */
VWARELIB(FLASHLIB_VF_FORMAT,	Format,			"UINT32 vfFormat(void)");
VWARELIB(FLASHLIB_VF_CREATE,	CreateFile, 	"HANDLE vfCreateFile(char *, UINT32, UINT32, UINT32)");
VWARELIB(FLASHLIB_VF_OPEN,		OpenFile,		"HANDLE vfOpenFile(char *)");
VWARELIB(FLASHLIB_VF_FINDFIRST,	FindFirst,		"UINT32 vfFindFirst(FFSFF *, char *)");
VWARELIB(FLASHLIB_VF_FINDNEXT,	FindNext,		"UINT32 vfFindNext(FFSFF *, char *)");
VWARELIB(FLASHLIB_VF_CLOSE,		CloseFile,		"UINT32 vfCloseFile(HANDLE)");
VWARELIB(FLASHLIB_VF_ABORT,		AbortFile,		"UINT32 vfAbortFile(HANDLE)");
VWARELIB(FLASHLIB_VF_READ,		ReadFile, 		"UINT32 vfReadFile(HANDLE, UINT32, UINT8 *, UINT32, UINT32 *)");
VWARELIB(FLASHLIB_VF_WRITE,		WriteFile,		"UINT32 vfWriteFile(HANDLE, UINT8 *, UINT32, UINT32 *)");
VWARELIB(FLASHLIB_VF_DELETE,	DeleteFile,		"UINT32 vfDeleteFile(char *)");
VWARELIB(FLASHLIB_VF_GETERR,	GetLastError,	"UINT32 vfGetLastError(void)");
VWARELIB(FLASHLIB_VF_DECODE,	Decode,			"FFSFRAGMENT *vfDecode(UINT32)");
VWARELIB(FLASHLIB_VF_BLOCKSIZE,	BlockSize,		"UINT32 vfBlockSize(void)");
VWARELIB(FLASHLIB_VF_NUMBLKS,	NumberOfBlocks,	"UINT32 vfNumberOfBlocks(void)");
VWARELIB(FLASHLIB_VF_RESULT,	FfsResult,		"void vfFfsResult(char *)");
VWARELIB(FLASHLIB_VF_SIZE,		Filesize,		"UINT32 vfFilesize(HANDLE)");

#endif
