/****************************************************************************
*
* Module:       cmds.h
*
* Description:  Command number assignments for intrinsic vWare commands
*
* Project:      HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:      See Visual SourceSafe History
*
* Disclaimer:   Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __CMDS_H__
#define __CMDS_H__

/****************************************************************************
 * Register & Memory Commands (CMDGROUP_VWARE)                              *
 ***************************************************************************/
enum
{
    CMD_MAIN = MAKECMD(CMDGROUP_VWARE, 1),
    CMD_DM,
    CMD_SM,
    CMD_MM,
    CMD_MMAP,
    CMD_DR,
    CMD_SR,
    CMD_RESET,
    CMD_READ_LOG_LONG,
    CMD_READ_LOG_SHORT,
    CMD_CLEAR_LOG,
    CMD_LOG_CNT
};

/****************************************************************************
 * Execution Commands (CMDGROUP_VMON)                                       *
  **************************************************************************/
enum
{
    CMD_SI = MAKECMD(CMDGROUP_VMON, 1),
    CMD_SIDR,
    CMD_FS,
    CMD_GO,
    CMD_HALT,
    CMD_DLBU,
    CMD_DNBU,
    CMD_DLBT,
    CMD_DLBS,
    CMD_LAUNCH,
	CMD_VXBOOT
};

/****************************************************************************
 * File Commands (CMDGROUP_VFILE)                                           *
 ***************************************************************************/
enum
{
    CMD_CREATE = MAKECMD(CMDGROUP_VFILE, 1),
    CMD_WRITE,
    CMD_OPEN,
    CMD_DEL,
    CMD_DIR,
    CMD_CLOSE,
    CMD_READ,
    CMD_SAVE,
    CMD_COPY,
    CMD_LOAD,
    CMD_FORMAT,
    CMD_PUT,
    CMD_TYPE,
    CMD_COPYCON,
    CMD_LOG_TO_FFS
};

/****************************************************************************
 * Flash Commands (CMDGROUP_VFLASH)                                         *
 ***************************************************************************/
enum
{
    CMD_ERASE = MAKECMD(CMDGROUP_VFLASH, 1),
    CMD_TFERASE,
    CMD_SF,
    CMD_BOOTERASE,
	CMD_COPYTOFLASH
};

/****************************************************************************
 * Flash Commands (CMDGROUP_VSTACK)                                         *
 ***************************************************************************/
enum
{
    CMD_ETHERNET = MAKECMD(CMDGROUP_VSTACK, 1),
    CMD_PING,
    CMD_OS
};

/****************************************************************************
 * Console Commands (CMDGROUP_VCONSOLE)                                     *
 ***************************************************************************/
enum
{
    CMD_UPDATE = MAKECMD(CMDGROUP_VCONSOLE, 1),
    CMD_LINK,
    CMD_SHELL,
    CMD_HELP,
    CMD_DC,
    CMD_DNBT,
    CMD_BR,
    CMD_PRINT,
    CMD_TIME,
    CMD_SERIAL,
    CMD_HE,
    CMD_COMPONENTS,
    CMD_WAITFORKEY,
    CMD_HISTORY,
    CMD_REPEAT,
    CMD_SHELLHIDE,
	CMD_TMD
};

/****************************************************************************
 * General Diagnostics                                                      *
 ***************************************************************************/
enum
{
    CMD_CLICK = MAKECMD(CMDGROUP_VDIAG, 1),
    CMD_CRC,
    CMD_LOOP,
    CMD_DRY,
    CMD_TDF1,
    CMD_TDF2,
    CMD_TDF3,
    CMD_TDF4,
    CMD_TDF5,
    CMD_TDF6,
    CMD_BURST,
    CMD_VDIAG,
    CMD_MCMP,
    CMD_FLASH,
    CMD_LOCK,
    CMD_UNLOCK,
    CMD_TDF7,
    CMD_MEMCOPY,
    CMD_MEMSCAN1,
    CMD_MEMSCAN2,
    CMD_MEMFILL,
    CMD_MEMBLKCMP,
    CMD_EEPROM,
    CMD_RUNALT,
    CMD_LEDCTRL,
    CMD_RUNALLON,
    CMD_RUNHIGH,
    CMD_RUNLOW,
    CMD_RUNUPLOW,
    CMD_RUNSTAIRS,
    CMD_FLASHLED,
    CMD_SDRAM,
    CMD_PCI,
    CMD_OMCT,
    CMD_PCM,
    CMD_ATMVER,
    LED_TEST1,
    LED_TEST2,
    LED_TEST3,
    LED_TEST4,
    LED_TEST5,
    LED_TEST6,
    LED_TEST7,
    CMD_TDMVER,
    CMD_TDM,
    CMD_ATM,
    CMD_Test,
    CMD_Digit,
    CMD_CAN_Loopback,  
    CMD_CAN_Receive,
    CMD_CAN_Transmit,
    CMD_hdlc,
    CMD_IrDA_Console,
    CMD_IrDA_Echo,
    CMD_IrDA_Loopback,
    CMD_IrDA_Receive,
    CMD_IrDA_Transmit,
    CMD_ARMLCD,
    CMD_860,
    CMD_TDF860,
    CMD_CACHETEST,
    CMD_MMU,
    CMD_PRINT_ALL_MEM_SETTINGS,
    CMD_PRINT_MEM_SETTINGS,
    CMD_CHANGE_MEM_SETTING,
    CMD_TEST_D_CACHE,
    CMD_DISABLE_D_CACHE,
    CMD_ENABLE_D_CACHE,
    CMD_WIPE_D_CACHE,
    CMD_ALLOCATE_D_CACHELINE,
    CMD_LOCK_D_CACHELINE,
    CMD_FILLWAY,
    CMD_PCISCAN,
    CMD_I2C
};  


/****************************************************************************
 * FPGA Commands (CMDGROUP_VFPGA)                                           *
 ****************************************************************************/


enum
{
    CMD_FPGA    = MAKECMD(CMDGROUP_VFPGA, 1),
    CMD_ADMXRC_LOAD,
    CMD_ADMXRC_STOP,    
    CMD_ADMXRC_STEP,    
    CMD_ADMXRC_START,
    CMD_ADMXRC_SET_CLOCK,
    CMD_RC1000_LOAD,
    CMD_RC1000_STOP,    
    CMD_RC1000_STEP,    
    CMD_RC1000_START,
    CMD_RC1000_SET_CLOCK,
    CMD_FPGA_SPI,
    CMD_PROTEUS_LOCAL_LOAD,
    CMD_PROTEUS_SWITCHLEDS

};
    
/****************************************************************************
 * Temporary/Test Commands                                                  *
 ***************************************************************************/
enum
{
    CMD_TEMP1 = MAKECMD(CMDGROUP_TEMP, 1),
    CMD_TEMP2,
    CMD_TEMP3,
    CMD_TEMP4,
    CMD_TEMP5,
    CMD_TEMP6,
    CMD_TEMP7,
    CMD_TEMP8,
    CMD_TEMP9,
    CMD_TEMP10
};

#endif          // __CMDS_H__
