/***************************************************************************
*
* Module:		esttype.h
*
* Description:	Elemental type definitions
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*	BL - Added Signed types
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __ESTTYPE_H__
#define __ESTTYPE_H__

#ifndef __ASSEMBLER__

#ifdef __cplusplus
typedef int 		(*FUNCPTR) (...);     /* ptr to function returning int */
typedef void 		(*VOIDFUNCPTR) (...); /* ptr to function returning void */
typedef double 		(*DBLFUNCPTR) (...);  /* ptr to function returning double*/
typedef float 		(*FLTFUNCPTR) (...);  /* ptr to function returning float */
#else
typedef int 		(*FUNCPTR) ();		/* ptr to function returning int */
typedef void 		(*VOIDFUNCPTR) ();	/* ptr to function returning void */
typedef double 		(*DBLFUNCPTR) (); 	/* ptr to function returning double*/
typedef float 		(*FLTFUNCPTR) ();	/* ptr to function returning float */
#endif			/* _cplusplus */


typedef int  STATUS;

#if	!defined(NULL) || (NULL!=0)
#define NULL  0
#endif

#if	!defined(FALSE) || (FALSE!=0)
#define FALSE		0
#endif

#if	!defined(TRUE) || (TRUE!=1)
#define TRUE		1
#endif

#define GLOBAL
#define LOCAL  	static
#define EXTERN 	extern

#define IMPORT  extern

#define VOID    void

#define VOIDPTR void *

#define FAST	register

#define INT32  	long
#define INT16  	short
#define INT8   	char
#define	INT64	long long

#define VINT32  volatile long
#define VINT16  volatile	short
#define VINT8   volatile	char
#define	VINT64	volatile long long

typedef	int		BOOL;
typedef	int		BOOLEAN;

#define SINT32 signed long
#define SINT16 signed short
#define SINT8  signed char
#define	SINT64 signed long long

#define UINT32 unsigned long
#define UINT16 unsigned short
#define UINT8  unsigned char
#define	UINT64 unsigned long long

#define VUINT32 volatile unsigned long
#define VUINT16 volatile unsigned short
#define VUINT8  volatile unsigned char
#define	VUINT64	volatile unsigned long long

typedef UINT32 IPADDR;

#define UBYTE  unsigned char

#define UCHAR  unsigned char
#define USHORT unsigned short
#define ULONG  unsigned long

#define UINT	unsigned int
#define INT		int

#ifndef __vWARE_size_t
#define	__vWARE_size_t
typedef unsigned int size_t;
#endif

#endif			

#endif			/* __ESTTYPE_H__ */
