/***************************************************************************
*
* Module:		filetype.h
*
* Description:	support for plugin file types
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __FILETYPE_H__
#define __FILETYPE_H__

/****************************************************************************
 * Definition of structure which gets passed to a Preload function.         *
 ***************************************************************************/
typedef struct
{
	char Filespec[64];
	UINT32 Bias;
} tPRELOAD;

/****************************************************************************
 * tFileType structure definition.                                          *
 ***************************************************************************/
typedef struct tFileType
{
	char *pName;
	UINT32 (*Preload)(tPRELOAD *);
	UINT32 (*ProcessChunk)(UINT8 *, UINT32);
	UINT32 (*Postload)(void);
} tFileType;

/****************************************************************************
 * FileType macro.  Use this to declare a plugin filetype.                  *
 ***************************************************************************/
#define FileType(name, vbegin, vcont, vfini)	\
asm	("	.section	.vstrings,1,r");		\
asm	("vnames:	.set	.");				\
asm	("	.asciz	" #name);					\
asm	("	.section	.filetypes,4,r");		\
asm	("	.word	vnames");					\
asm	("	.word	" #vbegin);					\
asm	("	.word	" #vcont);					\
asm	("	.word	" #vfini);

/****************************************************************************
 * Return codes for filetype plugins.                                       *
 ***************************************************************************/
enum
{
	FT_SUCCESS = 0,
	FT_FLASHERROR = 1,
	FT_PROTECTED = 2,
	FT_VERIFYERROR = 3
};

/****************************************************************************
 * External References.                                                     *
 ***************************************************************************/
global UINT8 DownloadTemp[32];
global UINT32 BytesRemaining;
global UINT8 *DownloadAddress;
global UINT32 DownloadBias;
global signed long MoveLength;
global UINT32 (*LoadMemoryVector)(UINT8 *, UINT32);
global void BeginDownload(UINT32 Bias);
global UINT32 LoadMemory(UINT8 *buffer, UINT32 Length);
global UINT32 ProcessMode;

#endif									// __FILETYPE_H__
