/***************************************************************************
*
* Module:		malloc.h
*
* Description:	Visionware memory allocation structures
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __MALLOC_H__
#define __MALLOC_H__

#define MALLOCTABLESIZE	16
#define MALLOCALIGNMENT	(sizeof(UINT64))

typedef struct AddrResource
{
	UINT32 Start;
	UINT32 Size;
	struct AddrResource *Next;
} AddrResource;

typedef struct
{
	UINT32 Start;
	UINT32 Limit;
	AddrResource *Head;
} Pool;

global void *AllocateRange(UINT32 RequestedLength,	UINT32 Alignment, Pool *pPool);
global void ReleaseRange(UINT32 Start, Pool *pPool);

#endif						// #ifndef __MALLOC_H__
