/***************************************************************************
*
* Module:		PIC.h
*
* Description:	PIC Wrapper definitions
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __PIC_H__
#define __PIC_H__

/****************************************************************************
 * tHANDLER structure definition.  Every registered exception/interrupt
 * handler is defined by one of these structures.
 ***************************************************************************/
#ifndef __ASSEMBLER__
typedef struct tHANDLER
{
	struct tHANDLER	*pNext;
	UINT32			UnbiasedID;
	UINT32			BiasedID;
	int				(*Vector)(void *);
	void			*pParameters;
	void			*pPicdata;
	UINT32			Picdata[2];
	VMMCONTEXT		vc;
} tHANDLER;
#else
#define HandlerNext			0x00
#define HandlerUnbiasedID	0x04
#define HandlerBiasedID		0x08
#define HandlerVector		0x0C
#define HandlerParameter	0x10
#define HandlerpPicdata		0x14
#define HandlerPicdata0		0x18
#define HandlerPicdata1		0x1C
#define HandlerVmmContext	0x20
#endif

#ifndef __ASSEMBLER__
typedef struct tPIC
{
	UINT32 	nLo;
	UINT32 	nHi;
	HLIST	*Handles;
	void	(*Install)(tHANDLER *, UINT32);
	void	(*Remove)(tHANDLER *);
	void	(*Enable)(tHANDLER *);
	void	(*Disable)(tHANDLER *);
} tPIC;
#else
#define PicLo				0x00
#define PicHi				0x04
#define PicHlist			0x08
#define PicIsr				0x0C
#define PicInstall			0x10
#define PicRemove			0x14
#define PicEnable			0x18
#define PicDisable			0x1C
#endif

#ifndef __ASSEMBLER__
#define PIC(name)					\
asm ("	.section	.vpic,4,r");	\
asm ("	.word	" #name);
#endif

#endif									// #ifndef __PIC_H__
