/* sysVware.h - visionWare-dependent definitions */

/* Copyright 2001 Wind River Systems, Inc. */

/*
modification history
--------------------
01c,12jun02,kab  SPR 74987: cplusplus protection
01b,25oct01,g_h  Making compliamce with our coding convention.
01a,22apr01,g_h  written.
*/

/*
DESCRIPTION
This module contains visionWare-dependent structures and definitions needed
to run image under visionWare.
*/

#ifndef __INCsysVwareh
#define __INCsysVwareh

#ifdef __cplusplus
    extern "C" {
#endif

#define VWARE_MAC_ADRS_LEN	6

/*
 * vWare (version 1) passing structure
 */
typedef struct _vWareParams 
    {
    char	label[6];
    char	ipAddrs[24];
    UINT32	IpAddress;
    UINT8	MacBytes[6];
    UINT32	Subnet;
    UINT32	DefaultGateway;
    UINT32	PrimaryHost;
    }vWareParams;

#define OSPARAMS_VERSION                        2

/*
 * vWare (version 2) passing structure
 */
typedef struct tOsParams
    {
    /* House-keeping stuff. */
    char    Signature[8];         /* "vWARE" padded with zeros */
    UINT8   Version;              /* version of this structure */
    UINT8   Checksum;             /* two's complement checksum */
    UINT16  Size;                 /* size of this structure in bytes */

    /* Memory blocks */
    UINT32  RamStart;             /* virtual start address of RAM  */
    UINT32  RamSize;              /* size of RAM */
    UINT32  FlashStart;           /* virtual start address of flash */
    UINT32  FlashSize;            /* size of flash */
    UINT32  Start3;               /* reserved */
    UINT32  Size3;                /* reserved */
    UINT32  Start4;               /* reserved */
    UINT32  Size4;                /* reserved */
    UINT32  MmrBase;              /* start of CPU-specific register block */

    /* MMU stuff */
    UINT32  MmuTableBase;         /* address of MMU tables */
    UINT32  MmuTableSize;         /* size of block reserved for MMU tables */
    UINT32  MmuBaseTable;         /* address of base table */

    /* System stuff */
    UINT32  XtalSpeed;            /* input to system clock */

    /* TCP/IP Stack stuff */
    UINT32  IpAddress;
    UINT32  Subnet;
    UINT32  DefaultGateway;
    UINT32  PrimaryHost;
    UINT8   MacBytes[6];
    UINT16  Reserved;             /* padding */

	// Version 2 starts here.
	void *pVwareEntry;					// pointer to a tVwareEntry structure

    /* Add new stuff here... */

    } tOsParams;

#ifdef __cplusplus
    }
#endif

#endif /* __INCsysVwareh */
