/***************************************************************************
*
* Module:		timer.h
*
* Description:	Timer API
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __TIMER_H__
#define __TIMER_H__

#define TIMERPERIOD		10				// 10 millisecond period

typedef struct TIMEOUT
{
	struct TIMEOUT *pNext;
	INT32 Timer;
	UINT32 Parameter;
	void (*Vector)(UINT32, struct TIMEOUT *);
	UINT32 InUse;
	VMMCONTEXT vc;
} TIMEOUT;

#define TIMERFUNC	(void (*)(void *))
#define TIMERFLAG_PERIODIC	1
#define TIMERFLAG_ONESHOT	0

typedef struct tTIMEOUT
{
	struct	tTIMEOUT *pNext;
	UINT32	SeedValue;
	void	(*Vector)(void *);
	void	*pParameter;
	UINT32	Flags;
	TIMEOUT	t;
} tTIMEOUT;

// APIGUI
global HANDLE InstallOneshotTimer(UINT32 nMilliseconds, void (*Vector)(void *), void *pParameter);
global HANDLE InstallPeriodicTimer(UINT32 nMilliseconds, void (*Vector)(void *), void *pParameter);
global void RemoveTimer(HANDLE pTimer);
global void BlockTimers(void);
global void AllowTimers(void);
// APIGUIEND

global void InstallTimer(TIMEOUT *pNew);	// obsolete - do not use
global void KillTimer(TIMEOUT *pTimeout);	// obsolete - do not use

global void SetBaseTime(UINT64 *pBaseTime);
global void SetElapsedTime(UINT64 *pBaseTime, UINT64 *pElapsedTime);
global UINT32 Milliseconds(UINT64 *pElapsedTime);
global void ProcessTimers(UINT32 MillisecondsElapsed);

#endif			// __TIMER_H__
