/* vBaseLib.c - Core Library */

/* Copyright 2002 Wind River Systems, Inc. */

/*
 * DESCRIPTION
 * This library is the core library entry point to connect from an external application.
 */

#define YES	1
#define NO	0
/* VWARE_PARAMS_BEGIN */
#define	vBASE_EXT_INTERFACE		NO		/* Expose API	CHOICE	NO|YES */
/* VWARE_PARAMS_END */

#if vBASE_EXT_INTERFACE

#define __VBASELIB_C__

/* includes */

#include "vm.h"
#include "vBaseLib.h"

/***********************************************************************************
*
* vTimeInit - intialize time stamp
*
* This routine initializes the decrementer timer and the time stamp.
*
* RETURNS: N/A
*/

void vTimeInit (void)
	{
	InitTimerIRQ ();		/* initialize the timer */
	EnableInterrupts ();	/* now able to manage decrementer interrupts */
	}

VWARELIB (BASELIB_TIME,			GetLocalTimestamp,	"UINT32 vTimeGet(void)");
VWARELIB (BASELIB_TIME_INIT,	vTimeInit,			"void vTimeInit(void)");
VWARELIB (BASELIB_INTLOCK,		DisableInterrupts,	"void vIntLock(void)");
VWARELIB (BASELIB_INTUNLOCK,	EnableInterrupts,	"void vIntUnlock(void)");

#endif
