/***************************************************************************
*
* Module:		vm.h
*
* Description:	Primary vware include file.  Should be included by all
*				C and C++ source files.
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
#ifndef __VM_H_
#define __VM_H_

/****************************************************************************
 * global                                                                   *
 ***************************************************************************/
#ifdef __cplusplus
#define global extern "C"
#else
#define global extern
#endif

/****************************************************************************
 * gap() - a macro for defining gaps in a structure.                        *
 ***************************************************************************/
#define ___gap(y,x)	UINT8 Gap ## y[x]
#define __gap(y,x)	___gap(y,x)
#define gap(x)		__gap(__LINE__,x)

/****************************************************************************
 * EVAL() - a macro to force the preprocessor to evaulate somthing.         *
 ***************************************************************************/
#define __EVAL(x) #x
#define EVAL(x) __EVAL(x)

/****************************************************************************
 * Includes                                                                 *
 ***************************************************************************/
#include "packed.h"
#include "esttype.h"
#include "handles.h"
#include "assignednumbers.h"
#include "launch.h"
#ifndef MINAGENT
#ifndef VMLIB
#include "board.h"
#endif
#endif
#include "vdlog.h"
#include "cpucore.h"
#include "pic.h"
#include "vware.h"
#include "lib.h"
#include "malloc.h"
#include "cpu.h"

#ifdef FFS_ON
#include "vfile.h"
#endif

#ifdef FLASH_ON
#include "vflash.h"
#endif

#ifdef ESTACK_ON
#include "vstack.h"
#endif

#endif			// __VM_H_
