
/* vxBootline.c -	The purpose of the routine in this file is to generate
					a default bootline for vxWorks */

/* Copyright 1999-2000 Wind River Systems, Inc. */

/*
modification history
--------------------
01	19Sept02	created
*/

/*DESCRIPTION	The purpose of these routines is to allow the user to construct a default
				command line in order to boot their vxWorks image

INCLUDE FILES : vm.h,vxBootline.h*/

/* includes */
#include "vm.h"
#include "cmd.h"
#include "vxBootline.h"
#include "shell.h"
#include "board.h"
#include "estack.h"
#include "cmds.h"
#include "vconsole.h"

/* defines */

/* typedefs */

/* globals */

/* locals */

/* forward declarations */

ShellVar(SHELLVAR_OS_BOOTLINE, "Auto Generate vxWorks Bootline (y/n)", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);
ShellVar(SHELLVAR_vxBOOT_DEV_NAME, "Boot Device Name", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);
ShellVar(SHELLVAR_vxELF_FILE_LOC, "ELF file name and path", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);
ShellVar(SHELLVAR_vxUSERNAME, "User Name (u)", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);
ShellVar(SHELLVAR_vxPASSWORD, "Password (pw)", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);
ShellVar(SHELLVAR_vxFLAGS, "Flags (f)", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);
ShellVar(SHELLVAR_vxTARGET_NAME, "Target Name (tn)", SHELLTYPE_STRING, 0, 128, 1, 1, 0, 0);

void vxBoot(void)
{
	char p[256];	
	char ConvertedIp[24];
	char RawIP[24];
	char RawSubnet[24];
	char ConvertedSubnet[24];
	int index;
	char *pointer;
	char InvokeBootlineGen[3];

	/* Init arrays so that we know what's in them */
	for(index=0;index<=23;index++)
	{
		ConvertedIp[index] = 0;
		RawIP[index] = 0;
		RawSubnet[index] = 0;
		ConvertedSubnet[index] = 0;
	}
	for(index=0;index<=3;index++)
	{
		InvokeBootlineGen[index] = 0;
	}
	
	/* check to see if the user has specified auto generation as they may want to
	   use the default bootline inside the BSP instead */
	strcpy(InvokeBootlineGen,((char *)GetShellVarPointer(SHELLVAR_OS_BOOTLINE)));
	strtoupper(InvokeBootlineGen);
	if(strcmp(InvokeBootlineGen,"N"))
	{
	pointer = (char *)DEFAULT_BOOTLINE_ADDR;
	/* Get the boot device name (i.e. motfcc) */
	strcpy(pointer,((char *)GetShellVarPointer(SHELLVAR_vxBOOT_DEV_NAME)));
	strcat(pointer, "(0,0)");
	/*	Get the target name, At this point in the bootline, it is
		being used to name the target server */
	strcat(pointer,((char *)GetShellVarPointer(SHELLVAR_vxTARGET_NAME)));
	strcat(pointer, ":");
	/* Get the name of the Elf file and any path information */
	strcat(pointer,((char *)GetShellVarPointer(SHELLVAR_vxELF_FILE_LOC)));
	strcat(pointer, " ");
	/* Get the remote host IP address and convert it */
	strcat(pointer, "h=");
	sprintf(RawIP,((char *)GetShellVarPointer(SHELLVAR_REMOTEIP)));
	sprintf(ConvertedIp, "%1d.%1d.%1d.%1d", RawIP[0],RawIP[1],RawIP[2],RawIP[3]);
	strcat(pointer,ConvertedIp);
	strcat(pointer, " ");
	/* Get the target host IP address and convert it */
	strcat(pointer, "e=");
	sprintf(RawIP,((char *)GetShellVarPointer(SHELLVAR_IP)));
	sprintf(ConvertedIp, "%1d.%1d.%1d.%1d", RawIP[0],RawIP[1],RawIP[2],RawIP[3]);
	strcat(pointer,ConvertedIp);
	/* Get the Subnet mask and convert it */
	strcat(pointer, ":");
	sprintf(RawSubnet,((char *)GetShellVarPointer(SHELLVAR_SUBNET)));
	sprintf(ConvertedSubnet, "%02x%02x%02x%02x", RawSubnet[0],RawSubnet[1],RawSubnet[2],RawSubnet[3]);
	strcat(pointer, ConvertedSubnet);
	strcat(pointer, " ");
	/* Get the Gateway address and convert it */
	strcat(pointer, "g=");
	sprintf(RawIP,((char *)GetShellVarPointer(SHELLVAR_GATEWAY)));
	sprintf(ConvertedIp, "%1d.%1d.%1d.%1d", RawIP[0],RawIP[1],RawIP[2],RawIP[3]);
	strcat(pointer,ConvertedIp);
	strcat(pointer, " ");
	/* get the vxWorks User name */
	strcat(pointer, "u=");
	strcat(pointer,((char *)GetShellVarPointer(SHELLVAR_vxUSERNAME)));
	strcat(pointer, " ");
	/* get the vxWorks password */
	strcat(pointer, "pw=");
	strcat(pointer,((char *)GetShellVarPointer(SHELLVAR_vxPASSWORD)));
	strcat(pointer, " ");
	/* get the vxWorks flags */
	strcat(pointer, "f=");
	strcat(pointer,((char *)GetShellVarPointer(SHELLVAR_vxFLAGS)));
	strcat(pointer, " ");
	/* Get the name of the target */
	strcat(pointer, "tn=");
	strcat(pointer,((char *)GetShellVarPointer(SHELLVAR_vxTARGET_NAME)));
	strcat(pointer, " ");

	/*	based on the architecture selected, assign a pointer to the location that the
		bootline should appear at */
//	pointer = (char *)DEFAULT_BOOTLINE_ADDR;
	/* Write the bootline to memory */
//	sprintf(pointer, p);
	}
}
Command(CMD_VXBOOT,"vxboot",vxBoot,HIDDEN,"vxboot","Test vxWorks bootline generator");
CommandEnd();

Fini(0, vxBoot);
