/* 21555.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: 
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef I21555_H
#define I21555_H

#define VENDOR_INTEL	0x8086
#define DEVICE_21555	0xB555

#define SROM_NUM_BYTES 0x200

#define SECONDARY_OFFSET				0x00
#define I21555_ROM_CTRL_SromStartBusy	(1<<0)
//#define I21555_ROM_CTRL					(0xcf)
// Use this for byte addressing on Deer Island
#define I21555_ROM_CTRL					(0xcc)
#define I21555_ROM_ADDR_Erase			(3<<9)
//#define I21555_ROM_DATA					(0xca)
// Use this for byte addressing on Deer Island
#define I21555_ROM_DATA					(0xc9)
#define I21555_ROM_ADDR					(0xcc)
#define I21555_ROM_CTRL_PromStartBusy	(1<<1)
#define I21555_ROM_ADDR_Read			(2<<9)
#define I21555_ROM_ADDR_Write			(1<<9)
#define I21555_ROM_CTRL_SromPoll		(1<<3)
#define I21555_ROM_ADDR_WriteDisable	((0<<7)|I21555_ROM_ADDR_OpGeneral)
#define I21555_ROM_ADDR_WriteEnable		((3<<7)|I21555_ROM_ADDR_OpGeneral)
#define PCI_CHIP_CTRL0_PriAccessLockout	(1<<10)
#define PCI_CHIP_CTRL0					(0xcc)
#define PCI_SECONDARY_CSR_IO_BAR		(SECONDARY_OFFSET + 0x14)
#define I21555_ROM_ADDR_OpGeneral		(0<<9)

typedef struct ntbinfo
{
	unsigned int ioBase;
} NTBINFO;

NTBINFO ntbInfo;


#endif //I21555_H