/* ADM1031.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef _ADM1031_H
#define _ADM1031_H

struct ADM1031RegData
{
UINT8	ADM1031_Reg;
UINT8 	ADM1031_Data;
};

#define ADM1031InitTblsz \
(sizeof ADM1031InitTbl/sizeof ADM1031InitTbl[0])

// These are Analog Devices ADM1031 register offsets and defines
// See their Intelligent Temperature Monitor and Dual PWM Fan 
// Controller spec for details

#define  	ADM1031_ADDR	 				0x2D
#define 	ADM1031_CHIPID 	 				0x4131

#define		ADM1031_Config_1				0x00
#define		ADM1031_Config_2				0x01
#define		ADM1031_Status_1				0x02
#define		ADM1031_Status_2				0x03
#define     ADM1031_Extended_Temp			0x06
#define		ADM1031_Local_Temp_Value 		0x0A
#define		ADM1031_Remote_Temp_1_Value 	0x0B
#define		ADM1031_Remote_Temp_2_Value 	0x0C
#define		ADM1031_Local_Temp_Offset		0x0D
#define		ADM1031_Remote_Temp_1_Offset	0x0E
#define		ADM1031_Remote_Temp_2_Offset	0x0F

#define		ADM1031_Local_High_Limit		0x14
#define		ADM1031_Local_Low_Limit			0x15
#define		ADM1031_Local_Therm_Limit		0x16
#define		ADM1031_Remote_1_High_Limit		0x18
#define		ADM1031_Remote_1_Low_Limit		0x19
#define		ADM1031_Remote_1_Therm_Limit	0x1A
#define		ADM1031_Remote_2_High_Limit		0x1C
#define		ADM1031_Remote_2_Low_Limit		0x1D
#define		ADM1031_Remote_2_Therm_Limit	0x1E

#define		ADM1031_Local_Temp				0x24
#define		ADM1031_Remote_Temp_1   		0x25
#define		ADM1031_Remote_Temp_2   		0x26
#define		ADM1031_DeviceID				0x3D
#define		ADM1031_CompanyID				0x3E
#define		ADM1031_Therm_Behave_Rev		0x3F

//ADM1031_Config_1			
#define 	ADM1031_Fan_Fault_En 			0x10

//ADM1031_Config_2			
#define 	ADM1031_Loc_Temp_En 			0x10
#define 	ADM1031_Remote_1_Temp_En		0x20
#define 	ADM1031_Remote_2_Temp_En		0x40
#define		ADM1031_SW_RESET				0x80

#define LocalTempShft  			6
#define LocalTempMask			3
#define RemoteTemp2Shft 		3
#define RemoteTemp2Mask 		7
#define RemoteTemp1Shft 		0
#define RemoteTemp1Mask 		7

#define NEG_MASK				0x80

//Remote sensor extended temperature values 
static char *remote_extend_val[] = 
{
".000", ".125", ".250", ".375",
".500", ".625", ".750", ".850"
};

//Local sensor extemded temperature values
static char *local_extend_val[] =
{
".00", ".25", ".50", ".75"
};
