/* IXF1110.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

// IXF1110 Per-port registers
#define IXF1110_RX_CONFIG_WORD_REG(port)		((port * 0x80 + 0x16) * 4)
#define IXF1110_TX_CONFIG_WORD_REG(port)		((port * 0x80 + 0x17) * 4)
#define IXF1110_DIVERSE_CONFIG_WRITE_REG(port)	((port * 0x80 + 0x18) * 4)

#define IXF1110_PORT_ENABLE_REG         0x500
#define IXF1110_LINK_LED_ENABLE_REG     0x502
#define IXF1110_CPU_INTERFACE_REG		0x508
#define IXF1110_LED_CONTROL_REG         0x509
#define IXF1110_SPI4_RX_TRAINING_REG	0x701
#define IXF1110_SPI4_DESKEW_REG			0x706
// DIVERSE_CONFIG_WRITE_REG(port) bit definitions	
#define IXF1110_ENABLE_AUTO_NEG         1 << 5

// IXF1110_CPU_Interface_Reg bit definitions
#define IXF1110_BIG_ENDIAN				0x01
#define IXF1110_LITTLE_ENDIAN			0x00 

// IXF1110_LED_CONTROL_REG bit definitions
#define IXF1110_ENABLE_LED				1 << 1
#define IXF1110_LED_MODE_0				0x0
#define IXF1110_LED_MODE_1				0x1

// IXF1110_LINK_LED_ENABLE_REG bit definitions
#define IXF1110_LINK_LED_ENABLE(port)   1 << port
// IXF1110_SPI4_RX_Training bit definitions
#define IXF1110_REP_T_MASK              0xff << 16
#define IXF1110_DATA_MAX_T_MASK         0xffff 

// IXF1110_RX_CONFIG_WORD_REG(port) bit definitions
#define IXF1110_AN_COMPLETE						 1 << 21

// IXF1110_SPI4_DESKEW_REG bit definitions
#define DESKEW_LPBK						1<<29
#define DESKEW_LPBK_MASK				0xdffff
                                      	                          
