/* IXF1810.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

#define IXF1810IntLoopTblsz (sizeof IXF1810IntLoopTbl/sizeof IXF1810IntLoopTbl[0])
#define IXF1810ExtLoopTblsz (sizeof IXF1810ExtLoopTbl/sizeof IXF1810ExtLoopTbl[0])
// Global configuration registers 0x0 - 0xfff
#define IXF1810_GLB_CFG1		 	0x00    
#define	IXF1810_GLB_CHIPID     	 	0x01
#define IXF1810_GLB_CHIPVER	 		0x02
#define IXF1810_GLB_RST				0x03
#define IXF1810_GLB_WATCH			0x04
#define IXF1810_GLB_FAILADDR		0x05
#define IXF1810_GLB_CLKCFG1			0x06
#define IXF1810_GLB_CLKCFG2			0x08
#define IXF1810_GLB_LINE			0x0A
#define IXF1810_GLB_APS				0x0D
#define IXF1810_GLB_SPI4			0x10
#define IXF1810_GLB_STAT			0x11
#define IXF1810_GLB_INTSTAT			0x12
#define IXF1810_GLB_INTEN			0x13
#define IXF1810_GLB_CLKINTSTAT		0x14
#define IXF1810_GLB_CLKINTEN		0x15

// Sonet Registers 0x1000 - 0x2fff
#define IXF1810_WISLOOP_CFG 		0x1009

// SONET Receive Path OH (POH) Registers 0x11C0 - 0x17FF
#define IXF1810_RL_POH_CFG2			0x11C1

// SONET Transmit Path Overhead (POH) Registers	 0x1820 - 0x186F 
#define IXF1810_TL_POH_CTL			0x1821
#define IXF1810_TL_POH_BVA_C2Val	0x1832
#define IXF1810_TL_POH_BVA_G1Val	0x1833

#define IXF1810_TL_POH_SCA_B3Src	0x1841
#define IXF1810_TL_POH_SCA_C2Src	0x1842
#define IXF1810_TL_POH_SCA_G1Src	0x1843

//SONET Transmit Transport TOH Registers 0x1870 - 0x1fff
#define IXF1810_TL_SC1_TOH			0x1882

// System Packet Interface (SPI) Level Four Phase 2 Registers 0x3000 - 0x30FF

//SPI-4 RX Polarity register
#define IXF1810_RX_POL_REG	0x3010

// MAC Management Registers	 0x3100 - ox311F
#define IXF1810_XGMAC_CNTL			0x3100
#define IXF1810_XGMAC_ADDLO			0x3112
#define IXF1810_XGMAC_ADDHIJUM		0x3114

// PCS Registers 0x3200 - 0x32FF 
#define IXF1810_PCS_CNTL1 			0x3200
#define IXF1810_PCS_STAT1			0x3201
#define IXF1810_PCS_ID1				0x3202
#define IXF1810_PCS_ID2				0x3203
#define IXF1810_PCS_SPEED_ABIL		0x3204

// Packet over SONET (POS) Registers 0x3300 - 0x33FF
#define IXF1810_R_PHCCNF			0x3300
#define IXF1810_T_PHCCNF			0x3330

// GFP Registers 0x3400 - 0x34FF
//#define IXF1810_GFP_CFG1			0x3400
//#define IXF1810_GFP_CFG2			0x3401
//#define IXF1810_GFP_CFG3			0x3402



// IXF1810_GLB_CHIPID bit definitions																		
#define IXF1810_ChipID			 	0x46B5

// IXF1810_GLB_WATCH bit definitions
#define IXF1810_Watchdg_En			1 < 8

// IXF1810_GLB_RST bit definitions
#define IXF1810_SPI_Interface_Rst	1 << 3
#define IXF1810_Line_Interface_Rst	1 << 2
#define IXF1810_APS_Interface_Rst	1 << 1
#define IXF1810_SftRst				1 << 0

// IXF1810_WISLOOP_CFG bit definitions
#define IXF1810_mapper_test_loop_enable		0x10
#define IXF1810_mapper_test_loop_disable	0x00


