/* 4k_ustore_test.uc	  
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800							 
 *  subsystem: DIAG
 *  author: ccm, Mar 14, 02
 * 
 * --------------------------------------------------------------------------
 */

// *NOTE*:	Alternative #1 might not detect faults at bne[SEND_STATUS#] but
//			provides the granularity of error detection
//			Whereas Alternative #2 will detect errors at any location but
//			does not provide approximation of error location.

#include "me_xscale_sync.h"

#ifndef ALTERNATIVE
#define ALTERNATIVE 1
#endif

#define NUM_OF_LOOPS (NUM_OF_LINES_TO_GEN - 22)	   
#define x 1	// incremented value used for checking against alu operations

.reg counter temp base me me_offset
.reg $status
.sig scratch_write			 				
immed[counter, 0x1]
immed[base, 0x4]


	// Only use context 0
	br=ctx[0, thread_0#]	; if thread 0 continue
	ctx_arb[kill]			; not thread 0,just kill
thread_0#:

#if (ALTERNATIVE == 1)

#while(x <= (NUM_OF_LOOPS/4))		 
	#define_eval x (x + 1)
	alu[counter, counter, +, 1]		// increments counter
	immed[temp, x]					// move constant to be compared
	alu[--, counter, -, temp]		// determine if any instructions were skipped
	bne[SEND_STATUS#]
#endloop

#elif (ALTERNATIVE == 2)

#while(x <= NUM_OF_LOOPS)
	alu[counter, counter, +, 1]		// increments counter
	#define_eval x (x + 1)
#endloop

#endif

// writes counter value to scratch to be verified by XScale	   
SEND_STATUS#:

// calculate me_offset
local_csr_rd[active_ctx_sts]
immed[me, 0]
alu_shf[me, 0x1f, AND, me, >>3]
alu[me_offset, 0x7, AND, me]

alu_shf[me, 0x8, AND, me, >>1]
alu[me_offset, me_offset, OR, me]

alu_shf[me_offset, --, B, me_offset, <<2]

alu[$status, --, B, counter]
nop
nop
scratch[write, $status, base, me_offset, 1], ctx_swap[scratch_write]

nop
nop
nop
nop
nop
nop
nop
nop
ctx_arb[kill]
