/* common_uc.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: dalsraja, May 8, 2002
 *  revisions: 
 * 
 * 
 * --------------------------------------------------------------------------
 */

#define MSF_WORKAROUND
//#define WORKBENCH_SIM

#define MSF_RX_CONTROL					0x0000
#define MSF_TX_CONTROL					0x0004
#define CSIX_TYPE_MAP					0x0010       
#define HWM_CONTROL						0x0024
#define RX_THREAD_FREELIST_0			0x0030
#define RBUF_ELEMENT_DONE				0x0044
#define TX_SEQUENCE_0					0x0060
#define RX_UP_CONTROL_0					0x0080
#define TX_UP_CONTROL_0					0x0090
#define FCIFIFO							0x0100	// (         / 0x0100 - 0x013C)
#define FCEFIFO							0x0140

#define TBUF_ELEMENT_CONTROL_V			0x1800	// (         / 0x1800 - 0x1FFC)
#define RBUF_TBUF						0x2000	// (0 to 127 / 0x4000 - 0x5FFF)

//*******************************************************************************

#define MSF_SINGLE_PHY					0
#define MSF_MULTIPLE_PHY				1

#define MSF_WIDTH_1x32					0
#define MSF_WIDTH_2x16					1
#define MSF_WIDTH_4x8					2
#define MSF_WIDTH_1x16_2x8				3

#define MSF_POS_UTOPIA					0
#define MSF_CSIX						1

#define MSF_ELEMENTSIZE_256				2
#define MSF_ELEMENTSIZE_128				1
#define MSF_ELEMENTSIZE_64				0

#define MSF_PARITY_EVEN					3
#define MSF_PARITY_ODD					2
#define MSF_PARITY_NONE					0

#define MSF_HEC_ENABLE					1
#define MSF_HEC_DISABLE					0

#define MSF_CSIX_DISCARD				0
#define MSF_CSIX_RBUF_CONTROL			1
#define MSF_CSIX_RBUF_DATA				2
#define MSF_CSIX_FCEFIFO				3

#define MSF_POS2						0
#define MSF_POS3						1

// UP_Control Settings
#define UP_CTRL_DRTIME					1			// 0=1cycle, 1=2cycles
#define UP_CTRL_CELLSIZE				(0 << 1)	// 0=52 bytes, 1=56 bytes
#define UP_CTRL_PARITY					(MSF_PARITY_EVEN << 2)
#define UP_CTRL_CP_MODE					(1 << 4)	// 1=packet mode, 0=cell mode
#ifdef WORKBENCH_SIM
	#define UP_CTRL_PP_MODE					(MSF_POS3 << 5)
#else
	#define UP_CTRL_PP_MODE					(MSF_POS2 << 5)
#endif	

#define CSIX_UNICAST					1
#define CSIX_FLOWCONTROL				6
#define BIT_SHF_UNICAST					(CSIX_UNICAST * 2)
#define BIT_SHF_FLOWCONTROL				(CSIX_FLOWCONTROL * 2)

#define CSIX_BASE_HDR_LEN				2	// CSIX Base Header Length = 2 bytes
#define CSIX_TAIL_LEN					1	// CSIX Tail Length = 1 byte

//*******************************************************************************

#define MASK_16BIT						0xFFFF

#define PACKET_SENT						0x1010
#define PACKET_RECEIVED					0x2020
#define TEST_COMPLETE					0xBABE
#define ERROR_PATTERN					0xF0F0
#define INCORRECT_TYPE					0xF1F1
#define INCORRECT_SIZE					0xF2F2
#define NOT_SENT						0xF3F3
#define NOT_RECEIVED					0xF4F4
#define SLAVE_MAILBOX0_NO_SIG			0xF5F5
#define SLAVE_MAILBOX1_NO_SIG			0xF6F6
#define INIT_ERROR						0xF7F7
#define INIT_COMPLETE					0xF8F8
#define NOT_COMPLETE					0xF9F9

#define PCI_LOCAL_CSR_BASE				0xDF000000
#define MAILBOX0_OFFSET					0x50
#define MAILBOX1_OFFSET					0x54
#define MAILBOX2_OFFSET					0x58
#define MAILBOX3_OFFSET					0x5c

#define RING_0							0
#define RING_1							1
#define SRAM_CHANNEL_NUMBER_FIELD		30
#define SRAM_Q_ARRAY_NUMBER_FIELD		24
#define CHAN_NUMBER						1
#define Q_NUMBER						0

//#define SRAM_DESC_BASE					0x100000		// 1 Meg onwards
//#define DRAM_PCKT_BASE					0x1000000		// 16 Meg onwards