/* diag_utils.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ccm, Apr 03, 02
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef _DIAG_UTILS_H
#define _DIAG_UTILS_H

void Enable_CPSR_Int(void);
void Disable_CPSR_Int(void);
unsigned int get_CP15(void);
void dcache_on(void);
void dcache_off(void);
void icache_on(void);
void icache_off(void);
void dcache_sync(void);
void dcache_flush(void);
void flush(void);

void cmd_print(void);
void cmd_change(void);
void cmd_fill(void);
void cmd_blockmove(void);
void cmd_wrv(void);

void cmd_memrb(void);
void cmd_memwb(void);
void cmd_memrw(void);
void cmd_memww(void);
void cmd_memrd(void);
void cmd_memwd(void);

void cmd_iorb(void);
void cmd_iowb(void);
void cmd_iorw(void);
void cmd_ioww(void);
void cmd_iord(void);
void cmd_iowd(void);

void cmd_cfgrb(void);
void cmd_cfgwb(void);
void cmd_cfgrw(void);
void cmd_cfgww(void);
void cmd_cfgrd(void);
void cmd_cfgwd(void);

void cmd_setbaud(void);
void cmd_viewlog(void);
void cmd_set_verbose(void);
void set_hoe(void);
void cmd_reset(void);


// USED BY SLOWPORT
#define SP_FATAL 1
#define SP_NON_FATAL 0
#define SP_PASS	0x50415353	/* ascii values:  P=50, A=41, S=53, S=53 */
#define SP_FAIL	0x4641494c
#define SP_DONE	0x444f4e45

#define SP_COPY	0x434f5059
#define SP_DRAM	0x4452414d
#define SP_FLSH 0x464c5348
#define SP_GPIO	0x4750494f
#define SP_I2C	0x00493243
#define SP_INIT	0x494e4954
#define SP_LED	0x004c4544
#define SP_ME	0x00004d45
#define SP_NIC	0x004e4943
#define SP_PCI	0x00504349
#define SP_POST	0x504f5354
#define SP_SLAV	0x534c4156 
#define SP_SRAM	0x5352414d
#define SP_TEMP 0x54454d50
#define SP_TIME 0x54494d45
#define SP_UART	0x55415254
#define SP_XSC	0x00585343 

#define SP_ONE	0x004f4e45
#define SP_TWO	0x0054574f
#define SP_BROM	0x42524f4d

#ifdef IXP2800
#define SWAP32(x)               \
  (((x) << 24) |                \
  (((x) & 0x0000FF00) << 8) |   \
  (((x) & 0x00FF0000) >> 8) |   \
  (((unsigned int)(x)) >> 24))
#endif //IXP2800

#endif
