/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 BY Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/* ixd2810Autoneg.h - IXD2810 MAC device header file

modification history
--------------------
01a, 08oct02,eme	created
*/

#ifndef __INCixd2810Autonegh
#define __INCixd2810Autonegh

#include <ixd2810.h>
#include <ixd2810Port.h>

/* #define DEBUG */

/* Auto-negotiation related macros */
#define AN_TIMEOUT	30 /* seconds */

/* function prototypes */
STATUS doAutoneg(IXD2810_DEV *pDev, uint32_t port);
void configMac(IXD2810_DEV *pDev, uint32_t port);
void fiberAutoNeg(IXD2810_DEV *pDev, uint32_t port);
void disablePort(IXD2810_DEV *pDev, uint32_t port);
void enablePort(IXD2810_DEV *pDev, uint32_t port);
void printMsg(IXD2810_DEV *pDev, uint32_t port, int mode);

/* Link Up Register */
#define LINK_UP(port)			(0x1 << port)	/* bits 9:0 */

/* Port Enable Register */
#define PORT_EN(port)			(0x1 << port)	/* bits 9:0 */

#define ENABLE_BOUNDARY	0xFFFF

#endif /* __INCixd2810Autonegh */
