/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 BY Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/* ixd2810Int.h - IXD2810 MAC device Interrupt header file 

modification history
--------------------
01a, 08oct02,eme	created
*/
#ifndef __INCixd2810Inth__
#define __INCixd2810Inth__

/* includes */
#include "ixd2810.h"
/* defines */

/* initialize GBIC Control interrupt value */
#define GC_INT_ENABLE (GC_Rx_Loss_Enable  | \
					   GC_Tx_Fault_Enable | \
					   GC_Mod_Def_Enable)
#define GC_INT_DISABLE 0
	
/* variables */

/* interrupt level definition */
LOCAL uint32_t intLevelList[] =
	{
	(uint32_t) INT_LVL_MEDIA,
	(uint32_t) INT_LVL_FABRIC
	};

/* task names list */
LOCAL char *taskNames[] = 
	{
	"Device_0_ISR_Task",
	"Device_1_ISR_Task"
	};

/* task spawn parameters */
#define TASK_PRIORITY		100
#define TASK_OPTS			0
#define TASK_STACK_SIZE 	2000

/* function prototypes */
STATUS ixd2810IntDevInit(IXD2810_DEV *pDev);
STATUS ixd2810IntDevRelease(IXD2810_DEV *pDev);

#endif /* INCixd2810Inth__ */

