/* ixp2000gpio.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: jjd	 01a,05jun02
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
/*
DESCRIPTION

IXP2000 GPIO Header File

INCLUDE FILES: N/A
*/

#ifndef __INCixp2000gpioh
#define __INCixp2000gpioh

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GPIO_BASE       0xc0010000

#define GPIO_PLR        (GPIO_BASE + 0x00)       /* pin level */
#define GPIO_PDPR       (GPIO_BASE + 0x04)       /* pin direction programmable */
#define GPIO_PDSR       (GPIO_BASE + 0x08)       /* pin direction set */
#define GPIO_PDCR       (GPIO_BASE + 0x0C)       /* pin direction clear */
#define GPIO_POPR       (GPIO_BASE + 0x10)       /* pin output programmable */
#define GPIO_POSR       (GPIO_BASE + 0x14)       /* pin output set */
#define GPIO_POCR       (GPIO_BASE + 0x18)       /* pin output clear */
#define GPIO_REDR	(GPIO_BASE + 0x1c)	/* rising edge detect */
#define GPIO_FEDR	(GPIO_BASE + 0x20)	/* falling edge detect */
#define GPIO_EDSR	(GPIO_BASE + 0x24)	/* edge detect status */
#define GPIO_LSHR	(GPIO_BASE + 0x28)	/* level sense high enable */
#define GPIO_LSLR	(GPIO_BASE + 0x2c)	/* level sense low enable */
#define GPIO_LDSR	(GPIO_BASE + 0x30)	/* level detect status */
#define GPIO_INER	(GPIO_BASE + 0x34)	/* interrupt enable */
#define GPIO_INSR	(GPIO_BASE + 0x38)	/* interrupt set */
#define GPIO_INCR	(GPIO_BASE + 0x3c)	/* interrupt reset */
#define GPIO_INST	(GPIO_BASE + 0x40)	/* interrupt status */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __INCixp2000gpioh */
