/* ixp2000pic.h - ixp2000 PIC Driver */

/* Copyright 1984-1999 Wind River Systems, Inc., 2002 Intel Corporation */

/*
modification history
--------------------
01a,26apr02, jjd  created from 01a brhpic.c
*/

/*
DESCRIPTION

IXP2000 Programmable Interrupt Controller

INCLUDE FILES: 
*/

#ifndef __INCixp2000h
#define __INCixp2000h

/* Interrupt Controller Status / Mask / Steering Registers */
#define PIC_SWI             0x00000001
#define PIC_ERRSUM          0x00000002
#define PIC_UART            0x00000004
#define PIC_GPIO            0x00000008
#define PIC_TIMER1          0x00000010
#define PIC_TIMER2          0x00000020
#define PIC_TIMER3          0x00000040
#define PIC_TIMER4          0x00000080
#define PIC_SP              0x00000100
#define PIC_FRM             0x00000200
#define PIC_DMA0            0x00000400
#define PIC_DMA1            0x00000800
#define PIC_DMA2            0x00001000
#define PIC_DBELL           0x00002000
#define PIC_ME              0x00004000
#define PIC_THDGRP0_A       0x00008000
#define PIC_THDGRP1_A       0x00010000
#define PIC_THDGRP2_A       0x00020000
#define PIC_THDGRP3_A       0x00040000
#define PIC_THDGRP0_B       0x01000000
#define PIC_THDGRP1_B       0x02000000
#define PIC_THDGRP2_B       0x04000000
#define PIC_THDGRP3_B       0x08000000

/* typedefs */
typedef volatile struct ixp2000Pic  /* IXP2000_PIC */
    {
    UINT32  PicStatus;      /* PIC Interrupt Status */
    UINT32 :32;
    UINT32  PicEnableSet;   /* PIC interrupt enable */
    UINT32 :32;
    UINT32  PicEnableClr;   /* PIC interrupt mask */
    } IXP2000_PIC;

#endif /* __INCixp2000h */
