/* IXP2800Global.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem:
 *  author:
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef __IXP2800GLOBAL_H
#define __IXP2800GLOBAL_H

// Global control registers //
#define GLOBAL_CONTROL_BASE			0xC0004A00

//#define MISC_CONTROL_OFF			0x4
#define IXP_RESET0_OFF				0xC
#define CCR_OFF						0x14
//#define STRAP_OPTIONS_OFF			0x18

//#define MISC_CONTROL				(GLOBAL_CONTROL_BASE + MISC_CONTROL_OFF)
#define IXP_RESET0					(GLOBAL_CONTROL_BASE + IXP_RESET0_OFF)
#define CCR							(GLOBAL_CONTROL_BASE + CCR_OFF)
//#define STRAP_OPTIONS				(GLOBAL_CONTROL_BASE + STRAP_OPTIONS_OFF)

#define MISC_CONTROL_REG			((volatile UINT32 *)MISC_CONTROL)
#define IXP_RESET0_REG				((volatile UINT32 *)IXP_RESET0)
#define CCR_REG						((volatile UINT32 *)CCR)
//#define STRAP_OPTIONS_REG			((volatile UINT32 *)STRAP_OPTIONS)



// Strap Options bit definitions
#define CFG_PCI_BOOT_HOST     		(1 << 2)
#define CFG_RST_DIR	  				(1 << 0)                                            

#define SOFT_INT					(1 << 0)

//Global CSR bit definitions
#define WDOG_RST_ENABLE				(1 << 24)

#endif   // __IXP2800GLOBAL_H



