/* IXP2800IntCtl.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem:
 *  author:
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef __IXP2800INTCTL_H
#define __IXP2800INTCTL_H

// interrupt registers //
#define INTERRUPT_CONTROLLER_BASE	0xD6000000

#define FIQ_STATUS_OFF				0x4
#define IRQ_STATUS_OFF				0x8
#define FIQ_ENABLE_OFF				0xC
#define FIQ_ENABLE_SET_OFF			0xC
#define IRQ_ENABLE_OFF				0x10
#define IRQ_ENABLE_SET_OFF			0x10
#define FIQ_ENABLE_CLR_OFF			0x14
#define IRQ_ENABLE_CLR_OFF			0x18
#define FIQ_IRQ_SOFT_INT_OFF		0x54

#define IRQ_STATUS_REG			((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ IRQ_STATUS_OFF))
#define IRQ_ENABLE_REG			((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ IRQ_ENABLE_OFF))
#define IRQ_ENABLE_SET_REG		((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ IRQ_ENABLE_SET_OFF))
#define IRQ_ENABLE_CLR_REG		((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ IRQ_ENABLE_CLR_OFF))
#define FIQ_STATUS_REG			((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ FIQ_STATUS_OFF))
#define FIQ_ENABLE_REG			((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ FIQ_ENABLE_OFF))
#define FIQ_ENABLE_SET_REG		((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ FIQ_ENABLE_SET_OFF))
#define FIQ_ENABLE_CLR_REG		((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ FIQ_ENABLE_CLR_OFF))
#define FIQ_IRQ_SOFT_INT_REG	((volatile UINT32 *)(INTERRUPT_CONTROLLER_BASE \
								+ FIQ_IRQ_SOFT_INT_OFF))

 #endif   // __IXP2800INTCTL_H



