/* ixp2800media.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXP2800MEDIA_H
#define __IXP2800MEDIA_H

#define MASTER_NPU 0
#define SLAVE_NPU  0
#define MEDIA_LOOPBACK_TX_ME			0x0
#define MEDIA_LOOPBACK_RX_ME			0x0

// SPI-4 Rx enable 64 bytes, 1 way, duplex
#define RX_CTL_WD						0x40000000	
	
// SPI-4 Tx enable Enable General Transmit
#define TX_CTL_WD						0x20000400		

// CSIX_TYPE_MAP 
#define CSIX_MAP_WD           			0x00005AA8		

// Tx Element Control word 64 bytes
#define Tx_ELM_WD						0x40000000	  	
#define CSIX_Tx_ELM_WD					0x40000001	  	
#define Tx_ELM_Ex_WD 					0x0
#define CSIX_Tx_ELM_Ex_WD 				0x87654321

// MAILBOX Message defines
#define DM_EGRESS_SYNC					0x11
#define DM_EGRESS_DATA_LOCATION			0x12
#define DM_TEST_COMPLETE				0x13
#define DM_INGRESS_MEDIA_TEST           0x20
#define DM_INGRESS_SYNC					0x21
#define DM_INGRESS_RXRDY				0x22
#define DM_INGRESS_PACKETS_RCVD			0x23     
#define DM_CLEANUP_COMPLETE				0x24
#define DM_PACKETSRCVD					0x25
#define DM_INIT_INGRESS_SCRATCH			0x26
#define DM_INGRESS_START				0x27
#define DM_INGRESS_TRAIN_COMPLETE       0x28
#define DM_EGRESS_TRAIN_COMPLETE        0x29
#define DM_LOAD_RX_UCODE				0x2A
#define DM_EGRESS_INIT					0x2B
#define DM_EGRESS_RXRDY				    0x2C
#define DM_EGRESS_START_TRAIN			0x2D

#define DM_CSIX_IMI1					0x30
#define DM_CSIX_IMI2					0x31
#define DM_CSIX_IMI3					0x32
#define DM_CSIX_IMI4					0x33
#define DM_CSIX_EMI1					0x34
#define DM_CSIX_EMI2					0x35
#define DM_CSIX_EMI3					0x36
#define DM_CSIX_EMI4					0x37
#define DM_CSIX_ITP						0x38



// Size of XScale Media storage area        
#define XS_MEDIA_STORAGE_SIZE			0x3ffc

#define XS_TESTPARAMETERS				0x0
#define XS_MACNUMBER					0x0
#define XS_NUMBEROFMACPORTS				0x04
#define XS_TOTALPACKETCOUNT				0x08
#define XS_MACTYPE						0x0C
#define XS_TXRXPACKETDATA				0x20
#define XS_TXPACKETCOUNT				0x70
#define XS_RXPACKETCOUNT				0xB0
#define XS_RXPACKETERR					0xF0

#define RXPORTDATA						0x200
#define XS_RXPORTDATA					0x200



// End XScale Media test storage area 

#define MEDIA_DELAY 0x50

// Start Ueng Media test storage area 
#define UENG_MEDIA_STORAGE_START   		0xCA000000 //Scratch OOffset        
#define UENG_MEDIA_STORAGE_END			(UENG_MEDIA_STORAGE_START + 0x200)

#define TESTPARAMETERS					(UENG_MEDIA_STORAGE_START + 0x0)
#define MACNUMBER						(TESTPARAMETERS + 0x0)
#define NUMBEROFMACPORTS				(TESTPARAMETERS + 0x1)
#define TotalPACKETCOUNT				(TESTPARAMETERS + 0x2)

#define TXRXPACKETDATA					(UENG_MEDIA_STORAGE_START + 0x20)
#define TXRXPACKETDATA0					(TXRXPACKETDATA + 0x00)					
#define TXRXPACKETDATA1					(TXRXPACKETDATA + 0x04)
#define TXRXPACKETDATA2					(TXRXPACKETDATA + 0x08)
#define TXRXPACKETDATA3					(TXRXPACKETDATA + 0x0C)
#define TXRXPACKETDATA4					(TXRXPACKETDATA + 0x10)
#define TXRXPACKETDATA5					(TXRXPACKETDATA + 0x14)
#define TXRXPACKETDATA6					(TXRXPACKETDATA + 0x18)
#define TXRXPACKETDATA7					(TXRXPACKETDATA + 0x1C)
#define TXRXPACKETDATA8					(TXRXPACKETDATA + 0x20)
#define TXRXPACKETDATA9					(TXRXPACKETDATA + 0x24)
#define TXRXPACKETDATAA					(TXRXPACKETDATA + 0x28)
#define TXRXPACKETDATAB					(TXRXPACKETDATA + 0x2C)
#define TXRXPACKETDATAC					(TXRXPACKETDATA + 0x30)
#define TXRXPACKETDATAD					(TXRXPACKETDATA + 0x34)
#define TXRXPACKETDATAE					(TXRXPACKETDATA + 0x38)
#define TXRXPACKETDATAF	 				(TXRXPACKETDATA + 0x3C)

#define TXPACKETCOUNT					(UENG_MEDIA_STORAGE_START + 0x70)
#define TXPACKETCOUNT0					(TXPACKETCOUNT + 0x00)					
#define TXPACKETCOUNT1					(TXPACKETCOUNT + 0x04)
#define TXPACKETCOUNT2					(TXPACKETCOUNT + 0x08)
#define TXPACKETCOUNT3					(TXPACKETCOUNT + 0x0C)
#define TXPACKETCOUNT4					(TXPACKETCOUNT + 0x10)
#define TXPACKETCOUNT5					(TXPACKETCOUNT + 0x14)
#define TXPACKETCOUNT6					(TXPACKETCOUNT + 0x18)
#define TXPACKETCOUNT7					(TXPACKETCOUNT + 0x1C)
#define TXPACKETCOUNT8					(TXPACKETCOUNT + 0x20)
#define TXPACKETCOUNT9					(TXPACKETCOUNT + 0x24)

#define RXPACKETCOUNT					(UENG_MEDIA_STORAGE_START + 0xB0)
#define RXPACKETCOUNT0					(RXPACKETCOUNT + 0x00)					
#define RXPACKETCOUNT1					(RXPACKETCOUNT + 0x04)
#define RXPACKETCOUNT2					(RXPACKETCOUNT + 0x08)
#define RXPACKETCOUNT3					(RXPACKETCOUNT + 0x0C)
#define RXPACKETCOUNT4					(RXPACKETCOUNT + 0x10)
#define RXPACKETCOUNT5					(RXPACKETCOUNT + 0x14)
#define RXPACKETCOUNT6					(RXPACKETCOUNT + 0x18)
#define RXPACKETCOUNT7					(RXPACKETCOUNT + 0x1C)
#define RXPACKETCOUNT8					(RXPACKETCOUNT + 0x20)
#define RXPACKETCOUNT9					(RXPACKETCOUNT + 0x24)

#define RXPACKETERR						(UENG_MEDIA_STORAGE_START + 0xF0)
#define RXPACKETERR0					(RXPACKETERR + 0x00)					
#define RXPACKETERR1					(RXPACKETERR + 0x04)
#define RXPACKETERR2					(RXPACKETERR + 0x08)
#define RXPACKETERR3					(RXPACKETERR + 0x0C)
#define RXPACKETERR4					(RXPACKETERR + 0x10)
#define RXPACKETERR5					(RXPACKETERR + 0x14)
#define RXPACKETERR6					(RXPACKETERR + 0x18)
#define RXPACKETERR7					(RXPACKETERR + 0x1C)
#define RXPACKETERR8					(RXPACKETERR + 0x20)
#define RXPACKETERR9					(RXPACKETERR + 0x24)




// End MEDIA Ueng TEST DATA area defines
#define FREELIST_INFO					0x7000
#define CSIX_MAP_DATA					0x5AA8

// with 64 byte packets in SPI-4 mode
#define MAX_ELEM_COUNT                  128

// Start of packet for TBUF/RBUF control
#define	SOP								0x200 

// End of packet for TBUF/RBUF control
#define	EOP								0x100	  

#ifndef UCA_BUILD

void Set_Blinking_LED(char* buffer, int blink_times, int ms);

#endif UCA_BUILD

#define HIGHWATER				0x3f

#define MASK_16BIT				0xFFFF

#endif   // __IXP2800MEDIA_H


 