/* ixp2800Msf.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: 
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */
#ifndef __IXP2800MSF_H
#define __IXP2800MSF_H


// MSF registers  
#define MSF_BASE					0xC8000000

#define MSF_RX_CONTROL_OFF			0x0
#define MSF_TX_CONTROL_OFF			0x4
#define MSF_INTERRUPT_STATUS_OFF	0x08      
#define MSF_INTERRUPT_ENABLE_OFF	0x0C      
#define CSIX_TYPE_MAP_OFF		    0x10      
#define HWM_CNTL_OFF				0x24
#define RX_THREAD_FREELIST_0_OFF    0x30
#define RX_PORT_MAP_OFF				0x40
#define RBUF_ELEMENT_DONE           0x44
#define MAILBOX_0_OFF				0x50	
#define MAILBOX_1_OFF				0x54
#define MAILBOX_2_OFF				0x58
#define MAILBOX_3_OFF				0x5C	
#define TX_SEQUENCE_0_OFF         	0x60
#define TX_SEQUENCE_1_OFF         	0x64
#define TX_SEQUENCE_2_OFF         	0x68
#define TRAIN_DATA					0xA0
#define TX_CALENDAR_0_OFF		 	0x1000     	// (0 TO 255 / 0x1000 - 0x13FC)
#define TX_PORT_STATUS_0_OFF	 	0x1400     	// (0 TO 255 / 0x1400 - 0x17FC)
#define TBUF_ELEMENT_CONTROL_OFF	0x1800      // (0 to 127 / 0x1800 - 0x1BFC)
#define RBUF_TBUF_OFF		 		0x2000      // (8KB      / 0x2000 - 0x3FFF)


#endif   // __IXP2800MSF_H



