/* ixp2800SowPort.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: Intel
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXP2800SLOWPORT_H
#define __IXP2800SLOWPORT_H


// slowport registers //
#define SLOWPORT_REGISTER_BASE		0xC0080000
#define SLOW_PORT_BASE 				SLOWPORT_REGISTER_BASE

#define SP_CCR_OFF					0x0
#define SP_WTC1_OFF					0x4
#define SP_RTC1_OFF					0xC
#define SP_FAC_OFF					0x20
#define SP_FRM_OFF					0x24

#define SP_CCR						(SLOWPORT_REGISTER_BASE + SP_CCR_OFF)
#define SP_WTC1						(SLOWPORT_REGISTER_BASE + SP_WTC1_OFF)
#define SP_RTC1						(SLOWPORT_REGISTER_BASE + SP_RTC1_OFF)
#define SP_FAC						(SLOWPORT_REGISTER_BASE + SP_FAC_OFF)
#define SP_FRM						(SLOWPORT_REGISTER_BASE + SP_FRM_OFF)

#define SP_CCR_REG					((volatile UINT32 *)SP_CCR)
#define SP_WTC1_REG					((volatile UINT32 *)SP_WTC1)
#define SP_RTC1_REG					((volatile UINT32 *)SP_RTC1)
#define SP_FAC_REG					((volatile UINT32 *)SP_FAC)
#define SP_FRM_REG					((volatile UINT32 *)SP_FRM)



#endif   // __IXP2800SLOWPORT_H



