/* ixp2x00.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: 
 *  author: Intel
 *
 * 
 * 
 * --------------------------------------------------------------------------
 */
/* ixp2x00.h Header for the Intel IXP2{8,4}00 Xscale Chip */

/*
modification history
--------------------
01c, 08/18/03 ajp Added pass/fail struct for script file break on error
01b,13Aug02,jjd  Added SRAM definitions
01a,21May02,jjd  Created
*/

/*
This module contains definitions for Registers and
resources internal to Intel's IXP2{8,4}00 Xscale Chip.
*/

#ifndef _INCixp2x00h
#define _INCixp2x00h

#ifdef IXP2800
#define RDRAM_0_BASE    0xd0009000
#define RDRAM_1_BASE    0xd000a000
#define RDRAM_2_BASE    0xd000b000

#define RDRAM_0_CONTROL               (RDRAM_0_BASE + 0x0)
#define RDRAM_0_ERR_STAT_1            (RDRAM_0_BASE + 0x08)
#define RDRAM_0_ERR_STAT_2            (RDRAM_0_BASE + 0x10)
#define RDRAM_0_ECC_TEST              (RDRAM_0_BASE + 0x18)
#define RDRAM_0_SERIAL_CMD            (RDRAM_0_BASE + 0x20)
#define RDRAM_0_SERIAL_DATA           (RDRAM_0_BASE + 0x28)
#define RDRAM_0_CONFIG_1              (RDRAM_0_BASE + 0x30)
#define RDRAM_0_CONFIG_2              (RDRAM_0_BASE + 0x38)
#define RDRAM_0_CONFIG_3              (RDRAM_0_BASE + 0x40)
#define RDRAM_0_RAC_INIT              (RDRAM_0_BASE + 0x48)
#define RDRAM_0_MISC_RAC_CONTROL      (RDRAM_0_BASE + 0x50)
#define RDRAM_0_RAC_CONFIG            (RDRAM_0_BASE + 0x58)
#define RDRAM_0_1066_CONFIG_GRP       (RDRAM_0_BASE + 0x60)
#define RDRAM_0_SERIAL_CONFIG         (RDRAM_0_BASE + 0x68)
#define RDRAM_0_K0                    (RDRAM_0_BASE + 0x100)
#define RDRAM_0_K1                    (RDRAM_0_BASE + 0x108)
#define RDRAM_0_K2                    (RDRAM_0_BASE + 0x110)    
#define RDRAM_0_K3                    (RDRAM_0_BASE + 0x118)
#define RDRAM_0_K4                    (RDRAM_0_BASE + 0x120)
#define RDRAM_0_K5                    (RDRAM_0_BASE + 0x128)
#define RDRAM_0_K6                    (RDRAM_0_BASE + 0x130)
#define RDRAM_0_K7                    (RDRAM_0_BASE + 0x138)
#define RDRAM_0_K8                    (RDRAM_0_BASE + 0x140)
#define RDRAM_0_K9                    (RDRAM_0_BASE + 0x148)
#define RDRAM_0_K10                   (RDRAM_0_BASE + 0x150)
#define RDRAM_0_K11                   (RDRAM_0_BASE + 0x158)
                               
#define RDRAM_1_CONTROL               (RDRAM_1_BASE + 0x0)
#define RDRAM_1_ERR_STAT_1            (RDRAM_1_BASE + 0x08)
#define RDRAM_1_ERR_STAT_2            (RDRAM_1_BASE + 0x10)
#define RDRAM_1_ECC_TEST              (RDRAM_1_BASE + 0x18)
#define RDRAM_1_SERIAL_CMD            (RDRAM_1_BASE + 0x20)
#define RDRAM_1_SERIAL_DATA           (RDRAM_1_BASE + 0x28)
#define RDRAM_1_CONFIG_1              (RDRAM_1_BASE + 0x30)
#define RDRAM_1_CONFIG_2              (RDRAM_1_BASE + 0x38)
#define RDRAM_1_CONFIG_3              (RDRAM_1_BASE + 0x40)
#define RDRAM_1_RAC_INIT              (RDRAM_1_BASE + 0x48)
#define RDRAM_1_MISC_RAC_CONTROL      (RDRAM_1_BASE + 0x50)
#define RDRAM_1_RAC_CONFIG            (RDRAM_1_BASE + 0x58)
#define RDRAM_1_1066_CONFIG_GRP       (RDRAM_1_BASE + 0x60)
#define RDRAM_1_SERIAL_CONFIG         (RDRAM_1_BASE + 0x68)
#define RDRAM_1_K0                    (RDRAM_1_BASE + 0x100)
#define RDRAM_1_K1                    (RDRAM_1_BASE + 0x108)
#define RDRAM_1_K2                    (RDRAM_1_BASE + 0x110)    
#define RDRAM_1_K3                    (RDRAM_1_BASE + 0x118)
#define RDRAM_1_K4                    (RDRAM_1_BASE + 0x120)
#define RDRAM_1_K5                    (RDRAM_1_BASE + 0x128)
#define RDRAM_1_K6                    (RDRAM_1_BASE + 0x130)
#define RDRAM_1_K7                    (RDRAM_1_BASE + 0x138)
#define RDRAM_1_K8                    (RDRAM_1_BASE + 0x140)
#define RDRAM_1_K9                    (RDRAM_1_BASE + 0x148)
#define RDRAM_1_K10                   (RDRAM_1_BASE + 0x150)
#define RDRAM_1_K11                   (RDRAM_1_BASE + 0x158)

#define RDRAM_2_CONTROL               (RDRAM_2_BASE + 0x0)
#define RDRAM_2_ERR_STAT_1            (RDRAM_2_BASE + 0x08)
#define RDRAM_2_ERR_STAT_2            (RDRAM_2_BASE + 0x10)
#define RDRAM_2_ECC_TEST              (RDRAM_2_BASE + 0x18)
#define RDRAM_2_SERIAL_CMD            (RDRAM_2_BASE + 0x20)
#define RDRAM_2_SERIAL_DATA           (RDRAM_2_BASE + 0x28)
#define RDRAM_2_CONFIG_1              (RDRAM_2_BASE + 0x30)
#define RDRAM_2_CONFIG_2              (RDRAM_2_BASE + 0x38)
#define RDRAM_2_CONFIG_3              (RDRAM_2_BASE + 0x40)
#define RDRAM_2_RAC_INIT              (RDRAM_2_BASE + 0x48)
#define RDRAM_2_MISC_RAC_CONTROL      (RDRAM_2_BASE + 0x50)
#define RDRAM_2_RAC_CONFIG            (RDRAM_2_BASE + 0x58)
#define RDRAM_2_1066_CONFIG_GRP       (RDRAM_2_BASE + 0x60)
#define RDRAM_2_SERIAL_CONFIG         (RDRAM_2_BASE + 0x68)
#define RDRAM_2_K0                    (RDRAM_2_BASE + 0x100)
#define RDRAM_2_K1                    (RDRAM_2_BASE + 0x108)
#define RDRAM_2_K2                    (RDRAM_2_BASE + 0x110)    
#define RDRAM_2_K3                    (RDRAM_2_BASE + 0x118)
#define RDRAM_2_K4                    (RDRAM_2_BASE + 0x120)
#define RDRAM_2_K5                    (RDRAM_2_BASE + 0x128)
#define RDRAM_2_K6                    (RDRAM_2_BASE + 0x130)
#define RDRAM_2_K7                    (RDRAM_2_BASE + 0x138)
#define RDRAM_2_K8                    (RDRAM_2_BASE + 0x140)
#define RDRAM_2_K9                    (RDRAM_2_BASE + 0x148)
#define RDRAM_2_K10                   (RDRAM_2_BASE + 0x150)
#define RDRAM_2_K11                   (RDRAM_2_BASE + 0x158)

#define RDRAM_CONTROL_Size8MB         (0 << 8)
#define RDRAM_CONTROL_Size16MB        (1 << 8)
#define RDRAM_CONTROL_Size32MB        (2 << 8)
#define RDRAM_CONTROL_Size64MB        (3 << 8)
#define RDRAM_CONTROL_Size128MB       (4 << 8)
#define RDRAM_CONTROL_Size256MB       (5 << 8)
#define RDRAM_CONTROL_Size512MB       (6 << 8)
#define RDRAM_CONTROL_Size1GB         (7 << 8)
#define RDRAM_CONTROL_SizeMask        0x700
#define RDRAM_CONTROL_NumChannels(x)  ( ((x) - 1) << 11)  /* only if x={1,2,3} */
#define RDRAM_CONTROL_NumChannelsMask (3 << 11)
#define RDRAM_CONTROL_ParityEnable    (1 << 14)
#define RDRAM_CONTROL_EccEnable       (2 << 14)
#define RDRAM_CONTROL_ReadBkPresDis   (1 << 16)         /* Read BackPressure Disable */
#define RDRAM_CONTROL_BankRemap(x)    ( ((x) & 0x3) << 18)

#define RDRAM_SERIAL_CMD_SerOpMask    0xf
#define RDRAM_SERIAL_CMD_SerDev(x)    ( ((x) & 0x3f) << 4)
#define RDRAM_SERIAL_CMD_SerBcast     (1 << 10)
#define RDRAM_SERIAL_CMD_SerAddr(x)   ( ((x) & 0xfff) << 11)
//#define RDRAM_SERIAL_CMD_SclkFreqDiv(x)  ( ((x) & 0xff) << 23) // deprecated
#define RDRAM_SERIAL_CMD_Busy         (1 << 31)

#define RDRAM_CONFIG_1_tRCD(x)        ( ((x) & 0xf) << 0) /* {5,7,9,11} */
#define RDRAM_CONFIG_1_tCAC(x)        ( ((x) & 0xf) << 4) /* {8,9,10,11,12} */
#define RDRAM_CONFIG_1_tCACMask       0xf0
#define RDRAM_CONFIG_1_tRASSyn(x)     ( (((x) & 0x1f) >> 2) << 8) /* {16,20,24,28} */
#define RDRAM_CONFIG_1_tRP(x)         ( ((x) & 0xf) << 12)  /* {6,8,10,12} */
#define RDRAM_CONFIG_1_tOffp(x)       ( ((x) & 0x7) << 16)  /* {4,5,6,7} */
#define RDRAM_CONFIG_1_tOffpMask      0x70000
#define RDRAM_CONFIG_1_RacStep2Enable (1 << 19)
#define RDRAM_CONFIG_1_tRASRefSyn(x)  ( (((x) & 0x3f) >> 2) << 20) /* {16,20,24, etc} */
#define RDRAM_CONFIG_1_tRPrefSyn(x)   ( (((x) & 0xf) >> 2) << 24)  /* {8,12,16, etc} */
#define RDRAM_CONFIG_1_CCTestMode(x)  ( ((x) & 0x7) << 28)
#define RDRAM_CONFIG_1_BtoBRead       (1 << 31)

#define RDRAM_CONFIG_3_NDevMask       (0x3F << 0)
#define RDRAM_CONFIG_3_DepBanks       (1 << 6)
#define RDRAM_CONFIG_3_SplitCore      (1 << 7)
#define RDRAM_CONFIG_3_2KPage         (1 << 8)
#define RDRAM_CONFIG_3_RowMask        (0xF << 9)
#define RDRAM_CONFIG_3_BankMask       (0x7 << 13)

#define RDRAM_RAC_INIT_InitInProgress (1 << 0)
#define RDRAM_RAC_INIT_DoRacInit      (1 << 1)
#define RDRAM_RAC_INIT_ClockLock      (1 << 2)
#define RDRAM_RAC_INIT_RacT44Timer(x) ( ((x) & 0x3ff) << 3)
#define RDRAM_RAC_INIT_RacCctlIn(x)   ( ((x) & 0x7f) << 13)
#define RDRAM_RAC_INIT_MaskCurrentCtl (1 << 20)
#define RDRAM_RAC_INIT_Step6Busy      (1 << 21)
#define RDRAM_RAC_INIT_Step5Busy      (1 << 22)
#define RDRAM_RAC_INIT_AllInitDone    (1 << 23)
#define RDRAM_RAC_INIT_InitRefCctlCnt(x) ( ((x) & 0xf) << 24)
#define RDRAM_RAC_INIT_DoStep6        (1 << 28)
#define RDRAM_RAC_INIT_DoStep5        (1 << 29)
#define RDRAM_RAC_INIT_RacReset       (1 << 30)
#define RDRAM_RAC_INIT_RacPowerup     (1 << 31)

#define RDRAM_SERIAL_CONFIG_SclkFreqDiv(x) ( ((x) & 0xff) << 0)
#define RDRAM_SERIAL_CONFIG_NapXCnt(x)     ( ((x) & 0xf) << 8)
#define RDRAM_SERIAL_CONFIG_Pdnx(x)        ( ((x) & 0xf) << 12)
#define RDRAM_SERIAL_CONFIG_PdnxMask       0xf000
#define RDRAM_SERIAL_CONFIG_Napx(x)        ( ((x) & 0xf) << 16)
#define RDRAM_SERIAL_CONFIG_NapxMask       0x0f00
#define RDRAM_SERIAL_CONFIG_RintStart(x)   ( ((x) & 0xff) << 20)
#define RDRAM_SERIAL_CONFIG_RintWidth(x)   ( ((x) & 0xf) << 28)

/* RDRAM Control Register Addresses */
#define INIT     0x021
#define TEST34   0x022
#define CNFGA    0x023
#define CNFGB    0x024
#define DEVID    0x040
#define REFB     0x041
#define REFR     0x042
#define CCA      0x043
#define CCB      0x044
#define NAPX     0x045
#define PDNXA    0x046
#define PDNX     0x047
#define TPARM    0x048
#define TFRM     0x049
#define TCDLY1   0x04a
#define TCYCLE   0x04c
#define SKIP     0x04b
#define TEST77   0x04d
#define TEST78   0x04e
#define TEST79   0x04f
#define TCPS     0x055   

/* RDRAM SIO Operations */ 
#define SIORESETOP	0xe	/* Reset the SIO interface of RDRAMs */
#define SIOSETROP	0x2	/* Perform secondary reset to RDRAMs */
#define SIOCLRROP	0xb	/* Clear secondary reset to RDRAMs */
#define SIOWRITEOP	0x1	/* SIO write register operation to RDRAMs */
#define SIOREADOP	0x0	/* SIO read register operation to RDRAMs */
#define SIOPDNEOP	0xf	/* Power down exit operation */
#define SIOSETFOP	0x4	/* Set fast (normal) clock mode */

/* RDRAM SIO Broadcast */
#define SIOSBC	0x400        
#else

#define DU_BASE        0xd0000000
#define DU_CONTROL     (DU_BASE + 0x00)
#define DU_ERR_STAT1   (DU_BASE + 0x08)
#define DU_ERR_STAT2   (DU_BASE + 0x10)
#define DU_ECC_TEST    (DU_BASE + 0x18)
#define DU_INIT        (DU_BASE + 0x20)
#define DU_CONTROL2    (DU_BASE + 0x28)

#endif /* IXP2800 */

/* scratch definitions */
#define SCRATCH_BASE    0xca000000
#define SCRATCH_SIZE    0x00004000

/* slowport definitions */
#define SP_BASE         0xc0080000
#define SP_CCR          (SP_BASE + 0x00)        /* clock configuration */
#define SP_WTC1         (SP_BASE + 0x04)        /* write timing 1 */
#define SP_WTC2         (SP_BASE + 0x08)        /* write timing 2 */
#define SP_RTC1         (SP_BASE + 0x0c)        /* read timing 1 */
#define SP_RTC2         (SP_BASE + 0x10)        /* read timing 2 */
#define SP_FSR          (SP_BASE + 0x14)        /* fault status */
#define SP_PCR          (SP_BASE + 0x18)        /* protocol control */
#define SP_ADC          (SP_BASE + 0x1c)        /* address size / data width */
#define SP_FAC          (SP_BASE + 0x20)        /* flash address size */
#define SP_FRM          (SP_BASE + 0x24)        /* flash read mode */
#define SP_FIN          (SP_BASE + 0x28)        /* framer interrupt enable */

#define SP_CCR_DivisorMask       0x0f

#define SP_WTC_SetupMask         (0xf << 6)
#define SP_WTC_SetupCycles(x)	( ((x) & 0xf) << 6)
#define SP_WTC_PulseWidthMask    (0xf << 2)
#define SP_WTC_PulseWidthCycles(x)	( ((x) & 0xf) << 2)
#define SP_WTC_HoldMask          (0x3 << 0)
#define SP_WTC_HoldCycles(x)	( (x) & 0x3)
#define SP_RTC_SetupMask         (0xf << 6)
#define SP_RTC_SetupCycles		( ((x) & 0xf) << 6)
#define SP_RTC_PulseWidthMask    (0xf << 2)
#define SP_RTC_PulseWidthCycles	( ((x) & 0xf) << 2)
#define SP_RTC_HoldMask          (0x3 << 0)
#define SP_RTC_HoldCycles(x)	( (x) & 0x3)

#define SP_FSR_ReadTimeoutDev1   (1 << 0)
#define SP_FSR_WriteTimeoutDev1  (1 << 1)
#define SP_FSR_ReadTimeoutDev2   (1 << 2)
#define SP_FSR_WriteTimeoutDev2  (1 << 3)
#define SP_FSR_FramerInterrupt   (1 << 4)

#define SP_PCR_ModeMask          0xf
#define SP_PCR_Mode(x)           ( (x) & 0xf )

#define SP_ADC_AddrSpaceMask     0x3
#define SP_ADC_AddrSpace8Bit     (0 << 0)
#define SP_ADC_AddrSpace16Bit    (1 << 0)
#define SP_ADC_AddrSpace24Bit    (2 << 0)
#define SP_ADR_AddrSpace32Bit    (3 << 0)       /* actually 25 bits */
#define SP_ADR_DataWidthMask     (0x3 << 4)
#define SP_ADR_DataWidth8Bit     (0 << 4)
#define SP_ADR_DataWidth16Bit    (1 << 4)
#define SP_ADR_DataWidth24Bit    (2 << 4)       /* not used */
#define SP_ADR_DataWidth32Bit    (3 << 4)

#define SP_FAC_AddrSpace8Bit     (0 << 0)
#define SP_FAC_AddrSpace16Bit    (1 << 0)
#define SP_FAC_AddrSpace24Bit    (2 << 0)
#define SP_FAC_AddrSpace32Bit    (3 << 0)       /* 25 bit */

#define SP_FRM_Use32Bit          (0 << 0)
#define SP_FRM_Use8Bit           (1 << 0)

#define SP_FIN_FramerInt         (1 << 0)

/* Global Control (CAP CSR) */
#define GLOBAL_CSR_BASE     0xc0004a00
#define PRODUCT_ID          (GLOBAL_CSR_BASE + 0x00)
#define MISC_CONTROL        (GLOBAL_CSR_BASE + 0x04)
#ifndef IXP2800
#define MCCR                (GLOBAL_CSR_BASE + 0x08)
#endif 
#define RESET_0             (GLOBAL_CSR_BASE + 0x0C)
#define RESET_1             (GLOBAL_CSR_BASE + 0x10)
#define CLOCK_CONTROL       (GLOBAL_CSR_BASE + 0x14)
#define STRAP_OPTIONS       (GLOBAL_CSR_BASE + 0x18)

/* PRODUCT_ID bitfields */
#define PRODUCT_ID_MinRevMask	(0xF << 0)
#define PRODUCT_ID_MajRevMask	(0xF << 4)
#define PRODUCT_ID_ProdMask		(0xFFF << 8)
#define PRODUCT_ID_Astep		(0 << 4)
#define PRODUCT_ID_Bstep		(1 << 4)

/* MISC_CONTROL bitfields */
#define MISC_CONTROL_FlashAliasDisable       (1 << 8)
#define MISC_CONTROL_FlashWriteEnable        (1 << 9)

/* RESET_0 bitfields */
#define RESET_0_XScale                  (1 << 0)
#define RESET_0_Pci                     (1 << 1)
#define RESET_0_AssertPciRst            (1 << 2)
#define RESET_0_Sram0                   (1 << 3)
#define RESET_0_Sram1                   (1 << 4)
#ifdef IXP2800
#define RESET_0_Sram2                   (1 << 5)
#define RESET_0_Sram3                   (1 << 6)
#endif /* IXP2800 */
#define RESET_0_Media                   (1 << 7)
#define RESET_0_Dram0                   (1 << 11)
#ifdef IXP2800
#define RESET_0_Dram1                   (1 << 12)
#define RESET_0_Dram2                   (1 << 13)
#endif /* IXP2800 */
#define RESET_0_ExtRst                  (1 << 15)
#define RESET_0_RstAll                  (1 << 16)
#define RESET_0_Shac                    (1 << 17)
#define RESET_0_DbusArb                 (1 << 18)
#define RESET_0_SbusArb                 (1 << 19)
#define RESET_0_CmdArb                  (1 << 20)
#define RESET_0_InitComplete            (1 << 21)
#ifdef IXP2800
#define RESET_0_ExtRstEnable            (1 << 22)
#endif /* IXP2800 */
#define RESET_0_WatchDogRstEnable       (1 << 24)

/* CLOCK_CONTROL bitfields */
#define CLOCK_CONTROL_Sram0ClkMask           (0xf << 0)
#define CLOCK_CONTROL_Sram1ClkMask           (0xf << 4)
#ifdef IXP2800
#define CLOCK_CONTROL_Sram2ClkMask           (0xf << 8)
#define CLOCK_CONTROL_Sram3ClkMask           (0xf << 12)
#endif
#ifndef IXP2800
#define CLOCK_CONTROL_DramClkMask            (0xf << 16)
#endif
#ifdef IXP2800
#define CLOCK_CONTROL_MsfClkMask             (0xf << 20)
#define CLOCK_CONTROL_ApbClkMask             (0xf << 24)
#define CLOCK_CONTROL_ApbClkShift            24
#endif

#define STRAP_OPTIONS_CfgPllMask        (0x3f << 8)
#define STRAP_OPTIONS_CfgPll(x)         ( ((x) & 0x3f) << 8)
#define STRAP_OPTIONS_CfgBootHost	(1 << 2)
#define STRAP_OPTIONS_CfgRstDir         (1 << 0)

/* SRAM Controller */
#define SRAM_BASE	0x80000000
#define SRAM_0_BASE	0xcc010000
#define SRAM_1_BASE	0xcc410000
#ifdef IXP2800
#define SRAM_2_BASE	0xcc810000
#define SRAM_3_BASE	0xccc10000
#endif

#define SRAM_CONTROL_OFFSET		0x0
#define SRAM_INT_PIPELINE_OFFSET	0x108
#define SRAM_RX_DLL_OFFSET		0x228
#define SRAM_RD_PTR_OFFSET_OFFSET	0x240
#define SRAM_RX_DESKEW_OFFSET		0x244
#define SRAM_RCMP_SETUP_CTL_OFFSET	0x300
#define SRAM_RCMP_SCOMP_OVERRIDE	0x314
#define SRAM_RCMP_SLEW_INDEX_CTL_OFFSET	0x318
#define SRAM_RCMP_ADDR_PMOS_PU0		0x340
#define SRAM_RCMP_ADDR_PMOS_PU1		0x344
#define SRAM_RCMP_ADDR_PMOS_PU2		0x348
#define SRAM_RCMP_ADDR_PMOS_PU3		0x34c
#define SRAM_RCMP_ADDR_NMOS_PD0		0x350
#define SRAM_RCMP_ADDR_NMOS_PD1		0x354
#define SRAM_RCMP_ADDR_NMOS_PD2		0x358
#define SRAM_RCMP_ADDR_NMOS_PD3		0x35c
#define SRAM_RCMP_DATA_PMOS_PU0		0x360
#define SRAM_RCMP_DATA_PMOS_PU1		0x364
#define SRAM_RCMP_DATA_PMOS_PU2		0x368
#define SRAM_RCMP_DATA_PMOS_PU3		0x36c
#define SRAM_RCMP_DATA_NMOS_PD0		0x370
#define SRAM_RCMP_DATA_NMOS_PD1		0x374
#define SRAM_RCMP_DATA_NMOS_PD2		0x378
#define SRAM_RCMP_DATA_NMOS_PD3		0x37c
#define SRAM_RCMP_KCLK_PMOS_PU0		0x380
#define SRAM_RCMP_KCLK_PMOS_PU1		0x384
#define SRAM_RCMP_KCLK_PMOS_PU2		0x388
#define SRAM_RCMP_KCLK_PMOS_PU3		0x38c
#define SRAM_RCMP_KCLK_NMOS_PD0		0x390
#define SRAM_RCMP_KCLK_NMOS_PD1		0x394
#define SRAM_RCMP_KCLK_NMOS_PD2		0x398
#define SRAM_RCMP_KCLK_NMOS_PD3		0x39c
#define SRAM_RCMP_DQ_PMOS_PU0		0x3a0
#define SRAM_RCMP_DQ_PMOS_PU1		0x3a4
#define SRAM_RCMP_DQ_PMOS_PU2		0x3a8
#define SRAM_RCMP_DQ_PMOS_PU3		0x3ac
#define SRAM_RCMP_DQ_NMOS_PD0		0x3b0
#define SRAM_RCMP_DQ_NMOS_PD1		0x3b4
#define SRAM_RCMP_DQ_NMOS_PD2		0x3b8
#define SRAM_RCMP_DQ_NMOS_PD3		0x3bc
#define SRAM_SLEW_POWERUP_DEFAULT	0x30003333

#define SRAM_0_CONTROL	(SRAM_0_BASE + 0x00)
#define SRAM_0_PARITY_STATUS1	(SRAM_0_BASE + 0x04)
#define SRAM_0_PARITY_STATUS2	(SRAM_0_BASE + 0x08)
#define SRAM_0_INT_PIPELINE	(SRAM_0_BASE + 0x108)
#define SRAM_0_RX_DLL		(SRAM_0_BASE + 0x228)
#define SRAM_0_RD_PTR_OFFSET	(SRAM_0_BASE + 0x240)
#define SRAM_0_RX_DESKEW	(SRAM_0_BASE + 0x244)
#define SRAM_0_RCMP_SETUP_CTL	(SRAM_0_BASE + 0x300)
#define SRAM_0_RCMP_SLEW_INDEX_CTL (SRAM_0_BASE + 0x318)

#define SRAM_1_CONTROL	(SRAM_1_BASE + 0x00)
#define SRAM_1_PARITY_STATUS1	(SRAM_1_BASE + 0x04)
#define SRAM_1_PARITY_STATUS2	(SRAM_1_BASE + 0x08)
#define SRAM_1_INT_PIPELINE	(SRAM_1_BASE + 0x108)
#define SRAM_1_RX_DLL		(SRAM_1_BASE + 0x228)
#define SRAM_1_RD_PTR_OFFSET	(SRAM_1_BASE + 0x240)
#define SRAM_1_RX_DESKEW	(SRAM_1_BASE + 0x244)
#define SRAM_1_RCMP_SETUP_CTL	(SRAM_1_BASE + 0x300)
#define SRAM_1_RCMP_SLEW_INDEX_CTL (SRAM_1_BASE + 0x318)
#ifdef IXP2800
#define SRAM_2_CONTROL	(SRAM_2_BASE + 0x00)
#define SRAM_2_PARITY_STATUS1	(SRAM_2_BASE + 0x04)
#define SRAM_2_PARITY_STATUS2	(SRAM_2_BASE + 0x08)
#define SRAM_2_INT_PIPELINE	(SRAM_2_BASE + 0x108)
#define SRAM_2_RX_DLL		(SRAM_2_BASE + 0x228)
#define SRAM_2_RD_PTR_OFFSET	(SRAM_2_BASE + 0x240)
#define SRAM_2_RX_DESKEW	(SRAM_2_BASE + 0x244)
#define SRAM_2_RCMP_SETUP_CTL	(SRAM_2_BASE + 0x300)
#define SRAM_2_RCMP_SLEW_INDEX_CTL (SRAM_2_BASE + 0x318)

#define SRAM_3_CONTROL	(SRAM_3_BASE + 0x00)
#define SRAM_3_PARITY_STATUS1	(SRAM_3_BASE + 0x04)
#define SRAM_3_PARITY_STATUS2	(SRAM_3_BASE + 0x08)
#define SRAM_3_INT_PIPELINE	(SRAM_3_BASE + 0x108)
#define SRAM_3_RX_DLL		(SRAM_3_BASE + 0x228)
#define SRAM_3_RD_PTR_OFFSET	(SRAM_3_BASE + 0x240)
#define SRAM_3_RX_DESKEW	(SRAM_3_BASE + 0x244)
#define SRAM_3_RCMP_SETUP_CTL	(SRAM_3_BASE + 0x300)
#define SRAM_3_RCMP_SLEW_INDEX_CTL (SRAM_3_BASE + 0x318)
#endif

/* SRAM_X_CONTROL bits */
#define SRAM_CONTROL_ParityEnable	(1 << 3)
#define SRAM_CONTROL_PortCtl0		(1 << 4)
#define SRAM_CONTROL_PortCtl1		(1 << 5)
#define SRAM_CONTROL_SizeMask		(7 << 7)
#define SRAM_CONTROL_Size512K		(0 << 7)
#define SRAM_CONTROL_Size1M		(1 << 7)
#define SRAM_CONTROL_Size2M		(2 << 7)
#define SRAM_CONTROL_Size4M		(3 << 7)
#define SRAM_CONTROL_Size8M		(4 << 7)
#define SRAM_CONTROL_Size16M		(5 << 7)
#define SRAM_CONTROL_Size32M		(6 << 7)
#define SRAM_CONTROL_Pipecycles(x)	( ((x) & 0x7) << 10)
#define SRAM_CONTROL_QCIgnSegCnt	(1 << 13)
#define SRAM_CONTROL_QCIgnEOP		(1 << 14)
#define SRAM_CONTROL_Swizzle		(1 << 17)

/* SRAM_X_PARITY_STATUS1 bits */
#define SRAM_PARITY_STATUS1_AddrMask	0xffffff
#define SRAM_PARITY_STATUS1_WWParity0	(1 << 28)
#define SRAM_PARITY_STATUS1_WWParity1	(1 << 29)
#define SRAM_PARITY_STATUS1_WWParity2	(1 << 30)
#define SRAM_PARITY_STATUS1_WWParity3	(1 << 31)

/* SRAM_X_PARITY_STATUS2 bits */
#define SRAM_PARITY_STATUS2_Err0	(1 << 0)
#define SRAM_PARITY_STATUS2_Err1	(1 << 1)
#define SRAM_PARITY_STATUS2_Err2	(1 << 2)
#define SRAM_PARITY_STATUS2_Err3	(1 << 3)
#define SRAM_PARITY_STATUS2_SrcXscalePci	(0 << 16)
#define SRAM_PARITY_STATUS2_SrcME	(1 << 16)
#define SRAM_PARITY_STATUS2_ThdXscale	(0 << 17)
#define SRAM_PARITY_STATUS2_ThdPci	(1 << 17)
#define SRAM_PARITY_STATUS2_ThdMask	(0x7 << 17)
#define SRAM_PARITY_STATUS2_MEMask	(0x1F << 20)
#define SRAM_PARITY_STATUS2_MultiErr	(1 << 31)

/* SRAM_X_INT_PIPELINE bits */
#define SRAM_INT_PIPELINE_Minus1	(0 << 0)
#define SRAM_INT_PIPELINE_Nominal	(1 << 0)
#define SRAM_INT_PIPELINE_Add1		(2 << 0)

/* SRAM_X_RX_DLL bits */
#define SRAM_RX_DLL_SlaveSelMask	0x1f
#define SRAM_RX_DLL_SlaveSel(x)		((x) & SRAM_RX_DLL_SlaveSelMask)

/* SRAM_X_RD_PTR_OFFSET bits */
#define SRAM_RD_PTR_OFFSET_PtrOffsetMask	0x3
#define SRAM_RD_PTR_OFFSET_PtrOffset(x)		((x) & SRAM_RD_PTR_OFFSET_PtrOffsetMask)

/* SRAM_X_RX_DESKEW bits */
#define SRAM_RX_DESKEW_MasterSelMask	0x1f
#define SRAM_RX_DESKEW_MasterSel(x)	((x) & SRAM_RX_DESKEW_MasterSelMask)

/* SRAM_RCMP_SCOMP_OVERRIDE bits (B0) */
#define SRAM_RCMP_SCOMP_OVERRIDE_KClockEnable	(3 << 0)
#define SRAM_RCMP_SCOMP_OVERRIDE_TxDllDisable	(1 << 2)
#define SRAM_RCMP_SCOMP_OVERRIDE_RxDllDisable	(1 << 3)
#define SRAM_RCMP_SCOMP_OVERRIDE_WrFifoPhaseDisable	(1 << 6)

/* SRAM_X_RCMP_SETUP_CTL bits */
#define SRAM_RCMP_SETUP_CTL_RoePmos	(1 << 0)
#define SRAM_RCMP_SETUP_CTL_RoeNmos	(1 << 1)
#define SRAM_RCMP_SETUP_CTL_Frcmp	(1 << 2)
#define SRAM_RCMP_SETUP_CTL_RcmpSmDisable	(1 << 3)
#define SRAM_RCMP_SETUP_CTL_BlockRcmpUpdates	(1 << 4)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod16ms	(0 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod8ms	(1 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod4ms	(2 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod2ms	(3 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod1ms	(4 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod500us	(5 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod250us	(6 << 5)
#define SRAM_RCMP_SETUP_CTL_RcmpPeriod250Clks	(7 << 5)
#define SRAM_RCMP_SETUP_CTL_FilterDisable	(0 << 8)
#define SRAM_RCMP_SETUP_CTL_FilterClamp1	(1 << 8)
#define SRAM_RCMP_SETUP_CTL_FilterClamp2	(2 << 8)
#define SRAM_RCMP_SETUP_CTL_FilterClamp4	(3 << 8)
#define SRAM_RCMP_SETUP_CTL_TablesProgrammed	(1 << 10)
#define SRAM_RCMP_SETUP_CTL_RcmpLock		(1 << 11)
#define SRAM_RCMP_SETUP_CTL_DQRSOverride	(1 << 12)
#define SRAM_RCMP_SETUP_CTL_KRSOverride		(1 << 13)
#define SRAM_RCMP_SETUP_CTL_DRSOverride		(1 << 14)
#define SRAM_RCMP_SETUP_CTL_ARSOverride		(1 << 15)
#define SRAM_RCMP_SETUP_CTL_IncDecInvert	(1 << 16)
#define SRAM_RCMP_SETUP_CTL_SlewIndexSel	(1 << 17)

/* SRAM_X_SLEW_INDEX_CTL bits */
#define SRAM_SLEW_INDEX_CTL_DQStrength(x)	(((x) & 0xf) << 0)
#define SRAM_SLEW_INDEX_CTL_DQSlewClamp		(1 << 4)
#define SRAM_SLEW_INDEX_CTL_KStrength(x)	(((x) & 0xf) << 5)
#define SRAM_SLEW_INDEX_CTL_KSlewClamp		(1 << 9)
#define SRAM_SLEW_INDEX_CTL_DStrength(x)	(((x) & 0xf) << 10)
#define SRAM_SLEW_INDEX_CTL_DSlewClamp		(1 << 14)
#define SRAM_SLEW_INDEX_CTL_AStrength(x)	(((x) & 0xf) << 15)
#define SRAM_SLEW_INDEX_CTL_ASlewClamp		(1 << 19)

/* Timer */
#define TIMER_0_BASE	0xc0020000
#define TIMER_0_CTL	(TIMER_0_BASE + 0)
#define TIMER_0_CLD	(TIMER_0_BASE + 0x10)
#define TIMER_0_CSR	(TIMER_0_BASE + 0x20)
#define TIMER_0_CLR	(TIMER_0_BASE + 0x30)

#define TIMER_4_BASE	0xc002000c
#define TIMER_4_CTL	(TIMER_4_BASE + 0)
#define TIMER_4_CLD	(TIMER_4_BASE + 0x10)
#define TIMER_4_CSR	(TIMER_4_BASE + 0x20)
#define TIMER_4_CLR	(TIMER_4_BASE + 0x30)

#define TIMER_CTL_Act	(1 << 7)


#ifndef __ASSEMBLER__
typedef struct _PassFail_testOut
{
	UINT32 PassFail;
	UINT32 ReturnCode;
} PassFail_testOut;
#endif



#endif /* _INCixp2x00h */
