/* mac.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp
 *  revision:
 * 
 * --------------------------------------------------------------------------
 */

#ifndef MAC_H
#define MAC_H
void InitIXF1110Mac(int, int, int);
void InitIXF1810Mac(int, int, int);
void InitSF12345(int, int);
void InitNullMac(int, int, int);
void Cleanup_before_return(void);
void ZeroEgressMailboxes(void);
void ZeroIngressMailboxes(void);

#define SZ_1M        0x00100000

#ifndef Angel_debug
#define MAXMACDEV    0x2  // On IXMB2800 board
#else
#define MAXMACDEV    0x1  // On IXMB2800 board
#endif //Angel_debug

enum{ 	MACNone	= 0x0, MACIXF1110 = 0x1, MACIXF1810 = 0x2};

#define MAC_PORT_CNT 10

#define MEDIA_BOARD_BASE 0xC6000000
#define SF_BOARD_BASE    0xC6800000
#define MacIOSz	         0x800000   // Each gets 8Meg


#define BOARD_IXD28192 0x28192  // Cross Island	Board
#define BOARD_IXD02810 0x02810  // Georges Island Board


#define AUTO_NEG_MAX_COUNT 300 // delay_ms(10) * 300 = 3 seconds

struct CsrAddDat
{
	int	CsrAddr;
	int	CsrData;
};

struct MacDat 
{
 	int		MacType;   		// type of MAC device
	char	*Descstr;
	int		PortCnt;		// number of ports	
	int		IOBase;
	void	(*MacInitFunc)(int, int, int);	// Init function to call
};


#endif //MAC_H