/* mem_test.c.c
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp, Jul, 10, 02
 *  revisions:
 * 
 01b, 08/20/03 ajp Modified the returns for script file break on error
 01a, 08/18/03 ajp Added pass/fail returns for script file break on error
 * 
 * --------------------------------------------------------------------------
 */
#include "vdtdf1.h"
#include "vm.h"		   
#include "cmd.h"
#include "ixp2x00.h"
#include "ixp2800diag.h"


UINT32 fnActualTest(UINT32 Start, UINT32 End, UINT32 Width, UINT32 NumberOfPatterns, char Scope);
void write_data_TDF1( UINT32 Width, UINT32 Addr, UINT32 Data);
UINT32 read_data_TDF1( UINT32 Width, UINT32 Addr);


int all_mem_tests(TDF1_in *pIn, PassFail_testOut *pOut,unsigned long *pOutputStructureNumber)
{
int pass1, pass2, pass6;
//Start of main routine
	TDF1(pIn, pOut, pOutputStructureNumber);
	pass1 = pOut->PassFail;
	TDF2(pIn, pOut, pOutputStructureNumber);
	pass2 = pOut->PassFail;
	TDF5(pIn, pOut, pOutputStructureNumber);
	TDF6(pIn, pOut, pOutputStructureNumber);
	pass6 = pOut->PassFail;

	pOut->ReturnCode = PASS;         
	pOut->PassFail = (pass1 | pass2 | pass6);
	return(pOut->PassFail);

}
  

Command(CMD_MEM, "mem", all_mem_tests, SIZESUFFIX|SILENTTYPE|DIAGNOSTIC, "TDF1", "runs memory tests TDF1, TDF2, TDF5, and TDF6");
Arg(UINT32ARG,"start address", "enter the start address of the memory to be tested");
Arg(UINT32ARG, "end address", "enter the end address of the memory to be tested");
OptArg(UINT32ARG, "number of patterns to perform (1 or 2)", "perform two tests on each address (1 or 2)",1);
OptArg(CHAR2ARG,"escape", "select ability to exit diagnostic whilst running (y or n)","n");
OptArg(CHAR4ARG,"scopeloop", "select ability to loop on error (y or n)","n"); 
Output(UINT32ARG, "Return Code");
Output(CHAR8ARG, "Result");
NewOutput(UINT32ARG, "Return Code");
Output(CHAR8ARG, "Result");
Output(UINT32ARG, "Address");
Output(UINT32ARG, "Expected");
Output(UINT32ARG, "Read");
NewOutput(UINT32ARG, "Return Code");
Output(CHAR64ARG, "Error");
CommandEnd();
   