/* msf.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: dalsraja, March, 2002
 *  revisions:
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef MSF_H
#define MSF_H

#ifndef IXP2800
#include "common.h"
#endif //IXP2800

#define MSF_BASE							0xC8000000

#define MSF_RX_CONTROL						0x0000
#define MSF_TX_CONTROL						0x0004
#define CSIX_TYPE_MAP						0x0010
#define HWM_CONTROL							0x0024
#define RX_MPHY_POLL_LIMIT					0x0048
#define RX_THREAD_FREELIST_TIMEOUT_0		0x0050
#define RX_THREAD_FREELIST_TIMEOUT_1		0x0054
#define RX_THREAD_FREELIST_TIMEOUT_2		0x0058

#define MSF_RX_CONTROL_MASK					0x007F220C
#define MSF_TX_CONTROL_MASK					0x007F200C
#define CSIX_TYPE_MAP_MASK					0xFFFFFFFF
#define HWM_CONTROL_MASK					0x00000FCF
#define RX_MPHY_POLL_LIMIT_MASK				0x0000000F
#define RX_THREAD_FREELIST_TIMEOUT_0_MASK	0x00000FFF
#define RX_THREAD_FREELIST_TIMEOUT_1_MASK	0x00000FFF
#define RX_THREAD_FREELIST_TIMEOUT_2_MASK	0x00000FFF
#define RX_THREAD_FREELIST_TIMEOUT_3_MASK	0x00000FFF
#define TX_MPHY_P0LL_LIMIT_MASK				0x0000000F
#define RX_UP_CONTROL_0_MASK				0x0000003F
#define RX_UP_CONTROL_1_MASK				0x0000003F
#define RX_UP_CONTROL_2_MASK				0x0000003F
#define RX_UP_CONTROL_3_MASK				0x0000003F
#define TX_UP_CONTROL_0_MASK				0x0000001F
#define TX_UP_CONTROL_1_MASK				0x0000001F
#define TX_UP_CONTROL_2_MASK				0x0000001F
#define TX_UP_CONTROL_3_MASK				0x0000001F

#define UNICAST_RX_ME						0
#define UNICAST_TX_ME						0
#define UNICAST_DRAM_BASE_SRC				0x01000000
#define UNICAST_DRAM_BASE_DEST				0x02000000
#define CBUS_RX_ME							0
#define CBUS_TX_ME							0
#define CBUS_DRAM_BASE_SRC					0x01000000
#define CBUS_SRAM_BASE_DEST					0x02000000

#define EXT_HDR								0x11223344

int Msf_Register_Test(void);
int Msf_Unicast_Test(void);
void Msf_Unicast_Test_Slave(void);
int Msf_Cbus_Test(void);
void Msf_Cbus_Test_Slave(void);


#endif
