/* pci_diag.h
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: dalsraja, Feb 2002
 * 
 * --------------------------------------------------------------------------
 */

#ifndef PCI_DIAG_H
#define PCI_DIAG_H

#define SET_BIT(bit_no)			(0xFFFFFFFF & (1 << bit_no))
#define RESET_BIT(bit_no)		~(0xFFFFFFFF & (1 << bit_no))
#define XSCALE_PCI_REG_BASE		PCI_CFG_REG_BASE
#define XSCALE_DOORBELL			(XSCALE_PCI_REG_BASE + 0x60)

#ifdef IXP2800
#define XSCALE_DOORBELL_OFF     0x60
#define SCRATCH_CSR_BASE_FRM_PCI	0xF0000
#define PCI_CSR_BASE_FRM_PCI	0xFE000
#endif //IXP2800

#define STRAP_OPTION			STRAP_OPTIONS
#define DBELL_PATT1				0xCAFE
#define DBELL_PATT2				0x0000FEED
#define DBELL_PATT3				0xEDFE0000

#define VENDOR_INTEL			0x8086
#define DEVICE_21555			0xB555
#define DEVICE_21154			0xB154
#define DEVICE_NIC				0x1209
#define DEVICE_NPU				0x9004

#define DBELL_BIT				0
#define MSF_U_BIT				1
#define MSF_C_BIT				2
#define SF_LB_BIT				3
#define MEDIA_LB_BIT			4
#define SF_SPI4_LB_BIT			5
#define READ_TEMP_BIT			6


#ifdef IXP2800
void InitDoorbellIRQ (void);

int Find_i21555(void);
int Find_i21154(void);
int Pci_Doorbell_Test(void);
void Doorbell_Intr_Received(void);
void Set_Pci_Doorbell(int bit_num, int db_intr_addr);
int Pci_Dma_Test(void);

#define TB_VENDOR_ID				0x8086
#define TB_DEVICE_ID				0xB154

/* 21154 PCI-to-PCI Bridge register offset */
#define VIDR_OFF					0x0
#define DIDR_OFF					0x2
#define PCR_OFF						0x4
#define PSR_OFF						0x6
#define RIDR_OFF					0x8
#define PIR_OFF						0x9
#define CLSR_OFF					0xC
#define PLTR_OFF					0xD
#define HTR_OFF						0xE
#define PBNR_OFF					0x18
#define SBNR_OFF					0x19
#define SUBBNR_OFF					0x1A
#define SLTR_OFF					0x1B
#define IOBR_OFF					0x1C
#define IOLR_OFF					0x1D
#define SSR_OFF						0x1E
#define MBR_OFF						0x20
#define MLR_OFF						0x22
#define PMBR_OFF					0x24
#define PMLR_OFF					0x26
#define ECPPR_OFF					0x34
#define SUBIDR_OFF					0x36
#define BCR_OFF						0x3E
#define TB_CCR_OFF					0x40
#define	ACR_OFF						0x42

#endif //IXP2800

#endif
