/* tcam.c
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: IXDP2800
 *  subsystem: DIAG
 *  author: ajp, Jan 14, 03
 *  revisions:
 * 								 
 * 
 * --------------------------------------------------------------------------
 */

#include "vm.h"		   
#include "cmd.h"
#include "ixp2800Diag.h"
#include "ixp2800Msf.h"
#include "ixp2000pci.h"
#include "ixp2000Pci.h"
#include "ixp2800Global.h"
#include "ixp2800Media.h"
#include "ixp2x00.h"



//*****************************************************************
// Function:    void TCAM_test(void* pUnused)
// Description: Calls IDT TCAM parser
// Input:		None
// Outputs:		None
//*****************************************************************

void TCAM_test(void* pUnused)
	{
	UINT32 look_at;


//register_dump()


	if(IS_EGRESS_NPU)
	{
	printf("TCAM test must be performed on Ingress NPU only\n");
	return;
	}

	else
	{
	printf("TCAM diagnostic test\n");
	}
	// SRAM_CONTROL
//	*(volatile unsigned int *)(0xccc10000) = 0x600;
	// QDR_RX_DLL
//	*(volatile unsigned int *)(0xccc10228) = 0x52;
	// QDR_RD_PTR_OFFSET
//	*(volatile unsigned int *)(0xccc10240) = 0x4;
	// QDR_RX_DESKEW
//	*(volatile unsigned int *)(0xccc10244) = 0x12;
	// Q_RCMP_SETUP_CONTROL
//	*(volatile unsigned int *)(0xccc10300) = 0x10160;
	// Q_RCMP_STRENGTH_SLEW_INDEX_SEL
//	*(volatile unsigned int *)(0xccc10318) = 0x518c3;

	*(volatile unsigned int *)(0xc0004a0c)  = 0x2008000;
	DelayNUsec(10000);
	*(volatile unsigned int *)(0xb0018000)  = 0x1800001;
	DelayNUsec(10000);
	
	look_at = *(volatile unsigned int *)(0xb0000004);
	if(look_at == 0x21E067)
	 	printf("Found the TCAM\n");
	else
		{
	 	printf("TCAM not found\n");
		printf("offset 4 = 0x%X\n", look_at);
		return;
		}
	
	// Call the IDT TCAM parser - their code handles parsing from this point
	IDT_main();
	return;
}


//void register_dump()
//{
//UINT32 look_at;
//
//	look_at = *(volatile unsigned int *)(0xc0004a14);
//	printf("CLK_CONTROL(0xc0004a14) = 0x%X\n", look_at); 
//
//	printf("SRAM 0 data\n");
//
//
//	look_at = *(volatile unsigned int *)(0xcc010000);
//	printf("SRAM_CONTROL_00(0xcc010000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010004);
//	printf("SRAM_PARITY1_00(0xcc010004) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010008);
//	printf("SRAM_PARITY2_00(0xcc010008) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010228);
//	printf("RX_DLL_00(0xcc010228) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010244);
//	printf("RX_DESKEW_00(0xcc010244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010108);
//	printf("INT_PIPELINE_00(0xcc010108) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010240);
//	printf("RD_PTR_OFFSET_00(0xcc010240) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010304);
//	printf("RCMP_PMOS_MEAS_I00(0xcc010304) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010308);
//	printf("RCMP_NMOS_MEAS_I00(0xcc010308) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc01030c);
//	printf("RCMP_PMOS_OVRD_I00(0xcc01030c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010310);
//	printf("RCMP_NMOS_OVRD_I00(0xcc010310) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010314);
//	printf("RCMP_SCOMP_OVRD_I00(0xcc010314) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc01031c);
//	printf("RCMP_ADDR_PMOS_PU_OFF_I00(0xcc01031c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010320);
//	printf("RCMP_ADDR_NMOS_PD_OFF_I00(0xcc010320) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010324);
//	printf("RCMP_DATA_PMOS_PU_OFF_I00(0xcc010324) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010328);
//	printf("RCMP_DATA_NMOS_PD_OFF_I00(0xcc010328) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc01032c);
//	printf("RCMP_KCLK_PMOS_PU_OFF_I00(0xcc01032c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010330);
//	printf("RCMP_KCLK_NMOS_PD_OFF_I00(0xcc010330) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010334);
//	printf("RCMP_DQ_PMOS_PU_OFF_I00(0xcc010334)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010338);
//	printf("RCMP_DQ_NMOS_PD_OFF_I00(0xcc010338)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc01033c);
//	printf("RCMP_VERT_OVRD_I00(0xcc01033c)        = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010300);
//	printf("RCMP_SETUP_CTL_I00(0xcc010300) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010318);
//	printf("RCMP_STRENGTH_SLEW_IDX_SEL_I00(0xcc010318) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010228);
//	printf("RX_DLL_I00(0xcc010228)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010244);
//	printf("RX_DESKEW_I00(0xcc010244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010000);
//	printf("CONTROL_I00(0xcc010000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010108);
//	printf("INT_PIPELINE_I00(0xcc010108)  = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc010240);
//	printf("RD_PTR_OFFSET_I00(0xcc010240) = 0x%X\n", look_at);
//
//
//
//	printf("SRAM 1 data\n");
//
//	look_at = *(volatile unsigned int *)(0xcc410000);
//	printf("SRAM_CONTROL_00(0xcc410000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410004);
//	printf("SRAM_PARITY1_00(0xcc410004) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410008);
//	printf("SRAM_PARITY2_00(0xcc410008) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410228);
//	printf("RX_DLL_00(0xcc410228) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410244);
//	printf("RX_DESKEW_00(0xcc410244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410108);
//	printf("INT_PIPELINE_00(0xcc410108) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410240);
//	printf("RD_PTR_OFFSET_00(0xcc410240) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410304);
//	printf("RCMP_PMOS_MEAS_I00(0xcc410304) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410308);
//	printf("RCMP_NMOS_MEAS_I00(0xcc410308) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc41030c);
//	printf("RCMP_PMOS_OVRD_I00(0xcc41030c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410310);
//	printf("RCMP_NMOS_OVRD_I00(0xcc410310) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410314);
//	printf("RCMP_SCOMP_OVRD_I00(0xcc410314) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc41031c);
//	printf("RCMP_ADDR_PMOS_PU_OFF_I00(0xcc41031c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410320);
//	printf("RCMP_ADDR_NMOS_PD_OFF_I00(0xcc410320) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410324);
//	printf("RCMP_DATA_PMOS_PU_OFF_I00(0xcc410324) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410328);
//	printf("RCMP_DATA_NMOS_PD_OFF_I00(0xcc410328) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc41032c);
//	printf("RCMP_KCLK_PMOS_PU_OFF_I00(0xcc41032c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410330);
//	printf("RCMP_KCLK_NMOS_PD_OFF_I00(0xcc410330) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410334);
//	printf("RCMP_DQ_PMOS_PU_OFF_I00(0xcc410334)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410338);
//	printf("RCMP_DQ_NMOS_PD_OFF_I00(0xcc410338)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc41033c);
//	printf("RCMP_VERT_OVRD_I00(0xcc41033c)        = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410300);
//	printf("RCMP_SETUP_CTL_I00(0xcc410300) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410318);
//	printf("RCMP_STRENGTH_SLEW_IDX_SEL_I00(0xcc410318) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410228);
//	printf("RX_DLL_I00(0xcc410228)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410244);
//	printf("RX_DESKEW_I00(0xcc410244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410000);
//	printf("CONTROL_I00(0xcc410000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410108);
//	printf("INT_PIPELINE_I00(0xcc410108)  = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc410240);
//	printf("RD_PTR_OFFSET_I00(0xcc410240) = 0x%X\n", look_at);
//
//
//
//	printf("SRAM 2 data\n");
//
//	look_at = *(volatile unsigned int *)(0xcc810000);
//	printf("SRAM_CONTROL_00(0xcc810000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810004);
//	printf("SRAM_PARITY1_00(0xcc810004) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810008);
//	printf("SRAM_PARITY2_00(0xcc810008) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810228);
//	printf("RX_DLL_00(0xcc810228) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810244);
//	printf("RX_DESKEW_00(0xcc810244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810108);
//	printf("INT_PIPELINE_00(0xcc810108) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810240);
//	printf("RD_PTR_OFFSET_00(0xcc810240) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810304);
//	printf("RCMP_PMOS_MEAS_I00(0xcc810304) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810308);
//	printf("RCMP_NMOS_MEAS_I00(0xcc810308) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc81030c);
//	printf("RCMP_PMOS_OVRD_I00(0xcc81030c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810310);
//	printf("RCMP_NMOS_OVRD_I00(0xcc810310) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810314);
//	printf("RCMP_SCOMP_OVRD_I00(0xcc810314) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc81031c);
//	printf("RCMP_ADDR_PMOS_PU_OFF_I00(0xcc81031c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810320);
//	printf("RCMP_ADDR_NMOS_PD_OFF_I00(0xcc810320) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810324);
//	printf("RCMP_DATA_PMOS_PU_OFF_I00(0xcc810324) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810328);
//	printf("RCMP_DATA_NMOS_PD_OFF_I00(0xcc810328) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc81032c);
//	printf("RCMP_KCLK_PMOS_PU_OFF_I00(0xcc81032c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810330);
//	printf("RCMP_KCLK_NMOS_PD_OFF_I00(0xcc810330) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810334);
//	printf("RCMP_DQ_PMOS_PU_OFF_I00(0xcc810334)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810338);
//	printf("RCMP_DQ_NMOS_PD_OFF_I00(0xcc810338)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc81033c);
//	printf("RCMP_VERT_OVRD_I00(0xcc81033c)        = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810300);
//	printf("RCMP_SETUP_CTL_I00(0xcc810300) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810318);
//	printf("RCMP_STRENGTH_SLEW_IDX_SEL_I00(0xcc810318) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810228);
//	printf("RX_DLL_I00(0xcc810228)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810244);
//	printf("RX_DESKEW_I00(0xcc810244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810000);
//	printf("CONTROL_I00(0xcc810000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810108);
//	printf("INT_PIPELINE_I00(0xcc810108)  = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xcc810240);
//	printf("RD_PTR_OFFSET_I00(0xcc810240) = 0x%X\n", look_at);
//
//
//
//
//	printf("SRAM 3 data\n");
//
//	look_at = *(volatile unsigned int *)(0xccc10000);
//	printf("SRAM_CONTROL_00(0xccc10000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10004);
//	printf("SRAM_PARITY1_00(0xccc10004) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10008);
//	printf("SRAM_PARITY2_00(0xccc10008) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10228);
//	printf("RX_DLL_00(0xccc10228) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10244);
//	printf("RX_DESKEW_00(0xccc10244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10108);
//	printf("INT_PIPELINE_00(0xccc10108) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10240);
//	printf("RD_PTR_OFFSET_00(0xccc10240) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10304);
//	printf("RCMP_PMOS_MEAS_I00(0xccc10304) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10308);
//	printf("RCMP_NMOS_MEAS_I00(0xccc10308) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc1030c);
//	printf("RCMP_PMOS_OVRD_I00(0xccc1030c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10310);
//	printf("RCMP_NMOS_OVRD_I00(0xccc10310) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10314);
//	printf("RCMP_SCOMP_OVRD_I00(0xccc10314) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc1031c);
//	printf("RCMP_ADDR_PMOS_PU_OFF_I00(0xccc1031c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10320);
//	printf("RCMP_ADDR_NMOS_PD_OFF_I00(0xccc10320) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10324);
//	printf("RCMP_DATA_PMOS_PU_OFF_I00(0xccc10324) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10328);
//	printf("RCMP_DATA_NMOS_PD_OFF_I00(0xccc10328) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc1032c);
//	printf("RCMP_KCLK_PMOS_PU_OFF_I00(0xccc1032c) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10330);
//	printf("RCMP_KCLK_NMOS_PD_OFF_I00(0xccc10330) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10334);
//	printf("RCMP_DQ_PMOS_PU_OFF_I00(0xccc10334)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10338);
//	printf("RCMP_DQ_NMOS_PD_OFF_I00(0xccc10338)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc1033c);
//	printf("RCMP_VERT_OVRD_I00(0xccc1033c)        = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10300);
//	printf("RCMP_SETUP_CTL_I00(0xccc10300) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10318);
//	printf("RCMP_STRENGTH_SLEW_IDX_SEL_I00(0xccc10318) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10228);
//	printf("RX_DLL_I00(0xccc10228)   = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10244);
//	printf("RX_DESKEW_I00(0xccc10244) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10000);
//	printf("CONTROL_I00(0xccc10000) = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10108);
//	printf("INT_PIPELINE_I00(0xccc10108)  = 0x%X\n", look_at);
//	look_at = *(volatile unsigned int *)(0xccc10240);
//	printf("RD_PTR_OFFSET_I00(0xccc10240) = 0x%X\n", look_at);
//
//
//}




// Macro Format: Command(CMD_CommandName,"Command Name",Func_Name,Options,"Friendly Name","Help String");
Command(CMD_TCAM,"tcam",TCAM_test,DIAGNOSTIC,"TCAM test","runs TCAM diagnostics");
CommandEnd();



