/***************************************************************************
*
* Module:		xscaletimebase.c
*
* Description:	Delay driver using xscale registers
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc.  All Rights Reserved
*
****************************************************************************/
//  Includes
#include "vm.h"

#define TICKS_PER_MSEC	50000			// shouldd be based off of CLOCKSPEED      
#define TICKS_PER_USEC  50
// Prototype
void DelayTBTicks(UINT32 nTicks);

/****************************************************************************
* Function:	DelayNMsec(UINT32 nMilliseconds);
*
* Purpose:	Delay for N milliseconds.
*
* Returns:	nothing
*****************************************************************************/
void DelayNMsec(UINT32 nMilliseconds)
{
    while(nMilliseconds > 100) {
        DelayTBTicks(TICKS_PER_MSEC * 100);
        nMilliseconds -= 100;
    }
    DelayTBTicks(TICKS_PER_MSEC * nMilliseconds);
}

/****************************************************************************
* Function:	DelayNUsec(UINT32 nMicroseconds);
*
* Purpose:	Delay for N microseconds.
*
* Returns:	nothing
*****************************************************************************/
void DelayNUsec(UINT32 nMicroseconds)
{
    while(nMicroseconds > 100) {
        DelayTBTicks(TICKS_PER_USEC * 100);
        nMicroseconds -= 100;
    }
    DelayTBTicks(TICKS_PER_USEC * nMicroseconds);
}

/****************************************************************************
* Function:	DelayTBTicks(UINT32 nTicks);
*
* Purpose:	Delay for N ticks.
*
* Returns:	nothing
*****************************************************************************/
void DelayTBTicks(UINT32 nTicks)
{
	BoardIOCtrl(DELAYTICKS, (void *)&nTicks);
}