*****************************************************************************
*
* Module:	vbiosasm.s
*
* Description:
*
* Project:	HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:	See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*****************************************************************************
*=== Includes ====================
	#include "cpu.h"
	#include "cpucore.h"

*=== External References =========

*=== Global Declarations =========
	.globl	_vbios

*****************************************************************************
* vbios - external entry point to call a registered vWARE function from an
* external application.
*****************************************************************************
* Called with:	R4 = function ID
*		R12 = tVwareEntry structure address
*		R12.Temporary[0] = original R4
* Returns:	whatever function returns
*****************************************************************************
_vbios:
	str	r5,[r12,#0x14]		#  Store calling functions r5 in ve->Temp[1]
	str	r6,[r12,#0x18]		#  Store calling functions r6 in ve->Temp[2]
	str	r7,[r12,#0x1C]		#  Store calling functions r7 in ve->Temp[3]
	str	lr,[r12,#0x20]		#  Store the return address in ve->Temp[4]
	str	r9,[r12,#0x0C]		#  Store calling functions R9 in ve->CallingContext.r9
	ldr	r9,[r12,#0x08]		#  Load R9 with visionWares R9 from ve->VwareContext.r9
	add	r7,r12,#0			#  Load R7 with pointer to ve 
	ldr	r5,=__LIBFUNC_START #  Load R5 with __LIBFUNC_START
	ldr	r6,=__LIBFUNC_END	#  Load R6 with __LIBFUNC_END
	sub	r6,r6,r5			#  Store the size of the libfuncs in R6
vbios0:	ldr	r12,[r5,#0]     #  Load the libfunc entry into R12
	ldr	r12,[r12,#0]		#  Dereference the pointer value to get the function number in R12
	cmp	r12,r4				#  Compare the function number with the input value (R4)
	beq	vbios1				#  Branch if match found to vbios1
	add	r5,r5,#8			#  Point R5 to next libfunc entry
	sub	r6,r6,#8			#  Decrement size by 8 bytes
	bne	vbios0				#  If size is not zero, loop to vbios0
	ldr	r12,[r7,#4]			#  No match found, so load R12 with ve->Unresolved
	cmp	r12,#0				#  If Unresolved function pointer is null, branch to vbios2
	beq	vbios2
	add	r5,r7,#0			#  Load R5 with a ptr to function to call (ve->Vector)
	ldr	r9,[r7,#0x0C]		#  Load R9 with ve->CallingContext.R9  (restore value)
	add	r0,r4,#0            #  Load the input function number into R0
	ldr	r1,[r7,#0x20]		#  Load r1 with the return address (ve->Temp[4])
	add	r1,r1,#-4
vbios1:	mov	lr,pc           #  Load LR with PC + 8 (vbios2)
	ldr	pc,[r5,#4]          #  Branch to function pointed to by R5 (returns to vbios2)
vbios2:	ldr	r9,[r7,#0x0C]   #  Restore R9  (r7 is not modified by previous function call)
	add	r12,r7,#0x14		#  Restore R12 to point to ve->Temp[1]
	ldmia	r12,{r5-r7,pc}  #  Restore R5-R7, then set the PC to the original LR value and branch there

	.end

