/******************************************************************************
*
* Module:		cpu.h
*
* Description:
*
* Project:		HSI VisionWare -- vWare
*
* Functions:
*
* Notes:
*
* History:		See Visual SourceSafe History
*
* Disclaimer:	Copyright 1999-2000 Wind River Systems, Inc. All Rights Reserved
*
*******************************************************************************/
#ifndef __CPU_H__
#define __CPU_H__

// Includes
#include "cpucore.h"
#ifdef YAVAPAI_CHIPSET
#include "yavapai.h"
#endif

#define TGTNAME	"80200"

/****************************************************************************
 * Vector number assignments.                                               *
 ***************************************************************************/
#ifndef __ASSEMBLER__
enum
{
	VECTOR_RESET = FIRSTVECTORID,
	VECTOR_UNDEFINED_OPCODE,
	VECTOR_SWI,
	VECTOR_PREFETCH_ABORT,
	VECTOR_DATA_ABORT,
	VECTOR_RESERVED,
	VECTOR_IRQ,
	VECTOR_FIRQ
};
#endif

/****************************************************************************
 * CPU-specific IRQ base                                                    *
 ***************************************************************************/
#define		CPUFIRQBASE (CPUIRQBASE + 64)

/****************************************************************************
 * CPU-specific API calls.                                                  *
 ***************************************************************************/
#ifndef __ASSEMBLER__
global void _InstallVector(UINT32 ID, CONTEXT *pContext, HANDLER Vector,
		void *pPrivateData);
#endif

/****************************************************************************
 * Symbolic names for general-purpose registers.                            *
 ***************************************************************************/
#ifdef __ASSEMBLER__
#define	a1	r0
#define	a2	r1
#define	a3	r2
#define	a4	r3
#define	v1	r4
#define	v2	r5
#define	v3	r6
#define	v4	r7
#define	v5	r8
#define	v6	r9
#define	sb	r9
#define	v7	r10
#define	sl	r10
#define	v8	r11
#define	fp	r11
#define	ip	r12
//#define	sp	r13						// already defined by the assembler
//#define	lr	r14						// already defined by the assembler
//#define	pc	r15						// already defined by the assembler
#endif									// #ifdef __ASSEMBLER__

/****************************************************************************
 * IOSync - this can be a macro, a function call, or an assembler macro.    *
 * IOSync is invoked in order to force all pending I/O operations to        *
 * complete.  The flash program and erase operations make use of this to    *
 * insure commands sent to the flash devices are sent in the correct order. *
 ***************************************************************************/
#define IOSync()
#define ISYNC

#endif									// __CPU_H__
