#CONFIG_BUILD = CONFIG

ifeq ($(strip $(CONFIG_BUILD)),CONFIG)

PLATFORM = WINDOWS

# CPU & Board Info
TGTCPU = IXP2800
TGTCORE = ARMV5ES
CPU = IXP2800

# VWARE Directory
VWAREDIR = C:/PROGRA~1/VISION~1/vWare

# Diab 'Bin' Directory
DIABDIR = C:/PROGRA~1/VISION~1/diab/4.4t/win32/bin

# Project Directory
BASEDIR = C:/PROGRA~1/VISION~1/projects/IXP28x0

# Define Memory Map
BOOTVECTOR = 0xC4000000
WORKSPACE = 0x03E00000
WORKSPACESIZE = 0x00100000
FLASHIMAGE = 0xC4008000

# Defines for drivers
BOOTFLASHFILE = 29F080x4

# Defines from components
LIBS += vBASE
LIBS += vCONSOLE
LIBS += vFILE
COMPONENTS += FFS
COMPONENTS += FLASH
DEFINES += PCI_ON
COMPONENTS += ESTACK
LIBS += vSTACK
LIBS += vTFTP
COMPONENTS += TFTP

# Adding directories for user files

# All Src Files from Each Component
CONFIGOBJECTS += 
CONFIGOBJECTS += boardinit
CONFIGOBJECTS += volume1
CONFIGOBJECTS += estackobjects
CONFIGOBJECTS += Intel_28F128J3_N_8_8_I
CONFIGOBJECTS += ixp2000pic
CONFIGOBJECTS += board
CONFIGOBJECTS += boot
CONFIGOBJECTS += bootasm
CONFIGOBJECTS += copy2flash
CONFIGOBJECTS += core
CONFIGOBJECTS += coreasm
CONFIGOBJECTS += cpu
CONFIGOBJECTS += cpuasm
CONFIGOBJECTS += entry
CONFIGOBJECTS += hdlx2416
CONFIGOBJECTS += irq
CONFIGOBJECTS += isr
CONFIGOBJECTS += ixp2000i2c
CONFIGOBJECTS += mmuasm
CONFIGOBJECTS += timestamp
CONFIGOBJECTS += vBaseLib
CONFIGOBJECTS += vbios
CONFIGOBJECTS += vbiosasm
CONFIGOBJECTS += vdlog
CONFIGOBJECTS += xscaletimebase
CONFIGOBJECTS += esd
CONFIGOBJECTS += ixp2000Timer
CONFIGOBJECTS += serial16550
CONFIGOBJECTS += shellvars
CONFIGOBJECTS += shShellHide
CONFIGOBJECTS += vSerialLib
CONFIGOBJECTS += diag_utils
CONFIGOBJECTS += ethernet
CONFIGOBJECTS += gpio
CONFIGOBJECTS += i2c_test
CONFIGOBJECTS += i8255xmdi
CONFIGOBJECTS += i8255xmdiw
CONFIGOBJECTS += led
CONFIGOBJECTS += ixd2810Autoneg
CONFIGOBJECTS += ixd2810Int
CONFIGOBJECTS += mac
CONFIGOBJECTS += uc_load
CONFIGOBJECTS += mem_test
CONFIGOBJECTS += vdmemblkcmp
CONFIGOBJECTS += vdmemcopy
CONFIGOBJECTS += vdmemfill
CONFIGOBJECTS += vdmemscan1
CONFIGOBJECTS += vdmemscan2
CONFIGOBJECTS += microengine
CONFIGOBJECTS += msf
CONFIGOBJECTS += pci_diag
CONFIGOBJECTS += pci_dma
CONFIGOBJECTS += msf_init
CONFIGOBJECTS += sf_loopback
CONFIGOBJECTS += Dump
CONFIGOBJECTS += FileLib
CONFIGOBJECTS += IdtFifo
CONFIGOBJECTS += IdtLog
CONFIGOBJECTS += IdtOSFunctions
CONFIGOBJECTS += IdtOsSupport
CONFIGOBJECTS += IdtStack
CONFIGOBJECTS += IipcDiagLayer
CONFIGOBJECTS += IipcLearnInstr
CONFIGOBJECTS += IipcMultiDatabaseLookupInstr
CONFIGOBJECTS += IipcMultiHitInstr
CONFIGOBJECTS += IipcQdrAgingDiag
CONFIGOBJECTS += IipcQdrConfigure
CONFIGOBJECTS += IipcQdrDiags
CONFIGOBJECTS += IipcQdrDiagsCli
CONFIGOBJECTS += IipcQdrDiagsCliMain
CONFIGOBJECTS += IIpcQdrDiagsSupport
CONFIGOBJECTS += IipcQdrDualWrite
CONFIGOBJECTS += IipcQdrMultiHitInvalidateInstr
CONFIGOBJECTS += IipcQdrSramCopyInstr
CONFIGOBJECTS += IipcQdrWriteKeepValidInstr
CONFIGOBJECTS += IipcReissueMDLInstr
CONFIGOBJECTS += ImsIntelXScaleIf
CONFIGOBJECTS += IpcLayer
CONFIGOBJECTS += Menu
CONFIGOBJECTS += Prompt
CONFIGOBJECTS += QdrIipcDpolFunctions
CONFIGOBJECTS += QdrIipcDptlFunctions
CONFIGOBJECTS += QdrIipcIlFunctions
CONFIGOBJECTS += tcam
CONFIGOBJECTS += temperature
CONFIGOBJECTS += timer_test
CONFIGOBJECTS += uart
CONFIGOBJECTS += xscale
CONFIGOBJECTS += vdclick
CONFIGOBJECTS += vderror
CONFIGOBJECTS += vdexec
CONFIGOBJECTS += vdloop
CONFIGOBJECTS += vdmemcompare
CONFIGOBJECTS += vdtdf1
CONFIGOBJECTS += vdtdf2
CONFIGOBJECTS += vdtdf3
CONFIGOBJECTS += vdtdf4
CONFIGOBJECTS += vdtdf5
CONFIGOBJECTS += vdtdf6
CONFIGOBJECTS += Intel_28F128J3_N_8_8_I
CONFIGOBJECTS += vFlashLib
CONFIGOBJECTS += Intel_28F128J3_N_8_8_I
CONFIGOBJECTS += tf
CONFIGOBJECTS += ixp2000pci
CONFIGOBJECTS += pciautoconfig
CONFIGOBJECTS += pciconfiglib
CONFIGOBJECTS += pciconfigshow
CONFIGOBJECTS += pcirw
CONFIGOBJECTS += vdpcisetshow
CONFIGOBJECTS += i8255x
CONFIGOBJECTS += estack
CONFIGOBJECTS += vNetLib
CONFIGOBJECTS += vxBootline
CONFIGOBJECTS += tftpclient
CONFIGOBJECTS += eed
CONFIGOBJECTS += media_test
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/bdxfile
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/binfile
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/cmdfile
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/dm
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/gohalt
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/dl
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/elffile
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/ffscmds
CONFIGOBJECTS += $(VWAREDIR)/Lib/ARMV5ES/type

endif

