########################################################################
#
# Module:       win32.mak
#
# Description:  Build rules for VisionWARE running on Windows 32.
#
# History:      See Visual SourceSafe History
#
# Disclaimer:   Copyright (c) 1995, 1998, 1999 EST Corporation
########################################################################


########################################################################
# Tool Location/Names                                                  #
########################################################################
UTILS = $(VWAREDIR)/utilities
C2ASM = $(UTILS)/c2asm
CC = $(Q)$(DIABDIR)/dplus $(TARGET_ARCH) $(P) $(R)
#CPP = $(Q)$(UTILS)/cpp -P
#CPP = $(Q)dcc -P
CPP = $(Q)$(DIABDIR)/dplus $(TARGET_ARCH) -P $(R)
AS = $(Q)$(DIABDIR)/das $(TARGET_ARCH) $(R)
LD = $(Q)$(DIABDIR)/dld $(TARGET_ARCH) $(R)
AR = $(Q)$(DIABDIR)/dar
ARFLAGS = ruc
CONVERT = $(Q)$(UTILS)/convert $(DASHQ)
RM = $(Q)$(UTILS)/hsicmd delete
ECHO = $(Q)$(UTILS)/hsicmd echo
FECHO = $(Q)$(UTILS)/hsicmd fecho
JOIN = $(Q)$(UTILS)/hsicmd join
CP = $(Q)$(UTILS)/hsicmd cpfiles
LEX = $(Q)$(UTILS)/RegLex
VWARELIB = $(Q)$(UTILS)/VwareLib
VWARELIBDIR = $(BASEDIR)/vwareLib
FROMELF = $(Q)$(UTILS)/fromelf
COPY = copy
TARGETLIST = $(Q)$(UTILS)/TargetList
SWAPBYTES = $(BASEDIR)/stripswapbytes

# Translate an elf file to a bdx file for debugging.
%.bdx: %.elf
	@$(ECHO) Creating $@.
	@$(CONVERT) $^ -b -c -l $(WORKSPACE)
	$(FROMELF) $(TARGET).elf
	$(CP) . $(BASEDIR)/Builds/$(TGTBOARD)/$(TGTBUILD) vWARE28x0.bdx vWARE28x0.ab vWARE28x0.abx vWARE28x0.Map vWARE28x0.out

# Translate an elf file into a binary file.
%.bin: %.elf
#	@$(ECHO) Converting $< to $@.
	@$(ECHO) Creating $@.
#	@$(ECHO) @$(CONVERT) $^ -a -c -l $(CONVERTADDR)
	@$(CONVERT) $^ -a -c -l $(CONVERTADDR)
	$(FROMELF) $(TARGET).elf
	$(SWAPBYTES) vWARE28x0.bin vware_swap28x0.bin
	$(CP) . $(BASEDIR)/Builds/$(TGTBOARD)/$(TGTBUILD) vWARE28x0.bin vWARE28x0.ab vWARE28x0.abx vWARE28x0.Map vWARE28x0.out vware_swap28x0.bin
