/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:01p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/common_types.h $
*   WORKFILE:       $Workfile: common_types.h $
*
* --------------------------------------------------------------------------
* Project: All
*
* Purpose: This file defines types that are common to all IXF API and driver 
*          modules
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/common_types.h $
 * 
 * 1     3/11/04 3:01p Tepulkow
 * 
 * 1     5/16/03 1:41p Tepulkow
* 
* 2     12/12/02 9:50p Machambe
* Adding ifdef IXF_LINUX on some types
* 
* 1     12/04/01 1:39p Jaalliso
* Common types file
* 
* --------------------------------------------------------------------------
*/
#ifndef __COMMON_TYPES_H__
#define __COMMON_TYPES_H__

/* Basic integer types
* Redefine these to ensure the correct sizes for each compiler. */

/* Define other integer types for compatiblity */
#ifdef IXF_LINUX

#include <sys/types.h>
typedef int sint;
typedef short sshort;
typedef char schar;
typedef unsigned char uchar;
typedef unsigned char boolean;  /* used in function calls */
#else
typedef int            sint;
typedef unsigned int   uint;
typedef long           slong;
typedef unsigned long  ulong;


#ifndef VXWORKS
typedef short          sshort;
typedef unsigned short ushort;
#endif

typedef char           schar;
typedef unsigned char  uchar;
typedef unsigned char  boolean; /* used in function calls */
#endif

#endif /* __COMMON_TYPES_H__ */
