/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:02p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/include/ixf18100_gfp.h $
*   WORKFILE:       $Workfile: ixf18100_gfp.h $
*
* --------------------------------------------------------------------------
* Project: ixf18100 family device API
*
* Purpose: This file contains function prototypes for GFP block related
*          routines
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/include/ixf18100_gfp.h $
 * 
 * 1     3/11/04 3:02p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 11    1/10/03 2:30p Pkjain2
* 
* 10    12/02/02 2:24p Kssaepha
* Added support for Setting GFP OpModes 
* 
* 7     7/11/02 4:21p Pkjain2
* Corrected some headers. Added Legal notice to some files. 
* 
* 6     7/10/02 3:23p Pkjain2
* 
* 5     7/08/02 1:16p Pkjain2
* Moved Calypso specific data stuctures into Calypso block specific data
* structure file.
* 
* 1     7/18/01 10:55a Rfranz
* Initial check in - file headers only
* 
* --------------------------------------------------------------------------
*/


#ifndef _IXF18100_GFP_H__
#define _IXF18100_GFP_H__


/******************************************************************************
* Function : Ixf18100GfpGlbSetCfg
*------------------------------------------------------------------------------
* Description  : The function takes the values from GFP global config structure
* and masks it appropriately and writes the 16 bit value into the register.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpGlbCfg_t *ptGfpGlbCfg: pointer to the values that need
*				to be set in the device
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpGlbSetCfg(bb_RegPointer_type BaseAddress,
                     ixf18100_GfpGlbCfg_t *ptGfpGlbCfg);

                     /******************************************************************************
                     * Function : Ixf18100GfpRxSetCfg
                     *------------------------------------------------------------------------------
                     * Description  : The function takes the values from GFP Rx config structure
                     * and masks it appropriately and writes the 16 bit value into the register.
                     *------------------------------------------------------------------------------
                     * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                     *			ixf18100_GfpRxCfg_t *ptGfpRxCfg: pointer to the values that need to 
                     *				be set in the device
                     * Outputs : none
                     *------------------------------------------------------------------------------
                     * Returns : bb_NO_ERROR
                     *------------------------------------------------------------------------------
                     * Access Globals : none
                     *------------------------------------------------------------------------------
                     * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpRxSetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpRxCfg_t *ptGfpRxCfg);

                    /******************************************************************************
                    * Function : Ixf18100GfpTxSetCfg
                    *------------------------------------------------------------------------------
                    * Description  : The function takes the values from GFP Tx config structure
                    * and masks it appropriately and writes the 16 bit value into the register.
                    *------------------------------------------------------------------------------
                    * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                    *			ixf18100_GfpTxCfg_t *ptGfpTxCfg: pointer to the values that need
                    *				to be set in the device
                    * Outputs : none
                    *------------------------------------------------------------------------------
                    * Returns : bb_NO_ERROR
                    *------------------------------------------------------------------------------
                    * Access Globals : none
                    *------------------------------------------------------------------------------
                    * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpTxSetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpTxCfg_t *ptGfpTxCfg);

                    /******************************************************************************
                    * Function : Ixf18100GfpGlbGetCfg
                    *------------------------------------------------------------------------------
                    * Description  : The function reads the 16 bit register values and sets the
                    * value in the structure members appropriately.
                    *------------------------------------------------------------------------------
                    * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                    *			ixf18100_GfpGlbCfg_t *ptGfpGlbCfg: pointer to the values that need to 
                    *				be set from the current device configuration
                    * Outputs : none
                    *------------------------------------------------------------------------------
                    * Returns : bb_NO_ERROR
                    *------------------------------------------------------------------------------
                    * Access Globals : none
                    *------------------------------------------------------------------------------
                    * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpGlbGetCfg(bb_RegPointer_type BaseAddress,
                     ixf18100_GfpGlbCfg_t *ptGfpGlbCfg);

                     /******************************************************************************
                     * Function : Ixf18100GfpRxGetCfg
                     *------------------------------------------------------------------------------
                     * Description  : The function reads the 16 bit register values and sets the
                     * value in the structure members appropriately.
                     *------------------------------------------------------------------------------
                     * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                     *			ixf18100_GfpRxCfg_t *ptGfpRxCfg: pointer to the values that need to 
                     *				be set from the current device configuration
                     * Outputs : none
                     *------------------------------------------------------------------------------
                     * Returns : bb_NO_ERROR
                     *------------------------------------------------------------------------------
                     * Access Globals : none
                     *------------------------------------------------------------------------------
                     * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpRxGetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpRxCfg_t *ptGfpRxCfg);

                    /******************************************************************************
                    * Function : Ixf18100GfpTxGetCfg
                    *------------------------------------------------------------------------------
                    * Description  : The function reads the 16 bit register values and sets the
                    * value in the structure members appropriately.
                    *------------------------------------------------------------------------------
                    * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                    *			ixf18100_GfpTxCfg_t *ptGfpTxCfg: pointer to the values that need to 
                    *				be set from the current device configuration
                    * Outputs : none
                    *------------------------------------------------------------------------------
                    * Returns : bb_NO_ERROR
                    *------------------------------------------------------------------------------
                    * Access Globals : none
                    *------------------------------------------------------------------------------
                    * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpTxGetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpTxCfg_t *ptGfpTxCfg);

                    /******************************************************************************
                    * Function : Ixf18100GfpRxGetCounters
                    *------------------------------------------------------------------------------
                    * Description  : The function reads one/all the GFP Rx counters
                    *------------------------------------------------------------------------------
                    * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                    *			bb_SelCounters_e SelCntr: selects coutner to be returned
                    *			void *ptCounters: pointer to the counter structure
                    * Outputs : none
                    *------------------------------------------------------------------------------
                    * Returns : bb_NO_ERROR, bb_INV_SEL_COUNTERS
                    *------------------------------------------------------------------------------
                    * Access Globals : none
                    *------------------------------------------------------------------------------
                    * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpRxGetCounters(bb_RegPointer_type BaseAddress,
                         bb_SelCounters_e SelCntr, void *ptCounters);

                         /******************************************************************************
                         * Function : Ixf18100GfpTxGetCounters
                         *------------------------------------------------------------------------------
                         * Description  : The function reads one/all the GFP Tx counters
                         *------------------------------------------------------------------------------
                         * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                         *			bb_SelCounters_e SelCntr: selects coutner to be returned
                         *			void *ptCounters: pointer to the counter structure
                         * Outputs : none
                         *------------------------------------------------------------------------------
                         * Returns : bb_NO_ERROR, bb_INV_SEL_COUNTERS
                         *------------------------------------------------------------------------------
                         * Access Globals : none
                         *------------------------------------------------------------------------------
                         * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpTxGetCounters(bb_RegPointer_type BaseAddress,
                         bb_SelCounters_e SelCntr, void *ptCounters);

                         /******************************************************************************
                         * Function : Ixf18100GfpSetCfg
                         *------------------------------------------------------------------------------
                         * Description  : The function takes the values from GFP config structure and 
                         * masks it appropriately and writes the 16 bit value into the register.
                         *------------------------------------------------------------------------------
                         * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                         *			bb_SelConfig_e	SelCfg: enum value defining what configuration
                         *				needs to be set
                         *			ixf18100_GfpCfg_t *ptGfpCfg: pointer to the values that need to 
                         *				be set in the device
                         * Outputs : none
                         *------------------------------------------------------------------------------
                         * Returns : bb_NO_ERROR, bb_INV_PARAMETER
                         *------------------------------------------------------------------------------
                         * Access Globals : none
                         *------------------------------------------------------------------------------
                         * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpSetCfg(bb_RegPointer_type BaseAddress, bb_SelConfig_e SelCfg,
                  ixf18100_GfpCfg_t *ptGfpCfg);

                  /******************************************************************************
                  * Function : Ixf18100GfpGetCfg
                  *------------------------------------------------------------------------------
                  * Description  : The function reads the 16 bit register values and sets the
                  * value in the structure members appropriately.
                  *------------------------------------------------------------------------------
                  * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                  *			bb_SelConfig_e	SelCfg: enum value defining what configuration
                  *				needs to be set
                  *			ixf18100_GfpCfg_t *ptGfpCfg: pointer to the values that need to 
                  *				be set from the current device configuration
                  * Outputs : none
                  *------------------------------------------------------------------------------
                  * Returns : bb_NO_ERROR, bb_INV_PARAMETER
                  *------------------------------------------------------------------------------
                  * Access Globals : none
                  *------------------------------------------------------------------------------
                  * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpGetCfg(bb_RegPointer_type BaseAddress, bb_SelConfig_e SelCfg,
                  ixf18100_GfpCfg_t *ptGfpCfg);

                  /******************************************************************************
                  * Function : Ixf18100GfpGetCounters
                  *------------------------------------------------------------------------------
                  * Description  : The function reads one/all the GFP counters
                  *------------------------------------------------------------------------------
                  * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                  *           bb_SelCounters_e SelCntr: Selctes the counter(s) to be read.
                  *			void *ptGfpCounters: pointer to the counter 
                  *				structure
                  * Outputs : none
                  *------------------------------------------------------------------------------
                  * Returns : bb_NO_ERROR, bb_INV_SEL_COUNTERS
                  *------------------------------------------------------------------------------
                  * Access Globals : none
                  *------------------------------------------------------------------------------
                  * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpGetCounters(bb_RegPointer_type BaseAddress,
                       bb_SelCounters_e SelCntr, void *ptGfpCounters);

                       /******************************************************************************
                       * Function : Ixf18100GfpGetStatus
                       *------------------------------------------------------------------------------
                       * Description  : The function reads the 16 bit register values and sets the
                       * value in the structure members appropriately.
                       *------------------------------------------------------------------------------
                       * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                       *           selStatus : Type of Status: 
                       *			void *ptGfpStatus: pointer to the status
                       *				that needs to be read from the device
                       * Outputs : none
                       *------------------------------------------------------------------------------
                       * Returns : bb_NO_ERROR
                       *------------------------------------------------------------------------------
                       * Access Globals : none
                       *------------------------------------------------------------------------------
                       * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpGetStatus(bb_RegPointer_type BaseAddress,
                     bb_SelStatus_e selStatus, void* pStatus);

                     /******************************************************************************
                     * Function : Ixf18100GfpReset
                     *------------------------------------------------------------------------------
                     * Description  : Reset the GFP interfaces and then reconfigure it.
                     *------------------------------------------------------------------------------
                     * Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
                     *           resetType : Specifies type of Reset
                     * Outputs : None.
                     *------------------------------------------------------------------------------
                     * Returns : bb_NO_ERROR, bb_INV_RESET_TYPE
                     *------------------------------------------------------------------------------
                     * Access Globals : None.
                     *------------------------------------------------------------------------------
                     * Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100GfpReset(bb_RegPointer_type BaseAddress, bb_SelResetType_e resetType);

/******************************************************************************
* Function : Ixf18100SetGfpOverSonetMode
*------------------------------------------------------------------------------
* Description  : The function configures the device from end to end for GFP
*                over SONET mode.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           opMode : GFP Mode
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100SetGfpOverSonetMode(bb_ChipData_t *pChipData, bb_OperMode_e opMode);

/******************************************************************************
* Function : Ixf18100SetGfpClientMapMode
*------------------------------------------------------------------------------
* Description  : The function configures the device from end to end for GFP
*                Client Map mode.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           opMode : GFP Mode
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
extern bb_Error_e
Ixf18100SetGfpClientMapMode(bb_ChipData_t *pChipData, bb_OperMode_e opMode);

#endif /* _IXF18100_GFP_H__ */


