/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:03p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_cnfg_d.h $
*   WORKFILE:       $Workfile: ixf18100_cnfg_d.h $
*
* --------------------------------------------------------------------------
* Project: ixf1810x API
*
* Purpose: Provides Combined Chip Configuration Structure - for IXF1810x
*         
* Notes:
*         
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_cnfg_d.h $
 * 
 * 1     3/11/04 3:03p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 12    2/20/03 3:19p Kssaepha
* Changed ifndef logic to ifdef to allow a combination of ixf1810x's to
* be defined
* 
* 11    11/11/02 11:58a Jaalliso
* Resolving compile isues for ixf18103
* 
* 10    8/13/02 1:19p Pkjain2
* 
* 9     8/12/02 5:30p Machambe
* Adding IXF1810x Family support
* 
* 8     7/08/02 1:16p Pkjain2
* Moved Calypso specific data stuctures into Calypso block specific data
* structure file.
* 
* 7     5/16/02 11:08a Jaalliso
* Adding file header
* 
* --------------------------------------------------------------------------
*/ 
#ifndef  IXF18100_CNFG_H
#define  IXF18100_CNFG_H

/* Chip Config struct; */
typedef struct                  
{
    ixf18100_ChipLevelCfg_t   ChipLevelCfg;   /* Chip configuration */
    ixf18100_Spi4Cfg_t        Spi4Cfg;        /* SPI-4 configuration */
    
    /* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)   
    ixf18100_SonetCfg_t       SonetCfg;       /* Sonet configuration */
#endif
    
    /* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
    ixf18100_PosCfg_t         PosCfg;         /* POS configuration */
    ixf18100_GfpCfg_t         GfpCfg;         /* GFP configuration */
#endif
    
    /* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
    ixf18100_PcsCfg_t         PcsCfg;         /* PCS configuration */
    ixf18100_XgmacCfg_t       XgmacCfg;       /* XGMAC configuration */
#endif    
    
} ixf18100_ChipCfg_t;
#endif
