/*
*---------------------------------------------------------------------------
*
*                  I N T E L   P R O P R I E T A R Y                   
*
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*
*                        INTEL  CORPORATION                            
*
*                     2200 MISSION COLLEGE BLVD                        
*
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:03p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_util.c $
*   WORKFILE:       $Workfile: ixf18100_util.c $
*
* --------------------------------------------------------------------------
* Project: ixf18100 family device API
*
* Purpose: This file contains the utility functions.
*
* Notes:
*
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_util.c $
 * 
 * 1     3/11/04 3:03p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 6     1/20/03 2:06p Pkjain2
* beautified the code
* 
* 5     11/13/02 4:40p Kssaepha
* Added preprocessor includes that were previously in header file
* 
* 4     12/04/01 4:24p Pkjain2
* 
* 3     11/20/01 3:46p Pkjain2
* 
* 2     8/08/01 3:50p Rfranz
* added support for debugging using memory block instead of Calypso
* device or simulator.  Moved device read/write macros/functions to
* ixf18100_util.[ch]
* 
* 
* 1     7/18/01 10:55a Rfranz
* Initial check in - file headers only
* 
* --------------------------------------------------------------------------
*/

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "common_types.h"
#include "common_def.h"
#include "ixf18100_d.h"
#include "ixf18100_util.h"
#include "hal.h"


/******************************************************************************
* Function : Ixf18100SetBits16
*------------------------------------------------------------------------------
* Description : This function does a read-modify-write on a set of bits in
*       a 16 bit register.
*------------------------------------------------------------------------------
* Inputs  : puiReg: Address of the register to be modified.
*           uiMask: Mask for the bits to be modified.
*           uiValue: Value to be written into the register.
* Outputs : None
*------------------------------------------------------------------------------
* Returns : None
*------------------------------------------------------------------------------
* Access Globals :
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
void
Ixf18100SetBits16(bb_RegPointer_type puiReg, ushort uiMask, ushort uiValue)
{
    HAL_IXF18100_WRITE(puiReg,(HAL_IXF18100_READ(puiReg) & ~uiMask)
        | (uiValue & uiMask));
}

