/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:03p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_xgmac_b.h $
*   WORKFILE:       $Workfile: ixf18100_xgmac_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf18100 family device API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_xgmac_b.h $
 * 
 * 1     3/11/04 3:03p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 17    1/30/03 4:40p Pkjain2
* Made changes for PTQ release. Added Getstatus calls for SONET and
* GLOBAL block.
* 
* 16    11/12/02 2:26p Jaalliso
* Deleting bit shifts for CNTL reg that moved to CNTL2
* 
* 15    11/07/02 6:06p Jjchin
* Added RxPadStripEn bit and XGMAC_CNTL2 register for B0.
* 
* 14    5/17/02 9:09a Jaalliso
* Removing PrependValue from XGMAC_CNTL
* 
* 13    3/06/02 5:51p Pkjain2
* 
* 12    11/20/01 11:34a Srodrig1
* 
* 11    10/23/01 3:46p Kssaepha
* Modified block offsets
* 
* 10    10/03/01 1:29p Kssaepha
* Changed defualt value for XGMAC_CNTL Register
* 
* 9     8/28/01 9:05a Kssaepha
* Added XGMAC Base Offset
* 
* 8     8/24/01 11:03a Wrbrackn
* 
* 7     8/23/01 4:12p Wrbrackn
* Made changes suggested after review of the code with Mark.
* 
*
* 
* --------------------------------------------------------------------------
*/

#ifndef __IXF18100_XGMAC_B_H__
#define __IXF18100_XGMAC_B_H__

#ifndef ixf18100_REG_SHIFT
#define ixf18100_REG_SHIFT  0x0
#endif

/* Block Offset for XGMAC */
#ifndef ixf18100_XGMAC_BASE
#define ixf18100_XGMAC_BASE             0x3100
#endif

#define ixf18100_XGMAC_REG(offset) ((ixf18100_XGMAC_BASE + offset) << ixf18100_REG_SHIFT)
/******************************************************************************/
/* XGMAC_CNTL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_CNTL_W0_OFFSET   ixf18100_XGMAC_REG(0x00)
#define ixf18100_XGMAC_CNTL_W1_OFFSET   ixf18100_XGMAC_REG(0x01)
#define ixf18100_XGMAC_CNTL_DFLT        0x280457FB

/* -------- Bit, shift and mask defines.-------- */

/*TxCRC_En * Enables CRC to be appended to the transmitted pkt*/
#define ixf18100_sTX_CRC_EN             0

/*RxCRC_Strip * Causes CRC to be stripped form all pkts*/
#define ixf18100_sRX_CRC_STRIP          1

/*JumFrmEn * Allows frames upto the size specified in register offset 0x15*/
#define ixf18100_sJUM_FRM_EN            2

/*TxCRC_Rst * Reset the Transmit CRC Generator*/
#define ixf18100_sTX_CRC_RST            3

/*TxRst * Reset the entire transmit block*/
#define ixf18100_sTX_RST                4

/*RxCRC_Rst * Reset the Receive CRC Checker */
#define ixf18100_sRX_CRC_RST            5

/*RxRst Reset the entire receive block */
#define ixf18100_sRX_RST                6

/*MngmntRst * Reset MNGMNT */
#define ixf18100_sMNGMNT_RST            8

/*SftRst * Reset all blocks */
#define ixf18100_sSFT_RST               9

/*TxPadFrmEn * Pad short transmit pkts to 64 bytes*/
#define ixf18100_sTX_PAD_FRM_EN         10

/*TxEn * Enable transmission of pkts*/
#define ixf18100_sTX_EN                 11

/*TxPauseEn * Enable transmission of transmit pause pkts*/
#define ixf18100_sTX_PAUSE_EN           12

/*RxEn* Enable reception of pkts*/
#define ixf18100_sRX_EN                 13

/*RxPauseEn * Pause transmitter if pause frame received*/
#define ixf18100_sRX_PAUSE_EN           14

/*Loopback* Send transmit data through receiver*/
#define ixf18100_sLOOPBACK              15

/*MDC_SpdSel * High or Low speed MDC to PCS WIS*/
#define ixf18100_sMDC_SPD_SEL           16

/*Cont_MDC * Turn off MDC between MDIO pkts*/
#define ixf18100_sCONT_MDC              17               

/*CntlFrmFilterEn * Filter out unrecognized control pkts*/
#define ixf18100_sCNTL_FRM_FILTER_EN    18               

/*RxPauseFrameAddr * Address to use as qualification for Pause Frames*/
#define ixf18100_sRX_PAUSE_FRAME_ADDR   25               
#define ixf18100_mRX_PAUSE_FRAME_ADDR   (0x3 << ixf18100_sRX_PAUSE_FRAME_ADDR)

#define ixf18100_MC_MAC_PFRAME_DEST     (0x0 << ixf18100_sRX_PAUSE_FRAME_ADDR)      
#define ixf18100_MC_ANYMAC_PFRAME_DEST  (0x1 << ixf18100_sRX_PAUSE_FRAME_ADDR)      
#define ixf18100_MC_ONLY_PFRAME_DEST    (0x2 << ixf18100_sRX_PAUSE_FRAME_ADDR)  

/******************************************************************************/

/* Calypso B0 Chip ONLY */
/******************************************************************************/
/* XGMAC_CNTL2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_CNTL2_W0_OFFSET   ixf18100_XGMAC_REG(0x1A)
#define ixf18100_XGMAC_CNTL2_W1_OFFSET   ixf18100_XGMAC_REG(0x1B)
#define ixf18100_XGMAC_CNTL2_DFLT        0x00000007

/* -------- Bit, shift and mask defines.-------- */
/*RxCrcErrorDropEn * Drop received CRC Error frames*/
#define ixf18100_sRX_CRC_ERROR_DROP_EN  0

/*RxOversizeDropEN * Drop receive Oversize frames*/
#define ixf18100_sRX_OVERSIZE_DROP_EN   1

/*RxUndersizeDropEN * Drop received undersized frames*/
#define ixf18100_sRX_UNDERSIZE_DROP_EN  2

/******************************************************************************/

/******************************************************************************/
/* XGMAC_STATUS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_STATUS_W0_OFFSET ixf18100_XGMAC_REG(0x02)
#define ixf18100_XGMAC_STATUS_W1_OFFSET ixf18100_XGMAC_REG(0x03)
#define ixf18100_XGMAC_STATUS_DFLT      0x00000000

/* -------- Bit, shift and mask defines.-------- */

/*RevID * Version number of XGMAC Core*/
#define ixf18100_sREV_ID                0
#define ixf18100_mREV_ID                (0xF << ixf18100_sREV_ID)

/*Autoscan * Enables AutoScans*/
#define ixf18100_sAUTOSCAN              4

/*RxErSym * Error symbol during receive pkt*/
#define ixf18100_sRX_ER_SYM             5

/*RxIllegalSym * Illegal symbol during receive pkt*/
#define ixf18100_sRX_ILLEGAL_SYM        6

/*RxIdleError * Non Idle symbol during idle period*/
#define ixf18100_sRX_IDLE_ERROR         7

/*RxLocalFault * Fault Reported from PMD, PMA or PCS*/
#define ixf18100_sRX_LOCAL_FAULT        8

/*RxRemoteFault * Link partner reported remote fault*/
#define ixf18100_sRX_REMOTE_FAULT       9

/*RxLinkFail * Link down indication*/
#define ixf18100_sRX_LINK_FAIL          10
/******************************************************************************/

/******************************************************************************/
/* XGMAC_PP_W0 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_PP_W0_OFFSET     ixf18100_XGMAC_REG(0x04)
#define ixf18100_XGMAC_PP_W1_OFFSET     ixf18100_XGMAC_REG(0x05)
#define ixf18100_XGMAC_PP_DFLT          0x0000FFFF

/* -------- Bit, shift and mask defines.-------- */

/*TxPauseCnt Pause Count in Bytes to Send in the Transmitted Pause
*Frame to Pause Link Partners Transmitter.
*/
#define ixf18100_sTX_PAUSE_CNT          0
#define ixf18100_mTX_PAUSE_CNT          (0xFFFF << ixf18100_sTX_PAUSE_CNT)

/*TxPace*/
#define ixf18100_sTX_PACE               16
#define ixf18100_mTX_PACE               (0xF << ixf18100_sTX_PACE)

#define ixf18100_TX_PACE_10_GBPS        (0x0 << ixf18100_sTX_PACE)
#define ixf18100_TX_PACE_1_GBPS         (0x1 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_2_GBPS         (0x2 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_3_GBPS         (0x3 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_4_GBPS         (0x4 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_5_GBPS         (0x5 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_6_GBPS         (0x6 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_7_GBPS         (0x7 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_8_GBPS         (0x8 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_9_GBPS         (0x9 << ixf18100_sTX_PACE)      
#define ixf18100_TX_PACE_9_294_GBPS     (0xF << ixf18100_sTX_PACE)              
/******************************************************************************/

/******************************************************************************/
/* XGMAC_ADDLO Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_ADDLO_W0_OFFSET  ixf18100_XGMAC_REG(0x12)
#define ixf18100_XGMAC_ADDLO_W1_OFFSET  ixf18100_XGMAC_REG(0x13)
#define ixf18100_XGMAC_ADDLO_DFLT       0x00000000

/* -------- Bit, shift and mask defines.-------- */

/*MAC_AddrLo * Least Significant 32 Bits of the 48-Bit MAC Address*/
#define ixf18100_sMAC_ADDR_LO           0
#define ixf18100_mMAC_ADDR_LO           (0xFFFFFFFF << ixf18100_sMAC_ADDR_LO_W0)
/******************************************************************************/

/******************************************************************************/
/* XGMAC_ADDHIJUM Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_ADDHIJUM_W0_OFFSET   ixf18100_XGMAC_REG(0x14)
#define ixf18100_XGMAC_ADDHIJUM_W1_OFFSET   ixf18100_XGMAC_REG(0x15)
#define ixf18100_XGMAC_ADDHIJUM_DFLT        0x05EE0000

/* -------- Bit, shift and mask defines.-------- */

/*MAC_AddrHigh *Most Significat 16 Bits of the 48-Bit MAC Address*/
#define ixf18100_sMAC_ADDR_HIGH             0
#define ixf18100_mMAC_ADDR_HIGH             (0xFFFF << ixf18100_sMAC_ADDR_HIGH)

/*MaxFrmSize *Maximum Number of Bytes in a Frame That Can Be Transmitted*/
#define ixf18100_sMAX_FRM_SIZE              16
#define ixf18100_mMAX_FRM_SIZE              (0xFFFF << ixf18100_sMAX_FRM_SIZE)
/******************************************************************************/

/******************************************************************************/
/* XGMAC_STATINTSTAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_STATINTSTAT_W3_OFFSET    ixf18100_XGMAC_REG(0x23)
#define ixf18100_XGMAC_STATINTSTAT_W2_OFFSET    ixf18100_XGMAC_REG(0x22)
#define ixf18100_XGMAC_STATINTSTAT_W1_OFFSET    ixf18100_XGMAC_REG(0x21)
#define ixf18100_XGMAC_STATINTSTAT_W0_OFFSET    ixf18100_XGMAC_REG(0x20)
#define ixf18100_XGMAC_STATINTSTAT_DFLT         0x00000000

/* -------- Bit, shift and mask defines.-------- */

/* -- Least Significant 32 Bits -- */

/*OvrflwInt_OctetsTransmittedOK * Overflow interrupt status of OctetsTransmittedOK*/
#define ixf18100_sOVRFLW_INT_OCTETS_TX_OK           0

/*OvrflwInt_MulticastFrame * Overflow interrupt status of MulticastFramesTransmittedOK*/
#define ixf18100_sOVRFLW_INT_MULTICAST_FRAME_TX_OK  1

/*OvrflwInt_BroadcastFramesTransmittedOK *Overflow interrupt status of BroadcastFramesTransmittedOK*/
#define ixf18100_sOVRFLW_INT_BROADCAST_FRAMES_TX_OK 2

/*OvrflwInt_FramesTransmittedOK *Overflow interrupt status of FramesTransmittedOK*/
#define ixf18100_sOVRFLW_INT_FRAMES_TX_OK           3

/*OvrflwInt_64OctetTrans *Overflow interrupt status of 64OctetTransmittedFrames*/
#define ixf18100_sOVRFLW_INT_64OCTET_TX_FRAMES      4

/*OvrflwInt_65to127Trans *Overflow interrupt status of 65to127TransmittedFrames*/
#define ixf18100_sOVRFLW_INT_65TO127_TX_FRAMES      5

/*OvrflwInt_128to255TransmittedFrames * Overflow interrupt status of 128to255TransmittedFrames*/
#define ixf18100_sOVRFLW_INT_128TO255_TX_FRAMES     6

/*OvrflwInt_256to511TransmittedOK * Overflow interrupt status of 256to511TransmittedOK*/
#define ixf18100_sOVRFLW_INT_256TO511_TX_OK         7

/*OvrflwInt_512to1023TransmittedOK * Overflow interrupt status of 512to1023TransmittedOK*/
#define ixf18100_sOVRFLW_INT_512TO1023_TX_OK        8

/*OvrflwInt_1024to15xxTransmittedOK * Overflow interrupt status of 1024to15xxTransmittedOK*/
#define ixf18100_sOVRFLW_INT_1024TO15XX_TX_OK       9

/*OvrflwInt_15xxtomaxTransmittedOK * Overflow interrupt status of 15xxtomaxTransmittedOK*/
#define ixf18100_sOVRFLW_INT_15XXTOMAX_TX_OK        10

/*OvrflwInt_VLANFramesTransmittedOK * Overflow interrupt status of VLANFramesTransmittedOK*/
#define ixf18100_sOVRFLW_INT_VLAN_FRAMES_TX_OK      11

/*OvrflwInt_PAUSECtrlFramesTransmitted * Overflow interrupt status of PAUSECtrlFramesTransmitted*/
#define ixf18100_sOVRFLW_INT_PAUSE_CTRL_FRAMES_TX   12

/*OvrflwInt_UnicastFramesTransmittedOK * Overflow interrupt status of UnicastFramesTransmittedOK*/
#define ixf18100_sOVRFLW_INT_UNICAST_FRAME_TX_OK    13

/*OvrflwInt_MACControlFramesTransmitted * Overflow interrupt status of MACControlFramesTransmitted*/
#define ixf18100_sOVRFLW_INT_MAC_CNTRL_FRAMES_TX    14

/*OvrflwInt_OctetsReceivedOK * Overflow interrupt status of OctetsReceivedOK*/
#define ixf18100_sOVRFLW_INT_OCTETS_RX_OK           15

/*OvrflwInt_MulticastFramesReceivedOK * Overflow interrupt status of MulticastFramesReceivedOK*/
#define ixf18100_sOVRFLW_INT_MULTICAST_FRAMES_RX_OK 16

/*OvrflwInt_BroadcastFramesReceivedOK * Overflow interrupt status of BroadcastFramesReceivedOK*/
#define ixf18100_sOVRFLW_INT_BROADCAST_FRAMES_RX_OK 17

/*OvrflwInt_FramesReceivedOK * Overflow interrupt status of FramesReceivedOK*/
#define ixf18100_sOVRFLW_INT_FRAMES_RX_OK           18

/*OvrflwInt_64OctetReceivedFrames * Overflow interrupt status of 64OctetReceivedFrames*/
#define ixf18100_sOVRFLW_INT_64OCTETS_RX_FRAMES     19

/*OvrflwInt_65to127ReceivedFrames  * Overflow interrupt status of 65to127ReceivedFrames*/
#define ixf18100_sOVRFLW_INT_65TO127_RX_FRAMES      20

/*OvrflwInt_128to255ReceivedFrames * Overflow interrupt status of 128to255ReceivedFrames*/
#define ixf18100_sOVRFLW_INT_128TO255_RX_FRAMES     21

/*OvrflwInt_256to511ReceivedOK * Overflow interrupt status of 256to511ReceivedOK*/
#define ixf18100_sOVRFLW_INT_256TO511_RX_OK         22

/*OvrflwInt_512to1023ReceivedOK * Overflow interrupt status of 512to1023ReceivedOK*/
#define ixf18100_sOVRFLW_INT_512TO1023_RX_OK        23

/*OvrflwInt_1024to15xxReceivedOK * Overflow interrupt status of 1024to15xxReceivedOK*/
#define ixf18100_sOVRFLW_INT_1024TO15XX_RX_OK       24

/*OvrflwInt_15xxtomaxReceivedOK * Overflow interrupt status of 15xxtomaxReceivedOK*/
#define ixf18100_sOVRFLW_INT_15XXTOMAX_RX_OK        25

/*OvrflwInt_VLANFramesReceivedOK * Overflow interrupt status of VLANFramesReceivedOK*/
#define ixf18100_sOVRFLW_INT_VLAN_FRAMES_RX_OK      26

/*OvrflwInt_PAUSEMACCtrlFramesReceived * Overflow interrupt status of PAUSEMACCtrlFramesReceived*/
#define ixf18100_sOVRFLW_INT_PAUSE_MAC_CTRL_RX      27

/*OvrflwInt_UnicastFramesReceivedOK * Overflow interrupt status of UnicastFramesReceivedOK*/
#define ixf18100_sOVRFLW_INT_UNICAST_FRAMES_RX_OK   28

/*OvrflwInt_MACControlFramesReceived * Overflow interrupt status of MACControlFramesReceived*/
#define ixf18100_sOVRFLW_INT_MAC_CTRL_FRAMES_RX     29

/*OvrflwInt_etherStatsUndersizePkts * Overflow interrupt status of etherStatsUndersizePkts*/
#define ixf18100_sOVRFLW_INT_ETHER_STATS_UNDERSIZE_PKTS 30

/*OvrflwInt_etherStatsOversizePkts * Overflow interrupt status of etherStatsOversizePkts*/
#define ixf18100_sOVRFLW_INT_ETHER_STATS_OVERSIZE_PKTS  31

/* -- Most Significant 32 Bits -- */

/*OvrflwInt_etherStatsOctets * Overflow interrupt status of etherStatsOctets*/
#define ixf18100_sOVRFLW_INT_ETHER_STATS_OCTETS     0

/*OvrflwInt_etherStatsPkts Overflow interrupt status of etherStatsPkts*/
#define ixf18100_sOVRFLW_INT_ETHER_STATS_PKTS       1

/*OvrflwInt_etherStatsFragments * Overflow interrupt status of etherStatsFragments*/
#define ixf18100_sOVRFLW_INT_ETHER_STATS_FRAGMENTS  2

/*OvrflwInt_etherStatsJabbers * Overflow interrupt status of etherStatsJabbers*/
#define ixf18100_sOVRFLW_INT_ETHER_STATS_JABBERS    3

/*OvrflwInt_FrameCheckSequenceErrors * Overflow interrupt status of FrameCheckSequenceErrors*/
#define ixf18100_sOVRFLW_INT_FRM_CHK_SEQUENCE_ERRS  4
/******************************************************************************/

/******************************************************************************/
/* XGMAC_STATINTENB Register*/

/*Offset/Default definition for register.*/
#define ixf18100_XGMAC_STATINTENB_W3_OFFSET     ixf18100_XGMAC_REG(0x27)
#define ixf18100_XGMAC_STATINTENB_W2_OFFSET     ixf18100_XGMAC_REG(0x26)
#define ixf18100_XGMAC_STATINTENB_W1_OFFSET     ixf18100_XGMAC_REG(0x25)
#define ixf18100_XGMAC_STATINTENB_W0_OFFSET     ixf18100_XGMAC_REG(0x24)
#define ixf18100_XGMAC_STATINTENB_DFLT          0x00000000

/* -------- Bit, shift and mask defines.-------- */

/* -- Least Significant 32 Bits -- */

/*OvrflwEn_OctetsTransmittedOK *Interrupt enable of OctetsTransmittedOK*/
#define ixf18100_sOVRFLW_EN_OCTETS_TX_OK            0

/*OvrflwEn_MulticastFramesTransmittedOK * Interrupt enable of MulticastFramesTransmittedOK*/
#define ixf18100_sOVRFLW_EN_MULTICAST_FRAMES_TX_OK  1

/*OvrflwEn_BroadcastFramesTransmittedOK * Interrupt enable of BroadcastFramesTransmittedOK*/
#define ixf18100_sOVRFLW_EN_BROADCAST_FRAMES_TX_OK  2

/*OvrflwEn_FramesTransmittedOK * Interrupt enable of FramesTransmittedOK*/
#define ixf18100_sOVRFLW_EN_FRAMES_TX_OK            3

/*OvrflwEn_64OctetTransmittedFrames * Interrupt enable of 64OctetTransmittedFrames*/
#define ixf18100_sOVRFLW_EN_64OCTET_TX_FRAMES       4

/*OvrflwEn_65to127TransmittedFrames * Interrupt enable of 65to127TransmittedFrames*/
#define ixf18100_sOVRFLW_EN_65TO127_TX_FRAMES       5

/*OvrflwEn_128to255TransmittedFrames * Interrupt enable of 128to255TransmittedFrames*/
#define ixf18100_sOVRFLW_EN_128TO255_TX_FRAMES      6

/*OvrflwEn_256to511TransmittedOK * Interrupt enable of 256to511TransmittedOK*/
#define ixf18100_sOVRFLW_EN_256TO511_TX_OK          7

/*OvrflwEn_512to1023TransmittedOK * Interrupt enable of 512to1023TransmittedOK*/
#define ixf18100_sOVRFLW_EN_512TO1023_TX_OK         8

/*OvrflwEn_1024to15xxTransmittedOK * Interrupt enable of 1024to15xxTransmittedOK*/
#define ixf18100_sOVRFLW_EN_1024TO15XX_TX_OK        9

/*OvrflwEn_15xxtomaxTransmittedOK * Interrupt enable of 15xxtomaxTransmittedOK*/
#define ixf18100_sOVRFLW_EN_15XXTOMAX_TX_OK         10

/*OvrflwEn_VLANFramesTransmittedOK * Interrupt enable of VLANFramesTransmittedOK*/
#define ixf18100_sOVRFLW_EN_VLAN_FRAMES_TX_OK       11

/*OvrflwEn_PAUSECtrlFramesTransmitted * Interrupt enable of PAUSECtrlFramesTransmitted*/
#define ixf18100_sOVRFLW_EN_PAUSE_CTRL_FRAMES_TX    12

/*OvrflwEn_UnicastFramesTransmittedOK * Interrupt enable of UnicastFramesTransmittedOK*/
#define ixf18100_sOVRFLW_EN_UNICAST_FRAMES_TX_OK    13

/*OvrflwEn_MACControlFramesTransmitted * Interrupt enable of MACControlFramesTransmitted*/
#define ixf18100_sOVRFLW_EN_MAC_CTRL_FRAMES_TX      14

/*OvrflwEn_OctetsReceivedOK * Interrupt enable of OctetsReceivedOK*/
#define ixf18100_sOVRFLW_EN_OCTETS_RX_OK            15

/*OvrflwEn_MulticastFramesReceivedOK * Interrupt enable of MulticastFramesReceivedOK*/
#define ixf18100_sOVRFLW_EN_MULTICAST_FRAMES_RX_OK  16

/*OvrflwEn_BroadcastFramesReceivedOK * Interrupt enable of BroadcastFramesReceivedOK*/
#define ixf18100_sOVRFLW_EN_BROADCAST_FRAMES_RX_OK  17

/*OvrflwEn_FramesReceivedOK * Interrupt enable of FramesReceivedOK*/
#define ixf18100_sOVRFLW_EN_FRAMES_RX_OK            18

/*OvrflwEn_64OctetReceivedFrames * Interrupt enable of 64OctetReceivedFrames*/
#define ixf18100_sOVRFLW_EN_64OCTET_RX_FRAMES       19

/*OvrflwEn_65to127ReceivedFrames * Interrupt enable of 65to127ReceivedFrames*/
#define ixf18100_sOVRFLW_EN_65TO127_RX_FRAMES       20

/*OvrflwEn_128to255ReceivedFrames * Interrupt enable of 128to255ReceivedFrames*/
#define ixf18100_sOVRFLW_EN_128TO255_RX_FRAMES      21               

/*OvrflwEn_256to511ReceivedOK * Interrupt enable of 256to511ReceivedOK*/
#define ixf18100_sOVRFLW_EN_256TO511_RX_OK          22

/*OvrflwEn_512to1023ReceivedOK * Interrupt enable of 512to1023ReceivedOK*/
#define ixf18100_sOVRFLW_EN_512TO1023_RX_OK         23

/*OvrflwEn_1024to15xxReceivedOK * Interrupt enable of 1024to15xxReceivedOK*/
#define ixf18100_sOVRFLW_EN_1024TO15XX_RX_OK        24

/*OvrflwEn_15xxtomaxReceivedOK * Interrupt enable of 15xxtomaxReceivedOK*/
#define ixf18100_sOVRFLW_EN_15XXTOMAX_RX_OK         25

/*OvrflwEn_VLANFramesReceivedOK * Interrupt enable of VLANFramesReceivedOK*/
#define ixf18100_sOVRFLW_EN_VLAN_FRAMES_RX_OK       26

/*OvrflwEn_PAUSEMACCtrlFramesReceived * Interrupt enable of PAUSEMACCtrlFramesReceived*/
#define ixf18100_sOVRFLW_EN_PAUSE_MAC_CTRL_FRAMES_RX    27

/*OvrflwEn_UnicastFramesReceivedOK * Interrupt enable of UnicastFramesReceivedOK*/
#define ixf18100_sOVRFLW_EN_UNICAST_FRAMES_RX_OK    28

/*OvrflwEn_MACControlFramesReceived * Interrupt enable of MACControlFramesReceived*/
#define ixf18100_sOVRFLW_EN_MAC_CNTRL_FRAMES_RX     29               

/*OvrflwEn_etherStatsUndersizePkts * Interrupt enable of etherStatsUndersizePkts*/
#define ixf18100_sOVRFLW_EN_ETHER_STATS_UNDERSIZE_PKTS  30

/*OvrflwEn_etherStatsOversizePkts * Interrupt enable of etherStatsOversizePkts*/
#define ixf18100_sOVRFLW_EN_ETHER_STATS_OVERSIZE_PKTS   31

/* -- Most Significant 32 Bits -- */

/*OvrflwEn_etherStatsOctets * Interrupt enable of etherStatsOctets*/
#define ixf18100_sOVRFLW_EN_ETHER_STATS_OCTETS      0

/*OvrflwEn_etherStatsPkts * Interrupt enable of etherStatsPkts*/
#define ixf18100_sOVRFLW_EN_ETHER_STATS_PKTS        1

/*OvrflwEn_etherStatsFragments * Interrupt enable of etherStatsFragments*/
#define ixf18100_sOVRFLW_EN_ETHER_STATS_FRAGMENTS   2         

/*OvrflwEn_etherStatsJabbers * Interrupt enable of etherStatsJabbers*/
#define ixf18100_sOVRFLW_EN_ETHER_STATS_JABBERS     3              

/*OvrflwEn_FrameCheckSequenceErrors * Interrupt enable of FrameCheckSequenceErrors*/
#define ixf18100_sOVRFLW_EN_FRM_CHK_SEQUENCE_ERRS   4
/******************************************************************************/

/******************************************************************************/
/* OCTETS_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_OCTETS_TX_OK_W3_OFFSET     ixf18100_XGMAC_REG(0x2B)
#define ixf18100_OCTETS_TX_OK_W2_OFFSET     ixf18100_XGMAC_REG(0x2A)
#define ixf18100_OCTETS_TX_OK_W1_OFFSET     ixf18100_XGMAC_REG(0x29)
#define ixf18100_OCTETS_TX_OK_W0_OFFSET     ixf18100_XGMAC_REG(0x28)
#define ixf18100_OCTETS_TX_OK_DFLT          0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sOCTETS_TX_OK              0
#define ixf18100_mOCTETS_TX_OK              (0xFFFFFFFF << ixf18100_sOCTETS_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* MULTICAST_FRAMES_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_MULTICAST_FRAMES_TX_OK_W3_OFFSET   ixf18100_XGMAC_REG(0x2F)
#define ixf18100_MULTICAST_FRAMES_TX_OK_W2_OFFSET   ixf18100_XGMAC_REG(0x2E)
#define ixf18100_MULTICAST_FRAMES_TX_OK_W1_OFFSET   ixf18100_XGMAC_REG(0x2D)
#define ixf18100_MULTICAST_FRAMES_TX_OK_W0_OFFSET   ixf18100_XGMAC_REG(0x2C)
#define ixf18100_MULTICAST_FRAMES_TX_OK_DFLT        0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sMULTICAST_FRAMES_TX_OK    0
#define ixf18100_mMULTICAST_FRAMES_TX_OK    (0xFFFFFFFF << ixf18100_sMULTICAST_FRAMES_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* BROADCAST_FRAMES_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_BROADCAST_FRAMES_TX_OK_W3_OFFSET   ixf18100_XGMAC_REG(0x33)
#define ixf18100_BROADCAST_FRAMES_TX_OK_W2_OFFSET   ixf18100_XGMAC_REG(0x32)
#define ixf18100_BROADCAST_FRAMES_TX_OK_W1_OFFSET   ixf18100_XGMAC_REG(0x31)
#define ixf18100_BROADCAST_FRAMES_TX_OK_W0_OFFSET   ixf18100_XGMAC_REG(0x30)
#define ixf18100_BROADCAST_FRAMES_TX_OK_DFLT        0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sBROADCAST_FRAMES_TX_OK    0
#define ixf18100_mBROADCAST_FRAMES_TX_OK    (0xFFFFFFFF << ixf18100_sBROADCAST_FRAMES_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* FRAMES_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_FRAMES_TX_OK_W3_OFFSET         ixf18100_XGMAC_REG(0x37)
#define ixf18100_FRAMES_TX_OK_W2_OFFSET         ixf18100_XGMAC_REG(0x36)
#define ixf18100_FRAMES_TX_OK_W1_OFFSET         ixf18100_XGMAC_REG(0x35)
#define ixf18100_FRAMES_TX_OK_W0_OFFSET         ixf18100_XGMAC_REG(0x34)
#define ixf18100_FRAMES_TX_OK_DFLT              0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sFRAMES_TX_OK                  0
#define ixf18100_mFRAMES_TX_OK                  (0xFFFFFFFF << ixf18100_sFRAMES_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* 64OCTET_TX_FRAMES Register*/

/*Offset/Default definition for register.*/
#define ixf18100_64OCTET_TX_FRAMES_W3_OFFSET    ixf18100_XGMAC_REG(0x3B)
#define ixf18100_64OCTET_TX_FRAMES_W2_OFFSET    ixf18100_XGMAC_REG(0x3A)
#define ixf18100_64OCTET_TX_FRAMES_W1_OFFSET    ixf18100_XGMAC_REG(0x39)
#define ixf18100_64OCTET_TX_FRAMES_W0_OFFSET    ixf18100_XGMAC_REG(0x38)
#define ixf18100_64OCTET_TX_FRAMES_DFLT         0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s64OCTET_TX_FRAMES             0
#define ixf18100_m64OCTET_TX_FRAMES             (0xFFFFFFFF << ixf18100_s64OCTET_TX_FRAMES)
/******************************************************************************/

/******************************************************************************/
/* 65TO127_TX_FRAMES Register*/

/*Offset/Default definition for register.*/
#define ixf18100_65TO127_TX_FRAMES_W3_OFFSET    ixf18100_XGMAC_REG(0x3F)
#define ixf18100_65TO127_TX_FRAMES_W2_OFFSET    ixf18100_XGMAC_REG(0x3E)
#define ixf18100_65TO127_TX_FRAMES_W1_OFFSET    ixf18100_XGMAC_REG(0x3D)
#define ixf18100_65TO127_TX_FRAMES_W0_OFFSET    ixf18100_XGMAC_REG(0x3C)
#define ixf18100_65TO127_TX_FRAMES_DFLT         0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s65TO127_TX_FRAMES             0
#define ixf18100_m65TO127_TX_FRAMES             (0xFFFFFFFF << ixf18100_s65TO127_TX_FRAMES)
/******************************************************************************/

/******************************************************************************/
/* 128TO255_TX_FRAMES Register*/

/*Offset/Default definition for register.*/
#define ixf18100_128TO255_TX_FRAMES_W3_OFFSET   ixf18100_XGMAC_REG(0x43)
#define ixf18100_128TO255_TX_FRAMES_W2_OFFSET   ixf18100_XGMAC_REG(0x42)
#define ixf18100_128TO255_TX_FRAMES_W1_OFFSET   ixf18100_XGMAC_REG(0x41)
#define ixf18100_128TO255_TX_FRAMES_W0_OFFSET   ixf18100_XGMAC_REG(0x40)
#define ixf18100_128TO255_TX_FRAMES_DFLT        0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s128TO255_TX_FRAMES            0
#define ixf18100_m128TO255_TX_FRAMES            (0xFFFFFFFF << ixf18100_s128TO255_TX_FRAMES)
/******************************************************************************/

/******************************************************************************/
/* 256TO511_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_256TO511_TX_OK_W3_OFFSET       ixf18100_XGMAC_REG(0x47)
#define ixf18100_256TO511_TX_OK_W2_OFFSET       ixf18100_XGMAC_REG(0x46)
#define ixf18100_256TO511_TX_OK_W1_OFFSET       ixf18100_XGMAC_REG(0x45)
#define ixf18100_256TO511_TX_OK_W0_OFFSET       ixf18100_XGMAC_REG(0x44)
#define ixf18100_256TO511_TX_OK_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s256TO511_TX_OK                0
#define ixf18100_m256TO511_TX_OK                (0xFFFFFFFF << ixf18100_s256TO511_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* 512TO1023_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_512TO1023_TX_OK_W3_OFFSET      ixf18100_XGMAC_REG(0x4B)
#define ixf18100_512TO1023_TX_OK_W2_OFFSET      ixf18100_XGMAC_REG(0x4A)
#define ixf18100_512TO1023_TX_OK_W1_OFFSET      ixf18100_XGMAC_REG(0x49)
#define ixf18100_512TO1023_TX_OK_W0_OFFSET      ixf18100_XGMAC_REG(0x48)
#define ixf18100_512TO1023_TX_OK_DFLT           0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s512TO1023_TX_OK               0
#define ixf18100_m512TO1023_TX_OK               (0xFFFFFFFF << ixf18100_s512TO1023_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* 1024TO15XX_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_1024TO15XX_TX_OK_W3_OFFSET     ixf18100_XGMAC_REG(0x4F)
#define ixf18100_1024TO15XX_TX_OK_W2_OFFSET     ixf18100_XGMAC_REG(0x4E)
#define ixf18100_1024TO15XX_TX_OK_W1_OFFSET     ixf18100_XGMAC_REG(0x4D)
#define ixf18100_1024TO15XX_TX_OK_W0_OFFSET     ixf18100_XGMAC_REG(0x4C)
#define ixf18100_1024TO15XX_TX_OK_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s1024TO15XX_TX_OK              0
#define ixf18100_m1024TO15XX_TX_OK              (0xFFFFFFFF << ixf18100_s1024TO15XX_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* 15XXTOMAX_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_15XXTOMAX_TX_OK_W3_OFFSET      ixf18100_XGMAC_REG(0x53)
#define ixf18100_15XXTOMAX_TX_OK_W2_OFFSET      ixf18100_XGMAC_REG(0x52)
#define ixf18100_15XXTOMAX_TX_OK_W1_OFFSET      ixf18100_XGMAC_REG(0x51)
#define ixf18100_15XXTOMAX_TX_OK_W0_OFFSET      ixf18100_XGMAC_REG(0x50)
#define ixf18100_15XXTOMAX_TX_OK_DFLT           0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s15XXTOMAX_TX_OK               0
#define ixf18100_m15XXTOMAX_TX_OK               (0xFFFFFFFF << ixf18100_s15XXTOMAX_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* VLAN_FRAMES_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_VLAN_FRAMES_TX_OK_W3_OFFSET    ixf18100_XGMAC_REG(0x57)
#define ixf18100_VLAN_FRAMES_TX_OK_W2_OFFSET    ixf18100_XGMAC_REG(0x56)
#define ixf18100_VLAN_FRAMES_TX_OK_W1_OFFSET    ixf18100_XGMAC_REG(0x55)
#define ixf18100_VLAN_FRAMES_TX_OK_W0_OFFSET    ixf18100_XGMAC_REG(0x54)
#define ixf18100_VLAN_FRAMES_TX_OK_DFLT         0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sVLAN_FRAMES_TX_OK             0
#define ixf18100_mVLAN_FRAMES_TX_OK             (0xFFFFFFFF << ixf18100_sVLAN_FRAMES_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* PAUSE_CTRL_FRAMES_TX Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PAUSE_CTRL_FRAMES_TX_W3_OFFSET ixf18100_XGMAC_REG(0x5B)
#define ixf18100_PAUSE_CTRL_FRAMES_TX_W2_OFFSET ixf18100_XGMAC_REG(0x5A)
#define ixf18100_PAUSE_CTRL_FRAMES_TX_W1_OFFSET ixf18100_XGMAC_REG(0x59)
#define ixf18100_PAUSE_CTRL_FRAMES_TX_W0_OFFSET ixf18100_XGMAC_REG(0x58)
#define ixf18100_PAUSE_CTRL_FRAMES_TX_DFLT      0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sPAUSE_CTRL_FRAMES_TX          0
#define ixf18100_mPAUSE_CTRL_FRAMES_TX          (0xFFFFFFFF << ixf18100_sPAUSE_CTRL_FRAMES_TX)
/******************************************************************************/

/******************************************************************************/
/* UNICAST_FRAMES_TX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_UNICAST_FRAMES_TX_OK_W3_OFFSET ixf18100_XGMAC_REG(0x5F)
#define ixf18100_UNICAST_FRAMES_TX_OK_W2_OFFSET ixf18100_XGMAC_REG(0x5E)
#define ixf18100_UNICAST_FRAMES_TX_OK_W1_OFFSET ixf18100_XGMAC_REG(0x5D)
#define ixf18100_UNICAST_FRAMES_TX_OK_W0_OFFSET ixf18100_XGMAC_REG(0x5C)
#define ixf18100_UNICAST_FRAMES_TX_OK_DFLT      0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sUNICAST_FRAMES_TX_OK          0
#define ixf18100_mUNICAST_FRAMES_TX_OK          (0xFFFFFFFF << ixf18100_sUNICAST_FRAMES_TX_OK)
/******************************************************************************/

/******************************************************************************/
/* MAC_CNTRL_FRAMES_TX Register*/

/*Offset/Default definition for register.*/
#define ixf18100_MAC_CNTRL_FRAMES_TX_W3_OFFSET  ixf18100_XGMAC_REG(0x63)
#define ixf18100_MAC_CNTRL_FRAMES_TX_W2_OFFSET  ixf18100_XGMAC_REG(0x62)
#define ixf18100_MAC_CNTRL_FRAMES_TX_W1_OFFSET  ixf18100_XGMAC_REG(0x61)
#define ixf18100_MAC_CNTRL_FRAMES_TX_W0_OFFSET  ixf18100_XGMAC_REG(0x60)
#define ixf18100_MAC_CNTRL_FRAMES_TX_DFLT       0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sMAC_CNTRL_FRAMES_TX           0
#define ixf18100_mMAC_CNTRL_FRAMES_TX           (0xFFFFFFFF << ixf18100_sMAC_CNTRL_FRAMES_TX)
/******************************************************************************/

/******************************************************************************/
/* OCTETS_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_OCTETS_RX_OK_W3_OFFSET         ixf18100_XGMAC_REG(0x83)
#define ixf18100_OCTETS_RX_OK_W2_OFFSET         ixf18100_XGMAC_REG(0x82)
#define ixf18100_OCTETS_RX_OK_W1_OFFSET         ixf18100_XGMAC_REG(0x81)
#define ixf18100_OCTETS_RX_OK_W0_OFFSET         ixf18100_XGMAC_REG(0x80)
#define ixf18100_OCTETS_RX_OK_DFLT              0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sOCTETS_RX_OK                  0
#define ixf18100_mOCTETS_RX_OK                  (0xFFFFFFFF << ixf18100_sOCTETS_RX_OK)
/******************************************************************************/

/******************************************************************************/
/* MULTICAST_FRAMES_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_MULTICAST_FRAMES_RX_OK_W3_OFFSET   ixf18100_XGMAC_REG(0x87)
#define ixf18100_MULTICAST_FRAMES_RX_OK_W2_OFFSET   ixf18100_XGMAC_REG(0x86)
#define ixf18100_MULTICAST_FRAMES_RX_OK_W1_OFFSET   ixf18100_XGMAC_REG(0x85)
#define ixf18100_MULTICAST_FRAMES_RX_OK_W0_OFFSET   ixf18100_XGMAC_REG(0x84)
#define ixf18100_MULTICAST_FRAMES_RX_OK_DFLT        0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sMULTICAST_FRAMES_RX_OK            0
#define ixf18100_mMULTICAST_FRAMES_RX_OK            (0xFFFFFFFF << ixf18100_sMULTICAST_FRAMES_RX_OK)
/******************************************************************************/

/******************************************************************************/
/* BROADCAST_FRAMES_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_BROADCAST_FRAMES_RX_OK_W3_OFFSET   ixf18100_XGMAC_REG(0x8B)
#define ixf18100_BROADCAST_FRAMES_RX_OK_W2_OFFSET   ixf18100_XGMAC_REG(0x8A)
#define ixf18100_BROADCAST_FRAMES_RX_OK_W1_OFFSET   ixf18100_XGMAC_REG(0x89)
#define ixf18100_BROADCAST_FRAMES_RX_OK_W0_OFFSET   ixf18100_XGMAC_REG(0x88)
#define ixf18100_BROADCAST_FRAMES_RX_OK_DFLT        0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sBROADCAST_FRAMES_RX_OK            0
#define ixf18100_mBROADCAST_FRAMES_RX_OK            (0xFFFFFFFF << ixf18100_sBROADCAST_FRAMES_RX_OK)
/******************************************************************************/

/******************************************************************************/
/* FRAMES_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_FRAMES_RX_OK_W3_OFFSET         ixf18100_XGMAC_REG(0x8F)
#define ixf18100_FRAMES_RX_OK_W2_OFFSET         ixf18100_XGMAC_REG(0x8E)
#define ixf18100_FRAMES_RX_OK_W1_OFFSET         ixf18100_XGMAC_REG(0x8D)
#define ixf18100_FRAMES_RX_OK_W0_OFFSET         ixf18100_XGMAC_REG(0x8C)
#define ixf18100_FRAMES_RX_OK_DFLT              0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sFRAMES_RX_OK                  0
#define ixf18100_mFRAMES_RX_OK                  (0xFFFFFFFF << ixf18100_sFRAMES_RX_OK)
/******************************************************************************/

/******************************************************************************/
/* 64OCTET_RX_FRAMES Register*/

/*Offset/Default definition for register.*/
#define ixf18100_64OCTET_RX_FRAMES_W3_OFFSET    ixf18100_XGMAC_REG(0x93)
#define ixf18100_64OCTET_RX_FRAMES_W2_OFFSET    ixf18100_XGMAC_REG(0x92)
#define ixf18100_64OCTET_RX_FRAMES_W1_OFFSET    ixf18100_XGMAC_REG(0x91)
#define ixf18100_64OCTET_RX_FRAMES_W0_OFFSET    ixf18100_XGMAC_REG(0x90)
#define ixf18100_64OCTET_RX_FRAMES_DFLT         0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s64OCTET_RX_FRAMES             0
#define ixf18100_m64OCTET_RX_FRAMES             (0xFFFFFFFF << ixf18100_s64OCTET_RX_FRAMES)
/******************************************************************************/

/******************************************************************************/
/*  65TO127_RX_FRAMES Register*/

/*Offset/Default definition for register.*/
#define ixf18100_65TO127_RX_FRAMES_W3_OFFSET    ixf18100_XGMAC_REG(0x97)
#define ixf18100_65TO127_RX_FRAMES_W2_OFFSET    ixf18100_XGMAC_REG(0x96)
#define ixf18100_65TO127_RX_FRAMES_W1_OFFSET    ixf18100_XGMAC_REG(0x95)
#define ixf18100_65TO127_RX_FRAMES_W0_OFFSET    ixf18100_XGMAC_REG(0x94)
#define ixf18100_65TO127_RX_FRAMES_DFLT         0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s65TO127_RX_FRAMES             0
#define ixf18100_m65TO127_RX_FRAMES             (0xFFFFFFFF << ixf18100_s65TO127_RX_FRAMES)
/******************************************************************************/

/******************************************************************************/
/*  128TO255_RX_FRAMES Register*/

/*Offset/Default definition for register.*/
#define ixf18100_128TO255_RX_FRAMES_W3_OFFSET   ixf18100_XGMAC_REG(0x9B)
#define ixf18100_128TO255_RX_FRAMES_W2_OFFSET   ixf18100_XGMAC_REG(0x9A)
#define ixf18100_128TO255_RX_FRAMES_W1_OFFSET   ixf18100_XGMAC_REG(0x99)
#define ixf18100_128TO255_RX_FRAMES_W0_OFFSET   ixf18100_XGMAC_REG(0x98)
#define ixf18100_128TO255_RX_FRAMES_DFLT        0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s128TO255_RX_FRAMES            0
#define ixf18100_m128TO255_RX_FRAMES            (0xFFFFFFFF << ixf18100_s128TO255_RX_FRAMES)
/******************************************************************************/

/******************************************************************************/
/*  256TO511_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_256TO511_RX_OK_W3_OFFSET       ixf18100_XGMAC_REG(0x9F)
#define ixf18100_256TO511_RX_OK_W2_OFFSET       ixf18100_XGMAC_REG(0x9E)
#define ixf18100_256TO511_RX_OK_W1_OFFSET       ixf18100_XGMAC_REG(0x9D)
#define ixf18100_256TO511_RX_OK_W0_OFFSET       ixf18100_XGMAC_REG(0x9C)
#define ixf18100_256TO511_RX_OK_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s256TO511_RX_OK                0
#define ixf18100_m256TO511_RX_OK                (0xFFFFFFFF << ixf18100_s256TO511_RX_OK)
/******************************************************************************/

/******************************************************************************/
/*  512TO1023_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_512TO1023_RX_OK_W3_OFFSET      ixf18100_XGMAC_REG(0xA3)
#define ixf18100_512TO1023_RX_OK_W2_OFFSET      ixf18100_XGMAC_REG(0xA2)
#define ixf18100_512TO1023_RX_OK_W1_OFFSET      ixf18100_XGMAC_REG(0xA1)
#define ixf18100_512TO1023_RX_OK_W0_OFFSET      ixf18100_XGMAC_REG(0xA0)
#define ixf18100_512TO1023_RX_OK_DFLT           0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s512TO1023_RX_OK               0
#define ixf18100_m512TO1023_RX_OK               (0xFFFFFFFF << ixf18100_s512TO1023_RX_OK)
/******************************************************************************/

/******************************************************************************/
/*  1024TO15XX_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_1024TO15XX_RX_OK_W3_OFFSET     ixf18100_XGMAC_REG(0xA7)
#define ixf18100_1024TO15XX_RX_OK_W2_OFFSET     ixf18100_XGMAC_REG(0xA6)
#define ixf18100_1024TO15XX_RX_OK_W1_OFFSET     ixf18100_XGMAC_REG(0xA5)
#define ixf18100_1024TO15XX_RX_OK_W0_OFFSET     ixf18100_XGMAC_REG(0xA4)
#define ixf18100_1024TO15XX_RX_OK_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s1024TO15XX_RX_OK              0
#define ixf18100_m1024TO15XX_RX_OK              (0xFFFFFFFF << ixf18100_s1024TO15XX_RX_OK)
/******************************************************************************/

/******************************************************************************/
/*  15XXTOMAX_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_15XXTOMAX_RX_OK_W3_OFFSET      ixf18100_XGMAC_REG(0xAB)
#define ixf18100_15XXTOMAX_RX_OK_W2_OFFSET      ixf18100_XGMAC_REG(0xAA)
#define ixf18100_15XXTOMAX_RX_OK_W1_OFFSET      ixf18100_XGMAC_REG(0xA9)
#define ixf18100_15XXTOMAX_RX_OK_W0_OFFSET      ixf18100_XGMAC_REG(0xA8)
#define ixf18100_15XXTOMAX_RX_OK_DFLT           0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s15XXTOMAX_RX_OK               0
#define ixf18100_m15XXTOMAX_RX_OK               (0xFFFFFFFF << ixf18100_s15XXTOMAX_RX_OK)
/******************************************************************************/

/******************************************************************************/
/*  VLAN_FRAMES_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_VLAN_FRAMES_RX_OK_W3_OFFSET    ixf18100_XGMAC_REG(0xAF)
#define ixf18100_VLAN_FRAMES_RX_OK_W2_OFFSET    ixf18100_XGMAC_REG(0xAE)
#define ixf18100_VLAN_FRAMES_RX_OK_W1_OFFSET    ixf18100_XGMAC_REG(0xAD)
#define ixf18100_VLAN_FRAMES_RX_OK_W0_OFFSET    ixf18100_XGMAC_REG(0xAC)
#define ixf18100_VLAN_FRAMES_RX_OK_DFLT         0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sVLAN_FRAMES_RX_OK             0
#define ixf18100_mVLAN_FRAMES_RX_OK             (0xFFFFFFFF << ixf18100_sVLAN_FRAMES_RX_OK)
/******************************************************************************/

/******************************************************************************/
/*  PAUSE_MAC_CTRL_FRAMES_RX Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PAUSE_MAC_CTRL_FRAMES_RX_W3_OFFSET ixf18100_XGMAC_REG(0xB3)
#define ixf18100_PAUSE_MAC_CTRL_FRAMES_RX_W2_OFFSET ixf18100_XGMAC_REG(0xB2)
#define ixf18100_PAUSE_MAC_CTRL_FRAMES_RX_W1_OFFSET ixf18100_XGMAC_REG(0xB1)
#define ixf18100_PAUSE_MAC_CTRL_FRAMES_RX_W0_OFFSET ixf18100_XGMAC_REG(0xB0)
#define ixf18100_PAUSE_MAC_CTRL_FRAMES_RX_DFLT      0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sPAUSE_MAC_CTRL_FRAMES_RX      0
#define ixf18100_mPAUSE_MAC_CTRL_FRAMES_RX      (0xFFFFFFFF << ixf18100_sPAUSE_MAC_CTRL_FRAMES_RX)
/******************************************************************************/

/******************************************************************************/
/*  UNICAST_FRAMES_RX_OK Register*/

/*Offset/Default definition for register.*/
#define ixf18100_UNICAST_FRAMES_RX_OK_W3_OFFSET ixf18100_XGMAC_REG(0xB7)
#define ixf18100_UNICAST_FRAMES_RX_OK_W2_OFFSET ixf18100_XGMAC_REG(0xB6)
#define ixf18100_UNICAST_FRAMES_RX_OK_W1_OFFSET ixf18100_XGMAC_REG(0xB5)
#define ixf18100_UNICAST_FRAMES_RX_OK_W0_OFFSET ixf18100_XGMAC_REG(0xB4)
#define ixf18100_UNICAST_FRAMES_RX_OK_DFLT      0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sUNICAST_FRAMES_RX_OK          0
#define ixf18100_mUNICAST_FRAMES_RX_OK          (0xFFFFFFFF << ixf18100_sUNICAST_FRAMES_RX_OK)
/******************************************************************************/

/******************************************************************************/
/*  MAC_CNTRL_FRAMES_RX Register*/

/*Offset/Default definition for register.*/
#define ixf18100_MAC_CNTRL_FRAMES_RX_W3_OFFSET  ixf18100_XGMAC_REG(0xBB)
#define ixf18100_MAC_CNTRL_FRAMES_RX_W2_OFFSET  ixf18100_XGMAC_REG(0xBA)
#define ixf18100_MAC_CNTRL_FRAMES_RX_W1_OFFSET  ixf18100_XGMAC_REG(0xB9)
#define ixf18100_MAC_CNTRL_FRAMES_RX_W0_OFFSET  ixf18100_XGMAC_REG(0xB8)
#define ixf18100_MAC_CNTRL_FRAMES_RX_DFLT       0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sMAC_CNTRL_FRAMES_RX           0
#define ixf18100_mMAC_CNTRL_FRAMES_RX           (0xFFFFFFFF << ixf18100_sMAC_CNTRL_FRAMES_RX)
/******************************************************************************/

/******************************************************************************/
/*  ETHER_STATS_UNDERSIZE_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ETHER_STATS_UNDERSIZE_PKTS_W3_OFFSET   ixf18100_XGMAC_REG(0xBF)
#define ixf18100_ETHER_STATS_UNDERSIZE_PKTS_W2_OFFSET   ixf18100_XGMAC_REG(0xBE)
#define ixf18100_ETHER_STATS_UNDERSIZE_PKTS_W1_OFFSET   ixf18100_XGMAC_REG(0xBD)
#define ixf18100_ETHER_STATS_UNDERSIZE_PKTS_W0_OFFSET   ixf18100_XGMAC_REG(0xBC)
#define ixf18100_ETHER_STATS_UNDERSIZE_PKTS_DFLT        0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sETHER_STATS_UNDERSIZE_PKTS    0
#define ixf18100_mETHER_STATS_UNDERSIZE_PKTS    (0xFFFFFFFF << ixf18100_sETHER_STATS_UNDERSIZE_PKTS)
/******************************************************************************/

/******************************************************************************/
/*  ETHER_STATS_OVERSIZE_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ETHER_STATS_OVERSIZE_PKTS_W3_OFFSET    ixf18100_XGMAC_REG(0xC3)
#define ixf18100_ETHER_STATS_OVERSIZE_PKTS_W2_OFFSET    ixf18100_XGMAC_REG(0xC2)
#define ixf18100_ETHER_STATS_OVERSIZE_PKTS_W1_OFFSET    ixf18100_XGMAC_REG(0xC1)
#define ixf18100_ETHER_STATS_OVERSIZE_PKTS_W0_OFFSET    ixf18100_XGMAC_REG(0xC0)
#define ixf18100_ETHER_STATS_OVERSIZE_PKTS_DFLT         0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sETHER_STATS_OVERSIZE_PKTS     0
#define ixf18100_mETHER_STATS_OVERSIZE_PKTS     (0xFFFFFFFF << ixf18100_sETHER_STATS_OVERSIZE_PKTS)
/******************************************************************************/

/******************************************************************************/
/*  ETHER_STATS_OCTECTS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ETHER_STATS_OCTECTS_W3_OFFSET  ixf18100_XGMAC_REG(0xC7)
#define ixf18100_ETHER_STATS_OCTECTS_W2_OFFSET  ixf18100_XGMAC_REG(0xC6)
#define ixf18100_ETHER_STATS_OCTECTS_W1_OFFSET  ixf18100_XGMAC_REG(0xC5)
#define ixf18100_ETHER_STATS_OCTECTS_W0_OFFSET  ixf18100_XGMAC_REG(0xC4)
#define ixf18100_ETHER_STATS_OCTECTS_DFLT       0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sETHER_STATS_OCTECTS           0
#define ixf18100_mETHER_STATS_OCTECTS           (0xFFFFFFFF << ixf18100_sETHER_STATS_OCTECTS)
/******************************************************************************/

/******************************************************************************/
/*  ETHER_STATS_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ETHER_STATS_PKTS_W3_OFFSET     ixf18100_XGMAC_REG(0xCB)
#define ixf18100_ETHER_STATS_PKTS_W2_OFFSET     ixf18100_XGMAC_REG(0xCA)
#define ixf18100_ETHER_STATS_PKTS_W1_OFFSET     ixf18100_XGMAC_REG(0xC9)
#define ixf18100_ETHER_STATS_PKTS_W0_OFFSET     ixf18100_XGMAC_REG(0xC8)
#define ixf18100_ETHER_STATS_PKTS_DFLT          0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sETHER_STATS_PKTS              0 
#define ixf18100_mETHER_STATS_PKTS              (0xFFFFFFFF << ixf18100_sETHER_STATS_PKTS)
/******************************************************************************/

/******************************************************************************/
/*  ETHER_STATS_FRAGMENTS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ETHER_STATS_FRAGMENTS_W3_OFFSET    ixf18100_XGMAC_REG(0xCF)
#define ixf18100_ETHER_STATS_FRAGMENTS_W2_OFFSET    ixf18100_XGMAC_REG(0xCE)
#define ixf18100_ETHER_STATS_FRAGMENTS_W1_OFFSET    ixf18100_XGMAC_REG(0xCD)
#define ixf18100_ETHER_STATS_FRAGMENTS_W0_OFFSET    ixf18100_XGMAC_REG(0xCC)
#define ixf18100_ETHER_STATS_FRAGMENTS_DFLT         0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sETHER_STATS_FRAGMENTS         0
#define ixf18100_mETHER_STATS_FRAGMENTS         (0xFFFFFFFF << ixf18100_sETHER_STATS_FRAGMENTS)
/******************************************************************************/

/******************************************************************************/
/*  ETHER_STATS_JABBERS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ETHER_STATS_JABBERS_W3_OFFSET  ixf18100_XGMAC_REG(0xD3)
#define ixf18100_ETHER_STATS_JABBERS_W2_OFFSET  ixf18100_XGMAC_REG(0xD2)
#define ixf18100_ETHER_STATS_JABBERS_W1_OFFSET  ixf18100_XGMAC_REG(0xD1)
#define ixf18100_ETHER_STATS_JABBERS_W0_OFFSET  ixf18100_XGMAC_REG(0xD0)
#define ixf18100_ETHER_STATS_JABBERS_DFLT       0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sETHER_STATS_JABBERS           0
#define ixf18100_mETHER_STATS_JABBERS           (0xFFFFFFFF << ixf18100_sETHER_STATS_JABBERS)
/******************************************************************************/

/******************************************************************************/
/*  FRAME_CHECK_SEQ_ERRS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_FRAME_CHECK_SEQ_ERRS_W3_OFFSET ixf18100_XGMAC_REG(0xD7)
#define ixf18100_FRAME_CHECK_SEQ_ERRS_W2_OFFSET ixf18100_XGMAC_REG(0xD6)
#define ixf18100_FRAME_CHECK_SEQ_ERRS_W1_OFFSET ixf18100_XGMAC_REG(0xD5)
#define ixf18100_FRAME_CHECK_SEQ_ERRS_W0_OFFSET ixf18100_XGMAC_REG(0xD4)
#define ixf18100_FRAME_CHECK_SEQ_ERRS_DFLT      0x00000000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sFRAME_CHECK_SEQ_ERRS          0
#define ixf18100_mFRAME_CHECK_SEQ_ERRS          (0xFFFFFFFF << ixf18100_sFRAME_CHECK_SEQ_ERRS)
/******************************************************************************/


#endif /*__IXF18100_XGMAC_B_H__*/
