/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:03p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_xgmac_d.h $
*   WORKFILE:       $Workfile: ixf18100_xgmac_d.h $
*
* --------------------------------------------------------------------------
* Project: ixf18100 family device API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf1810x/ixf18100_xgmac_d.h $
 * 
 * 1     3/11/04 3:03p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 8     1/30/03 4:40p Pkjain2
* Made changes for PTQ release. Added Getstatus calls for SONET and
* GLOBAL block.
* 
* 7     11/12/02 2:29p Jaalliso
* XGMAC_CNTL/XGMAC_CNTL2 B0 silicon changes
* 
* 6     7/08/02 1:17p Pkjain2
* Moved Calypso specific data stuctures into Calypso block specific data
* structure file.
* 
* 3     8/24/01 3:16p Wrbrackn
* Removed case structure in XGMAC_PP register per Mark's request.
* 
* 2     8/23/01 5:43p Wrbrackn
* Test driver that tests the sets and gets now compiles cleanly.
* 
* 1     8/23/01 4:13p Wrbrackn
* Seperated data structures out from main header file.
*
* --------------------------------------------------------------------------
*/

#ifndef __IXF18100_XGMAC_D_H__
#define __IXF18100_XGMAC_D_H__

typedef uint64Struct_t Ixf18100_MacAddress_t;

typedef enum
{
    eTxPace_10gbps = 0,
        eTxPace_1gbps,
        eTxPace_2gbps,
        eTxPace_3gbps,
        eTxPace_4gbps,
        eTxPace_5gbps,
        eTxPace_6gbps,
        eTxPace_7gbps,
        eTxPace_8gbps,
        eTxPace_9gbps,
        eTxPace_9_294gbps = 0xf,
        
} eIxf18100_TxPace_t;


typedef struct
{
    /* XGMAC_CNTL */
    uchar   ucRxPauseFrameAddr;
    uchar   ucPrependValue;
    uchar   ucCntlFrmFilterEn;
    uchar   ucCont_MDC_En;
    uchar   ucMDC_SpdSel;
    uchar   ucLoopback;
    uchar   ucRxPauseEn;
    uchar   ucRxEn;
    uchar   ucTxPauseEn;
    uchar   ucTxEn;
    uchar   ucTxPadFrmEn;
    uchar   ucSftRst;
    uchar   ucMngmntRst;
    uchar   ucRxRst;
    uchar   ucRxCRC_Rst;
    uchar   ucTxRst;
    uchar   ucTxCRC_Rst;
    uchar   ucJumFrmEn;
    uchar   ucRxCRC_Strip;
    uchar   ucTxCRC_En;
    
    /* XGMAC_CNTL2 */
    uchar   ucRxUndersizeDropEn;
    uchar   ucRxOversizeDropEn;
    uchar   ucRxCrcErrorDropEn;
    
    /* Xgmac_PP */
    eIxf18100_TxPace_t   eTxPace;
    ushort  uiTxPauseCnt;
    
    /* MAC Address */
    uint64Struct_t  MAC_Addr;
    
    /* Xgmac_ADDHIJUM */
    ushort  uiMaxFrmSize;
    
} ixf18100_XgmacCfg_t;


typedef struct
{
    uchar   ucRxLinkFail;
    uchar   ucRxRemoteFault;
    uchar   ucRxLocalFault;
    uchar   ucRxIdleError;
    uchar   ucRxIllegalSymbol;
    uchar   ucRxErrorSymbol;
    uchar   ucAutoscanInProgress;
    uchar   ucRevisionID;
    
} ixf18100_XgmacStatus_t;

#endif /*__IXF18100_XGMAC_D_H__*/
