/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:01p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf_api_ether_d.h $
*   WORKFILE:       $Workfile: ixf_api_ether_d.h $
*
* --------------------------------------------------------------------------
* Project: All
*
* Purpose: This file defines Ethernet related types
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/ixf_api_ether_d.h $
 * 
 * 1     3/11/04 3:01p Tepulkow
 * 
 * 1     5/16/03 1:41p Tepulkow
* 
* 7     12/12/02 9:50p Machambe
* Moving uint64Struct_t to common_def.h
* 
* --------------------------------------------------------------------------
*/
#ifndef __IXF_API_ETHER_D_H__
#define __IXF_API_ETHER_D_H__

typedef uint64Struct_t IxfApi_MacAddress_t;

typedef struct
{
    uint64Struct_t  OctetsTxOK;
    uint64Struct_t  MulticastFramesTxOK;
    uint64Struct_t  BroadcastFramesTxOK;
    uint64Struct_t  FramesTxOK;
    uint64Struct_t  Counter64OctetTxFrames;
    uint64Struct_t  Counter65to127TxFrames;
    uint64Struct_t  Counter128to255TxFrames;
    uint64Struct_t  Counter256to511TxFrames;
    uint64Struct_t  Counter512to1023TxOK;
    uint64Struct_t  Counter1024to15xxTxOK;
    uint64Struct_t  Counter15xxtoMaxTxOK;
    uint64Struct_t  VLANFramesTxOK;
    uint64Struct_t  PAUSECtrlFramesTx;
    uint64Struct_t  UnicastFramesTxOK;
    uint64Struct_t  MACCtrlFramesTx;
    uint64Struct_t  OctetsRxOK;
    uint64Struct_t  MulticastFramesRxOK;
    uint64Struct_t  BroadcastFramesRxOK;
    uint64Struct_t  FramesRxOK;
    uint64Struct_t  Counter64OctetRxFrames;
    uint64Struct_t  Counter65to127RxFrames;
    uint64Struct_t  Counter128to255RxFrames;
    uint64Struct_t  Counter256to511RxOK;
    uint64Struct_t  Counter512to1023RxOK;
    uint64Struct_t  Counter1024to15xxRxOK;
    uint64Struct_t  Counter15xxtoMaxRxOK;
    uint64Struct_t  VLANFramesRxOK;
    uint64Struct_t  PAUSEMACCtrlFramesRx;
    uint64Struct_t  UnicastFramesRxOK;
    uint64Struct_t  MACCtrlFramesRx;
    uint64Struct_t  EtherStatsUndersizePkts;
    uint64Struct_t  EtherStatsOversizePkts;
    uint64Struct_t  EtherStatsOctets;
    uint64Struct_t  EtherStatsPkts;
    uint64Struct_t  EtherStatsFragments;
    uint64Struct_t  EtherStatsJabbers;
    uint64Struct_t  FrameCheckSeqErr;
} ixfApi_XgmacCounters_t;

#endif /*__IXF_API_ETHER_D_H__*/
