/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/11/04 3:01p $
*   LAST MODIFIED:  $Modtime: 3/05/04 12:05p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/test18101.c $
*   WORKFILE:       $Workfile: test18101.c $
*
* --------------------------------------------------------------------------
* Project: IXF API
*
* Purpose: Provides a simple driver to drive the driver :)
*			
* Notes:
*			
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/VxWorks/MediaCardDrivers/IXD28192/ixf/test18101.c $
 * 
 * 1     3/11/04 3:01p Tepulkow
 * 
 * 1     5/16/03 1:41p Tepulkow
*   Revision 1.9  2002/10/28 20:53:39  machambe
*   no message
*
*   Revision 1.8  2002/10/28 20:33:28  machambe
*   no message
*
*   Revision 1.7  2002/10/28 19:58:14  machambe
*   no message
*
*   Revision 1.6  2002/10/28 13:58:57  machambe
*   no message
*
*   Revision 1.5  2002/10/27 18:20:44  machambe
*   no message
*
*   Revision 1.4  2002/10/26 00:40:05  machambe
*   no message
*
*   Revision 1.3  2002/10/25 20:24:49  machambe
*   no message
*
*   Revision 1.2  2002/10/14 09:41:04  machambe
*   no message
*
*   Revision 1.1  2002/10/05 00:08:39  machambe
*   no message
*
*   Revision 1.3  2002/07/22 23:23:28  machambe
*   no message
*
*   Revision 1.2  2002/07/21 03:19:41  machambe
*   no message
*
* 
* 27    5/17/02 1:54p Machambe
* 
* 26    5/02/02 4:47p Srodrig1
* Added Generic Lib.
* 
* 25    5/01/02 4:37p Machambe
* 
* 24    1/29/02 1:22p Machambe
* Modified test driver to support multiple chip testing
* 
* 23    1/07/02 9:46a Machambe
* 
* 22    12/04/01 4:23p Pkjain2
* 
* 21    12/01/01 6:35p Machambe
* 
* 20    11/15/01 6:41p Machambe
* 
* 19    11/15/01 10:03a Machambe
* Changing bb_util.h to ixf_api_d.h
* 
* 18    8/15/01 4:46p Machambe
* 
* 17    7/26/01 3:22p Machambe
* 
* 16    6/25/01 10:53a Machambe
* 
* 15    5/30/01 9:56a Rsood
* 
* 14    5/03/01 3:54p Machambe
* 
* --------------------------------------------------------------------------
*/

#include "stdio.h"
#include <stdlib.h>
#ifdef VXWORKS
#include "vxWorks.h"
#include "string.h"
#include "msgQLib.h"
#include "logLib.h"
#include "usrLib.h"
#include "intLib.h"
#endif

#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h" /* BroadBand Utility Definitions and Function headers */
#include "ixf_api_sonet_d.h"
#include "ixf_api.h"
#include "ixf_api_sonet.h"
#include "bld6048.h"
#include "ixf6048b.h"
#include "ixf6048d.h"
#include "hal.h"
#include "sim.h"
#ifdef INTERRUPT_SYSTEM_MODE
#include "ixf6048s.h"
#include "interrupts.h"
#include "intrhndlrd.h"
#include "intrhndlr.h"
#endif

extern void sp_config(void);
extern void save_sp_config(void);
extern void restore_sp_config(void);
extern void ixf6048_ChipIsr(bb_ChipData_t *pChipData);
SEM_ID ISRSemaphore;
MSG_Q_ID intrMsgQId;

volatile int isrFlag;
int HaveWeRunBefore = 1;

#define IXF6048_BASE_ADDRESS 0xC6000000
#define DATABUF_SIZE 64
#define HCO(chan)		(0x400+((chan)<<8))
#define LCO(chan)		(chan << 8)
/* globals */
#define MACNF		(0x001)
#define CHIP_ID		(0x002)
#define SRESET		(0x003)
#define BUF_ACNTS	(0x004)
#define SDH_GIS		(0x005)
#define ATMPOS_GIS	(0x006)
#define S_AIS		(0x007)
#define GOCNF		(0x008)
#define COCNF(x)	(0x009+LCO(x))
#define R_COCNF(x)	(0x00a+LCO(x))
#define T_COCNF(x)	(0x00b+LCO(x))
#define OHPCNF		(0x00c)
#define R_FPCNF		(0x00d)
#define T_FPCNF		(0x00e)
#define OCPCNF		(0x00f)
#define ICPCNF1		(0x010)
#define ICPCNF2		(0x011)
#define ICMR1		(0x012)
#define ICMR2		(0x013)
#define NCMODECNF	(0x014)
#define TESTCNF		(0x015)
#define TESTRAM_0	(0x016)
#define TESTRAM_1	(0x017)
#define TESTRAM_2	(0x018)
#define TESTRAM_3	(0x019)
#define PRBSINT		(0x01a)
#define PRBSINTEN	(0x01b)
#define TALBINT		(0x01c)
#define TALBINTEN	(0x01d)
#define LSPCNF		(0x01e)
#define LSPINT		(0x01f)
#define LSPINTEN	(0x020)
#define MISC_GIS	(0x021)

/* UTOPIA i/f */
#define R_UICNF			(0x070)
#define R_UIIML			(0x071)
#define R_UICHCNF(x)	(0x060+LCO(x))
#define R_PWM(x)		(0x061+LCO(x))
#define T_UICNF			(0x050)
#define T_UIIML			(0x051)
#define T_UICHCNF(x)	(0x040+LCO(x))
#define T_UIFDP(x)		(0x041+LCO(x))
#define T_NFPWM(x)		(0x042+LCO(x))
#define T_NEWWM(x)		(0x043+LCO(x))
#define R_UTOINT		(0x072)
#define T_UTOINT		(0x052)
#define R_UTOINTEN		(0x073)
#define T_UTOINTEN		(0x053)

/* SONET/SDH RX Regenerator Section Termination (per channel) */
#define R_RSTC(x)		(0x080+HCO(x))
#define LOF_LMN(x)		(0x081+HCO(x))
#define OOF_ECNT(x)		(0x082+HCO(x))
#define B1_ERRCNT(x)	(0x083+HCO(x))
#define R_J0_ERRCNT(x)	(0x085+HCO(x))
#define R_J0_ASTRA(x)	(0x086+HCO(x))
#define J0_RSTC(x)		(0x087+HCO(x))
#define IS_RG(x)		(0x0d0+HCO(x))
#define IE_RG(x)		(0x0d4+HCO(x))
#define S_RG(x)			(0x0d8+HCO(x))

/* SONET/SDH RX MUX Section Termination (per channel) */
#define	R_MST_C(x)			(0x090+HCO(x))
#define B2_BLKCNT_LO(x)		(0x095+HCO(x))
#define B2_BLKCNT_HI(x)		(0x096+HCO(x))
#define B2_BIPCNT_LO(x)		(0x097+HCO(x))
#define B2_BIPCNT_HI(x)		(0x098+HCO(x))
#define MR_BLKCNT_LO(x)		(0x099+HCO(x))
#define MR_BLKCNT_HI(x)		(0x09a+HCO(x))
#define MR_BIPCNT_LO(x)		(0x09b+HCO(x))
#define MR_BIPCNT_HI(x)		(0x09c+HCO(x))
#define R_K2K1(x) 			(0x09d+HCO(x))
#define R_S1(x)				(0x09f+HCO(x))
#define WINSZ_SB2(x)		(0x0b0+HCO(x))
#define CWIN_SB2(x)			(0x0b1+HCO(x))
#define E_EXCWIN(x)			(0x0b2+HCO(x))
#define WINSZ_CB2(x)		(0x0b3+HCO(x))
#define CWIN_CB2(x)			(0x0b4+HCO(x))
#define E_NEXCWIN_CB2(x)	(0x0b5+HCO(x))
#define WINSZ_SDEGB2_LO(x)	(0x0b6+HCO(x))
#define WINSZ_SDEGB2_HI(x)	(0x0b7+HCO(x))
#define CWIN_SDEGB2(x)		(0x0b8+HCO(x))
#define E_DEGWIN(x)			(0x0b9+HCO(x))
#define WINSZ_CDEGB2_LO(x)	(0x0ba+HCO(x))
#define WINSZ_CDEGB2_HI(x)	(0x0bb+HCO(x))
#define CWIN_CDEGB2(x)		(0x0bc+HCO(x))
#define E_NDEGWIN_CB2(x)	(0x0bd+HCO(x))
#define IS_MUX(x)			(0x0d1+HCO(x))
#define IE_MUX(x)			(0x0d5+HCO(x))
#define S_MUX(x)			(0x0d9+HCO(x))

/* SONET/SDH Receive MUX Section Adaptation Registers (per channel) */
#define R_MSA_C(x)		(0x0a0+HCO(x))
#define R_AU_NCNT(x)	(0x0a1+HCO(x))
#define R_AU_PCNT(x)	(0x0a2+HCO(x))
#define IS_ADP(x)		(0x0d2+HCO(x))
#define IE_ADP(x)		(0x0d6+HCO(x))
#define S_ADP(x)		(0x0da+HCO(x))

/* SONET/SDH Receive High Order Path Termination Registers (per channel) */
#define R_HPT_C1(x)		(0x0a4+HCO(x))
#define R_HPT_C2(x)		(0x0a5+HCO(x))
#define EXP_C2(x)		(0x0a6+HCO(x))
#define R_C2(x)			(0x0a7+HCO(x))
#define R_HPT_RDI(x)	(0x0a8+HCO(x))
#define B3_ECNT(x)		(0x0a9+HCO(x))
#define HPTREI_CNT(x)	(0x0aa+HCO(x))
#define R_J1_ASTRA(x)	(0x0ad+HCO(x))
#define R_J1_ESTRA(x)	(0x0af+HCO(x))
#define IS_HPT(x)		(0x0d3+HCO(x))
#define IE_HPT(x)		(0x0d7+HCO(x))
#define S_HPT(x)		(0x0db+HCO(x))

/* SONET/SDH Transmit Regenerator and MUX Section Termination (per channel) */
#define T_RMST_OP(x)	(0x0e0+HCO(x))
#define T_SC_RSOH(x)	(0x0e1+HCO(x))
#define T_SC_MSOH(x)	(0x0e2+HCO(x))
#define T_J0_STRA(x)	(0x0e4+HCO(x))
#define MP_TK2K1(x)		(0x0e5+HCO(x))
#define MP_TS1(x)		(0x0e6+HCO(x))

/* SONET/SDH Transmit MUX Section Adaptation Registers (per channel) */
#define T_AU_PTS(x)		(0x0e9+HCO(x))
#define T_CAU_PT(x)		(0x0ea+HCO(x))

/* SONET/SDH Transmit High Order Path Termination Registers (per channel) */
#define T_HPT_C(x)		(0x0e8+HCO(x))
#define MP_TC2(x)		(0x0eb+HCO(x))
#define MP_THPTRDI(x)	(0x0ec+HCO(x))
#define T_J1_STRA(x)	(0x0ee+HCO(x))
#define T_HPT_OPC(x)	(0x0ef+HCO(x))

/* ATM Rx channel Registers */
#define R_ACPCNF(x)			(0x020+HCO(x))
#define R_IUCFLTR(x)		(0x021+HCO(x))
#define R_LCDFLTR_LO(x)		(0x022+HCO(x))
#define R_LCDFLTR_HI(x)		(0x023+HCO(x))
#define R_ACELLCNT_LO(x)	(0x024+HCO(x))
#define R_ACELLCNT_HI(x)	(0x025+HCO(x))
#define R_ICELLCNT_LO(x)	(0x026+HCO(x))
#define R_ICELLCNT_HI(x)	(0x027+HCO(x))
#define R_CHECNT(x)			(0x028+HCO(x))
#define R_UHECNT(x)			(0x029+HCO(x))
#define R_CFOCNT(x)			(0x02a+HCO(x))
#define R_ATMINT(x)			(0x02b+HCO(x))
#define R_ATMINTEN(x)		(0x02c+HCO(x))

/* ATM Tx channel Registers */
#define T_ACPCNF(x)			(0x010+HCO(x))
#define T_ICELLP(x)			(0x011+HCO(x))
#define T_ACELLCNT_LO(x)	(0x012+HCO(x))
#define T_ACELLCNT_HI(x)	(0x013+HCO(x))
#define T_ICELLCNT_LO(x)	(0x014+HCO(x))
#define T_ICELLCNT_HI(x)	(0x015+HCO(x))
#define T_ATMINT(x)			(0x016+HCO(x))
#define T_ATMINTEN(x)		(0x017+HCO(x))

/* POS Rx Channel Registers */
#define R_PHCCNF(x)			(0x060+HCO(x))
#define R_MINPL(x)			(0x061+HCO(x))
#define R_MAXPL(x)			(0x062+HCO(x))
#define R_FRMCNT_LO(x)		(0x063+HCO(x))
#define R_FRMCNT_HI(x)		(0x064+HCO(x))
#define R_BYTECNT_LO(x)		(0x065+HCO(x))
#define R_BYTECNT_HI(x)		(0x066+HCO(x))
#define R_AFCNT_LO(x)		(0x067+HCO(x))
#define R_AFCNT_HI(x)		(0x068+HCO(x))
#define R_FCSECNT_LO(x)		(0x069+HCO(x))
#define R_FCSECNT_HI(x)		(0x06a+HCO(x))
#define R_PFOCNT(x)			(0x06b+HCO(x))
#define R_MINPLECNT_LO(x)	(0x06c+HCO(x))
#define R_MINPLECNT_HI(x)	(0x06d+HCO(x))
#define R_MAXPLECNT(x)		(0x06e+HCO(x))
#define R_POSINT(x)			(0x06f+HCO(x))
#define R_POSINTEN(x)		(0x070+HCO(x))

/* POS Tx channel Registers */
#define T_PHCCNF(x)		(0x040+HCO(x))
#define T_IPGCTRL(x)	(0x041+HCO(x))
#define T_FRMCNT_LO(x)	(0x042+HCO(x))
#define T_FRMCNT_HI(x)	(0x043+HCO(x))
#define T_BYTECNT_LO(x)	(0x044+HCO(x))
#define T_BYTECNT_HI(x)	(0x045+HCO(x))
#define T_AFCNT_LO(x)	(0x046+HCO(x))
#define T_AFCNT_HI(x)	(0x047+HCO(x))
#define T_PFUCNT(x)		(0x048+HCO(x))
#define T_POSINT(x)		(0x049+HCO(x))
#define T_POSINTEN(x)	(0x04a+HCO(x))


InitRegTable_t RegInitIXF6048Table[] =
{
/* Note: Channel applies depending of the Chip Block as:
Channel could represent the DataLine
Channel could represent the group
Channel could represent the Tributary
    Channel could represent the Line */
    
    /* IXF6048 Global Cnfg Register Block */
    { (bb_RegPointer_type) 0x0001,    0x0000 },
    { (bb_RegPointer_type) 0x0003,    0x0000 },
    { (bb_RegPointer_type) 0x0004,    0x0000 },
    { (bb_RegPointer_type) 0x0008,    0x0038 },
    { (bb_RegPointer_type) 0x000C,    0x0000 },
    { (bb_RegPointer_type) 0x000D,    0x0030 },
    { (bb_RegPointer_type) 0x000E,    0x3030 },
    { (bb_RegPointer_type) 0x000F,    0x0001 },
    { (bb_RegPointer_type) 0x0010,    0x0000 },
    { (bb_RegPointer_type) 0x0011,    0x0000 },
    { (bb_RegPointer_type) 0x0014,    0x0000 },
    { (bb_RegPointer_type) 0x0015,    0x0000 },
    { (bb_RegPointer_type) 0x001E,    0x0000 },
    { (bb_RegPointer_type) 0x001B,    0x0000 },
    { (bb_RegPointer_type) 0x001D,    0x0000 },
    { (bb_RegPointer_type) 0x0020,    0x0000 },
    /* IXF6048 Channel Confg Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0009,    0x0007 },
    { (bb_RegPointer_type) 0x000A,    0x01F3 },
    { (bb_RegPointer_type) 0x000B,    0x01F3 },
    /* IXF6048 Channel Confg Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0109,    0x0007 },
    { (bb_RegPointer_type) 0x010A,    0x00F2 },
    { (bb_RegPointer_type) 0x010B,    0x07F2 },
    /* IXF6048 Channel Confg Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0209,    0x0007 },
    { (bb_RegPointer_type) 0x020A,    0x00F2 },
    { (bb_RegPointer_type) 0x020B,    0x07F2 },
    /* IXF6048 Channel Confg Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0309,    0x0007 },
    { (bb_RegPointer_type) 0x030A,    0x00F2 },
    { (bb_RegPointer_type) 0x030B,    0x07F2 },
    /* IXF6048 Glb Utopia Register Block */
    { (bb_RegPointer_type) 0x0070,    0x00A5 },
    { (bb_RegPointer_type) 0x0071,    0x0002 },
    { (bb_RegPointer_type) 0x0050,    0x0024 },
    { (bb_RegPointer_type) 0x0051,    0x0002 },
    { (bb_RegPointer_type) 0x0073,    0x0000 },
    { (bb_RegPointer_type) 0x0053,    0x1010 },
    /* IXF6048 Channel Utopia Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0060,    0x0319 },
    { (bb_RegPointer_type) 0x0061,    0x000F },
    { (bb_RegPointer_type) 0x0040,    0x0319 },
    { (bb_RegPointer_type) 0x0041,    0x00FF },
    { (bb_RegPointer_type) 0x0042,    0x001F },
    { (bb_RegPointer_type) 0x0043,    0x00FF },
    /* IXF6048 Channel Utopia Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0160,    0x0119 },
    { (bb_RegPointer_type) 0x0161,    0x000F },
    { (bb_RegPointer_type) 0x0140,    0x0119 },
    { (bb_RegPointer_type) 0x0141,    0x001F },
    { (bb_RegPointer_type) 0x0142,    0x001F },
    { (bb_RegPointer_type) 0x0143,    0x00FF },
    /* IXF6048 Channel Utopia Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0260,    0x0119 },
    { (bb_RegPointer_type) 0x0261,    0x000F },
    { (bb_RegPointer_type) 0x0240,    0x0119 },
    { (bb_RegPointer_type) 0x0241,    0x001F },
    { (bb_RegPointer_type) 0x0242,    0x001F },
    { (bb_RegPointer_type) 0x0243,    0x00FF },
    /* IXF6048 Channel Utopia Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0360,    0x0119 },
    { (bb_RegPointer_type) 0x0361,    0x000F },
    { (bb_RegPointer_type) 0x0340,    0x0119 },
    { (bb_RegPointer_type) 0x0341,    0x001F },
    { (bb_RegPointer_type) 0x0342,    0x001F },
    { (bb_RegPointer_type) 0x0343,    0x00FF },
    /* IXF6048 RST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0480,    0x8000 },
    { (bb_RegPointer_type) 0x0481,    0x0000 },
    { (bb_RegPointer_type) 0x0487,    0x0002 },
    { (bb_RegPointer_type) 0x04D0,    0x030F },
    { (bb_RegPointer_type) 0x04D4,    0x0000 },
    { (bb_RegPointer_type) 0x04D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0580,    0x8100 },
    { (bb_RegPointer_type) 0x0581,    0x0000 },
    { (bb_RegPointer_type) 0x0587,    0x0002 },
    { (bb_RegPointer_type) 0x05D0,    0x0000 },
    { (bb_RegPointer_type) 0x05D4,    0x0000 },
    { (bb_RegPointer_type) 0x05D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0680,    0x8100 },
    { (bb_RegPointer_type) 0x0681,    0x0000 },
    { (bb_RegPointer_type) 0x0687,    0x0002 },
    { (bb_RegPointer_type) 0x06D0,    0x0000 },
    { (bb_RegPointer_type) 0x06D4,    0x0000 },
    { (bb_RegPointer_type) 0x06D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0780,    0x8100 },
    { (bb_RegPointer_type) 0x0781,    0x0000 },
    { (bb_RegPointer_type) 0x0787,    0x0002 },
    { (bb_RegPointer_type) 0x07D0,    0x0000 },
    { (bb_RegPointer_type) 0x07D4,    0x0000 },
    { (bb_RegPointer_type) 0x07D8,    0x0000 },
    /* IXF6048 MST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0490,    0x0500 },
    { (bb_RegPointer_type) 0x04B0,    0x0000 },
    { (bb_RegPointer_type) 0x04B1,    0x0003 },
    { (bb_RegPointer_type) 0x04B2,    0x002B },
    { (bb_RegPointer_type) 0x04B3,    0x0000 },
    { (bb_RegPointer_type) 0x04B4,    0x0003 },
    { (bb_RegPointer_type) 0x04B5,    0x0008 },
    { (bb_RegPointer_type) 0x04B8,    0x0003 },
    { (bb_RegPointer_type) 0x04B9,    0x002B },
    { (bb_RegPointer_type) 0x04BC,    0x0003 },
    { (bb_RegPointer_type) 0x04BD,    0x0008 },
    { (bb_RegPointer_type) 0x04D1,    0x7FFF },
    { (bb_RegPointer_type) 0x04D5,    0x0000 },
    { (bb_RegPointer_type) 0x04D9,    0x00F2 },
    /* IXF6048 MST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0590,    0x0500 },
    { (bb_RegPointer_type) 0x05B0,    0x0000 },
    { (bb_RegPointer_type) 0x05B1,    0x0003 },
    { (bb_RegPointer_type) 0x05B2,    0x002B },
    { (bb_RegPointer_type) 0x05B3,    0x0000 },
    { (bb_RegPointer_type) 0x05B4,    0x0003 },
    { (bb_RegPointer_type) 0x05B5,    0x0008 },
    { (bb_RegPointer_type) 0x05B8,    0x0003 },
    { (bb_RegPointer_type) 0x05B9,    0x002B },
    { (bb_RegPointer_type) 0x05BC,    0x0003 },
    { (bb_RegPointer_type) 0x05BD,    0x0008 },
    { (bb_RegPointer_type) 0x05D1,    0x0000 },
    { (bb_RegPointer_type) 0x05D5,    0x0000 },
    { (bb_RegPointer_type) 0x05D9,    0x0000 },
    /* IXF6048 MST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0690,    0x0500 },
    { (bb_RegPointer_type) 0x06B0,    0x0000 },
    { (bb_RegPointer_type) 0x06B1,    0x0003 },
    { (bb_RegPointer_type) 0x06B2,    0x002B },
    { (bb_RegPointer_type) 0x06B3,    0x0000 },
    { (bb_RegPointer_type) 0x06B4,    0x0003 },
    { (bb_RegPointer_type) 0x06B5,    0x0008 },
    { (bb_RegPointer_type) 0x06B8,    0x0003 },
    { (bb_RegPointer_type) 0x06B9,    0x002B },
    { (bb_RegPointer_type) 0x06BC,    0x0003 },
    { (bb_RegPointer_type) 0x06BD,    0x0008 },
    { (bb_RegPointer_type) 0x06D1,    0x0000 },
    { (bb_RegPointer_type) 0x06D5,    0x0000 },
    { (bb_RegPointer_type) 0x06D9,    0x0000 },
    /* IXF6048 MST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0790,    0x0500 },
    { (bb_RegPointer_type) 0x07B0,    0x0000 },
    { (bb_RegPointer_type) 0x07B1,    0x0003 },
    { (bb_RegPointer_type) 0x07B2,    0x002B },
    { (bb_RegPointer_type) 0x07B3,    0x0000 },
    { (bb_RegPointer_type) 0x07B4,    0x0003 },
    { (bb_RegPointer_type) 0x07B5,    0x0008 },
    { (bb_RegPointer_type) 0x07B8,    0x0003 },
    { (bb_RegPointer_type) 0x07B9,    0x002B },
    { (bb_RegPointer_type) 0x07BC,    0x0003 },
    { (bb_RegPointer_type) 0x07BD,    0x0008 },
    { (bb_RegPointer_type) 0x07D1,    0x0000 },
    { (bb_RegPointer_type) 0x07D5,    0x0000 },
    { (bb_RegPointer_type) 0x07D9,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04A0,    0x0000 },
    { (bb_RegPointer_type) 0x04D2,    0x0026 },
    { (bb_RegPointer_type) 0x04D6,    0x0000 },
    { (bb_RegPointer_type) 0x04DA,    0x0024 },
    /* IXF6048 RX MSA Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05A0,    0x0000 },
    { (bb_RegPointer_type) 0x05D2,    0x0000 },
    { (bb_RegPointer_type) 0x05D6,    0x0000 },
    { (bb_RegPointer_type) 0x05DA,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06A0,    0x0000 },
    { (bb_RegPointer_type) 0x06D2,    0x0000 },
    { (bb_RegPointer_type) 0x06D6,    0x0000 },
    { (bb_RegPointer_type) 0x06DA,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07A0,    0x0000 },
    { (bb_RegPointer_type) 0x07D2,    0x0000 },
    { (bb_RegPointer_type) 0x07D6,    0x0000 },
    { (bb_RegPointer_type) 0x07DA,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04A4,    0x60FC },
    { (bb_RegPointer_type) 0x04A5,    0x0200 },
    { (bb_RegPointer_type) 0x04D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05A4,    0x60FC },
    { (bb_RegPointer_type) 0x05A5,    0x0200 },
    { (bb_RegPointer_type) 0x05D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06A4,    0x60FC },
    { (bb_RegPointer_type) 0x06A5,    0x0200 },
    { (bb_RegPointer_type) 0x06D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07A4,    0x60FC },
    { (bb_RegPointer_type) 0x07A5,    0x0200 },
    { (bb_RegPointer_type) 0x07D7,    0x0000 },
    /* IXF6048 RMST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E0,    0x8040 },
    { (bb_RegPointer_type) 0x04E1,    0x0124 },
    { (bb_RegPointer_type) 0x04E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E0,    0x8040 },
    { (bb_RegPointer_type) 0x05E1,    0x0124 },
    { (bb_RegPointer_type) 0x05E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E0,    0x8040 },
    { (bb_RegPointer_type) 0x06E1,    0x0124 },
    { (bb_RegPointer_type) 0x06E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E0,    0x8040 },
    { (bb_RegPointer_type) 0x07E1,    0x0124 },
    { (bb_RegPointer_type) 0x07E2,    0x000A },
    /* IXF6048 TX MSA Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E9,    0x0000 },
    /* IXF6048 TX MSA Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E9,    0x0000 },
    /* IXF6048 TX MSA Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E9,    0x0000 },
    /* IXF6048 TX MSA Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E9,    0x0000 },
    /* IXF6048 TX HPM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E8,    0x0140 },
    { (bb_RegPointer_type) 0x04EF,    0x0410 },
    /* IXF6048 TX HPM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E8,    0x0140 },
    { (bb_RegPointer_type) 0x05EF,    0x0610 },
    /* IXF6048 TX HPM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E8,    0x0140 },
    { (bb_RegPointer_type) 0x06EF,    0x0610 },
    /* IXF6048 TX HPM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E8,    0x0140 },
    { (bb_RegPointer_type) 0x07EF,    0x0610 },
    /* IXF6048 RX ATM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0420,    0x0783 },
    { (bb_RegPointer_type) 0x0421,    0xFF01 },
    { (bb_RegPointer_type) 0x042C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0520,    0x0183 },
    { (bb_RegPointer_type) 0x0521,    0xFF01 },
    { (bb_RegPointer_type) 0x052C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0620,    0x0183 },
    { (bb_RegPointer_type) 0x0621,    0xFF01 },
    { (bb_RegPointer_type) 0x062C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0720,    0x0183 },
    { (bb_RegPointer_type) 0x0721,    0xFF01 },
    { (bb_RegPointer_type) 0x072C,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0410,    0x0023 },
    { (bb_RegPointer_type) 0x0411,    0x6A01 },
    { (bb_RegPointer_type) 0x0417,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0510,    0x0023 },
    { (bb_RegPointer_type) 0x0511,    0x6A01 },
    { (bb_RegPointer_type) 0x0517,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0610,    0x0023 },
    { (bb_RegPointer_type) 0x0611,    0x6A01 },
    { (bb_RegPointer_type) 0x0617,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0710,    0x0023 },
    { (bb_RegPointer_type) 0x0711,    0x6A01 },
    { (bb_RegPointer_type) 0x0717,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0460,    0x00ED },
    { (bb_RegPointer_type) 0x0461,    0x0002 },
    { (bb_RegPointer_type) 0x0462,    0x0600 },
    { (bb_RegPointer_type) 0x0470,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0560,    0x006F },
    { (bb_RegPointer_type) 0x0561,    0x0002 },
    { (bb_RegPointer_type) 0x0562,    0x0600 },
    { (bb_RegPointer_type) 0x0570,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0660,    0x006F },
    { (bb_RegPointer_type) 0x0661,    0x0002 },
    { (bb_RegPointer_type) 0x0662,    0x0600 },
    { (bb_RegPointer_type) 0x0670,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0760,    0x006F },
    { (bb_RegPointer_type) 0x0761,    0x0002 },
    { (bb_RegPointer_type) 0x0762,    0x0600 },
    { (bb_RegPointer_type) 0x0770,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0440,    0x004D },
    { (bb_RegPointer_type) 0x0441,    0x0401 },
    { (bb_RegPointer_type) 0x044A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0540,    0x004F },
    { (bb_RegPointer_type) 0x0541,    0x0401 },
    { (bb_RegPointer_type) 0x054A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0640,    0x004F },
    { (bb_RegPointer_type) 0x0641,    0x0401 },
    { (bb_RegPointer_type) 0x064A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0740,    0x004F },
    { (bb_RegPointer_type) 0x0741,    0x0401 },
    { (bb_RegPointer_type) 0x074A,    0x0000 },
    
    { (bb_RegPointer_type) 0xFFFF,    0xA5A5 }
};

static const InitRegTable_t defaultArray[] = 
{
    { (bb_RegPointer_type)(CHIP_ID)           , 0x0201}, 
        /*    { (bb_RegPointer_type)(GOCNF)             , 0x0020}, */
    { (bb_RegPointer_type)(COCNF(0))          , 0x0007}, 
    { (bb_RegPointer_type)(R_COCNF(0))        , 0x00F2},
    { (bb_RegPointer_type)(T_COCNF(0))        , 0x07F2}, 
    { (bb_RegPointer_type)(R_FPCNF)           , 0x0030},
    { (bb_RegPointer_type)(T_FPCNF)           , 0x3030}, 
    { (bb_RegPointer_type)(R_UICNF)           , 0x0024},
    { (bb_RegPointer_type)(R_UIIML)           , 0x0002}, 
    { (bb_RegPointer_type)(R_UICHCNF(0))      , 0x0119},
    { (bb_RegPointer_type)(R_PWM(0))          , 0x000F}, 
    { (bb_RegPointer_type)(T_UICNF)           , 0x0024},
    { (bb_RegPointer_type)(T_UIIML)           , 0x0002}, 
    { (bb_RegPointer_type)(T_UICHCNF(0))      , 0x0119},
    { (bb_RegPointer_type)(T_UIFDP(0))        , 0x00FF}, 
    { (bb_RegPointer_type)(T_NFPWM(0))        , 0x001F}, 
    { (bb_RegPointer_type)(T_NEWWM(0))        , 0x00FF}, 
    { (bb_RegPointer_type)(R_RSTC(0))         , 0x8100}, 
    { (bb_RegPointer_type)(J0_RSTC(0))        , 0x0002}, 
    { (bb_RegPointer_type)(R_MST_C(0))        , 0x0500}, 
    { (bb_RegPointer_type)(CWIN_SB2(0))       , 0x0003}, 
    { (bb_RegPointer_type)(E_EXCWIN(0))       , 0x002B}, 
    { (bb_RegPointer_type)(CWIN_CB2(0))       , 0x0003}, 
    { (bb_RegPointer_type)(E_NEXCWIN_CB2(0))  , 0x0008}, 
    { (bb_RegPointer_type)(CWIN_SDEGB2(0))    , 0x0003}, 
    { (bb_RegPointer_type)(E_DEGWIN(0))       , 0x002B}, 
    { (bb_RegPointer_type)(CWIN_CDEGB2(0))    , 0x0003}, 
    { (bb_RegPointer_type)(E_NDEGWIN_CB2(0))  , 0x0008}, 
    { (bb_RegPointer_type)(R_HPT_C1(0))       , 0x60FC}, 
    { (bb_RegPointer_type)(R_HPT_C2(0))       , 0x0200}, 
    { (bb_RegPointer_type)(EXP_C2(0))         , 0x0001}, 
    { (bb_RegPointer_type)(T_RMST_OP(0))      , 0x8040}, 
    { (bb_RegPointer_type)(T_SC_RSOH(0))      , 0x0124}, 
    { (bb_RegPointer_type)(T_SC_MSOH(0))      , 0x000A}, 
    { (bb_RegPointer_type)(T_HPT_C(0))        , 0x0140}, 
    { (bb_RegPointer_type)(T_HPT_OPC(0))      , 0x0610}, 
    { (bb_RegPointer_type)(MP_TC2(0))         , 0x0001}, 
    /*    { (bb_RegPointer_type)(R_ACPCNF(0))       , 0x0183},  */
    { (bb_RegPointer_type)(R_IUCFLTR(0))      , 0xFF01}, 
    { (bb_RegPointer_type)(R_LCDFLTR_LO(0))   , 0x2FC0}, 
    { (bb_RegPointer_type)(R_LCDFLTR_HI(0))   , 0x0001}, 
    { (bb_RegPointer_type)(T_ACPCNF(0))       , 0x0023}, 
    { (bb_RegPointer_type)(T_ICELLP(0))       , 0x6A01}, 
    { (bb_RegPointer_type)(R_PHCCNF(0))       , 0x006F}, 
    { (bb_RegPointer_type)(R_MINPL(0))        , 0x0002}, 
    { (bb_RegPointer_type)(R_MAXPL(0))        , 0x0600}, 
    { (bb_RegPointer_type)(T_PHCCNF(0))       , 0x004F}, 
    { (bb_RegPointer_type)(T_IPGCTRL(0))      , 0x0401},
    { (bb_RegPointer_type) 0xFFFF,    0xA5A5 }
};

static const InitRegTable_t BDExtLoopbackArray[] = { 
    
/* Note: Channel applies depending of the Chip Block as:
Channel could represent the DataLine
Channel could represent the group
Channel could represent the Tributary
    Channel could represent the Line */
    
    /* IXF6048 Global Cnfg Register Block */
    { (bb_RegPointer_type) 0x0001,    0x0000 },
    { (bb_RegPointer_type) 0x0003,    0x0000 },
    { (bb_RegPointer_type) 0x0004,    0x0000 },
    { (bb_RegPointer_type) 0x0008,    0x0028 },
    { (bb_RegPointer_type) 0x000C,    0x0000 },
    { (bb_RegPointer_type) 0x000D,    0x0000 },
    { (bb_RegPointer_type) 0x000E,    0x0000 },
    { (bb_RegPointer_type) 0x000F,    0xF001 },
    { (bb_RegPointer_type) 0x0010,    0x0000 },
    { (bb_RegPointer_type) 0x0011,    0x0000 },
    { (bb_RegPointer_type) 0x0014,    0x0010 },
    { (bb_RegPointer_type) 0x0015,    0x0000 },
    { (bb_RegPointer_type) 0x001E,    0x0000 },
    { (bb_RegPointer_type) 0x001B,    0x000F },
    { (bb_RegPointer_type) 0x001D,    0x0000 },
    { (bb_RegPointer_type) 0x0020,    0x0000 },
    /* IXF6048 Channel Confg Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0009,    0x0006 },
    { (bb_RegPointer_type) 0x000A,    0x0010 },
    { (bb_RegPointer_type) 0x000B,    0x0210 },
    /* IXF6048 Channel Confg Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0109,    0x0006 },
    { (bb_RegPointer_type) 0x010A,    0x00EA },
    { (bb_RegPointer_type) 0x010B,    0x050A },
    /* IXF6048 Channel Confg Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0209,    0x0006 },
    { (bb_RegPointer_type) 0x020A,    0x00EA },
    { (bb_RegPointer_type) 0x020B,    0x050A },
    /* IXF6048 Channel Confg Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0309,    0x0006 },
    { (bb_RegPointer_type) 0x030A,    0x00EA },
    { (bb_RegPointer_type) 0x030B,    0x050A },
    /* IXF6048 Glb Utopia Register Block */
    { (bb_RegPointer_type) 0x0070,    0x0164 },
    { (bb_RegPointer_type) 0x0071,    0x0002 },
    { (bb_RegPointer_type) 0x0050,    0x0024 },
    { (bb_RegPointer_type) 0x0051,    0x0002 },
    { (bb_RegPointer_type) 0x0073,    0x0000 },
    { (bb_RegPointer_type) 0x0053,    0x0000 },
    /* IXF6048 Channel Utopia Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0060,    0x0105 },
    { (bb_RegPointer_type) 0x0061,    0x000F },
    { (bb_RegPointer_type) 0x0040,    0x0110 },
    { (bb_RegPointer_type) 0x0041,    0x00FF },
    { (bb_RegPointer_type) 0x0042,    0x000F },
    { (bb_RegPointer_type) 0x0043,    0x000F },
    /* IXF6048 Channel Utopia Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0160,    0x0105 },
    { (bb_RegPointer_type) 0x0161,    0x000F },
    { (bb_RegPointer_type) 0x0140,    0x0105 },
    { (bb_RegPointer_type) 0x0141,    0x001F },
    { (bb_RegPointer_type) 0x0142,    0x000F },
    { (bb_RegPointer_type) 0x0143,    0x000F },
    /* IXF6048 Channel Utopia Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0260,    0x0105 },
    { (bb_RegPointer_type) 0x0261,    0x000F },
    { (bb_RegPointer_type) 0x0240,    0x0105 },
    { (bb_RegPointer_type) 0x0241,    0x001F },
    { (bb_RegPointer_type) 0x0242,    0x000F },
    { (bb_RegPointer_type) 0x0243,    0x000F },
    /* IXF6048 Channel Utopia Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0360,    0x0105 },
    { (bb_RegPointer_type) 0x0361,    0x000F },
    { (bb_RegPointer_type) 0x0340,    0x0105 },
    { (bb_RegPointer_type) 0x0341,    0x001F },
    { (bb_RegPointer_type) 0x0342,    0x000F },
    { (bb_RegPointer_type) 0x0343,    0x000F },
    /* IXF6048 RST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0480,    0x8000 },
    { (bb_RegPointer_type) 0x0481,    0x0000 },
    { (bb_RegPointer_type) 0x0487,    0x0002 },
    { (bb_RegPointer_type) 0x04D0,    0x0000 },
    { (bb_RegPointer_type) 0x04D4,    0x0000 },
    { (bb_RegPointer_type) 0x04D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0580,    0x8100 },
    { (bb_RegPointer_type) 0x0581,    0x0000 },
    { (bb_RegPointer_type) 0x0587,    0x0002 },
    { (bb_RegPointer_type) 0x05D0,    0x0008 },
    { (bb_RegPointer_type) 0x05D4,    0x0000 },
    { (bb_RegPointer_type) 0x05D8,    0x0008 },
    /* IXF6048 RST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0680,    0x8100 },
    { (bb_RegPointer_type) 0x0681,    0x0000 },
    { (bb_RegPointer_type) 0x0687,    0x0002 },
    { (bb_RegPointer_type) 0x06D0,    0x0008 },
    { (bb_RegPointer_type) 0x06D4,    0x0000 },
    { (bb_RegPointer_type) 0x06D8,    0x0008 },
    /* IXF6048 RST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0780,    0x8100 },
    { (bb_RegPointer_type) 0x0781,    0x0000 },
    { (bb_RegPointer_type) 0x0787,    0x0002 },
    { (bb_RegPointer_type) 0x07D0,    0x0008 },
    { (bb_RegPointer_type) 0x07D4,    0x0000 },
    { (bb_RegPointer_type) 0x07D8,    0x0008 },
    /* IXF6048 MST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0490,    0x0508 },
    { (bb_RegPointer_type) 0x04B0,    0x0003 },
    { (bb_RegPointer_type) 0x04B1,    0x0003 },
    { (bb_RegPointer_type) 0x04B2,    0x03F7 },
    { (bb_RegPointer_type) 0x04B3,    0x0004 },
    { (bb_RegPointer_type) 0x04B4,    0x000F },
    { (bb_RegPointer_type) 0x04B5,    0x0020 },
    { (bb_RegPointer_type) 0x04B8,    0x0000 },
    { (bb_RegPointer_type) 0x04B9,    0x0000 },
    { (bb_RegPointer_type) 0x04BC,    0x0000 },
    { (bb_RegPointer_type) 0x04BD,    0x0000 },
    { (bb_RegPointer_type) 0x04D1,    0x0FFF },
    { (bb_RegPointer_type) 0x04D5,    0x0000 },
    { (bb_RegPointer_type) 0x04D9,    0x0000 },
    /* IXF6048 MST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0590,    0x0500 },
    { (bb_RegPointer_type) 0x05B0,    0x0000 },
    { (bb_RegPointer_type) 0x05B1,    0x0003 },
    { (bb_RegPointer_type) 0x05B2,    0x002B },
    { (bb_RegPointer_type) 0x05B3,    0x0000 },
    { (bb_RegPointer_type) 0x05B4,    0x0003 },
    { (bb_RegPointer_type) 0x05B5,    0x0008 },
    { (bb_RegPointer_type) 0x05B8,    0x0003 },
    { (bb_RegPointer_type) 0x05B9,    0x002B },
    { (bb_RegPointer_type) 0x05BC,    0x0003 },
    { (bb_RegPointer_type) 0x05BD,    0x0008 },
    { (bb_RegPointer_type) 0x05D1,    0x0000 },
    { (bb_RegPointer_type) 0x05D5,    0x0000 },
    { (bb_RegPointer_type) 0x05D9,    0x0000 },
    /* IXF6048 MST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0690,    0x0500 },
    { (bb_RegPointer_type) 0x06B0,    0x0000 },
    { (bb_RegPointer_type) 0x06B1,    0x0003 },
    { (bb_RegPointer_type) 0x06B2,    0x002B },
    { (bb_RegPointer_type) 0x06B3,    0x0000 },
    { (bb_RegPointer_type) 0x06B4,    0x0003 },
    { (bb_RegPointer_type) 0x06B5,    0x0008 },
    { (bb_RegPointer_type) 0x06B8,    0x0003 },
    { (bb_RegPointer_type) 0x06B9,    0x002B },
    { (bb_RegPointer_type) 0x06BC,    0x0003 },
    { (bb_RegPointer_type) 0x06BD,    0x0008 },
    { (bb_RegPointer_type) 0x06D1,    0x0000 },
    { (bb_RegPointer_type) 0x06D5,    0x0000 },
    { (bb_RegPointer_type) 0x06D9,    0x0000 },
    /* IXF6048 MST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0790,    0x0500 },
    { (bb_RegPointer_type) 0x07B0,    0x0000 },
    { (bb_RegPointer_type) 0x07B1,    0x0003 },
    { (bb_RegPointer_type) 0x07B2,    0x002B },
    { (bb_RegPointer_type) 0x07B3,    0x0000 },
    { (bb_RegPointer_type) 0x07B4,    0x0003 },
    { (bb_RegPointer_type) 0x07B5,    0x0008 },
    { (bb_RegPointer_type) 0x07B8,    0x0003 },
    { (bb_RegPointer_type) 0x07B9,    0x002B },
    { (bb_RegPointer_type) 0x07BC,    0x0003 },
    { (bb_RegPointer_type) 0x07BD,    0x0008 },
    { (bb_RegPointer_type) 0x07D1,    0x0000 },
    { (bb_RegPointer_type) 0x07D5,    0x0000 },
    { (bb_RegPointer_type) 0x07D9,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04A0,    0x0000 },
    { (bb_RegPointer_type) 0x04D2,    0x0000 },
    { (bb_RegPointer_type) 0x04D6,    0x0000 },
    { (bb_RegPointer_type) 0x04DA,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05A0,    0x0000 },
    { (bb_RegPointer_type) 0x05D2,    0x0000 },
    { (bb_RegPointer_type) 0x05D6,    0x0000 },
    { (bb_RegPointer_type) 0x05DA,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06A0,    0x0000 },
    { (bb_RegPointer_type) 0x06D2,    0x0000 },
    { (bb_RegPointer_type) 0x06D6,    0x0000 },
    { (bb_RegPointer_type) 0x06DA,    0x0000 },
    /* IXF6048 RX MSA Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07A0,    0x0000 },
    { (bb_RegPointer_type) 0x07D2,    0x0000 },
    { (bb_RegPointer_type) 0x07D6,    0x0000 },
    { (bb_RegPointer_type) 0x07DA,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04A4,    0x4058 },
    { (bb_RegPointer_type) 0x04A5,    0x0200 },
    { (bb_RegPointer_type) 0x04D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05A4,    0x4058 },
    { (bb_RegPointer_type) 0x05A5,    0x0200 },
    { (bb_RegPointer_type) 0x05D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06A4,    0x607C },
    { (bb_RegPointer_type) 0x06A5,    0x0200 },
    { (bb_RegPointer_type) 0x06D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07A4,    0x607C },
    { (bb_RegPointer_type) 0x07A5,    0x0200 },
    { (bb_RegPointer_type) 0x07D7,    0x0000 },
    /* IXF6048 RMST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E0,    0x8080 },
    { (bb_RegPointer_type) 0x04E1,    0x0124 },
    { (bb_RegPointer_type) 0x04E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E0,    0x8040 },
    { (bb_RegPointer_type) 0x05E1,    0x0124 },
    { (bb_RegPointer_type) 0x05E2,    0x800A },
    /* IXF6048 RMST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E0,    0x8040 },
    { (bb_RegPointer_type) 0x06E1,    0x0124 },
    { (bb_RegPointer_type) 0x06E2,    0x800A },
    /* IXF6048 RMST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E0,    0x8040 },
    { (bb_RegPointer_type) 0x07E1,    0x0124 },
    { (bb_RegPointer_type) 0x07E2,    0x800A },
    /* IXF6048 TX MSA Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E9,    0x8400 },
    /* IXF6048 TX MSA Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E9,    0x8800 },
    /* IXF6048 TX MSA Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E9,    0x8800 },
    /* IXF6048 TX MSA Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E9,    0x8800 },
    /* IXF6048 TX HPM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E8,    0x0140 },
    { (bb_RegPointer_type) 0x04EF,    0x04C0 },
    /* IXF6048 TX HPM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E8,    0x0140 },
    { (bb_RegPointer_type) 0x05EF,    0x04C0 },
    /* IXF6048 TX HPM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E8,    0x0140 },
    { (bb_RegPointer_type) 0x06EF,    0x04C0 },
    /* IXF6048 TX HPM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E8,    0x0140 },
    { (bb_RegPointer_type) 0x07EF,    0x04C0 },
    /* IXF6048 RX ATM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0420,    0x0783 },
    { (bb_RegPointer_type) 0x0421,    0xFF01 },
    { (bb_RegPointer_type) 0x042C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0520,    0x0183 },
    { (bb_RegPointer_type) 0x0521,    0xFF01 },
    { (bb_RegPointer_type) 0x052C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0620,    0x0183 },
    { (bb_RegPointer_type) 0x0621,    0xFF01 },
    { (bb_RegPointer_type) 0x062C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0720,    0x0183 },
    { (bb_RegPointer_type) 0x0721,    0xFF01 },
    { (bb_RegPointer_type) 0x072C,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0410,    0x0023 },
    { (bb_RegPointer_type) 0x0411,    0x6A01 },
    { (bb_RegPointer_type) 0x0417,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0510,    0x0023 },
    { (bb_RegPointer_type) 0x0511,    0x6A01 },
    { (bb_RegPointer_type) 0x0517,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0610,    0x0023 },
    { (bb_RegPointer_type) 0x0611,    0x6A01 },
    { (bb_RegPointer_type) 0x0617,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0710,    0x0023 },
    { (bb_RegPointer_type) 0x0711,    0x6A01 },
    { (bb_RegPointer_type) 0x0717,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0460,    0x006F },
    { (bb_RegPointer_type) 0x0461,    0x0002 },
    { (bb_RegPointer_type) 0x0462,    0x0600 },
    { (bb_RegPointer_type) 0x0470,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0560,    0x006F },
    { (bb_RegPointer_type) 0x0561,    0x0002 },
    { (bb_RegPointer_type) 0x0562,    0x0600 },
    { (bb_RegPointer_type) 0x0570,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0660,    0x006F },
    { (bb_RegPointer_type) 0x0661,    0x0002 },
    { (bb_RegPointer_type) 0x0662,    0x0600 },
    { (bb_RegPointer_type) 0x0670,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0760,    0x006F },
    { (bb_RegPointer_type) 0x0761,    0x0002 },
    { (bb_RegPointer_type) 0x0762,    0x0600 },
    { (bb_RegPointer_type) 0x0770,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0440,    0x004F },
    { (bb_RegPointer_type) 0x0441,    0x0401 },
    { (bb_RegPointer_type) 0x044A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0540,    0x004F },
    { (bb_RegPointer_type) 0x0541,    0x0401 },
    { (bb_RegPointer_type) 0x054A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0640,    0x004F },
    { (bb_RegPointer_type) 0x0641,    0x0401 },
    { (bb_RegPointer_type) 0x064A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0740,    0x004F },
    { (bb_RegPointer_type) 0x0741,    0x0401 },
    { (bb_RegPointer_type) 0x074A,    0x0000 },
    
    { (bb_RegPointer_type) 0xFFFF,    0xA5A5 }
};


static const InitRegTable_t BWExtLoopbackArray[] = {
/* Note: Channel applies depending of the Chip Block as:
Channel could represent the DataLine
Channel could represent the group
Channel could represent the Tributary
    Channel could represent the Line */
    /* Note: Channel applies depending of the Chip Block as:
    Channel could represent the DataLine
    Channel could represent the group
    Channel could represent the Tributary
    Channel could represent the Line */
    
    /* IXF6048 Global Cnfg Register Block */
    { (bb_RegPointer_type) 0x0001,    0x0000 },
    { (bb_RegPointer_type) 0x0003,    0x0000 },
    { (bb_RegPointer_type) 0x0004,    0x0000 },
    { (bb_RegPointer_type) 0x0008,    0x0078 },
    { (bb_RegPointer_type) 0x000C,    0x0000 },
    { (bb_RegPointer_type) 0x000D,    0x0030 },
    { (bb_RegPointer_type) 0x000E,    0x3030 },
    { (bb_RegPointer_type) 0x000F,    0xF001 },
    { (bb_RegPointer_type) 0x0010,    0x0000 },
    { (bb_RegPointer_type) 0x0011,    0x0000 },
    { (bb_RegPointer_type) 0x0014,    0x0000 },
    { (bb_RegPointer_type) 0x0015,    0x0000 },
    { (bb_RegPointer_type) 0x001E,    0x0000 },
    { (bb_RegPointer_type) 0x001B,    0x0001 },
    { (bb_RegPointer_type) 0x001D,    0x0000 },
    { (bb_RegPointer_type) 0x0020,    0x0000 },
    /* IXF6048 Channel Confg Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0009,    0x0006 },
    { (bb_RegPointer_type) 0x000A,    0x0008 },
    { (bb_RegPointer_type) 0x000B,    0x0608 },
    /* IXF6048 Channel Confg Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0109,    0x0006 },
    { (bb_RegPointer_type) 0x010A,    0x0008 },
    { (bb_RegPointer_type) 0x010B,    0x0608 },
    /* IXF6048 Channel Confg Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0209,    0x0006 },
    { (bb_RegPointer_type) 0x020A,    0x0008 },
    { (bb_RegPointer_type) 0x020B,    0x0608 },
    /* IXF6048 Channel Confg Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0309,    0x0006 },
    { (bb_RegPointer_type) 0x030A,    0x0008 },
    { (bb_RegPointer_type) 0x030B,    0x0608 },
    /* IXF6048 Glb Utopia Register Block */
    { (bb_RegPointer_type) 0x0070,    0x00A9 },
    { (bb_RegPointer_type) 0x0071,    0x0002 },
    { (bb_RegPointer_type) 0x0050,    0x0028 },
    { (bb_RegPointer_type) 0x0051,    0x0002 },
    { (bb_RegPointer_type) 0x0073,    0x0000 },
    { (bb_RegPointer_type) 0x0053,    0x0000 },
    /* IXF6048 Channel Utopia Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0060,    0x0319 },
    { (bb_RegPointer_type) 0x0061,    0x000F },
    { (bb_RegPointer_type) 0x0040,    0x0319 },
    { (bb_RegPointer_type) 0x0041,    0x00FF },
    { (bb_RegPointer_type) 0x0042,    0x001F },
    { (bb_RegPointer_type) 0x0043,    0x00FF },
    /* IXF6048 Channel Utopia Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0160,    0x0319 },
    { (bb_RegPointer_type) 0x0161,    0x000F },
    { (bb_RegPointer_type) 0x0140,    0x0319 },
    { (bb_RegPointer_type) 0x0141,    0x00FF },
    { (bb_RegPointer_type) 0x0142,    0x001F },
    { (bb_RegPointer_type) 0x0143,    0x00FF },
    /* IXF6048 Channel Utopia Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0260,    0x0319 },
    { (bb_RegPointer_type) 0x0261,    0x000F },
    { (bb_RegPointer_type) 0x0240,    0x0319 },
    { (bb_RegPointer_type) 0x0241,    0x00FF },
    { (bb_RegPointer_type) 0x0242,    0x001F },
    { (bb_RegPointer_type) 0x0243,    0x00FF },
    /* IXF6048 Channel Utopia Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0360,    0x0319 },
    { (bb_RegPointer_type) 0x0361,    0x000F },
    { (bb_RegPointer_type) 0x0340,    0x0319 },
    { (bb_RegPointer_type) 0x0341,    0x00FF },
    { (bb_RegPointer_type) 0x0342,    0x001F },
    { (bb_RegPointer_type) 0x0343,    0x00FF },
    /* IXF6048 RST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0480,    0x8000 },
    { (bb_RegPointer_type) 0x0481,    0x0000 },
    { (bb_RegPointer_type) 0x0487,    0x0002 },
    { (bb_RegPointer_type) 0x04D0,    0x030F },
    { (bb_RegPointer_type) 0x04D4,    0x0000 },
    { (bb_RegPointer_type) 0x04D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0580,    0x8000 },
    { (bb_RegPointer_type) 0x0581,    0x0000 },
    { (bb_RegPointer_type) 0x0587,    0x0002 },
    { (bb_RegPointer_type) 0x05D0,    0x030F },
    { (bb_RegPointer_type) 0x05D4,    0x0000 },
    { (bb_RegPointer_type) 0x05D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0680,    0x8000 },
    { (bb_RegPointer_type) 0x0681,    0x0000 },
    { (bb_RegPointer_type) 0x0687,    0x0002 },
    { (bb_RegPointer_type) 0x06D0,    0x030F },
    { (bb_RegPointer_type) 0x06D4,    0x0000 },
    { (bb_RegPointer_type) 0x06D8,    0x0000 },
    /* IXF6048 RST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0780,    0x8000 },
    { (bb_RegPointer_type) 0x0781,    0x0000 },
    { (bb_RegPointer_type) 0x0787,    0x0002 },
    { (bb_RegPointer_type) 0x07D0,    0x030F },
    { (bb_RegPointer_type) 0x07D4,    0x0000 },
    { (bb_RegPointer_type) 0x07D8,    0x0000 },
    /* IXF6048 MST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0490,    0x0500 },
    { (bb_RegPointer_type) 0x04B0,    0x0000 },
    { (bb_RegPointer_type) 0x04B1,    0x0003 },
    { (bb_RegPointer_type) 0x04B2,    0x002B },
    { (bb_RegPointer_type) 0x04B3,    0x0000 },
    { (bb_RegPointer_type) 0x04B4,    0x0003 },
    { (bb_RegPointer_type) 0x04B5,    0x0008 },
    { (bb_RegPointer_type) 0x04B8,    0x0003 },
    { (bb_RegPointer_type) 0x04B9,    0x002B },
    { (bb_RegPointer_type) 0x04BC,    0x0003 },
    { (bb_RegPointer_type) 0x04BD,    0x0008 },
    { (bb_RegPointer_type) 0x04D1,    0x7FFF },
    { (bb_RegPointer_type) 0x04D5,    0x0000 },
    { (bb_RegPointer_type) 0x04D9,    0x00F2 },
    /* IXF6048 MST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0590,    0x0500 },
    { (bb_RegPointer_type) 0x05B0,    0x0000 },
    { (bb_RegPointer_type) 0x05B1,    0x0003 },
    { (bb_RegPointer_type) 0x05B2,    0x002B },
    { (bb_RegPointer_type) 0x05B3,    0x0000 },
    { (bb_RegPointer_type) 0x05B4,    0x0003 },
    { (bb_RegPointer_type) 0x05B5,    0x0008 },
    { (bb_RegPointer_type) 0x05B8,    0x0003 },
    { (bb_RegPointer_type) 0x05B9,    0x002B },
    { (bb_RegPointer_type) 0x05BC,    0x0003 },
    { (bb_RegPointer_type) 0x05BD,    0x0008 },
    { (bb_RegPointer_type) 0x05D1,    0x7FFF },
    { (bb_RegPointer_type) 0x05D5,    0x0000 },
    { (bb_RegPointer_type) 0x05D9,    0x00F2 },
    /* IXF6048 MST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0690,    0x0500 },
    { (bb_RegPointer_type) 0x06B0,    0x0000 },
    { (bb_RegPointer_type) 0x06B1,    0x0003 },
    { (bb_RegPointer_type) 0x06B2,    0x002B },
    { (bb_RegPointer_type) 0x06B3,    0x0000 },
    { (bb_RegPointer_type) 0x06B4,    0x0003 },
    { (bb_RegPointer_type) 0x06B5,    0x0008 },
    { (bb_RegPointer_type) 0x06B8,    0x0003 },
    { (bb_RegPointer_type) 0x06B9,    0x002B },
    { (bb_RegPointer_type) 0x06BC,    0x0003 },
    { (bb_RegPointer_type) 0x06BD,    0x0008 },
    { (bb_RegPointer_type) 0x06D1,    0x7FFF },
    { (bb_RegPointer_type) 0x06D5,    0x0000 },
    { (bb_RegPointer_type) 0x06D9,    0x00F2 },
    /* IXF6048 MST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0790,    0x0500 },
    { (bb_RegPointer_type) 0x07B0,    0x0000 },
    { (bb_RegPointer_type) 0x07B1,    0x0003 },
    { (bb_RegPointer_type) 0x07B2,    0x002B },
    { (bb_RegPointer_type) 0x07B3,    0x0000 },
    { (bb_RegPointer_type) 0x07B4,    0x0003 },
    { (bb_RegPointer_type) 0x07B5,    0x0008 },
    { (bb_RegPointer_type) 0x07B8,    0x0003 },
    { (bb_RegPointer_type) 0x07B9,    0x002B },
    { (bb_RegPointer_type) 0x07BC,    0x0003 },
    { (bb_RegPointer_type) 0x07BD,    0x0008 },
    { (bb_RegPointer_type) 0x07D1,    0x7FFF },
    { (bb_RegPointer_type) 0x07D5,    0x0000 },
    { (bb_RegPointer_type) 0x07D9,    0x00F2 },
    /* IXF6048 RX MSA Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04A0,    0x0000 },
    { (bb_RegPointer_type) 0x04D2,    0x0026 },
    { (bb_RegPointer_type) 0x04D6,    0x0000 },
    { (bb_RegPointer_type) 0x04DA,    0x0024 },
    /* IXF6048 RX MSA Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05A0,    0x0000 },
    { (bb_RegPointer_type) 0x05D2,    0x0026 },
    { (bb_RegPointer_type) 0x05D6,    0x0000 },
    { (bb_RegPointer_type) 0x05DA,    0x0024 },
    /* IXF6048 RX MSA Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06A0,    0x0000 },
    { (bb_RegPointer_type) 0x06D2,    0x0026 },
    { (bb_RegPointer_type) 0x06D6,    0x0000 },
    { (bb_RegPointer_type) 0x06DA,    0x0024 },
    /* IXF6048 RX MSA Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07A0,    0x0000 },
    { (bb_RegPointer_type) 0x07D2,    0x0026 },
    { (bb_RegPointer_type) 0x07D6,    0x0000 },
    { (bb_RegPointer_type) 0x07DA,    0x0024 },
    /* IXF6048 RX HPM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04A4,    0x609C },
    { (bb_RegPointer_type) 0x04A5,    0x0200 },
    { (bb_RegPointer_type) 0x04D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05A4,    0x609C },
    { (bb_RegPointer_type) 0x05A5,    0x0200 },
    { (bb_RegPointer_type) 0x05D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06A4,    0x609C },
    { (bb_RegPointer_type) 0x06A5,    0x0200 },
    { (bb_RegPointer_type) 0x06D7,    0x0000 },
    /* IXF6048 RX HPM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07A4,    0x609C },
    { (bb_RegPointer_type) 0x07A5,    0x0200 },
    { (bb_RegPointer_type) 0x07D7,    0x0000 },
    /* IXF6048 RMST Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E0,    0x8040 },
    { (bb_RegPointer_type) 0x04E1,    0x0124 },
    { (bb_RegPointer_type) 0x04E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E0,    0x8040 },
    { (bb_RegPointer_type) 0x05E1,    0x0124 },
    { (bb_RegPointer_type) 0x05E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E0,    0x8040 },
    { (bb_RegPointer_type) 0x06E1,    0x0124 },
    { (bb_RegPointer_type) 0x06E2,    0x000A },
    /* IXF6048 RMST Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E0,    0x8040 },
    { (bb_RegPointer_type) 0x07E1,    0x0124 },
    { (bb_RegPointer_type) 0x07E2,    0x000A },
    /* IXF6048 TX MSA Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E9,    0x0000 },
    /* IXF6048 TX MSA Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E9,    0x0000 },
    /* IXF6048 TX MSA Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E9,    0x0000 },
    /* IXF6048 TX MSA Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E9,    0x0000 },
    /* IXF6048 TX HPM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x04E8,    0x0140 },
    { (bb_RegPointer_type) 0x04EF,    0x0410 },
    /* IXF6048 TX HPM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x05E8,    0x0140 },
    { (bb_RegPointer_type) 0x05EF,    0x0410 },
    /* IXF6048 TX HPM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x06E8,    0x0140 },
    { (bb_RegPointer_type) 0x06EF,    0x0410 },
    /* IXF6048 TX HPM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x07E8,    0x0140 },
    { (bb_RegPointer_type) 0x07EF,    0x0410 },
    /* IXF6048 RX ATM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0420,    0x0783 },
    { (bb_RegPointer_type) 0x0421,    0xFF01 },
    { (bb_RegPointer_type) 0x042C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0520,    0x0183 },
    { (bb_RegPointer_type) 0x0521,    0xFF01 },
    { (bb_RegPointer_type) 0x052C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0620,    0x0183 },
    { (bb_RegPointer_type) 0x0621,    0xFF01 },
    { (bb_RegPointer_type) 0x062C,    0x0000 },
    /* IXF6048 RX ATM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0720,    0x0183 },
    { (bb_RegPointer_type) 0x0721,    0xFF01 },
    { (bb_RegPointer_type) 0x072C,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0410,    0x0023 },
    { (bb_RegPointer_type) 0x0411,    0x6A01 },
    { (bb_RegPointer_type) 0x0417,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0510,    0x0023 },
    { (bb_RegPointer_type) 0x0511,    0x6A01 },
    { (bb_RegPointer_type) 0x0517,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0610,    0x0023 },
    { (bb_RegPointer_type) 0x0611,    0x6A01 },
    { (bb_RegPointer_type) 0x0617,    0x0000 },
    /* IXF6048 TX ATM Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0710,    0x0023 },
    { (bb_RegPointer_type) 0x0711,    0x6A01 },
    { (bb_RegPointer_type) 0x0717,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0460,    0x00ED },
    { (bb_RegPointer_type) 0x0461,    0x0002 },
    { (bb_RegPointer_type) 0x0462,    0x0600 },
    { (bb_RegPointer_type) 0x0470,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0560,    0x00ED },
    { (bb_RegPointer_type) 0x0561,    0x0002 },
    { (bb_RegPointer_type) 0x0562,    0x0600 },
    { (bb_RegPointer_type) 0x0570,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0660,    0x00ED },
    { (bb_RegPointer_type) 0x0661,    0x0002 },
    { (bb_RegPointer_type) 0x0662,    0x0600 },
    { (bb_RegPointer_type) 0x0670,    0x0000 },
    /* IXF6048 RX POS Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0760,    0x00ED },
    { (bb_RegPointer_type) 0x0761,    0x0002 },
    { (bb_RegPointer_type) 0x0762,    0x0600 },
    { (bb_RegPointer_type) 0x0770,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 0 */
    { (bb_RegPointer_type) 0x0440,    0x004D },
    { (bb_RegPointer_type) 0x0441,    0x0401 },
    { (bb_RegPointer_type) 0x044A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 1 */
    { (bb_RegPointer_type) 0x0540,    0x004D },
    { (bb_RegPointer_type) 0x0541,    0x0401 },
    { (bb_RegPointer_type) 0x054A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 2 */
    { (bb_RegPointer_type) 0x0640,    0x004D },
    { (bb_RegPointer_type) 0x0641,    0x0401 },
    { (bb_RegPointer_type) 0x064A,    0x0000 },
    /* IXF6048 TX POS Register Block Channel = 3 */
    { (bb_RegPointer_type) 0x0740,    0x004D },
    { (bb_RegPointer_type) 0x0741,    0x0401 },
    { (bb_RegPointer_type) 0x074A,    0x0000 },
    
    { (bb_RegPointer_type) 0xFFFF,    0xA5A5 }
};

/****************************************************************************************/


#ifdef INTERRUPT_SYSTEM_MODE
void
InitTestInterrupts(void)
{
    /* Initialize Interrupt handler Array*/
    IxfInitISRArray();
    
    /* Creat a binary semaphore */
    if ((ISRSemaphore = semBCreate(SEM_Q_FIFO, SEM_EMPTY)) == NULL)
        perror ("Cannot create the binary semaphore\n");
    
    /* Initialize  system's interrupt */
    if ( IXF_Init_System_Interrupt() == ERROR)
        printf("  Error initializing ISR\n");
    
    /* Interrupt Handler Creation for  using in the ISR */
    if (taskSpawn("tIXF_InterruptHandler", 80, 0, 1000, (FUNCPTR) IXF_InterruptHandler,
        0,0, 0, 0, 0, 0, 0, 0, 0, 0) == ERROR)
        perror ("IXF_InterruptHandler task spawning error\n");
}

/******************************************************************
* Function : TurnPRBSOn
*-----------------------------------------------------------------
* Description  : This routine places the device in PRBS mode and 
*                enable PRBS interrupts.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid pointer to the device.
*           chanNum : Specifies the channel number.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : None.
*-----------------------------------------------------------------
* Access Globals : None.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
void
TurnPRBSOn(bb_ChipData_t *pChipData, int chanNum)
{
    bb_ChipSegment_t section;
    ushort regVal;
    
    /* Assign the channel number */
    section.group.channel = chanNum;
    
    section.block.flow = BOTH_FLOWS;
    
    /* Start PRBS Test */
    IxfApiSetOpMode(pChipData, &section, TEST_MODE, NULL);
    
    /* Clear PRBS Interrupts */
    IxfApiGenericRead(pChipData, TWO_BYTES, PRBSINT, 1, &regVal);
    
    /* Enable PRBS Interrupts */
    IxfApiGenericRead(pChipData, TWO_BYTES, PRBSINTEN, 1, &regVal);
    regVal |= (1 << chanNum);
    IxfApiGenericWrite(pChipData, TWO_BYTES, PRBSINTEN, 1, &regVal);
}

/******************************************************************
* Function : TurnPRBSOff
*-----------------------------------------------------------------
* Description  : This routine disables PRBS interrupts.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid pointer to the device.
*           chanNum : Specifies the channel number.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : None.
*-----------------------------------------------------------------
* Access Globals : None.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
void
TurnPRBSOff(bb_ChipData_t *pChipData, int chanNum)
{
    ushort regVal;
    
    /* Disable PRBS Interrupts */
    IxfApiGenericRead(pChipData, TWO_BYTES, PRBSINTEN, 1, &regVal);
    regVal &= ~(1 << chanNum);
    IxfApiGenericWrite(pChipData, TWO_BYTES, PRBSINTEN, 1, &regVal);
}

/***********************************************************************
* Private Callback function
* 		-- AlarmCallback 
*
*         This Function is Called from the ixf6048 Interrupt Handler
*         block to report All Active interrupts. The void pointer pAlarmStatus
*		   can be a pointer to any of the Alarm Structure Types, and is 
*		   Automatically Type-Cast based upon the AlarmType Param. 
**********************************************************************/
void Ixf6048ClearAlarmCallback (ushort *BaseAddress,
                                AlarmCallbackType_e   AlarmType,     /* Type of Alarm */
                                void* pAlarmStatus)  /* -> Alarm status struct */
{
    
    switch(AlarmType)
    {  /* pAlarmStatus -> ixf6048_GlobalAlarmCfg_t */
    case bb_6048_MISC_ALARM:
        printf("Received Transient  MISC ALARM\n");
        break;
    case bb_6048_OHT_ALARM:
        printf("Received Transient  a UTOPIA ALARM\n");
        break;
    case bb_6048_UTOPIA_ALARM:
        printf("Received Transient  a UTOPIA ALARM\n");
        break;
    case bb_6048_POS_ALARM:
        printf("Received Transient  a POS ALARM\n");
        break;
    case bb_6048_ATM_ALARM:
        printf("Received Transient  a ATM ALARM\n");
        break;
    default:
        printf("Received Transient  alarm number %d\n", AlarmType);
        break;
    }
}

/***********************************************************************
* Private Callback function
* 		-- AlarmCallback 
*
*         This Function is Called from the ixf6048 Interrupt Handler
*         block to report All Active interrupts. The void pointer pAlarmStatus
*		   can be a pointer to any of the Alarm Structure Types, and is 
*		   Automatically Type-Cast based upon the AlarmType Param. 
**********************************************************************/
void Ixf6048TestAlarmCallback (ushort *BaseAddress,
                               AlarmCallbackType_e   AlarmType,     /* Type of Alarm */
                               void* pAlarmStatus)  /* -> Alarm status struct */
{
    ixf6048_MiscAlarmStatus_t *MiscAlarms;
    
    MiscAlarms = (ixf6048_MiscAlarmStatus_t *) pAlarmStatus;
    
    /* Call the Alarm Handler Function */
    switch(AlarmType)
    {  /* pAlarmStatus -> ixf6048_GlobalAlarmCfg_t */
    case bb_6048_MISC_ALARM:
        isrFlag = 0;
        if (MiscAlarms->PRBSAlarms)
            printf("Received PRBS ALARM on channel %d\n", MiscAlarms->Channel);
        break;
    case bb_6048_OHT_ALARM:
        printf("Received a UTOPIA ALARM\n");
        break;
    case bb_6048_UTOPIA_ALARM:
        printf("Received a UTOPIA ALARM\n");
        break;
    case bb_6048_POS_ALARM:
        printf("Received a POS ALARM\n");
        break;
    case bb_6048_ATM_ALARM:
        printf("Received a ATM ALARM\n");
        break;
    default:
        printf("Received alarm number %d\n", AlarmType);
        break;
    }
}

#endif

void TestIxfApiMain (void)
{
    
    ulong  sz=0;
    ulong  set_sz=0;
    bb_ChipData_t chipData;
    char string64[] = "Expected J0 String that is longer than 64 bytes in length and should be truncated ";
    bb_RegPointer_type pReg;
    bb_ChipInfo_t         ChipInfo;
    uchar                      J0String[64];
    ushort usTest1;
    ushort usTest2;
    bb_ChipSegment_t section;
    ushort len;
    int i;
    bb_Error_e ixfStatus;
    char dataBuf[DATABUF_SIZE];
    char myArray[512];
#ifdef INTERRUPT_SYSTEM_MODE
    ushort regVal;
#endif
    
    /* Setup a generic section parameter */
    section.block.block = 0;
    section.block.side = 0;
    section.block.flow = 0;
    section.group.channel = 0;
    section.indirect.slot = 0;
    section.value = 0;
    
    
    /***************/
    /* Test Case 1 */
    /***************/
    
    /* Test IxfApiInit */
    ixfStatus = IxfApiInit((bb_RegPointer_type) IXF6048_BASE_ADDRESS, bb_6048_CHIP, &chipData);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIINIT TEST                     : PASSED\n");
    }
    else
    {
        printf("IXFAPIINIT TEST                     : FAILED\n");
    }
    
    
    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiAllocDataStructureMem(&chipData);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIALLOCDATASTRUCTMEM TEST       : PASSED\n");
    }
    else
    {
        printf("IXFAPIALLOCDATASTRUCTMEM TEST       : FAILED\n");
    }
    
    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiDeAllocMemory(&chipData);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIDEALLOCMEMORY TEST            : PASSED\n");
    }
    else
    {
        printf("IXFAPIDEALLOCMEMORY TEST            : FAILED\n");
    }
    
    /* Test IxfApiInitChip */
    ixfStatus = IxfApiInitChip(&chipData, RegInitIXF6048Table);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIINITCHIP TEST                 : PASSED\n");
    }
    else
    {
        printf("IXFAPIINITCHIP TEST                 : FAILED\n");
    }
    
    /***************/
    /* Test Case 2 */
    /***************/
    
    /* Get h/w info for chip  */
    ixfStatus = IxfApiGetChipInfo(&chipData, &ChipInfo);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        if (((ChipInfo.ChipId & 0xF) == 1) && (ChipInfo.ChipVersion == 2))
            printf("IXFAPIGETCHIPINFO TEST              : PASSED\n");
        else
            printf("IXFAPIGETCHIPINFO TEST              : FAILED\n");
    }
    else
    {
        printf("IXFAPIGETCHIPINFO TEST              : FAILED\n");
    }
    
    
    
    /* Get Build Version */
    ixfStatus = IxfApiGetBuildVersion(&chipData, bb_SW_VERSION_API_TYPE, dataBuf, myArray, &usTest1, &usTest2);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        if (!(strcmp(dataBuf,IXF6048_BUILD_DRIVER_NAME)))
        {
            printf("IXFAPIGETBUILDVERSION TEST          : PASSED\n");
        }
    }
    else
    {
        printf("IXFAPIGETBUILDVERSION TEST          : FAILED\n");
    }
    
    /***************/
    /* Test Case 3 */
    /***************/
    /* Set WindowSize */
    set_sz = 0x12345678;
    ixfStatus = IxfApiSetWindowSize(&chipData, &section, CLEARING, set_sz);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPISETWINDOWSIZE TEST            : PASSED\n");
    }
    else
    {
        printf("IXFAPISETWINDOWSIZE TEST            : FAILED\n");
    }
    
    /* Get WindowSize */
    ixfStatus = IxfApiGetWindowSize(&chipData, &section, CLEARING, &sz);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        if (sz == 0xACE)
        {
            printf("IXFAPIGETWINDOWSIZE TEST            : PASSED\n");
        }
        else
        {
            printf("IXFAPIGETWINDOWSIZE TEST            : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPIGETWINDOWSIZE TEST            : FAILED\n");
    }
    
    /***************/
    /* Test Case 4 */
    /***************/
    /* Test Generic Write */
    dataBuf[0] = 0xA;
    dataBuf[1] = 0xB;
    ixfStatus = IxfApiGenericWrite(&chipData, 2, 0x8, 1, dataBuf);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test Generic Read */
        bzero(dataBuf,DATABUF_SIZE);
        
        ixfStatus = IxfApiGenericRead(&chipData, 2, 0x8, 1, dataBuf);
        if ((dataBuf[0] == 0xA) && (dataBuf[1] == 0xB))
        {
            printf("IXFAPIGENERICREAD  TEST             : PASSED\n");
            printf("IXFAPIGENERICWRITE TEST             : PASSED\n");
        }
        else
        {
            printf("IXFAPIGENERICREAD TEST              : FAILED\n");
            printf("IXFAPIGENERICWRITE TEST             : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPIGENERICWRITE TEST              : FAILED\n");
    }
    
    /***************/
    /* Test Case 5 */
    /***************/
    /* Set Overhead Bytes*/
    section.group.channel = 0;
    ixfStatus = IxfApiSetOhByte(&chipData, &section, bb_EXPECTED_C2, 0x13);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        /* Get Overhead Bytes*/
        section.group.channel = 0;
        ixfStatus = IxfApiGetOhBytes(&chipData, &section, bb_EXPECTED_C2, myArray);
        if (*((uchar *) myArray) == 0x13)
        {
            printf("IXFAPIGETOHBYTE TEST                : PASSED\n");
            printf("IXFAPISETOHBYTE TEST                : PASSED\n");
        }
        else
        {
            printf("IXFAPIGETOHBYTE TEST                : FAILED\n");
            printf("IXFAPISETOHBYTE TEST                : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPIGETOHBYTE TEST                : FAILED\n");
    }
    
    /***************/
    /* Test Case 6 */
    /***************/
    /* Test SetTrace */
    /* Set J0 trace for chan 0 */
#ifdef DREW
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) BDExtLoopbackArray);
#elif WALLACE    
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) BWExtLoopbackArray);
#else
    perror("YOU DID NOT SPECIFY DREW OR WALLACE\n");
#endif
    
    section.group.channel = 0;
    ixfStatus = IxfApiSetTrace(&chipData, &section, bb_EXPECTED_J0, bb_64_BYTE_WITH_LF_CR, string64);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test GetTrace */
        section.group.channel = 0;
        ixfStatus = IxfApiGetTrace(&chipData, &section, bb_EXPECTED_J0,  (char*) J0String, &len);
        
        if (!(strncmp(string64, J0String, 10)))
        {
            printf("IXFAPISETTRACE TEST                 : PASSED\n");
            printf("IXFAPIGETTRACE TEST                 : PASSED\n");
        }
        else
        {
            printf("IXFAPISETTRACE TEST                 : FAILED\n");
            printf("IXFAPIGETTRACE TEST                 : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPISETTRACE TEST                 : FAILED\n");
    }
    
    /***************/
    /* Test Case 7 */
    /***************/
    /* Get OHT Counters */
    ixfStatus = IxfApiGetCounters(&chipData, &section, bb_OOF_CNT, myArray);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIGETCOUNTERS TEST              : PASSED\n");
    }
    else
    {
        printf("IXFAPIGETCOUNTERS TEST              : FAILED\n");
    }
    
    
    
    /***************/
    /* Test Case 8 */
    /***************/
    i = 0;
    
    /* Write different values to the chip*/
    ixfStatus = IxfApiInitChip(&chipData, (InitRegTable_t *) RegInitIXF6048Table);
    
    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */
    
    /* Now Read and check the default values */
    while ((defaultArray[i].offset != (bb_RegPointer_type)0xFFFF) &&
        (defaultArray[i].value != IXF_INIT_DATA_DELIMITER))
    {
        /* Form the address */
        pReg = (chipData.BaseAddress + (int) defaultArray[i].offset);
        
        if (READ_FROM_HW(pReg) != defaultArray[i].value)
        {
            printf("BA = %08x", (unsigned int) chipData.BaseAddress);
            printf("MISMATCH on addr = %08x", (unsigned int) pReg);
            printf(" EXPECTED=0x%04x", defaultArray[i].value);
            printf(" ACTUAL=0x%04x\n", READ_FROM_HW(pReg));
            
            break;
        }
        
        i++;
    }
    
    /* Successful if we reached the delimiter */
    if ((defaultArray[i].offset == (bb_RegPointer_type)0xFFFF) &&
        (defaultArray[i].value == IXF_INIT_DATA_DELIMITER))
    {
        printf("IXFAPIRESET TEST                    : PASSED\n");
    }
    else
    {
        printf("IXFAPIRESET TEST                    : FAILED\n");
    }
    
    /***************/
    /* Test Case 9 */
    /***************/
    
    /* ChipIsr Test */
    /* If we are executing this test, then system software enabling
    interrupts must be running */
    
#ifdef INTERRUPT_SYSTEM_MODE
    
    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */
    
    if (HaveWeRunBefore)
    {
        InitTestInterrupts();
        HaveWeRunBefore = 0;
    }
    
    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) Ixf6048ClearAlarmCallback);
    IxfRegisterInterrupt(INT_DEVICE_1, 	&chipData, (ISRFuncPtr_t) IxfApiChipIsr);
    
    printf("Registering is complete\n");
    
#ifdef DREW
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) BDExtLoopbackArray);
#elif WALLACE    
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) BWExtLoopbackArray);
#else
    perror("YOU DID NOT SPECIFY DREW OR WALLACE\n");
#endif
    
    /* Clear any alarms generated during the device configuration above */
    IxfApiChipIsr(&chipData);
    
    /* Give the chip some time to settle out */
    taskDelay(400);
    
    /* Now let's enable the Master Interrupt Enable bit */
    IxfApiGenericRead(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    if (regVal & 1)
        printf("Enable was already set\n");
    regVal |= 1;
    IxfApiGenericWrite(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    
    
    IxfApiGenericRead(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    printf("GLOBAL ENABLE IS %s\n", (regVal & 1) ? "ENABLED" : "DISABLED");
    
    IxfApiGenericRead(&chipData, TWO_BYTES, PRBSINTEN, 1, &regVal);
    printf("PRBS ENABLE IS %s\n", (regVal & 1) ? "ENABLED" : "DISABLED");
    
    IxfApiGenericRead(&chipData, TWO_BYTES, MISC_GIS, 1, &regVal);
    printf("MISC_GIS %04x\n", regVal);
    
    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) Ixf6048TestAlarmCallback);
    
    /* Now, if an interrupt happens, the callback should be called
    and the callback will release the flag to complete this test */
    
    printf("You can pull out the fiber cable now\n");
    
    /* Initialize the ISR flag */
    isrFlag = 1;
    
    while (1)
    {
        if (!(isrFlag))
            break;
    }
    
    
    /* Now let's disable the Master Interrupt Enable bit */
    IxfApiGenericRead(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    regVal &= 6;
    IxfApiGenericWrite(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    
    printf("IRQ test complete\n");
    
    /* Remove the entries in ISR Table for this pChipData */
    IxfDeleteISRChipData(&chipData);
    
    IxfApiReset(&chipData, &section, bb_RESET_CHIP);
#endif
    
}

void TestIxfApi(void)
{
    if (taskSpawn("TestIxfApiMain", 120, 0,  4000, 
        (FUNCPTR) TestIxfApiMain, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0) == ERROR)
    {
        /* if taskSpawn fails, close fd and return to top of loop */
        perror ("taskSpawn");
    }
}

