/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 6/03/03 12:42p $
*   LAST MODIFIED:  $Modtime: 6/03/03 12:36p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /dev_2000/BoardSupport/VxWorks/MediaCardDrivers/IXD28192/test_app/test18101.c $
*   WORKFILE:       $Workfile: test18101.c $
*
* --------------------------------------------------------------------------
* Project: IXF API
*
* Purpose: Provides a simple driver to drive the driver :)
*			
* Notes:
*			
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* 
* --------------------------------------------------------------------------
*/

#include "stdio.h"
#include <stdlib.h>
#ifdef VXWORKS
#include "vxWorks.h"
#include "string.h"
#include "msgQLib.h"
#include "logLib.h"
#include "usrLib.h"
#include "intLib.h"
#elif IXF_LINUX
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#endif /*VXWORKS*/

#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h" /* BroadBand Utility Definitions and Function headers */
#include "ixf_api_sonet_d.h"
#include "ixf_api.h"
#include "ixf_api_sonet.h"
#include "bld18100.h"
/*
#include "ixf18100b.h"
#include "ixf18100d.h"
*/
#include "hal.h"
#include "sim.h"
#include "test18101.h"
#ifdef INTERRUPT_SYSTEM_MODE
#include "interrupts.h"
#include "intrhndlrd.h"
#include "intrhndlr.h"
#endif /*INTERRUPT_SYSTEM_MODE*/

#define I2S_MAJOR 10
#define I2S_MINOR 35

extern void *map_memory (unsigned long phys_addr, size_t size);

#ifdef VXWORKS
SEM_ID ISRSemaphore;
MSG_Q_ID intrMsgQId;
#endif /*VXWORKS*/

volatile int isrFlag;
int HaveWeRunBefore = 1;

#define IXF18101_BASE_ADDRESS 0xC6000000
#define DATABUF_SIZE 64

/****************************************************************************************/
#ifdef IXF_LINUX
void
dump_sp ()
{
  int i;
  unsigned long *originalPtr;
  originalPtr = (unsigned long *) map_memory (0xc0080000, 64);
  for (i = 0; i < 16; i++)
    {
      printf ("ADDR %p CONTENT %08x\n", &(originalPtr[i]), originalPtr[i]);
    }
}


void
sighandler (int signo)
{
  unsigned short regVal;

  if (signo == SIGIO)
    {
      printf ("Received an Interrupt\n");
      /* Call ChipIsr */
      IxfApiChipIsr (savedChipData);

//#if 0  /* We only want to run one time */
      /* Now let's enable the Master Interrupt Enable bit */
      IxfApiGenericRead (savedChipData, TWO_BYTES, MACNF, 1, &regVal);
      regVal |= 1;
      IxfApiGenericWrite (savedChipData, TWO_BYTES, MACNF, 1, &regVal);
//#endif

    }
  return;
}
#endif /*IXF_LINUX*/
#ifdef INTERRUPT_SYSTEM_MODE
#ifdef VXWORKS
void
InitTestInterrupts(void)
{
    /* Initialize Interrupt handler Array*/
    IxfInitISRArray();
    
    /* Creat a binary semaphore */
    if ((ISRSemaphore = semBCreate(SEM_Q_FIFO, SEM_EMPTY)) == NULL)
        perror ("Cannot create the binary semaphore\n");
    
    /* Initialize  system's interrupt */
    if ( IXF_Init_System_Interrupt() == ERROR)
        printf("  Error initializing ISR\n");
    
    /* Interrupt Handler Creation for  using in the ISR */
    if (taskSpawn("tIXF_InterruptHandler", 80, 0, 1000, (FUNCPTR) IXF_InterruptHandler,
        0,0, 0, 0, 0, 0, 0, 0, 0, 0) == ERROR)
        perror ("IXF_InterruptHandler task spawning error\n");
}

#endif /*VXWORKS*/

/******************************************************************
* Function : TurnPRBSOn
*-----------------------------------------------------------------
* Description  : This routine places the device in PRBS mode and 
*                enable PRBS interrupts.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid pointer to the device.
*           chanNum : Specifies the channel number.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : None.
*-----------------------------------------------------------------
* Access Globals : None.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
void
TurnPRBSOn(bb_ChipData_t *pChipData, int chanNum)
{
    bb_ChipSegment_t section;
    ushort regVal;
    
    /* Assign the channel number */
    section.group.channel = chanNum;
    
    section.block.flow = BOTH_FLOWS;

/* ==>> TOM

       Manipulate the PRBS registers in Calypso...

 */

    /* Start PRBS Interrupts */    

    /* Clear PRBS Interrupts */
       
    /* Enable PRBS Interrupts */


}

/******************************************************************
* Function : TurnPRBSOff
*-----------------------------------------------------------------
* Description  : This routine disables PRBS interrupts.
*-----------------------------------------------------------------
* Inputs  : pChipData : Valid pointer to the device.
*           chanNum : Specifies the channel number.
* Outputs : None.
*-----------------------------------------------------------------
* Returns : None.
*-----------------------------------------------------------------
* Access Globals : None.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
void
TurnPRBSOff(bb_ChipData_t *pChipData, int chanNum)
{
    ushort regVal;

/* ==>> TOM

       Manipulate the PRBS register in Calypso...
 */

    
    /* Disable PRBS Interrupts */
}

/***********************************************************************
* Private Callback function
* 		-- AlarmCallback 
*
*         This Function is Called from the ixf18101 Interrupt Handler
*         block to report All Active interrupts. The void pointer pAlarmStatus
*		   can be a pointer to any of the Alarm Structure Types, and is 
*		   Automatically Type-Cast based upon the AlarmType Param. 
**********************************************************************/
void Ixf18101ClearAlarmCallback (ushort *BaseAddress,
                                AlarmCallbackType_e   AlarmType,     /* Type of Alarm */
                                void* pAlarmStatus)  /* -> Alarm status struct */
{
    
    switch(AlarmType)
    {  /* pAlarmStatus -> ixf18101_GlobalAlarmCfg_t */
    default:
        printf("Received Transient  alarm number %d\n", AlarmType);
        break;
    }
}

/***********************************************************************
* Private Callback function
* 		-- AlarmCallback 
*
*         This Function is Called from the ixf18101 Interrupt Handler
*         block to report All Active interrupts. The void pointer pAlarmStatus
*		   can be a pointer to any of the Alarm Structure Types, and is 
*		   Automatically Type-Cast based upon the AlarmType Param. 
**********************************************************************/
void Ixf18101TestAlarmCallback (ushort *BaseAddress,
                               AlarmCallbackType_e   AlarmType,     /* Type of Alarm */
                               void* pAlarmStatus)  /* -> Alarm status struct */
{
    ixf18101_MiscAlarmStatus_t *MiscAlarms;
    
    MiscAlarms = (ixf18101_MiscAlarmStatus_t *) pAlarmStatus;
    
    /* Call the Alarm Handler Function */
    switch(AlarmType)
    {  /* pAlarmStatus -> ixf18101_GlobalAlarmCfg_t */
    default:
        printf("Received alarm number %d\n", AlarmType);
        break;
    }
}

#endif /*INTERRUPT_SYSTEM_MODE*/

void TestIxfApiMain (void)
{
    
    ulong  sz=0;
    ulong  set_sz=0;
    bb_ChipData_t chipData;
    char string64[] = "Expected J0 String that is longer than 64 bytes in length and should be truncated ";
    bb_RegPointer_type pReg;
    bb_ChipInfo_t         ChipInfo;
    uchar                      J0String[64];
    ushort usTest1;
    ushort usTest2;
    bb_ChipSegment_t section;
    ushort len;
    int i;
    bb_Error_e ixfStatus;
    char dataBuf[DATABUF_SIZE];
    char myArray[512];
#ifdef INTERRUPT_SYSTEM_MODE
    ushort regVal;
#endif /*INTERRUPT_SYSTEM_MODE*/

#ifdef IXF_LINUX
  unsigned long *baseAddr;
  struct sigaction action;
  char *devPath = "/dev/irq2sig";
  int devFd;

  baseAddr = (unsigned long *) map_memory (IXF18101_BASE_ADDRESS, DEVICE_SIZE);
#endif /*IXF_LINUX*/
    
    /* Setup a generic section parameter */
    section.block.block = 0;
    section.block.side = 0;
    section.block.flow = 0;
    section.group.channel = 0;
    section.indirect.slot = 0;
    section.value = 0;
    
    
    /***************/
    /* Test Case 1 */
    /***************/
    
    /* Test IxfApiInit */
#ifdef VXWORKS
    ixfStatus = IxfApiInit((bb_RegPointer_type) IXF18101_BASE_ADDRESS, bb_18101_CHIP, &chipData);
#elif IXF_LINUX
    ixfStatus = IxfApiInit ((bb_RegPointer_type) baseAddr, bb_18101_CHIP, &chipData);
#endif
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIINIT TEST                     : PASSED\n");
    }
    else
    {
        printf("IXFAPIINIT TEST                     : FAILED\n");
    }
    
    
    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiAllocDataStructureMem(&chipData);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIALLOCDATASTRUCTMEM TEST       : PASSED\n");
    }
    else
    {
        printf("IXFAPIALLOCDATASTRUCTMEM TEST       : FAILED\n");
    }
    
    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiDeAllocMemory(&chipData);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIDEALLOCMEMORY TEST            : PASSED\n");
    }
    else
    {
        printf("IXFAPIDEALLOCMEMORY TEST            : FAILED\n");
    }
    
    /* Test IxfApiInitChip */
    ixfStatus = IxfApiInitChip(&chipData, RegInitIXF18101Table);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIINITCHIP TEST                 : PASSED\n");
    }
    else
    {
        printf("IXFAPIINITCHIP TEST                 : FAILED\n");
    }
    
    /***************/
    /* Test Case 2 */
    /***************/
    
    /* Get h/w info for chip  */
    ixfStatus = IxfApiGetChipInfo(&chipData, &ChipInfo);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        if (((ChipInfo.ChipId & 0xF) == 1) && (ChipInfo.ChipVersion == 2))
            printf("IXFAPIGETCHIPINFO TEST              : PASSED\n");
        else
            printf("IXFAPIGETCHIPINFO TEST              : FAILED\n");
    }
    else
    {
        printf("IXFAPIGETCHIPINFO TEST              : FAILED\n");
    }
    
    
    
    /* Get Build Version */
    ixfStatus = IxfApiGetBuildVersion(&chipData, bb_SW_VERSION_API_TYPE, dataBuf, myArray, &usTest1, &usTest2);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        if (!(strcmp(dataBuf,IXF18100_BUILD_DRIVER_NAME)))
        {
            printf("IXFAPIGETBUILDVERSION TEST          : PASSED\n");
        }
    }
    else
    {
        printf("IXFAPIGETBUILDVERSION TEST          : FAILED\n");
    }
    
    /***************/
    /* Test Case 3 */
    /***************/
    /* Set WindowSize */
    set_sz = 0x12345678;
    ixfStatus = IxfApiSetWindowSize(&chipData, &section, CLEARING, set_sz);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPISETWINDOWSIZE TEST            : PASSED\n");
    }
    else
    {
        printf("IXFAPISETWINDOWSIZE TEST            : FAILED\n");
    }
    
    /* Get WindowSize */
    ixfStatus = IxfApiGetWindowSize(&chipData, &section, CLEARING, &sz);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        if (sz == 0xACE)
        {
            printf("IXFAPIGETWINDOWSIZE TEST            : PASSED\n");
        }
        else
        {
            printf("IXFAPIGETWINDOWSIZE TEST            : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPIGETWINDOWSIZE TEST            : FAILED\n");
    }
    
    /***************/
    /* Test Case 4 */
    /***************/
    /* Test Generic Write */
    dataBuf[0] = 0xA;
    dataBuf[1] = 0xB;
    ixfStatus = IxfApiGenericWrite(&chipData, 2, 0x8, 1, dataBuf);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test Generic Read */
        bzero(dataBuf,DATABUF_SIZE);
        
        ixfStatus = IxfApiGenericRead(&chipData, 2, 0x8, 1, dataBuf);
        if ((dataBuf[0] == 0xA) && (dataBuf[1] == 0xB))
        {
            printf("IXFAPIGENERICREAD  TEST             : PASSED\n");
            printf("IXFAPIGENERICWRITE TEST             : PASSED\n");
        }
        else
        {
            printf("IXFAPIGENERICREAD TEST              : FAILED\n");
            printf("IXFAPIGENERICWRITE TEST             : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPIGENERICWRITE TEST              : FAILED\n");
    }
    
    /***************/
    /* Test Case 5 */
    /***************/
    /* Set Overhead Bytes*/
    section.group.channel = 0;
    ixfStatus = IxfApiSetOhByte(&chipData, &section, bb_EXPECTED_C2, 0x13);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        /* Get Overhead Bytes*/
        section.group.channel = 0;
        ixfStatus = IxfApiGetOhBytes(&chipData, &section, bb_EXPECTED_C2, myArray);
        if (*((uchar *) myArray) == 0x13)
        {
            printf("IXFAPIGETOHBYTE TEST                : PASSED\n");
            printf("IXFAPISETOHBYTE TEST                : PASSED\n");
        }
        else
        {
            printf("IXFAPIGETOHBYTE TEST                : FAILED\n");
            printf("IXFAPISETOHBYTE TEST                : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPIGETOHBYTE TEST                : FAILED\n");
    }
    
    /***************/
    /* Test Case 6 */
    /***************/
    /* Test SetTrace */
    /* Set J0 trace for chan 0 */
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) CIExtLoopbackArray);

    section.group.channel = 0;
    ixfStatus = IxfApiSetTrace(&chipData, &section, bb_EXPECTED_J0, bb_64_BYTE_WITH_LF_CR, string64);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test GetTrace */
        section.group.channel = 0;
        ixfStatus = IxfApiGetTrace(&chipData, &section, bb_EXPECTED_J0,  (char*) J0String, &len);
        
        if (!(strncmp(string64, J0String, 10)))
        {
            printf("IXFAPISETTRACE TEST                 : PASSED\n");
            printf("IXFAPIGETTRACE TEST                 : PASSED\n");
        }
        else
        {
            printf("IXFAPISETTRACE TEST                 : FAILED\n");
            printf("IXFAPIGETTRACE TEST                 : FAILED\n");
        }
    }
    else
    {
        printf("IXFAPISETTRACE TEST                 : FAILED\n");
    }
    
    /***************/
    /* Test Case 7 */
    /***************/
    /* Get OHT Counters */
    ixfStatus = IxfApiGetCounters(&chipData, &section, bb_OOF_CNT, myArray);
    
    if (ixfStatus == bb_NO_ERROR)
    {
        printf("IXFAPIGETCOUNTERS TEST              : PASSED\n");
    }
    else
    {
        printf("IXFAPIGETCOUNTERS TEST              : FAILED\n");
    }
    
    
    
    /***************/
    /* Test Case 8 */
    /***************/
    i = 0;
    
    /* Write different values to the chip*/
    ixfStatus = IxfApiInitChip(&chipData, (InitRegTable_t *) RegInitIXF18101Table);
    
    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */
    
    /* Now Read and check the default values */
    while ((defaultArray[i].offset != (bb_RegPointer_type)0xFFFF) &&
        (defaultArray[i].value != IXF_INIT_DATA_DELIMITER))
    {
        /* Form the address */
        pReg = (chipData.BaseAddress + (int) defaultArray[i].offset);
        
        if (READ_FROM_HW(pReg) != defaultArray[i].value)
        {
            printf("BA = %08x", (unsigned int) chipData.BaseAddress);
            printf("MISMATCH on addr = %08x", (unsigned int) pReg);
            printf(" EXPECTED=0x%04x", defaultArray[i].value);
            printf(" ACTUAL=0x%04x\n", READ_FROM_HW(pReg));
            
            break;
        }
        
        i++;
    }
    
    /* Successful if we reached the delimiter */
    if ((defaultArray[i].offset == (bb_RegPointer_type)0xFFFF) &&
        (defaultArray[i].value == IXF_INIT_DATA_DELIMITER))
    {
        printf("IXFAPIRESET TEST                    : PASSED\n");
    }
    else
    {
        printf("IXFAPIRESET TEST                    : FAILED\n");
    }
    
    /***************/
    /* Test Case 9 */
    /***************/
    
    /* ChipIsr Test */
    /* If we are executing this test, then system software enabling
    interrupts must be running */
  /* ChipIsr Test */
#ifdef INTERRUPT_SYSTEM_MODE

#ifdef IXF_LINUX
savedChipData = &chipData;    /* for the signal handler */

  memset (&action, 0, sizeof (action));
  action.sa_handler = sighandler;
  action.sa_flags = 0;

  sigaction (SIGIO, &action, NULL);

  remove (devPath);
  mknod (devPath, S_IFCHR | 0777, makedev (I2S_MAJOR, I2S_MINOR));

  if ((devFd = open (devPath, O_RDWR | O_NONBLOCK)) == -1)
    {
      printf ("Could not open character device\n");
      return;
    }


  fcntl (devFd, F_SETOWN, getpid ());
  fcntl (devFd, F_SETFL, fcntl (devFd, F_GETFL) | FASYNC);
#endif /*IXF_LINUX*/
    
    
    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */
    
    if (HaveWeRunBefore)
    {
        InitTestInterrupts();
        HaveWeRunBefore = 0;
    }
    
    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) Ixf18101ClearAlarmCallback);
    IxfRegisterInterrupt(INT_DEVICE_1, 	&chipData, (ISRFuncPtr_t) IxfApiChipIsr);
    
    printf("Registering is complete\n");
    
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) CIExtLoopbackArray);
    
    /* Clear any alarms generated during the device configuration above */
    IxfApiChipIsr(&chipData);
    
    /* Give the chip some time to settle out */
#ifdef VXWORKS
    taskDelay(400);
#elif IXF_LINUX
   sleep(3);
#endif /*VXWORKS*/
    
    /* Now let's enable the Master Interrupt Enable bit */
    IxfApiGenericRead(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    if (regVal & 1)
        printf("Enable was already set\n");
    regVal |= 1;
    IxfApiGenericWrite(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    
    
    IxfApiGenericRead(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    printf("GLOBAL ENABLE IS %s\n", (regVal & 1) ? "ENABLED" : "DISABLED");
    
    IxfApiGenericRead(&chipData, TWO_BYTES, PRBSINTEN, 1, &regVal);
    printf("PRBS ENABLE IS %s\n", (regVal & 1) ? "ENABLED" : "DISABLED");
    
    IxfApiGenericRead(&chipData, TWO_BYTES, MISC_GIS, 1, &regVal);
    printf("MISC_GIS %04x\n", regVal);
    
    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) Ixf18101TestAlarmCallback);
    
    /* Now, if an interrupt happens, the callback should be called
    and the callback will release the flag to complete this test */
    
    printf("You can pull out the fiber cable now\n");

#ifdef VXWORKS
    /*Initialize the ISR flag */
    isrFlag = 1;
    
    while (1)
    {
        if (!(isrFlag))
            break;
    }
    
    
    /* Now let's disable the Master Interrupt Enable bit */
    IxfApiGenericRead(&chipData, TWO_BYTES, MACNF, 1, &regVal);
    regVal &= 6;
    IxfApiGenericWrite(&chipData, TWO_BYTES, MACNF, 1, &regVal);

    /* Remove the entries in ISR Table for this pChipData */
    IxfDeleteISRChipData(&chipData);
    
    IxfApiReset(&chipData, &section, bb_RESET_CHIP);

#elif IXF_LINUX
    /* this only returns if a signal arrives */
    sleep (86400);                /* one day */
#endif /*VXWORKS*/
    
    printf("IRQ test complete\n");    
#endif /*INTERRUPT_SYSTEM_MODE*/
}

void 
TestIxfApi(void)
{
    if (taskSpawn("TestIxfApiMain", 120, 0,  4000, 
        (FUNCPTR) TestIxfApiMain, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0) == ERROR)
    {
        /* if taskSpawn fails, close fd and return to top of loop */
        perror ("taskSpawn");
    }
}

