/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 6/27/03 3:56p $
*   LAST MODIFIED:  $Modtime: 6/27/03 3:51p $
*   REV#:           $Revision: 3 $
*   LOGFILE:        $Logfile: /dev_2000/BoardSupport/VxWorks/MediaCardDrivers/ixd2810/Test_App/test2810.c $
*   WORKFILE:       $Workfile: test2810.c $
*
* --------------------------------------------------------------------------
* Project: IXF API
*
* Purpose: Provides a simple driver to drive the driver :)
*			
* Notes:
*			
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* 
* --------------------------------------------------------------------------
*/

#include "stdio.h"
#include <stdlib.h>
#include "vxWorks.h"
#include "string.h"
#include "msgQLib.h"
#include "logLib.h"
#include "usrLib.h"
#include "intLib.h"
#include "test2810.h"
#include "ixd2810.h"

#define PORTREGCOUNT	16
#define REGCOUNT		10


uint32_t testPortData[BOARDID_BLOCK][PORTREGCOUNT];
uint32_t testPortDatar[BOARDID_BLOCK][PORTREGCOUNT];
uint32_t testBoardIDData;
block_t  testBlock;
int32_t	 callBackSem;

IMPORT	pixd2810CallBackFunc;

/* Foward protoypes */

void ixd2810CallBackRoutine(void);



void TAM (void)
{
  	int devId = 0;
	int ixdStatus;
	uint32_t testBoardIDData;
	block_t *ptestBlock;
	int i;
	
	ptestBlock=&testBlock;

	printf("IXD2810 API TEST SUITE!!\n");
    
    /***************/
    /* Test Case 1 */
    /***************/
    
	printf("IXD2810 API Create TEST...\n");
    /* Test ixd2810_Create */
    ixdStatus = ixd2810_Create(devId);

    if (ixdStatus == OK)
    {
        printf("IXD API Create TEST                 : PASSED\n");
    }
    else
    {
        printf("IXD API Create TEST                 : FAILED\n");
    }
    
    /***************/
    /* Test Case 2 */
    /***************/
    
	printf("IXD2810 API Start TEST...\n");
    /* Test ixd2810_Start */
    ixdStatus = ixd2810_Start(devId);
    
    if (ixdStatus == OK)
    {
        printf("IXD API Start TEST                  : PASSED\n");
    }
    else
    {
        printf("IXD API Start TEST                  : FAILED\n");
    }
    

    /***************/
    /* Test Case 3 */
    /***************/
    /* Test ixd2810_IOCTL_Get board_ID*/

	
	ptestBlock->blockId=BOARDID_BLOCK;
	ptestBlock->startingReg=0;
	ptestBlock->data=&testBoardIDData;
	ptestBlock->regNum=1;

	ixdStatus = ixd2810_Ioctl(devId, IXD2810_IOCTL_GET, ptestBlock);
    
    if (ixdStatus == OK)
    {
        printf("IXD API Ioctl get boardID TEST      : PASSED\n");
    }
    else
    {
        printf("IXD API Ioctl get boardID TEST      : FAILED\n");
    }

    printf("BoardID returned =%x\n", *(ptestBlock->data));


    /***************/
    /* Test Case 4 */
    /***************/
    /* Test ixd2810_IOCTL_Get for port blocks*/


	ptestBlock->startingReg=0;
	ptestBlock->regNum=PORTREGCOUNT;

	for(ptestBlock->blockId=PORT0_BLOCK;ptestBlock->blockId<=PORT9_BLOCK;(ptestBlock->blockId)++)
		{
		ptestBlock->data=&testPortData[ptestBlock->blockId][0];
		ixdStatus = ixd2810_Ioctl(devId, IXD2810_IOCTL_GET, ptestBlock);
    	if (ixdStatus == OK)
    		{
       			printf("IXD API Ioctl get Port %s TEST      : PASSED\n", ixd2810BlockStr[ptestBlock->blockId]);
				for(i=0;i<PORTREGCOUNT;i++) printf("Reg %x = %x\n", i, (uint32_t *)testPortData[ptestBlock->blockId][i]); 
    		}
    		else
    		{
        		printf("IXD API Ioctl get Port %s TEST      : FAILED\n", ixd2810BlockStr[ptestBlock->blockId]);
    		}
		}

    /***************/
    /* Test Case 5 */
    /***************/
    /* Test ixd2810_IOCTL_Get for other than ports*/


	ptestBlock->startingReg=0;
	ptestBlock->regNum=REGCOUNT;

	for(ptestBlock->blockId=GLOBAL_BLOCK;ptestBlock->blockId<=GBIC_BLOCK;(ptestBlock->blockId)++)
		{
		ptestBlock->data=&testPortData[ptestBlock->blockId][0];
		ixdStatus = ixd2810_Ioctl(devId, IXD2810_IOCTL_GET, ptestBlock);
    	if (ixdStatus == OK)
    		{
       			printf("IXD API Ioctl get Block %s TEST     : PASSED\n", ixd2810BlockStr[ptestBlock->blockId]);
				for(i=0;i<REGCOUNT;i++) printf("Reg %x = %x\n", i, (uint32_t *)testPortData[ptestBlock->blockId][i]); 
    		}
    		else
    		{
        		printf("IXD API Ioctl get Block %s TEST     : FAILED\n", ixd2810BlockStr[ptestBlock->blockId]);
    		}
		}

    /***************/
    /* Test Case 6 */
    /***************/
    /* Test ixd2810_IOCTL_Set for port blocks*/


	ptestBlock->startingReg=0;
	ptestBlock->regNum=1;

	for(ptestBlock->blockId=PORT0_BLOCK;ptestBlock->blockId<=PORT9_BLOCK;(ptestBlock->blockId)++)
		{
		ptestBlock->data=&testPortData[ptestBlock->blockId][0];
		testPortData[ptestBlock->blockId][0]=ptestBlock->blockId;
		ixdStatus = ixd2810_Ioctl(devId, IXD2810_IOCTL_SET, ptestBlock);
		ptestBlock->data=&testPortDatar[ptestBlock->blockId][0];
		ixdStatus = ixd2810_Ioctl(devId, IXD2810_IOCTL_GET, ptestBlock);
    	if (ixdStatus == OK)
    		{
				if(testPortData[ptestBlock->blockId][0]==testPortDatar[ptestBlock->blockId][0])
					{
	       			printf("IXD API Ioctl set Port %s TEST      : PASSED\n", ixd2810BlockStr[ptestBlock->blockId]);
					}
				else
					{
	       			printf("IXD API Ioctl set Port %s TEST      : FAILED\n", ixd2810BlockStr[ptestBlock->blockId]);
					}
				printf("Write data = %x, Read data = %x\n",testPortData[ptestBlock->blockId][0],testPortDatar[ptestBlock->blockId][0]);
    		}
    		else
    		{
        		printf("IXD API Ioctl get Port %s TEST      : FAILED\n", ixd2810BlockStr[ptestBlock->blockId]);
    		}
		}

    /***************/
    /* Test Case 7 */
    /***************/
    /* Test ixd2810 IRQ callback function */

	callBackSem=FALSE;
	(void *)pixd2810CallBackFunc=&ixd2810CallBackRoutine;
	printf("Callback installed, change line connection now to test\n");
	printf("Waiting for callback...\n");
/*	taskDelay(10);*/
	while(callBackSem==FALSE);
	(void *)pixd2810CallBackFunc=NULL;
	printf("Callback recieved!!\n");
	printf("IXD API INT Callback TEST           : PASSED\n");



    /***************/
    /* Test Case 8 */
    /***************/
    
    /* Test ixd2810_Stop */
    ixdStatus = ixd2810_Stop(devId);
    
    if (ixdStatus == OK)
    {
        printf("IXD API Stop TEST                   : PASSED\n");
    }
    else
    {
        printf("IXD API Stop TEST                   : FAILED\n");
    }
}


void	ixd2810CallBackRoutine(void)
	{
	callBackSem=TRUE;
	}

