/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/* ixd2810Autoneg.h - IXD2810 MAC device header file

modification history
--------------------
01a, 08oct02,eme	created
01b, 18jun03,tep removed the LOCAL directive from doAutoneg prototype.
*/

#ifndef __INCixd2810Autonegh
#define __INCixd2810Autonegh

#include <ixd2810.h>
#include <ixd2810Port.h>


/* Auto-negotiation related macros */
#define AN_TIMEOUT	30 /* seconds */

/* function prototypes */
STATUS doAutoneg(IXD2810_DEV *pDev, uint32_t port);
LOCAL void configMac(IXD2810_DEV *pDev, uint32_t port);
LOCAL void fiberAutoNeg(IXD2810_DEV *pDev, uint32_t port);
LOCAL void printMsg(IXD2810_DEV *pDev, uint32_t port, int mode);

#endif /* __INCixd2810Autonegh */
