/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:58p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Autoneg.h $
*   WORKFILE:       $Workfile: ixd2810Autoneg.h $
*
 *-------------------------------------------------------------------------------
 *	Description:
 *-------------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Autoneg.h $
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 2     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
* 
* --------------------------------------------------------------------------
*/
/* defines */
#define AN_TIMEOUT		30		/* 30 secs */

/****************************** register address ******************************/

/* left-shift address lines by 2 */

#define DESIRED_DUPLEX(port)		((port * 0x80 + 0x2) * 4)

/********************************** bit mask **********************************/

/* Rx Config Word Register */
#define HALF_DUPLEX			(1 << 6)		
#define FULL_DUPLEX			(1 << 5)		

#define LINK_UP(port)		(1 << port)		/* Link Up Register */
#define PORT_EN(port)		(1 << port)		/* Port Enable Register */

/* Diverse Config Write Register */
#define INVERT_LOSS			(1 << 13)		
#define AUTONEG_ENABLE		(1 << 5)		
#define LOS_INVERT			(1 << 4)		
#define SET_LINKUP			(1 << 0)		

#define FB_AN_COMPLETE		(1 << 21)		/* Rx Config Word Register */

#define REG_DUPLEX_FULL		(1 << 0)		/* Desired Duplex Register */

/* function prototypes */

void performAutoneg(IXD2810_DEV *pDev, int port);
void configMac(IXD2810_DEV *pDev, int port);
void doFiberAutoneg(IXD2810_DEV *pDev, int port);
void printMsg(IXD2810_DEV *pDev, int port, int mode);
extern void disablePort(IXD2810_DEV *pDev, int port);

