/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:58p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Board.h $
*   WORKFILE:       $Workfile: ixd2810Board.h $
*
 *-------------------------------------------------------------------------------
 *	Description:
 *-------------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Board.h $
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 3     10/13/03 4:56p Tepulkow
 * added slow port workaround to port_rd macro
 * 
 * 2     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
* 
* --------------------------------------------------------------------------
*/

#ifndef __IXD2810BOARD_H
#define __IXD2810BOARD_H

/* debugging utility */
/*#define DEBUG*/
#ifdef DEBUG
#define dprintk(fmt, args...)	printk(fmt , ##args)
#else
#define dprintk(fmt, args...)	
#endif

/* macros */

#define LOCAL	static

#define	PORT_RD(addr)			ixd2810SpRead(addr)
#define	PORT_WR(value,addr)		writel(cpu_to_le32(value),addr)

/* function return values */
#define ERROR	(-1)
#define OK		(0)

/* Board IDs */
#define IXD2810_BOARDID	0x02810

/* Number of device supported */
#define N_DEVICES	1

/* Port number found on IXD2810 */
#define N_PORTS	10

/* Converts a port number to the corresponding port mask bit definition */
#define	PORT_MASK(p)	(1 << p)

/* size constants */
#define    SZ_1M                          0x00100000
#define    SZ_2M                          0x00200000
#define    SZ_3M                          0x00300000
#define    SZ_4M                          0x00400000
#define    SZ_8M                          0x00800000
#define    SZ_16M                         0x01000000
#define    SZ_32M                         0x02000000
/* Memory size allocated for each device */
#define IXD2810_MAC_SIZE SZ_2M

/* Board Id location offset */
#define IXD2810_BOARDID_OFFSET	(SZ_1M >> 2)
#define IXD2810_BOARDID_MASK 	0xfffff  /* masks */

/* macro definitions from BSP */
#define MEDIA_SLOWPORT_BASE			0xc6000000		
#define FABRIC_SLOWPORT_BASE		0xc6800000

/* device name */
#define MEDIA_DEV_NAME			"/dev/ixd2810Media"
#define FABRIC_DEV_NAME			"/dev/ixd2810Fabric"

/*
 * Boolean type
 */
typedef enum _BOOL {FALSE=0, TRUE=1} BOOL;


#endif /* __IXD2810BOARD_H */


