/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:58p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Board_s.h $
*   WORKFILE:       $Workfile: ixd2810Board_s.h $
*
 *-------------------------------------------------------------------------------
 *	Description:
 *-------------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Board_s.h $
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 2     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
* 
* --------------------------------------------------------------------------
*/
#ifndef __IXD2810BOARD_S_H
#define __IXD2810BOARD_S_H
/*
 * Data maintained by the driver during the execution of the code 
 */
typedef struct _ixd2810_dev
{
	unsigned int	devId;			/* dev identifier; copy */
	unsigned int	boardId;		/* board identifier */
	unsigned int 	*vbase;			/* virtual address base */
	unsigned int	gbicStatus;		/* GBIC Status */
	BOOL			created;		/* TRUE if this device has been created */
	BOOL 			doAutoNeg[N_PORTS];/* whether or not to perform autoneg */
	int 			intCnt;			/* interrupt count */
	int 			irq;			/* interrupt level */
	struct tq_struct stModDefTask; 	/* ISR: queued task */
	PortStatusObj 	portStatus[N_PORTS];
	int			port;			/* port on which to perform autoneg */
} IXD2810_DEV;
	
/* global variables */
IXD2810_DEV ixd2810Dev[N_DEVICES]; /* device array */


#endif /* __IXD2810BOARD_S_H */
