/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:58p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Int.h $
*   WORKFILE:       $Workfile: ixd2810Int.h $
*
 *-------------------------------------------------------------------------------
 *	Description:
 *-------------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXD2810INT/include/ixd2810Int.h $
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 3     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
* 
* --------------------------------------------------------------------------
*/

#ifndef __IXD2810INT_H
#define __IXD2810INT_H

/* defines */

/* initialize GBIC control interrupt value */
#define GC_INT_ENABLE (GC_Rx_Loss_Enable | \
							  GC_Tx_Fault_Enable | \
							  GC_Mod_Def_Enable)
#define GC_INT_DISABLE 0

#define LINK_UP(port)	(0x1 << port)		/* bits 9:0 */
#define PORT_EN(port)	(0x1 << port)		/* bits 9:0 */

#define ENABLE_BOUNDARY	0x3FF

#define LED_MODE0	2
#define LED_MODE1	3

#define	ALL_PORTS	0x3FF

/* task names list */
static char *taskNames[] = 
	{
	"Device_0_ISR_Task",
	"Device_1_ISR_Task"
	};

/* variables */
/* IRQs */
typedef struct _ixd2810_irqs {
	u32 gpio_irq;
} IXD2810_IRQ;

/* function prototypes */

void ixd2810Isr(int irq, void *dev_id, struct pt_regs *regs);
void rxLossIsr(IXD2810_DEV *pDev, u32 irq, u32 uiStatus);
void txFaultIsr(IXD2810_DEV *pDev, u32 irq, u32 uiStatus);
void modDefIsr(IXD2810_DEV *pDev, u32 irq, u32 uiStatus);
void disablePort(IXD2810_DEV *pDev, int port);
void enablePort(IXD2810_DEV *pDev, int port);
void getModState(void *ptr);
extern int performAutoneg(IXD2810_DEV *pDev, int port);    /* export from autoneg module */

#endif /* __IXD2810INT_H */

