/* 
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/devlib.h $
*   WORKFILE:       $Workfile: devlib.h $
*
* --------------------------------------------------------------------------
* Project: ALL
*
* Purpose: Defines the function pointers for the device libraries.
*          The function pointers depeneds on the bb_ChipType_e type
*          numbering.
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/devlib.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 4     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
* --------------------------------------------------------------------------
*/ 

#ifndef __DEVLIB_H_ /* Include file contents only once per compilation */
#define __DEVLIB_H_

/* Common API related include's */
#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h" /* General data structures for entire API */

#ifdef I2C_INCLUDED
#include "ixf_api_I2C_d.h"
#endif

#ifdef SONET_INCLUDED
#include "ixf_api_sonet_d.h" /* Sonet related data structures */
#endif
#ifdef OTN_INCLUDED
#include "ixf_api_otn_d.h"
#endif
#include "ixf_api.h"   /* Prototypes */
/*#include "ixf_api_sonet.h"*/   /* Prototypes */
#ifdef ETHERNET_INCLUDED
#include "ixf_api_ether_d.h"
#endif

/* IXF6192 Device */
#ifdef INCLUDE_6192_LIB
/* IXF6192 related include's */
#include "ixf6192f.h" /* Prototypes for the IXF6192 */
#endif

/* IXF18100 Family */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
defined(INCLUDE_18103_LIB) || defined(INCLUDE_18104_LIB)

#include "ixf18100.h"

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
defined(INCLUDE_18104_LIB)
#include "ixf18100_xgmac_d.h"
#include "ixf18100_xgmac.h"
#endif

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
defined(INCLUDE_18103_LIB)
#include "ixf18100_sonet_d.h"
#include "ixf18100_sonet.h"
#endif

#endif

#ifdef INCLUDE_1110_LIB
#include "ixf1110.h"
#include "ixf1110_xgmac_d.h"
#include "ixf1110_xgmac.h"
#endif	/*INCLUDE_1110_LIB*/

#ifdef INCLUDE_6048_LIB
/* IXF6048 related include's */
#include "bkcompat.h"
#endif

#ifdef INCLUDE_16121_LIB
/* IXF16121 related include's */
#include "ixf16121_global_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_global_interrupts_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_hpt_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_msa_b.h" /* Bit definitions for IXF16121 */
#include "ixf16121_rmst_b.h" /* Bit definitions for IXF16121 */

#include "ixf16121.h" /* Prototypes for the IXF16121 */
#include "ixf16121_d.h" /* Data definitions for IXF16121 */
#include "ixf16121_cnfg_d.h"
#include "ixf16121_counters_d.h"
#include "ixf16121_jn_trace_d.h"
#include "ixf16121_oht_d.h"
#include "ixf16121_tests_d.h"
#include "ixf16121_ber_d.h"
#include "ixf16121_cnfg.h"
#include "ixf16121_counters.h"
#include "ixf16121_jn_trace.h"
#include "ixf16121_oht.h"
#include "ixf16121_tests.h"
#include "ixf16121_ber.h"
#endif

#ifdef INCLUDE_30007_LIB
#include "ixf30007.h"
#endif

#ifdef INCLUDE_30009_LIB
/* Ixf30009 related Includes */
#include "ixf30009.h"

/* Include Ixf30009 SONET Functionality */
#ifdef SONET_INCLUDED
#include "ixf30009_sonet_d.h"
#include "ixf30009_sonet.h"
#endif  /* SONET_INCLUDED */

#ifdef OTN_INCLUDED
#include "ixf30009_otn_d.h"
#include "ixf30009_otn.h"
#endif /* OTN_INCLUDED */

#endif  /* INCLUDE_30009_LIB */

#if defined(INCLUDE_30025_LIB) || defined(INCLUDE_30005_LIB)
#include "ixf300x5.h"
#endif



#ifdef INCLUDE_3503_LIB
#include "ixf3503_e1.h"
#include "ixf3503_e3.h"
#include "ixf3503_ds1.h"
#include "ixf3503_ds3.h"
#include "ixf3503_sonet.h"
#include "ixf3503_global.h"
#endif

#ifdef INCLUDE_3502_LIB
#include "ixf3502_global.h"
#endif


#ifdef INCLUDE_GENERIC_LIB
#include "genericdriver.h"  /*Prototypes for the Generic Driver 
Functions, if no chip library is 
included or a chip type not recognized 
is added, this will be the default driver*/
#endif

/* The types below define the common api prototypes */
typedef bb_Error_e (*IxfInitChip_t)(bb_ChipData_t *pChipData,
                                    InitRegTable_t *pTable);

typedef bb_Error_e (*IxfAllocMem_t)(bb_ChipData_t *pChipData);

typedef bb_Error_e (*IxfDeAllocMem_t)(bb_ChipData_t *pChipData);

typedef bb_Error_e (*IxfGetStatus_t)(bb_ChipData_t *pChipData,
                                     bb_ChipSegment_t *section,
                                     bb_SelStatus_e selStatus,
                                     void *pStatus);

typedef bb_Error_e (*IxfGetOpMode_t)(bb_ChipData_t *pChipData,
                                     bb_ChipSegment_t *section,
                                     bb_OperMode_e *opMode,
                                     void *pModeCfg);

typedef bb_Error_e (*IxfSetOpMode_t)(bb_ChipData_t *pChipData,
                                     bb_ChipSegment_t *section,
                                     bb_OperMode_e opMode,
                                     void *pModeCfg);

typedef  bb_Error_e (*IxfReset_t)(bb_ChipData_t *pChipData, 
                                  bb_ChipSegment_t *section,
                                  bb_SelResetType_e resetType);

typedef bb_Error_e (*IxfInitAlarmCallback_t)(bb_ChipData_t *pChipData,
                                             AlarmCallBack pAlarmCallbackArg); 

typedef bb_Error_e (*IxfChipIsr_t)(bb_ChipData_t *pChipData);

typedef bb_Error_e (*IxfCfgTest_t)(bb_ChipData_t *pChipData, 
                                   bb_ChipSegment_t *section,
                                   bb_TestType_e testType, void *pTestCfg);

typedef bb_Error_e (*IxfGetCounters_t)(bb_ChipData_t *pChipData, 
                                       bb_ChipSegment_t *section, 
                                       bb_SelCounters_e SelCounters, 
                                       void *pCounters);

typedef bb_Error_e (*IxfGetChipInfo_t)(bb_ChipData_t *pChipData, bb_ChipInfo_t *pChipInfo);

typedef bb_Error_e (*IxfSetChipOnline_t)(bb_ChipData_t *pChipData, bb_ChipSegment_t *section);

typedef bb_Error_e (*IxfSetChipOffline_t)(bb_ChipData_t *pChipData,
                                          bb_ChipSegment_t *section);

typedef bb_Error_e (*IxfSetAlarmCfg_t)(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                                       bb_AlarmType_e AlarmType, void *pAlarmCfg);

typedef bb_Error_e (*IxfGetBuildVersion_t) (bb_ChipData_t *pChipData,
                                            char *drvName, char *date,
                                            ushort *buildVer, ushort *buildRev);

typedef bb_Error_e (*IxfRead_t)(bb_ChipData_t *pChipData, bb_Word_Size_t wordSize,
                                ulong address, ushort length, void *buffer);

typedef bb_Error_e (*IxfWrite_t)(bb_ChipData_t *pChipData, bb_Word_Size_t wordSize,
                                 ulong address, ushort length, void *buffer);

typedef bb_Error_e (*IxfApiGetCfg_t)(bb_ChipData_t *ptChipData, 
                                     bb_ChipSegment_t *ptSegment,
                                     bb_SelConfig_e SelCfg);

typedef bb_Error_e (*IxfApiSetCfg_t)(bb_ChipData_t *ptChipData,
                                     bb_ChipSegment_t *ptSegment,
                                     bb_SelConfig_e SelCfg);

#ifdef I2C_INCLUDED
typedef bb_Error_e (*IxfApiI2CRead_t) (bb_ChipData_t *pChipData,
                                       bb_ChipSegment_t *section,
                                       ixfApi_I2CData_t *i2cData);

typedef bb_Error_e (*IxfApiI2CWrite_t) (bb_ChipData_t *pChipData,
                                        bb_ChipSegment_t *section,
                                        ixfApi_I2CData_t *i2cData);
#endif

#ifdef SONET_INCLUDED
/* The types below define the SONET prototypes */
typedef bb_Error_e (*IxfGetWindowSize_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section,
                                         bb_WindowSizeMode_e mode,
                                         ulong *value);

typedef bb_Error_e (*IxfSetWindowSize_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section,
                                         bb_WindowSizeMode_e mode,
                                         ulong value);

typedef bb_Error_e (*IxfSetBERThreshold_t)(bb_ChipData_t *pChipData, 
                                           bb_ChipSegment_t *section,
                                           bb_BerThresholdSel_e berThresholdSel, 
                                           bb_STSMode_e mode, 
                                           short expNum);

typedef bb_Error_e (*IxfGetTrace_t)(bb_ChipData_t *pChipData,
                                    bb_ChipSegment_t *section,
                                    bb_TraceType_e TraceType,
                                    char *pTrace,
                                    ushort *pLength);

typedef bb_Error_e (*IxfSetTrace_t)(bb_ChipData_t *pChipData, 
                                    bb_ChipSegment_t *section,
                                    bb_TraceType_e TraceType, 
                                    bb_TraceFormat_e TraceFormat, 
                                    char *pTrace);

typedef bb_Error_e (*IxfGetOhBytes_t)(bb_ChipData_t *pChipData, 
                                      bb_ChipSegment_t *section,
                                      bb_SelOhBytes_e  SelOhBytes, 
                                      void *pOhBytes);

typedef bb_Error_e (*IxfSetOhByte_t)(bb_ChipData_t *pChipData, 
                                     bb_ChipSegment_t *section,
                                     bb_SelOhBytes_e SelOhByte, 
                                     ushort OhByte);

typedef bb_Error_e (*IxfMapFrame_t)(bb_ChipData_t *pChipData,
                                    MapFrame_t type,
                                    bb_SignalType_e sigType,
                                    ulong src,
                                    ulong dest,
                                    ulong srcFrameNum,
                                    ulong destFrameNum,
                                    ulong numOfFrames);

typedef bb_Error_e (*IxfGetMappedFrame_t)(bb_ChipData_t *pChipData,
                                          bb_SignalType_e sigType,
                                          ulong src,
                                          ulong destFrameNum,
                                          ulong numOfFrames,
                                          ushort *address);

typedef bb_Error_e (*IxfGetAuPointer_t)(bb_ChipData_t *pChipData,
                                        ulong src,
                                        bb_SignalType_e sigType,
                                        ulong srcFrameNum,
                                        ulong numOfFrames,
                                        ushort *AuPtrValue);


typedef bb_Error_e (*IxfSetRmstSourceBytes_t)(bb_ChipData_t *pChipData,
                                              bb_ChipSegment_t *section);

typedef bb_Error_e (*IxfGetRmstSourceBytes_t)(bb_ChipData_t *pChipData,
                                              bb_ChipSegment_t *section);
#endif /* SONET_INCLUDED */

#ifdef ETHERNET_INCLUDED
/* The types below define the XGMAC prototypes */
typedef bb_Error_e (*IxfGetMacAddress_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section, IxfApi_MacAddress_t *address);

typedef bb_Error_e (*IxfSetMacAddress_t)(bb_ChipData_t *pChipData,
                                         bb_ChipSegment_t *section, IxfApi_MacAddress_t *address);

#endif /* ETHERNET_INCLUDED */

#ifdef OTN_INCLUDED

/* The types below define the OTN prototypes */
typedef bb_Error_e (*IxfApiGetOTNTrace_t)(bb_ChipData_t *pChipData,
                                          bb_ChipSegment_t *section, ixfApi_OTNTraceType_e eTraceType,
                                          void *pTrace);

typedef bb_Error_e (*IxfApiSetOTNTrace_t)(bb_ChipData_t *pChipData,
                                          bb_ChipSegment_t *section, ixfApi_OTNTraceType_e eTraceType,
                                          void *pTrace);

typedef bb_Error_e (*IxfApiSetOTNOhByte_t)(bb_ChipData_t* pChipData,
                                           bb_ChipSegment_t *section, ixfApi_OTNOHBytes_e eOhByte,
                                           void *pOhByte);

typedef bb_Error_e (*IxfApiGetOTNOhByte_t)(bb_ChipData_t *pChipData,
                                           bb_ChipSegment_t *section, ixfApi_OTNOHBytes_e eOhBytes,
                                           void *pOhBytes);
#endif /* OTN_INCLUDED */

/* All Common API routines definition */
typedef struct 
{
    IxfInitChip_t           InitChipFuncPtr;
    IxfAllocMem_t           AllocFuncPtr;
    IxfDeAllocMem_t         DeAllocFuncPtr;
    IxfGetStatus_t          GetStatusFuncPtr;
    IxfGetOpMode_t          GetOpModeFuncPtr;
    IxfSetOpMode_t          SetOpModeFuncPtr;
    IxfReset_t              ResetFuncPtr;
    IxfInitAlarmCallback_t  InitAlarmCallbackFuncPtr;
    IxfChipIsr_t            ChipIsrFuncPtr;
    IxfCfgTest_t            CfgTestFuncPtr;
    IxfGetCounters_t        GetCountersFuncPtr;
    IxfGetChipInfo_t        ChipInfoFuncPtr;
    IxfSetChipOnline_t      ChipOnlineFuncPtr;
    IxfSetChipOffline_t     ChipOfflineFuncPtr;
    IxfSetAlarmCfg_t        SetAlarmCfgFuncPtr;
    IxfGetBuildVersion_t    GetBuildVersionFuncPtr;
    IxfRead_t               ReadFuncPtr;
    IxfWrite_t              WriteFuncPtr;
    IxfApiGetCfg_t          GetCfgFuncPtr;
    IxfApiSetCfg_t          SetCfgFuncPtr;
} CommonFunctionPointers_t;

#ifdef SONET_INCLUDED
/* All SONET API routines definition */
typedef struct 
{
    IxfGetWindowSize_t      GetWindowSizeFuncPtr;
    IxfSetWindowSize_t      SetWindowSizeFuncPtr;
    IxfSetBERThreshold_t    SetBERThresholdFuncPtr;
    IxfGetTrace_t           GetTraceFuncPtr;
    IxfSetTrace_t           SetTraceFuncPtr;
    IxfGetOhBytes_t         GetOhBytesFuncPtr;
    IxfSetOhByte_t          SetOhBytesFuncPtr;
    IxfSetRmstSourceBytes_t SetRmstSourceFuncPtr;
    IxfGetRmstSourceBytes_t GetRmstSourceFuncPtr;
    IxfMapFrame_t           MapFramesFuncPtr;
    IxfGetMappedFrame_t     GetMappedFramesFuncPtr;
    IxfGetAuPointer_t       GetFramesAuPointerFuncPtr;
} SonetFunctionPointers_t;
#endif /* SONET_INCLUDED */

#ifdef DS1_INCLUDED

/* The types below define the DS1 prototypes */
typedef bb_Error_e (*IxfDS1_GetCfg_t)(bb_ChipData_t* pChipData,
                                      const bb_ChipSegment_t* ptSection, 
                                      bb_DS1_Cfg* ptChanData);
typedef bb_Error_e (*IxfDS1_SetCfg_t)(bb_ChipData_t* pChipData,
                                      const bb_ChipSegment_t* ptSection, 
                                      const bb_DS1_Cfg* ptChanData);
typedef bb_Error_e (*IxfDS1_GetFramerCfg_t)(bb_ChipData_t* pChipData,
                                            const bb_ChipSegment_t* ptSection, 
                                            bb_DS1_FramerCfg* pFramerCfg);
typedef bb_Error_e (*IxfDS1_SetFramerCfg_t)(bb_ChipData_t* pChipData,
                                            const bb_ChipSegment_t* ptSection, 
                                            const bb_DS1_FramerCfg* pFramerCfg);
typedef bb_Error_e (*IxfDS1_GetFramerMode_t)(bb_ChipData_t* pChipData,
                                             const bb_ChipSegment_t* ptSection, 
                                             bb_DS1_FramerMode_e* mode);
typedef bb_Error_e (*IxfDS1_SetFramerMode_t)(bb_ChipData_t* pChipData,
                                             const bb_ChipSegment_t* ptSection, 
                                             bb_DS1_FramerMode_e mode);

typedef bb_Error_e (*IxfDS1_GetPerfMonCfg_t)(bb_ChipData_t* pChipData,
                                             const bb_ChipSegment_t* ptSection, 
                                             bb_DS1_PerfMonCfg* cfg);
typedef bb_Error_e (*IxfDS1_SetPerfMonCfg_t)(bb_ChipData_t* pChipData,
                                             const bb_ChipSegment_t* ptSection, 
                                             const bb_DS1_PerfMonCfg* cfg);

/* All DS1 API routines definition */
typedef struct
{
    IxfDS1_SetCfg_t         SetCfgPtr;
    IxfDS1_GetCfg_t         GetCfgPtr;
    IxfDS1_GetFramerCfg_t   GetFramerCfgPtr;
    IxfDS1_SetFramerCfg_t   SetFramerCfgPtr;
    IxfDS1_GetFramerMode_t  GetFramerModePtr;
    IxfDS1_SetFramerMode_t  SetFramerModePtr;
    IxfDS1_GetPerfMonCfg_t   GetPerfMonCfgPtr;
    IxfDS1_SetPerfMonCfg_t   SetPerfMonCfgPtr;
} DS1FunctionPointers_t;

#endif /* DS1_INCLUDED */

#ifdef DS3_INCLUDED

/* the types below define the DS3 prototypes */
typedef bb_Error_e (*IxfDS3_GetCfg_t)(bb_ChipData_t* pChipData,
                                      const bb_ChipSegment_t* ptSection, 
                                      bb_DS3_Cfg* ptChanData);

typedef bb_Error_e (*IxfDS3_SetCfg_t)(bb_ChipData_t* pChipData,
                                      const bb_ChipSegment_t* ptSection, 
                                      const bb_DS3_Cfg* ptChanData);


typedef bb_Error_e (*IxfDS3_GetFramerCfg_t)(bb_ChipData_t* pChipData,
                                            const bb_ChipSegment_t* ptSection, 
                                            bb_DS3_FramerCfg* pFramerCfg);
typedef bb_Error_e (*IxfDS3_SetFramerCfg_t)(bb_ChipData_t* pChipData,
                                            const bb_ChipSegment_t* ptSection, 
                                            const bb_DS3_FramerCfg* pFramerCfg);

typedef bb_Error_e (*IxfDS3_GetPerfMonCfg_t)(bb_ChipData_t* pChipData,
                                             const bb_ChipSegment_t* ptSection, 
                                             bb_DS3_PerfMonCfg* pPerMonCfg);
typedef bb_Error_e (*IxfDS3_SetPerfMonCfg_t)(bb_ChipData_t* pChipData,
                                             const bb_ChipSegment_t* ptSection, 
                                             const bb_DS3_PerfMonCfg* pPerMonCfg);

typedef bb_Error_e (*IxfDS3_GetDiagnosticCfg_t)(bb_ChipData_t* pChipData,
                                                const bb_ChipSegment_t* ptSection, 
                                                bb_DS3_DiagnosticCfg* pPerMonCfg);
typedef bb_Error_e (*IxfDS3_SetDiagnosticCfg_t)(bb_ChipData_t* pChipData,
                                                const bb_ChipSegment_t* ptSection, 
                                                const bb_DS3_DiagnosticCfg* pPerMonCfg);

/* All DS3 API routines definition */
typedef struct
{
    IxfDS3_SetCfg_t         SetCfgPtr;
    IxfDS3_GetCfg_t         GetCfgPtr;
    IxfDS3_GetFramerCfg_t   GetFramerCfgPtr;
    IxfDS3_SetFramerCfg_t   SetFramerCfgPtr;
    IxfDS3_GetPerfMonCfg_t  GetPerfMonCfgPtr;
    IxfDS3_SetPerfMonCfg_t  SetPerfMonCfgPtr;
    IxfDS3_GetDiagnosticCfg_t    GetDiagnosticCfgPtr;
    IxfDS3_SetDiagnosticCfg_t    SetDiagnosticCfgPtr;
} DS3FunctionPointers_t;

#endif /* DS3_INCLUDED */

#ifdef E1_INCLUDED

/* The types below define the E1 prototypes */
typedef bb_Error_e (*IxfE1_GetCfg_t)(bb_ChipData_t* pChipData,
                                     const bb_ChipSegment_t* ptSection, 
                                     bb_E1_Cfg* ptChanData);
typedef bb_Error_e (*IxfE1_SetCfg_t)(bb_ChipData_t* pChipData,
                                     const bb_ChipSegment_t* ptSection, 
                                     const bb_E1_Cfg* ptChanData);
typedef bb_Error_e (*IxfE1_GetFramerCfg_t)(bb_ChipData_t* pChipData,
                                           const bb_ChipSegment_t* ptSection, 
                                           bb_E1_FramerCfg* pFramerCfg);
typedef bb_Error_e (*IxfE1_SetFramerCfg_t)(bb_ChipData_t* pChipData,
                                           const bb_ChipSegment_t* ptSection, 
                                           const bb_E1_FramerCfg* pFramerCfg);
typedef bb_Error_e (*IxfE1_GetFramerMode_t)(bb_ChipData_t* pChipData,
                                            const bb_ChipSegment_t* ptSection, 
                                            bb_E1_FramerMode_e* mode);
typedef bb_Error_e (*IxfE1_SetFramerMode_t)(bb_ChipData_t* pChipData,
                                            const bb_ChipSegment_t* ptSection, 
                                            bb_E1_FramerMode_e mode);

/* All E1 API routines definition */
typedef struct
{
    IxfE1_SetCfg_t         SetCfgPtr;
    IxfE1_GetCfg_t         GetCfgPtr;
    IxfE1_GetFramerCfg_t   GetFramerCfgPtr;
    IxfE1_SetFramerCfg_t   SetFramerCfgPtr;
    IxfE1_GetFramerMode_t  GetFramerModePtr;
    IxfE1_SetFramerMode_t  SetFramerModePtr;
} E1FunctionPointers_t;

#endif /* E1_INCLUDED */

#ifdef E3_INCLUDED

/* the types below define the E3 prototypes */
typedef bb_Error_e (*IxfE3_GetCfg_t)(bb_ChipData_t* pChipData,
                                     const bb_ChipSegment_t* ptSection, 
                                     bb_E3_Cfg* ptChanData);

typedef bb_Error_e (*IxfE3_SetCfg_t)(bb_ChipData_t* pChipData,
                                     const bb_ChipSegment_t* ptSection, 
                                     const bb_E3_Cfg* ptChanData);


typedef bb_Error_e (*IxfE3_GetFramerCfg_t)(bb_ChipData_t* pChipData,
                                           const bb_ChipSegment_t* ptSection, 
                                           bb_E3_FramerCfg* pFramerCfg);
typedef bb_Error_e (*IxfE3_SetFramerCfg_t)(bb_ChipData_t* pChipData,
                                           const bb_ChipSegment_t* ptSection, 
                                           const bb_E3_FramerCfg* pFramerCfg);

/* All E3 API routines definition */
typedef struct
{
    IxfE3_SetCfg_t         SetCfgPtr;
    IxfE3_GetCfg_t         GetCfgPtr;
    IxfE3_GetFramerCfg_t   GetFramerCfgPtr;
    IxfE3_SetFramerCfg_t   SetFramerCfgPtr;
} E3FunctionPointers_t;

#endif /* E3_INCLUDED */

#ifdef ETHERNET_INCLUDED
/* All XGMAC API routines definition */
typedef struct 
{                                               
    IxfGetMacAddress_t          GetMacAddressPtr;
    IxfSetMacAddress_t          SetMacAddressPtr;
} XgmacFunctionPointers_t;
#endif /* ETHERNET_INCLUDED */

#ifdef OTN_INCLUDED
/* All OTN API Routines */
typedef struct
{
    IxfApiGetOTNTrace_t         GetOTNTraceFuncPtr;
    IxfApiSetOTNTrace_t         SetOTNTraceFuncPtr;
    IxfApiGetOTNOhByte_t        GetOTNOhByteFuncPtr;
    IxfApiSetOTNOhByte_t        SetOTNOhByteFuncPtr;
} OTNFunctionPointers_t;
#endif /* OTN_INCLUDED */

#ifdef I2C_INCLUDED
/* All I2C API Routines */
typedef struct
{
    IxfApiI2CRead_t         I2CReadPtr;
    IxfApiI2CWrite_t        I2CWritePtr; 
} I2CFunctionPointers_t;
#endif

typedef struct
{
    CommonFunctionPointers_t    *tCommonFuncPtr;
#ifdef SONET_INCLUDED
    SonetFunctionPointers_t     *tSonetFuncPtr;
#endif
#ifdef ETHERNET_INCLUDED
    XgmacFunctionPointers_t     *tXgmacFuncPtr;
#endif
#ifdef OTN_INCLUDED
    OTNFunctionPointers_t       *tOTNFuncPtr;
#endif
#ifdef I2C_INCLUDED
    I2CFunctionPointers_t       *tI2CFuncPtr;
#endif
    
#ifdef DS1_INCLUDED
    DS1FunctionPointers_t       *tDS1FuncPtr;
#endif
#ifdef DS3_INCLUDED
    DS3FunctionPointers_t       *tDS3FuncPtr;
#endif
#ifdef E1_INCLUDED
    E1FunctionPointers_t        *tE1FuncPtr;
#endif
#ifdef E3_INCLUDED
    E3FunctionPointers_t        *tE3FuncPtr;
#endif
    
} ChipFunctionPointers_t;


#ifdef INCLUDE_6192_LIB
/* Function Pointers for the Ixf6192 Chip */

extern ChipFunctionPointers_t ixf6192FuncPtrs;
#endif /* INCLUDE_6192_LIB */

#ifdef INCLUDE_6048_LIB
/* Function Pointers for the Ixf6048 Chip */

extern ChipFunctionPointers_t ixf6048FuncPtrs;
#endif /* INCLUDE_6048_LIB */

#ifdef INCLUDE_18101_LIB
extern ChipFunctionPointers_t ixf18101FuncPtrs;
#endif /* INCLUDE_18101_LIB */

#ifdef INCLUDE_18102_LIB
extern ChipFunctionPointers_t ixf18102FuncPtrs;
#endif /* INCLUDE_18102_LIB */

#ifdef INCLUDE_18103_LIB
extern ChipFunctionPointers_t ixf18103FuncPtrs;
#endif /* INCLUDE_18103_LIB */

#ifdef INCLUDE_18104_LIB
extern ChipFunctionPointers_t ixf18104FuncPtrs;
#endif /* INCLUDE_18104_LIB */

#ifdef INCLUDE_16121_LIB
/* Function Pointers for the Ixf16121 Chip */

extern ChipFunctionPointers_t ixf16121FuncPtrs;
#endif /* INCLUDE_16121_LIB */

#ifdef INCLUDE_30007_LIB
/* Function Pointers for the Ixf30007 Chip */

extern ChipFunctionPointers_t ixf30007FuncPtrs;
#endif /* INCLUDE_30007_LIB */

#ifdef INCLUDE_30009_LIB
/* Function Pointers for the Ixf30009 Chip */

extern ChipFunctionPointers_t ixf30009FuncPtrs;
#endif /* INCLUDE_30009_LIB */


#ifdef INCLUDE_3502_LIB

/* Function Pointers for the 3502 Chip */
extern ChipFunctionPointers_t ixf3502FuncPtrs;

#endif /* INCLUDE_3503_LIB */

#ifdef INCLUDE_3503_LIB

/* Function Pointers for the 3503 Chip */
extern ChipFunctionPointers_t ixf3503FuncPtrs;

#endif /* INCLUDE_3503_LIB */

#ifdef INCLUDE_1110_LIB
extern ChipFunctionPointers_t ixf1110FuncPtrs;
#endif /* INCLUDE_1110_LIB */


/*Function Pointers for the generic driver, this is the
default driver in case of an urecognized type of chip is added*/
extern ChipFunctionPointers_t genericFuncPtrs;

extern ChipFunctionPointers_t *chipArrayFuncPtrs[];

extern ChipFunctionPointers_t *getChipFuncPtr(bb_ChipType_e chipType);
extern bb_ChipType_e checkChipType(bb_ChipType_e chipType);

#endif   /* __DEVLIB_H_ */
