/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/include/ixf1110_spi4.h $
*   WORKFILE:       $Workfile: ixf1110_spi4.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 family device API
*
* Purpose: This file contains function prototypes for SPI4 block related
*          routines
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/include/ixf1110_spi4.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 5     10/07/03 2:03p Tepulkow
 * General cleanup for code review
 * 
 * 4     9/19/03 9:33a Rnballar
 * 
 * 3     9/18/03 12:06p Rnballar
 * 
 * 2     9/17/03 3:41p Rnballar
 * updated headers to match _d.h files
 * 
 * 1     8/04/03 3:50p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* --------------------------------------------------------------------------
*/


#ifndef _IXF1110_SPI4_H__
#define _IXF1110_SPI4_H__

/******************************************************************************
* Function : Ixf1110Spi4SetCfg
*------------------------------------------------------------------------------
* Description : The function takes the values from SPI4 cfg struct and 
* masks it appropriately and writes the 32 bit value into the register.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the chip.
*           ixf1110_Spi4Cfg_t *ptSpi4Cfg: pointer to the values that
*               need to be set in the device
* Outputs : None
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
extern bb_Error_e
Ixf1110Spi4SetCfg(bb_RegPointer_type BaseAddress, bb_SelConfig_e SelCfg,
                  ixf1110_Spi4Cfg_t *ptSpi4Cfg);

/******************************************************************************
* Function : Ixf1110Spi4GetCfg
*------------------------------------------------------------------------------
* Description : The function reads the 16 bit register values and sets the
* value in the structure members appropriately.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the chip.
*           ixf1110_Spi4Cfg_t *ptSpi4Cfg: pointer to the values that need to 
*               be set from the current chip configuration
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_INV_CHIP_TYPE, bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
extern bb_Error_e
Ixf1110Spi4GetCfg(bb_RegPointer_type BaseAddress, bb_SelConfig_e SelCfg,
			 ixf1110_Spi4Cfg_t *ptSpi4Cfg);



extern bb_Error_e
Ixf1110Spi4GetStatus(bb_RegPointer_type BaseAddress, bb_SelStatus_e SelStatus, void* pStatus);
#endif /* _IXF1110_SPI4_H__ */

