/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_alarms.c $
*   WORKFILE:       $Workfile: ixf1110_alarms.c $
*
* --------------------------------------------------------------------------
* Project: ixf1110 family device API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_alarms.c $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 7     10/21/03 10:36a Tepulkow
 * consolidated the rx, tx, and mod_def edit alarm functions into a single
 * function
 * 
 * 6     9/23/03 4:02p Rnballar
 * fixed linking
 * 
 * 5     9/23/03 10:21a Rnballar
 * added ixf1110 alarms
 * 
 * 4     9/22/03 4:05p Rnballar
 * 
 * 3     9/15/03 11:18a Tepulkow
 * Added kernel ifdefs
 * 
 * 2     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 
* --------------------------------------------------------------------------
*/
#ifdef VXWORKS
#include "vxworks.h"
#include "msgQLib.h"
#include "semLib.h"
#endif

#ifdef IXF_LINUX
#ifndef __KERNEL__
#include <semaphore.h>
#endif
#endif

#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h"
#include "ixf_perf_metric.h"
#include "ixf1110_global_b.h"

#ifdef __KERNEL__
#include "linuxkern.h"
#else
#include "os.h"
#endif

#include "ixf1110_xgmac_b.h"
#include "ixf_api_ether_d.h"

#include "ixf1110_spi4_b.h"
#include "ixf1110_global_d.h"

#include "ixf1110_spi4_d.h"
#include "ixf1110_d.h"
#include "ixf1110_spi4.h"
#include "ixf1110_alarms_d.h"
#include "ixf1110_alarms.h"
#include "ixf1110_gbic_b.h"
#include "hal.h"

/******************************************************************************
* Function : Ixf1110Edit_Alarms
*------------------------------------------------------------------------------
* Description : Edit Chip Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           GlobalChipIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
void 
Ixf1110Edit_Alarms(bb_RegPointer_type BaseAddress,
                          ulong *pGbic_Cntrl_regval)
{
    HAL_IXF1110_WRITE(BaseAddress + ixf1110_GBIC_CNTL_OFFSET,
    					*pGbic_Cntrl_regval);
}



