/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_cnfg_d.h $
*   WORKFILE:       $Workfile: ixf1110_cnfg_d.h $
*
* --------------------------------------------------------------------------
* Project: ixf1810x API
*
* Purpose: Provides Combined Chip Configuration Structure - for IXF1810x
*         
* Notes:
*         
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_cnfg_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 5     9/18/03 12:04p Rnballar
 * 
 * 4     9/17/03 3:46p Rnballar
 * 
 * 3     9/16/03 10:34a Rnballar
 * added ixf1110 structs to overall chipcfg struct
 * 
 * 2     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* --------------------------------------------------------------------------
*/ 
#ifndef  IXF1110_CNFG_H
#define  IXF1110_CNFG_H

#include "ixf1110_spi4_d.h"
#include "ixf1110_rx_d.h"
#include "ixf1110_tx_d.h"
#include "ixf1110_serdes_d.h"
#include "ixf1110_global_d.h"
#include "ixf1110_gbic_d.h"
#include "ixf1110_xgmac_d.h"

/* Chip Config struct */
typedef struct {

    ixf1110_Spi4Cfg_t       Spi4Cfg;   						/*SPI-4 Block*/
	ixf1110_RxCfg_t		RxCfg;						/*Global RX Block*/
	ixf1110_TxCfg_t		TxCfg;						/*Global TX Block*/
	ixf1110_SerDesCfg_t		SerDesCfg;						/*SerDes Block*/
	ixf1110_GlbStatusCfg_t	GlbStatusCfg;					/*Global Status & Config Block*/
	ixf1110_GbicCfg_t		GbicCfg;						/*GBIC Block*/  
    ixf1110_XgmacCfg_t      XgmacCfg;		/*Mac Control Block*/
    
} ixf1110_ChipCfg_t;
#endif
