/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_gbic_b.h $
*   WORKFILE:       $Workfile: ixf1110_gbic_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API 
* 
* Purpose: This file contains register and bit defines for the GBIC  
*          Configuration registers in the ixf1110.
*
* Notes:
*
*   
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_gbic_b.h $ 
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 3     10/10/03 2:58p Tepulkow
 * removed the REG_SHIFT and GBIC_BASE macros to clean build warns
 * 
 * 2     9/11/03 2:03p Tepulkow
 * 
 * 1     9/09/03 4:52p Tepulkow
 * Created these header files for the IXF1110 MAC device blocks new to the
 * IXF API framework
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 
* --------------------------------------------------------------------------
*/ 

#ifndef __ixf1110_GBIC_B_H__
#define __ixf1110_GBIC_B_H__


#define ixf1110_GBIC_REG(offset) ((ixf1110_GBIC_BASE + offset) << ixf1110_REG_SHIFT)

/************GBIC Status Register*/

/*Offset/Default definition for register.*/
#define ixf1110_GBIC_STATUS_OFFSET       ixf1110_GBIC_REG(0x0000)  
#define ixf1110_GBIC_STATUS_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sMOD_DEF0          0   
#define ixf1110_mMOD_DEF0          (0x1 << ixf1110_sMOD_DEF0)    
#define ixf1110_vMOD_DEF0          (0x1 << ixf1110_sMOD_DEF0)    

#define ixf1110_sMOD_DEF1          1   
#define ixf1110_mMOD_DEF1          (0x1 << ixf1110_sMOD_DEF1)    
#define ixf1110_vMOD_DEF1          (0x1 << ixf1110_sMOD_DEF1)    

#define ixf1110_sMOD_DEF2          2   
#define ixf1110_mMOD_DEF2          (0x1 << ixf1110_sMOD_DEF2)    
#define ixf1110_vMOD_DEF2          (0x1 << ixf1110_sMOD_DEF2)    

#define ixf1110_sMOD_DEF3          3   
#define ixf1110_mMOD_DEF3          (0x1 << ixf1110_sMOD_DEF3)    
#define ixf1110_vMOD_DEF3          (0x1 << ixf1110_sMOD_DEF3)    

#define ixf1110_sMOD_DEF4          4   
#define ixf1110_mMOD_DEF4          (0x1 << ixf1110_sMOD_DEF4)    
#define ixf1110_vMOD_DEF4          (0x1 << ixf1110_sMOD_DEF4)    

#define ixf1110_sMOD_DEF5          5   
#define ixf1110_mMOD_DEF5          (0x1 << ixf1110_sMOD_DEF5)    
#define ixf1110_vMOD_DEF5          (0x1 << ixf1110_sMOD_DEF5)    

#define ixf1110_sMOD_DEF6          6   
#define ixf1110_mMOD_DEF6          (0x1 << ixf1110_sMOD_DEF6)    
#define ixf1110_vMOD_DEF6          (0x1 << ixf1110_sMOD_DEF6)    

#define ixf1110_sMOD_DEF7          7   
#define ixf1110_mMOD_DEF7          (0x1 << ixf1110_sMOD_DEF7)    
#define ixf1110_vMOD_DEF7          (0x1 << ixf1110_sMOD_DEF7)    

#define ixf1110_sMOD_DEF8          8   
#define ixf1110_mMOD_DEF8          (0x1 << ixf1110_sMOD_DEF8)    
#define ixf1110_vMOD_DEF8          (0x1 << ixf1110_sMOD_DEF8)    

#define ixf1110_sMOD_DEF9          9   
#define ixf1110_mMOD_DEF9          (0x1 << ixf1110_sMOD_DEF9)    
#define ixf1110_vMOD_DEF9          (0x1 << ixf1110_sMOD_DEF9)    


#define ixf1110_sTX_FLT0           10   
#define ixf1110_mTX_FLT0           (0x1 << ixf1110_sTX_FLT0)    
#define ixf1110_vTX_FLT0           (0x1 << ixf1110_sTX_FLT0)    

#define ixf1110_sTX_FLT1           11   
#define ixf1110_mTX_FLT1           (0x1 << ixf1110_sTX_FLT1)    
#define ixf1110_vTX_FLT1           (0x1 << ixf1110_sTX_FLT1)    

#define ixf1110_sTX_FLT2           12   
#define ixf1110_mTX_FLT2           (0x1 << ixf1110_sTX_FLT2)    
#define ixf1110_vTX_FLT2           (0x1 << ixf1110_sTX_FLT2)    

#define ixf1110_sTX_FLT3           13   
#define ixf1110_mTX_FLT3           (0x1 << ixf1110_sTX_FLT3)    
#define ixf1110_vTX_FLT3           (0x1 << ixf1110_sTX_FLT3)    

#define ixf1110_sTX_FLT4           14   
#define ixf1110_mTX_FLT4           (0x1 << ixf1110_sTX_FLT4)    
#define ixf1110_vTX_FLT4           (0x1 << ixf1110_sTX_FLT4)    

#define ixf1110_sTX_FLT5           15   
#define ixf1110_mTX_FLT5           (0x1 << ixf1110_sTX_FLT5)    
#define ixf1110_vTX_FLT5           (0x1 << ixf1110_sTX_FLT5)    

#define ixf1110_sTX_FLT6           16   
#define ixf1110_mTX_FLT6           (0x1 << ixf1110_sTX_FLT6)    
#define ixf1110_vTX_FLT6           (0x1 << ixf1110_sTX_FLT6)    

#define ixf1110_sTX_FLT7           17   
#define ixf1110_mTX_FLT7           (0x1 << ixf1110_sTX_FLT7)    
#define ixf1110_vTX_FLT7           (0x1 << ixf1110_sTX_FLT7)    

#define ixf1110_sTX_FLT8           18   
#define ixf1110_mTX_FLT8           (0x1 << ixf1110_sTX_FLT8)    
#define ixf1110_vTX_FLT8           (0x1 << ixf1110_sTX_FLT8)    

#define ixf1110_sTX_FLT9           19   
#define ixf1110_mTX_FLT9           (0x1 << ixf1110_sTX_FLT9)    
#define ixf1110_vTX_FLT9           (0x1 << ixf1110_sTX_FLT9)    


#define ixf1110_sRX_LOS0           20
#define ixf1110_mRX_LOS0           (0x1 << ixf1110_sRX_LOS0)    
#define ixf1110_vRX_LOS0           (0x1 << ixf1110_sRX_LOS0)    

#define ixf1110_sRX_LOS1           21
#define ixf1110_mRX_LOS1           (0x1 << ixf1110_sRX_LOS1)    
#define ixf1110_vRX_LOS1           (0x1 << ixf1110_sRX_LOS1)    

#define ixf1110_sRX_LOS2           22
#define ixf1110_mRX_LOS2           (0x1 << ixf1110_sRX_LOS2)    
#define ixf1110_vRX_LOS2           (0x1 << ixf1110_sRX_LOS2)    

#define ixf1110_sRX_LOS3           23
#define ixf1110_mRX_LOS3           (0x1 << ixf1110_sRX_LOS3)    
#define ixf1110_vRX_LOS3           (0x1 << ixf1110_sRX_LOS3)    

#define ixf1110_sRX_LOS4           24
#define ixf1110_mRX_LOS4           (0x1 << ixf1110_sRX_LOS4)    
#define ixf1110_vRX_LOS4           (0x1 << ixf1110_sRX_LOS4)    

#define ixf1110_sRX_LOS5           25
#define ixf1110_mRX_LOS5           (0x1 << ixf1110_sRX_LOS5)    
#define ixf1110_vRX_LOS5           (0x1 << ixf1110_sRX_LOS5)    

#define ixf1110_sRX_LOS6           26
#define ixf1110_mRX_LOS6           (0x1 << ixf1110_sRX_LOS6)    
#define ixf1110_vRX_LOS6           (0x1 << ixf1110_sRX_LOS6)    

#define ixf1110_sRX_LOS7           27
#define ixf1110_mRX_LOS7           (0x1 << ixf1110_sRX_LOS7)    
#define ixf1110_vRX_LOS7           (0x1 << ixf1110_sRX_LOS7)    

#define ixf1110_sRX_LOS8           28
#define ixf1110_mRX_LOS8           (0x1 << ixf1110_sRX_LOS8)    
#define ixf1110_vRX_LOS8           (0x1 << ixf1110_sRX_LOS8)    

#define ixf1110_sRX_LOS9           29
#define ixf1110_mRX_LOS9           (0x1 << ixf1110_sRX_LOS9)    
#define ixf1110_vRX_LOS9           (0x1 << ixf1110_sRX_LOS9)    

/************GBIC Control Register*/

/*Offset/Default definition for register.*/
#define ixf1110_GBIC_CNTL_OFFSET       ixf1110_GBIC_REG(0x0001)  
#define ixf1110_GBIC_CNTL_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sTX_DIS0           0   
#define ixf1110_mTX_DIS0          (0x1 << ixf1110_sTX_DIS0)    
#define ixf1110_vTX_DIS0          (0x1 << ixf1110_sTX_DIS0)    

#define ixf1110_sTX_DIS1           1   
#define ixf1110_mTX_DIS1          (0x1 << ixf1110_sTX_DIS1)    
#define ixf1110_vTX_DIS1          (0x1 << ixf1110_sTX_DIS1)    

#define ixf1110_sTX_DIS2           2   
#define ixf1110_mTX_DIS2          (0x1 << ixf1110_sTX_DIS2)    
#define ixf1110_vTX_DIS2          (0x1 << ixf1110_sTX_DIS2)    

#define ixf1110_sTX_DIS3           3   
#define ixf1110_mTX_DIS3          (0x1 << ixf1110_sTX_DIS3)    
#define ixf1110_vTX_DIS3          (0x1 << ixf1110_sTX_DIS3)    

#define ixf1110_sTX_DIS4           4   
#define ixf1110_mTX_DIS4          (0x1 << ixf1110_sTX_DIS4)    
#define ixf1110_vTX_DIS4          (0x1 << ixf1110_sTX_DIS4)    

#define ixf1110_sTX_DIS5           5   
#define ixf1110_mTX_DIS5          (0x1 << ixf1110_sTX_DIS5)    
#define ixf1110_vTX_DIS5          (0x1 << ixf1110_sTX_DIS5)    

#define ixf1110_sTX_DIS6           6   
#define ixf1110_mTX_DIS6          (0x1 << ixf1110_sTX_DIS6)    
#define ixf1110_vTX_DIS6          (0x1 << ixf1110_sTX_DIS6)    

#define ixf1110_sTX_DIS7           7   
#define ixf1110_mTX_DIS7          (0x1 << ixf1110_sTX_DIS7)    
#define ixf1110_vTX_DIS7          (0x1 << ixf1110_sTX_DIS7)    

#define ixf1110_sTX_DIS8           8   
#define ixf1110_mTX_DIS8          (0x1 << ixf1110_sTX_DIS8)    
#define ixf1110_vTX_DIS8          (0x1 << ixf1110_sTX_DIS8)    

#define ixf1110_sTX_DIS9           9   
#define ixf1110_mTX_DIS9          (0x1 << ixf1110_sTX_DIS9)    
#define ixf1110_vTX_DIS9          (0x1 << ixf1110_sTX_DIS9)    

#define ixf1110_sMOD_DEF_EN       10
#define ixf1110_mMOD_DEF_EN       (0x1 << ixf1110_sMOD_DEF_EN)    
#define ixf1110_vMOD_DEF_EN       (0x1 << ixf1110_sMOD_DEF_EN)    

#define ixf1110_sTX_FLT_EN        11
#define ixf1110_mTX_FLT_EN       (0x1 << ixf1110_sTX_FLT_EN)    
#define ixf1110_vTX_FLT_EN       (0x1 << ixf1110_sTX_FLT_EN)    

#define ixf1110_sRX_LOS_EN        12
#define ixf1110_mRX_LOS_EN       (0x1 << ixf1110_sRX_LOS_EN)    
#define ixf1110_vRX_LOS_EN       (0x1 << ixf1110_sRX_LOS_EN)    

/************I2C Control and Data Register*/

/*Offset/Default definition for register.*/
#define ixf1110_GBIC_I2C_OFFSET       ixf1110_GBIC_REG(0x0002)  
#define ixf1110_GBIC_I2C_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */



#endif /* ifndef __ixf1110_GBIC_B_H__ */
