/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/05/04 2:59p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_gbic_d.h $
 *   WORKFILE:       $Workfile: ixf1110_gbic_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: 
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_gbic_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 4     9/22/03 4:06p Rnballar
 * 
 * 3     9/17/03 3:46p Rnballar
 * 
 * 2     9/16/03 10:20a Rnballar
 * 
 * 1     9/15/03 10:50a Rnballar
 * Created GBIC Register structs
 * 
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF1110_GBIC_D_H__
#define __IXF1110_GBIC_D_H__

#include "ixf_bitfield_macros.h"



/*I2C Control Register Ports 9-0 Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_14(
				uint uiRegAddr 			:11,
				uint uiDeviceID			:4, 		
				uint uiReadWrite		:1, 		  
				uint uiPortAddrSel 		:4, 	   
				uint uiReadValid 		:1,	
				uint 					:1,  
				uint uiWriteComplete 	:1,
				uint 					:1,
				uint uiI2CStart		 	:1,
				uint uiI2CEnable		:1,
				uint uiNo_ack_err 		:1,
				uint uiWP_Err			:1,
				uint uiPortAddrErr		:1,
				uint					:3
		);
	} tCnfg;

} ixf1110_I2C_Control_t;


/*I2C Data Register Ports 9-0 Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_4(
				uint uiRead_Data	:8,
				uint 				:8, 		
				uint uiWrite_Data	:8, 		  
				uint				:8
		);
	} tCnfg;

} ixf1110_I2C_Data_t;



/*GBIC Configuration Struct*/
typedef struct {

	ixf1110_I2C_Control_t		I2CControl;
	ixf1110_I2C_Data_t			I2CData;

} ixf1110_GbicCfg_t;


#endif /* __IXF1110_GBIC_D_H__ */

