/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_global_b.h $
*   WORKFILE:       $Workfile: ixf1110_global_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API 
* 
* Purpose: This file contains register and bit defines for the GLOBAL  
*          Configuration registers in the ixf1110.
*
* Notes:
*
*   
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_global_b.h $ 
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 7     10/10/03 3:03p Tepulkow
 * removed the BASE address and REG_SHIFT macros 
 * 
 * 6     9/26/03 2:54p Rnballar
 * added reset functionailty
 * 
 * 5     9/26/03 9:57a Rnballar
 * added get/set cfg
 * 
 * 4     9/24/03 11:47a Tepulkow
 * Divided board ID offset by four
 * 
 * 3     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 2     9/08/03 11:23a Tepulkow
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 
* --------------------------------------------------------------------------
*/ 

#ifndef __ixf1110_GLOBAL_B_H__
#define __ixf1110_GLOBAL_B_H__



#define ixf1110_GLB_REG(offset) ((ixf1110_GLOBAL_BASE + offset) << ixf1110_REG_SHIFT)

/************PORT_ENABLE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_PORT_EN_OFFSET       ixf1110_GLB_REG(0x0000)  
#define ixf1110_PORT_EN_DFLT         0x3FF

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sPORT0_EN	           0    
#define ixf1110_mPORT0_EN	           (0x1 << ixf1110_sPORT0_EN)    
#define ixf1110_vPORT0_EN	           (0x1 << ixf1110_sPORT0_EN)    

#define ixf1110_sPORT1_EN	           1    
#define ixf1110_mPORT1_EN	           (0x1 << ixf1110_sPORT1_EN)    
#define ixf1110_vPORT1_EN	           (0x1 << ixf1110_sPORT1_EN)    

#define ixf1110_sPORT2_EN	           2    
#define ixf1110_mPORT2_EN	           (0x1 << ixf1110_sPORT2_EN)    
#define ixf1110_vPORT2_EN	           (0x1 << ixf1110_sPORT2_EN)    

#define ixf1110_sPORT3_EN	           3    
#define ixf1110_mPORT3_EN	           (0x1 << ixf1110_sPORT3_EN)    
#define ixf1110_vPORT3_EN	           (0x1 << ixf1110_sPORT3_EN)    

#define ixf1110_sPORT4_EN	           4    
#define ixf1110_mPORT4_EN	           (0x1 << ixf1110_sPORT4_EN)    
#define ixf1110_vPORT4_EN	           (0x1 << ixf1110_sPORT4_EN)    

#define ixf1110_sPORT5_EN	           5    
#define ixf1110_mPORT5_EN	           (0x1 << ixf1110_sPORT5_EN)    
#define ixf1110_vPORT5_EN	           (0x1 << ixf1110_sPORT5_EN)    

#define ixf1110_sPORT6_EN	           6    
#define ixf1110_mPORT6_EN	           (0x1 << ixf1110_sPORT6_EN)    
#define ixf1110_vPORT6_EN	           (0x1 << ixf1110_sPORT6_EN)    

#define ixf1110_sPORT7_EN	           7    
#define ixf1110_mPORT7_EN	           (0x1 << ixf1110_sPORT7_EN)    
#define ixf1110_vPORT7_EN	           (0x1 << ixf1110_sPORT7_EN)    

#define ixf1110_sPORT8_EN	           8    
#define ixf1110_mPORT8_EN	           (0x1 << ixf1110_sPORT8_EN)    
#define ixf1110_vPORT8_EN	           (0x1 << ixf1110_sPORT8_EN)    

#define ixf1110_sPORT9_EN	           9    
#define ixf1110_mPORT9_EN	           (0x1 << ixf1110_sPORT9_EN)    
#define ixf1110_vPORT9_EN	           (0x1 << ixf1110_sPORT9_EN)    

/************LINKLED_ENABLE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_LINKLED_EN_OFFSET       ixf1110_GLB_REG(0x0002)  
#define ixf1110_LINKLED_EN_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sLINKLED0_EN	           0    
#define ixf1110_mLINKLED0_EN	           (0x1 << ixf1110_sLINKLED0_EN)    
#define ixf1110_vLINKLED0_EN	           (0x1 << ixf1110_sLINKLED0_EN)    

#define ixf1110_sLINKLED1_EN	           1    
#define ixf1110_mLINKLED1_EN	           (0x1 << ixf1110_sLINKLED1_EN)    
#define ixf1110_vLINKLED1_EN	           (0x1 << ixf1110_sLINKLED1_EN)    

#define ixf1110_sLINKLED2_EN	           2    
#define ixf1110_mLINKLED2_EN	           (0x1 << ixf1110_sLINKLED2_EN)    
#define ixf1110_vLINKLED2_EN	           (0x1 << ixf1110_sLINKLED2_EN)    

#define ixf1110_sLINKLED3_EN	           3    
#define ixf1110_mLINKLED3_EN	           (0x1 << ixf1110_sLINKLED3_EN)    
#define ixf1110_vLINKLED3_EN	           (0x1 << ixf1110_sLINKLED3_EN)    

#define ixf1110_sLINKLED4_EN	           4    
#define ixf1110_mLINKLED4_EN	           (0x1 << ixf1110_sLINKLED4_EN)    
#define ixf1110_vLINKLED4_EN	           (0x1 << ixf1110_sLINKLED4_EN)    

#define ixf1110_sLINKLED5_EN	           5    
#define ixf1110_mLINKLED5_EN	           (0x1 << ixf1110_sLINKLED5_EN)    
#define ixf1110_vLINKLED5_EN	           (0x1 << ixf1110_sLINKLED5_EN)    

#define ixf1110_sLINKLED6_EN	           6    
#define ixf1110_mLINKLED6_EN	           (0x1 << ixf1110_sLINKLED6_EN)    
#define ixf1110_vLINKLED6_EN	           (0x1 << ixf1110_sLINKLED6_EN)    

#define ixf1110_sLINKLED7_EN	           7    
#define ixf1110_mLINKLED7_EN	           (0x1 << ixf1110_sLINKLED7_EN)    
#define ixf1110_vLINKLED7_EN	           (0x1 << ixf1110_sLINKLED7_EN)    

#define ixf1110_sLINKLED8_EN	           8    
#define ixf1110_mLINKLED8_EN	           (0x1 << ixf1110_sLINKLED8_EN)    
#define ixf1110_vLINKLED8_EN	           (0x1 << ixf1110_sLINKLED8_EN)    

#define ixf1110_sLINKLED9_EN	           9    
#define ixf1110_mLINKLED9_EN	           (0x1 << ixf1110_sLINKLED9_EN)    
#define ixf1110_vLINKLED9_EN	           (0x1 << ixf1110_sLINKLED9_EN)


/************Core Clock Soft Rest*/
#define ixf1110_CORCLKSFTRESET_OFFSET	ixf1110_GLB_REG(0x0004)
#define ixf1110_sCORCLKSFTRST           0    
#define ixf1110_mCORCLKSFTRST	        (0x1 << ixf1110_sCORCLKSFTRST)    

/************MACRESET Register*/

/*Offset/Default definition for register.*/
#define ixf1110_MACRESET_OFFSET       ixf1110_GLB_REG(0x0005) 
#define ixf1110_mMACRESET_ALL		0x3FF 
#define ixf1110_MACRESET_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sMACRESET0	           0    
#define ixf1110_mMACRESET0	           (0x1 << ixf1110_sMACRESET0)    
#define ixf1110_vMACRESET0	           (0x1 << ixf1110_sMACRESET0)    

#define ixf1110_sMACRESET1	           1    
#define ixf1110_mMACRESET1	           (0x1 << ixf1110_sMACRESET1)    
#define ixf1110_vMACRESET1	           (0x1 << ixf1110_sMACRESET1)    

#define ixf1110_sMACRESET2	           2    
#define ixf1110_mMACRESET2	           (0x1 << ixf1110_sMACRESET2)    
#define ixf1110_vMACRESET2	           (0x1 << ixf1110_sMACRESET2)    

#define ixf1110_sMACRESET3	           3    
#define ixf1110_mMACRESET3	           (0x1 << ixf1110_sMACRESET3)    
#define ixf1110_vMACRESET3	           (0x1 << ixf1110_sMACRESET3)    

#define ixf1110_sMACRESET4	           4    
#define ixf1110_mMACRESET4	           (0x1 << ixf1110_sMACRESET4)    
#define ixf1110_vMACRESET4	           (0x1 << ixf1110_sMACRESET4)    

#define ixf1110_sMACRESET5	           5    
#define ixf1110_mMACRESET5	           (0x1 << ixf1110_sMACRESET5)    
#define ixf1110_vMACRESET5	           (0x1 << ixf1110_sMACRESET5)    

#define ixf1110_sMACRESET6	           6    
#define ixf1110_mMACRESET6	           (0x1 << ixf1110_sMACRESET6)    
#define ixf1110_vMACRESET6	           (0x1 << ixf1110_sMACRESET6)    

#define ixf1110_sMACRESET7	           7    
#define ixf1110_mMACRESET7	           (0x1 << ixf1110_sMACRESET7)    
#define ixf1110_vMACRESET7	           (0x1 << ixf1110_sMACRESET7)    

#define ixf1110_sMACRESET8	           8    
#define ixf1110_mMACRESET8	           (0x1 << ixf1110_sMACRESET8)    
#define ixf1110_vMACRESET8	           (0x1 << ixf1110_sMACRESET8)    

#define ixf1110_sMACRESET9	           9    
#define ixf1110_mMACRESET9	           (0x1 << ixf1110_sMACRESET9)    
#define ixf1110_vMACRESET9	           (0x1 << ixf1110_sMACRESET9)    


/************CPU_XFACE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_CPU_XFACE_OFFSET       ixf1110_GLB_REG(0x0008)  
#define ixf1110_CPU_XFACE_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */

#define ixf1110_sENDIAN	               0
#define ixf1110_mENDIAN                (0x1 << ixf1110_sENDIAN)    
#define ixf1110_vLENDIAN               (0x0 << ixf1110_sENDIAN)    
#define ixf1110_vBENDIAN               (0x1 << ixf1110_sENDIAN)    

/************LED_CONTROL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_LED_CONTROL_OFFSET       ixf1110_GLB_REG(0x0009)  
#define ixf1110_LED_CONTROL_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */

#define ixf1110_sLED_CTL		       0
#define ixf1110_mLED_CTL               (0x1 << ixf1110_sCTL)
    
#define ixf1110_vLED_MODE0             (0x0 << ixf1110_sCTL)    
#define ixf1110_vLED_MODE1             (0x1 << ixf1110_sCTL)    


#define ixf1110_sLED_EN		           1
#define ixf1110_mLED_EN                (0x1 << ixf1110_sLED_EN)    

#define ixf1110_vLED_DIS               (0x0 << ixf1110_sLED_EN)    
#define ixf1110_vLED_EN                (0x1 << ixf1110_sLED_EN)    


/************LED_FLASH_RATE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_LED_FLASH_RATE_OFFSET       ixf1110_GLB_REG(0x000A)
#define ixf1110_LED_FLASH_RATE_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */

#define ixf1110_sLED_FLASH_RATE        0
#define ixf1110_mLED_FLASH_RATE        (0x3 << ixf1110_sCTL)
    
#define ixf1110_vLED_FLASH_100         (0x0 << ixf1110_sCTL)    
#define ixf1110_vLED_FLASH_250         (0x1 << ixf1110_sCTL)    
#define ixf1110_vLED_FLASH_500         (0x2 << ixf1110_sCTL)    
#define ixf1110_vLED_FLASH_RSV         (0x3 << ixf1110_sCTL)    


/************LED_FAULT_DISABLE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_LED_FAULT_DIS_OFFSET       ixf1110_GLB_REG(0x000B)  
#define ixf1110_LED_FAULT_DIS_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */

#define ixf1110_sLED_FAULT_DIS_0               0    
#define ixf1110_mLED_FAULT_DIS_0	           (0x1 << ixf1110_sLED_FAULT_DIS_0)    
#define ixf1110_vLED_FAULT_DIS_0	           (0x1 << ixf1110_sLED_FAULT_DIS_0)    

#define ixf1110_sLED_FAULT_DIS_1	           1    
#define ixf1110_mLED_FAULT_DIS_1	           (0x1 << ixf1110_sLED_FAULT_DIS_1)    
#define ixf1110_vLED_FAULT_DIS_1	           (0x1 << ixf1110_sLED_FAULT_DIS_1)    

#define ixf1110_sLED_FAULT_DIS_2	           2    
#define ixf1110_mLED_FAULT_DIS_2	           (0x1 << ixf1110_sLED_FAULT_DIS_2)    
#define ixf1110_vLED_FAULT_DIS_2	           (0x1 << ixf1110_sLED_FAULT_DIS_2)    

#define ixf1110_sLED_FAULT_DIS_3	           3    
#define ixf1110_mLED_FAULT_DIS_3	           (0x1 << ixf1110_sLED_FAULT_DIS_3)    
#define ixf1110_vLED_FAULT_DIS_3	           (0x1 << ixf1110_sLED_FAULT_DIS_3)    

#define ixf1110_sLED_FAULT_DIS_4	           4    
#define ixf1110_mLED_FAULT_DIS_4	           (0x1 << ixf1110_sLED_FAULT_DIS_4)    
#define ixf1110_vLED_FAULT_DIS_4	           (0x1 << ixf1110_sLED_FAULT_DIS_4)    

#define ixf1110_sLED_FAULT_DIS_5	           5    
#define ixf1110_mLED_FAULT_DIS_5	           (0x1 << ixf1110_sLED_FAULT_DIS_5)    
#define ixf1110_vLED_FAULT_DIS_5	           (0x1 << ixf1110_sLED_FAULT_DIS_5)    

#define ixf1110_sLED_FAULT_DIS_6	           6    
#define ixf1110_mLED_FAULT_DIS_6	           (0x1 << ixf1110_sLED_FAULT_DIS_6)    
#define ixf1110_vLED_FAULT_DIS_6	           (0x1 << ixf1110_sLED_FAULT_DIS_6)    

#define ixf1110_sLED_FAULT_DIS_7	           7    
#define ixf1110_mLED_FAULT_DIS_7	           (0x1 << ixf1110_sLED_FAULT_DIS_7)    
#define ixf1110_vLED_FAULT_DIS_7	           (0x1 << ixf1110_sLED_FAULT_DIS_7)    

#define ixf1110_sLED_FAULT_DIS_8	           8    
#define ixf1110_mLED_FAULT_DIS_8	           (0x1 << ixf1110_sLED_FAULT_DIS_8)    
#define ixf1110_vLED_FAULT_DIS_8	           (0x1 << ixf1110_sLED_FAULT_DIS_8)    

#define ixf1110_sLED_FAULT_DIS_9	           9    
#define ixf1110_mLED_FAULT_DIS_9	           (0x1 << ixf1110_sLED_FAULT_DIS_9)    
#define ixf1110_vLED_FAULT_DIS_9	           (0x1 << ixf1110_sLED_FAULT_DIS_9)


/*********** GLB_CHIPID Register*/

/*Offset/Default definition for register.*/
#define ixf1110_GLB_CHIPID_OFFSET      (0x00100000/4)
#define ixf1110_GLB_CHIPID_DFLT        0x00002810

/*  ------- Bit, shift and mask defines.  ------ */

/*The IXF18101 identification number in hexadecimal format.*/
#define ixf1110_sCHIP_ID               0
#define ixf1110_mCHIP_ID               (0xFFFFF << ixf1110_sCHIP_ID)

/*The IXF18101 version number in hexadecimal format.*/
#define ixf1110_sCHIP_VER       20
#define ixf1110_mCHIP_VER       (0xFFF << ixf1110_sCHIP_VER)


#endif /* ifndef __ixf1110_GLOBAL_B_H__ */
