/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_global_d.h $
*   WORKFILE:       $Workfile: ixf1110_global_d.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_global_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 7     9/26/03 9:57a Rnballar
 * added get/set cfg
 * 
 * 6     9/17/03 3:50p Rnballar
 * 
 * 5     9/16/03 10:20a Rnballar
 * 
 * 4     9/15/03 2:17p Rnballar
 * port to ixf1110
 * 
 * 3     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 2     9/08/03 11:23a Tepulkow
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* --------------------------------------------------------------------------
*/

#ifndef IXF1110_GLOBAL_D_H
#define IXF1110_GLOBAL_D_H

#include "ixf_bitfield_macros.h"



/*Port Enable Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiPort0En	:1,
				uint uiPort1En	:1, 		
				uint uiPort2En	:1, 		  
				uint uiPort3En	:1, 	   
				uint uiPort4En	:1,	
				uint uiPort5En	:1,  
				uint uiPort6En	:1,
				uint uiPort7En	:1,
				uint uiPort8En	:1,
				uint uiPort9En	:1,
				uint			:22
		);
	} tCnfg;

} ixf1110_Glb_PortEn_t;

/*Link LED Enable Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiLinkLEDEn_0	:1,
				uint uiLinkLEDEn_1	:1, 		
				uint uiLinkLEDEn_2	:1, 		  
				uint uiLinkLEDEn_3	:1, 	   
				uint uiLinkLEDEn_4	:1,	
				uint uiLinkLEDEn_5	:1,  
				uint uiLinkLEDEn_6	:1,
				uint uiLinkLEDEn_7	:1,
				uint uiLinkLEDEn_8	:1,
				uint uiLinkLEDEn_9	:1,
				uint				:22
		);
	} tCnfg;

} ixf1110_Glb_LinkLEDEn_t;

/*Core Clock Soft Reset Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiReset	:1,
				uint			:31
		);
	} tCnfg;

} ixf1110_Glb_CoreClkSftReset_t;

/*MAC Soft Reset Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiMACSoftReset_0	:1,
				uint uiMACSoftReset_1	:1, 		
				uint uiMACSoftReset_2	:1, 		  
				uint uiMACSoftReset_3	:1, 	   
				uint uiMACSoftReset_4	:1,	
				uint uiMACSoftReset_5	:1,  
				uint uiMACSoftReset_6	:1,
				uint uiMACSoftReset_7	:1,
				uint uiMACSoftReset_8	:1,
				uint uiMACSoftReset_9	:1,
				uint					:22
		);
	} tCnfg;

} ixf1110_Glb_MACSoftReset_t;



/*CPU Interface Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiEndian	:1,
				uint			:31
		);
	} tCnfg;

} ixf1110_Glb_CPUInterface_t;


/*LED Control Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_3(
				uint uiLed_Sel_Mode	:1,
				uint Led_Enable		:1,
				uint				:30
		);
	} tCnfg;

} ixf1110_Glb_LEDControl_t;


/*LED Flash Rate Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiLedFlashRate_Mode	:3,
				uint						:29
		);
	} tCnfg;

} ixf1110_Glb_LEDFlashRate_t;


/*LED Fault Disable Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiLEDFaultDis_0	:1,
				uint uiLEDFaultDis_1	:1, 		
				uint uiLEDFaultDis_2	:1, 		  
				uint uiLEDFaultDis_3	:1, 	   
				uint uiLEDFaultDis_4	:1,	
				uint uiLEDFaultDis_5	:1,  
				uint uiLEDFaultDis_6	:1,
				uint uiLEDFaultDis_7	:1,
				uint uiLEDFaultDis_8	:1,
				uint uiLEDFaultDis_9	:1,
				uint					:22
		);
	} tCnfg;

} ixf1110_Glb_LEDFaultDisable_t;



/*JTAG ID Revision Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_5(
				uint 						:1,
				uint uiJEDEC_ID				:7,
				uint uiJEDEC_Cont			:4,
				uint uiPart_ID				:16,
				uint uiVersion				:4
		);
	} tCnfg;

} ixf1110_Glb_JTAG_ID_Rev_t;




/*Global Status and Configuration Struct*/
typedef struct {

	ixf1110_Glb_PortEn_t			Glb_PortEn;
	ixf1110_Glb_LinkLEDEn_t			Glb_LinkLEDEn;
	ixf1110_Glb_CoreClkSftReset_t	Glb_CorClkSftRst;
	ixf1110_Glb_MACSoftReset_t		Glb_MACSftRst;
	ixf1110_Glb_CPUInterface_t		Glb_CPUXFace;
	ixf1110_Glb_LEDControl_t		Glb_LEDControl;
	ixf1110_Glb_LEDFlashRate_t		Glb_LEDFlashRate;
	ixf1110_Glb_LEDFaultDisable_t	Glb_LEDFaultDis;
	ixf1110_Glb_JTAG_ID_Rev_t		Glb_JTAG_ID_Rev;

} ixf1110_GlbStatusCfg_t;




#endif   /* __IXF1110_GLOBAL_D_H__ */
 
