/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_rx_b.h $
*   WORKFILE:       $Workfile: ixf1110_rx_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API 
* 
* Purpose: This file contains register and bit defines for the RX Block  
*          Configuration registers in the ixf1110.
*
* Notes:
*
*   
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_rx_b.h $ 
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 4     10/10/03 3:03p Tepulkow
 * removed the BASE address and REG_SHIFT macros 
 * 
 * 3     9/26/03 2:55p Rnballar
 * added reset functionailty
 * 
 * 2     9/23/03 1:26p Rnballar
 * added functionality set & get config
 * 
 * 1     9/09/03 4:52p Tepulkow
 * Created these header files for the IXF1110 MAC device blocks new to the
 * IXF API framework
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 
* --------------------------------------------------------------------------
*/ 

#ifndef __ixf1110_RX_B_H__
#define __ixf1110_RX_B_H__



#define ixf1110_RX_REG(offset) ((ixf1110_RX_BASE + offset) << ixf1110_REG_SHIFT)

/************RX FIFO High Water Mark Register*/
#define ixf1110_RXHIWATER_DFLT         0x0740

/*Offset/Default definition for register.*/
#define ixf1110_RXHIWATER0_OFFSET       ixf1110_RX_REG(0x0000)  
#define ixf1110_RXHIWATER0_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER1_OFFSET       ixf1110_RX_REG(0x0001)  
#define ixf1110_RXHIWATER1_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER2_OFFSET       ixf1110_RX_REG(0x0002)  
#define ixf1110_RXHIWATER2_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER3_OFFSET       ixf1110_RX_REG(0x0003)  
#define ixf1110_RXHIWATER3_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER4_OFFSET       ixf1110_RX_REG(0x0004)  
#define ixf1110_RXHIWATER4_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER5_OFFSET       ixf1110_RX_REG(0x0005)  
#define ixf1110_RXHIWATER5_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER6_OFFSET       ixf1110_RX_REG(0x0006)  
#define ixf1110_RXHIWATER6_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER7_OFFSET       ixf1110_RX_REG(0x0007)  
#define ixf1110_RXHIWATER7_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER8_OFFSET       ixf1110_RX_REG(0x0008)  
#define ixf1110_RXHIWATER8_DFLT         ixf1110_RXHIWATER_DFLT

#define ixf1110_RXHIWATER9_OFFSET       ixf1110_RX_REG(0x0009)  
#define ixf1110_RXHIWATER9_DFLT         ixf1110_RXHIWATER_DFLT

/************RX FIFO Low Water Mark Register*/
#define ixf1110_RXLOWATER_DFLT         0x0730

/*Offset/Default definition for register.*/
#define ixf1110_RXLOWATER0_OFFSET       ixf1110_RX_REG(0x000A)  
#define ixf1110_RXLOWATER0_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER1_OFFSET       ixf1110_RX_REG(0x000B)
#define ixf1110_RXLOWATER1_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER2_OFFSET       ixf1110_RX_REG(0x000C)  
#define ixf1110_RXLOWATER2_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER3_OFFSET       ixf1110_RX_REG(0x000D)  
#define ixf1110_RXLOWATER3_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER4_OFFSET       ixf1110_RX_REG(0x000E)  
#define ixf1110_RXLOWATER4_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER5_OFFSET       ixf1110_RX_REG(0x000F)  
#define ixf1110_RXLOWATER5_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER6_OFFSET       ixf1110_RX_REG(0x0010)  
#define ixf1110_RXLOWATER6_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER7_OFFSET       ixf1110_RX_REG(0x0011)  
#define ixf1110_RXLOWATER7_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER8_OFFSET       ixf1110_RX_REG(0x0012)  
#define ixf1110_RXLOWATER8_DFLT         ixf1110_RXLOWATER_DFLT

#define ixf1110_RXLOWATER9_OFFSET       ixf1110_RX_REG(0x0013)  
#define ixf1110_RXLOWATER9_DFLT         ixf1110_RXLOWATER_DFLT

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sSTA_ADDR_LO	           0   
#define ixf1110_mSTA_ADDR_LO	           (0xFFFFFFFF << ixf1110_sSTA_ADDR_LO) 


/* RX FIFO Number of Frames Removed Ports 0 to 9 */
#define ixf1110_RXNUMFRMREMV0_OFFSET		ixf1110_RX_REG(0x0014)
#define ixf1110_RXNUMFRMREMV1_OFFSET		ixf1110_RX_REG(0x0015)
#define ixf1110_RXNUMFRMREMV2_OFFSET		ixf1110_RX_REG(0x0016)
#define ixf1110_RXNUMFRMREMV3_OFFSET		ixf1110_RX_REG(0x0017)
#define ixf1110_RXNUMFRMREMV4_OFFSET		ixf1110_RX_REG(0x0018)
#define ixf1110_RXNUMFRMREMV5_OFFSET		ixf1110_RX_REG(0x0019)
#define ixf1110_RXNUMFRMREMV6_OFFSET		ixf1110_RX_REG(0x001A)
#define ixf1110_RXNUMFRMREMV7_OFFSET		ixf1110_RX_REG(0x001B)
#define ixf1110_RXNUMFRMREMV8_OFFSET		ixf1110_RX_REG(0x001C)
#define ixf1110_RXNUMFRMREMV9_OFFSET		ixf1110_RX_REG(0x001D)

/*RX FIFO Port Reset Register (Addr: 0x59E)*/
#define ixf1110_RXFIFOPORTRESET_OFFSET		ixf1110_RX_REG(0x001E)
#define ixf1110_mRXFIFOPORTRESET_ALL		0x3FF


/* RX FIFO Errored Frame Drop Enable Register*/
#define ixf1110_RXERRFRMDROPEN_OFFSET 		ixf1110_RX_REG(0x001F)
/* RX FIFO Overflow Event Register*/
#define ixf1110_RXOVRFLWEVENT_OFFSET		ixf1110_RX_REG(0x0020)


   


#endif /* ifndef __ixf1110_RX_B_H__ */
