/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_rx_d.h $
*   WORKFILE:       $Workfile: ixf1110_rx_d.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_rx_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 6     10/01/03 12:13p Rnballar
 * added status/counter structs
 * 
 * 5     9/18/03 7:30a Rnballar
 * 
 * 4     9/17/03 3:46p Rnballar
 * 
 * 3     9/16/03 10:20a Rnballar
 * 
 * 2     9/16/03 8:24a Rnballar
 * 
 * 1     9/15/03 3:48p Rnballar
 * Created register structs for ixf1110
* 
* 
* 
* --------------------------------------------------------------------------
*/

#ifndef IXF1110_RX_D_H
#define IXF1110_RX_D_H
#include "ixf_bitfield_macros.h"

/*RX FIFO High Watermark Ports 0 to 9 Registers*/
typedef struct {

  ulong ulPort_0;
  ulong ulPort_1;
  ulong ulPort_2;
  ulong ulPort_3;
  ulong ulPort_4;
  ulong ulPort_5;
  ulong ulPort_6;
  ulong ulPort_7;
  ulong ulPort_8;
  ulong ulPort_9;

} ixf1110_RxFIFO_HiWaterMrk_t; 


/*RX FIFO Low Watermark Ports 0 to 9 Registers*/
typedef struct {

  ulong ulPort_0;
  ulong ulPort_1;
  ulong ulPort_2;
  ulong ulPort_3;
  ulong ulPort_4;
  ulong ulPort_5;
  ulong ulPort_6;
  ulong ulPort_7;
  ulong ulPort_8;
  ulong ulPort_9;

} ixf1110_RxFIFO_LowWaterMrk_t;

/*RX FIFO Number of Frames Removed Ports 0 to 9 Registers*/
typedef struct {

  ulong ulPort_0;
  ulong ulPort_1;
  ulong ulPort_2;
  ulong ulPort_3;
  ulong ulPort_4;
  ulong ulPort_5;
  ulong ulPort_6;
  ulong ulPort_7;
  ulong ulPort_8;
  ulong ulPort_9;

} ixf1110_RxFIFO_NumFrmRem_t;

/*RX FIFO Errored Frame Drop Enable Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiPort0En	:1,
				uint uiPort1En	:1, 		
				uint uiPort2En	:1, 		  
				uint uiPort3En	:1, 	   
				uint uiPort4En	:1,	
				uint uiPort5En	:1,  
				uint uiPort6En	:1,
				uint uiPort7En	:1,
				uint uiPort8En	:1,
				uint uiPort9En	:1,
				uint			:22
		);
	} tCnfg;

} ixf1110_RxFIFO_ErrFrmDropEn_t;

/*RX FIFO Overflow Event Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiPort_0	:1,
				uint uiPort_1	:1, 		
				uint uiPort_2	:1, 		  
				uint uiPort_3	:1, 	   
				uint uiPort_4	:1,	
				uint uiPort_5	:1,  
				uint uiPort_6	:1,
				uint uiPort_7	:1,
				uint uiPort_8	:1,
				uint uiPort_9	:1,
				uint			:22
		);
	} tCnfg;

} ixf1110_RxFIFO_OvrFlwEvent_t;

/*Global RX Block Config Struct*/
typedef struct {

	ixf1110_RxFIFO_HiWaterMrk_t 	RxHiWaterMrk;
	ixf1110_RxFIFO_LowWaterMrk_t	RxLowWaterMrk;
	ixf1110_RxFIFO_ErrFrmDropEn_t	RxErrFrmDrpEn;

} ixf1110_RxCfg_t;

/*Global RX Block Status Struct*/
typedef struct {
		ixf1110_RxFIFO_OvrFlwEvent_t	RxOvrFlwEvent;
} ixf1110_RxFIFO_Status_t;

/*Global RX Block counter struct*/
typedef struct {
	ixf1110_RxFIFO_NumFrmRem_t		RxNumFrmRem;
} ixf1110_RxFIFO_Counters_t;


#endif   /* __IXF1110_RX_D_H__ */
 
