/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_serdes_b.h $
*   WORKFILE:       $Workfile: ixf1110_serdes_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API 
* 
* Purpose: This file contains register and bit defines for the SERDES  
*          Configuration registers in the ixf1110.
*
* Notes:
*
*   
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_serdes_b.h $ 
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 5     10/10/03 3:03p Tepulkow
 * removed the BASE address and REG_SHIFT macros 
 * 
 * 4     10/07/03 2:04p Tepulkow
 * General cleanup for code review
 * 
 * 3     9/12/03 11:43a Tepulkow
 * 
 * 2     9/11/03 1:28p Tepulkow
 * 
 * 1     9/09/03 4:52p Tepulkow
 * Created these header files for the IXF1110 MAC device blocks new to the
 * IXF API framework
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 
* --------------------------------------------------------------------------
*/ 

#ifndef __ixf1110_SERDES_B_H__
#define __ixf1110_SERDES_B_H__


#define ixf1110_SERDES_REG(offset) ((ixf1110_SERDES_BASE + offset) << ixf1110_REG_SHIFT)

/************Tx and RX AC/DC Coupling Selection Register*/

/*Offset/Default definition for register.*/
#define ixf1110_ACDC_CPL_OFFSET       ixf1110_SERDES_REG(0x0000)  
#define ixf1110_ACDC_CPL_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sTXCADA0	           0   
#define ixf1110_mTXCADA0	           (0x1 << ixf1110_sTXCADA0)    

#define ixf1110_sRXCADA0	           1   
#define ixf1110_mRXCADA0	           (0x1 << ixf1110_sRXCADA0)    

#define ixf1110_sTXCADA1	           2   
#define ixf1110_mTXCADA1	           (0x1 << ixf1110_sTXCADA1)    

#define ixf1110_sRXCADA1	           3   
#define ixf1110_mRXCADA1	           (0x1 << ixf1110_sRXCADA1)    

#define ixf1110_sTXCADA2	           4   
#define ixf1110_mTXCADA2	           (0x1 << ixf1110_sTXCADA2)    

#define ixf1110_sRXCADA2	           5   
#define ixf1110_mRXCADA2	           (0x1 << ixf1110_sRXCADA2)    

#define ixf1110_sTXCADA3	           6   
#define ixf1110_mTXCADA3	           (0x1 << ixf1110_sTXCADA3)    

#define ixf1110_sRXCADA3	           7   
#define ixf1110_mRXCADA3	           (0x1 << ixf1110_sRXCADA3)    

#define ixf1110_sTXCADA4	           8   
#define ixf1110_mTXCADA4	           (0x1 << ixf1110_sTXCADA4)    

#define ixf1110_sRXCADA4	           9   
#define ixf1110_mRXCADA4	           (0x1 << ixf1110_sRXCADA4)    

#define ixf1110_sTXCADA5	           10   
#define ixf1110_mTXCADA5	           (0x1 << ixf1110_sTXCADA5)    

#define ixf1110_sRXCADA5	           11   
#define ixf1110_mRXCADA5	           (0x1 << ixf1110_sRXCADA5)    

#define ixf1110_sTXCADA6	           12  
#define ixf1110_mTXCADA6	           (0x1 << ixf1110_sTXCADA6)    

#define ixf1110_sRXCADA6	           13  
#define ixf1110_mRXCADA6	           (0x1 << ixf1110_sRXCADA6)    

#define ixf1110_sTXCADA7	           14  
#define ixf1110_mTXCADA7	           (0x1 << ixf1110_sTXCADA7)    

#define ixf1110_sRXCADA7	           15  
#define ixf1110_mRXCADA7	           (0x1 << ixf1110_sRXCADA7)    

#define ixf1110_sTXCADA8	           16  
#define ixf1110_mTXCADA8	           (0x1 << ixf1110_sTXCADA8)    

#define ixf1110_sRXCADA8	           17  
#define ixf1110_mRXCADA8	           (0x1 << ixf1110_sRXCADA8)    

#define ixf1110_sTXCADA9	           18  
#define ixf1110_mTXCADA9	           (0x1 << ixf1110_sTXCADA9)    

#define ixf1110_sRXCADA9	           19  
#define ixf1110_mRXCADA9	           (0x1 << ixf1110_sRXCADA9)    

/************Tx and RX Power Down Selection Register*/

/*Offset/Default definition for register.*/
#define ixf1110_PWRDOWN_OFFSET       ixf1110_SERDES_REG(0x0007)  
#define ixf1110_PWRDOWN_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sRPWRDOWN	           0   
#define ixf1110_mRPWRDOWN	           (0x3FF << ixf1110_sRPWRDOWN)    

#define ixf1110_sRPWRDOWN0	           0    
#define ixf1110_mRPWRDOWN0	           (1 << ixf1110_sRPWRDOWN0)    
#define ixf1110_vRPWRDOWN0	           (1 << ixf1110_sRPWRDOWN0)    

#define ixf1110_sRPWRDOWN1	           1
#define ixf1110_mRPWRDOWN1	           (1 << ixf1110_sRPWRDOWN1)    
#define ixf1110_vRPWRDOWN1	           (1 << ixf1110_sRPWRDOWN1)    

#define ixf1110_sRPWRDOWN2	           2    
#define ixf1110_mRPWRDOWN2	           (1 << ixf1110_sRPWRDOWN2)    
#define ixf1110_vRPWRDOWN2	           (1 << ixf1110_sRPWRDOWN2)    

#define ixf1110_sRPWRDOWN3	           3    
#define ixf1110_mRPWRDOWN3	           (1 << ixf1110_sRPWRDOWN3)    
#define ixf1110_vRPWRDOWN3	           (1 << ixf1110_sRPWRDOWN3)    

#define ixf1110_sRPWRDOWN4	           4    
#define ixf1110_mRPWRDOWN4	           (1 << ixf1110_sRPWRDOWN4)    
#define ixf1110_vRPWRDOWN4	           (1 << ixf1110_sRPWRDOWN4)    

#define ixf1110_sRPWRDOWN5	           5    
#define ixf1110_mRPWRDOWN5	           (1 << ixf1110_sRPWRDOWN5)    
#define ixf1110_vRPWRDOWN5	           (1 << ixf1110_sRPWRDOWN5)    

#define ixf1110_sRPWRDOWN6	           6    
#define ixf1110_mRPWRDOWN6	           (1 << ixf1110_sRPWRDOWN6)    
#define ixf1110_vRPWRDOWN6	           (1 << ixf1110_sRPWRDOWN6)    

#define ixf1110_sRPWRDOWN7	           7    
#define ixf1110_mRPWRDOWN7	           (1 << ixf1110_sRPWRDOWN7)    
#define ixf1110_vRPWRDOWN7	           (1 << ixf1110_sRPWRDOWN7)    

#define ixf1110_sRPWRDOWN8	           8    
#define ixf1110_mRPWRDOWN8	           (1 << ixf1110_sRPWRDOWN8)    
#define ixf1110_vRPWRDOWN8	           (1 << ixf1110_sRPWRDOWN8)    

#define ixf1110_sRPWRDOWN9	           9    
#define ixf1110_mRPWRDOWN9	           (1 << ixf1110_sRPWRDOWN9)    
#define ixf1110_vRPWRDOWN9	           (1 << ixf1110_sRPWRDOWN9)    


#define ixf1110_sTPWRDOWN	           10   
#define ixf1110_mTPWRDOWN	           (0x3FF << ixf1110_sTXCADA0)    

#define ixf1110_sTPWRDOWN0	           10
#define ixf1110_mTPWRDOWN0	           (1 << ixf1110_sTPWRDOWN0)    
#define ixf1110_vTPWRDOWN0	           (1 << ixf1110_sTPWRDOWN0)    

#define ixf1110_sTPWRDOWN1	           11
#define ixf1110_mTPWRDOWN1	           (1 << ixf1110_sTPWRDOWN1)    
#define ixf1110_vTPWRDOWN1	           (1 << ixf1110_sTPWRDOWN1)    

#define ixf1110_sTPWRDOWN2	           12    
#define ixf1110_mTPWRDOWN2	           (1 << ixf1110_sTPWRDOWN2)    
#define ixf1110_vTWRDOWN2	           (1 << ixf1110_sTPWRDOWN2)    

#define ixf1110_sTPWRDOWN3	           13    
#define ixf1110_mTPWRDOWN3	           (1 << ixf1110_sTPWRDOWN3)    
#define ixf1110_vTPWRDOWN3	           (1 << ixf1110_sTPWRDOWN3)    

#define ixf1110_sTPWRDOWN4	           14    
#define ixf1110_mTPWRDOWN4	           (1 << ixf1110_sTPWRDOWN4)    
#define ixf1110_vTPWRDOWN4	           (1 << ixf1110_sTPWRDOWN4)    

#define ixf1110_sTPWRDOWN5	           15    
#define ixf1110_mTPWRDOWN5	           (1 << ixf1110_sTPWRDOWN5)    
#define ixf1110_vTPWRDOWN5	           (1 << ixf1110_sTPWRDOWN5)    

#define ixf1110_sTPWRDOWN6	           16    
#define ixf1110_mTPWRDOWN6	           (1 << ixf1110_sTPWRDOWN6)    
#define ixf1110_vTPWRDOWN6	           (1 << ixf1110_sTPWRDOWN6)    

#define ixf1110_sTPWRDOWN7	           17    
#define ixf1110_mTPWRDOWN7	           (1 << ixf1110_sTPWRDOWN7)    
#define ixf1110_vTWRDOWN7	           (1 << ixf1110_sTPWRDOWN7)    

#define ixf1110_sTPWRDOWN8	           18    
#define ixf1110_mTPWRDOWN8	           (1 << ixf1110_sTPWRDOWN8)    
#define ixf1110_vTPWRDOWN8	           (1 << ixf1110_sTPWRDOWN8)    

#define ixf1110_sTPWRDOWN9	           19    
#define ixf1110_mTPWRDOWN9	           (1 << ixf1110_sTPWRDOWN9)    
#define ixf1110_vTPWRDOWN9	           (1 << ixf1110_sTPWRDOWN9)    


/************RX Signal Detect Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RXSIGDET_OFFSET       ixf1110_SERDES_REG(0x0013)  
#define ixf1110_RXSIGDET_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sRXSIGDET0	           0   
#define ixf1110_mRXSIGDET0	           (0x1 << ixf1110_sRXSIGDET0)    
#define ixf1110_vRXSIGDET0	           (0x1 << ixf1110_sRXSIGDET0)    

#define ixf1110_sRXSIGDET1	           1   
#define ixf1110_mRXSIGDET1	           (0x1 << ixf1110_sRXSIGDET1)    
#define ixf1110_vRXSIGDET1	           (0x1 << ixf1110_sRXSIGDET1)    

#define ixf1110_sRXSIGDET2	           2   
#define ixf1110_mRXSIGDET2	           (0x1 << ixf1110_sRXSIGDET2)    
#define ixf1110_vRXSIGDET2	           (0x1 << ixf1110_sRXSIGDET2)    

#define ixf1110_sRXSIGDET3	           3   
#define ixf1110_mRXSIGDET3	           (0x1 << ixf1110_sRXSIGDET3)    
#define ixf1110_vRXSIGDET3	           (0x1 << ixf1110_sRXSIGDET3)    

#define ixf1110_sRXSIGDET4	           4   
#define ixf1110_mRXSIGDET4	           (0x1 << ixf1110_sRXSIGDET4)    
#define ixf1110_vRXSIGDET4	           (0x1 << ixf1110_sRXSIGDET4)    

#define ixf1110_sRXSIGDET5	           5   
#define ixf1110_mRXSIGDET5	           (0x1 << ixf1110_sRXSIGDET5)    
#define ixf1110_vRXSIGDET5	           (0x1 << ixf1110_sRXSIGDET5)    

#define ixf1110_sRXSIGDET6	           6   
#define ixf1110_mRXSIGDET6	           (0x1 << ixf1110_sRXSIGDET6)    
#define ixf1110_vRXSIGDET6	           (0x1 << ixf1110_sRXSIGDET6)    

#define ixf1110_sRXSIGDET7	           7   
#define ixf1110_mRXSIGDET7	           (0x1 << ixf1110_sRXSIGDET7)    
#define ixf1110_vRXSIGDET7	           (0x1 << ixf1110_sRXSIGDET7)    

#define ixf1110_sRXSIGDET8	           8   
#define ixf1110_mRXSIGDET8	           (0x1 << ixf1110_sRXSIGDET8)    
#define ixf1110_vRXSIGDET8	           (0x1 << ixf1110_sRXSIGDET8)    

#define ixf1110_sRXSIGDET9	           9   
#define ixf1110_mRXSIGDET9	           (0x1 << ixf1110_sRXSIGDET9)    
#define ixf1110_vRXSIGDET9	           (0x1 << ixf1110_sRXSIGDET9)    


#endif /* ifndef __ixf1110_SERDES_B_H__ */
