/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/05/04 2:59p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_serdes_d.h $
 *   WORKFILE:       $Workfile: ixf1110_serdes_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: 
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_serdes_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:57p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 6     9/17/03 3:46p Rnballar
 * 
 * 5     9/16/03 10:20a Rnballar
 * 
 * 4     9/15/03 1:23p Rnballar
 * 
 * 3     9/15/03 1:19p Rnballar
 * 
 * 2     9/15/03 11:18a Rnballar
 * completed config struct
 * 
 * 1     9/15/03 10:18a Rnballar
 * Created register structs
 * 
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF1110_SERDES_D_H__
#define __IXF1110_SERDES_D_H__
#include "ixf_bitfield_macros.h"
/*TX and RX AC/DC Coupling Selection Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_21(		
			uint uiTxACDC0		:1,	
			uint uiRxACDC0		:1,
			uint uiTxACDC1		:1,
			uint uiRxACDC1		:1,
			uint uiTxACDC2		:1,
			uint uiRxACDC2		:1,
			uint uiTxACDC3		:1,
			uint uiRxACDC3		:1,
			uint uiTxACDC4		:1,
			uint uiRxACDC4		:1,
			uint uiTxACDC5		:1,
			uint uiRxACDC5		:1,
			uint uiTxACDC6		:1,
			uint uiRxACDC6		:1,
			uint uiTxACDC7		:1,
			uint uiRxACDC7		:1,
			uint uiTxACDC8		:1,
			uint uiRxACDC8		:1,
			uint uiTxACDC9		:1,
			uint uiRxACDC9		:1,
			uint				:12			
		);
	} tCnfg;

} ixf1110_SerDes_TxRxACDCCplSel_t;

/*Tx and Rx Power-Down Ports 0-9 Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_3(
			uint uiRPwrDwn	:10,
			uint uiTPwrDwn	:10,
			uint 		  	:12
		);
	} tCnfg;
	
} ixf1110_SerDes_TxRxPwrDwn_t;

/*Rx Signal Detect Level Ports 0-9 Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_11(
				uint uiRxSigDet0	:1,
				uint uiRxSigDet1	:1, 		
				uint uiRxSigDet2	:1, 		  
				uint uiRxSigDet3	:1, 	   
				uint uiRxSigDet4	:1,	
				uint uiRxSigDet5	:1,  
				uint uiRxSigDet6	:1,
				uint uiRxSigDet7	:1,
				uint uiRxSigDet8	:1,
				uint uiRxSigDet9	:1,
				uint			:22
		);
	} tCnfg;

} ixf1110_SerDes_SigDetLvl_t;


/*SerDes Configuration Struct*/
typedef struct {

	ixf1110_SerDes_TxRxACDCCplSel_t		SerDes_TxRxACDCCplSel;
	ixf1110_SerDes_TxRxPwrDwn_t 		SerDes_TxRxPwrDwn;
	ixf1110_SerDes_SigDetLvl_t 			SerDes_SigDetLvl;
	
} ixf1110_SerDesCfg_t;


#endif /* __IXF1110_SERDES_D_H__ */

