/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_spi4_b.h $
*   WORKFILE:       $Workfile: ixf1110_spi4_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 family device API
*
* Purpose: This file contains the device specific SPI4 bit definitions.
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_spi4_b.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 4     10/10/03 3:03p Tepulkow
 * removed the BASE address and REG_SHIFT macros 
 * 
 * 3     10/07/03 2:04p Tepulkow
 * General cleanup for code review
 * 
 * 2     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
* 
* --------------------------------------------------------------------------
*/
#ifndef SPI4BIT_DEFINES_H
#define SPI4BIT_DEFINES_H


#define ixf1110_SPI4_REG(offset) ((ixf1110_SPI4_BASE + offset) << ixf1110_REG_SHIFT)

/******************************************************************************/
/* SIF_RX_BURST Register*/

/*Offset/Default definition for register.*/
#define ixf1110_SIF_RX_BURST_OFFSET	ixf1110_SPI4_REG(0x0000)
#define ixf1110_SIF_RX_BURST_DFLT		0x00060002

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_BURST *MaxBurst2 for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_MAXBURST2	0
#define ixf1110_mSIF_RX_MAXBURST2	(0x1FF << ixf1110_sSIF_RX_MAXBURST2)

/*SIF_RX_BURST *MaxBurst1 for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_MAXBURST1	16
#define ixf1110_mSIF_RX_MAXBURST1	(0x1FF << ixf1110_sSIF_RX_MAXBURST1)

/*SIF_RX_BURST *NoIdles for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_NOIDLES		31
#define ixf1110_mSIF_RX_NOIDLES		(0x1 << ixf1110_sSIF_RX_NOIDLES)

/******************************************************************************/
/* SIF_RX_TRAINING Register*/

/*Offset/Default definition for register.*/
#define ixf1110_SIF_RX_TRAINING_OFFSET	ixf1110_SPI4_REG(0x0001)
#define ixf1110_SIF_RX_TRAINING_DFLT		0x0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_TRAINING *DATAMAXT for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_DATAMAX_T	0
#define ixf1110_mSIF_RX_DATAMAX_T	(0x0FFFF << ixf1110_sSIF_RX_DATAMAX_T)

/*SIF_RX_TRAINING *REPT for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_REP_T		16
#define ixf1110_mSIF_RX_REP_T		(0x0FF << ixf1110_sSIF_RX_REP_T)

/******************************************************************************/
/* SIF_RX_CALENDAR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_SIF_RX_CALENDAR_OFFSET	ixf1110_SPI4_REG(0x0002)
#define ixf1110_SIF_RX_CALENDAR_DFLT		0x00010300

/* -------- Bit, shift and mask defines.-------- */

/*SIF_CALENDAR *CAL_M for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_CAL_M		0
#define ixf1110_mSIF_RX_CAL_M		(0x0F << ixf1110_sSIF_CAL_M)

/*SIF_CALENDAR *LossOfSynch for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_LOS			8
#define ixf1110_mSIF_RX_LOS			(0x0F << ixf1110_sSIF_RX_LOS)

/*SIF_CALENDAR *DIP-2_Thr for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_DIP2THR		16
#define ixf1110_mSIF_RX_DIP2THR		(0x0F << ixf1110_sSIF_RX_DIP2THR)

/*SIF_CALENDAR *DIP2ERR for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_DIP2ERR		20
#define ixf1110_mSIF_RX_DIP2ERR		(0x1 << ixf1110_sSIF_RX_DIP2ERR)

/*SIF_CALENDAR *TSCLK_INV for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_TSCLK_INV	28
#define ixf1110_mSIF_RX_TSCLK_INV	(0x1 << ixf1110_sSIF_RX_TSCLK_INV)

/*SIF_CALENDAR *RSCLK_INV for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_RSCLK_INV	29
#define ixf1110_mSIF_RX_RSCLK_INV	(0x1 << ixf1110_sSIF_RX_RSCLK_INV)

/*SIF_CALENDAR *CAL_M for SPI-4 Phase 2 Receive. */
#define ixf1110_sSIF_RX_TEST_MODE		30
#define ixf1110_mSIF_RX_TEST_MODE		(0x3 << ixf1110_sSIF_RX_TEST_MODES)
#define ixf1110_vSIF_RX_TEST_MODE_NRML	(0x0 << ixf1110_sSIF_RX_TEST_MODES)
#define ixf1110_vSIF_RX_TEST_MODE_NONE	(0x1 << ixf1110_sSIF_RX_TEST_MODES)
#define ixf1110_vSIF_RX_TEST_MODE_CONT	(0x2 << ixf1110_sSIF_RX_TEST_MODES)


/******************************************************************************/
/* SIF_TX_SYNCH Register*/

/*Offset/Default definition for register.*/
#define ixf1110_SIF_TX_SYNCH_OFFSET	ixf1110_SPI4_REG(0x0003)
#define ixf1110_SIF_TX_SYNCH_DFLT		0x00000045

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_SYNCH *DIP4LCK for SPI-4 Phase 2 Transmit. */
#define ixf1110_sSIF_DIP4LCK		0
#define ixf1110_mSIF_DIP4LCK		(0x0F << ixf1110_sSIF_DIP4LCK)

/*SIF_TX_SYNCH *DIP4LCK for SPI-4 Phase 2 Transmit. */
#define ixf1110_sSIF_DIP4UNLCK		4
#define ixf1110_mSIF_DIP4UNLCK		(0x0F << ixf1110_sSIF_DIP4UNLCK)


/******************************************************************************/
#endif /* SPI4BIT_DEFINES_H */

