/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/05/04 2:59p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_spi4_d.h $
 *   WORKFILE:       $Workfile: ixf1110_spi4_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: 
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_spi4_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 10    10/02/03 3:28p Rnballar
 * fixed tx synchro bitfield
 * 
 * 9     10/01/03 1:16p Rnballar
 * added get status
 * 
 * 7     9/17/03 3:46p Rnballar
 * 
 * 6     9/16/03 10:20a Rnballar
 * 
 * 5     9/15/03 11:16a Rnballar
 * Completed config struct
 * 
 * 4     9/15/03 9:41a Rnballar
 * completed spi4cfg struct
 * 
 * 3     9/15/03 9:20a Rnballar
 * Tailor structs to ixf1110
 * 
 * 2     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
 * 
 * 1     7/08/02 1:37p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF1110_SPI4_D_H__
#define __IXF1110_SPI4_D_H__
#include "ixf_bitfield_macros.h"

/*SPI-4 Burst Size Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_5(
			uint uiMaxBurts2		:9,
			uint					:7,
			uint uiMaxBurts1		:9,
			uint 					:6,
		  	uint uiIdles			:1
		);
	} tCnfg;

} ixf1110_Spi4BurstSize_t;

/*SPI-4 Training Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_3(
			uint uiData_max		:16,
			uint uiRep			:8,
			uint 				:8
		);
	} tCnfg;
	
} ixf1110_Spi4Training_t;

/*SPI-4 Rx Calendar Register*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_12(
				uint uiCal_m 			:4,
				uint					:4,
				uint uiLossOfSync		:4,
				uint TxSpi4Sync			:1,
				uint RxSpi4Sync			:1,
				uint					:2,
				uint uiDip_2_thr		:4,
				uint uiDip2_error		:1,
				uint					:7,
				uint uiTsclk_invert		:1,
				uint uiRsclk_invert		:1,
				uint uiRxTrainTestModes	:2 
		);
	} tCnfg;

} ixf1110_Spi4RxCalendar_t;

/*SPI-4 Tx Synchronization Register*/
typedef union {

  ulong ulReg;
	struct {
		BITFIELD_3(
			uint uiDIP4_Lock	:8,
			uint uiDIP4_UnLock2	:8,
			uint uiDIP4_Errors	:16
		);
	} tCnfg;
	
} ixf1110_Spi4TxSynchro_t;

/*SPI-4 Configuration Struct*/
typedef struct {

	ixf1110_Spi4BurstSize_t 	Spi4BurstSize;
	ixf1110_Spi4Training_t		Spi4Training;
	ixf1110_Spi4RxCalendar_t	Spi4RxCalendar;
	ixf1110_Spi4TxSynchro_t		Spi4TxSynchro;

} ixf1110_Spi4Cfg_t;

/*spi-4 status struct*/
typedef struct {
	uint uiDIP2_Error;
} ixf1110_Spi4Status_t;


#endif /* __IXF1110_SPI4_D_H__ */

