/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_tx_b.h $
*   WORKFILE:       $Workfile: ixf1110_tx_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 API 
* 
* Purpose: This file contains register and bit defines for the TX Block  
*          Configuration registers in the ixf1110.
*
* Notes:
*
*   
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
* $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_tx_b.h $ 
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 5     10/10/03 3:03p Tepulkow
 * removed the BASE address and REG_SHIFT macros 
 * 
 * 4     9/26/03 2:55p Rnballar
 * added reset functionailty
 * 
 * 3     9/23/03 1:26p Rnballar
 * added functionality set & get config
 * 
 * 2     9/23/03 12:43p Rnballar
 * 
 * 1     9/09/03 4:52p Tepulkow
 * Created these header files for the IXF1110 MAC device blocks new to the
 * IXF API framework
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 
* --------------------------------------------------------------------------
*/ 

#ifndef __ixf1110_TX_B_H__
#define __ixf1110_TX_B_H__


#define ixf1110_TX_REG(offset) ((ixf1110_TX_BASE + offset) << ixf1110_REG_SHIFT)

/************TX Registers*/

/*Offset/Default definition for register.*/
/*Tx FIFO Hi water*/
#define ixf1110_TXHIWATER0_OFFSET       ixf1110_TX_REG(0x0000)
#define ixf1110_TXHIWATER1_OFFSET       ixf1110_TX_REG(0x0001)
#define ixf1110_TXHIWATER2_OFFSET       ixf1110_TX_REG(0x0002)
#define ixf1110_TXHIWATER3_OFFSET       ixf1110_TX_REG(0x0003)
#define ixf1110_TXHIWATER4_OFFSET       ixf1110_TX_REG(0x0004)
#define ixf1110_TXHIWATER5_OFFSET       ixf1110_TX_REG(0x0005)
#define ixf1110_TXHIWATER6_OFFSET       ixf1110_TX_REG(0x0006)
#define ixf1110_TXHIWATER7_OFFSET       ixf1110_TX_REG(0x0007)
#define ixf1110_TXHIWATER8_OFFSET       ixf1110_TX_REG(0x0008)
#define ixf1110_TXHIWATER9_OFFSET       ixf1110_TX_REG(0x0009)
/*Tx FIFO Low water*/
#define ixf1110_TXLOWATER0_OFFSET       ixf1110_TX_REG(0x000A)
#define ixf1110_TXLOWATER1_OFFSET       ixf1110_TX_REG(0x000B)
#define ixf1110_TXLOWATER2_OFFSET       ixf1110_TX_REG(0x000C)
#define ixf1110_TXLOWATER3_OFFSET       ixf1110_TX_REG(0x000D)
#define ixf1110_TXLOWATER4_OFFSET       ixf1110_TX_REG(0x000E)
#define ixf1110_TXLOWATER5_OFFSET       ixf1110_TX_REG(0x000F)
#define ixf1110_TXLOWATER6_OFFSET       ixf1110_TX_REG(0x0010)
#define ixf1110_TXLOWATER7_OFFSET       ixf1110_TX_REG(0x0011)
#define ixf1110_TXLOWATER8_OFFSET       ixf1110_TX_REG(0x0012)
#define ixf1110_TXLOWATER9_OFFSET       ixf1110_TX_REG(0x0013)
/*Tx FIFO MAC Thresh*/
#define ixf1110_TXMACTHRESH0_OFFSET		ixf1110_TX_REG(0x0014)
#define ixf1110_TXMACTHRESH1_OFFSET		ixf1110_TX_REG(0x0015)
#define ixf1110_TXMACTHRESH2_OFFSET		ixf1110_TX_REG(0x0016)
#define ixf1110_TXMACTHRESH3_OFFSET		ixf1110_TX_REG(0x0017)
#define ixf1110_TXMACTHRESH4_OFFSET		ixf1110_TX_REG(0x0018)
#define ixf1110_TXMACTHRESH5_OFFSET		ixf1110_TX_REG(0x0019)
#define ixf1110_TXMACTHRESH6_OFFSET		ixf1110_TX_REG(0x001A)
#define ixf1110_TXMACTHRESH7_OFFSET		ixf1110_TX_REG(0x001B)
#define ixf1110_TXMACTHRESH8_OFFSET		ixf1110_TX_REG(0x001C)
#define ixf1110_TXMACTHRESH9_OFFSET		ixf1110_TX_REG(0x001D)


/*TX FIFO Overflow Event */
#define ixf1110_TXOVRFLWEVENT_OFFSET	ixf1110_TX_REG(0x001E)

/*TX FIFO Port Reset Register*/
#define ixf1110_TXFIFOPORTRESET_OFFSET		ixf1110_TX_REG(0x0020)
#define ixf1110_mTXFIFOPORTRESET_ALL		0x3FF


/*TX FIFO Info Out-of-Sequence */
#define ixf1110_TXINFOUTSEQ_OFFSET		ixf1110_TX_REG(0x0021)

/*TX FIFO Number of Frames Removed Ports 0-9*/
#define ixf1110_TXNUMFRMREMOVE0			ixf1110_TX_REG(0x0022)
#define ixf1110_TXNUMFRMREMOVE1			ixf1110_TX_REG(0x0023)
#define ixf1110_TXNUMFRMREMOVE2			ixf1110_TX_REG(0x0024)
#define ixf1110_TXNUMFRMREMOVE3			ixf1110_TX_REG(0x0025)
#define ixf1110_TXNUMFRMREMOVE4			ixf1110_TX_REG(0x0026)
#define ixf1110_TXNUMFRMREMOVE5			ixf1110_TX_REG(0x0027)
#define ixf1110_TXNUMFRMREMOVE6			ixf1110_TX_REG(0x0028)
#define ixf1110_TXNUMFRMREMOVE7			ixf1110_TX_REG(0x0029)
#define ixf1110_TXNUMFRMREMOVE8			ixf1110_TX_REG(0x002A)
#define ixf1110_TXNUMFRMREMOVE9			ixf1110_TX_REG(0x002B)




/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_XXX_DFLT         0x0
#define ixf1110_sXXX	           0   
#define ixf1110_mXXX	           (0xFFFFFFFF << ixf1110_sSTA_ADDR_LO)    


#endif /* ifndef __ixf1110_TX_B_H__ */
