/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_xgmac_b.h $
*   WORKFILE:       $Workfile: ixf1110_xgmac_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 family device API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_xgmac_b.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 10    10/21/03 10:39a Tepulkow
 * changed the default for the FC_EN csr from 1 to 7.  Added defines for
 * TXFCEN bits.
 * 
 * 9     9/25/03 10:09a Rnballar
 * changed pause thresh mask
 * 
 * 8     9/18/03 12:05p Rnballar
 * 
 * 7     9/18/03 10:30a Tepulkow
 * added xgmac_cnt define
 * 
 * 6     9/17/03 5:42p Tepulkow
 * added xgmac_ch_reg macro and xgmac_sz define
 * 
 * 5     9/16/03 8:13a Tepulkow
 * Changed PORTCTRL_BASE define to XGMAC_BASE
 * 
 * 4     9/15/03 5:40p Tepulkow
 * Completed the creation of this file
 * 
 * 3     9/12/03 11:43a Tepulkow
 * 
 * 2     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
* 
* --------------------------------------------------------------------------
*/

#ifndef __IXF1110_XGMAC_B_H__
#define __IXF1110_XGMAC_B_H__

#define	ixf1110_XGMAC_CH_SZ		0x80
#define	ixf1110_XGMAC_CH_CNT	10

#define ixf1110_XGMAC_REG(offset) ((ixf1110_XGMAC_BASE + offset) << ixf1110_REG_SHIFT)

#define ixf1110_XGMAC_CH_REG(channel, offset) ((channel * ixf1110_XGMAC_CH_SZ) + offset)


/************STA_ADDR_LO Register*/

/*Offset/Default definition for register.*/
#define ixf1110_STA_ADDR_LO_OFFSET       ixf1110_XGMAC_REG(0x0000)  
#define ixf1110_STA_ADDR_LO_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sSTA_ADDR_LO	           0   
#define ixf1110_mSTA_ADDR_LO	           (0xFFFFFFFF << ixf1110_sSTA_ADDR_LO)    

/************STA_ADDR_HI Register*/

/*Offset/Default definition for register.*/
#define ixf1110_STA_ADDR_HI_OFFSET       ixf1110_XGMAC_REG(0x0001)  
#define ixf1110_STA_ADDR_HI_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sSTA_ADDR_HI	           0   
#define ixf1110_mSTA_ADDR_HI	           (0xFFFF << ixf1110_sSTA_ADDR_HI)    

/************FDFC_TYPE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_FDFC_TYPE_OFFSET       ixf1110_XGMAC_REG(0x0003)  
#define ixf1110_FDFC_TYPE_DFLT         0x8808

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sFDFC_TYPE	           0   
#define ixf1110_mFDFC_TYPE	           (0xFFFF << ixf1110_sFDFC_TYPE)    

/************FCTX_TIMER Register*/

/*Offset/Default definition for register.*/
#define ixf1110_FCTX_TIMER_OFFSET       ixf1110_XGMAC_REG(0x0007)  
#define ixf1110_FCTX_TIMER_DFLT         0x5E

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sFCTX_TIMER	           0   
#define ixf1110_mFCTX_TIMER	           (0xFFFF << ixf1110_sFCTX_TIMER)    

/************FDFC_ADDR_LO Register*/

/*Offset/Default definition for register.*/
#define ixf1110_FDFC_ADDR_LO_OFFSET       ixf1110_XGMAC_REG(0x0008)  
#define ixf1110_FDFC_ADDR_LO_DFLT         0xC2000001

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sFDFC_ADDR_LO	           0   
#define ixf1110_mFDFC_ADDR_LO	           (0xFFFFFFFF << ixf1110_sFDFC_ADDR_LO)    

/************FDFC_ADDR_HI Register*/

/*Offset/Default definition for register.*/
#define ixf1110_FDFC_ADDR_HI_OFFSET       ixf1110_XGMAC_REG(0x0009)  
#define ixf1110_FDFC_ADDR_HI_DFLT         0x0180

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sFDFC_ADDR_HI	           0   
#define ixf1110_mFDFC_ADDR_HI	           (0xFFFF << ixf1110_sFDFC_ADDR_HI)    

/************IPG_RX_TIME1 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_IPG_RX_TIME1_OFFSET       ixf1110_XGMAC_REG(0x000A)  
#define ixf1110_IPG_RX_TIME1_DFLT         0x0008

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sIPG_RX_TIME1	           0   
#define ixf1110_mIPG_RX_TIME1	           (0x3FF << ixf1110_sIPG_RX_TIME1)    

/************IPG_RX_TIME2 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_IPG_RX_TIME2_OFFSET       ixf1110_XGMAC_REG(0x000B)  
#define ixf1110_IPG_RX_TIME2_DFLT         0x0007

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sIPG_RX_TIME2	           0   
#define ixf1110_mIPG_RX_TIME2	           (0x3FF << ixf1110_sIPG_RX_TIME2)    

/************IPG_TX_TIME2 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_IPG_TX_TIME_OFFSET       ixf1110_XGMAC_REG(0x000C)  
#define ixf1110_IPG_TX_TIME_DFLT         0x0008

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sIPG_TX_TIME	           0   
#define ixf1110_mIPG_TX_TIME	           (0x3FF << ixf1110_sIPG_TX_TIME)    

/************PAUSE_THRESHLD Register*/

/*Offset/Default definition for register.*/
#define ixf1110_PAUSE_THRESHLD_OFFSET       ixf1110_XGMAC_REG(0x000E)  
#define ixf1110_PAUSE_THRESHLD_DFLT         0x002F

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sPAUSE_THRESHLD	           0   
#define ixf1110_mPAUSE_THRESHLD	           (0xFFFF << ixf1110_sPAUSE_THRESHLD)    

/************MAX_FRAME_SZ Register*/

/*Offset/Default definition for register.*/
#define ixf1110_MAX_FRAME_SZ_OFFSET       ixf1110_XGMAC_REG(0x000F)  
#define ixf1110_MAX_FRAME_SZ_DFLT         0x05EE

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sMAX_FRAME_SZ	           0   
#define ixf1110_mMAX_FRAME_SZ	           (0x3FFF << ixf1110_sMAX_FRAME_SZ)    

/************FC_ENABLE Register*/

/*Offset/Default definition for register.*/
#define ixf1110_FC_EN_OFFSET       ixf1110_XGMAC_REG(0x0012)  
#define ixf1110_FC_EN_DFLT         0x0007

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sRXFDFC_EN	           0   
#define ixf1110_mRXFDFC_EN             (1 << ixf1110_sRXFDFC_EN)    
#define ixf1110_vRXFDFC_EN             (1 << ixf1110_sRXFDFC_EN)    

#define ixf1110_sTXFDFC_EN	           1   
#define ixf1110_mTXFDFC_EN             (1 << ixf1110_sTXFDFC_EN)    
#define ixf1110_vTXFDFC_EN             (1 << ixf1110_sTXFDFC_EN)

#define ixf1110_sTXHDFC_EN	           2   
#define ixf1110_mTXHDFC_EN             (1 << ixf1110_sTXHDFC_EN)    
#define ixf1110_vTXHDFC_EN             (1 << ixf1110_sTXHDFC_EN)    
    

/************SHORT_RUNTS_THRESHLD Register*/

/*Offset/Default definition for register.*/
#define ixf1110_SHORT_RUNTS_THRESHLD_OFFSET       ixf1110_XGMAC_REG(0x0014)  
#define ixf1110_SHORT_RUNTS_THRESHLD_DFLT         0x08

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sSHORT_RUNTS_THRESHLD	           0   
#define ixf1110_mSHORT_RUNTS_THRESHLD	           (0x1F << ixf1110_sSHORT_RUNTS_THRESHLD)    


/************DISCARD_UNKNOWN_CTRL_FRM Register*/

/*Offset/Default definition for register.*/
#define ixf1110_DISCARD_UNKNOWN_CTRL_FRM_OFFSET       ixf1110_XGMAC_REG(0x0015)  
#define ixf1110_DISCARD_UNKNOWN_CTRL_FRM_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sDISCARD_UNKNOWN_CTRL_FRM	           0   
#define ixf1110_mDISCARD_UNKNOWN_CTRL_FRM	           (1 << ixf1110_sDISCARD_UNKNOWN_CTRL_FRM)    
#define ixf1110_vDISCARD_UNKNOWN_CTRL_FRM	           (1 << ixf1110_sDISCARD_UNKNOWN_CTRL_FRM)    

/************RX_CONFIG_WORD Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_CONFIG_WORD_OFFSET       ixf1110_XGMAC_REG(0x0016)  
#define ixf1110_RX_CONFIG_WORD_DFLT         0x0

/*  ------- Bit, shift and mask defines.  ------ */
#define ixf1110_sFULL_DUPLEX				           5   
#define ixf1110_mFULL_DUPLEX	           				(1 << ixf1110_sFULL_DUPLEX)    
#define ixf1110_vFULL_DUPLEX	           				(1 << ixf1110_sFULL_DUPLEX)    

#define ixf1110_sHALF_DUPLEX				           6   
#define ixf1110_mHALF_DUPLEX	           				(1 << ixf1110_sHALF_DUPLEX)    
#define ixf1110_vHALF_DUPLEX	           				(1 << ixf1110_sHALF_DUPLEX)    

#define ixf1110_sSYMPAUSE					           7   
#define ixf1110_mSYMPAUSE	           					(1 << ixf1110_sSYMPAUSE)    
#define ixf1110_vSYMPAUSE	           					(1 << ixf1110_sSYMPAUSE)    

#define ixf1110_sASYMPAUSE					           8
#define ixf1110_mASYMPAUSE	           					(1 << ixf1110_sASYMPAUSE)    
#define ixf1110_vASYMPAUSE	           					(1 << ixf1110_sASYMPAUSE)    

#define ixf1110_sREMOTE_FAULT				           12
#define ixf1110_mREMOTE_FAULT	           				(3 << ixf1110_sREMOTE_FAULT)    

#define ixf1110_sNEXT_PAGE					           15
#define ixf1110_mNEXT_PAGE	           					(1 << ixf1110_sNEXT_PAGE)    
#define ixf1110_vNEXT_PAGE	           					(1 << ixf1110_sNEXT_PAGE)    

#define ixf1110_sCARRIER_SENSE				           16
#define ixf1110_mCARRIER_SENSE	           				(1 << ixf1110_sCARRIER_SENSE)    
#define ixf1110_vCARRIER_SENSE       					(0 << ixf1110_sCARRIER_SENSE)    

#define ixf1110_sINVALID_WORD				           17
#define ixf1110_mINVALID_WORD	           				(1 << ixf1110_sINVALID_WORD)    
#define ixf1110_vINVALID_WORD		       				(1 << ixf1110_sINVALID_WORD)    

#define ixf1110_sCONFIG_CHANGED				           18
#define ixf1110_mCONFIG_CHANGED	           				(1 << ixf1110_sCONFIG_CHANGED)    
#define ixf1110_vCONFIG_CHANGED		       				(1 << ixf1110_sCONFIG_CHANGED)    

#define ixf1110_sRX_CONFIG					           19
#define ixf1110_mRX_CONFIG	           					(1 << ixf1110_sRX_CONFIG)    
#define ixf1110_vRX_CONFIG_IDLE       					(0 << ixf1110_sRX_CONFIG)    
#define ixf1110_vRX_CONFIG_CSET       					(1 << ixf1110_sRX_CONFIG)    

#define ixf1110_sRX_SYNCH					           20
#define ixf1110_mRX_SYNCH	           					(1 << ixf1110_sRX_SYNCH)    
#define ixf1110_vRX_SYNCH       						(1 << ixf1110_sRX_SYNCH)    

#define ixf1110_sAN_COMPLETE				           21
#define ixf1110_mAN_COMPLETE	           				(1 << ixf1110_sAN_COMPLETE)    
#define ixf1110_vAN_COMPLETE       						(1 << ixf1110_sAN_COMPLETE)    

/************TX_CONFIG_WORD Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_CONFIG_WORD_OFFSET       ixf1110_XGMAC_REG(0x0017)  
#define ixf1110_TX_CONFIG_WORD_DFLT         0x01A0

/*  ------- Bit, shift and mask defines.  ------ */

/* Same as RX config word above  
#define ixf1110_sFULL_DUPLEX				           5   
#define ixf1110_mFULL_DUPLEX	           				(1 << ixf1110_sFULL_DUPLEX)    
#define ixf1110_vFULL_DUPLEX	           				(1 << ixf1110_sFULL_DUPLEX)    

#define ixf1110_sHALF_DUPLEX				           6   
#define ixf1110_mHALF_DUPLEX	           				(1 << ixf1110_sHALF_DUPLEX)    
#define ixf1110_vHALF_DUPLEX	           				(1 << ixf1110_sHALF_DUPLEX)    

#define ixf1110_sSYMPAUSE					           7   
#define ixf1110_mSYMPAUSE	           					(1 << ixf1110_sSYMPAUSE)    
#define ixf1110_vSYMPAUSE	           					(1 << ixf1110_sSYMPAUSE)    

#define ixf1110_sASYMPAUSE					           8
#define ixf1110_mASYMPAUSE	           					(1 << ixf1110_sASYMPAUSE)    
#define ixf1110_vASYMPAUSE	           					(1 << ixf1110_sASYMPAUSE)    

#define ixf1110_sREMOTE_FAULT				           12
#define ixf1110_mREMOTE_FAULT	           				(3 << ixf1110_sREMOTE_FAULT)    

#define ixf1110_sNEXT_PAGE					           15
#define ixf1110_mNEXT_PAGE	           					(1 << ixf1110_sNEXT_PAGE)    
#define ixf1110_vNEXT_PAGE	           					(1 << ixf1110_sNEXT_PAGE)    
Same as RX config word above  */


/************DIVERSE_CONFIG Register*/

/*Offset/Default definition for register.*/
#define ixf1110_DIVERSE_CONFIG_OFFSET       ixf1110_XGMAC_REG(0x0018)  
#define ixf1110_DIVERSE_CONFIG_FRM_DFLT         0x110D

/*  ------- Bit, shift and mask defines.  ------ */

#define ixf1110_sSET_LINK_UP					   0
#define ixf1110_mSET_LINK_UP	           		   (1 << ixf1110_sSET_LINK_UP)    
#define ixf1110_vSET_LINK_UP       				   (1 << ixf1110_sSET_LINK_UP)    

#define ixf1110_sSEND_CONFIG					   1
#define ixf1110_mSEND_CONFIG	           		   (1 << ixf1110_sSEND_CONFIG)    
#define ixf1110_vSEND_CONFIG       				   (1 << ixf1110_sSEND_CONFIG)    

#define ixf1110_sFORCE_DUPLEX					   2
#define ixf1110_mFORCE_DUPLEX	           		   (1 << ixf1110_sFORCE_DUPLEX)    
#define ixf1110_vFORCE_DUPLEX       			   (1 << ixf1110_sFORCE_DUPLEX)    

#define ixf1110_sPHY_DUPLEX							3
#define ixf1110_mPHY_DUPLEX	           				(1 << ixf1110_sPHY_DUPLEX)    
#define ixf1110_vPHY_DUPLEX       					(1 << ixf1110_sPHY_DUPLEX)    

#define ixf1110_sLOS_INVERT							4
#define ixf1110_mLOS_INVERT	           				(1 << ixf1110_sLOS_INVERT)    
#define ixf1110_vLOS_INVERT       					(1 << ixf1110_sLOS_INVERT)    

#define ixf1110_sAUTONEG_EN							5
#define ixf1110_mAUTONEG_EN	           				(1 << ixf1110_sAUTONEG_EN)    
#define ixf1110_vAUTONEG_EN       					(1 << ixf1110_sAUTONEG_EN)    

#define ixf1110_sCRC_ADD							6
#define ixf1110_mCRC_ADD	           				(1 << ixf1110_sCRC_ADD)    
#define ixf1110_vCRC_ADD       						(1 << ixf1110_sCRC_ADD)    

#define ixf1110_sPAD_EN								7
#define ixf1110_mPAD_EN	           					(1 << ixf1110_sPAD_EN)    
#define ixf1110_vPAD_EN       						(1 << ixf1110_sPAD_EN)    

#define ixf1110_sUNDRUN_NORETRANS					8
#define ixf1110_mUNDRUN_NORETRANS	           		(1 << ixf1110_sUNDRUN_NORETRANS)    
#define ixf1110_vUNDRUN_NORETRANS       			(1 << ixf1110_sUNDRUN_NORETRANS)    

#define ixf1110_sLATE_COL_RETRANS					9
#define ixf1110_mLATE_COL_RETRANS	           		(1 << ixf1110_sLATE_COL_RETRANS)    
#define ixf1110_vLATE_COL_RETRANS       			(1 << ixf1110_sLATE_COL_RETRANS)    

#define ixf1110_sBURST_MODE_EN						10
#define ixf1110_mBURST_MODE_EN	           			(1 << ixf1110_sBURST_MODE_EN)    
#define ixf1110_vBURST_MODE_EN       				(1 << ixf1110_sBURST_MODE_EN)    

#define ixf1110_sCLK_SWITCH_DEFER					11
#define ixf1110_mCLK_SWITCH_DEFER	           		(1 << ixf1110_sCLK_SWITCH_DEFER)    
#define ixf1110_vCLK_SWITCH_DEFER       			(1 << ixf1110_sCLK_SWITCH_DEFER)    

#define ixf1110_sRBC_RUNNING_125					12
#define ixf1110_mRBC_RUNNING_125	           		(1 << ixf1110_sRBC_RUNNING_125)    
#define ixf1110_vRBC_RUNNING_125       				(1 << ixf1110_sRBC_RUNNING_125)    

#define ixf1110_sINV_LOS							13
#define ixf1110_mINV_LOS	           				(1 << ixf1110_sINV_LOS)    
#define ixf1110_vINV_LOS       						(1 << ixf1110_sINV_LOS)    

#define ixf1110_sALIGN_PHASE_OP						14
#define ixf1110_mALIGN_PHASE_OP	           			(1 << ixf1110_sALIGN_PHASE_OP)    
#define ixf1110_vALIGN_PHASE_OP       				(1 << ixf1110_sALIGN_PHASE_OP)    

#define ixf1110_sFORCE_FSM_ABORT_EN					15
#define ixf1110_mFORCE_FSM_ABORT_EN	           		(1 << ixf1110_sFORCE_FSM_ABORT_EN)    
#define ixf1110_vFORCE_FSM_ABORT_EN       			(1 << ixf1110_sFORCE_FSM_ABORT_EN)    

/************RXPCKT_FLTR_CTRL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RXPCKT_FLTR_CTRL_OFFSET       ixf1110_XGMAC_REG(0x0019)  
#define ixf1110_RXPCKT_FLTR_CTRL_DFLT         0x0000

/*  ------- Bit, shift and mask defines.  ------ */

#define ixf1110_sUCAST_MATCH_EN						0
#define ixf1110_mUCAST_MATCH_EN	           			(1 << ixf1110_sUCAST_MATCH_EN)    
#define ixf1110_vUCAST_MATCH_EN       				(1 << ixf1110_sUCAST_MATCH_EN)    

#define ixf1110_sMCAST_MATCH_EN						1
#define ixf1110_mMCAST_MATCH_EN	           			(1 << ixf1110_sMCAST_MATCH_EN)    
#define ixf1110_vMCAST_MATCH_EN       				(1 << ixf1110_sMCAST_MATCH_EN)    

#define ixf1110_sBCAST_MATCH_EN						2
#define ixf1110_mBCAST_MATCH_EN	           			(1 << ixf1110_sBCAST_MATCH_EN)    
#define ixf1110_vBCAST_MATCH_EN       				(1 << ixf1110_sBCAST_MATCH_EN)    

#define ixf1110_sVLAN_DROP_EN						3
#define ixf1110_mVLAN_DROP_EN	           			(1 << ixf1110_sVLAN_DROP_EN)    
#define ixf1110_vVLAN_DROP_EN       				(1 << ixf1110_sVLAN_DROP_EN)    

#define ixf1110_sPAUSE_FRM_PASS						4
#define ixf1110_mPAUSE_FRM_PASS	           			(1 << ixf1110_sPAUSE_FRM_PASS)    
#define ixf1110_vPAUSE_FRM_PASS       				(1 << ixf1110_sPAUSE_FRM_PASS)    

#define ixf1110_sCRC_ERR_PASS						5
#define ixf1110_mCRC_ERR_PASS	           			(1 << ixf1110_sCRC_ERR_PASS)    
#define ixf1110_vCRC_ERR_PASS       				(1 << ixf1110_sCRC_ERR_PASS)    

/************PORT_MCAST_ADDR_LO Register*/

/*Offset/Default definition for register.*/
#define ixf1110_PORT_MCAST_ADDR_LO_OFFSET       ixf1110_XGMAC_REG(0x001A)  
#define ixf1110_PORT_MCAST_ADDR_LO_DFLT         0x0000
#define ixf1110_mPORT_MCAST_ADDR_LO				0xFFFFFFFF

/************PORT_MCAST_ADDR_HI Register*/

/*Offset/Default definition for register.*/
#define ixf1110_PORT_MCAST_ADDR_HI_OFFSET       ixf1110_XGMAC_REG(0x001B)  
#define ixf1110_PORT_MCAST_ADDR_HI_DFLT         0x0000
#define ixf1110_mPORT_MCAST_ADDR_HI				0xFFFF
/************RX_OCT_OK Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_OCT_OK_OFFSET       			ixf1110_XGMAC_REG(0x0020)  
#define ixf1110_RX_OCT_OK_DFLT			         0x0000

/************RX_OCT_BAD Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_OCT_BAD_OFFSET       		ixf1110_XGMAC_REG(0x0021)  
#define ixf1110_RX_OCT_BAD_DFLT			         0x0000

/************RX_UC_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_UC_PKTS_OFFSET       		ixf1110_XGMAC_REG(0x0022)  
#define ixf1110_RX_UC_PKTS_DFLT			         0x0000

/************RX_MC_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_MC_PKTS_OFFSET       		ixf1110_XGMAC_REG(0x0023)  
#define ixf1110_RX_MC_PKTS_DFLT			         0x0000

/************RX_BC_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_BC_PKTS_OFFSET       		ixf1110_XGMAC_REG(0x0024)  
#define ixf1110_RX_BC_PKTS_DFLT			         0x0000

/************RX_PKTS_64OCT Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_64_OFFSET       		ixf1110_XGMAC_REG(0x0025)  
#define ixf1110_RX_PKTS_64_DFLT			         0x0000

/************RX_PKTS_65TO127 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_65TO127_OFFSET       		ixf1110_XGMAC_REG(0x0026)  
#define ixf1110_RX_PKTS_65TO127_DFLT			         0x0000

/************RX_PKTS_128TO255 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_128TO255_OFFSET       		ixf1110_XGMAC_REG(0x0027)  
#define ixf1110_RX_PKTS_128TO255_DFLT			         0x0000

/************RX_PKTS_256TO511 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_256TO511_OFFSET       		ixf1110_XGMAC_REG(0x0028)  
#define ixf1110_RX_PKTS_256TO511_DFLT			         0x0000

/************RX_PKTS_512TO1023 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_512TO1023_OFFSET       		ixf1110_XGMAC_REG(0x0029)  
#define ixf1110_RX_PKTS_512TO1023_DFLT			         0x0000

/************RX_PKTS_1024TO1518 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_1024TO1518_OFFSET       		ixf1110_XGMAC_REG(0x002A)  
#define ixf1110_RX_PKTS_1024TO1518_DFLT			         0x0000

/************RX_PKTS_1519TOMAX Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PKTS_1519TOMAX_OFFSET       		ixf1110_XGMAC_REG(0x002B)  
#define ixf1110_RX_PKTS_1519TOMAX_DFLT			         0x0000

/************RX_FCS_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_FCS_ERR_OFFSET       		ixf1110_XGMAC_REG(0x002C)  
#define ixf1110_RX_FCS_ERR_DFLT			         0x0000

/************RX_TAGGED Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_TAGGED_OFFSET       		ixf1110_XGMAC_REG(0x002D)  
#define ixf1110_RX_TAGGED_DFLT			         0x0000

/************RX_DATA_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_DATA_ERR_OFFSET       		ixf1110_XGMAC_REG(0x002E)  
#define ixf1110_RX_DATA_ERR_DFLT			         0x0000

/************RX_ALIGN_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_ALIGN_ERR_OFFSET       		ixf1110_XGMAC_REG(0x002F)  
#define ixf1110_RX_ALIGN_ERR_DFLT			         0x0000

/************RX_LONG_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_LONG_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0030)  
#define ixf1110_RX_LONG_ERR_DFLT			         0x0000

/************RX_JABBER_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_JABBER_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0031)  
#define ixf1110_RX_JABBER_ERR_DFLT			         0x0000

/************RX_PAUSE_CTRL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_PAUSE_CTRL_OFFSET       		ixf1110_XGMAC_REG(0x0032)  
#define ixf1110_RX_PAUSE_CTRL_DFLT			         0x0000

/************RX_UNKNOWN_CTRL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_UNKNOWN_CTRL_OFFSET       		ixf1110_XGMAC_REG(0x0033)  
#define ixf1110_RX_UNKNOWN_CTRL_DFLT			         0x0000

/************RX_VERYLONG_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_VERYLONG_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0034)  
#define ixf1110_RX_VERYLONG_ERR_DFLT			         0x0000

/************RX_RUNT_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_RUNT_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0035)  
#define ixf1110_RX_RUNT_ERR_DFLT			         0x0000

/************RX_SHORT_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_SHORT_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0036)  
#define ixf1110_RX_SHORT_ERR_DFLT			         0x0000

/************RX_CAR_EXT_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_CAR_EXT_OFFSET       		ixf1110_XGMAC_REG(0x0037)  
#define ixf1110_RX_CAR_EXT_DFLT			         0x0000

/************RX_SEQ_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_SEQ_OFFSET       		ixf1110_XGMAC_REG(0x0038)  
#define ixf1110_RX_SEQ_DFLT			         0x0000

/************RX_SYMBOL_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_RX_SYMBOL_OFFSET       		ixf1110_XGMAC_REG(0x0039)  
#define ixf1110_RX_SYMBOL_DFLT			         0x0000


/************TX_OCT_OK Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_OCT_OK_OFFSET       			ixf1110_XGMAC_REG(0x0040)  
#define ixf1110_TX_OCT_OK_DFLT			         0x0000

/************TX_OCT_BAD Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_OCT_BAD_OFFSET       		ixf1110_XGMAC_REG(0x0041)  
#define ixf1110_TX_OCT_BAD_DFLT			         0x0000

/************TX_UC_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_UC_PKTS_OFFSET       		ixf1110_XGMAC_REG(0x0042)  
#define ixf1110_TX_UC_PKTS_DFLT			         0x0000

/************TX_MC_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_MC_PKTS_OFFSET       		ixf1110_XGMAC_REG(0x0043)  
#define ixf1110_TX_MC_PKTS_DFLT			         0x0000

/************TX_BC_PKTS Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_BC_PKTS_OFFSET       		ixf1110_XGMAC_REG(0x0044)  
#define ixf1110_TX_BC_PKTS_DFLT			         0x0000

/************TX_PKTS_64OCT Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_64_OFFSET       		ixf1110_XGMAC_REG(0x0045)  
#define ixf1110_TX_PKTS_64_DFLT			         0x0000

/************TX_PKTS_65TO127 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_65TO127_OFFSET       		ixf1110_XGMAC_REG(0x0046)  
#define ixf1110_TX_PKTS_65TO127_DFLT			         0x0000

/************TX_PKTS_128TO255 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_128TO255_OFFSET       		ixf1110_XGMAC_REG(0x0047)  
#define ixf1110_TX_PKTS_128TO255_DFLT			         0x0000

/************TX_PKTS_256TO511 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_256TO511_OFFSET       		ixf1110_XGMAC_REG(0x0048)  
#define ixf1110_TX_PKTS_256TO511_DFLT			         0x0000

/************TX_PKTS_512TO1023 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_512TO1023_OFFSET       		ixf1110_XGMAC_REG(0x0049)  
#define ixf1110_TX_PKTS_512TO1023_DFLT			         0x0000

/************TX_PKTS_1024TO1518 Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_1024TO1518_OFFSET       		ixf1110_XGMAC_REG(0x004A)  
#define ixf1110_TX_PKTS_1024TO1518_DFLT			         0x0000

/************TX_PKTS_1519TOMAX Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PKTS_1519TOMAX_OFFSET       		ixf1110_XGMAC_REG(0x004B)  
#define ixf1110_TX_PKTS_1519TOMAX_DFLT			         0x0000

/************TX_DEFERRED Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_DEFERRED_OFFSET       		ixf1110_XGMAC_REG(0x004C)  
#define ixf1110_TX_DEFERRED_DFLT			         0x0000

/************TX_TOTAL_COL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_TOTAL_COL_OFFSET       		ixf1110_XGMAC_REG(0x004D)  
#define ixf1110_TX_TOTAL_COL_DFLT			         0x0000

/************TX_SINGLE_COL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_SINGLE_COL_OFFSET       		ixf1110_XGMAC_REG(0x004E)  
#define ixf1110_TX_SINGLE_COL_DFLT			         0x0000


/************TX_MULT_COL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_MULT_COL_OFFSET       		ixf1110_XGMAC_REG(0x004F)  
#define ixf1110_TX_MULT_COL_DFLT			         0x0000

/************TX_LATE_COL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_LATE_COL_OFFSET       		ixf1110_XGMAC_REG(0x0050)  
#define ixf1110_TX_LATE_COL_DFLT			         0x0000

/************TX_EXCESS_COL_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_EXCESS_COL_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0051)  
#define ixf1110_TX_EXCESS_COL_ERR_DFLT			         0x0000

/************TX_EXCESS_DEF_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_EXCESS_DEF_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0052)  
#define ixf1110_TX_EXCESS_DEF_ERR_DFLT			         0x0000

/************TX_EXCESS_LENGTH_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_EXCESS_LENGTH_DROP_OFFSET       		ixf1110_XGMAC_REG(0x0053)  
#define ixf1110_TX_EXCESS_LENGTH_DROP_DFLT			         0x0000

/************TX_UNDERRUN Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_UNDERRUN_OFFSET       		ixf1110_XGMAC_REG(0x0054)  
#define ixf1110_TX_UNDERRUN_DFLT			         0x0000

/************TX_TAGGED Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_TAGGED_OFFSET       		ixf1110_XGMAC_REG(0x0055)  
#define ixf1110_TX_TAGGED_DFLT			         0x0000


/************TX_CRC_ERR Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_CRC_ERR_OFFSET       		ixf1110_XGMAC_REG(0x0056)  
#define ixf1110_TX_CRC_ERR_DFLT			         0x0000

/************TX_PAUSE_CTRL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_PAUSE_CTRL_OFFSET       		ixf1110_XGMAC_REG(0x0057)  
#define ixf1110_TX_PAUSE_CTRL_DFLT			         0x0000

/************TX_FLOW_CTRL_COL Register*/

/*Offset/Default definition for register.*/
#define ixf1110_TX_FLOW_CTRL_COL_OFFSET       		ixf1110_XGMAC_REG(0x0058)  
#define ixf1110_TX_FLOW_CTRL_COL_DFLT			         0x0000



#endif /*__IXF1110_XGMAC_B_H__*/
