/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_xgmac_d.h $
*   WORKFILE:       $Workfile: ixf1110_xgmac_d.h $
*
* --------------------------------------------------------------------------
* Project: ixf1110 family device API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf1110/ixf1110_xgmac_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 7     10/21/03 10:40a Tepulkow
 * modified comment for xgmac status struct.
 * 
 * 6     9/25/03 10:10a Rnballar
 * moved rxconfigword to status struct
 * 
 * 5     9/18/03 12:05p Rnballar
 * 
 * 4     9/17/03 3:46p Rnballar
 * 
 * 3     9/16/03 10:14a Rnballar
 * port to ixf1110
 * 
 * 2     9/09/03 4:46p Tepulkow
 * Created and modified many header files for IXF GI creation
 * 
 * 1     8/04/03 3:51p Tepulkow
 * 
 * 1     5/16/03 1:43p Tepulkow
* 
* 8     1/30/03 4:40p Pkjain2
* Made changes for PTQ release. Added Getstatus calls for SONET and
* GLOBAL block.
* 
* 7     11/12/02 2:29p Jaalliso
* XGMAC_CNTL/XGMAC_CNTL2 B0 silicon changes
* 
* 6     7/08/02 1:17p Pkjain2
* Moved Calypso specific data stuctures into Calypso block specific data
* structure file.
* 
* 3     8/24/01 3:16p Wrbrackn
* Removed case structure in XGMAC_PP register per Mark's request.
* 
* 2     8/23/01 5:43p Wrbrackn
* Test driver that tests the sets and gets now compiles cleanly.
* 
* 1     8/23/01 4:13p Wrbrackn
* Seperated data structures out from main header file.
*
* --------------------------------------------------------------------------
*/

#ifndef __IXF1110_XGMAC_D_H__
#define __IXF1110_XGMAC_D_H__


#include "ixf_bitfield_macros.h"


/*	Station Address Struct:
	Station Address Register Low (Addr: Port_Index + 0x00)
	Station Address Register High (Addr: Port_Index + 0x01)
*/
typedef struct {

	ulong ulStationAddrLow;
	ulong ulStationAddrHi;

} ixf1110_Xgmac_StationAddr_t;


/*FDFC Type Register (Addr: Port_Index + 0x03)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiFDFCType				:16,
				uint						:16
		);
	} tCnfg;

} ixf1110_Xgmac_FDFCType_t;

/*FC TX Timer Value Register (Addr: Port_Index + 0x07)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiFCTxTimer			:16,
				uint						:16
		);
	} tCnfg;

} ixf1110_Xgmac_FCTxTimer_t;


/*FDFC Address Struct:
FDFC Address Low Register (Addr: Port_Index + 0x08)
FDFC Address High Register (Addr: Port_Index + 0x09)*/
typedef struct {

	ulong ulFDFCAddrLow;
	ulong ulFDFCAddrHi;

} ixf1110_Xgmac_FDFCAddr_t;

/*IPG Transmit Time Register (Addr: Port_Index + 0x0C)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiIPGTxTime			:10,
				uint						:22
		);
	} tCnfg;

} ixf1110_Xgmac_IPGTxTime_t;


/*Pause Threshold Register (Addr: Port_Index + 0x0E)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiPauseThresh			:16,
				uint						:16
		);
	} tCnfg;

} ixf1110_Xgmac_PauseThreshold_t;

/*Max Frame Size Register (Addr: Port_Index + 0x0F)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiMaxFrameSize			:14,
				uint						:18
		);
	} tCnfg;

} ixf1110_Xgmac_MaxFrameSize_t;

/*FC Enable Register (Addr: Port_Index + 0x12)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_3(
				uint uiRX_FD_FC			:1,
				uint uiTX_FD_FC			:1,
				uint					:30
		);
	} tCnfg;

} ixf1110_Xgmac_FCEnable_t;


/*Short Runts Threshold Register (Addr: Port_Index + 0x14)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiShrtRntThrsh			:5,
				uint						:27
		);
	} tCnfg;

} ixf1110_Xgmac_ShortRuntThresh_t;



/*Discard Unknown Control Frame Register (Addr: Port_Index + 0x15)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_2(
				uint uiDisUnkCtrlFrm		:1,
				uint						:31
		);
	} tCnfg;

} ixf1110_Xgmac_DisUnkCtrlFrm_t;

/*RX Config Word Register (Addr: Port_Index + 0x16)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_16(
				uint						:5,
				uint uiFullDuplex			:1,
				uint uiHalfDuplex			:1,
				uint uiSymPause				:1,
				uint uiAsymPause			:1,
				uint						:3,
				uint uiRemoteFault			:2,
				uint 						:1,
				uint uiNextPage				:1,
				uint uiCarrierSense			:1,
				uint uiInvalidWord			:1,
				uint uiConfigChanged		:1,
				uint uiRXConfig				:1,
				uint RXSync					:1,
				uint uiAn_complete			:1,
				uint 						:10
		);
	} tCnfg;

} ixf1110_Xgmac_RxConfigWord_t;

/*TX Config Word Register (Addr: Port_Index + 0x16)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_10(
				uint						:5,
				uint uiFullDuplex			:1,
				uint uiHalfDuplex			:1,
				uint uiSymPause				:1,
				uint uiAsymPause			:1,
				uint						:3,
				uint uiRemoteFault			:2,
				uint 						:1,
				uint uiNextPage				:1,
				uint 						:16
		);
	} tCnfg;

} ixf1110_Xgmac_TxConfigWord_t;



/*Diverse Config Register (Addr: Port_Index + 0x18)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_5(
				uint						:5,
				uint uiAN_enable			:1,
				uint uiCrc_add				:1,
				uint uiPad_enable			:1,
				uint						:24
		);
	} tCnfg;

} ixf1110_Xgmac_DivCfgWord_t;

/*RX Packet Filter Control Register (Addr: Port_Index + 0x19)*/
typedef union {

	ulong ulReg;
	struct {
		BITFIELD_7(
				uint uiUCastMatch_En		:1,
				uint uiMCastMatch_En		:1,
				uint uiBCastDrop_En			:1,
				uint uiVLANDrop_En			:1,
				uint uiPauseFrmPass			:1,
				uint uiCRCErrorPass			:1,
				uint 						:26
		);
	} tCnfg;

} ixf1110_Xgmac_RxPktFilter_t;


/*	Port Multicast Address Struct:
	Port Multicast Address Low Register (Addr: Port_Index + 0x1A)
	Port Multicast Address High Register (Addr: Port_Index + 0x1B)
*/
typedef struct {

	ulong ulPortMultCstAddrLow;
	ulong ulPortMultCstAddrHi;

} ixf1110_Xgmac_PortMultCstAddr_t;


/*xgmac config struct*/
typedef struct {
        
	ixf1110_Xgmac_StationAddr_t			Xgmac_StationAddr;
	ixf1110_Xgmac_FDFCType_t			Xgmac_FDFCType;
	ixf1110_Xgmac_FCTxTimer_t			Xgmac_FCTxTimer;
	ixf1110_Xgmac_FDFCAddr_t			Xgmac_FDFCAddr;
	ixf1110_Xgmac_IPGTxTime_t			Xgmac_IPGTxTime;
	ixf1110_Xgmac_PauseThreshold_t		Xgmac_PauseThreshold;
	ixf1110_Xgmac_MaxFrameSize_t		Xgmac_MaxFrameSize;
	ixf1110_Xgmac_FCEnable_t			Xgmac_FCEnable;
	ixf1110_Xgmac_ShortRuntThresh_t		Xgmac_ShortRuntThresh;
	ixf1110_Xgmac_DisUnkCtrlFrm_t		Xgmac_DisUnkCtrlFrm;
	ixf1110_Xgmac_TxConfigWord_t		Xgmac_TxConfigWord;
	ixf1110_Xgmac_DivCfgWord_t			Xgmac_DivCfgWord;
	ixf1110_Xgmac_RxPktFilter_t			Xgmac_RxPktFilter;
	ixf1110_Xgmac_PortMultCstAddr_t		Xgmac_PortMultCstAddr;


} ixf1110_XgmacCfg_t;


/*xgmac status struct*/
typedef struct {

	ixf1110_Xgmac_RxConfigWord_t		Xgmac_RxConfigWord;

} ixf1110_XgmacStatus_t;


#endif /*__IXF1110_XGMAC_D_H__*/
