/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf_api_ether_d.h $
*   WORKFILE:       $Workfile: ixf_api_ether_d.h $
*
* --------------------------------------------------------------------------
* Project: All
*
* Purpose: This file defines Ethernet related types
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf_api_ether_d.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 5     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
 * 4     9/18/03 8:47a Tepulkow
 * Added conditional for 1110_lib to alter xgmacCounter struct for ixf1110
 * port
* --------------------------------------------------------------------------
*/
#ifndef __IXF_API_ETHER_D_H__
#define __IXF_API_ETHER_D_H__

typedef uint64Struct_t IxfApi_MacAddress_t;

typedef struct
{
#ifdef	INCLUDE_1110_LIB
    ulong  OctetsTxOK;
    ulong  OctetsTxBad;
    ulong  UnicastFramesTxOK;
    ulong  MulticastFramesTxOK;
    ulong  BroardcastFramesTxOK;
    ulong  Counter64OctetTxFrames;
    ulong  Counter65to127TxFrames;
    ulong  Counter128to255TxFrames;
    ulong  Counter256to511TxFrames;
    ulong  Counter512to1023TxOK;
    ulong  Counter1024to15xxTxOK;
    ulong  Counter15xxtoMaxTxOK;
    ulong  DeferredTx;
    ulong  TotalCollisionsTx;
    ulong  SingleCollisionsTx;
    ulong  MultiCollisionsTx;
    ulong  LateCollisionsTx;
    ulong  ExcessCollisionsTx;
    ulong  ExcessDeferralTx;
    ulong  ExcessLengthDropTx;
    ulong  UnderrunTx;
    ulong  TaggedTx;
    ulong  CRCErrTx;
    ulong  PAUSECtrlFramesTx;
    ulong  FlowCtlCollisionsSendTx;
    ulong  OctetsRxOK;
    ulong  OctetsRxBad;
    ulong  UnicastFramesRxOK;
    ulong  MulticastFramesRxOK;
    ulong  BroardcastFramesRxOK;
    ulong  Counter64OctetRxFrames;
    ulong  Counter65to127RxFrames;
    ulong  Counter128to255RxFrames;
    ulong  Counter256to511RxOK;
    ulong  Counter512to1023RxOK;
    ulong  Counter1024to15xxRxOK;
    ulong  Counter15xxtoMaxRxOK;
    ulong  FCSErrRx;
    ulong  TaggedRx;
    ulong  DataErrRx;
    ulong  AlignErrRx;
    ulong  LongErrRx;
    ulong  JabbersErrRx;
    ulong  PAUSEMACCtrlFramesRx;
    ulong  UnknownCtlCntRx;
    ulong  VeryLongErrRx;
    ulong  RuntErrRx;
    ulong  ShortErrRx;
    ulong  CarierExtErrRx;
    ulong  SequenceErrRx;
    ulong  SymbolErrRx;
#else
    uint64Struct_t  OctetsTxOK;
    uint64Struct_t  MulticastFramesTxOK;
    uint64Struct_t  BroadcastFramesTxOK;
    uint64Struct_t  FramesTxOK;
    uint64Struct_t  Counter64OctetTxFrames;
    uint64Struct_t  Counter65to127TxFrames;
    uint64Struct_t  Counter128to255TxFrames;
    uint64Struct_t  Counter256to511TxFrames;
    uint64Struct_t  Counter512to1023TxOK;
    uint64Struct_t  Counter1024to15xxTxOK;
    uint64Struct_t  Counter15xxtoMaxTxOK;
    uint64Struct_t  VLANFramesTxOK;
    uint64Struct_t  PAUSECtrlFramesTx;
    uint64Struct_t  UnicastFramesTxOK;
    uint64Struct_t  MACCtrlFramesTx;
    uint64Struct_t  OctetsRxOK;
    uint64Struct_t  MulticastFramesRxOK;
    uint64Struct_t  BroadcastFramesRxOK;
    uint64Struct_t  FramesRxOK;
    uint64Struct_t  Counter64OctetRxFrames;
    uint64Struct_t  Counter65to127RxFrames;
    uint64Struct_t  Counter128to255RxFrames;
    uint64Struct_t  Counter256to511RxOK;
    uint64Struct_t  Counter512to1023RxOK;
    uint64Struct_t  Counter1024to15xxRxOK;
    uint64Struct_t  Counter15xxtoMaxRxOK;
    uint64Struct_t  VLANFramesRxOK;
    uint64Struct_t  PAUSEMACCtrlFramesRx;
    uint64Struct_t  UnicastFramesRxOK;
    uint64Struct_t  MACCtrlFramesRx;
    uint64Struct_t  EtherStatsUndersizePkts;
    uint64Struct_t  EtherStatsOversizePkts;
    uint64Struct_t  EtherStatsOctets;
    uint64Struct_t  EtherStatsPkts;
    uint64Struct_t  EtherStatsFragments;
    uint64Struct_t  EtherStatsJabbers;
    uint64Struct_t  FrameCheckSeqErr;
#endif	/*INCLUDE_1110_LIB*/
} ixfApi_XgmacCounters_t;


#endif /*__IXF_API_ETHER_D_H__*/
