/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf_bitfield_macros.h $
*   WORKFILE:       $Workfile: ixf_bitfield_macros.h $
*
* --------------------------------------------------------------------------
* Project: IXF API
*
* Purpose: 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags:   -DLITTLE_ENDIAN_BITFIELD or -DBIG_ENDIAN_BITFIELD (but
*                  not both) must be defined at compile time to control
*                  the "endianness" of bitfields. 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/ixf_bitfield_macros.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 2     10/07/03 2:02p Tepulkow
 * General cleanup for code review
 * 
* 
* --------------------------------------------------------------------------
*/

#ifndef __BITFIELD_H__
#define __BITFIELD_H__

/* Verify that both little and big endian bitfield compiler flags are not set */
#ifdef LITTLE_ENDIAN_BITFIELD
#ifdef BIG_ENDIAN_BITFIELD

#error ERROR - BOTH LITTLE_ENDIAN_BITFIELD AND BIG_ENDIAN_BITFIELD DEFINED

#endif
#endif

/* Little Endian bitfields? */
#ifdef LITTLE_ENDIAN_BITFIELD

#define BITFIELD_2(a,b) a; b;

#define BITFIELD_3(a,b,c) a; b; c;

#define BITFIELD_4(a,b,c,d) a; b; c; d;

#define BITFIELD_5(a,b,c,d,e) a; b; c; d; e; 

#define BITFIELD_6(a,b,c,d,e,f) a; b; c; d; e; f;

#define BITFIELD_7(a,b,c,d,e,f,g) a; b; c; d; e; f; g; 

#define BITFIELD_8(a,b,c,d,e,f,g,h) a; b; c; d; e; f; g; h;

#define BITFIELD_9(a,b,c,d,e,f,g,h,i) a; b; c; d; e; f; g; h; i;

#define BITFIELD_10(a,b,c,d,e,f,g,h,i,j) a; b; c; d; e; f; g; h; i; j;

#define BITFIELD_11(a,b,c,d,e,f,g,h,i,j,k) a; b; c; d; e; f; g; h; i; j; k;

#define BITFIELD_12(a,b,c,d,e,f,g,h,i,j,k,l) a; b; c; d; e; f; g; h; i; j; k; \
l;

#define BITFIELD_13(a,b,c,d,e,f,g,h,i,j,k,l,m) a; b; c; d; e; f; g; h; i; j; \
k; l; m;

#define BITFIELD_14(a,b,c,d,e,f,g,h,i,j,k,l,m,n) a; b; c; d; e; f; g; h; i; \
j; k; l; m; n;

#define BITFIELD_15(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o;

#define BITFIELD_16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p;

#define BITFIELD_17(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p; q;

#define BITFIELD_18(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p; q; r;

#define BITFIELD_19(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p; q; r; s;

#define BITFIELD_20(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p; q; r; s; t;

#define BITFIELD_21(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p; q; r; s; t; u;

#define BITFIELD_22(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v) a; b; c; d; e; f; g; h; \
i; j; k; l; m; n; o; p; q; r; s; t; u; v;

#else

/* Big Endian bitfields? */
#ifdef  BIG_ENDIAN_BITFIELD

#define BITFIELD_2(a,b) b; a;

#define BITFIELD_3(a,b,c) c; b; a;

#define BITFIELD_4(a,b,c,d) d; c; b; a;

#define BITFIELD_5(a,b,c,d,e) e; d; c; b; a;

#define BITFIELD_6(a,b,c,d,e,f) f; e; d; c; b; a;

#define BITFIELD_7(a,b,c,d,e,f,g) g; f; e; d; c; b; a;

#define BITFIELD_8(a,b,c,d,e,f,g,h) h; g; f; e; d; c; b; a;

#define BITFIELD_9(a,b,c,d,e,f,g,h,i) i; h; g; f; e; d; c; b; a;

#define BITFIELD_10(a,b,c,d,e,f,g,h,i,j) j; i; h; g; f; e; d; c; b; a;

#define BITFIELD_11(a,b,c,d,e,f,g,h,i,j,k) k; j; i; h; g; f; e; d; c; b; a;

#define BITFIELD_12(a,b,c,d,e,f,g,h,i,j,k,l) l; k; j; i; h; g; f; e; d; c; b; \
a;

#define BITFIELD_13(a,b,c,d,e,f,g,h,i,j,k,l,m) m; l; k; j; i; h; g; f; e; d; \
c; b; a;

#define BITFIELD_14(a,b,c,d,e,f,g,h,i,j,k,l,m,n) n; m; l; k; j; i; h; g; f; \
e; d; c; b; a;

#define BITFIELD_15(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) o; n; m; l; k; j; i; h; g; \
f; e; d; c; b; a;

#define BITFIELD_16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;
#define BITFIELD_17(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q) q; p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;

#define BITFIELD_18(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r) r; q; p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;

#define BITFIELD_19(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s) s; r; q; p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;

#define BITFIELD_20(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t) t; s; r; q; p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;

#define BITFIELD_21(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u) u; t; s; r; q; p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;

#define BITFIELD_22(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v) v; u; t; s; r; q; p; o; n; m; l; k; j; i; \
h; g; f; e; d; c; b; a;

#else 

/* Neither big or little endian bitfields defined.  Halt compile with error. */
#error ERROR - LITTLE_ENDIAN_BITFIELD OR BIG_ENDIAN_BITFIELD NOT DEFINED

#endif /* else clause of error check for no big/little endian compile flag */

#endif /* else clause of Big Endian bitfields? */

#endif /*__BITFIELD_H__ */

