/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:06p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/os_linux.h $
*   WORKFILE:       $Workfile: os_linux.h $
*
* --------------------------------------------------------------------------
* Project: Angel Island
*
* Purpose: Provides the specification to the linux support routines and data
*          definitions.
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/IXF/os_linux.h $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 2     10/07/03 2:02p Tepulkow
 * General cleanup for code review
* --------------------------------------------------------------------------
*/

#ifdef IXF_LINUX 

#ifndef __LINUXOSSUPPORT_H__
#define __LINUXOSSUPPORT_H__

typedef sem_t *SEM_ID;
typedef void VOID;
typedef int MSG_Q_ID;
typedef int (*FUNCPTR) (void);  /* ptr to function returning int */
#define OK 0
#define ERROR -1
#define NO_WAIT 0
#define WAIT_FOREVER -1
#define STATUS int
#define FOREVER while(1)

#include <pthread.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>

/**********************************************************/
/* Example Linux mapping file for OSAL functions that     */
/* require more than a #define to work with Linux.        */
/**********************************************************/

/**********************************************************/
/* Memory allocation functions                            */
/**********************************************************/
/* These functions taken care of in the os.h via #defines */

/**********************************************************/
/* Binary semaphore functions                             */
/**********************************************************/
/* These functions require C mappings rather than #defines*/
extern sem_t *LinuxSemCreate (void);
extern int LinuxSemTake (sem_t * id, int timeout);
extern void LinuxSemDestroy (sem_t * id);

#endif
#endif

