/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/05/04 2:59p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:14p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/TEST_APP/test2810.c $
*   WORKFILE:       $Workfile: test2810.c $
*
 *-------------------------------------------------------------------------------
 *	Description:
 *-------------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd2810/TEST_APP/test2810.c $
 * 
 * 1     3/05/04 2:59p Tepulkow
 * 
 * 1     3/05/04 2:58p Tepulkow
 * 
 * 1     3/05/04 2:54p Tepulkow
 * 
 * 8     10/07/03 2:04p Tepulkow
 * General cleanup for code review
 * 
* 
* --------------------------------------------------------------------------
*/
#include <linux/kernel.h>
#include <linux/module.h>
#include <asm/io.h>
#include <asm/hardware.h>
#include <asm/irq.h>
#include "common_types.h"
#include "common_def.h"
#include "bld1110.h"
#include "ixf1110_alarms_d.h"
#include "ixf_api_ether_d.h"
#include "ixf_api_d.h" /* BroadBand Utility Definitions and Function headers */
#include "ixf_api.h"
#include "hal.h"

//typedef void       (*ISRFuncPtr_t)(void *pChipData);

//extern void IxfRegisterInterrupt();
//extern void IxfDeleteISRChipData();

InitRegTable_t RegInitIXF1110Table[] =
{

	{ (bb_RegPointer_type) 0x509, 0x2}, /* LED control*/
	{ (bb_RegPointer_type) 0x502, 0xF}, /* LED Enalble of first four ports */
	{ (bb_RegPointer_type) 0x500, 0x3FF}, /* Port Enalble*/
	{ (bb_RegPointer_type) 0x0000, 0x11223344}, /* station addr low port 0 */
	{ (bb_RegPointer_type) 0x0601, 0x00005566}, /* station addr hi port 1 */
	{ (bb_RegPointer_type) 0x0602, 0xaabbccdd}, /* station addr low port 9 */
	{ (bb_RegPointer_type) 0x0603, 0x0000eeff}, /* station addr hi port 9 */
	{ (bb_RegPointer_type) 0x0600, 0x00000999}, /* tx FIFO Hi water port 0 */
	{ (bb_RegPointer_type) 0x0601, 0x00000888}, /* tx FIFO Hi water port 1 */
	{ (bb_RegPointer_type) 0x0602, 0x00000777}, /* tx FIFO Hi water port 2 */
	{ (bb_RegPointer_type) 0x0603, 0x00000666}, /* tx FIFO Hi water port 3 */
	{ (bb_RegPointer_type) 0x060a, 0x00000200}, /* tx FIFO low water port 0 */
	{ (bb_RegPointer_type) 0x060b, 0x00000200}, /* tx FIFO low water port 1 */
	{ (bb_RegPointer_type) 0x060c, 0x00000200}, /* tx FIFO low water port 2 */
	{ (bb_RegPointer_type) 0x06cd, 0x00000200}, /* tx FIFO low water port 3 */
	{ (bb_RegPointer_type) 0x0580, 0x00000840}, /* rx FIFO Hi water port 0*/
	{ (bb_RegPointer_type) 0x058a, 0x00000530}, /* rx FIFO lowwater port 0*/
	{ (bb_RegPointer_type) 0xffff, 0xa5a5}	/* end marker */
};

InitRegTable_t BoardInitIXF1110Table[] =
{
	{ (bb_RegPointer_type) 0x509, 0x2}, /* LED control*/
	{ (bb_RegPointer_type) 0x502, 0x3ff}, /* LED Enalble of first four ports */
	{ (bb_RegPointer_type) 0x500, 0x3FF}, /* Port Enalble*/
	{ (bb_RegPointer_type) ((0*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((1*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((2*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((3*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((4*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((5*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((6*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((7*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((8*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) ((9*0x80)+0x0018), 0x116D}, 
	{ (bb_RegPointer_type) 0xffff, 0xa5a5}	/* end marker */
};

void TestAlarmCallback (pChipData, AlarmType, pAlarmStatus)
{
	printk("Arrived at the IXD2810 alarm callback function!\n");

	printk("ISR sent %x for Gbic_Status\n", ((ixf1110_AlarmCfgSet_t *)pAlarmStatus)->Gbic_Status.ulReg);	
	printk("ISR sent %x for Gbic_Change\n", ((ixf1110_AlarmCfgSet_t *)pAlarmStatus)->Gbic_Change.ulReg);		

}

void TestIxfApiMain (void)
{

    ulong  sz=0;
    ulong  set_sz=0;
    bb_ChipData_t chipData;
    char string64[] = "Expected J0 String that is longer than 64 bytes in length and should be truncated ";
    bb_RegPointer_type pReg;
    bb_ChipInfo_t	ChipInfo;
    uchar           J0String[64];
    ushort usTest1;
    ushort usTest2;
    bb_ChipSegment_t section;
	IxfApi_MacAddress_t macaddress;
    ushort len;
    int i;
    bb_Error_e ixfStatus;
    char dataBuf[64];
    char myArray[512];
#ifdef INTERRUPT_SYSTEM_MODE
    ushort regVal;
#endif
    char *baseAddr;

    /* Setup a generic section parameter */
    section.block.block = 0;
    section.block.side = 0;
    section.block.flow = 0;
    section.group.channel = 0;
    section.indirect.slot = 0;
    section.value = 0;


    /***************/
    /* Test Case 1 */
    /***************/
    /* Test IXF API INIT */

    baseAddr = (char *)ioremap_nocache(0xc6000000,0x00800000);
    /* Test IxfApiInit */
    ixfStatus = IxfApiInit((bb_RegPointer_type)baseAddr , bb_1110_CHIP, &chipData);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIINIT TEST                     : PASSED\n");
    }
    else
    {
        printk("IXFAPIINIT TEST                     : FAILED\n");
    }

    /***************/
    /* Test Case 2 */
    /***************/
    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiAllocDataStructureMem(&chipData);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIALLOCDATASTRUCTMEM TEST       : PASSED\n");
    }
    else
    {
        printk("IXFAPIALLOCDATASTRUCTMEM TEST       : FAILED\n");
    }

#if 0
    /***************/
    /* Test Case 3 */
    /***************/
    /* Test DeAlloc Data Structure Memory */
    ixfStatus = IxfApiDeAllocMemory(&chipData);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIDEALLOCMEMORY TEST            : PASSED\n");
    }
    else
    {
        printk("IXFAPIDEALLOCMEMORY TEST            : FAILED\n");
    }
#endif
   
    /***************/
    /* Test Case 4 */
    /***************/

    /* Test IxfApiInitChip */
    ixfStatus = IxfApiInitChip(&chipData, RegInitIXF1110Table);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIINITCHIP TEST                 : PASSED\n");
    }
    else
    {
        printk("IXFAPIINITCHIP TEST                 : FAILED\n");
    }

    /***************/
    /* Test Case 5 */
    /***************/

    /* Get h/w info for chip  */
    ixfStatus = IxfApiGetChipInfo(&chipData, &ChipInfo);

    if (ixfStatus == bb_NO_ERROR)
    {
        if ((ChipInfo.ChipId == 0x2810) && (ChipInfo.ChipVersion == 3))
            printk("IXFAPIGETCHIPINFO TEST              : PASSED\n");
        else {
            printk("IXFAPIGETCHIPINFO TEST              : FAILED\n");
	    printk("Read ChipId: 0x%x, ChipVersion: 0x%x\n",ChipInfo.ChipId,ChipInfo.ChipVersion);
	    }
    }
    else
    {
        printk("IXFAPIGETCHIPINFO TEST              : FAILED\n");
    }



    /***************/
    /* Test Case 6 */
    /***************/
    /* Get Build Version */
    ixfStatus = IxfApiGetBuildVersion(&chipData, bb_SW_VERSION_CHIP_TYPE, dataBuf, myArray, &usTest1, &usTest2);

    if (ixfStatus == bb_NO_ERROR)
    {
        if (!(strcmp(dataBuf,IXF1110_BUILD_DRIVER_NAME)))
        {
            printk("IXFAPIGETBUILDVERSION TEST          : PASSED\n");
        }
	else
	{
	    printk("IXFAPIGETBUILDVERSION TEST FAILED: %s\n",dataBuf);
	}
    }
    else
    {
        printk("IXFAPIGETBUILDVERSION TEST          : FAILED\n");
    }


    /*******************/
    /* Test Case 7 & 8 */
    /*******************/
    /* Test Generic Read and Write */
    dataBuf[0] = 0xA;
    dataBuf[1] = 0xB;
    ixfStatus = IxfApiGenericWrite(&chipData, 4, 0x0, 1, dataBuf);

    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test Generic Read */
        memset(dataBuf,0,64);

        ixfStatus = IxfApiGenericRead(&chipData, 4, 0x0, 1, dataBuf);
        if ((dataBuf[0] == 0xA) && (dataBuf[1] == 0xB))
        {
            printk("IXFAPIGENERICREAD  TEST             : PASSED\n");
            printk("IXFAPIGENERICWRITE TEST             : PASSED\n");
        }
        else
        {
            printk("IXFAPIGENERICREAD TEST              : FAILED\n");
            printk("IXFAPIGENERICWRITE TEST             : FAILED\n");
        }
    }
    else
    {
        printk("IXFAPIGENERICWRITE TEST              : FAILED\n");
    }

    /***************/
    /* Test Case 9 */
    /***************/
	/* initialize the ports and interrupts*/

    ixfStatus = IxfApiInitChip(&chipData, BoardInitIXF1110Table);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIINIT BOARD                    : PASSED\n");
	printk("test_app sending %x for pChipData\n", &chipData);
	ixfStatus = ixd2810IsrInit(&chipData);
	   if (ixfStatus == bb_NO_ERROR)
	    {
 	       printk("IXFAPIINIT BOARD COMPLETE!\n");
	    }
	   else
 	   {
  	      printk("IXFAPIINIT BOARD                    : FAILED\n");
	   }	

    }

    ixfStatus = IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) TestAlarmCallback);
     if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIINITALARMCALLBACK              : PASSED\n");
    }
    else
    {
       printk("IXFAPIINITALARMCALLBACK               : FAILED\n");
    }


#if 0
    IxfApiChipIsr(&chipData);
     if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPICHIPISR                        : PASSED\n");
    }
    else
    {
       printk("IXFAPICHIPISR                         : FAILED\n");
    }
#endif




    /***************/
    /* Test Case 9 */
    /***************/
	/* test get and set mac address */

	for (i=0;i<10;i++)
	{
   		section.group.channel = i;
		macaddress.ulLowValue = i;
		macaddress.ulHighValue = i;
		ixfStatus = IxfApiSetMacAddress(&chipData, &section, &macaddress);
    	if (ixfStatus == bb_NO_ERROR)
		{
    		printk("IXFAPISETMACADDRESS  TEST Port %x     : PASSED\n", i);
		}
	    else
    	{
    		printk("IXFAPISETMACADDRESS  TEST Port %x     : FAILED\n", i);
		}
	}

	for (i=0;i<10;i++)
	{
   		section.group.channel = i;
		ixfStatus = IxfApiGetMacAddress(&chipData, &section, &macaddress);
    	if ((ixfStatus == bb_NO_ERROR)&&(macaddress.ulLowValue == i)&&(macaddress.ulHighValue == i))
		{
    		printk("IXFAPIGETMACADDRESS  TEST Port %x     : PASSED\n", i);
		}
	    else
    	{
    		printk("IXFAPIGETMACADDRESS  TEST Port %x     : FAILED\n", i);
		}
	}

	
    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) TestAlarmCallback);


	while(1);

#if 0
    /****************/
    /* Test Case 10 */
    /****************/
    /* ChipIsr Test */
    /* If we are executing this test, then system software enabling
    interrupts must be running */

    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */


    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) TestAlarmCallback);
//    IxfRegisterInterrupt(IRQ_IXDP2800_MEDIA,&chipData, (ISRFuncPtr_t) IxfApiChipIsr);
//    IxfRegisterInterrupt(IRQ_IXP2000_SWI,&chipData, (ISRFuncPtr_t) IxfApiChipIsr);

    printk("Registering is complete\n");

    IxfApiInitChip(&chipData, (InitRegTable_t*) RegInitIXF1110Table);

    /* Now, if an interrupt happens, the callback should be called
    and the callback will release the flag to complete this test */
    *IXP2000_INTCTL_REG(0x54) = 1;

    printk("IRQ test complete\n");

    /* Remove the entries in ISR Table for this pChipData */
    IxfDeleteISRChipData(&chipData);

    IxfApiReset(&chipData, &section, bb_RESET_CHIP);
#endif
}

int init_module(void)
{
	TestIxfApiMain();
	return 0;
}

void cleanup_module(void)
{
}

