 /*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:56p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/common_def.h $
 *   WORKFILE:       $Workfile: common_def.h $
 *
 * --------------------------------------------------------------------------
 * Project: All
 *
 * Purpose: This file defines types that are common to all IXF API and driver 
 *          modules
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/common_def.h $
 * 
 * 1     3/08/04 1:56p Tepulkow
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 1     6/27/03 4:42p Daly
 * 
 * 45    4/18/03 4:23p Jaalliso
 * Moving error code definition to ixf_api_error_d.h
 * 
 * 44    4/08/03 10:14a Jaalliso
 * Adding bb_MAX_ERRORCODES to bb_Error_e
 * 
 * 43    4/07/03 2:00p Jaalliso
 * Adding GROUP_4
 * 
 * 42    3/31/03 3:53p Rcordova
 * Added the code for the Sif 1930x Fpga Dll project.
 * 
 * 41    3/24/03 3:21p Rsood
 * Updated enum type for VC Errors
 * 
 * 40    3/13/03 4:51p Jaalliso
 * Adding CHANNEL_48
 * 
 * 39    3/06/03 3:37p Jaalliso
 * Adding SLOT_ #defines
 * 
 * 38    3/05/03 10:00a Jaalliso
 * Really adding GROUP_12
 * 
 * 37    2/18/03 9:49a Jaalliso
 * Adding bb_INV_CHANNEL and bb_INV_FLOW error codes to bb_Error_e
 * 
 * 36    2/10/03 4:02p Rsood
 * Updated VCU related error types and struct initRegTable
 * 
 * 35    1/07/03 11:55a Rsood
 * Added some Error types for VC block.
 * 
 * 34    12/19/02 10:49a Jjchin
 * Added a WARNING to adding a new ChipType to bb_ChipType_e enum.
 * 
 * 33    12/16/02 4:41p Jaalliso
 * Adding GROUP_16
 * 
 * 32    12/12/02 9:50p Machambe
 * Moving the uint64Struct_t into this file from ixf_api_ether_d.h
 * 
 * 31    12/12/02 3:34p Kssaepha
 * Added error codes to bb_Error_e for ixf30009
 * 
 * 30    12/12/02 1:58p Jaalliso
 * Adding #define GROUP_12 12
 * 
 * 29    12/12/02 11:41a Machambe
 * Adding different word size options for bb_RegPointer_type
 * 
 * 28    12/06/02 3:52p Rsood
 * Added #define for  GROUP_64 and bb_IXF19300_CHIP
 * 
 * 27    11/13/02 10:18a Jaalliso
 * Adding #defines for #channels
 * 
 * 26    11/05/02 10:59a Kssaepha
 * Added Ixf30009EvbPld
 * 
 * 25    10/29/02 11:40a Sksinha
 * 
 * 24    10/25/02 2:02p Rcordova
 * Added Button_info control in the Generic Spread Sheet, getchipoffset
 * dll function, changed lxt16708 to the new chip Dll structure and
 * implemented the chip in sftplatform, fixed column header bug in generic
 * spread Sheet, removed WinSelUtil.h from the dll and sftplatform
 * workspaces,added slider special case for lxt16708, added new
 * functionallity to the dllutil class, updated dll functions in the
 * bachelor and Tenabo Chip.
 * 
 * 23    10/18/02 11:51a Bbpillai
 * fix compiler error
 * 
 * 22    10/16/02 10:00a Sksinha
 * 
 * 21    9/30/02 4:40p Jaalliso
 * Adding ixf1930x chiptypes
 * 
 * 20    9/18/02 2:37p Djlager
 * Remove Bachelor types
 * 
 * 18    9/04/02 4:52p Kssaepha
 * Added new ChipTypes
 * 
 * 17    8/23/02 2:34p Rcordova
 * Added Ixf30009, and Lxt16708 Chips Declarations.
 * 
 * 16    7/08/02 1:17p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * 15    5/29/02 9:37a Jaalliso
 * Changing bb_18100_CHIP to bb_18101_CHIP, adding 18102/3/4 chips
 * 
 * 14    4/29/02 4:48p Ngifford
 * Integrated IXF3502 and IXF3503 based on Hailey
 * 
 * 13    4/17/02 2:07p Srodrig1
 * 
 * 12    4/05/02 12:34p Machambe
 * Moving the InitRegTable_t here
 * 
 * 11    3/19/02 3:15p Skadrix
 * Added 5 new chip types ...
 * FPGAs for Hailey STB  (4)
 * Hailey DV Board 
 * 
 * 10    3/02/02 12:04p Jaalliso
 * Adding return code section for VTB portion of the driver
 * 
 * 9     2/21/02 3:07p Jaalliso
 * Adding bb_FPGA_OIFMISC_1810X
 * 
 * 8     2/14/02 11:23a Jaalliso
 * Adding error code for unsupported IXF function
 * 
 * 7     1/30/02 10:38a Machambe
 * 
 * 6     1/08/02 11:10a Kssaepha
 * Modified Trace Macros
 * 
 * 5     1/02/02 12:05p Rsood
 * Added bb_MAX_NUM_CHIPS to bb_ChipType_e
 * 
 * 4     12/17/01 2:49p Pkjain2
 * Added Trace Macros
 * 
 * 3     12/06/01 4:32p Jaalliso
 * Putting in bb_WordSize_t
 * 
 * 2     12/05/01 9:33a Machambe
 * Moving Error Codes in this file.
 * 
 * 1     12/04/01 1:39p Jaalliso
 * Common definitions file
 * 
 * --------------------------------------------------------------------------
 */
#ifndef __COMMON_DEF_H__
#define __COMMON_DEF_H__

/******************************************************************************/
/* Including ixf_api_error_d.h here and defining bb_Error_e as a ushort       */
/* because error codes are being moved from common_def.h. and being defined   */
/* via #defines vs. enumerated type.                                          */  
/******************************************************************************/
#include "ixf_api_error_d.h"

typedef ushort bb_Error_e;      /* legacy support */


/******************************************************************************/
/* Common enum definintions                                                   */
/******************************************************************************/
/* IMPORTANT!!!!!! READ THIS BEFORE MODIFYING CODE BELOW      */
/*      Changing the order, or Adding Chip Types MAY affect   */
/*      The Serialize method in CSftPlatformDoc. Proceed with */
/*      Caution.                                              */
typedef enum   /* Identifies type of chip */
{
    bb_FPGA_6048_CHIP = 0,
    bb_6051_CHIP,         
    bb_IXF30007_CHIP,           /* IXF30007 Chip */
    bb_6048_CHIP,
    bb_FPGA_GEOS,               /* GEOS FPGA */
    bb_6192_CHIP,
    bb_FPGA_INS_6192,
    bb_FPGA_EXT_6192,
    bb_18101_CHIP,              /* IXF18101 Chip */
    bb_LXT16708_CHIP,           /* LXT16708 Chip */
    bb_IXF30009_CHIP,           /* IXF30009 Chip */
    bb_IXF30025_CHIP,           /* IXF30025 Chip */ 
    bb_IXF30005_CHIP,           /* IXF30005 Chip */  
    bb_16121_CHIP,              /* IXF16121 Chip */
    bb_FPGA_INS_18100,          /* STB insertion FPGA for 1810x */
    bb_FPGA_EXT_18100,          /* STB extraction FPGA for 1810x */
    bb_FPGA_SIF_18100,          /* SIF FPGA for ixf1810x */
    bb_FPGA_OIFMISC_18100,      /* OIF/Misc. board control logical FPGA for 1810x */
    bb_FPGA_INS_SOH_16121,      /* STB SOH Insertion FPGA for IXF 16121 */
    bb_FPGA_EXT_SOH_16121,      /* STB SOH Extraction FPGA for IXF 16121 */
    bb_FPGA_INS_SALPAL_16121,   /* STB SAL/PAL Insertion FPGA for IXF 16121 */
    bb_FPGA_EXT_SALPAL_16121,   /* STB SAL/PAL Extraction FPGA for IXF 16121 */
    bb_DVBOARD_16121,           /* DV Board for IXF 16121 */
    bb_GENERIC_CHIP,            /* Generic Chip */
    bb_IXF3502_CHIP,            /* IXF3502 */
    bb_IXF3503_CHIP,            /* IXF3503 */
    bb_18102_CHIP,              /* IXF18102 Chip */
    bb_18103_CHIP,              /* IXF18103 Chip */
    bb_18104_CHIP,              /* IXF18104 Chip */
    bb_18101_8023WIS_CHIP,      /* IXF18101 (with 802.3 WIS block) Chip */
    bb_18103_8023WIS_CHIP,      /* IXF18103 (with 802.3 WIS block) Chip */
    bb_IXF19300_CHIP,           /* IXF19300 */
    bb_IXF19301_CHIP,           /* IXF19301 */
    bb_IXF19302_CHIP,           /* IXF19302 */
    bb_IXF19303_CHIP,           /* IXF19303 */
    bb_LXT16708_DV_CHIP,        /* LXT16708 Dv Chip */ 
    bb_LXT16708_PI_CHIP,        /* LXT16708 Pi Chip */ 
    bb_LXT16708_DV_PI_CHIP,     /* LXT16708 Dv Pi Chip */
    bb_IXF35032_CHIP,           /* IXF35032 */
    bb_IXF30009_EVB_PLD,        /* IXF30009 EVB PLD */
/*Rossy Sif*/
    bb_FPGA_SIF_1930X,        /* SIF FPGA for Ixf1930x Chip */
    /* WARNING: Add your new chip here ONLY */
    bb_MAX_NUM_CHIPS
} bb_ChipType_e;

/* Define a Register pointer type that can be casted 
                 based upon the Chip type (16 bit or 8 bit) */

#ifdef IXF_REG_POINTER_32
typedef ulong *bb_RegPointer_type;
#elif IXF_REG_POINTER_8
typedef uchar *bb_RegPointer_type;
#else
typedef ushort *bb_RegPointer_type;
#endif
 
#ifdef IXF_REG_DATA_32
typedef ulong bb_RegDataValue_type;
#elif IXF_REG_DATA_8
typedef uchar bb_RegDataValue_type;
#else
typedef ushort bb_RegDataValue_type;
#endif


/******************************************************************************/
/* Common #defines                                                            */
/******************************************************************************/
#ifndef TRUE
#define  TRUE  1
#endif
#ifndef FALSE
#define  FALSE 0
#endif

#ifndef  NULL
#define  NULL  ((void*)0)  /* For use as NULL pointer value */
#endif

/******************************************************************************/
/* Common #defines for dimensioning arrays & loop counters                    */
/******************************************************************************/
#define CHANNEL_12  12
#define CHANNEL_16  16
#define CHANNEL_24  24
#define CHANNEL_32  32
#define CHANNEL_48  48
#define CHANNEL_64  64
#define CHANNEL_192 192
#define CHANNEL_256 256

#define GROUP_4     4
#define GROUP_12    12
#define GROUP_16    16
#define GROUP_64    64

#define SLOT_12     12
#define SLOT_192    192

/* Defined word sizes */
typedef enum 
{
    ONE_BYTE    =   1,
    TWO_BYTES   =   2,
    FOUR_BYTES  =   4,
    EIGHT_BYTES =   8,
    MAX_BYTES
} bb_Word_Size_t;

typedef struct
{
    ulong    ulLowValue;
    ulong    ulHighValue;
} uint64Struct_t;

/* Defines the structure to be used by the InitChip routine */
typedef struct initRegTable
{
    bb_RegPointer_type    offset;
    bb_RegDataValue_type  value;
} InitRegTable_t;

/* Function pointer for Alarm Callbacks */  
typedef void (*AlarmCallBack)(
        void *pChipData, 
        ulong AlarmType,                /* Type of Alarm */
        void *pAlarmStatusCounters);    /* -> Alarm status counter ptr*/


#ifdef INCLUDE_TRACE

#ifdef SIMULATOR
extern void PrintToView(char *sString);

#define IXF_FUNC_ENTRY_TRC(fmtStr)      \
do {\
char Buffer[129] = "Entering: ";\
strcat(Buffer, fmtStr);\
strcat(Buffer, "\r\n");\
PrintToView(Buffer);\
} while(0);

#define IXF_FUNC_EXIT_TRC(fmtStr, retVal)   \
do {\
char Buffer[129] = "Exiting: ";\
strcat(Buffer, fmtStr);\
strcat(Buffer, " with Return Code: %d\r\n");\
sprintf(Buffer, Buffer, retVal);\
PrintToView(Buffer);\
} while(0);

#else /* SIMULATOR */

#define IXF_FUNC_ENTRY_TRC(fmtStr)      printf(fmtStr)

#define IXF_FUNC_EXIT_TRC(fmtStr, retVal)   printf(fmtStr, retVal)

#endif /* SIMULATOR */

#else /* INCLUDE_TRACE */

#define IXF_FUNC_ENTRY_TRC(fmtStr)

#define IXF_FUNC_EXIT_TRC(fmtStr, retVal)

#endif /* INCLUDE_TRACE */

#endif /* __COMMON_DEF_H__ */
