/*---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/include/ixf18100_alarms.h $
 *   WORKFILE:       $Workfile: ixf18100_alarms.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 family device API
 *
 * Purpose: This file contains function prototypes for alarms related
 *          routines
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/include/ixf18100_alarms.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 1     6/27/03 4:42p Daly
 * 
 * 13    2/20/03 3:19p Kssaepha
 * Changed ifndef logic to ifdef to allow a combination of ixf1810x's to
 * be defined
 * 
 * 12    1/30/03 4:41p Pkjain2
 * Made changes for PTQ release. Added Getstatus calls for SONET and
 * GLOBAL block.
 * 
 * 11    1/10/03 2:30p Pkjain2
 * 
 * 8     11/11/02 3:53p Jaalliso
 * Conditional compilation for Ixf18103/4
 * 
 * 7     10/17/02 11:34a Jaalliso
 * Replacing tab characters with spaces
 * 
 * 6     8/12/02 5:30p Machambe
 * Adding IXF1810x Family support
 * 
 * 5     1/25/02 11:06a Srodrig1
 * 
 * 4     1/21/02 9:41p Srodrig1
 * 
 * 
 * 1     12/15/01 9:58p Srodrig1
 * Initial check in - file headers only
 * 
 * --------------------------------------------------------------------------
 */

#ifndef IXF18100_ALARMS_H
#define IXF18100_ALARMS_H

/******************************************************************************
* Function : EditGlbChipAlarms
*------------------------------------------------------------------------------
* Description : Edit Global Chip Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           GlobalChipIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void 
Ixf18100EditGlbChipAlarms(bb_RegPointer_type BaseAddress,
                          ushort *GlobalChipIntAlarms);

/******************************************************************************
* Function : EditGlbClkAlarms
*------------------------------------------------------------------------------
* Description : Edit Global Clock Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           GlobalClkIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditGlbClkAlarms(bb_RegPointer_type BaseAddress,
                      ushort *GlobalClkIntAlarms);

/******************************************************************************
* Function : EditGlbAlarms
*------------------------------------------------------------------------------
* Description : Edit Global Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           GlobalIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditGlbAlarms(bb_RegPointer_type BaseAddress,
                      ushort *GlobalIntAlarms);

/******************************************************************************
* Function : EditSifAlarms
*------------------------------------------------------------------------------
* Description : Edit SIF Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           SifIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditSifAlarms(bb_RegPointer_type BaseAddress,
                      ushort *SifIntAlarms);

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
/******************************************************************************
* Function : EditPosRcvAlarms
*------------------------------------------------------------------------------
* Description : Edit POS Receive Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           PosRcvIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditPosRcvAlarms(bb_RegPointer_type BaseAddress,
                         ushort *PosRcvIntAlarms);

/******************************************************************************
* Function : EditPosXmtAlarms
*------------------------------------------------------------------------------
* Description : Edit POS Transmit Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           PosXmtIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditPosXmtAlarms(bb_RegPointer_type BaseAddress,
                         ushort *PosXmtIntAlarms);

/******************************************************************************
* Function : EditGfpAlarms
*------------------------------------------------------------------------------
* Description : Edit GFP Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           GfpIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditGfpAlarms(bb_RegPointer_type BaseAddress,
                      ushort *GfpIntAlarms);

#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) */


/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)

/******************************************************************************
* Function : EditWisAlarms
*------------------------------------------------------------------------------
* Description : Edit WIS Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           WisIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditWisAlarms(bb_RegPointer_type BaseAddress,
                      ushort *WisIntAlarms);

/******************************************************************************
* Function : EditRlPohAlarms
*------------------------------------------------------------------------------
* Description : Edit Receive Line POH Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           RlPohIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditRlPohAlarms(bb_RegPointer_type BaseAddress,
                        ushort *RlPohIntAlarms);

/******************************************************************************
* Function : EditRlJ1Alarms
*------------------------------------------------------------------------------
* Description : Edit Receive Line J1 Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           RlJ1IntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditRlJ1Alarms(bb_RegPointer_type BaseAddress,
                       ushort *RlJ1IntAlarms);

/******************************************************************************
* Function : EditRlPtrAlarms
*------------------------------------------------------------------------------
* Description : Edit Receive Line Pointer Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           RlPtrIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditRlPtrAlarms(bb_RegPointer_type BaseAddress,
                        ushort *RlPtrIntAlarms);

/******************************************************************************
* Function : EditRlLohAlarms
*------------------------------------------------------------------------------
* Description : Edit Receive Line Overhead Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           RlLohIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditRlLohAlarms(bb_RegPointer_type BaseAddress,
                        ushort *RlLohIntAlarms);

/******************************************************************************
* Function : Ixf18100EditRlSohAlarms
*------------------------------------------------------------------------------
* Description : Edit Receive Line SOH Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           RlSohIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditRlSohAlarms(bb_RegPointer_type BaseAddress,
                        ushort *RlSohIntAlarms);

/******************************************************************************
* Function : EditTxTimAlAlarms
*------------------------------------------------------------------------------
* Description : Edit Transmit Tim Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           TxTimAlIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditTxTimAlAlarms(bb_RegPointer_type BaseAddress,
                          ushort *TxTimAlIntAlarms);

/******************************************************************************
* Function : EditSerAlAlarms
*------------------------------------------------------------------------------
* Description : Edit Serial Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           SerAlIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditTTPrtAlarms(bb_RegPointer_type BaseAddress,
                        ushort *SerAlIntAlarms);
    
/******************************************************************************
* Function : EditTTSerPrt1Alarms
*------------------------------------------------------------------------------
* Description : Edit TT Serial Port 1 Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           TTSerPrt1IntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditTTSerPrt1Alarms(bb_RegPointer_type BaseAddress,
                      ushort *TTSerPrt1IntAlarms);
    
/******************************************************************************
* Function : EditTTSerPrt1Alarms
*------------------------------------------------------------------------------
* Description : Edit TT Serial Port 2 Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           TTSerPrt2IntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditTTSerPrt2Alarms(bb_RegPointer_type BaseAddress,
                            ushort *TTSerPrt2IntAlarms);

/******************************************************************************
* Function : Ixf18100EditApsWisAlarms
*------------------------------------------------------------------------------
* Description : Edit APS WIS Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           ApsWisIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditApsWisAlarms(bb_RegPointer_type BaseAddress,
                         ushort *ApsWisAlarms);

/******************************************************************************
* Function : Ixf18100EditApsRlLohAlarms
*------------------------------------------------------------------------------
* Description : Edit APS Receive Line Overhead Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           ApsRlLohIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditApsRlLohAlarms(bb_RegPointer_type BaseAddress,
                           ushort *ApsRlLohAlarms);
   
/******************************************************************************
* Function : Ixf18100EditApsRlSohAlarms
*------------------------------------------------------------------------------
* Description : Edit APS Receive Line SOH Interrupts Enable Masks
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           ApsRlSohIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditApsRlSohAlarms(bb_RegPointer_type BaseAddress,
                           ushort *ApsRlSohAlarms);

#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
          defined(INCLUDE_18103_LIB) */

/******************************************************************************
* Function : MasterInterruptHandler
*------------------------------------------------------------------------------
* Description : Master Interrupt Handler
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           pAlarmCallback : User Alarm Callback Function Pointer
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
ixf18100MasterInterruptHandler(bb_ChipData_t *pChipData,
                               ixf18100_GlbChpIntStat_t *glbChipStat,          
                               AlarmCallBack pAlarmCallback);

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)

/******************************************************************************
* Function : EditPcsAlarms
*------------------------------------------------------------------------------
* Description : Edit PCS Interrupts Enable Mask
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           PcsIntAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditPcsAlarms(bb_RegPointer_type BaseAddress,
                      ushort *PcsIntAlarms);

/******************************************************************************
* Function : Ixf18100EditXgmacAlarms
*------------------------------------------------------------------------------
* Description : Edit XGMAC Interrupts Enable Mask
*------------------------------------------------------------------------------
* Inputs  : BaseAddress : Pointer to the base address of the device
*           XgmacAlarms : The value of the enable masks
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : None.
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.  
******************************************************************************/
extern void
Ixf18100EditXgmacAlarms(bb_RegPointer_type BaseAddress,
                        ixf18100_XgmacIntCfg_t *XgmacAlarms);

#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
          defined(INCLUDE_18104_LIB) */

#endif  /* IXF18100_ALARMS_H */
