/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100.c $
 *   WORKFILE:       $Workfile: ixf18100.c $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 family device API
 *
 * Purpose: This file contains the device specific API's called by the IXF API
 *          layer.
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100.c $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 58    2/20/03 3:19p Kssaepha
 * Changed ifndef logic to ifdef to allow a combination of ixf1810x's to
 * be defined
 * 
 * 57    1/30/03 4:40p Pkjain2
 * Made changes for PTQ release. Added Getstatus calls for SONET and
 * GLOBAL block.
 * 
 * 56    1/10/03 2:30p Pkjain2
 * 
 * 54    1/03/03 1:43p Pkjain2
 * 
 * 53    12/12/02 9:49p Machambe
 * Adding IXF_LINUX
 * 
 * 52    12/11/02 1:23p Jaalliso
 * Fixing chiptype error checking
 * 
 * 51    12/02/02 2:25p Kssaepha
 * Added support for Setting GFP OpModes 
 * 
 * 50    11/18/02 3:24p Jaalliso
 * Conditional compilation for ixf1810x family
 * 
 * 49    11/15/02 3:33p Jaalliso
 * ixf1810x conditional compilation for ixf18100_GetStatus()
 * 
 * 48    11/12/02 2:25p Jaalliso
 * Ixf18101 conditional compile debug
 * 
 * 47    11/11/02 11:58a Jaalliso
 * Resolving issues building for ixf18103
 * 
 * 46    11/07/02 11:20a Jaalliso
 * Changes to support INCLUDE_IXF18102_LIB
 * 
 * 45    8/13/02 1:20p Pkjain2
 * 
 * 44    8/12/02 5:28p Machambe
 * Adding IXF1810x Family support
 * 
 * 43    7/08/02 1:16p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * 42    6/04/02 1:28p Pkjain2
 * 
 * 41    5/29/02 9:37a Jaalliso
 * Changing bb_18100_CHIP to bb_18101_CHIP, adding 18102/3/4 chips
 * 
 * 40    5/17/02 2:48p Jaalliso
 * Remove #include "init18100 .h"
 * 
 * 39    5/17/02 1:54p Machambe
 * Updating InitChip
 * 
 * 38    5/17/02 11:12a Jaalliso
 * Formatting code to current standards
 * 
 * 37    5/14/02 4:41p Machambe
 * Added 2nd param to InitChip
 * 
 * 36    5/10/02 1:04p Jaalliso
 * Removing unused variable from GetOpMode(), adding dummy read to SW
 * Workaround in SetOpMode
 * 
 * 35    5/01/02 4:06p Pkjain2
 * Fixed Set Get OpMode
 * 
 * 34    4/18/02 4:53p Jaalliso
 * Fixing GetOpMode
 * 
 * 33    4/16/02 4:05p Jaalliso
 * Changing #defines for Get/SetOpMode
 * 
 * 32    4/16/02 2:44p Jaalliso
 * Renaming ixf_api_xgmac
 * 
 * 31    4/15/02 4:59p Jaalliso
 * #defines for Get/SetOpMode moving to ixf18100_global_b.h
 * 
 * 30    4/10/02 7:00p Jaalliso
 * SW Workaround for wrong default value in XGMAC test register
 * 
 * 26    2/12/02 11:10a Jaalliso
 * Renaming SIF loopbacks to be more generic
 * 
 * 25    2/11/02 4:07p Srodrig1
 * 
 * 24    2/07/02 5:10p Skadrix
 * Added a section (ChipSegment) parameter to the Ixf18100CfgTest function
 * to keep it consistent with the IxtApiCfgTest function prototype.
 * 
 * 4     8/08/01 3:50p Rfranz
 * added support for debugging using memory block instead of Calypso
 * device or simulator.  Moved device read/write macros/functions to
 * ixf18100_util.[ch]
 * 
 * 
 * --------------------------------------------------------------------------
 */

#ifdef VXWORKS
#include "vxWorks.h"
#include "msgQLib.h"
#endif

#ifdef IXF_LINUX
#ifndef __KERNEL__
#include <semaphore.h>
#endif
#endif

#ifndef __KERNEL__
#include <string.h>
#include <stdlib.h>
#else
#include <linux/string.h>
#endif
#include "common_types.h"
#include "common_def.h"
#ifdef __KERNEL__
#include "linuxkern.h"
#else
#include "os.h"
#endif
#include "ixf_api_d.h"
#include "ixf18100_d.h"

#include "ixf18100_global_d.h"  /* needed so ixf_api.h can be unchanged...*/
#include "ixf_api_spi4_d.h"     /* needed so ixf_api.h can be unchanged...*/

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)
#include "ixf_api_sonet_d.h"    /* needed so ixf_api.h can be unchanged...*/
#include "ixf18100_sonet_d.h"
#include "ixf18100_sonet.h"
#endif

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
#include "ixf_api_gfp_d.h"      /* needed so ixf_api.h can be unchanged...*/
#include "ixf_api_pos_d.h"      /* needed so ixf_api.h can be unchanged...*/
#include "ixf18100_pos_d.h"
#include "ixf18100_pos.h"
#include "ixf18100_gfp_d.h"
#include "ixf18100_gfp.h"
#endif

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
#include "ixf_api_pcs_d.h"
#include "ixf_api_ether_d.h"
#include "ixf18100_xgmac_d.h"
#include "ixf18100_xgmac.h"
#include "ixf18100_pcs_d.h"
#include "ixf18100_pcs.h"
#endif

#include "ixf18100_global.h"
#include "ixf18100.h"
#include "ixf18100_spi4_d.h"
#include "ixf18100_spi4.h"
#include "ixf_api.h"
#include "bld18100.h"
#include "ixf18100_d.h"
#include "ixf18100_cnfg_d.h"
#include "ixf18100_alarms_d.h"
#include "ixf18100_alarms.h"
#include "ixf18100_global_b.h"
#include "hal.h"
#include "ixf_perf_metric.h"

/******************************************************************************
* Function : Ixf18100GetChipInfo
*------------------------------------------------------------------------------
* Description : Retrieves chip ID and version.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           pChipInfo : Pointer to Chip info structure where chip ID and
*                       version will be stored
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_CHIP_TYPE, bb_NULL_ARG
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GetChipInfo (bb_ChipData_t *pChipData, bb_ChipInfo_t *pChipInfo)
{
    if (pChipInfo != NULL && pChipData != NULL)
    {
        /* Validate ChipType */
        if (pChipData->ChipType != bb_18101_CHIP &&
            pChipData->ChipType != bb_18102_CHIP &&
            pChipData->ChipType != bb_18103_CHIP &&
            pChipData->ChipType != bb_18104_CHIP &&
            pChipData->ChipType != bb_18101_8023WIS_CHIP &&
            pChipData->ChipType != bb_18103_8023WIS_CHIP)
        {
            return bb_INV_CHIP_TYPE;
        }

        pChipInfo->ChipId = (ushort)HAL_IXF18100_READ(pChipData->BaseAddress
                                + ixf18100_GLB_CHIPID_OFFSET);

        pChipInfo->ChipVersion
            = (uchar)(HAL_IXF18100_READ(pChipData->BaseAddress
                + ixf18100_GLB_CHIPVER_OFFSET) & ixf18100_mCHIP_VER);

        return bb_NO_ERROR;
    }

    return bb_NULL_ARG;
}

/******************************************************************************
* Function : Ixf18100GetCounters
*------------------------------------------------------------------------------
* Description : Retrieves one/all counters (from one/all) blocks of 
*                the chip Ixf18100.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) to retrieve counters
*           eCounter  : Specifies which counter
*           pCounters : buffer to write the counters.
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_CHIP_SEGMENT, bb_INV_BLOCK_OPERATION
*           bb_NULL_ARG
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GetCounters(bb_ChipData_t *pChipData, bb_ChipSegment_t *ptSegment,
                    bb_SelCounters_e eCounter, void *pCounters)
{
    bb_Error_e rc = bb_NO_ERROR;

    if (pCounters == NULL)
        return bb_NULL_ARG;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch (ptSegment->block.block)
    {
        case ixf_eSPI4:
            rc = Ixf18100Spi4GetCounters(pChipData->BaseAddress, eCounter,
                    pCounters);
            break;

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)
        case ixf_eSONET:
            rc = Ixf18100SonetGetCounters(pChipData, ptSegment, eCounter,
                    pCounters);
            break;

        case ixf_eAPS:
            rc = Ixf18100SonetGetCounters(pChipData, ptSegment, eCounter,
                    pCounters);
            break;
#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
          defined(INCLUDE_18103_LIB) */

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
        case ixf_ePOS:
            rc = Ixf18100PosGetCounters(pChipData->BaseAddress, eCounter,
                    pCounters);
            break;

        case ixf_eGFP:
            rc = Ixf18100GfpGetCounters(pChipData->BaseAddress, eCounter,
                    pCounters);
            break;
#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)*/
        
/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
        case ixf_ePCS:
            rc = Ixf18100PcsGetCounters(pChipData->BaseAddress, eCounter,
                    pCounters);
            break;

        case ixf_eXGMAC:
            rc = Ixf18100XgmacGetCounters(pChipData->BaseAddress, eCounter,
                    pCounters);
            break;
#endif

        default:
            rc = bb_INV_PARAMETER;
            break;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100Reset
*------------------------------------------------------------------------------
* Description : Reset (chip or a section of the chip) and then 
*                reconfigure it.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) to reset
*           resetType : Specifies type of Reset
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_RESET_TYPE, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100Reset(bb_ChipData_t *pChipData, bb_ChipSegment_t *ptSegment,
              bb_SelResetType_e resetType)
{
    bb_Error_e rc = bb_NO_ERROR;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch (resetType)
    {
/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
        case bb_RESET_GFP_TX_INTF:
        case bb_RESET_GFP_RX_INTF:
        case bb_RESET_GFP_CPU_INTF:
        case bb_RESET_GFP_TX_FCS:
        case bb_RESET_GFP_RX_FCS:
        case bb_RESET_GFP_RX_FSM:
        case bb_RESET_GFP:
            rc = Ixf18100GfpReset(pChipData->BaseAddress, resetType);
            break;
#endif           
        case bb_RESET_CHIP:
            rc = Ixf18100HoldSwReset(pChipData->BaseAddress);
            if (rc == bb_NO_ERROR)
                rc = Ixf18100ReleaseSwReset(pChipData->BaseAddress);
            break;

        case bb_RESET_LINE_INTF:
            rc = Ixf18100HoldLnIntfReset(pChipData->BaseAddress);
            if (rc == bb_NO_ERROR)
                rc = Ixf18100ReleaseLnIntfReset(pChipData->BaseAddress);
            break;

        case bb_RESET_SPI_INTF:
            rc = Ixf18100HoldSpiReset(pChipData->BaseAddress);
            if (rc == bb_NO_ERROR)
                rc = Ixf18100ReleaseSpiReset(pChipData->BaseAddress);
            break;

        case bb_RESET_APS_INTF:
            rc = Ixf18100HoldApsReset(pChipData->BaseAddress);
            if (rc == bb_NO_ERROR)
                rc = Ixf18100ReleaseApsReset(pChipData->BaseAddress);
            break;

        default:
            rc = bb_INV_RESET_TYPE;
            break;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100CfgTest
*------------------------------------------------------------------------------
* Description : Run Tests
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           section   : Determines the section(block) to run the tests on.
*           testType  : The type of test to run.
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_NULL_ARG, bb_INV_CHIP_TYPE, bb_INV_TEST_CNFG
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100CfgTest(bb_ChipData_t *pChipData, bb_ChipSegment_t *ptSegment,
                bb_TestType_e testType, void *pTestCfg)
{       
    bb_Error_e rc = bb_NO_ERROR;

    if (pTestCfg == NULL)
        return bb_NULL_ARG;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch (testType)
    {
        case bb_SYSTEM_LOCAL_LOOPBACK:
        case bb_SYSTEM_REMOTE_LOOPBACK:
        case bb_SPI4_TX_LOCK_DIS:
            rc = Ixf18100Spi4SetTestCfg(pChipData->BaseAddress, testType,
                    pTestCfg);
            break;

        case bb_LINE_LOCAL_LOOPBACK:
        case bb_LINE_REMOTE_LOOPBACK:
        case bb_APS_INTF_LOCAL:
        case bb_APS_INTF_REMOTE:
            rc = Ixf18100GlobalSetTestCfg(pChipData->BaseAddress, testType,
                    pTestCfg);
            break;

        default:
            rc = bb_INV_TEST_CNFG;
            break;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100SetCfg
*------------------------------------------------------------------------------
* Description : Configures one/all block(s) of IXF1810x device
*------------------------------------------------------------------------------
* Inputs  : *pChipData : pointer to the chip information.
*           *pChipSeg   : pointer to chip segment structure
*           SelCfg      : enum value defining what config needs to be set
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_NULL_ARG, bb_INV_PARAMETER, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100SetCfg(bb_ChipData_t *pChipData, bb_ChipSegment_t *ptSegment,
               bb_SelConfig_e  SelCfg)
{
    bb_Error_e rc = bb_NO_ERROR;
    ixf18100_ChipCfg_t *p18100ChipCfg
        = (ixf18100_ChipCfg_t *)pChipData->pChipCfg;

    if (pChipData->pChipCfg == NULL)
        return bb_NULL_ARG;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch (ptSegment->block.block)
    {
        case ixf_eGLOBAL:
            rc = Ixf18100GlobalSetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->ChipLevelCfg));
            break;

        case ixf_eSPI4:
            rc = Ixf18100Spi4SetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->Spi4Cfg));
            break;

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)
        case ixf_eSONET:
            rc = Ixf18100SonetSetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->SonetCfg));
            break;
#endif

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
        case ixf_ePOS:
            rc = Ixf18100PosSetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->PosCfg));
            break;

        case ixf_eGFP:
            rc = Ixf18100GfpSetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->GfpCfg));
            break;
#endif

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
        case ixf_ePCS:
            rc = Ixf18100PcsSetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->PcsCfg));
            break;

        case ixf_eXGMAC:
            rc = Ixf18100XgmacSetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->XgmacCfg));
            break;
#endif
        default:
            rc = bb_INV_PARAMETER;
            break;
    }
    return rc;
}

/******************************************************************************
* Function : Ixf18100GetCfg
*------------------------------------------------------------------------------
* Description : Reads the configuration of one/all block(s) of IXF1810x device
*------------------------------------------------------------------------------
* Inputs  : *pChipData : pointer to the chip information.
*           *pChipSeg   : pointer to chip segment structure
*           SelCfg      : enum value defining what configuration
*                         needs to be retrieved
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_NULL_ARG, bb_INV_PARAMETER, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GetCfg(bb_ChipData_t *pChipData, bb_ChipSegment_t *ptSegment,
               bb_SelConfig_e  SelCfg)
{
    bb_Error_e rc = bb_NO_ERROR;
    ixf18100_ChipCfg_t *p18100ChipCfg
        = (ixf18100_ChipCfg_t *)pChipData->pChipCfg;

    if (NULL == pChipData->pChipCfg)
        return bb_NULL_ARG;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch (ptSegment->block.block)
    {
        case ixf_eGLOBAL:
            rc = Ixf18100GlobalGetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->ChipLevelCfg));
            break;

        case ixf_eSPI4:
            rc = Ixf18100Spi4GetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->Spi4Cfg));
            break;

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)
        case ixf_eSONET:
            rc = Ixf18100SonetGetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->SonetCfg));
            break;
#endif

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
        case ixf_ePOS:
            rc = Ixf18100PosGetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->PosCfg));
            break;

        case ixf_eGFP:
            rc = Ixf18100GfpGetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->GfpCfg));
            break;
#endif /* #if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) */

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
        case ixf_ePCS:
            rc = Ixf18100PcsGetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->PcsCfg));
            break;

        case ixf_eXGMAC:
            rc = Ixf18100XgmacGetCfg(pChipData->BaseAddress, SelCfg,
                    &(p18100ChipCfg->XgmacCfg));
            break;
#endif /* INCLUDE_18102_LIB */

        default:
            rc = bb_INV_PARAMETER;
            break;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100GetStatus
*------------------------------------------------------------------------------
* Description : Reads the status of one/all block(s) of IXF1810x device
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) to get the status from.
*           selStatus : Type of Status: 
* Outputs : pStatus : place to put Status.
*------------------------------------------------------------------------------
* Returns : bb_Error_e  Returns Error Condition if Not successful
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100GetStatus(bb_ChipData_t *pChipData, bb_ChipSegment_t *ptSegment,
                  bb_SelStatus_e selStatus, void *pStatus)
{
    bb_Error_e rc = bb_NO_ERROR;

    if (NULL == pStatus)
        return bb_NULL_ARG;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch (ptSegment->block.block)
    {
    case ixf_eGLOBAL:
        rc = Ixf18100GlobalGetStatus(pChipData->BaseAddress, selStatus,
                pStatus);
        break;

    case ixf_eSPI4:
        rc = Ixf18100Spi4GetStatus(pChipData->BaseAddress, selStatus,
                pStatus);
        break;

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)
    case ixf_eSONET:
        rc = Ixf18100SonetGetStatus(pChipData->BaseAddress, ptSegment,
            selStatus, pStatus);
        break;
#endif

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
    case ixf_ePOS:
        rc = bb_INV_BLOCK_OPERATION;
        break;

    case ixf_eGFP:
        rc = Ixf18100GfpGetStatus(pChipData->BaseAddress, selStatus,
                pStatus);
        break;
#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) */

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) \
    || defined(INCLUDE_18104_LIB)
    case ixf_ePCS:
        rc = Ixf18100PcsGetStatus(pChipData->BaseAddress, selStatus,
                pStatus);
        break;

    case ixf_eXGMAC:
        rc = Ixf18100XgmacGetStatus(pChipData->BaseAddress, selStatus,
                pStatus);
        break;
#endif /* INCLUDE_18102_LIB */

    default:
        rc = bb_INV_PARAMETER;
        break;
    }
    return rc;
}

/******************************************************************************
* Function : Ixf18100GetBuildVersion
*------------------------------------------------------------------------------
* Description : Reads the build version for the IXF1810x device driver
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) to get the
*                       status from.
*           selStatus : Type of Status: 
* Outputs : pStatus   : place to put Status.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100GetBuildVersion(bb_ChipData_t *pChipData, char *drvName, char *date,
                        ushort *buildVer, ushort *buildRev)
{
    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    strcpy(drvName, IXF18100_BUILD_DRIVER_NAME);
    strcpy(date, IXF18100_BUILD_DATE);
    *buildVer = IXF18100_BUILD_VERSION;
    *buildRev = IXF18100_BUILD_REV;

    return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100Read
*------------------------------------------------------------------------------
* Description : Reads n number of one/two/four byte values.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           wordSize  : One/two/four byte word size
*           address   : Starting address to read from
*           length    : Number of words to read
*           buffer    : Location where words are read into
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_Error_e  Returns Error Condition if Not successful
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100Read(bb_ChipData_t *pChipData, bb_Word_Size_t wordSize, ulong address,
             ushort length, void *buffer)
{
    bb_Error_e rc = bb_NO_ERROR;
    ushort *BaseAddress = pChipData->BaseAddress + address;
    int i;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_FPGA_SIF_18100 &&
        pChipData->ChipType != bb_FPGA_OIFMISC_18100 &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch(wordSize)
    {
        case ONE_BYTE:
            for (i = 0; i < length; i++)
                *((uchar*)buffer + i)
                    = (uchar)HAL_IXF18100_READ(BaseAddress + i);
            break;

        case TWO_BYTES:
            for (i = 0; i < length; i++)
                *((ushort*)buffer + i)
                    = (ushort)HAL_IXF18100_READ(BaseAddress + i);
            break;

        case FOUR_BYTES:
            for (i = 0; i < (length * 2); i++)
                *((ushort*)buffer + i)
                    = (ushort)HAL_IXF18100_READ(BaseAddress + i);
            break;

        case EIGHT_BYTES:
        default:
            rc = bb_WORD_SIZE_UNSUPPORTED;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100Write
*------------------------------------------------------------------------------
* Description : Writes n number of one/two/four byte values to the device
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           wordSize  : One/two/four byte word size
*           address   : Starting address to write to
*           length    : Number of words to write
*           buffer    : Location where words are written from
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_Error_e  Returns Error Condition if Not successful
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100Write(bb_ChipData_t *pChipData, bb_Word_Size_t wordSize, ulong address,
              ushort length, void *buffer)
{
    bb_Error_e rc = bb_NO_ERROR;
    ushort *BaseAddress = pChipData->BaseAddress + address;
    int i;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_FPGA_SIF_18100 &&
        pChipData->ChipType != bb_FPGA_OIFMISC_18100 &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

#ifdef IXF1810X_SW_WORKAROUND

/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)

#include "ixf18100_sonet_b.h"
    if (address == ixf18100_APS_TL_TOH_CFG_OFFSET)
    {
        Ixf18100GetClkCnfg(pChipData->BaseAddress, &glbClkCnfg);

        if (glbClkCnfg.reg1.tCnfg.txTmsprtClk
            != glbClkCnfg.reg1.tCnfg.txApsClk)
        {
            Ixf18100GetWatchDogCnfg(pChipData->BaseAddress, &prevWatchDogCfg);

            watchDogCfg.watchDogCnfgRegister.Cnfg.watchDogEnSel
                = ixf18100_eWATCHDOG_ENABLE;

            watchDogCfg.watchDogCnfgRegister.Cnfg.watchDogTmr = 0x80;

            Ixf18100EditWatchDogCnfg(pChipData->BaseAddress, &watchDogCfg);

            prevAlarmCfg = HAL_IXF18100_READ(pChipData->BaseAddress
                + ixf18100_GLB_CHP_INTEN_OFFSET);

            alarmCfg = prevAlarmCfg;           

            alarmCfg &= ~(ixf_BIT(ixf18100_sWATCH_INT_EN));

            HAL_IXF18100_WRITE(pChipData->BaseAddress
                + ixf18100_GLB_CHP_INTEN_OFFSET, alarmCfg);
        }

        switch(wordSize)
        {
            case ONE_BYTE:
                for (i = 0; i < length; i++)
                    HAL_IXF18100_WRITE(BaseAddress + i, *((uchar*)buffer + i));
                break;

            case TWO_BYTES:
                for (i = 0; i < length; i++)
                    HAL_IXF18100_WRITE(BaseAddress + i, *((ushort*)buffer + i));
                break;

            case FOUR_BYTES:
                for (i = 0; i < (length * 2); i++)
                    HAL_IXF18100_WRITE(BaseAddress + i, *((ushort*)buffer + i));
                break;

            case EIGHT_BYTES:
            default:
                rc = bb_WORD_SIZE_UNSUPPORTED;
        }

        if (glbClkCnfg.reg1.tCnfg.txTmsprtClk
            != glbClkCnfg.reg1.tCnfg.txApsClk)
        {
            Ixf18100EditWatchDogCnfg(pChipData->BaseAddress, &prevWatchDogCfg);

            HAL_IXF18100_WRITE(pChipData->BaseAddress
                + ixf18100_GLB_CHP_INTEN_OFFSET, prevAlarmCfg);
        }

        return rc; 
    }
    else if (address == ixf18100_TXTMG_CFG_OFFSET)
    {
        usValue = (ushort *)buffer;

        /* We need to ALWAYS write 1 to Reference Frm Pulse Sel bit */
        *usValue |= 0x1000;
    }

#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
          defined(INCLUDE_18103_LIB) */

#endif /* IXF1810X_SW_WORKAROUND */

    switch(wordSize)
    {
        case ONE_BYTE:
            for (i = 0; i < length; i++)
                HAL_IXF18100_WRITE(BaseAddress + i, *((uchar*)buffer + i));
            break;

        case TWO_BYTES:
            for (i = 0; i < length; i++)
                HAL_IXF18100_WRITE(BaseAddress + i, *((ushort*)buffer + i));
            break;

        case FOUR_BYTES:
           for (i = 0; i < (length * 2); i++)
               HAL_IXF18100_WRITE(BaseAddress + i, *((ushort*)buffer + i));
           break;

        case EIGHT_BYTES:
        default:
            rc = bb_WORD_SIZE_UNSUPPORTED ;
    }

    return rc;
}

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
/******************************************************************************
* Function : Ixf18100GetMacAddress
*------------------------------------------------------------------------------
* Description : Gets the Mac Address of the device.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) of the chip
* Outputs : address   : Pointer to the Mac Address structure
*------------------------------------------------------------------------------
* Returns : bb_Error_e  Returns Error Condition if Not successful
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100GetMacAddress(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                      void *address)
{
    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    return Ixf18100XgmacGetAddress(pChipData, section,
        (IxfApi_MacAddress_t *)address);
}

/******************************************************************************
* Function : Ixf18100SetMacAddress
*------------------------------------------------------------------------------
* Description : Sets the Mac Address of the device.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) of the chip
*           address   : Pointer to the Mac Address structure
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_Error_e  Returns Error Condition if Not successful
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100SetMacAddress(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                      void *address)
{
    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    return Ixf18100XgmacSetAddress(pChipData, section,
        (IxfApi_MacAddress_t *)address);
}
#endif /* INCLUDE_18102_LIB */

/******************************************************************************
* Function : Ixf18100SetAlarmCfg
*------------------------------------------------------------------------------
* Description : Configures the interrupt masks
*------------------------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) of the chip
*           AlarmType : Type of Alarm 
* Outputs : None
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : None.
******************************************************************************/
bb_Error_e
Ixf18100SetAlarmCfg(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                    bb_AlarmType_e AlarmType, void *pAlarmCfg)
{
    bb_Error_e rc = bb_NO_ERROR;
    ixf18100_AlarmCfg_t *ptAlarmChipCfg;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    ptAlarmChipCfg = (ixf18100_AlarmCfg_t*)pChipData->pAlarmCfg;

    /* Error if Alarm structure not initialized */
    if (pAlarmCfg == NULL)
        return bb_NO_ALARM_CFG; /* We Have a Problem */

    /* Configure alarms based upon type */
    switch(AlarmType)
    {
        case bb_18100_GLOBAL_CHIP_ALARM:
            Ixf18100EditGlbChipAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->GlobalChipAlarms));
            break;

        case bb_18100_GLOBAL_ALARM:
            Ixf18100EditGlbAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->GlobalIntAlarms));
            break;

        case bb_18100_GLOBAL_CLK_ALARM:
            Ixf18100EditGlbClkAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->GlobalClkAlarms));
            break;

        case bb_18100_SIF_ALARM:
            Ixf18100EditSifAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->SifIntAlarms));
            break;

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)

        case bb_18100_POS_RCV_ALARM:
            Ixf18100EditPosRcvAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->PosRcvIntAlarms));
            break;

        case bb_18100_POS_XMT_ALARM:
            Ixf18100EditPosXmtAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->PosXmtIntAlarms));
            break;

        case bb_18100_GFP_ALARM:
            Ixf18100EditGfpAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->GfpIntAlarms));
            break;

#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) */


/* ixf18101/2/3 support SONET, ixf18104 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
    defined(INCLUDE_18103_LIB)

        case bb_18100_WIS_ALARM:
            Ixf18100EditWisAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->WisIntAlarms));
            break;

        case bb_18100_RL_POH_ALARM:
            Ixf18100EditRlPohAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->RlPohIntAlarms));
            break;

        case bb_18100_RL_J1_ALARM:
            Ixf18100EditRlJ1Alarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->RlJ1IntAlarms));
            break;

        case bb_18100_RL_PTR_ALARM:
            Ixf18100EditRlPtrAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->RlPtrIntAlarms));
            break;

        case bb_18100_RL_LOH_ALARM:
            Ixf18100EditRlLohAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->RlLohIntAlarms));
            break;

        case bb_18100_RL_SOH_ALARM:
            Ixf18100EditRlSohAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->RlSohIntAlarms));
            break;

        case bb_18100_TX_TIM_AL_ALARM:
            Ixf18100EditTxTimAlAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->TxTimAlIntAlarms));
            break;

        case bb_18100_SER_AL_ALARM:
            Ixf18100EditTTPrtAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->SerAlIntAlarms));
            break;

        case bb_18100_TT_SER_PRT1_ALARM:
            Ixf18100EditTTSerPrt1Alarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->TTSerPrt1IntAlarms));
            break;

        case bb_18100_TT_SER_PRT2_ALARM:
            Ixf18100EditTTSerPrt1Alarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->TTSerPrt2IntAlarms));
            break;

        case bb_18100_APS_WIS_ALARM:
            Ixf18100EditApsWisAlarms(pChipData->BaseAddress,
                (ushort*) &(ptAlarmChipCfg->pAlarmCfg->ApsWisIntCfg));
            break;

        case bb_18100_APS_RL_LOH_ALARM:
            Ixf18100EditApsRlLohAlarms(pChipData->BaseAddress,
                (ushort*) &(ptAlarmChipCfg->pAlarmCfg->ApsWisIntCfg));
            break;

        case bb_18100_APS_RL_SOH_ALARM:
            Ixf18100EditApsRlSohAlarms(pChipData->BaseAddress,
                (ushort*) &(ptAlarmChipCfg->pAlarmCfg->ApsWisIntCfg));    
            break;
#endif /* defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB) || \
          defined(INCLUDE_18103_LIB) */

/* ixf18101/3/4 support Ethernet, ixf18102 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18103_LIB) || \
    defined(INCLUDE_18104_LIB)
        case bb_18100_PCS_ALARM:
            Ixf18100EditPcsAlarms(pChipData->BaseAddress,
                (ushort *)&(ptAlarmChipCfg->pAlarmCfg->PcsIntAlarms));
            break;

        case bb_18100_XGMAC_ALARM:
            Ixf18100EditXgmacAlarms(pChipData->BaseAddress,
                &(ptAlarmChipCfg->pAlarmCfg->XgmacIntCfg));
            break;
#endif /* INCLUDE_18102_LIB */

        default:
            rc = bb_INV_PARAMETER;
            break;
    }
    return rc;
}

/******************************************************************************
* Function : Ixf18100InitAlarmCallback
*------------------------------------------------------------------------------
* Description : Initialize the alarm callback function with the IXF30007
*               device driver
*------------------------------------------------------------------------------
* Inputs  : pChipData      : Validated Chip Data
*           pAlarmCallback : Alarm Callback
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100InitAlarmCallback(bb_ChipData_t *pChipData,
                          AlarmCallBack pAlarmCallbackArg)
{
    ixf18100_AlarmCfg_t *AlarmConfigPtr
        = (ixf18100_AlarmCfg_t *) pChipData->pAlarmCfg;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    /* Error if we have not initialized our Alarm structure */
    if (AlarmConfigPtr == NULL)
        return bb_NO_ALARM_CFG;

    /* Assign the Alarm Callback Function Pointer */
    AlarmConfigPtr->pAlarmCallback = pAlarmCallbackArg;

    /* Indicate that the driver is using Alarms */
    AlarmConfigPtr->bAlarmsUsed = TRUE;

    /* Set flag indicating we are complete with Callback assigment */
    /* Alarm Callback Function Pointer has been assigned */
    (*AlarmConfigPtr).bAlarmCallbackAssigned = TRUE;

    return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100ChipIsr
*------------------------------------------------------------------------------
* Description : The ISR services the interrupts that the user has selected to
*               monitor
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : 
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100ChipIsr(bb_ChipData_t *pChipData)
{
    ixf18100_GlbChpIntStat_t alarms;
    ixf18100_AlarmCfg_t *AlarmConfigPtr = (ixf18100_AlarmCfg_t *) pChipData->pAlarmCfg;

    OS_CMD_METRIC_EVENT(IXF_EVENT_CHIPISR_ENTRY, 0,0);

    if (AlarmConfigPtr == NULL)
        return bb_NO_ALARM_CFG;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    alarms.uiReg = 0;

    alarms.uiReg |= HAL_IXF18100_READ(pChipData->BaseAddress
        + ixf18100_GLB_CHP_INTSTAT_OFFSET);

    if (AlarmConfigPtr->bAlarmCallbackAssigned)
        ixf18100MasterInterruptHandler(pChipData, &alarms,
            AlarmConfigPtr->pAlarmCallback);
    else
        return bb_NO_ALARM_CFG;

    OS_CMD_METRIC_EVENT(IXF_EVENT_CHIPISR_EXIT, 0,0);

    return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100InitAllocMemory
*------------------------------------------------------------------------------
* Description : Allocate the memory space for IXF1810x device driver
*               configuration and alarm structures.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100InitAllocMemory(bb_ChipData_t *pChipData)
{
    ixf18100_AlarmCfg_t *pAlarmCfg;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    /* Allocate memory for ChipCfg */
    pChipData->pChipCfg
        = (ixf18100_ChipCfg_t *) OS_CMD_ALLOC_MEM(sizeof(ixf18100_ChipCfg_t));

    /* Allocate memory for AlarmCfg */
    pChipData->pAlarmCfg
        = (ixf18100_AlarmCfg_t *)
            OS_CMD_ALLOC_MEM(sizeof(ixf18100_AlarmCfg_t));

    /* Cast the void pointer */
    pAlarmCfg = (ixf18100_AlarmCfg_t *) pChipData->pAlarmCfg;

    pAlarmCfg->pAlarmCfg
        = (ixf18100_AlarmCfgSet_t *)
            OS_CMD_ALLOC_MEM(sizeof(ixf18100_AlarmCfgSet_t));

    return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100DeAllocMemory
*------------------------------------------------------------------------------
* Description : Deallocate the memory space for IXF1810x device driver
*               configuration and alarm structures.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_NO_CHIP_CFG
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100DeAllocMemory(bb_ChipData_t *pChipData)
{
    ixf18100_AlarmCfg_t* pAlarmCfg;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    /* Deallocate memory for ChipCfg */
    if (pChipData->pChipCfg) 
    {       
        OS_CMD_DEALLOC_MEM(pChipData->pChipCfg);
    }
    else 
    {
        /* Exit with error. Chip configuration parameter is not initialized */
        return bb_NO_CHIP_CFG;
    }

    /* Deallocate memory for AlarmCfg */
    if (pChipData->pAlarmCfg) 
    {
        pAlarmCfg = (ixf18100_AlarmCfg_t *) pChipData->pAlarmCfg;
        OS_CMD_DEALLOC_MEM(pAlarmCfg->pAlarmCfg);
        OS_CMD_DEALLOC_MEM(pChipData->pAlarmCfg);
    } 
    else 
    {
        /* Exit with error. Chip configuration parameter is not initialized */
        return bb_NO_ALARM_CFG;
    }

    return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100InitChip
*------------------------------------------------------------------------------
* Description : Initialize the ixf1810x chip via OCM UI generated
*               data structure
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           pTable : Table to be committed to the device.
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_NULL_ARG
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100InitChip(bb_ChipData_t *pChipData, InitRegTable_t *pTable)
{
    bb_Error_e rc = bb_NO_ERROR;
    InitRegTable_t *pRegPtr;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    if (NULL == pTable)
    {
        return bb_NULL_ARG;
    }

    /* Initialize the register pointer */
    pRegPtr = pTable;

    /* Loop through the array commiting the data down to the chip */
    while ((pRegPtr->offset != (ushort*)0xFFFF) &&
           (pRegPtr->value  != IXF_INIT_DATA_DELIMITER))
    {
        HAL_IXF18100_WRITE((pChipData->BaseAddress + (ulong) pRegPtr->offset),
            pRegPtr->value);

        pRegPtr++;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100GetOpMode
*------------------------------------------------------------------------------
* Description : This function returns the operational mode that the chip is
*               configured in.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           section: Chip Segment
*           pModeCfg: NULL
* Outputs : opMode: Operational Mode
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_STM_MODE_MISMATCH, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : We have only one enum value for GFP over FIBER Mode 
* and GFP  Client Map Mode. The reason being that the configuration
* value for this register in these two modes is identical.
******************************************************************************/
bb_Error_e
Ixf18100GetOpMode(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                  bb_OperMode_e *opMode, void *pModeCfg)
{
    bb_Error_e rc = bb_NO_ERROR;
    ushort regValue;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    regValue = HAL_IXF18100_READ(pChipData->BaseAddress
        + ixf18100_GLB_CFG1_OFFSET);

    if(regValue == ixf18100_vGLB_CFG1_POS)
    {
        *opMode = POS_MODE;
    }
    else if(regValue == ixf18100_vGLB_CFG1_ETHERNET)
    {
        *opMode = ETHERNET_MODE;
    }
    else if(regValue == ixf18100_vGLB_CFG1_WANPHY)
    {
        *opMode = WAN_PHY_MODE;
    }
    else if(regValue == ixf18100_vGLB_CFG1_GFPFIBER)
    {
        *opMode = GFP_CLIENT_FIBER_MODE;
    }
    else if(regValue == ixf18100_vGLB_CFG1_GFPSONET)
    {
        *opMode = GFP_SONET_MODE;
    }
    else
    {
        rc = bb_STM_MODE_MISMATCH;
    }

    return rc;
}

/******************************************************************************
* Function : Ixf18100SetOpMode
*------------------------------------------------------------------------------
* Description : Configures the Chip Configuration structure to 
*               operate in a certain mode.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           section: Chip Segment
*           opMode: Operational Mode
*           pModeCfg: NULL
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_PARAMETER
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100SetOpMode(bb_ChipData_t *pChipData, bb_ChipSegment_t *section,
                  bb_OperMode_e opMode, void *pModeCfg)
{
    bb_Error_e rc = bb_NO_ERROR;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18103_CHIP &&
        pChipData->ChipType != bb_18104_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP &&
        pChipData->ChipType != bb_18103_8023WIS_CHIP)
    {
        return bb_INV_CHIP_TYPE;
    }

    switch(opMode)
    {
        case POS_MODE:
            HAL_IXF18100_WRITE(pChipData->BaseAddress
                + ixf18100_GLB_CFG1_OFFSET, ixf18100_vGLB_CFG1_POS);
            break;

        case ETHERNET_MODE:
            HAL_IXF18100_WRITE(pChipData->BaseAddress
                + ixf18100_GLB_CFG1_OFFSET, ixf18100_vGLB_CFG1_ETHERNET);
            break;

        case WAN_PHY_MODE:
            HAL_IXF18100_WRITE(pChipData->BaseAddress
                + ixf18100_GLB_CFG1_OFFSET, ixf18100_vGLB_CFG1_WANPHY);
            break;

/* ixf18101/2 support POS and GFP, ixf18103/4 does not */
#if defined(INCLUDE_18101_LIB) || defined(INCLUDE_18102_LIB)
        case GFP_SONET_HEADER_PRE_INSERT_1_MODE:
        case GFP_SONET_HEADER_PRE_INSERT_2_MODE:
        case GFP_SONET_HEADER_PRE_INSERT_3_MODE:
        case GFP_SONET_HEADER_PRE_INSERT_4_MODE:
        case GFP_SONET_HEADER_PRE_INSERT_5_MODE:
            /* Set GFP Over SONET Mode */
            rc = Ixf18100SetGfpOverSonetMode(pChipData, opMode);
            break;

        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_1_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_2_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_3_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_4_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_5_MODE:
            /* Set GFP Client Map Mode */
            rc = Ixf18100SetGfpClientMapMode(pChipData, opMode);
            break;
#endif

        default:
            rc = bb_STM_MODE_MISMATCH;
            break;
    }

#if defined(IXF1810X_SW_WORKAROUND) && !defined(INCLUDE_18102_LIB)
    /* This is a workaround for the correcting the default value in
    XGMAC registers when IXF1810X is set in Ethernet mode. */

    switch(opMode)
    {
        case ETHERNET_MODE:
        case WAN_PHY_MODE:
            HAL_IXF18100_WRITE(pChipData->BaseAddress + 0x3116, 0x0000);
            HAL_IXF18100_WRITE(pChipData->BaseAddress + 0x3117, 0x0084);
            /* Dummy read, if XGMAC block was in reset, ensure that next
            read will return correct value */
            HAL_IXF18100_READ(pChipData->BaseAddress
                + ixf18100_GLB_CFG1_OFFSET);
            break;

        default:
            break;
    }
#endif /* defined(IXF1810X_SW_WORKAROUND) && !defined(INCLUDE_18102_LIB) */

    return rc;
}
