/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_8023WIS_d.h $
 *   WORKFILE:       $Workfile: ixf18100_8023WIS_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18101/3 802.3 WIS API
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_8023WIS_d.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 1     6/24/02 10:23a Jaalliso
 * ixf1810x IEEE 802.3 WIS API definitions header file
 * 
 * 7     6/20/02 11:34a Jaalliso
 * Adding IEEE8023_eWIS_REGNOTSUPPORTED
 * 
 * 6     6/11/02 4:43p Jaalliso
 * Intermediate check in
 * 
 * 5     6/11/02 8:58a Jaalliso
 * Intermediate check in
 * 
 * 4     6/07/02 8:26a Jaalliso
 * Intermediate check in
 * 
 * 3     5/31/02 2:09p Jaalliso
 * Intermediate check in
 * 
 * 2     5/23/02 4:56p Jaalliso
 * Intermediate check in
 * 
 * 1     5/23/02 7:52a Jaalliso
 * Ixf18101/3 IEEE 802.3 WIS API definitions header file
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF18100_8023WIS_D_H_
#define __IXF18100_8023WIS_D_H_

/* IEEE 802.3 trace length */
#define IEEE8023_WIS_TRACELENGTH 16

/* IEEE 802.3 WIS API error codes */
typedef enum
{
    IEEE8023_eNO_ERROR = 0,         /* No error */
    IEEE8023_eWIS_IN_RESET,         /* WIS is in reset */
    IEEE8023_eWIS_RESERVED,         /* Reserved IEEE 802.3 WIS Register */
    IEEE8023_eWIS_READONLY,         /* Read Only IEEE 802.3 WIS Register */
    IEEE8023_eWIS_INVALID_CFG,      /* Invalid bit/bits configuration */
    IEEE8023_eWIS_INVALID_REG,      /* Invalid register offset */
    IEEE8023_eWIS_IXFAPI_ERR,       /* Error calling IXF API */
    IEEE8023_eWIS_REGNOTSUPPORTED   /* IEEE 802.3 register not supported */
} IEEE8023_Error_e;

#endif /* __IXF18100_8023WIS_D_H_ */

