/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_8023_b.h $
 *   WORKFILE:       $Workfile: ixf18100_8023_b.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18101/3 802.3 WIS API
 *
 * Purpose: IEEE 802.3 WIS Register offsets, shifts, masks, defaults, values 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_8023_b.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 10    6/20/02 11:34a Jaalliso
 * Removing 2.9
 * 
 * 9     6/19/02 3:30p Jaalliso
 * Changing 2.7 default
 * 
 * 8     6/07/02 8:25a Jaalliso
 * Adding mask values
 * 
 * 7     6/06/02 7:41a Jaalliso
 * Adding offset #defines for reserved registers
 * 
 * 6     5/31/02 7:05a Jaalliso
 * Changing #define for register 2.5, fixing comments
 * 
 * 5     5/30/02 4:36p Jaalliso
 * Register name update
 * 
 * 4     5/30/02 3:39p Kssaepha
 * Changed some define names
 * 
 * 3     5/24/02 10:35a Jaalliso
 * Fixed a few default values
 * 
 * 2     5/23/02 4:56p Jaalliso
 * Intermediate check in
 * 
 * 1     5/16/02 10:18a Jaalliso
 * Register definitions for IEEE 802.3 WIS
 * 
 * --------------------------------------------------------------------------
 */

#ifndef ixf18100_802_3_B_H
#define ixf18100_802_3_B_H

/******************************************************************************/
/*WIS_CNTL1 Register (2.0)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_CNTL1_OFFSET            0
#define ixfIEEE8023_WIS_CNTL1_DFLT              0x2040

/* -------- Bit, shift and mask defines.-------- */

/*1 = WIS reset
0 = Normal Operation*/
#define ixfIEEE8023_sRESET                      15
#define ixfIEEE8023_mRESET                      (0x01 << ixfIEEE8023_sRESET)

/*1 = Enable loopback mode*/
#define ixfIEEE8023_sLOOPBACK                   14
#define ixfIEEE8023_mLOOPBACK                   (0x01 << ixfIEEE8023_sLOOPBACK)

/*1 = Operation at 10Gbps and above
0 = Unspecified*/
#define ixfIEEE8023_sSPD_SEL_13                 13
#define ixfIEEE8023_mSPD_SEL_13                 (0x01 << ixfIEEE8023_sSPD_SEL_13)

/*1 = Low power mode
0 = Normal operation*/
#define ixfIEEE8023_sLOW_PWR                    11
#define ixfIEEE8023_mLOW_PWR                    (0x01 << ixfIEEE8023_sLOW_PWR)

/*1 = Operation at 10Gbps and above
0 = Unspecified*/
#define ixfIEEE8023_sSPD_SEL_6                  6
#define ixfIEEE8023_mSPD_SEL_6                  (0x01 << ixfIEEE8023_sSPD_SEL_6)

/*1 x x x =Reserved
x 1 x x =Reserved
x x 1 x =Reserved
0 0 0 1 =Reserved
0 0 0 0 =10Gbps*/
#define ixfIEEE8023_sSPD_SEL_52                 2
#define ixfIEEE8023_mSPD_SEL_52                 (0x0F << ixfIEEE8023_sSPD_SEL_52)
/******************************************************************************/

/******************************************************************************/
/*WIS_STAT1 Register (2.1)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_STAT1_OFFSET            1
#define ixfIEEE8023_WIS_STAT1_DFLT              0x0002

/* -------- Bit, shift and mask defines.-------- */

/*1 = Local fault condition
0 = No local fault condition*/
#define ixfIEEE8023_sLOCAL_FAULT                7

/*1 = WIS link up
0 =WIS link down*/
#define ixfIEEE8023_sLINK_STAT                  2

/*1 = WIS supports low power mode
0 = WIS does not support low power mode*/
#define ixfIEEE8023_sLOW_PWR_ABLTY              1
#define ixfIEEE8023_mLOW_PWR_ABLTY              (0x01 << ixfIEEE8023_sLOW_PWR_ABLTY)

/******************************************************************************/

/******************************************************************************/
/*DEVICE_IDENTIFIER Register (2.2)*/

/*Offset/Default definition for register.*/
/*Offset/Default definition for register.*/
#define ixfIEEE8023_DEVICE_ID_2_OFFSET          2
#define ixfIEEE8023_DEVICE_ID_2_DFLT            0x0000

/******************************************************************************/
/*DEVICE_IDENTIFIER Register (2.3)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_DEVICE_ID_3_OFFSET          3
#define ixfIEEE8023_DEVICE_ID_3_DFLT            0x0000

/******************************************************************************/

/******************************************************************************/
/*WIS_SPD_ABLTY Register (2.4) */

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_SPD_ABLTY_OFFSET        4
#define ixfIEEE8023_WIS_SPD_ABLTY_DFLT          0x0001

/* -------- Bit, shift and mask defines.-------- */

/*WIS is capable of operating at 10G*/
#define ixfIEEE8023_s10G_CAPABLE                0
#define ixfIEEE8023_m10G_CAPABLE                (0x01 << ixfIEEE8023_s10G_CAPABLE)

/******************************************************************************/
/*DEV_IN_PKG_5 Register (2.5)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_DEV_IN_PKG_5_OFFSET         5
#define ixfIEEE8023_DEV_IN_PKG_5_DFLT           0x000C

/* -------- Bit, shift and mask defines.-------- */
/*1 = DTE XS present in package
0 = DTE XS not present in package*/
#define ixfIEEE8023_sDTE_XS_PRES                5
#define ixfIEEE8023_mDTE_XS_PRES                (0x01 << ixfIEEE8023_sDTE_XS_PRES)

/*1 = PHY XS present in package
0 = PHY XS not present in package*/
#define ixfIEEE8023_sPHY_XS_PRES                4
#define ixfIEEE8023_mPHY_XS_PRES                (0x01 << ixfIEEE8023_sPHY_XS_PRES)

/*1 = PCS present in package
0 = PCS not present in package*/
#define ixfIEEE8023_sPCS_PRES                   3
#define ixfIEEE8023_mPCS_PRES                   (0x01 << ixfIEEE8023_sPCS_PRES)

/*1 = WIS present in package
0 = WIS not present in package*/
#define ixfIEEE8023_sWIS_PRES                   2
#define ixfIEEE8023_mWIS_PRES                   (0x01 << ixfIEEE8023_sWIS_PRES)

/*1 = PMD/PMA present in package
0 = PMD/PMA not present in package*/
#define ixfIEEE8023_sPMD_PMA_PRES               1
#define ixfIEEE8023_mPMD_PMA_PRES               (0x01 << ixfIEEE8023_sPMD_PMA_PRES)

/*1 = Clause 22 registers present in package
0 = Clause 22 registers not present in package*/
#define ixfIEEE8023_sCLAUSE_22_REG_PRES         0
#define ixfIEEE8023_mCLAUSE_22_REG_PRES         (0x01 << ixfIEEE8023_sCLAUSE_22_REG_PRES)

/******************************************************************************/

/******************************************************************************/
/*DEV_IN_PKG_6 Register 2.6*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_DEV_IN_PKG_6_OFFSET         6
#define ixfIEEE8023_DEV_IN_PKG_6_DFLT           0x0000

/* -------- Bit, shift and mask defines.-------- */

/*1 = Vendor specific device present in package
0 = Vendor specific device not present in package*/
#define ixfIEEE8023_sVSD_PRES                   15

/******************************************************************************/

/******************************************************************************/
/*WIS_CNTL2 Register (2.7)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_CNTL2_OFFSET            7
#define ixfIEEE8023_WIS_CNTL2_DFLT              0x0001

/* -------- Bit, shift and mask defines.-------- */

/*1 = Square wave test pattern
0 = Mixed frequency test pattern*/
#define ixfIEEE8023_sTEST_PTRN                  3
#define ixfIEEE8023_mTEST_PTRN                  (0x01 << ixfIEEE8023_sTEST_PTRN)

/*1 = Enable test pattern mode on the receive path
0 = Disable test pattern mode on the receive path*/
#define ixfIEEE8023_sRX_TEST_PTRN_EN            2
#define ixfIEEE8023_mRX_TEST_PTRN_EN            (0x01 << ixfIEEE8023_sRX_TEST_PTRN_EN)

/*1 = Enable test pattern mode on the transmit path
0 = Disable test pattern mode on the transmit path*/
#define ixfIEEE8023_sTX_TEST_PTRN_EN            1
#define ixfIEEE8023_mTX_TEST_PTRN_EN            (0x01 << ixfIEEE8023_sTX_TEST_PTRN_EN)

/*1 = Select 10GBASE-WPCS type
0 = Select 10GBASE-R PCS type*/
#define ixfIEEE8023_sPCS_TYPE_SEL               0
#define ixfIEEE8023_mPCS_TYPE_SEL               (0x01 << ixfIEEE8023_sPCS_TYPE_SEL)

/******************************************************************************/

/******************************************************************************/
/*WIS_STAT2 Register (2.8)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_STAT2_OFFSET            8
#define ixfIEEE8023_WIS_STAT2_DFLT              0x8001

/* -------- Bit, shift and mask defines.-------- */

/*11 = No device responding at this address
 *10 = Device responding at this address
 *01 = No device responding at this address
 *00 = No device responding at this address*/
#define ixfIEEE8023_sDEV_PRES                   14
#define ixfIEEE8023_mDEV_PRES                   (0x03 << ixfIEEE8023_sDEV_PRES)

/*1 = WIS is able to support 10GBASE-R port types
0 = WIS is not able to support 10GBASE-R port types*/
#define ixfIEEE8023_s10GBASE_R_ABLTY            0

/*1=WIS ia able to support PRBS31 pattern testing
0=WIS is not able to suppport PRBS31 pattern testing*/
#define ixfIEEE8023_sPRBS31_PTRN_TEST           1
/******************************************************************************/

/******************************************************************************/
/*WIS_TP_ERR_COUNT Register (2.9) - Not supported as Ixf1810x doesn't support */
/*                                  PRBS31                                    */

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_TP_ERR_CNT_OFFSET       9

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/


/******************************************************************************/
/* 2.10 - 2.13 Reserved */
#define ixfIEEE8023_RESERVED10                  10
#define ixfIEEE8023_RESERVED11                  11
#define ixfIEEE8023_RESERVED12                  12
#define ixfIEEE8023_RESERVED13                  13
/******************************************************************************/

/******************************************************************************/
/*WIS_PACKAGE_ID_14 Register (2.14)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_PKG_ID_14_OFFSET            14
#define ixfIEEE8023_PKG_ID_14_DFLT              0x0000

/******************************************************************************/

/******************************************************************************/
/*WIS_PACKAGE_ID_15 Register (2.15)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_PKG_ID_15_OFFSET            15
#define ixfIEEE8023_PCK_ID_15_DFLT              0x0000

/******************************************************************************/

/******************************************************************************/
/* 2.16 - 2.32 Reserved */
#define ixfIEEE8023_RESERVED16                  16
#define ixfIEEE8023_RESERVED17                  17
#define ixfIEEE8023_RESERVED18                  18
#define ixfIEEE8023_RESERVED19                  19
#define ixfIEEE8023_RESERVED20                  20
#define ixfIEEE8023_RESERVED21                  21
#define ixfIEEE8023_RESERVED22                  22
#define ixfIEEE8023_RESERVED23                  23
#define ixfIEEE8023_RESERVED24                  24
#define ixfIEEE8023_RESERVED25                  25
#define ixfIEEE8023_RESERVED26                  26
#define ixfIEEE8023_RESERVED27                  27
#define ixfIEEE8023_RESERVED28                  28
#define ixfIEEE8023_RESERVED29                  29
#define ixfIEEE8023_RESERVED30                  30
#define ixfIEEE8023_RESERVED31                  31
#define ixfIEEE8023_RESERVED32                  32
/******************************************************************************/

/******************************************************************************/
/*WIS_STAT3 Register (2.33)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_STAT3_OFFSET            33
#define ixfIEEE8023_WIS_STAT3_DFLT              0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Severely errored frame*/
#define ixfIEEE8023_sSEF                        11

/*Far End Path Label Mismatch/Loss of Code-group Delineation*/
#define ixfIEEE8023_sFAR_END_PLM_P_LCD_P        10

/*Far End Alarm Path Indication Signal/ Path Loss of Pointer*/
#define ixfIEEE8023_sFAR_END_AIS_P_LOP_P        9

/*1 = Loss of Frame flag raised
0 = Loss of Frame flag lowered*/
#define ixfIEEE8023_sLOF                        7

/*1 = Loss of Signal flag raised
0 = Loss of Signal flag lowered*/
#define ixfIEEE8023_sLOS                        6

/*1 = Line Remote Defect flag raised
0 = Line Remote Defect flag lowered*/
#define ixfIEEE8023_sRDI_L                      5

/*1 = Line Alarm Indication flag raised
0 = Line Alarm Indication flag lowered*/
#define ixfIEEE8023_sAIS_L                      4

/*1 = Path Loss of Code-group Delineation flag raised
0 = Path Loss of Code-group Delineation flag lowered*/
#define ixfIEEE8023_sLCD_P                      3

/*1 = Path Label Mismatch flagr aised
0 = Path Label Mismatch flag lowered*/
#define ixfIEEE8023_sPLM_P                      2

/*1 = Path Alarm Indication Signal raised
0 = Path Alarm Indication Signal lowered*/
#define ixfIEEE8023_sAIS_P                      1

/*1 = Loss of Pointer flag raised
0 = Loss of Pointer flag lowered*/
#define ixfIEEE8023_sLOP_P                      0

/******************************************************************************/

/******************************************************************************/
/* 2.33 - 2.36 Reserved */
#define ixfIEEE8023_RESERVED33                  33
#define ixfIEEE8023_RESERVED34                  34
#define ixfIEEE8023_RESERVED35                  35
#define ixfIEEE8023_RESERVED36                  36
/******************************************************************************/

/******************************************************************************/
/*WIS_FEP_BLK_ERR_CNT Register (2.37)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_FEP_BLK_ERR_CNT_OFFSET  37
#define ixfIEEE8023_WIS_FEP_BLK_ERR_CNT_DFLT    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Far End Path Block Error Count*/
#define ixfIEEE8023_sFEP_BLK_ERR_CNT            0
#define ixfIEEE8023_mFEP_BLK_ERR_CNT            0xFFFF

/******************************************************************************/

/******************************************************************************/
/* 2.38 Reserved */
#define ixfIEEE8023_RESERVED38                  38
/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX Register (2.39)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX01_OFFSET          39
#define ixfIEEE8023_WIS_J1_TX01_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Transmitted Path Trace octet 1*/
#define ixfIEEE8023_sJ1_TX_1                    8
#define ixfIEEE8023_mJ1_TX_1                    (0xFF << ixfIEEE8023_sJ1_TX_1)

/*Transmitted Path Trace octet 0*/
#define ixfIEEE8023_sJ1_TX_0                    0
#define ixfIEEE8023_mJ1_TX_0                    (0xFF << ixfIEEE8023_sJ1_TX_0)

/******************************************************************************/
/******************************************************************************/
/*WIS_J0_TX23 Register (2.40)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX23_OFFSET          40
#define ixfIEEE8023_WIS_J1_TX23_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX45 Register (2.41)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX45_OFFSET          41
#define ixfIEEE8023_WIS_J1_TX45_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX67 Register (2.42)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX67_OFFSET          42
#define ixfIEEE8023_WIS_J1_TX67_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX89 Register (2.43)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX89_OFFSET          43
#define ixfIEEE8023_WIS_J1_TX89_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX1011 Register (2.44)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX1011_OFFSET        44
#define ixfIEEE8023_WIS_J1_TX1011_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX1112 Register (2.45)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX1213_OFFSET        45
#define ixfIEEE8023_WIS_J1_TX1213_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_TX1415 Register (2.46)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_TX1415_OFFSET        46
#define ixfIEEE8023_WIS_J1_TX1415_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX01 Register (2.47)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX01_OFFSET          47
#define ixfIEEE8023_WIS_J1_RX01_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Transmitted Path Trace octet 1*/
#define ixfIEEE8023_sJ1_RX_1                    0
#define ixfIEEE8023_mJ1_RX_1                    0xFF00

/*Transmitted Path Trace octet 0*/
#define ixfIEEE8023_sJ1_RX_0                    0
#define ixfIEEE8023_mJ1_RX_0                    0x00FF

/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX23 Register (2.48)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX23_OFFSET          48
#define ixfIEEE8023_WIS_J1_RX23_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX45 Register (2.49)/ */

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX45_OFFSET          49
#define ixfIEEE8023_WIS_J1_RX45_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX67 Register (2.50)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX67_OFFSET          50
#define ixfIEEE8023_WIS_J1_RX67_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX89 Register (2.51)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX89_OFFSET          51
#define ixfIEEE8023_WIS_J1_RX89_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX1011 Register (2.52)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX1011_OFFSET        52
#define ixfIEEE8023_WIS_J1_RX1011_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX1213 Register (2.53) */

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX1213_OFFSET        53
#define ixfIEEE8023_WIS_J1_RX1213_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J1_RX1415 Register (2.54)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J1_RX1415_OFFSET        54
#define ixfIEEE8023_WIS_J1_RX1415_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_FEL_BIP_ERR_55 Register (2.55)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_FEL_BIP_ERR_55_OFFSET   55
#define ixfIEEE8023_WIS_FEL_BIP_ERR_55_DFLT     0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Most significant word of the WIS Far End Line BIP Errors counter*/
#define ixfIEEE8023_sFEL_BIP_ERR_1              0
#define ixfIEEE8023_mFEL_BIP_ERR_1              (0xFFFF << ixfIEEE8023_sFEL_BIP_ERR_1)

/******************************************************************************/

/******************************************************************************/
/*WIS_FEL_BIP_ERR_56 Register (2.56)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_FEL_BIP_ERR_56_OFFSET   56
#define ixfIEEE8023_WIS_FEL_BIP_ERR_56_DFLT     0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Least significant word of the WIS Far End Line BIP Errors counter*/
#define ixfIEEE8023_sFEL_BIP_ERR_0              0
#define ixfIEEE8023_mFEL_BIP_ERR_0              (0xFFFF << ixfIEEE8023_sFEL_BIP_ERR_0)

/******************************************************************************/

/******************************************************************************/
/*WIS_LINE_BIP_ERR_57 Register (2.57)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_LINE_BIP_ERR_57_OFFSET  57
#define ixfIEEE8023_WIS_LINE_BIP_ERR_57_DFLT    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Most significant word of the WIS LINE BIP Errors counter*/
#define ixfIEEE8023_sLINE_BIP_ERR_1             0
#define ixfIEEE8023_mLINE_BIP_ERR_1             (0xFFFF << ixfIEEE8023_sLINE_BIP_ERR_1)

/******************************************************************************/

/******************************************************************************/
/*WIS_LINE_BIP_ERR_58 Register (2.58)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_LINE_BIP_ERR_58_OFFSET  58
#define ixfIEEE8023_WIS_LINE_BIP_ERR_58_DFLT    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Least significant word of the WIS LINE BIP Errors counter*/
#define ixfIEEE8023_sLINE_BIP_ERR_0             0
#define ixfIEEE8023_mLINE_BIP_ERR_0             (0xFFFF << ixfIEEE8023_sLINE_BIP_ERR_0)

/******************************************************************************/

/******************************************************************************/
/*WIS_PATH_BLK_ERR_CNT Register (2.59)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_PATH_BLK_ERR_CNT_OFFSET 59
#define ixfIEEE8023_WIS_PATH_BLK_ERR_CNT_DFLT   0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Path Block Error Counter*/
#define ixfIEEE8023_sPATH_BLK_ERR_CNT           0
#define ixfIEEE8023_mPATH_BLK_ERR_CNT           (0xFFFF << ixfIEEE8023_sPATH_BLK_ERR_CNT)

/******************************************************************************/

/******************************************************************************/
/*WIS_SECT_BIP_ERR_CNT Register (2.60)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_SECT_BIP_ERR_CNT_OFFSET 60
#define ixfIEEE8023_WIS_SECT_BIP_ERR_CNT_DFLT   0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Section BIP Error Count*/
#define ixfIEEE8023_sSECT_BIP_ERR_CNT           0
#define ixfIEEE8023_mSECT_BIP_ERR_CNT           (0xFFFF << ixfIEEE8023_sSECT_BIP_ERR_CNT)

/******************************************************************************/

/******************************************************************************/
/* 2.61 - 2.63 Reserved */
#define ixfIEEE8023_RESERVED61                  61
#define ixfIEEE8023_RESERVED62                  62
#define ixfIEEE8023_RESERVED63                  63
/******************************************************************************/


/******************************************************************************/
/*WIS_J0_TX01 Register (2.64)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX01_OFFSET          64
#define ixfIEEE8023_WIS_J0_TX01_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Transmitted Section Trace octet 1*/
#define ixfIEEE8023_sJ0_TX_1                    8
#define ixfIEEE8023_mJ0_TX_1                    0xFF00

/*Transmitted Section Trace octet 0*/
#define ixfIEEE8023_sJ0_TX_0                    8
#define ixfIEEE8023_mJ0_TX_0                    0x00FF

/******************************************************************************/
/*WIS_J0_TX23 Register (2.65)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX23_OFFSET          65
#define ixfIEEE8023_WIS_J0_TX23_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_TX45 Register (2.66)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX45_OFFSET          66
#define ixfIEEE8023_WIS_J0_TX45_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_TX67 Register (2.67)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX67_OFFSET          67
#define ixfIEEE8023_WIS_J0_TX67_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_TX89 Register (2.68)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX89_OFFSET          68
#define ixfIEEE8023_WIS_J0_TX89_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_TX1011 Register (2.69)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX1011_OFFSET        69
#define ixfIEEE8023_WIS_J0_TX1011_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_TX1213 Register (2.70)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX1213_OFFSET        70
#define ixfIEEE8023_WIS_J0_TX1213_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_TX1415 Register (2.71)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_TX1415_OFFSET        71
#define ixfIEEE8023_WIS_J0_TX1415_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX01 Register (2.72)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX01_OFFSET          72
#define ixfIEEE8023_WIS_J0_RX01_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixfIEEE8023_sJ0_RX_1                    8
#define ixfIEEE8023_mJ0_RX_1                    0xFF00

/*Received Section Trace octet 0*/
#define ixfIEEE8023_sJ0_RX_0                    0
#define ixfIEEE8023_mJ0_RX_0                    0x00FF

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX23 Register (2.73)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX23_OFFSET          73
#define ixfIEEE8023_WIS_J0_RX23_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX45 Register (2.74)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX45_OFFSET          74
#define ixfIEEE8023_WIS_J0_RX45_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */


/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX67 Register (2.75)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX67_OFFSET          75
#define ixfIEEE8023_WIS_J0_RX67_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX89 Register (2.76)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX89_OFFSET          76
#define ixfIEEE8023_WIS_J0_RX89_DFLT            0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX1011 Register (2.77)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX1011_OFFSET        77
#define ixfIEEE8023_WIS_J0_RX1011_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX1213 Register (2.78)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX1213_OFFSET        78
#define ixfIEEE8023_WIS_J0_RX1213_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

/******************************************************************************/
/*WIS_J0_RX1415 Register (2.79)*/

/*Offset/Default definition for register.*/
#define ixfIEEE8023_WIS_J0_RX1415_OFFSET        79
#define ixfIEEE8023_WIS_J0_RX1415_DFLT          0x0000

/* -------- Bit, shift and mask defines.-------- */

/******************************************************************************/

#endif /* ixf18100_802_3_B_H */

