/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_gfp.c $
 *   WORKFILE:       $Workfile: ixf18100_gfp.c $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 family device API
 *
 * Purpose: This file contains GFP block related routines
 *
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_gfp.c $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 16    1/10/03 2:30p Pkjain2
 * 
 * 15    12/02/02 2:25p Kssaepha
 * Added support for Setting GFP OpModes 
 * 
 * 14    7/11/02 4:21p Pkjain2
 * Corrected some headers. Added Legal notice to some files. 
 * 
 * 13    7/10/02 3:23p Pkjain2
 * 
 * 12    7/08/02 1:16p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * 11    4/15/02 4:52p Pkjain2
 * Cleaned up some if 0 code.
 * 
 * 10    12/17/01 2:49p Pkjain2
 * Added trace macros
 * 
 * 1     7/18/01 10:55a Rfranz
 * Initial check in - file headers only
 * 
 * --------------------------------------------------------------------------
 */
#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h"
#include "ixf18100_global_b.h"
#include "ixf18100_global_d.h"
#include "ixf18100_global.h"
#include "ixf18100_gfp_b.h"
#include "ixf_api_gfp_d.h"
#include "ixf18100_gfp_d.h"
#include "ixf18100_gfp.h"
#include "ixf18100_sonet_b.h"
#include "ixf18100_d.h"
#include "hal.h"


/******************************INTERNAL ROUTINES******************************/
/******************************************************************************
 * * Function : Ixf18100SetBits16
 * *------------------------------------------------------------------------------
 * * Description : This function does a read-modify-write on a set of bits in
 * *       a 16 bit register.
 * *------------------------------------------------------------------------------
 * * Inputs  : puiReg: Address of the register to be modified.
 * *           uiMask: Mask for the bits to be modified.
 * *           uiValue: Value to be written into the register.
 * * Outputs : None
 * *------------------------------------------------------------------------------
 * * Returns : None
 * *------------------------------------------------------------------------------
 * * Access Globals :
 * *------------------------------------------------------------------------------
 * * Comments :
 * ******************************************************************************/
extern void
Ixf18100SetBits16(ushort *puiReg, ushort uiMask, ushort uiValue);

#if 0
/******************************************************************************
 * * Function : Ixf18100EditGlbCnfg
 * *------------------------------------------------------------------------------
 * * Description : Global configuration functions, the mode combinations are
 * *               mutually exclusive.
 * *------------------------------------------------------------------------------
 * * Inputs  : BaseAddress : Pointer to the base address of the device
 * *           pCnfg : Pointer to values to set in the device
 * * Outputs : None.
 * *------------------------------------------------------------------------------
 * * Returns : bb_NO_ERROR, bb_NULL_ARG
 * *------------------------------------------------------------------------------
 * * Access Globals : None.
 * *------------------------------------------------------------------------------
 * * Comments : None.
 * ******************************************************************************/
extern bb_Error_e
Ixf18100EditGlbCnfg(bb_RegPointer_type BaseAddress, ixf18100_GlbCnfg_t *pCnfg);

/******************************************************************************
 * * Function : Ixf18100SetClkCfg
 * *------------------------------------------------------------------------------
 * * Description : This function sets the clock configuration for the device
 * *------------------------------------------------------------------------------
 * * Inputs  : BaseAddress : Pointer to the base address of the device
 * *         : pCnfg : The pointer to the values to set in the device
 * * Outputs : None.
 * *------------------------------------------------------------------------------
 * * Returns : bb_NO_ERROR
 * *------------------------------------------------------------------------------
 * * Access Globals : None.
 * *------------------------------------------------------------------------------
 * * Comments : None.
 * ******************************************************************************/
extern bb_Error_e
Ixf18100SetClkCfg(bb_RegPointer_type BaseAddress, ixf18100_GlbClkCnfg_t *cnfg);

/******************************************************************************
 * * Function : Ixf18100OifSfiSetGlblLnIntf
 * *------------------------------------------------------------------------------
 * * Description : This function sets the Line Interface configuration
 * *------------------------------------------------------------------------------
 * * Inputs  : BaseAddress : Pointer to the base address of the device
 * *         : pCnfg : The pointer to the values to set in the device
 * * Outputs : None.
 * *------------------------------------------------------------------------------
 * * Returns : None.
 * *------------------------------------------------------------------------------
 * * Access Globals : None.
 * *------------------------------------------------------------------------------
 * * Comments : None.
 * ******************************************************************************/
extern bb_Error_e
Ixf18100OifSfiSetGlblLnIntf(bb_RegPointer_type BaseAddress,
		                            ixf18100_GlobalLineInterfaceCnfg_t *pCnfg);

/******************************************************************************
 * * Function : Ixf18100SetGlblAps
 * *------------------------------------------------------------------------------
 * * Description : This functions sets global APS configuration
 * *------------------------------------------------------------------------------
 * * Inputs  : BaseAddress : Pointer to the base address of the device
 * *         : pCnfg : Pointer to the values to set in the device
 * * Outputs : None.
 * *------------------------------------------------------------------------------
 * * Returns : bb_NO_ERROR
 * *------------------------------------------------------------------------------
 * * Access Globals : None.
 * *------------------------------------------------------------------------------
 * * Comments : None.
 * ******************************************************************************/
extern bb_Error_e
Ixf18100SetGlblAps(bb_RegPointer_type BaseAddress,
	       	ixf18100_GlobalApsCfng_t *pCnfg);
#endif

/******************************************************************************
* Function : Ixf18100GfpRead32
*------------------------------------------------------------------------------
* Description  : Reads 32 bit values (counters) from the SONET block
*------------------------------------------------------------------------------
* Inputs  : ushort *puiLsb: pointer to the least significant bits of the
*                   32 bit value to be read.
*           ushort uiMaskMsb: Mask for the upper 16 bits
*           ushort uiMaskLsb: Mask for the lower 16 bits
* Outputs : none
*------------------------------------------------------------------------------
* Returns : 32 bit value containing properly masked value.
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
ulong
Ixf18100GfpRead32(ushort *puiLsb, ushort uiMaskMsb, ushort uiMaskLsb)
{

	ushort uiBitsHigh, uiBitsLow;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpRead32");

	/* The high counter bits are stored at the higher address, and must
	** be read second.  The function takes the address of the word
	** containing the least significant bits of the counter, so we 
	** add 1 to get the address of the word containing the most
	** significant bits. */
	uiBitsLow = HAL_IXF18100_READ(puiLsb);
	uiBitsHigh = HAL_IXF18100_READ(puiLsb + 1);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpRead32", 0);

	return(((uiBitsHigh & uiMaskMsb) << 16) | (uiBitsLow & uiMaskLsb));
}

/******************************************************************************
* Function : Ixf18100SetGfpMode
*------------------------------------------------------------------------------
* Description  : The function configures the GFP mode and enables the receive
*                and transmit blocks.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           opMode : GFP Mode
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_STM_MODE_MISMATCH, bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100SetGfpMode(bb_ChipData_t *pChipData, bb_OperMode_e opMode)
{
    bb_Error_e rc = bb_NO_ERROR;

    /* Set GFP Mode */
    switch(opMode)
    {
        case GFP_SONET_HEADER_PRE_INSERT_1_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_1_MODE:
            Ixf18100SetBits16(pChipData->BaseAddress
                + ixf18100_GFP_CFG1_OFFSET,
                ixf18100_mGFP_MODE, ixf18100_vGFP_MODE_1);
            break;
            
        case GFP_SONET_HEADER_PRE_INSERT_2_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_2_MODE:
            Ixf18100SetBits16(pChipData->BaseAddress
                + ixf18100_GFP_CFG1_OFFSET,
                ixf18100_mGFP_MODE, ixf18100_vGFP_MODE_2);
            break;

        case GFP_SONET_HEADER_PRE_INSERT_3_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_3_MODE:
            Ixf18100SetBits16(pChipData->BaseAddress
                + ixf18100_GFP_CFG1_OFFSET,
                ixf18100_mGFP_MODE, ixf18100_vGFP_MODE_3);
            break;

        case GFP_SONET_HEADER_PRE_INSERT_4_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_4_MODE:
            Ixf18100SetBits16(pChipData->BaseAddress
                + ixf18100_GFP_CFG1_OFFSET,
                ixf18100_mGFP_MODE, ixf18100_vGFP_MODE_4);
            break;

        case GFP_SONET_HEADER_PRE_INSERT_5_MODE:
        case GFP_CLIENT_MAP_HEADER_PRE_INSERT_5_MODE:
            Ixf18100SetBits16(pChipData->BaseAddress
                + ixf18100_GFP_CFG1_OFFSET,
                ixf18100_mGFP_MODE, ixf18100_vGFP_MODE_5);
            break;

        default:
            rc = bb_STM_MODE_MISMATCH;
            break;
    }

    /* Enable Receive and Transmit GFP Blocks */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_GFP_CFG3_OFFSET,
        IXF_BIT(ixf18100_sGFP_RX_EN), 0x1);

    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_GFP_CFG3_OFFSET,
        IXF_BIT(ixf18100_sGFP_TX_EN), 0x1);

    return rc;
}

/******************************EXTERNAL ROUTINES******************************/

/******************************************************************************
* Function : Ixf18100GfpGlbSetCfg
*------------------------------------------------------------------------------
* Description  : The function takes the values from GFP global config structure
* and masks it appropriately and writes the 16 bit value into the register.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpGlbCfg_t *ptGfpGlbCfg: pointer to the values that need
*				to be set in the device
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpGlbSetCfg(bb_RegPointer_type BaseAddress,
                     ixf18100_GfpGlbCfg_t *ptGfpGlbCfg)
{
	bb_Error_e		rc = bb_NO_ERROR;
	ushort		    usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpGlbSetCfg");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	usValue &= ~(ixf18100_mGFP_MODE);

	usValue |= (ixf18100_mGFP_MODE & (ptGfpGlbCfg->ucGfpProgrammedMode
        << ixf18100_sGFP_MODE));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI3_LENGTH & (ptGfpGlbCfg->ucGfpExi3Length
        << ixf18100_sGFP_EXI3_LENGTH));

	usValue |= (ixf18100_mGFP_EXI4_LENGTH & (ptGfpGlbCfg->ucGfpExi4Length
        << ixf18100_sGFP_EXI4_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL34_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI5_LENGTH & (ptGfpGlbCfg->ucGfpExi5Length
        << ixf18100_sGFP_EXI5_LENGTH));

	usValue |= (ixf18100_mGFP_EXI6_LENGTH & (ptGfpGlbCfg->ucGfpExi6Length
        << ixf18100_sGFP_EXI6_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL56_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI7_LENGTH & (ptGfpGlbCfg->ucGfpExi7Length
        << ixf18100_sGFP_EXI7_LENGTH));

	usValue |= (ixf18100_mGFP_EXI8_LENGTH & (ptGfpGlbCfg->ucGfpExi8Length
        << ixf18100_sGFP_EXI8_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL78_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI9_LENGTH & (ptGfpGlbCfg->ucGfpExi9Length
        << ixf18100_sGFP_EXI9_LENGTH));

	usValue |= (ixf18100_mGFP_EXI10_LENGTH & (ptGfpGlbCfg->ucGfpExi10Length
        << ixf18100_sGFP_EXI10_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL910_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI11_LENGTH & (ptGfpGlbCfg->ucGfpExi11Length
        << ixf18100_sGFP_EXI11_LENGTH));

	usValue |= (ixf18100_mGFP_EXI12_LENGTH & (ptGfpGlbCfg->ucGfpExi12Length
        << ixf18100_sGFP_EXI12_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL1112_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI13_LENGTH & (ptGfpGlbCfg->ucGfpExi13Length
        << ixf18100_sGFP_EXI13_LENGTH));

	usValue |= (ixf18100_mGFP_EXI14_LENGTH & (ptGfpGlbCfg->ucGfpExi14Length
        << ixf18100_sGFP_EXI14_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL1314_OFFSET, usValue);


	usValue = (ixf18100_mGFP_EXI15_LENGTH & (ptGfpGlbCfg->ucGfpExi15Length
        << ixf18100_sGFP_EXI15_LENGTH));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_EXIL15_OFFSET, usValue);


	usValue = (ixf18100_mGFP_MAX_FRM_SIZE & (ptGfpGlbCfg->uiGfpMaxFrmSize
        << ixf18100_sGFP_MAX_FRM_SIZE));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_FRMMAX_OFFSET, usValue);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpGlbSetCfg", rc);

	return rc;
}

/******************************************************************************
* Function : Ixf18100GfpRxSetCfg
*------------------------------------------------------------------------------
* Description  : The function takes the values from GFP Rx config structure
* and masks it appropriately and writes the 16 bit value into the register.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpRxCfg_t *ptGfpRxCfg: pointer to the values that need to 
*				be set in the device
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpRxSetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpRxCfg_t *ptGfpRxCfg)
{
	ushort		usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpRxSetCfg");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_STORE_PLI));

	usValue |= ((ptGfpRxCfg->ucGfpRxStorePliEn & 0x01)
        << ixf18100_sGFP_RX_STORE_PLI);

	usValue &= ~(ixf18100_mGFP_RX_PLI_VAL_STORE);

	usValue |= (ixf18100_mGFP_RX_PLI_VAL_STORE
        & (ptGfpRxCfg->ucGfpRxPliValToStore
            << ixf18100_sGFP_RX_PLI_VAL_STORE));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG2_OFFSET);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_PLD_DESCRMB_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxPldScrmbEn & 0x01)
        << ixf18100_sGFP_RX_PLD_DESCRMB_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_FCS_PROCESS_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxFcsProcessingEn & 0x01)
        << ixf18100_sGFP_RX_FCS_PROCESS_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_LOSS_SYNC_SIG_EN));

	usValue |= ((ptGfpRxCfg->ucGfpSendLosSigToWisEn & 0x01)
        << ixf18100_sGFP_RX_LOSS_SYNC_SIG_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_LOS_DISCARD_FRM));

	usValue |= ((ptGfpRxCfg->ucGfpFwdFrmInAllStateEn & 0x01)
        << ixf18100_sGFP_RX_LOS_DISCARD_FRM);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_MARK_ERR_FRM_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxMarkErrFrmToSifEn & 0x01)
        << ixf18100_sGFP_RX_MARK_ERR_FRM_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_CHEC_ALGO_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxcHecAlgoEn & 0x01)
        << ixf18100_sGFP_RX_CHEC_ALGO_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_THEC_ALGO_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxtHecAlgoEn & 0x01)
        << ixf18100_sGFP_RX_THEC_ALGO_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_DESCRMB_HDR_TO_SIF_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxFwdDescrmbCoreHdrToSifEn & 0x01)
        << ixf18100_sGFP_RX_DESCRMB_HDR_TO_SIF_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_CORE_HDR_DESCRMB_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxCoreHdrDescrmbEn & 0x01)
        << ixf18100_sGFP_RX_CORE_HDR_DESCRMB_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_PRESYNC_PLD_DESCRMB_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxPldDescrmbInPreSyncEn & 0x01)
        << ixf18100_sGFP_RX_PRESYNC_PLD_DESCRMB_EN);

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG2_OFFSET, usValue);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG3_OFFSET);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_EN));

	usValue |= ((ptGfpRxCfg->ucGfpReceiverEn & 0x01) << ixf18100_sGFP_RX_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_FRM_SIZE_CHK_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxMarkLargeFrmEn & 0x01)
        << ixf18100_sGFP_RX_FRM_SIZE_CHK_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_CRC_CTRL_FRM_EN));

	usValue |= ((ptGfpRxCfg->ucGfpRxProcessCtrlFrmCrcEn & 0x01)
        << ixf18100_sGFP_RX_CRC_CTRL_FRM_EN);

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG3_OFFSET, usValue);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG4_OFFSET);

	usValue &= ~(ixf18100_mGFP_RX_THECERRINTPROG);

	usValue = (ixf18100_mGFP_RX_THECERRINTPROG
        & (ptGfpRxCfg->ucGfpRxNumtHecFailToCauseIntr
            << ixf18100_sGFP_RX_THECERRINTPROG));

	usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_THECSERREN));

	usValue |= ((ptGfpRxCfg->ucGfpRxIncCorrectedtHecFailInCount & 0x01)
        << ixf18100_sGFP_RX_THECSERREN);

	usValue &= ~(ixf18100_mGFP_RX_EHECERINTPROG);

	usValue |= (ixf18100_mGFP_RX_EHECERINTPROG
        & (ptGfpRxCfg->ucGfpRxNumeHecFailToCauseIntr
            << ixf18100_sGFP_RX_EHECERINTPROG));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG4_OFFSET, usValue);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG5_OFFSET);

	usValue &= ~(ixf18100_mGFP_RX_CONERRINTPROG);

	usValue = (ixf18100_mGFP_RX_CONERRINTPROG
        & (ptGfpRxCfg->ucGfpNumCtrlFrmRcvdToCauseIntr
            << ixf18100_sGFP_RX_CONERRINTPROG));

	usValue &= ~(ixf18100_mGFP_RX_FCSERRINTPROG);

	usValue |= (ixf18100_mGFP_RX_FCSERRINTPROG
        & (ptGfpRxCfg->ucGfpRxNumFcsFailToCauseIntr
            << ixf18100_sGFP_RX_FCSERRINTPROG));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG5_OFFSET, usValue);


	usValue = (ixf18100_mGFP_RX_FSM_DELTA
        & (ptGfpRxCfg->ucGfpRxcHecFrmDeliDeltaVal
            << ixf18100_sGFP_RX_FSM_DELTA));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_RXFSMDEL_OFFSET, usValue);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpRxSetCfg", bb_NO_ERROR);

	return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100GfpTxSetCfg
*------------------------------------------------------------------------------
* Description  : The function takes the values from GFP Tx config structure
* and masks it appropriately and writes the 16 bit value into the register.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpTxCfg_t *ptGfpTxCfg: pointer to the values that need
*				to be set in the device
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpTxSetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpTxCfg_t *ptGfpTxCfg)
{
	ushort		usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpTxSetCfg");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	usValue &= ~(ixf18100_mGFP_TX_PLI_CTRL_FRM);

	usValue |= (ixf18100_mGFP_TX_PLI_CTRL_FRM
        & (ptGfpTxCfg->ucGfpPliOfTxCtrlFrm
            << ixf18100_sGFP_TX_PLI_CTRL_FRM));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG2_OFFSET);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_PLD_SCRMB_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxPldScrmbEn & 0x01)
        << ixf18100_sGFP_TX_PLD_SCRMB_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_APPEND_FCS_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxFcsAppendEn & 0x01)
        << ixf18100_sGFP_TX_APPEND_FCS_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_FCS_ERR_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxInsFcsErrEn & 0x01)
        << ixf18100_sGFP_TX_FCS_ERR_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_CHDR_SCRMB_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxCoreHdrScrmbEn & 0x01)
        << ixf18100_sGFP_TX_CHDR_SCRMB_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_DATA_STREAM_INS_ERR_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxInsErrInDataStrEn & 0x01)
        << ixf18100_sGFP_TX_DATA_STREAM_INS_ERR_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_IDLE_STREAM_INS_ERR_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxInsErrInIdleStrEn & 0x01)
        << ixf18100_sGFP_TX_IDLE_STREAM_INS_ERR_EN);

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG2_OFFSET, usValue);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG3_OFFSET);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_CTRL_FRM_SEL));

	usValue |= ((ptGfpTxCfg->ucGfpSendCtrlFrmEn & 0x01)
        << ixf18100_sGFP_TX_CTRL_FRM_SEL);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTransmitterEn & 0x01)
        << ixf18100_sGFP_TX_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_READ_SIF_FIFO_EN));

	usValue |= ((ptGfpTxCfg->ucGfpReadFromSifFifoEn & 0x01)
        << ixf18100_sGFP_TX_READ_SIF_FIFO_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_CRC_CTRL_FRM_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxAppendCrcEn & 0x01)
        << ixf18100_sGFP_TX_CRC_CTRL_FRM_EN);

	usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_CORE_HDR_DESCRMB_EN));

	usValue |= ((ptGfpTxCfg->ucGfpTxCoreHdrDescrmbEn & 0x01)
        << ixf18100_sGFP_TX_CORE_HDR_DESCRMB_EN);

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG3_OFFSET, usValue);


	usValue = (ixf18100_mGFP_TX_OAM_BYTES12 & (ptGfpTxCfg->uiGfpTxOamBytes12
        << ixf18100_sGFP_TX_OAM_BYTES12));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_TXOAM1_OFFSET, usValue);


	usValue = (ixf18100_mGFP_TX_OAM_BYTES34 & (ptGfpTxCfg->uiGfpTxOamBytes34
        << ixf18100_sGFP_TX_OAM_BYTES34));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_TXOAM2_OFFSET, usValue);


	usValue = (ixf18100_mGFP_TX_OAM_BYTES56 & (ptGfpTxCfg->uiGfpTxOamBytes56
        << ixf18100_sGFP_TX_OAM_BYTES56));

	HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_TXOAM3_OFFSET, usValue);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpTxSetCfg", bb_NO_ERROR);

	return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100GfpGlbGetCfg
*------------------------------------------------------------------------------
* Description  : The function reads the 16 bit register values and sets the
* value in the structure members appropriately.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpGlbCfg_t *ptGfpGlbCfg: pointer to the values that need to 
*				be set from the current device configuration
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpGlbGetCfg(bb_RegPointer_type BaseAddress,
                     ixf18100_GfpGlbCfg_t *ptGfpGlbCfg)
{
	ushort		usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpGlbGetCfg");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	ptGfpGlbCfg->ucGfpProgrammedMode = (uchar)((usValue & ixf18100_mGFP_MODE)
        >> ixf18100_sGFP_MODE);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL34_OFFSET);

	ptGfpGlbCfg->ucGfpExi4Length = (uchar)((usValue
        & ixf18100_mGFP_EXI4_LENGTH) >> ixf18100_sGFP_EXI4_LENGTH);

	ptGfpGlbCfg->ucGfpExi3Length = (uchar)((usValue
        & ixf18100_mGFP_EXI3_LENGTH) >> ixf18100_sGFP_EXI3_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL56_OFFSET);

	ptGfpGlbCfg->ucGfpExi6Length = (uchar)((usValue
        & ixf18100_mGFP_EXI6_LENGTH) >> ixf18100_sGFP_EXI6_LENGTH);

	ptGfpGlbCfg->ucGfpExi5Length = (uchar)((usValue
        & ixf18100_mGFP_EXI5_LENGTH) >> ixf18100_sGFP_EXI5_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL78_OFFSET);

	ptGfpGlbCfg->ucGfpExi8Length = (uchar)((usValue
        & ixf18100_mGFP_EXI8_LENGTH) >> ixf18100_sGFP_EXI8_LENGTH);

	ptGfpGlbCfg->ucGfpExi7Length = (uchar)((usValue
        & ixf18100_mGFP_EXI7_LENGTH) >> ixf18100_sGFP_EXI7_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL910_OFFSET);

	ptGfpGlbCfg->ucGfpExi10Length = (uchar)((usValue
        & ixf18100_mGFP_EXI10_LENGTH) >> ixf18100_sGFP_EXI10_LENGTH);

	ptGfpGlbCfg->ucGfpExi9Length = (uchar)((usValue
        & ixf18100_mGFP_EXI9_LENGTH) >> ixf18100_sGFP_EXI9_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL1112_OFFSET);

	ptGfpGlbCfg->ucGfpExi12Length = (uchar)((usValue
        & ixf18100_mGFP_EXI12_LENGTH) >> ixf18100_sGFP_EXI12_LENGTH);

	ptGfpGlbCfg->ucGfpExi11Length = (uchar)((usValue
        & ixf18100_mGFP_EXI11_LENGTH) >> ixf18100_sGFP_EXI11_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL1314_OFFSET);

	ptGfpGlbCfg->ucGfpExi14Length = (uchar)((usValue
        & ixf18100_mGFP_EXI14_LENGTH) >> ixf18100_sGFP_EXI14_LENGTH);

	ptGfpGlbCfg->ucGfpExi13Length = (uchar)((usValue
        & ixf18100_mGFP_EXI13_LENGTH) >> ixf18100_sGFP_EXI13_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_EXIL15_OFFSET);

	ptGfpGlbCfg->ucGfpExi15Length = (uchar)((usValue
        & ixf18100_mGFP_EXI15_LENGTH) >> ixf18100_sGFP_EXI15_LENGTH);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_FRMMAX_OFFSET);

	ptGfpGlbCfg->uiGfpMaxFrmSize = (ushort)((usValue
        & ixf18100_mGFP_MAX_FRM_SIZE) >> ixf18100_sGFP_MAX_FRM_SIZE);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpGlbGetCfg", bb_NO_ERROR);

	return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100GfpRxGetCfg
*------------------------------------------------------------------------------
* Description  : The function reads the 16 bit register values and sets the
* value in the structure members appropriately.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpRxCfg_t *ptGfpRxCfg: pointer to the values that need to 
*				be set from the current device configuration
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpRxGetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpRxCfg_t *ptGfpRxCfg)
{
	ushort		usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpRxGetCfg");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	ptGfpRxCfg->ucGfpRxStorePliEn = (uchar)((usValue
        >> ixf18100_sGFP_RX_STORE_PLI) & 0x01);

	ptGfpRxCfg->ucGfpRxPliValToStore
        = (uchar)((usValue & ixf18100_mGFP_RX_PLI_VAL_STORE)
            >> ixf18100_sGFP_RX_PLI_VAL_STORE);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG2_OFFSET);

	ptGfpRxCfg->ucGfpRxPldScrmbEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_PLD_DESCRMB_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxFcsProcessingEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_FCS_PROCESS_EN) & 0x01);

	ptGfpRxCfg->ucGfpSendLosSigToWisEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_LOSS_SYNC_SIG_EN) & 0x01);

	ptGfpRxCfg->ucGfpFwdFrmInAllStateEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_LOS_DISCARD_FRM) & 0x01);

	ptGfpRxCfg->ucGfpRxMarkErrFrmToSifEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_MARK_ERR_FRM_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxcHecAlgoEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_CHEC_ALGO_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxtHecAlgoEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_THEC_ALGO_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxFwdDescrmbCoreHdrToSifEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_DESCRMB_HDR_TO_SIF_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxCoreHdrDescrmbEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_CORE_HDR_DESCRMB_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxPldDescrmbInPreSyncEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_PRESYNC_PLD_DESCRMB_EN) & 0x01);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG3_OFFSET);

	ptGfpRxCfg->ucGfpReceiverEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxMarkLargeFrmEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_FRM_SIZE_CHK_EN) & 0x01);

	ptGfpRxCfg->ucGfpRxProcessCtrlFrmCrcEn
        = (uchar)((usValue >> ixf18100_sGFP_RX_CRC_CTRL_FRM_EN) & 0x01);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG4_OFFSET);

	ptGfpRxCfg->ucGfpRxNumtHecFailToCauseIntr
        = (uchar)((usValue & ixf18100_mGFP_RX_THECERRINTPROG)
            >> ixf18100_sGFP_RX_THECERRINTPROG);

	ptGfpRxCfg->ucGfpRxIncCorrectedtHecFailInCount
        = (uchar)((usValue >> ixf18100_sGFP_RX_THECSERREN) & 0x01);

	ptGfpRxCfg->ucGfpRxNumeHecFailToCauseIntr
        = (uchar)((usValue & ixf18100_mGFP_RX_EHECERINTPROG)
            >> ixf18100_sGFP_RX_EHECERINTPROG);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG5_OFFSET);

	ptGfpRxCfg->ucGfpNumCtrlFrmRcvdToCauseIntr
        = (uchar)((usValue & ixf18100_mGFP_RX_CONERRINTPROG)
            >> ixf18100_sGFP_RX_CONERRINTPROG);

	ptGfpRxCfg->ucGfpRxNumFcsFailToCauseIntr
        = (uchar)((usValue & ixf18100_mGFP_RX_FCSERRINTPROG)
            >> ixf18100_sGFP_RX_FCSERRINTPROG);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_RXFSMDEL_OFFSET);

	ptGfpRxCfg->ucGfpRxcHecFrmDeliDeltaVal
        = (uchar)((usValue & ixf18100_mGFP_RX_FSM_DELTA)
            >> ixf18100_sGFP_RX_FSM_DELTA);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpRxGetCfg", bb_NO_ERROR);

	return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100GfpTxGetCfg
*------------------------------------------------------------------------------
* Description  : The function reads the 16 bit register values and sets the
* value in the structure members appropriately.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			ixf18100_GfpTxCfg_t *ptGfpTxCfg: pointer to the values that need to 
*				be set from the current device configuration
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpTxGetCfg(bb_RegPointer_type BaseAddress,
                    ixf18100_GfpTxCfg_t *ptGfpTxCfg)
{
	ushort		usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpTxGetCfg");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	ptGfpTxCfg->ucGfpPliOfTxCtrlFrm
        = (uchar)((usValue & ixf18100_mGFP_TX_PLI_CTRL_FRM)
            >> ixf18100_sGFP_TX_PLI_CTRL_FRM);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG2_OFFSET);

	ptGfpTxCfg->ucGfpTxPldScrmbEn
        = (uchar)((usValue >> ixf18100_sGFP_TX_PLD_SCRMB_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxFcsAppendEn
        = ((usValue >> ixf18100_sGFP_TX_APPEND_FCS_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxInsFcsErrEn
        = ((usValue >> ixf18100_sGFP_TX_FCS_ERR_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxCoreHdrScrmbEn
        = ((usValue >> ixf18100_sGFP_TX_CHDR_SCRMB_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxInsErrInDataStrEn
        = ((usValue >> ixf18100_sGFP_TX_DATA_STREAM_INS_ERR_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxInsErrInIdleStrEn
        = ((usValue >> ixf18100_sGFP_TX_IDLE_STREAM_INS_ERR_EN) & 0x01);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG3_OFFSET);

	ptGfpTxCfg->ucGfpSendCtrlFrmEn
        = ((usValue >> ixf18100_sGFP_TX_CTRL_FRM_SEL) & 0x01);

	ptGfpTxCfg->ucGfpTransmitterEn
        = ((usValue >> ixf18100_sGFP_TX_EN) & 0x01);

	ptGfpTxCfg->ucGfpReadFromSifFifoEn
        = ((usValue >> ixf18100_sGFP_TX_READ_SIF_FIFO_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxAppendCrcEn
        = ((usValue >> ixf18100_sGFP_TX_CRC_CTRL_FRM_EN) & 0x01);

	ptGfpTxCfg->ucGfpTxCoreHdrDescrmbEn
        = ((usValue >> ixf18100_sGFP_TX_CORE_HDR_DESCRMB_EN) & 0x01);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_TXOAM1_OFFSET);

	ptGfpTxCfg->uiGfpTxOamBytes12
        = (ushort)((usValue & ixf18100_mGFP_TX_OAM_BYTES12)
            >> ixf18100_sGFP_TX_OAM_BYTES12);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_TXOAM2_OFFSET);

	ptGfpTxCfg->uiGfpTxOamBytes34
        = (ushort)((usValue & ixf18100_mGFP_TX_OAM_BYTES34)
            >> ixf18100_sGFP_TX_OAM_BYTES34);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_TXOAM3_OFFSET);

	ptGfpTxCfg->uiGfpTxOamBytes56
        = (ushort)((usValue & ixf18100_mGFP_TX_OAM_BYTES56)
            >> ixf18100_sGFP_TX_OAM_BYTES56);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpTxGetCfg", bb_NO_ERROR);

	return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100GfpRxGetCounters
*------------------------------------------------------------------------------
* Description  : The function reads one/all the GFP Rx counters
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			bb_SelCounters_e SelCntr: selects coutner to be returned
*			void *ptCounters: pointer to the counter structure
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_SEL_COUNTERS
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpRxGetCounters(bb_RegPointer_type BaseAddress,
                         bb_SelCounters_e SelCntr, void *ptCounters)
{
	bb_Error_e			rc = bb_NO_ERROR;
	ushort			usValue;
	ulong			*ulCounter = (ulong *)ptCounters;
	uchar				*ucCounter = (uchar *)ptCounters;
	ixfApi_GfpRxCntr_t	*ptGfpRxCounters = (ixfApi_GfpRxCntr_t *)ptCounters;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpRxGetCounters");

	switch (SelCntr)
	{
	case bb_GFP_RX_FRM_SBC_HEC_FAIL_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_SBCHECFAIL_W0_OFFSET, 
				ixf18100_mGFP_RXFRM_SBCHECFAIL_W1,
                ixf18100_mGFP_RXFRM_SBCHECFAIL_W0);
		break;

    case bb_GFP_RX_FRM_MBC_HEC_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_MBCHEC_W0_OFFSET, 
				ixf18100_mGFP_RXFRM_MBCHEC_W1, ixf18100_mGFP_RXFRM_MBCHEC_W0);
		break;

    case bb_GFP_RX_FRM_SBT_HEC_FAIL_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_SBTHECFAIL_W0_OFFSET,
				ixf18100_mGFP_RXFRM_SBTHECFAIL_W1,
                ixf18100_mGFP_RXFRM_SBTHECFAIL_W0);
		break;

    case bb_GFP_RX_FRM_MBT_HEC_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_MBTHEC_W0_OFFSET,
				ixf18100_mGFP_RXFRM_MBTHEC_W1, ixf18100_mGFP_RXFRM_MBTHEC_W0);
		break;

    case bb_GFP_RX_FRM_EHEC_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_EHEC_W0_OFFSET,
				ixf18100_mGFP_RXFRM_EHEC_W1, ixf18100_mGFP_RXFRM_EHEC_W0);
		break;

    case bb_GFP_RX_CTRL_FRM_CRC_ERR_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_CCRC_W0_OFFSET,
				ixf18100_mGFP_RXFRM_CCRC_W1, ixf18100_mGFP_RXFRM_CCRC_W0);
		break;

    case bb_GFP_RX_FRM_FCS_ERR_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_FCS_W0_OFFSET,
				ixf18100_mGFP_RXFRM_FCS_W1, ixf18100_mGFP_RXFRM_FCS_W0);
		break;

    case bb_GFP_RX_CTRL_FRM_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXCNTLFRM_W0_OFFSET,
				ixf18100_mGFP_RXCNTLFRM_W1, ixf18100_mGFP_RXCNTLFRM_W0);
		break;

    case bb_GFP_RX_LARGE_FRM_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_MAX_W0_OFFSET,
				ixf18100_mGFP_RXFRM_MAX_W1, ixf18100_mGFP_RXFRM_MAX_W0);
		break;

    case bb_GFP_RX_GOOD_FRM_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress + ixf18100_GFP_RX_GDFRM_W0_OFFSET,
				ixf18100_mGFP_RX_GDFRM_W1, ixf18100_mGFP_RX_GDFRM_W0);
		break;

    case bb_GFP_RX_CTRL_INT_CNT:
		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXCNTL_CNTI_OFFSET);

		*ucCounter = (uchar)((usValue & ixf18100_mGFP_RX_CTRL_FRM_CNT_INT)
            >> ixf18100_sGFP_RX_CTRL_FRM_CNT_INT);
		break;

    case bb_GFP_RX_THEC_ERR_INT_CNT:
		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXTHECER_CNTI_OFFSET);

		*ucCounter = (uchar)((usValue & ixf18100_mGFP_RX_THEC_ERR_CNT_INT)
            >> ixf18100_sGFP_RX_THEC_ERR_CNT_INT);
		break;

    case bb_GFP_RX_EHEC_ERR_INT_CNT:
		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXEHECER_CNTI_OFFSET);

		*ucCounter = (uchar)((usValue & ixf18100_mGFP_RX_EHEC_ERR_CNT_INT)
            >> ixf18100_sGFP_RX_EHEC_ERR_CNT_INT);
		break;

    case bb_GFP_RX_FCS_ERR_INT_CNT:
		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXFCSER_CNTI_OFFSET);

		*ucCounter = (uchar)((usValue & ixf18100_mGFP_RX_FCS_ERR_CNT_INT)
            >> ixf18100_sGFP_RX_FCS_ERR_CNT_INT);
		break;

    case bb_GFP_RX_COUNTERS:
		ptGfpRxCounters->ulGfpRxFrmSbcHecFailCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_SBCHECFAIL_W0_OFFSET, 
				ixf18100_mGFP_RXFRM_SBCHECFAIL_W1,
                ixf18100_mGFP_RXFRM_SBCHECFAIL_W0);

		ptGfpRxCounters->ulGfpRxFrmMbcHecCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_MBCHEC_W0_OFFSET, 
				ixf18100_mGFP_RXFRM_MBCHEC_W1, ixf18100_mGFP_RXFRM_MBCHEC_W0);

		ptGfpRxCounters->ulGfpRxFrmSbtHecFailCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_SBTHECFAIL_W0_OFFSET, 
				ixf18100_mGFP_RXFRM_SBTHECFAIL_W1,
                ixf18100_mGFP_RXFRM_SBTHECFAIL_W0);

		ptGfpRxCounters->ulGfpRxFrmMbtHecCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_MBTHEC_W0_OFFSET,
				ixf18100_mGFP_RXFRM_MBTHEC_W1, ixf18100_mGFP_RXFRM_MBTHEC_W0);

		ptGfpRxCounters->ulGfpRxFrmeHecCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_EHEC_W0_OFFSET,
                ixf18100_mGFP_RXFRM_EHEC_W1, ixf18100_mGFP_RXFRM_EHEC_W0);

		ptGfpRxCounters->ulGfpRxCtrlFrmCrcErrCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_CCRC_W0_OFFSET,
				ixf18100_mGFP_RXFRM_CCRC_W1, ixf18100_mGFP_RXFRM_CCRC_W0);

		ptGfpRxCounters->ulGfpRxFrmFcsErrCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_FCS_W0_OFFSET,
				ixf18100_mGFP_RXFRM_FCS_W1, ixf18100_mGFP_RXFRM_FCS_W0);

		ptGfpRxCounters->ulGfpRxCtrlFrmCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXCNTLFRM_W0_OFFSET,
				ixf18100_mGFP_RXCNTLFRM_W1, ixf18100_mGFP_RXCNTLFRM_W0);

		ptGfpRxCounters->ulGfpRxLargeFrmCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RXFRM_MAX_W0_OFFSET,
				ixf18100_mGFP_RXFRM_MAX_W1, ixf18100_mGFP_RXFRM_MAX_W0);

		ptGfpRxCounters->ulGfpRxGoodFrmCnt
			= Ixf18100GfpRead32(BaseAddress
                + ixf18100_GFP_RX_GDFRM_W0_OFFSET,
				ixf18100_mGFP_RX_GDFRM_W1, ixf18100_mGFP_RX_GDFRM_W0);

		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXCNTL_CNTI_OFFSET);

		ptGfpRxCounters->ucGfpRxCtrlFrmIntCnt
            = (uchar)((usValue & ixf18100_mGFP_RX_CTRL_FRM_CNT_INT)
                >> ixf18100_sGFP_RX_CTRL_FRM_CNT_INT);

		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXTHECER_CNTI_OFFSET);

		ptGfpRxCounters->ucGfpRxtHecErrIntCnt
            = (uchar)((usValue & ixf18100_mGFP_RX_THEC_ERR_CNT_INT)
                >> ixf18100_sGFP_RX_THEC_ERR_CNT_INT);

		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXEHECER_CNTI_OFFSET);

		ptGfpRxCounters->ucGfpRxeHecErrIntCnt
            = (uchar)((usValue & ixf18100_mGFP_RX_EHEC_ERR_CNT_INT)
                >> ixf18100_sGFP_RX_EHEC_ERR_CNT_INT);

		usValue = HAL_IXF18100_READ(BaseAddress
            + ixf18100_GFP_RXFCSER_CNTI_OFFSET);

		ptGfpRxCounters->ucGfpRxFcsErrIntCnt
            = (uchar)((usValue & ixf18100_mGFP_RX_FCS_ERR_CNT_INT)
                >> ixf18100_sGFP_RX_FCS_ERR_CNT_INT);
		break;
	default:
		rc = bb_INV_SEL_COUNTERS;
		break;
	}

	IXF_FUNC_EXIT_TRC("Ixf18100GfpRxGetCounters", rc);

	return rc;
}

/******************************************************************************
* Function : Ixf18100GfpTxGetCounters
*------------------------------------------------------------------------------
* Description  : The function reads one/all the GFP Tx counters
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			bb_SelCounters_e SelCntr: selects coutner to be returned
*			void *ptCounters: pointer to the counter structure
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_SEL_COUNTERS
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpTxGetCounters(bb_RegPointer_type BaseAddress,
                         bb_SelCounters_e SelCntr, void *ptCounters)
{
	bb_Error_e			rc = bb_NO_ERROR;
	ulong				*ulCounter = (ulong *)ptCounters;
	ixfApi_GfpTxCntr_t	*ptGfpTxCounters = (ixfApi_GfpTxCntr_t *)ptCounters;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpTxGetCounters");

	switch (SelCntr)
	{
	case bb_GFP_TX_GOOD_FRM_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress + ixf18100_GFP_TX_GDFRM_W0_OFFSET,
				ixf18100_mGFP_TX_GDFRM_W1, ixf18100_mGFP_TX_GDFRM_W0);
		break;

    case bb_GFP_TX_ERR_FRM_CNT:
		*ulCounter
			= Ixf18100GfpRead32(BaseAddress + ixf18100_GFP_TXFRMER_W0_OFFSET,
				ixf18100_mGFP_TXFRMER_W1, ixf18100_mGFP_TXFRMER_W0);
		break;

    case bb_GFP_TX_COUNTERS:
		ptGfpTxCounters->ulGfpTxGoodFrmCnt
			= Ixf18100GfpRead32(BaseAddress + ixf18100_GFP_TX_GDFRM_W0_OFFSET,
				ixf18100_mGFP_TX_GDFRM_W1, ixf18100_mGFP_TX_GDFRM_W0);

		ptGfpTxCounters->ulGfpTxErrFrmCnt
			= Ixf18100GfpRead32(BaseAddress + ixf18100_GFP_TXFRMER_W0_OFFSET,
				ixf18100_mGFP_TXFRMER_W1, ixf18100_mGFP_TXFRMER_W0);
		break;

    default:
		rc = bb_INV_SEL_COUNTERS;
		break;
	}

	IXF_FUNC_EXIT_TRC("Ixf18100GfpTxGetCounters", rc);

	return rc;
}

/******************************************************************************
* Function : Ixf18100GfpSetCfg
*------------------------------------------------------------------------------
* Description  : The function takes the values from GFP config structure and 
* masks it appropriately and writes the 16 bit value into the register.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			bb_SelConfig_e	SelCfg: enum value defining what configuration
*				needs to be set
*			ixf18100_GfpCfg_t *ptGfpCfg: pointer to the values that need to 
*				be set in the device
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_PARAMETER
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpSetCfg(bb_RegPointer_type BaseAddress, bb_SelConfig_e SelCfg,
                  ixf18100_GfpCfg_t *ptGfpCfg)
{
	bb_Error_e		rc = bb_NO_ERROR;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpSetCfg");

	switch (SelCfg)
	{
	case e_GLOBAL_CONFIG:
		rc = Ixf18100GfpGlbSetCfg(BaseAddress, &(ptGfpCfg->GfpGlbCfg));
		break;

    case e_RX_CONFIG:
		rc = Ixf18100GfpRxSetCfg(BaseAddress, &(ptGfpCfg->GfpRxCfg));
		break;

    case e_TX_CONFIG:
		rc = Ixf18100GfpTxSetCfg(BaseAddress, &(ptGfpCfg->GfpTxCfg));
		break;

    case e_ALL_CONFIG:
		rc = Ixf18100GfpGlbSetCfg(BaseAddress, &(ptGfpCfg->GfpGlbCfg));
		rc = Ixf18100GfpRxSetCfg(BaseAddress, &(ptGfpCfg->GfpRxCfg));
		rc = Ixf18100GfpTxSetCfg(BaseAddress, &(ptGfpCfg->GfpTxCfg));
		break;

    default:
		rc = bb_INV_PARAMETER;
		break;
	}

	IXF_FUNC_EXIT_TRC("Ixf18100GfpSetCfg", rc);

	return rc;
}

/******************************************************************************
* Function : Ixf18100GfpGetCfg
*------------------------------------------------------------------------------
* Description  : The function reads the 16 bit register values and sets the
* value in the structure members appropriately.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*			bb_SelConfig_e	SelCfg: enum value defining what configuration
*				needs to be set
*			ixf18100_GfpCfg_t *ptGfpCfg: pointer to the values that need to 
*				be set from the current device configuration
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_PARAMETER
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpGetCfg(bb_RegPointer_type BaseAddress, bb_SelConfig_e SelCfg,
                  ixf18100_GfpCfg_t *ptGfpCfg)
{
	bb_Error_e		rc = bb_NO_ERROR;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpGetCfg");

	switch (SelCfg)
	{
	case e_GLOBAL_CONFIG:
		rc = Ixf18100GfpGlbGetCfg(BaseAddress, &(ptGfpCfg->GfpGlbCfg));
		break;

    case e_RX_CONFIG:
		rc = Ixf18100GfpRxGetCfg(BaseAddress, &(ptGfpCfg->GfpRxCfg));
		break;

    case e_TX_CONFIG:
		rc = Ixf18100GfpTxGetCfg(BaseAddress, &(ptGfpCfg->GfpTxCfg));
		break;

    case e_ALL_CONFIG:
		rc = Ixf18100GfpGlbGetCfg(BaseAddress, &(ptGfpCfg->GfpGlbCfg));
		rc = Ixf18100GfpRxGetCfg(BaseAddress, &(ptGfpCfg->GfpRxCfg));
		rc = Ixf18100GfpTxGetCfg(BaseAddress, &(ptGfpCfg->GfpTxCfg));
		break;

    default:
		rc = bb_INV_PARAMETER;
		break;
	}

	IXF_FUNC_EXIT_TRC("Ixf18100GfpGetCfg", rc);

	return rc;
}

/******************************************************************************
* Function : Ixf18100GfpGetCounters
*------------------------------------------------------------------------------
* Description  : The function reads one/all the GFP counters
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*           bb_SelCounters_e SelCntr: Selctes the counter(s) to be read.
*			void *ptGfpCounters: pointer to the counter 
*				structure
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_SEL_COUNTERS
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpGetCounters(bb_RegPointer_type BaseAddress,
                       bb_SelCounters_e SelCntr, void *ptGfpCounters)
{
	bb_Error_e		rc = bb_NO_ERROR;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpGetCounters");

	switch (SelCntr)
	{
	case bb_GFP_RX_FRM_SBC_HEC_FAIL_CNT:
	case bb_GFP_RX_FRM_MBC_HEC_CNT:
	case bb_GFP_RX_FRM_SBT_HEC_FAIL_CNT:
	case bb_GFP_RX_FRM_MBT_HEC_CNT:
	case bb_GFP_RX_FRM_EHEC_CNT:
	case bb_GFP_RX_CTRL_FRM_CRC_ERR_CNT:
	case bb_GFP_RX_FRM_FCS_ERR_CNT:
	case bb_GFP_RX_CTRL_FRM_CNT:
	case bb_GFP_RX_LARGE_FRM_CNT:
	case bb_GFP_RX_GOOD_FRM_CNT:
	case bb_GFP_RX_CTRL_INT_CNT:
	case bb_GFP_RX_THEC_ERR_INT_CNT:
	case bb_GFP_RX_EHEC_ERR_INT_CNT:
	case bb_GFP_RX_FCS_ERR_INT_CNT:
	case bb_GFP_RX_COUNTERS:
		rc = Ixf18100GfpRxGetCounters(BaseAddress, SelCntr, ptGfpCounters);
		break;

    case bb_GFP_TX_GOOD_FRM_CNT:
	case bb_GFP_TX_ERR_FRM_CNT:
	case bb_GFP_TX_COUNTERS:
		rc = Ixf18100GfpTxGetCounters(BaseAddress, SelCntr, ptGfpCounters);
		break;

    case bb_GFP_COUNTERS:
		rc = Ixf18100GfpRxGetCounters(BaseAddress, bb_GFP_RX_COUNTERS,
			(void *)&(((ixfApi_GfpCntr_t *)ptGfpCounters)->GfpRxCntr));
		rc = Ixf18100GfpTxGetCounters(BaseAddress, bb_GFP_TX_COUNTERS,
			(void *)&(((ixfApi_GfpCntr_t *)ptGfpCounters)->GfpTxCntr));
		break;

    default:
		rc = bb_INV_SEL_COUNTERS;
		break;
	}

	IXF_FUNC_EXIT_TRC("Ixf18100GfpGetCounters", rc);

	return rc;
}

/******************************************************************************
* Function : Ixf18100GfpGetStatus
*------------------------------------------------------------------------------
* Description  : The function reads the 16 bit register values and sets the
* value in the structure members appropriately.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*           selStatus : Type of Status: 
*			void *ptGfpStatus: pointer to the status
*				that needs to be read from the device
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100GfpGetStatus(bb_RegPointer_type BaseAddress,
                     bb_SelStatus_e selStatus, void* pStatus)
{
	ushort			usValue;
	ixf18100_GfpStatus_t	*ptGfpStatus = (ixf18100_GfpStatus_t *)pStatus;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpGetStatus");

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);

	ptGfpStatus->ucGfpProgrammedMode
        = (uchar)((usValue & ixf18100_mGFP_MODE) >> ixf18100_sGFP_MODE);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_STAT_OFFSET);

	ptGfpStatus->ucGfpRxDeliFsmState
        = (uchar)((usValue & ixf18100_mGFP_RX_FSM_STATE_STATUS)
            >> ixf18100_sGFP_RX_FSM_STATE_STATUS);

	ptGfpStatus->ucGfpRxAisIndication
        = ((usValue >> ixf18100_sGFP_RX_AIS_INDICATION) & 0x01);

	ptGfpStatus->ucGfpRxCtrlBytOfCsfFrm
        = (uchar)((usValue & ixf18100_mGFP_RX_CTRL_BYTE_CSF_FRM)
            >> ixf18100_sGFP_RX_CTRL_BYTE_CSF_FRM);

	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_TXPL_OFFSET);

	ptGfpStatus->uiGfpTxLastPliVal
        = ((usValue & ixf18100_mGFP_TX_LAST_PLI) >> ixf18100_sGFP_TX_LAST_PLI);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_RXPL_OFFSET);

	ptGfpStatus->uiGfpRxLastPliVal
        = ((usValue & ixf18100_mGFP_RX_LAST_PLI) >> ixf18100_sGFP_RX_LAST_PLI);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_TXPLTYPE_OFFSET);

	ptGfpStatus->uiGfpTxLastPldTypeVal
        = ((usValue & ixf18100_mGFP_TX_LAST_PL_TYPE)
            >> ixf18100_sGFP_TX_LAST_PL_TYPE);


	usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_RXPLTYPE_OFFSET);

	ptGfpStatus->uiGfpRxLastPldTypeVal
        = ((usValue & ixf18100_mGFP_RX_LAST_PL_TYPE)
            >> ixf18100_sGFP_RX_LAST_PL_TYPE);

	IXF_FUNC_EXIT_TRC("Ixf18100GfpGetStatus", bb_NO_ERROR);

	return bb_NO_ERROR;
}

/******************************************************************************
* Function : Ixf18100GfpReset
*------------------------------------------------------------------------------
* Description  : Reset the GFP interfaces and then reconfigure it.
*------------------------------------------------------------------------------
* Inputs  : bb_RegPointer_type BaseAddress: Base address of the device.
*           resetType : Specifies type of Reset
* Outputs : None.
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_RESET_TYPE
*------------------------------------------------------------------------------
* Access Globals : None.
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e 
Ixf18100GfpReset(bb_RegPointer_type BaseAddress, bb_SelResetType_e resetType)
{
	bb_Error_e		rc = bb_NO_ERROR;
	ushort		usValue;

	IXF_FUNC_ENTRY_TRC("Ixf18100GfpReset");

	switch (resetType)
	{
	case bb_RESET_GFP_TX_INTF:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_TX_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    case bb_RESET_GFP_RX_INTF:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_RX_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    case bb_RESET_GFP_CPU_INTF:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_CPU_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_CPU_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    case bb_RESET_GFP_TX_FCS:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_TX_FCS_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_TX_FCS_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    case bb_RESET_GFP_RX_FCS:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_RX_FCS_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_FCS_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    case bb_RESET_GFP_RX_FSM:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_RX_FSM_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_RX_FSM_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    case bb_RESET_GFP:
		usValue = HAL_IXF18100_READ(BaseAddress + ixf18100_GFP_CFG1_OFFSET);
		usValue |= (0x01 << ixf18100_sGFP_RESET);
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);

		usValue &= ~(IXF_BIT(ixf18100_sGFP_RESET));
		HAL_IXF18100_WRITE(BaseAddress + ixf18100_GFP_CFG1_OFFSET, usValue);
		break;

    default:
		rc = bb_INV_RESET_TYPE;
		break;
	}

	IXF_FUNC_EXIT_TRC("Ixf18100GfpReset", rc);

    return rc;
}

/******************************************************************************
* Function : Ixf18100SetGfpOverSonetMode
*------------------------------------------------------------------------------
* Description  : The function configures the device from end to end for GFP
*                over SONET mode.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           opMode : GFP Mode
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100SetGfpOverSonetMode(bb_ChipData_t *pChipData, bb_OperMode_e opMode)
{
    bb_Error_e rc = bb_NO_ERROR;
    ixf18100_GlbCnfg_t tGlbCfg;
    ixf18100_GlbClkCnfg_t tGlbClkCfg;
    ixf18100_GlobalLineInterfaceCnfg_t tLineIntfCfg;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP)
    {
        return(bb_INV_CHIP_TYPE);
    }

    /* Initialize all bits to defaults */
    tGlbCfg.glbCnfgReg = ixf18100_GLB_CFG1_DFLT;
    tGlbClkCfg.reg1.uiReg = ixf18100_GLB_CLKCFG1_DFLT;
    tGlbClkCfg.reg2.uiReg = ixf18100_GLB_CLKCFG2_DFLT;
    tLineIntfCfg.lineCfg.reg = ixf18100_GLB_LINE_DFLT;
    
    /* Set Global Configuration */
    tGlbCfg.Cnfg.modeSelection = ixf18100_eGFP_MODE;
    tGlbCfg.Cnfg.sonetEnable = ixf18100_eSONET_ENABLED;
    tGlbCfg.Cnfg.lineSpeedSel = ixf18100_eWAN_OC192;
    rc = Ixf18100EditGlbCnfg(pChipData->BaseAddress, &tGlbCfg);

    /* Set Clock Configuration (forward clocking) */
    tGlbClkCfg.reg1.tCnfg.txAOifClk = ixf18100_eRLCI;
    tGlbClkCfg.reg1.tCnfg.txOifClk = ixf18100_eRLCI;
    tGlbClkCfg.reg1.tCnfg.txApsClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.txFifoClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.refOutClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.rxPathClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.txPathClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.txTmsprtClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg2.tCnfg.rxClkDiv = ixf18100_eDIVIDE_RLCI_BY_8;
    tGlbClkCfg.reg2.tCnfg.refClkInDiv = ixf18100_eDIVIDE_REF_BY_8; 
    rc = Ixf18100SetClkCfg(pChipData->BaseAddress, &tGlbClkCfg);
    
    /* Set the Line Interface Configuration */
    tLineIntfCfg.lineCfg.Cfg.rlciInv = ixf18100_eINVERT_POLARITY;
    tLineIntfCfg.rxDataInvMask = ixf18100_eDO_NOT_INVERT;
    tLineIntfCfg.txDataInvMask = ixf18100_eDO_NOT_INVERT;
    rc = Ixf18100OifSfiSetGlblLnIntf(pChipData->BaseAddress, &tLineIntfCfg);

    /* Select SPI4 Receive Clock */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_GLB_SPI4_OFFSET,
        IXF_BIT(ixf18100_sSPI4_RX_CLK_SEL), 0x1);

    /*** Set SONET Configuration ***/
    /* Select AIS-P Not Generated */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_RL_POH_CFG2_OFFSET,
        IXF_BIT(ixf18100_sFRC_AIS_EN), 0x0);

    /* Clear AIS-P Override to Carry Traffic */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_POH_CTL_OFFSET,
        IXF_BIT(ixf18100_sINS_AIS_P), 0x0);

    /* Select B3 Source to be Internally Calculated */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_POH_SCA_B3_OFFSET,
        ixf18100_mTL_POH_SRC, ixf18100_POH_SRC_HARDWARE);

    /* Select C2 Source from Microprocessor Registers */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_POH_SCA_C2_OFFSET,
        ixf18100_mTL_POH_SRC, ixf18100_POH_SRC_MICRO_PROC);

    /* Select G1 Source from Microprocessor Registers */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_POH_SCA_G1_OFFSET,
        ixf18100_mTL_POH_SRC, ixf18100_POH_SRC_MICRO_PROC);

    /* Set C2 Value */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_POH_BVA_C2_OFFSET,
        ixf18100_mTL_POH_BVA, 0x401);

    /* Set G1 Value */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_POH_BVA_G1_OFFSET,
        ixf18100_mTL_POH_BVA, 0x400);

    /* Clear AIS-L Override to Carry Traffic on Tx */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_TL_SC1_TOH_0_OFFSET,
        IXF_BIT(ixf18100_sINS_AIS_L), 0x0);

    /* Clear AIS-L Override to Carry Traffic on APS Tx */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_APS_TL_SC1_TOH_OFFSET,
        IXF_BIT(ixf18100_sINS_AIS_L), 0x1);

    /*** Set GFP Configuration ***/
    /* Important: All mode related configurations should be set before 
       enabling the GFP interface. */
    /* Set GFP Mode */
    rc = Ixf18100SetGfpMode(pChipData, opMode);

    return rc;    
}

/******************************************************************************
* Function : Ixf18100SetGfpClientMapMode
*------------------------------------------------------------------------------
* Description  : The function configures the device from end to end for GFP
*                Client Map mode.
*------------------------------------------------------------------------------
* Inputs  : pChipData : Validated Chip Data
*           opMode : GFP Mode
* Outputs : none
*------------------------------------------------------------------------------
* Returns : bb_NO_ERROR, bb_INV_CHIP_TYPE
*------------------------------------------------------------------------------
* Access Globals : none
*------------------------------------------------------------------------------
* Comments : 
******************************************************************************/
bb_Error_e
Ixf18100SetGfpClientMapMode(bb_ChipData_t *pChipData, bb_OperMode_e opMode)
{
    bb_Error_e rc = bb_NO_ERROR;
    ixf18100_GlbCnfg_t tGlbCfg;
    ixf18100_GlbClkCnfg_t tGlbClkCfg;
    ixf18100_GlobalLineInterfaceCnfg_t tLineIntfCfg;

    /* Validate ChipType */
    if (pChipData->ChipType != bb_18101_CHIP &&
        pChipData->ChipType != bb_18102_CHIP &&
        pChipData->ChipType != bb_18101_8023WIS_CHIP)
    {
        return(bb_INV_CHIP_TYPE);
    }

    /* Initialize all bits to defaults */
    tGlbCfg.glbCnfgReg = ixf18100_GLB_CFG1_DFLT;
    tGlbClkCfg.reg1.uiReg = ixf18100_GLB_CLKCFG1_DFLT;
    tGlbClkCfg.reg2.uiReg = ixf18100_GLB_CLKCFG2_DFLT;
    tLineIntfCfg.lineCfg.reg = ixf18100_GLB_LINE_DFLT;
    
    /* Set Global Configuration */
    tGlbCfg.Cnfg.modeSelection = ixf18100_eGFP_MODE;
    tGlbCfg.Cnfg.sonetEnable = ixf18100_eSONET_DISABLED;
    tGlbCfg.Cnfg.lineSpeedSel = ixf18100_eWAN_OC192;
    rc = Ixf18100EditGlbCnfg(pChipData->BaseAddress, &tGlbCfg);

    /* Set Clock Configuration (forward clocking) */
    tGlbClkCfg.reg1.tCnfg.txAOifClk = ixf18100_eRLCI;
    tGlbClkCfg.reg1.tCnfg.txOifClk = ixf18100_eRLCI;
    tGlbClkCfg.reg1.tCnfg.txApsClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.txFifoClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.refOutClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.rxPathClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.txPathClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg1.tCnfg.txTmsprtClk = ixf18100_eCLK_RXOIF_77;
    tGlbClkCfg.reg2.tCnfg.rxClkDiv = ixf18100_eDIVIDE_RLCI_BY_8;
    tGlbClkCfg.reg2.tCnfg.refClkInDiv = ixf18100_eDIVIDE_REF_BY_8; 
    rc = Ixf18100SetClkCfg(pChipData->BaseAddress, &tGlbClkCfg);
    
    /* Set the Line Interface Configuration */
    tLineIntfCfg.lineCfg.Cfg.rlciInv = ixf18100_eINVERT_POLARITY;
    tLineIntfCfg.rxDataInvMask = ixf18100_eDO_NOT_INVERT;
    tLineIntfCfg.txDataInvMask = ixf18100_eDO_NOT_INVERT;
    rc = Ixf18100OifSfiSetGlblLnIntf(pChipData->BaseAddress, &tLineIntfCfg);

    /* Select SPI4 Receive Clock */
    Ixf18100SetBits16(pChipData->BaseAddress + ixf18100_GLB_SPI4_OFFSET,
        IXF_BIT(ixf18100_sSPI4_RX_CLK_SEL), 0x1);

    /*** Set GFP Configuration ***/
    /* Important: All mode related configurations should be set before 
       enabling the GFP interface. */
    /* Set GFP Mode */
    rc = Ixf18100SetGfpMode(pChipData, opMode);

    return rc;
}

