/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_global_b.h $
 *   WORKFILE:       $Workfile: ixf18100_global_b.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 API 
 * 
 * Purpose: This file contains register and bit defines for the GLOBAL  
 *          Configuration registers in the ixf18100.
 *
 * Notes:
 *
 *   
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 * $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_global_b.h $ 
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 22    1/30/03 4:40p Pkjain2
 * Made changes for PTQ release. Added Getstatus calls for SONET and
 * GLOBAL block.
 * 
 * 21    6/17/02 4:52p Jaalliso
 * Adding mask values
 * 
 * 20    6/07/02 8:26a Jaalliso
 * Adding mask values
 * 
 * 19    5/22/02 4:10p Jaalliso
 * Adding mask values
 * 
 * 18    5/15/02 1:07p Rcordova
 * Fixed define declaration for ixf18100_vGLB_CFG1_GFPFIBER constant
 * instead of ixf18100_vGLB_CFG1_GFPCLIENT_FIBER constant.
 * 
 * 17    5/13/02 12:53p Jaalliso
 * Adding ixf18100_GLB_CHIPID_DFLT values for 101/2/3/4
 * 
 * 16    5/01/02 4:07p Pkjain2
 * Fixed Set Get OpMode
 * 
 * 15    4/26/02 4:22p Jjchin
 * Added bits 7:4 controls to GLB_RST register.
 * 
 * 14    4/16/02 4:05p Jaalliso
 * Fixing #define ixf18100_v values for GetSetOpMode()
 * 
 * 13    4/16/02 11:05a Jjchin
 * Added ixf18100_vMODE_SEL_POS (ETHERNET,GFP) back for UI.
 * 
 * 12    4/15/02 5:00p Jaalliso
 * Adding #defines for use by Get/SetOpmode()
 * 
 * 11    2/27/02 3:24p Pkjain2
 * 
 * 10    12/04/01 4:24p Pkjain2
 * 
 * 9     11/26/01 5:27p Jjchin
 * Included 'ixf18100_d.h' in Calypso.
 * 
 * 8     11/20/01 3:17p Srodrig1
 * 
 * 7     11/14/01 3:56p Srodrig1
 * 
 * 6     10/22/01 2:32p Machambe
 * Changes
 * 
 * 5     10/02/01 11:31a Kssaepha
 * 
 * 4     9/28/01 2:48p Kssaepha
 * 
 * 3     9/25/01 11:53a Kssaepha
 * 
 * 2     9/17/01 1:51p Kssaepha
 * Updated some register definitions
 * 
 * 1     9/05/01 2:10p Kssaepha
 * Initial Revision
 * 
 * --------------------------------------------------------------------------
 */ 

#ifndef __ixf18100_GLOBAL_B_H__
#define __ixf18100_GLOBAL_B_H__

#include "ixf18100_d.h"


#define ixf18100_GLB_REG(offset) ((ixf18100_GLOBAL_BASE + offset) << ixf18100_REG_SHIFT)

/************GLB_CFG1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CFG1_OFFSET        ixf18100_GLB_REG(0x0000)  
#define ixf18100_GLB_CFG1_DFLT          0x2

/*  ------- Bit, shift and mask defines.  ------ */

/*The IXF18101 device will drive the SPEED_SET pin to the SERDES device.*/
#define ixf18100_sLINE_SP_SEL           0    

/*Select to enable the SONET Framer into the data path*/
#define ixf18100_sSONET_EN              1    
#define ixf18100_mSONET_EN              (0x01 << ixf18100_sSONET_EN)    

/*Mode Select for the Mapping Function */
#define ixf18100_sMODE_SEL              2    
#define ixf18100_mMODE_SEL              (0x03 << ixf18100_sMODE_SEL)

#define ixf18100_vMODE_SEL_POS          (0x0 << ixf18100_sMODE_SEL)
#define ixf18100_vMODE_SEL_ETHERNET     (0x1 << ixf18100_sMODE_SEL)
#define ixf18100_vMODE_SEL_GFP          (0x2 << ixf18100_sMODE_SEL)

/* The following _v "value" #defines are for the GLB_CFG1 register value */
#define ixf18100_vGLB_CFG1_POS              (0x02)
#define ixf18100_vGLB_CFG1_ETHERNET         (0x05)
#define ixf18100_vGLB_CFG1_WANPHY           (0x06)
#define ixf18100_vGLB_CFG1_GFPSONET         (0x0A)
#define ixf18100_vGLB_CFG1_GFPFIBER         (0x08)

/*********** GLB_CHIPID Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CHIPID_OFFSET      ixf18100_GLB_REG(0x0001) 
#define ixf18100_GLB_CHIPID_DFLT        0x46B5
#define ixf18101_GLB_CHIPID_DFLT        0x46B5  /* 18101 */
#define ixf18102_GLB_CHIPID_DFLT        0x46B6  /* 18102 */
#define ixf18103_GLB_CHIPID_DFLT        0x46B7  /* 18103 */
#define ixf18104_GLB_CHIPID_DFLT        0x46B8  /* 18104 */

/*  ------- Bit, shift and mask defines.  ------ */

/*The IXF18101 identification number in hexadecimal format.*/
#define ixf18100_sCHIP_ID               0
#define ixf18100_mCHIP_ID               (0xFFFF << ixf18100_sCHIP_ID)

/*********** GLB_CHIPVER Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CHIPVER_OFFSET     ixf18100_GLB_REG(0x0002) 
#define ixf18100_GLB_CHIPVER_DFLT       0x0

/*  ------- Bit, shift and mask defines.  ------ */

/*The IXF18101 version number in hexadecimal format.*/
#define ixf18100_sCHIP_VER       0
#define ixf18100_mCHIP_VER       (0xF << ixf18100_sCHIP_VER)

/************ GLB_RST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_RST_OFFSET     ixf18100_GLB_REG(0x0003) 
#define ixf18100_GLB_RST_DFLT       0xF
#define ixf18100_mGLB_RST           0xF
/*  ------- Bit, shift and mask defines.  ------ */

/*Software Reset  */
#define ixf18100_sGLB_SFT_RST           0

/*APS interface reset*/
#define ixf18100_sAPS_INTERFACE_RST     1

/*Line Interface Reset.*/
#define ixf18100_sLINE_INTERFACE_RST    2
#define ixf18100_mLINE_INTERFACE_RST    (0x01 << ixf18100_sLINE_INTERFACE_RST)

/*SPI Reset.*/
#define ixf18100_sSPI_INTERFACE_RST     3

/*Rx Line FIFO Reset*/
#define ixf18100_sRXLN_FIFO_RST         4

/*Tx Line FIFO Reset*/
#define ixf18100_sTXLN_FIFO_RST         5

/*Rx APS FIFO Reset*/
#define ixf18100_sRXAPS_FIFO_RST        6

/*Tx APS FIFO Reset*/
#define ixf18100_sTXAPS_FIFO_RST        7

/*15:8 Unused
 */
/******************************************************************************/
/********  GLB_WATCH Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_WATCH_OFFSET       ixf18100_GLB_REG(0x0004) 
#define ixf18100_GLB_WATCH_DFLT         0x0110

/*  ------- Bit, shift and mask defines.  ------ */

/*Timer value */
#define ixf18100_sWATCHDG_TMR        0
#define ixf18100_mWATCHDG_TMR        (0xFF << ixf18100_sWATCHDG_TMR)

/*Enable internal watchdog timer */
#define ixf18100_sWATCHDG_EN         8

/*15:9 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_FAILADDR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_FAILADDR_OFFSET        ixf18100_GLB_REG(0x0005) 
/*Default value not applicable to this register*/

/*  ------- Bit, shift and mask defines.  ------ */

/*CPU address that was associated with a Watchdog failure.*/
#define ixf18100_sWATCHDG_ADDR       0
#define ixf18100_mWATCHDG_ADDR       (0x3FFF << ixf18100_sWATCHDG_ADDR)

/*15:14 Unused*/
/******************************************************************************/

/******************************************************************************/
/* GLB_CLKCFG1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CLKCFG1_OFFSET     ixf18100_GLB_REG(0x0006) 
#define ixf18100_GLB_CLKCFG1_DFLT       0x030F

/*  ------- Bit, shift and mask defines.  ------ */

/*Mux selection bits for the Transmit WIS transport clock.*/
#define ixf18100_sTX_TRNSPRT_CLK           0
#define ixf18100_mTX_TRNSPRT_CLK           (0x3 << ixf18100_sTX_TRNSPRT_CLK)

#define ixf18100_TRNSPRT_CLK_RXOIF_77      (0x0 << ixf18100_sTX_TRNSPRT_CLK)
#define ixf18100_TRNSPRT_CLK_RXAPSOIF_77   (0x1 << ixf18100_sTX_TRNSPRT_CLK)
#define ixf18100_TRNSPRT_CLK_TXREF_77      (0x2 << ixf18100_sTX_TRNSPRT_CLK)
#define ixf18100_TRNSPRT_CLK_TXOIF_77      (0x3 << ixf18100_sTX_TRNSPRT_CLK)

/*Mux selection bits for the Transmit WIS Path, POS, PCS, and GFP block
 *clocks.*/
#define ixf18100_sTX_PATH_CLK              2
#define ixf18100_mTX_PATH_CLK              (0x3 << ixf18100_sTX_PATH_CLK)

#define ixf18100_TX_PATH_CLK_RXOIF_77      (0x0 << ixf18100_sTX_PATH_CLK)
#define ixf18100_TX_PATH_CLK_RXAPSOIF_77   (0x1 << ixf18100_sTX_PATH_CLK)
#define ixf18100_TX_PATH_CLK_TXREF_77      (0x2 << ixf18100_sTX_PATH_CLK)
#define ixf18100_TX_PATH_CLK_TXOIF_77      (0x3 << ixf18100_sTX_PATH_CLK)

/*Mux selection bits for the Receive WIS Path, POS, PCS, and GFP block
 *clocks.*/
#define ixf18100_sRX_PATH_CLK              4
#define ixf18100_mRX_PATH_CLK              (0x3 << ixf18100_sRX_PATH_CLK)

#define ixf18100_RX_PATH_CLK_RXOIF_77      (0x0 << ixf18100_sRX_PATH_CLK)
#define ixf18100_RX_PATH_CLK_RXAPSOIF_77   (0x1 << ixf18100_sRX_PATH_CLK)
#define ixf18100_RX_PATH_CLK_TXREF_77      (0x2 << ixf18100_sRX_PATH_CLK)
#define ixf18100_RX_PATH_CLK_TXOIF_77      (0x3 << ixf18100_sRX_PATH_CLK)

/*Mux selection bits for the Reference Output clock.*/
#define ixf18100_sREF_OUT_CLK              6
#define ixf18100_mREF_OUT_CLK              (0x3 << ixf18100_sREF_OUT_CLK)

#define ixf18100_REF_OUT_CLK_RXOIF_77      (0x0 << ixf18100_sREF_OUT_CLK)
#define ixf18100_REF_OUT_CLK_RXAPSOIF_77   (0x1 << ixf18100_sREF_OUT_CLK)
#define ixf18100_REF_OUT_CLK_REF_77        (0x2 << ixf18100_sREF_OUT_CLK)
#define ixf18100_REF_OUT_CLK_TXOIF_77      (0x3 << ixf18100_sREF_OUT_CLK)

/*Mux selection bits for Tx WIS FIFO clock.*/
#define ixf18100_sTX_FIFO_CLK              8
#define ixf18100_mTX_FIFO_CLK              (0x3 << ixf18100_sTX_FIFO_CLK)

#define ixf18100_TX_FIFO_CLK_RXOIF_77      (0x0 << ixf18100_sTX_FIFO_CLK)
#define ixf18100_TX_FIFO_CLK_RXAPSOIF_77   (0x1 << ixf18100_sTX_FIFO_CLK)
#define ixf18100_TX_FIFO_CLK_TXREF_77      (0x2 << ixf18100_sTX_FIFO_CLK)
#define ixf18100_TX_FIFO_CLK_TXOIF_77      (0x3 << ixf18100_sTX_FIFO_CLK)

/*Mux selection bits for Tx WIS APS clock.*/
#define ixf18100_sTX_APS_CLK               10
#define ixf18100_mTX_APS_CLK               (0x3 << ixf18100_sTX_APS_CLK )

#define ixf18100_TX_APS_CLK_RXOIF_77      (0x0 << ixf18100_sTX_APS_CLK )
#define ixf18100_TX_APS_CLK_RXAPSOIF_77   (0x1 << ixf18100_sTX_APS_CLK )
#define ixf18100_TX_APS_CLK_TXREF_77      (0x2 << ixf18100_sTX_APS_CLK )
#define ixf18100_TX_APS_CLK_TXOIF_77      (0x3 << ixf18100_sTX_APS_CLK )

/*Mux selection bit for Tx OIF.*/
#define ixf18100_sTX_OIF_CLK               12
#define ixf18100_mTX_OIF_CLK               (0x3 << ixf18100_sTX_OIF_CLK)

#define ixf18100_TX_OIF_CLK_TLCI           (0x0 << ixf18100_sTX_OIF_CLK)
#define ixf18100_TX_OIF_CLK_REF_CLK_IN     (0x1 << ixf18100_sTX_OIF_CLK)
#define ixf18100_TX_OIF_CLK_RLCI           (0x2 << ixf18100_sTX_OIF_CLK)

/*Mux selection bit for Tx AOIF.*/
#define ixf18100_sTX_AOIF_CLK               14
#define ixf18100_mTX_AOIF_CLK              (0x3 << ixf18100_sTX_AOIF_CLK)

#define ixf18100_TX_AOIF_CLK_TLCI          (0x0 << ixf18100_sTX_AOIF_CLK)
#define ixf18100_TX_AOIF_CLK_REF_CLK_IN    (0x1 << ixf18100_sTX_AOIF_CLK)
#define ixf18100_TX_AOIF_CLK_RLCI          (0x2 << ixf18100_sTX_AOIF_CLK)

/******************************************************************************/


/******************************************************************************/
/* GLB_CLKCFG1_SHAD Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CLKCFG1_SHAD_OFFSET        ixf18100_GLB_REG(0x0007) 
#define ixf18100_GLB_CLKCFG1_SHAD_DFLT          0x030F

/*  ------- Bit, shift and mask defines.  ------ */

/*Refer to GLB_CLKCFG1 Register for shifts and mask defines*/

/******************************************************************************/

/******************************************************************************/
/* GLB_CLKCFG2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CLKCFG2_OFFSET     ixf18100_GLB_REG(0x0008) 
#define ixf18100_GLB_CLKCFG2_DFLT       0x0003

/*  ------- Bit, shift and mask defines.  ------ */

/*REF_CLK_IN Divider Select. The output of the divider circuit can be
 *used for REF_CLK_OUT. */
#define ixf18100_sREF_CLK_IN_DIV        0
#define ixf18100_mREF_CLK_IN_DIV        (0x3 << ixf18100_sREF_CLK_IN_DIV)

#define ixf18100_REF_CLK_IN_DIV_1       (0x0 << ixf18100_sREF_CLK_IN_DIV)
#define ixf18100_REF_CLK_IN_DIV_2       (0x1 << ixf18100_sREF_CLK_IN_DIV)
#define ixf18100_REF_CLK_IN_DIV_4       (0x2 << ixf18100_sREF_CLK_IN_DIV)
#define ixf18100_REF_CLK_IN_DIV_8       (0x3 << ixf18100_sREF_CLK_IN_DIV)

/*RLCI/RLAPSCI Divider Select.*/
#define ixf18100_sRX_CLK_DIV            2

/******************************************************************************/

/******************************************************************************/
/* GLB_CLKCFG2_SHAD Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CLKCFG2_SHAD_OFFSET        ixf18100_GLB_REG(0x0009) 
#define ixf18100_GLB_CLKCFG2_SHAD_DFLT          0x0003

/*  ------- Bit, shift and mask defines.  ------ */

/*Refer to GLB_CLKCFG2 Register for shifts and mask defines*/

/******************************************************************************/

/******************************************************************************/
/* GLB_LINE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_LINE_OFFSET    ixf18100_GLB_REG(0x000A) 
#define ixf18100_GLB_LINE_DFLT      0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*This bit controls the flipping of the bit order for the Receive Line data
 *interface.*/
#define ixf18100_sRX_LN_BIT_ORD_FLP        0

/*This bit controls the flipping of the bit order for the Transmit Line data
 *interface.*/
#define ixf18100_sTX_LN_BIT_ORD_FLP        1

/*This bit controls the inversion of the Receive Line input clock.*/
#define ixf18100_sRLCI_INV                 2

/*This bit controls the inversion of the Transmit Line output clock.*/
#define ixf18100_sTLCO_INV                 3

/*This bit controls the inversion of the Transmit Line Reference input clock*/
#define ixf18100_sTLCI_INV                 4

/*This bit controls the frame pulse inversion of the Transmit Line Interface*/
#define ixf18100_sTLFPO_INV                6

/*This bit controls the inversion of the System Reference input clock*/
#define ixf18100_sREF_CLK_IN_INV           7

/*Local Loopback Selection*/
#define ixf18100_sLLOOP_EN                 10
#define ixf18100_mLLOOP_EN                 (0x01 << ixf18100_sLLOOP_EN)

/*Remote Loopback Selection*/
#define ixf18100_sRLOOP_EN                 11

/*TLDO output data pattern*/
#define ixf18100_sLLOOP_PATTERN            12
#define ixf18100_mLLOOP_PATTERN            (0x01 << ixf18100_sLLOOP_PATTERN)

/*15:13 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_TXLNDATINV Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_TXLNDATINV_OFFSET      ixf18100_GLB_REG(0x000B) 
#define ixf18100_GLB_TXLNDATINV_DFLT        0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*TxLn_DataInv[i] controls the data inversion of Transmit Line data[i]*/
#define ixf18100_sTX_LN_DATA_INV        0
#define ixf18100_mTX_LN_DATA_INV        (0xFFFF << ixf18100_sTX_LN_DATA_INV)

/******************************************************************************/

/******************************************************************************/
/* GLB_RXLNDATINV Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_RXLNDATINV_OFFSET      ixf18100_GLB_REG(0x000C) 
#define ixf18100_GLB_RXLNDATINV_DFLT        0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*RxLn_DataInv[i] controls the data inversion of Receive Line data[i]*/
#define ixf18100_sRX_LN_DATA_INV        0
#define ixf18100_mRX_LN_DATA_INV        (0xFFFF << ixf18100_sRX_LN_DATA_INV)

/******************************************************************************/

/******************************************************************************/
/* GLB_APS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_APS_OFFSET     ixf18100_GLB_REG(0x000D) 
#define ixf18100_GLB_APS_DFLT       0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*This bit controls the flipping of the bit order for the Receive APS Side Port
 *interface*/
#define ixf18100_sRX_ABIT_ORD_FLP     0

/*This bit controls the flipping of the bit order for the Transmit APS Side
 *Port interface*/
#define ixf18100_sTX_ABIT_ORD_FLP     1

/*This bit controls the clock inversion of the Receive APS Side Port
 *Interface*/
#define ixf18100_sRLAPSCI_INV         2

/*This bit controls the clock inversion of the Transmit APS Side Port
 *Interface*/
#define ixf18100_sTLAPSCO_INV         3

/*Local Loopback Selection for the APS Interface*/
#define ixf18100_sLLOOP_APS_EN        4

/*Remote Loopback Selection for the APS Interface*/
#define ixf18100_sRLOOP_APS_EN        5

/******************************************************************************/

/******************************************************************************/
/* GLB_TXAPSDATINV Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_TXAPSDATINV_OFFSET     ixf18100_GLB_REG(0x000E) 
#define ixf18100_GLB_TXAPSDATINV_DFLT       0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*TxA_DataInv[i] controls the data inversion of Transmit APS Side Port
 *data[i]*/
#define ixf18100_sTX_ADATA_INV       0
#define ixf18100_mTX_ADATA_INV      (0xFFFF << ixf18100_sTX_ADATA_INV)

/******************************************************************************/

/******************************************************************************/
/* GLB_RXAPSDATINV Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_RXAPSDATINV_OFFSET     ixf18100_GLB_REG(0x000F) 
#define ixf18100_GLB_RXAPSDATINV_DFLT       0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*RxA_DataInv[i] controls the data inversion of Receive APS Side Port
 *data[i]*/
#define ixf18100_sRX_ADATA_INV       0
#define ixf18100_mRX_ADATA_INV      (0xFFFF << ixf18100_sRX_ADATA_INV)

/******************************************************************************/

/******************************************************************************/
/* GLB_SPI4 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_SPI4_OFFSET        ixf18100_GLB_REG(0x0010) 
#define ixf18100_GLB_SPI4_DFLT          0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*SPI-4 Receive Clock Select*/
#define ixf18100_sSPI4_RX_CLK_SEL          0

/*SPI-4 FIFO Status Interface Select. This bit selects which FIFO Status
 *pads can be selected for both the receive and transmit directions.*/
#define ixf18100_sSPI4_FIFO_STAT_SEL       1

/******************************************************************************/

/******************************************************************************/
/* GLB_STAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_STAT_OFFSET        ixf18100_GLB_REG(0x0011) 
#define ixf18100_GLB_STAT_DFLT          0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*0 Sig_Det
 *Signal Detect. Based upon the SIG_DET pin.*/
#define ixf18100_sSIG_DET          0

/*The PLL in the De-serializer (De-mux) chip cannot lock to the receive
 *data. Based upon the RLXLOS pin.*/
#define ixf18100_sRLXLOS           1

/*Status describing what line rate IXF18101 is configured to use based
 *upon the SPEED_SEL pin. This is the result of the Auto Speed
 *Select feature.*/
#define ixf18100_sLINE_RATE        2

/*Configuration Error. This bit will be asserted if the IXF18101 device is
 *setup in an illegal mode. This bit will be cleared only after legally
 *configuring the IXF18101 device. When this bit is asserted, the interrupt
 *signal for this block will also be asserted.*/
#define ixf18100_sCONFIG_ER        3

/*15:4 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_INTSTAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_INTSTAT_OFFSET     ixf18100_GLB_REG(0x0012) 
#define ixf18100_GLB_INTSTAT_DFLT       0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*The IXF18101 Device has been put into an invalid mode.*/
#define ixf18100_sCONFIG_ER_INT          0

/*A Line interface speed change has occurred from 10.3G to 9.9G or vise
 *versa.*/
#define ixf18100_sSPD_CHNG_INT           1

/*15:2 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_INTEN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_INTEN_OFFSET       ixf18100_GLB_REG(0x0013) 
#define ixf18100_GLB_INTEN_DFLT         0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*Configuration Error Interrupt Enable*/
#define ixf18100_sCONFIG_ER_INT_EN          0

/*Speed Change Interrupt Enable*/
#define ixf18100_sSPD_CHNG_INT_EN           1

/*15:2 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_CLKINTSTAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CLKINTSTAT_OFFSET      ixf18100_GLB_REG(0x0014) 
#define ixf18100_GLB_CLKINTSTAT_DFLT        0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*Receive Line Clock has failed
 */
#define ixf18100_sCLK_RX_FAIL_INT               0
#define ixf18100_mCLK_RX_FAIL_INT               (0x1 << ixf18100_sCLK_RX_FAIL_INT)

/*Receive APS Clock has failed
 */
#define ixf18100_sCLK_RX_APS_FAIL_INT           1

/*Transmit Line Clock has failed
 */
#define ixf18100_sCLK_TX_FAIL_INT               2

/*Transmit APS Clock has failed
 */
#define ixf18100_sCLK_TX_APS_FAIL_INT           3

/*Reference Clock has failed
 */
#define ixf18100_sCLK_REF_FAIL_INT              4

/*Ethernet Clock has failed
 */
#define ixf18100_sCLK_ENET_FAIL_INT             5

/*Reference SPI-4 Clock has failed
 */
#define ixf18100_sCLK_REF_SPI_FAIL_INT          6

/*Transmit SPI-4 Clock has failed
 */
#define ixf18100_sCLK_TX_SPI_FAIL_INT           7

/*Transmit SPI-4 FIFO Status Clock has failed
 */
#define ixf18100_sCLK_TX_FIFO_STAT_FAIL_INT     8

/*15:9 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_CLKINTEN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_GLB_CLKINTEN_OFFSET        ixf18100_GLB_REG(0x0015) 
#define ixf18100_GLB_GLB_CLKINTEN_DFLT          0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*Receive Line Clock Interrupt Enable*/
#define ixf18100_sCLK_RX_FAIL_INT_EN               0

/*Receive APS Clock Interrupt Enable*/
#define ixf18100_sCLK_RX_APS_FAIL_INT_EN           1

/*Transmit Line Clock Interrupt Enable*/
#define ixf18100_sCLK_TX_FAIL_INT_EN               2

/*Transmit APS Clock Interrupt Enable*/
#define ixf18100_sCLK_TX_APS_FAIL_INT_EN           3

/*Reference Clock Interrupt Enable*/
#define ixf18100_sCLK_REF_FAIL_INT_EN              4

/*Ethernet Clock Interrupt Enable*/
#define ixf18100_sCLK_ENET_FAIL_INT_EN             5

/*Reference SPI-4 Clock Interrupt Enable*/
#define ixf18100_sCLK_REF_SPI_FAIL_INT_EN          6

/*Transmit SPI-4 Clock Interrupt Enable*/
#define ixf18100_sCLK_TX_SPI_FAIL_INT_EN           7

/*Transmit SPI-4 FIFO Status Clock Interrupt Enable*/
#define ixf18100_sCLK_TX_FIFO_STAT_FAIL_INT_EN     8

/*15:9 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_CHP_INTSTAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CHP_INTSTAT_OFFSET     ixf18100_GLB_REG(0x0016) 
#define ixf18100_GLB_CHP_INTSTAT_DFLT       0x0000

/*  ------- Bit, shift and mask defines.  ------ */

/*POS Interrupt Status*/
#define ixf18100_sPOS_INT_STAT           0

/*System Interface Interrupt Status*/
#define ixf18100_sSIF_INT_STAT           1

/*MAC Interrupt Status*/
#define ixf18100_sMAC_INT_STAT           2

/*PCS Interrupt Status*/
#define ixf18100_sPCS_INT_STAT           4

/*GFP Interrupt Status*/
#define ixf18100_sGFP_INT_STAT           5

/*WIS Interrupt Status*/
#define ixf18100_sWIS_INT_STAT           6

/*WIS APS Alarm Interrupt Status*/
#define ixf18100_sWISAPS_INT_STAT        7

/*Global Register Interrupt Status 1*/
#define ixf18100_sGLBL_INT_STAT          8

/*Watchdog Interrupt Status 2*/
#define ixf18100_sWATCH_INT_STAT         9

/*Clock Interrupt Status 3*/
#define ixf18100_sCLOCK_INT_STAT         10

/*15:11 Unused
 *3 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_CHP_INTEN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_CHP_INTEN_OFFSET       ixf18100_GLB_REG(0x0017) 


#define ixf18100_GLB_CHP_INTEN_DFLT     0x0

/*  ------- Bit, shift and mask defines.  ------ */

/*Global POS Interrupt Enable*/
#define ixf18100_sPOS_INT_EN           0

/*Global System Interface Interrupt Enable*/
#define ixf18100_sSIF_INT_EN           1

/*Global MAC Interrupt Enable*/
#define ixf18100_sMAC_INT_EN           2

/*Global PCS Interrupt Enable*/
#define ixf18100_sPCS_INT_EN           4

/*Global GFP Interrupt Enable*/
#define ixf18100_sGFP_INT_EN           5

/*Global WIS Interrupt Enable*/
#define ixf18100_sWIS_INT_EN           6

/*Global WIS APS Alarm Interrupt Enable*/
#define ixf18100_sWISAPS_INT_EN        7

/*Global Register Interrupt Enable*/
#define ixf18100_sGLBL_INT_EN          8

/*Global Watchdog Interrupt Enable*/
#define ixf18100_sWATCH_INT_EN         9

/*Global Clock Interrupt Enable*/
#define ixf18100_sCLOCK_INT_EN         10

/*15:11 Unused
 *3 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_TST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_TST_OFFSET     ixf18100_GLB_REG(0x0020) 


#define ixf18100_GLB_TST_DFLT       0x0

/*  ------- Bit, shift and mask defines.  ------ */

/*PLL Bypass. This bit will select a mux to bypass the PLL and send in the
 *Ethernet clock signal from the pad.1*/
#define ixf18100_sPLL_BYPASS           0

/*Memory BIST Enable. This bit will enable the memory BIST feature to
 *test the memories. Software must disable the bit to disable the test
 *mode.*/
#define ixf18100_sMEM_BIST_EN           1

/*15:2 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* GLB_TST_STAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_GLB_TST_STAT_OFFSET        ixf18100_GLB_REG(0x0021) 


#define ixf18100_GLB_TST_STAT_DFLT      0x0

/*  ------- Bit, shift and mask defines.  ------ */

/*0 PCS_TXRAM1_Flt
 *PCS Transmit RAM1 BIST Fault. This bit is asserted when there is a*/
#define ixf18100_sPCS_TXRAM1_FLT         0

/*PCS Transmit RAM2 BIST Fault. This bit is asserted when there is a
 *RAM failure.*/
#define ixf18100_sPCS_TXRAM2_FLT         1

/*PCS Transmit RAM3 BIST Fault. This bit is asserted when there is a
 *RAM failure.*/
#define ixf18100_sPCS_TXRAM3_FLT         2

/*PCS Transmit RAM4 BIST Fault. This bit is asserted when there is a
 *RAM failure.*/
#define ixf18100_sPCS_TXRAM4_FLT         3

/*PCS Receive RAM1 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sPCS_RXRAM1_FLT         4

/*PCS Receive RAM2 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sPCS_RXRAM2_FLT         5

/*SIF Transmit RAM1 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_TXRAM1_FLT         6

/*SIF Transmit RAM2 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_TXRAM2_FLT         7

/*SIF Transmit RAM3 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_TXRAM3_FLT         8

/*SIF Transmit RAM4 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_TXRAM4_FLT         9

/*SIF Receive RAM1 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_RXRAM1_FLT         10

/*SIF Receive RAM2 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_RXRAM2_FLT         11

/*SIF Receive RAM3 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_RXRAM3_FLT         12

/*SIF Receive RAM4 BIST Fault. This bit is asserted when there is a RAM
 *failure.*/
#define ixf18100_sSIF_RXRAM4_FLT         13

/*15:14 Unused
 */
/******************************************************************************/

#endif /* ifndef __ixf18100_GLOBAL_B_H__ */
