/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pcs_b.h $
 *   WORKFILE:       $Workfile: ixf18100_pcs_b.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 family device API
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pcs_b.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 17    6/17/02 4:52p Jaalliso
 * Adding mask value
 * 
 * 16    3/07/02 11:23a Pkjain2
 * 
 * 15    1/23/02 5:31p Kssaepha
 * Updated default values
 * 
 * 14    12/11/01 4:15p Jjchin
 * Added 'PCS_PACK_ID1, PCS_PACK_ID2' registers.
 * 
 * 13    11/20/01 4:56p Jjchin
 * Updated PCS GUI
 * 
 * 12    11/20/01 11:34a Srodrig1
 * 
 * 11    10/23/01 3:46p Kssaepha
 * Modified block offsets
 * 
 * 10    9/04/01 5:43p Pkjain2
 * Added PCS Status GUI and corrected some errors in the PCS bit file.
 * 
 * 9     9/04/01 9:59a Pkjain2
 * 
 * 8     8/30/01 11:10a Pkjain2
 * Added PCS Configuration Code.
 * Also changed corrected errors in PCS bit definition file
 * In Edit Box controls, added shift instead of NO_SHIFT. This would make
 * the code more flexible to bit position changes in the register spec.
 * 
 * 7     8/24/01 11:03a Wrbrackn
 * 
 * 6     8/23/01 4:12p Wrbrackn
 * Made changes suggested after review of the code with Mark.
 * 
 *
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF18100_PCS_B_H__
#define __IXF18100_PCS_B_H__

#ifndef ixf18100_REG_SHIFT
#define ixf18100_REG_SHIFT  0x0
#endif

/* Block Offset for PCS */
#ifndef ixf18100_PCS_BASE
#define ixf18100_PCS_BASE   0x3200
#endif

#define ixf18100_PCS_REG(offset) ((ixf18100_PCS_BASE + offset) << ixf18100_REG_SHIFT)
/******************************************************************************/
/* PCS_CNTL1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_CNTL1_OFFSET		ixf18100_PCS_REG(0x00)
#define ixf18100_PCS_CNTL1_DFLT		    0x2040

/* -------- Bit, shift and mask defines.-------- */

/*Speed Selection*/
#define ixf18100_sSPEED_SELECTION1      2
#define ixf18100_mSPEED_SELECTION1	    (0xF << ixf18100_sSPEED_SELECTION1)
/* Values */
#define ixf18100_PCS_10GBPS             (0x0000 << ixf18100_sSPEED_SELECTION1)

/*Speed Selection*/
#define ixf18100_sSPEED_SELECTION2      6

/*pcs_powerdown R/W 0 Power Down*/
#define ixf18100_sPCS_POWERDOWN         11

/*Speed Selection*/
#define ixf18100_sSPEED_SELECTION3      13

/*Pcs Loopback*/
#define ixf18100_sPCS_LOOPBACK          14

/*Pcs Register Reset*/
#define ixf18100_sPCS_RESET             15
/******************************************************************************/

/******************************************************************************/
/* PCS_STAT1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_STAT1_OFFSET		ixf18100_PCS_REG(0x01)
#define ixf18100_PCS_STAT1_DFLT		    0x0002

/* -------- Bit, shift and mask defines.-------- */

/*Pcs powerdown ability*/
#define ixf18100_sPCS_POWERDOWN_ABILITY 1

/*PCS receive link status*/
#define ixf18100_sPCS_REC_LINK_STAT     2
#define ixf18100_mPCS_REC_LINK_STAT     (0x1 << ixf18100_sPCS_REC_LINK_STAT)

/*Local Fault*/
#define ixf18100_sPCS_LOCAL_FAULT       7
/******************************************************************************/

/******************************************************************************/
/* PCS_ID1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_ID1_OFFSET		ixf18100_PCS_REG(0x02)
#define ixf18100_PCS_ID1_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*pcs_id1 *PCS Identifier 1 value*/
#define ixf18100_sPCS_ID1           0
#define ixf18100_mPCS_ID1			(0xFFFF << ixf18100_sPCS_ID1)
/******************************************************************************/

/******************************************************************************/
/* PCS_ID2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_ID2_OFFSET		ixf18100_PCS_REG(0x03)
#define ixf18100_PCS_ID2_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_sPCS_ID2           0
#define ixf18100_mPCS_ID2			(0xFFFF << ixf18100_sPCS_ID2)
/******************************************************************************/

/******************************************************************************/
/* PCS_SPEED_ABIL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SPEED_ABIL_OFFSET		ixf18100_PCS_REG(0x04)
#define ixf18100_PCS_SPEED_ABIL_DFLT		0x0001

/* -------- Bit, shift and mask defines.-------- */

#define ixf18100_s10G_CAPABLE               0

/*15:1 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_DEVICES1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_DEVICES1_OFFSET		ixf18100_PCS_REG(0x05)
#define ixf18100_PCS_DEVICES1_DFLT		    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*pcs_vendor_spec * Vendor Specific Device*/
#define ixf18100_sPCS_VENDOR_SPEC           15

/*14:0 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_DEVICES2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_DEVICES2_OFFSET		ixf18100_PCS_REG(0x06)
#ifdef IXF18104_CHIP_TYPE
#define ixf18100_PCS_DEVICES2_DFLT		    0x0008
#else
#define ixf18100_PCS_DEVICES2_DFLT		    0x000C
#endif

/* -------- Bit, shift and mask defines.-------- */

/*clause22_present * Clause 22 registers present*/
#define ixf18100_sCLAUSE22_PRESENT          0

/*pmd_pma_present * PMD/PMA present*/
#define ixf18100_sPMD_PMA_PRESENT           1

/*wis_present * WIS present*/
#define ixf18100_sWIS_PRESENT               2

/*pcs_present * PCS present*/
#define ixf18100_sPCS_PRESENT               3

/*phy_present * PHY XS present*/
#define ixf18100_sPHY_PRESENT               4

/*dte_present * DTE XS present*/
#define ixf18100_sDTE_PRESENT               5

/*15:6 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_10GCNTL2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_10GCNTL2_OFFSET		ixf18100_PCS_REG(0x07)
#define ixf18100_PCS_10GCNTL2_DFLT1		    0x0000
#define ixf18100_PCS_10GCNTL2_DFLT2		    0x0002

/* -------- Bit, shift and mask defines.-------- */

/*Port type selection*/
#define ixf18100_sPCS_PORT_TYPE_SEL         0
#define ixf18100_mPCS_PORT_TYPE_SEL			(0x3 << ixf18100_sPCS_PORT_TYPE_SEL)

#define ixf18100_PCS_PORT_10GBASE_R         (0x0 << ixf18100_sPCS_PORT_TYPE_SEL)		
#define ixf18100_PCS_PORT_10GBASE_X         (0x1 << ixf18100_sPCS_PORT_TYPE_SEL)		
#define ixf18100_PCS_PORT_10GBASE_W         (0x2 << ixf18100_sPCS_PORT_TYPE_SEL)		

/*Jitter Test Mode*/
#define ixf18100_sPCS_JITTER_TEST_MODE      2
/******************************************************************************/

/******************************************************************************/
/* PCS_10GSTAT2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_10GSTAT2_OFFSET		ixf18100_PCS_REG(0x08)
#ifdef IXF18104_CHIP_TYPE
#define ixf18100_PCS_10GSTAT2_DFLT		    0x8001
#else
#define ixf18100_PCS_10GSTAT2_DFLT		    0x8005
#endif

/* -------- Bit, shift and mask defines.-------- */

/*10GBASE-R capable * Hardwired signal indicating what 10GBASE-R operation the PCS is
 *capable of supporting.*/
#define ixf18100_s10GBASE_R_CAPABLE         0

/*10GBASE-X capable * Hardwired signal indicating what 10GBASE-X operation the PCS is
 *capable of supporting.*/
#define ixf18100_s10GBASE_X_CAPABLE         1

/*10GBASE-W capable * Hardwired signal indicating waht 10GBASE-W operation the PCS is
 *capable of supporting.*/
#define ixf18100_s10GBASE_W_CAPABLE         2

/*Receive local fault*/
#define ixf18100_sRECEIVE_LOCAL_FAULT       10

/*Transmit local fault*/
#define ixf18100_sTRANSMIT_LOCAL_FAULT      11

/*Device present * These bits will be hardwired as 10 to always indicate that this device is
 *present.*/
#define ixf18100_sDEVICE_PRESENT            14
#define ixf18100_mDEVICE_PRESENT			(0x3 << ixf18100_sDEVICE_PRESENT)

#define ixf18100_DEVICE_PRESENT             (0x10 << ixf18100_sDEVICE_PRESENT)		

/*13:12 Reserved
 *9:3 Reserved
*/
/******************************************************************************/

/******************************************************************************/
/* PCS_PACK_ID1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_PACK_ID1_OFFSET    ixf18100_PCS_REG(0x0E)
#define ixf18100_PCS_PACK_ID1_DFLT      0x0000

/* -------- Bit, shift and mask defines.-------- */

/*package_id1 * PCS package identifier 1 value, always reads all zeros.*/
#define ixf18100_sPCS_PACK_ID1          0
#define ixf18100_mPCS_PACK_ID1			(0xFFFF << ixf18100_sPCS_PACK_ID1)
/******************************************************************************/

/******************************************************************************/
/* PCS_PACK_ID2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_PACK_ID2_OFFSET	ixf18100_PCS_REG(0x0F)
#define ixf18100_PCS_PACK_ID2_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*package_id2 * PCS package identifier 2 value, always reads all zeros.*/
#define ixf18100_sPCS_PACK_ID2           0   
#define ixf18100_mPCS_PACK_ID2			(0xFFFF << ixf18100_sPCS_PACK_ID2)
/******************************************************************************/

/******************************************************************************/
/* PCS_10GXSTAT1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_10GXSTAT1_OFFSET		ixf18100_PCS_REG(0x18)
#define ixf18100_PCS_10GXSTAT1_DFLT		    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*10GBASE-X status * Since Calypso PCS does not support, always reads all zeros.*/
#define ixf18100_s10GBASE_X_STATUS          0               
#define ixf18100_m10GBASE_X_STATUS			(0xFFFF << ixf18100_s10GBASE_X_STATUS)
/******************************************************************************/

/******************************************************************************/
/* PCS_10GXTESTC Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_10GXTESTC_OFFSET		ixf18100_PCS_REG(0x19)
#define ixf18100_PCS_10GXTESTC_DFLT		    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*PCS_10GXTESTC * PCS 10GBASE-X PCS Test Control Register*/
#define ixf18100_sPCS_10GXTESTC             0               
#define ixf18100_mPCS_10GXTESTC			    (0xFFFF << ixf18100_sPCS_10GXTESTC)
/******************************************************************************/

/******************************************************************************/
/* PCS_10GBRSTAT1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_10GBRSTAT1_OFFSET		ixf18100_PCS_REG(0x20)
#define ixf18100_PCS_10GBRSTAT1_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*10GBASE-R PCS block lock*/
#define ixf18100_s10GBASE_R_PCS_LOCK       0

/*1 10GBASE-R PCS high BER*/
#define ixf18100_s10GBASE_R_PCS_HIGH_BER   1

/*10GBASE-R receive link status*/
#define ixf18100_s10GBASE_R_RCV_LINK_STAT  12

/* 11:2 Reserved
 * 15:13 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_10GBRSTAT2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_10GBRSTAT2_OFFSET		ixf18100_PCS_REG(0x21)
#define ixf18100_PCS_10GBRSTAT2_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*Errorred blocks counter * 8-bit Errored blocks counter.
 *Counts each time the RX_E state is entered.*/
#define ixf18100_sSTAT2_ERR_BLK_CNTR            0
#define ixf18100_mSTAT2_ERR_BLK_CNTR			(0xFF << ixf18100_sSTAT2_ERR_BLK_CNTR)

/*BER counter * 6-bit BER counter.
 *Counts number of times BER_BAD_SH state has been entered (since
 *last read by CPUIF).*/
#define ixf18100_sSTAT2_BER_CNTR                8
#define ixf18100_mSTAT2_BER_CNTR			    (0x3F << ixf18100_sSTAT2_BER_CNTR)

/*Latched high BER */
#define ixf18100_sSTAT2_LATCHED_HIGH_BER        14

/*Latched block lock*/
#define ixf18100_sSTAT2_LATCHED_BLK_LOCK        15
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDA0 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDA0_OFFSET		ixf18100_PCS_REG(0x22)
#define ixf18100_PCS_SEEDA0_DFLT		0x804F

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_a0 * Jitter Test Seed A (Part 0), bits 0:15 */
#define ixf18100_sPCS_SEED_A0           0
#define ixf18100_mPCS_SEED_A0			(0xFFFF << ixf18100_sPCS_SEED_A0)

/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDA1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDA1_OFFSET		ixf18100_PCS_REG(0x23)
#define ixf18100_PCS_SEEDA1_DFLT		0xCAB6

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_a1 *Jitter Test Seed A (Part 1), bits 16:31*/
#define ixf18100_sPCS_SEED_A1           0
#define ixf18100_mPCS_SEED_A1			(0xFFFF << ixf18100_sPCS_SEED_A1)
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDA2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDA2_OFFSET		ixf18100_PCS_REG(0x24)
#define ixf18100_PCS_SEEDA2_DFLT		0xB44D

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_a2 * Jitter Test Seed A (Part 2), bits 32:47*/
#define ixf18100_sPCS_SEED_A2           0
#define ixf18100_mPCS_SEED_A2			(0xFFFF << ixf18100_sPCS_SEED_A2)
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDA3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDA3_OFFSET		ixf18100_PCS_REG(0x25)
#define ixf18100_PCS_SEEDA3_DFLT		0x03C8

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_a3 * Jitter Test Seed A (Part 3), bits 48:57*/
#define ixf18100_sPCS_SEED_A3           0
#define ixf18100_mPCS_SEED_A3			(0x03FF << ixf18100_sPCS_SEED_A3)
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDB0 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDB0_OFFSET		ixf18100_PCS_REG(0x26)
#define ixf18100_PCS_SEEDB0_DFLT		0x9C73

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_b0 * Jitter Test Seed B (Part 0), bits 0:15*/
#define ixf18100_sPCS_SEED_B0           0
#define ixf18100_mPCS_SEED_B0			(0xFFFF << ixf18100_sPCS_SEED_B0)
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDB1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDB1_OFFSET		ixf18100_PCS_REG(0x27)
#define ixf18100_PCS_SEEDB1_DFLT		0xCF3B

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_b1 * Jitter Test Seed B (Part 1), bits 16:31*/
#define ixf18100_sPCS_SEED_B1           0
#define ixf18100_mPCS_SEED_B1			(0xFFFF << ixf18100_sPCS_SEED_B1)
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDB2_OFFSET		ixf18100_PCS_REG(0x28)
#define ixf18100_PCS_SEEDB2_DFLT		0x9CCC

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_b2 * Jitter Test Seed B (Part 2), bits 32:47*/
#define ixf18100_sPCS_SEED_B2           0
#define ixf18100_mPCS_SEED_B2			(0xFFFF << ixf18100_sPCS_SEED_B2)
/******************************************************************************/

/******************************************************************************/
/* PCS_SEEDB3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_SEEDB3_OFFSET		ixf18100_PCS_REG(0x29)
#define ixf18100_PCS_SEEDB3_DFLT		0x0312

/* -------- Bit, shift and mask defines.-------- */

/*pcs_seed_b3 * Jitter Test Seed B (Part 3), bits 48:57*/
#define ixf18100_sPCS_SEED_B3           0
#define ixf18100_mPCS_SEED_B3			(0x03FF << ixf18100_sPCS_SEED_B3)
/******************************************************************************/

/******************************************************************************/
/* PCS_JITCTL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_JITCTL_OFFSET		ixf18100_PCS_REG(0x2A)
#define ixf18100_PCS_JITCTL_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*jitter_data_pattern * Jitter Date pattern select*/
#define ixf18100_sJITTER_DATA_PATTERN   0

/*jitter_test_pattern * Jitter test pattern select*/
#define ixf18100_sJITTER_TEST_PATTERN   1

/*rx_jitter_enable * Receive Jitter test pattern enable*/
#define ixf18100_sRX_JITTER_ENABLE      2

/*tx_jitter_enable * Transmit Jitter test pattern enable*/
#define ixf18100_sTX_JITTER_ENABLE      3

/*15:4 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_JIT_COUNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_JIT_COUNT_OFFSET		ixf18100_PCS_REG(0x2B)
#define ixf18100_PCS_JIT_COUNT_DFLT		    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*jitter_error_cnt * Jitter test error counter*/
#define ixf18100_sJITTER_ERROR_CNT          0
#define ixf18100_mJITTER_ERROR_CNT			(0xFFFF << ixf18100_sJITTER_ERROR_CNT)
/******************************************************************************/

/******************************************************************************/
/* PCS_INTR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_INTR_OFFSET		ixf18100_PCS_REG(0x30)
#define ixf18100_PCS_INTR_DFLT		    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*pcs_tx_fifo_over * Tx FIFO overflow*/
#define ixf18100_sPCS_TX_FIFO_OVER      0

/*pcs_tx_fifo_under * Tx FIFO underflow*/
#define ixf18100_sPCS_TX_FIFO_UNDER     1

/*pcs_rx_fifo_over * Rx FIFO overflow*/
#define ixf18100_sPCS_RX_FIFO_OVER      2

/*15:4 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_CALY1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_CALY1_OFFSET		ixf18100_PCS_REG(0x31)
#define ixf18100_PCS_CALY1_DFLT		    0x000D

/* -------- Bit, shift and mask defines.-------- */

/*pcs_init_done * init done*/
#define ixf18100_sPCS_INIT_DONE         0

/*pcs_scrambler_bypass*/
#define ixf18100_sPCS_SCRAMBLER_BYPASS  1

/*pcs_tx_latency * Number of clock cycles of latency between when wis_tx_datreq 
 *is asserted and when pcs_tx_data is valid*/
#define ixf18100_sPCS_TX_LATENCY        2
#define ixf18100_mPCS_TX_LATENCY        (0x7 << ixf18100_sPCS_TX_LATENCY)

/*Load fitter error counter with MAX-1 value.*/
#define ixf18100_sPCS_JIT_CNT_MAX_ID    5

/*15:5 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_CALY2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_CALY2_OFFSET		ixf18100_PCS_REG(0x32)
#define ixf18100_PCS_CALY2_DFLT		    0x0000

/* -------- Bit, shift and mask defines.-------- */

/*pcs_io_sig_det * LAN mode signal detect * Indicates the state of the oif_rx_sig_det port*/
#define ixf18100_sPCS_IO_SIG_DET        0

/*pcs_wis_sig_det * WAN mode signal detect Indicates the state of the wis_rx_sig_det port*/
#define ixf18100_sPCS_WIS_SIG_DET       1
              
/*15:2 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* PCS_CALY3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_CALY3_OFFSET		ixf18100_PCS_REG(0x33)
#define ixf18100_PCS_CALY3_DFLT		    0x0120

/* -------- Bit, shift and mask defines.-------- */

/*pcs_rx_fifo_load * Rx FIFO pointer load*/
#define ixf18100_sPCS_RX_FIFO_LOAD      0

/*pcs_rx_ptr_gap * Rx FIFO gap between read and write pointers*/
#define ixf18100_sPCS_RX_PTR_GAP        1
#define ixf18100_mPCS_RX_PTR_GAP	    (0x1F << ixf18100_sPCS_RX_PTR_GAP)

/*pcs_rx_threshold * Rx FIFO threshold*/
#define ixf18100_sPCS_RX_THRESHOLD      6
#define ixf18100_mPCS_RX_THRESHOLD	    (0x7 << ixf18100_sPCS_RX_THRESHOLD)
/******************************************************************************/

/******************************************************************************/
/* PCS_CALY4 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_CALY4_OFFSET		ixf18100_PCS_REG(0x34)
#define ixf18100_PCS_CALY4_DFLT		    0x1014

/* -------- Bit, shift and mask defines.-------- */

/*pcs_tx_fifo_load * Tx FIFO pointer load*/
#define ixf18100_sPCS_TX_FIFO_LOAD      0

/*pcs_tx_ptr_gap * Tx FIFO gap between read and write pointers*/
#define ixf18100_sPCS_TX_PTR_GAP        1
#define ixf18100_mPCS_TX_PTR_GAP	    (0x1FF << ixf18100_sPCS_TX_PTR_GAP)

/*pcs_tx_threshold * Tx FIFO threshold*/
#define ixf18100_sPCS_TX_THRESHOLD      10
#define ixf18100_mPCS_TX_THRESHOLD		(0x1F << ixf18100_sPCS_TX_THRESHOLD)

/*pcs_tx_lan_ipg_val * Control for idle byte deletion algorithm*/
#define ixf18100_s_PCS_TX_LAN_IPG_VAL   15
/******************************************************************************/

/******************************************************************************/
/* PCS_INTEREN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PCS_INTEREN_OFFSET		ixf18100_PCS_REG(0x36)
#define ixf18100_PCS_INTEREN_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*pcs_tx_fifo_over * Tx FIFO overflow interrupt enable (0=disable, 1=enable)*/
#define ixf18100_sPCS_TX_FIFO_OVER_EN      0

/*pcs_tx_fifo_under * Tx FIFO underflow interrupt enable (0=disable, 1=enable)*/
#define ixf18100_sPCS_TX_FIFO_UNDER_EN     1

/*pcs_rx_fifo_over * Rx FIFO overflow interrupt enable (0=disable, 1=enable)*/
#define ixf18100_sPCS_RX_FIFO_OVER_EN      2
/******************************************************************************/

#endif /*__IXF18100_PCS_B_H__*/
