/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pcs_d.h $
 *   WORKFILE:       $Workfile: ixf18100_pcs_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 family device API
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pcs_d.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 4     7/08/02 1:16p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * 3     2/27/02 3:15p Srodrig1
 * 
 * 2     11/29/01 4:46p Srodrig1
 * 
 * 1     8/23/01 4:13p Wrbrackn
 * Seperated data structures out from main header file.
 * 
 *
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF18100_PCS_D_H__
#define __IXF18100_PCS_D_H__


typedef struct{

/*PCS_CNTL1 REGISTER*/
    uchar     ucResetPcsRegisters;
    uchar     ucLoopbackModeEn;
    uchar     ucSpeedSelection1;
    uchar     ucSpeedSelection2;
    uchar     ucPcsPowerdownEn;
    uchar     ucSpeedSelection3;

/*PCS_10GCNTL2 REGISTER*/
    uchar     ucJitterTestPattModeEn;
    uchar     ucPortTypeSel;
       
/*PCS_SEED REGISTERS*/
    ushort    uiJittTestSeedA0;
    ushort    uiJittTestSeedA1;
    ushort    uiJittTestSeedA2;
    ushort    uiJittTestSeedA3;
    ushort    uiJittTestSeedB0;
    ushort    uiJittTestSeedB1;
    ushort    uiJittTestSeedB2;
    ushort    uiJittTestSeedB3;

/*PCS_JITCTL REGISTER*/
    uchar     ucTxJittTestPattEn;
    uchar     ucRxJittTestPattEn;
    uchar     ucJittTestPattSel_SW1_PR0;
    uchar     ucJittDataPattSel_Z1_LF0;

/*PCS_CALY1 REGISTER*/
    uchar     ucPcsJitCntMaxID;
    uchar     ucPcsTxLatency;
    uchar     ucPcsInitDoneSignal;

/*PCS_CALY3 REGISTER*/
    uchar     ucPcsRxThreshold;
    uchar     ucPcsRxPtrGap;
    uchar     ucPcsRxFifoLoad;

/*PCS_CALY4 REGISTER*/
    uchar     ucPcsTxThreshold;
    ushort    uiPcsTxPtrGap;
    uchar     ucPcsTxFifoLoad;
	uchar     ucPcsTxLanIpgVal;
}ixf18100_PcsCfg_t;



typedef struct{

/*PCS_CNTL1 REGISTER*/
	uchar		ucPCSLoopbackTxRx;

/*PCS_10GCNTL2 REGISTER*/
    uchar		ucPCSJitterTestMode;
	    
/*PCS_JITCTL REGISTER*/
    uchar		ucPcsTxJitterEnable;
    uchar		ucPcsRxJitterEnable;
    uchar     ucJittTestPattSel_SW1_PR0;
    uchar     ucJittDataPattSel_Z1_LF0;

/*PCS_SEED REGISTERS*/
	ushort	uiPCSSeedA0;
	ushort    uiPCSSeedA1;
	ushort    uiPCSSeedA2;
	ushort    uiPCSSeedA3;
	ushort    uiPCSSeedB0;
	ushort    uiPCSSeedB1;
	ushort    uiPCSSeedB2;
	ushort    uiPCSSeedB3;

}ixf18100_PcsTestCfg_t;


typedef struct{

/*PCS_STAT1 REGISTER*/
    uchar     ucLocalFault;
    uchar     ucPcsRxLinkupEn;
    uchar     ucPowerdownAbility;

/*PCS_ID1 REGISTER*/
    ushort    uiPcsID1;

/*PCS_ID2 REGISTER*/
    ushort    uiPcsID2;

/*PCS_SPEED_ABIL REGISTER*/
    uchar     ucPcs10gCapable;

/*PCS_DEVICES1*/
    uchar     ucPcsVendorSpecDevicePresent;

/*PCS_DEVICES2*/
    uchar     ucDTE_Present;
    uchar     ucPHY_Present;
    uchar     ucPcsPresent;
    uchar     ucWIS_Present;
    uchar     ucPMD_PMA_Present;
    uchar     ucClause22Present;

/*PCS_10GSTAT2 REGISTER*/
    uchar     ucDevicePresent;
    uchar     ucTxLocalFaultDetected;
    uchar     ucRxLocalFaultDetected;
    uchar     uc10gBaseW_Supported;
    uchar     uc10gBaseX_Supported;
    uchar     uc10gBaseR_Supported;

/*PCS_10GBRSTAT1 REGISTER*/
    uchar     uc10gBaseR_RxLinkStatus;    
    uchar     uc10gBaseR_HiBER_Reported;
    uchar     uc10gBaseR_PcsLocked;

/*PCS_10GBRSTAT2 REGISTER*/
    uchar     ucBlockLockOccurred;
    uchar     ucHiBER_Entered;

/*PCS_CALY2 REGISTER*/
    uchar     ucWAN_ModeSignalDetect;
    uchar     ucLAN_ModeSignalDetect;

}ixf18100_PcsStatus_t;



#endif /*__IXF18100_PCS_D_H__*/

