/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001-2004 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/08/04 1:57p $
*   LAST MODIFIED:  $Modtime: 3/05/04 3:13p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pos_b.h $
*   WORKFILE:       $Workfile: ixf18100_pos_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf18101/3 802.3 pos API
*
* Purpose: IEEE 802.3 pos Register offsets, shifts, masks, defaults, values 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pos_b.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
*/

#ifndef ixf18100_POSBIT_DEFINES_H
#define ixf18100_POSBIT_DEFINES_H

#ifndef ixf18100_REG_SHIFT
#define ixf18100_REG_SHIFT  0x0
#endif

/* Block Offset for POS */
#ifndef ixf18100_POS_BASE
#define ixf18100_POS_BASE		0x3300
#endif

#define POS_REG_OFFSET(offset) ((ixf18100_POS_BASE + offset) << ixf18100_REG_SHIFT)
/******************************************************************************/
/* R_PHCCNF Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_PHCCNF_OFFSET	POS_REG_OFFSET(0x0000)
#define ixf18100_R_PHCCNF_DFLT		0x006F

/* -------- Bit, shift and mask defines.-------- */

/*RcvDescrEn *Enables the descrambling of HDLC frame */
#define ixf18100_sPOS_RX_DESCRABLER_EN	0

/*RcvACPass *Configures writing of HDLC Address and Control fields in Rx Fifo */
#define ixf18100_sPOS_RX_AC_PASS_EN		1

/*RcvFCSCnf *Selects the size of FCS in Rx frames */
#define ixf18100_sPOS_RX_FCS_CNF		2
#define ixf18100_mPOS_RX_FCS_CNF		(0x03 << ixf18100_sPOS_RX_FCS_CNF)

/*RcvACChk *Enables checking of HDLC Address and Control fields by receiver */
#define ixf18100_sPOS_RX_AC_CHECK_EN	4

/*RcvMinPLDEn *Enables discarding of packets smaller than minimum length specified */
#define ixf18100_sPOS_RX_MIN_PLD_EN		5

/*RcvMaxPLDEn *Enables discarding of packets larger than maximum length specified */
#define ixf18100_sPOS_RX_MAX_PLD_EN		6

/*RcvTrDescrEn *Controls HDLC frame descrambling after byte destuffing */
#define ixf18100_sPOS_RX_TR_DESCRAMBLER_EN	7

/*RcvFCSPass *Configures the writing of HDLC FCS field into the receive FIFO. */
#define ixf18100_sPOS_RX_FCS_PASS_EN	8

/*RcvFCSErr *Mark frames with FCS errors as erroneous in the FIFO */
#define ixf18100_sPOS_RX_FCS_ERR_EN		9

/*RcvSoftRst *Resets all datapaths, clears all registers and counter configurations */
#define ixf18100_sPOS_RX_READ_EN		10

/******************************************************************************/
/* R_MINPL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_MINPL_OFFSET	POS_REG_OFFSET(0x0001)
#define ixf18100_R_MINPL_DFLT	0x0005

/* -------- Bit, shift and mask defines. -------- */

/*RcvMinPL *Minimum receive packet length */
#define ixf18100_sPOS_RX_MIN_PKT_LEN	0
#define ixf18100_mPOS_RX_MIN_PKT_LEN	(0xFF << ixf18100_sPOS_RX_MIN_PKT_LEN)

/******************************************************************************/
/* R_MAXPL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_MAXPL_OFFSET	POS_REG_OFFSET(0x0002)
#define ixf18100_R_MAXPL_DFLT		0x0600

/* -------- Bit, shift and mask defines. -------- */

/*RcvMaxPL *Maximum receive packet length */
#define ixf18100_sPOS_RX_MAX_PKT_LEN	0
#define ixf18100_mPOS_RX_MAX_PKT_LEN	(0x7FFF << ixf18100_sPOS_RX_MAX_PKT_LEN)

/******************************************************************************/
/* R_GFCNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_GFCNT_W0_OFFSET	POS_REG_OFFSET(0x0010)
#define ixf18100_R_GFCNT_W1_OFFSET	POS_REG_OFFSET(0x0011)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*RcvGFCnt *Receive Good Frame Counter */
#define ixf18100_sR_GFCNT_W0		0
#define ixf18100_mR_GFCNT_W0		(0xFFFF << ixf18100_sR_GFCNT_W0)
#define ixf18100_sR_GFCNT_W1		0
#define ixf18100_mR_GFCNT_W1		(0x3FFF << ixf18100_sR_GFCNT_W1)

/******************************************************************************/
/* R_GFBYTECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_GFBYTECNT_W0_OFFSET	POS_REG_OFFSET(0x0012)
#define ixf18100_R_GFBYTECNT_W1_OFFSET	POS_REG_OFFSET(0x0013)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_GFBYTECNT *Receive Good Frame Byte Counter */
#define ixf18100_sR_GFBYTECNT_W0		0
#define ixf18100_mR_GFBYTECNT_W0		(0xFFFF << ixf18100_sR_GFBYTECNT_W0)
#define ixf18100_sR_GFBYTECNT_W1		0
#define ixf18100_mR_GFBYTECNT_W1		(0xFFFF << ixf18100_sR_GFBYTECNT_W1)

/******************************************************************************/
/* R_AFCNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_AFCNT_W0_OFFSET	POS_REG_OFFSET(0x0014)
#define ixf18100_R_AFCNT_W1_OFFSET	POS_REG_OFFSET(0x0015)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_AFCNT *Receive Aborted Frame Counter */
#define ixf18100_sR_AFCNT_W0		0
#define ixf18100_mR_AFCNT_W0		(0xFFFF << ixf18100_sR_AFCNT_W0)
#define ixf18100_sR_AFCNT_W1		0
#define ixf18100_mR_AFCNT_W1		(0x3FFF << ixf18100_sR_AFCNT_W1)

/******************************************************************************/
/* R_AFBYTECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_AFBYTECNT_W0_OFFSET	POS_REG_OFFSET(0x0016)
#define ixf18100_R_AFBYTECNT_W1_OFFSET	POS_REG_OFFSET(0x0017)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_AFBYTECNT *Receive Aborted Frame Byte Counter */
#define ixf18100_sR_AFBYTECNT_W0		0
#define ixf18100_mR_AFBYTECNT_W0		(0xFFFF << ixf18100_sR_AFBYTECNT_W0)
#define ixf18100_sR_AFBYTECNT_W1		0
#define ixf18100_mR_AFBYTECNT_W1		(0xFFFF << ixf18100_sR_AFBYTECNT_W1)

/******************************************************************************/
/* R_FCSECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_FCSECNT_W0_OFFSET	POS_REG_OFFSET(0x0018)
#define ixf18100_R_FCSECNT_W1_OFFSET	POS_REG_OFFSET(0x0019)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_FCSECNT *Receive FCS Error Counter */
#define ixf18100_sR_FCSECNT_W0		0
#define ixf18100_mR_FCSECNT_W0		(0xFFFF << ixf18100_sR_FCSECNT_W0)
#define ixf18100_sR_FCSECNT_W1		0
#define ixf18100_mR_FCSECNT_W1		(0x3FFF << ixf18100_sR_FCSECNT_W1)

/******************************************************************************/
/* R_FCSEBYTECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_FCSEBYTECNT_W0_OFFSET	POS_REG_OFFSET(0x001A)
#define ixf18100_R_FCSEBYTECNT_W1_OFFSET	POS_REG_OFFSET(0x001B)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_FCSEBYTECNT *Receive FCS Error Byte Counter */
#define ixf18100_sR_FCSEBYTECNT_W0		0
#define ixf18100_mR_FCSEBYTECNT_W0		(0xFFFF << ixf18100_sR_FCSEBYTECNT_W0)
#define ixf18100_sR_FCSEBYTECNT_W1		0
#define ixf18100_mR_FCSEBYTECNT_W1		(0xFFFF << ixf18100_sR_FCSEBYTECNT_W1)

/******************************************************************************/
/* R_MINPLECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_MINPLECNT_W0_OFFSET	POS_REG_OFFSET(0x001C)
#define ixf18100_R_MINPLECNT_W1_OFFSET	POS_REG_OFFSET(0x001D)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_MINPLECNT *Receive Minimum packet length error counter */
#define ixf18100_sR_MINPLECNT_W0		0
#define ixf18100_mR_MINPLECNT_W0		(0xFFFF << ixf18100_sR_MINPLECNT_W0)
#define ixf18100_sR_MINPLECNT_W1		0
#define ixf18100_mR_MINPLECNT_W1		(0x3FFF << ixf18100_sR_MINPLECNT_W1)

/******************************************************************************/
/* R_MAXPLECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_MAXPLECNT_OFFSET	POS_REG_OFFSET(0x001E)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*R_MAXPLECNT *Receive Maximum packet length error counter */
#define ixf18100_sR_MAXPLECNT		0
#define ixf18100_mR_MAXPLECNT		(0xFFFF << ixf18100_sR_MAXPLECNT)

/******************************************************************************/
/* R_POSINT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_POSINT_OFFSET	POS_REG_OFFSET(0x0020)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*RcvFCSI *Interrupt for when a packet with FCS error is received */
#define ixf18100_sPOS_RX_FCS_ERR_INT		    0

/*RcvAbortI *Interrupt for when a packet with abort sequence is received */
#define ixf18100_sPOS_RX_ABORT_INT			    1

/*RcvACI *Interrupt for when HDLC Address and Control field are different than expected */
#define ixf18100_sPOS_RX_HDLC_AC_INT		    2

/*RvcDblEscI *Interrupt for when Control Escape character pair is received. */
#define ixf18100_sPOS_RX_DBL_ESC_INT		    3

/*RcvMinPLI *Interrupt for when packet smaller than MinPL is received */
#define ixf18100_sPOS_RX_MIN_PKT_LEN_INT	    4

/*RcvMaxPLI *Interrupt for when packet larger than MaxPL is received */
#define ixf18100_sPOS_RX_MAX_PKT_LEN_INT	    5

/*RcvSFI *Interrupt for when a short frame (less than 5 bytes) is discarded */
#define ixf18100_sPOS_RX_SHORT_FRM_DISCARD_INT	6

/*RcvFCSCntI *Interrupt for when FCS Error Counter rolls over */
#define ixf18100_sPOS_RX_FCS_ERR_CNT_INT	    7

/*RcvAFCntI *Interrupt for when Aborted Frame Counter rolls over */
#define ixf18100_sPOS_RX_ABORT_FRM_CNT_INT	    8

/*RcvGFCntI *Interrupt for when Good Frame Counter rolls over */
#define ixf18100_sPOS_RX_GOOD_FRM_CNT_INT	    9

/*RcvGFByteCntI *Interrupt for when Good Frame Byte Counter rolls over */
#define ixf18100_sPOS_RX_GF_BYTE_CNT_INT	    10

/*RcvMinPLCntI *Interrupt for when Minimum Packet Length Error Counter rolls over */
#define ixf18100_sPOS_RX_MINPL_ERR_CNT_INT	    11

/*RcvMaxPLCntI *Interrupt for when Maximum Packet Length Error Counter rolls over */
#define ixf18100_sPOS_RX_MAXPL_ERR_CNT_INT	    12

/*RcvAFByteCntI *Interrupt for when Aborted Frame Byte Counter rolls over */
#define ixf18100_sPOS_RX_AF_BYTE_CNT_INT	    13

/*RcvFCSEByteCntI *Interrupt for when FCS Error Byte Counter rolls over */
#define ixf18100_sPOS_RX_FCS_ERR_BYTE_CNT_INT	14

/******************************************************************************/
/* R_POSINTEN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_R_POSINTEN_OFFSET	POS_REG_OFFSET(0x0021)
#define ixf18100_R_POSINTEN_DFLT	0x0000

/* -------- Bit, shift and mask defines. -------- */

/*RcvFCSIEn *Interrupt enable for when a packet with FCS error is received */
#define ixf18100_sPOS_RX_FCS_ERR_INT_EN		        0

/*RcvAbortIEn *Interrupt enable for when a packet with abort sequence is received */
#define ixf18100_sPOS_RX_ABORT_INT_EN			    1

/*RcvACIEn *Interrupt enable for when HDLC Address and Control field are different than expected */
#define ixf18100_sPOS_RX_HDLC_AC_INT_EN		        2

/*RvcDblEscIEn *Interrupt enable for when Control Escape character pair is received. */
#define ixf18100_sPOS_RX_DBL_ESC_INT_EN		        3

/*RcvMinPLIEn *Interrupt enable for when packet smaller than MinPL is received */
#define ixf18100_sPOS_RX_MIN_PKT_LEN_INT_EN	        4

/*RcvMaxPLIEn *Interrupt enable for when packet larger than MaxPL is received */
#define ixf18100_sPOS_RX_MAX_PKT_LEN_INT_EN	        5

/*RcvSFIEn *Interrupt enable for when a short frame is discarded */
#define ixf18100_sPOS_RX_SHORT_FRM_DISCARD_INT_EN	6

/*RcvFCSCntIEn *Interrupt enable for when FCS Error Counter rolls over */
#define ixf18100_sPOS_RX_FCS_ERR_CNT_INT_EN	        7

/*RcvAFCntIEn *Interrupt enable for when Aborted Frame Counter rolls over */
#define ixf18100_sPOS_RX_ABORT_FRM_CNT_INT_EN	    8

/*RcvGFCntIEn *Interrupt enable for when Good Frame Counter rolls over */
#define ixf18100_sPOS_RX_GOOD_FRM_CNT_INT_EN	    9

/*RcvGFByteCntIEn *Interrupt enable for when Good Frame Byte Counter rolls over */
#define ixf18100_sPOS_RX_GF_BYTE_CNT_INT_EN	        10

/*RcvMinPLCntIEn *Interrupt enable for when Minimum Packet Length Error Counter rolls over */
#define ixf18100_sPOS_RX_MINPL_ERR_CNT_INT_EN	    11

/*RcvMaxPLCntIEn *Interrupt enable for when Maximum Packet Length Error Counter rolls over */
#define ixf18100_sPOS_RX_MAXPL_ERR_CNT_INT_EN	    12

/*RcvAFByteCntIEn *Interrupt enable for when Aborted Frame Byte Counter rolls over */
#define ixf18100_sPOS_RX_AF_BYTE_CNT_INT_EN	        13

/*RcvFCSEByteCntIEn *Interrupt enable for when FCS Error Byte Counter rolls over */
#define ixf18100_sPOS_RX_FCS_ERR_BYTE_CNT_INT_EN	14

/******************************************************************************/
/* T_PHCCNF Register*/

/*Offset/Default definition for register.*/
#define ixf18100_T_PHCCNF_OFFSET	POS_REG_OFFSET(0x0030)
#define ixf18100_T_PHCCNF_DFLT		0x000F

/* -------- Bit, shift and mask defines. -------- */

/*XmtScrEn *Enables the scrambling of HDLC frame */
#define ixf18100_sPOS_TX_SCRABLER_EN	    0

/*RcvACPass *Configures transmission of HDLC Address and Control fields */
#define ixf18100_sPOS_TX_AC_PASS_EN		    1

/*XmtFCSCnf *Selects the type of FCS inserted in the transmitted frames */
#define ixf18100_sPOS_TX_FCS_CNF		    2
#define ixf18100_mPOS_TX_FCS_CNF		    (0x03 << ixf18100_sPOS_TX_FCS_CNF)

/*XmtFCSErr *Controls the insertion of FCS errors in transmitted frames */
#define ixf18100_sPOS_TX_FCS_ERR_EN		    4

/*XmtFCSErrCnf *Configures if only one or all packets will transmitted with FCS errors. */
#define ixf18100_sPOS_TX_FCS_ERR_CNF_EN	    5

/*XmtReadEn *Enables reading of the POS packets from transmit FIFO */
#define ixf18100_sPOS_TX_PKT_READ_EN	    6

/*XmtTrScrEn *Enables the scrambling of user data before passing it throgh byte stuffing */
#define ixf18100_sPOS_TX_TR_SCRAMBLER_EN	7

/******************************************************************************/
/* T_IPGCTRL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_T_IPGCTRL_OFFSET	POS_REG_OFFSET(0x0031)
#define ixf18100_T_IPGCTRL_DFLT		0x0000

/* -------- Bit, shift and mask defines. -------- */

/*XmtIPGAbs *Number of Flag characters to insert between consecutive HDLC frames */
#define ixf18100_sPOS_TX_IPG_ABS	    0
#define ixf18100_mPOS_TX_IPG_ABS	    (0xFF << ixf18100_sPOS_TX_IPG_ABS)

/*XmtIPGAbsCnf *Ensures minimum number of interframe flag characters between two consecutive frames */
#define ixf18100_sPOS_TX_IPG_ABS_CNF	8

/*XmtIPGAbsEn *Enables insertion of interframe Flag characters to ensure minimum number of 
*flag characters between two consecutive frames */
#define ixf18100_sPOS_TX_IPG_ABS_EN		9

/*XmtIPGRel *Configures number of flag characters to insert between two consecutive 
*frames a function of transmitted frame length */
#define ixf18100_sPOS_TX_IPG_REL		10
#define ixf18100_mPOS_TX_IPG_REL		(0x07 << ixf18100_sPOS_TX_IPG_REL)

/*XmtIPGRelCnf *Configures how to calculate the number of flag characters to be inserted */
#define ixf18100_sPOS_TX_IPG_REL_CNF	13

/*XmtIPGRelEn *Enables the insertionof interframe filling flag characters */
#define ixf18100_sPOS_TX_IPG_REL_EN		14

/******************************************************************************/
/* T_FRMCNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_T_FRMCNT_W0_OFFSET	POS_REG_OFFSET(0x0040)
#define ixf18100_T_FRMCNT_W1_OFFSET	POS_REG_OFFSET(0x0041)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*RcvGFCnt *Transmit Frame Counter */
#define ixf18100_sT_FRMCNT_W0		0
#define ixf18100_mT_FRMCNT_W0		(0xFFFF << ixf18100_sT_FRMCNT_W0)
#define ixf18100_sT_FRMCNT_W1		0
#define ixf18100_mT_FRMCNT_W1		(0x3FFF << ixf18100_sT_FRMCNT_W1)

/******************************************************************************/
/* T_BYTECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_T_BYTECNT_W0_OFFSET	POS_REG_OFFSET(0x0042)
#define ixf18100_T_BYTECNT_W1_OFFSET	POS_REG_OFFSET(0x0043)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*T_BYTECNT *Transmit Byte Counter */
#define ixf18100_sT_BYTECNT_W0		0
#define ixf18100_mT_BYTECNT_W0		(0xFFFF << ixf18100_sT_BYTECNT_W0)
#define ixf18100_sT_BYTECNT_W1		0
#define ixf18100_mT_BYTECNT_W1		(0xFFFF << ixf18100_sT_BYTECNT_W1)

/******************************************************************************/
/* T_POSINT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_T_POSINT_OFFSET	POS_REG_OFFSET(0x0050)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines. -------- */

/*XmtFCSI *Interrupt for when a FCS error is inserted into a packet */
#define ixf18100_sPOS_TX_FCS_ERR_INT		0

/*XmtFrmCntI *Interrupt for when Transmit Frame Counter rolls over */
#define ixf18100_sPOS_TX_FRM_CNT_INT		1

/*XmtByteCntI *Interupt for when Transmit Byte Counter rolls over */
#define ixf18100_sPOS_TX_BYTE_CNT_INT		2

/******************************************************************************/
/* T_POSINTEN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_T_POSINTEN_OFFSET	POS_REG_OFFSET(0x0051)
#define ixf18100_T_POSINTEN_DFLT	0x0000

/* -------- Bit, shift and mask defines. -------- */

/*XmtFCSIEn *Interrupt enable for when a FCS error is inserted into a packet */
#define ixf18100_sPOS_TX_FCS_ERR_INT_EN		0

/*XmtFrmCntIEn *Interrupt enable for when Transmit Frame Counter rolls over */
#define ixf18100_sPOS_TX_FRM_CNT_INT_EN		1

/*XmtByteCntIEn *Interrupt enable for when Transmit Byte Counter rolls over */
#define ixf18100_sPOS_TX_BYTE_CNT_INT_EN	2

/******************************************************************************/
/* POS_INT_STATUS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_POS_INT_STATUS_OFFSET	POS_REG_OFFSET(0x0052)
#define ixf18100_POS_INT_STATUS_DFLT	0x0000

/* -------- Bit, shift and mask defines. -------- */

/*XmtI *Transmit Interrupt Status Bit */
#define ixf18100_sPOS_TX_INT_STATUS		0

/*RcvI *Receive Interrupt Status Bit */
#define ixf18100_sPOS_RX_INT_STATUS		1

/******************************************************************************/
#endif /* ixf18100_POSBIT_DEFINES_H */

