/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pos_d.h $
 *   WORKFILE:       $Workfile: ixf18100_pos_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: 
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_pos_d.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     6/27/03 4:43p Daly
 * 
 * 1     7/08/02 1:37p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * 7     4/15/02 4:52p Pkjain2
 * Cleaned up some structures that were not being used.
 * 
 * 6     12/04/01 4:22p Pkjain2
 * 
 * 5     11/10/01 11:26a Pkjain2
 * 
 * 4     11/02/01 5:10p Pkjain2
 * 
 * 3     8/17/01 2:35p Pkjain2
 * 
 * 1     8/15/01 8:34a Pkjain2
 * POS Files
 * 
 * 1     7/18/01 10:54a Rfranz
 * Initial check in - file headers only
 * 
 * --------------------------------------------------------------------------
 */
#ifndef IXF18100_POS_D_H
#define IXF18100_POS_D_H


typedef enum {

	e_REL_PKT_GAP_DISABLE	= 0,
	e_PKT_LEN_MULT_1		= 1,
	e_PKT_LEN_MULT_2		= 2,
	e_PKT_LEN_MULT_4		= 3,
	e_PKT_LEN_MULT_8		= 4,
	e_PKT_LEN_MULT_16		= 5,
	e_PKT_LEN_MULT_32		= 6,
	e_PKT_LEN_MULT_64		= 7,
	e_PKT_LEN_MULT_128		= 8,
	e_MAX_PKTLEN_1			= 9,
	e_PKT_LEN_DIV_2			= 10,
	e_PKT_LEN_DIV_4			= 11,
	e_PKT_LEN_DIV_8			= 12,
	e_PKT_LEN_DIV_16		= 13,
	e_PKT_LEN_DIV_32		= 14,
	e_PKT_LEN_DIV_64		= 15,
	e_PKT_LEN_DIV_128		= 16
}ixfPos_RelPktGap_e;


typedef struct 
{

	uchar	ucPosRxHdlcFrmDescrambleEn;
	uchar	ucPosWriteHdlcAddrInRxFifoEn;
	uchar	ucPosRxFcsType;
	uchar	ucPosRxCheckHdlcAddrEn;
	uchar	ucPosRxDiscardSmallPkt;
	uchar	ucPosRxDiscardLargePkt;
	uchar	ucPosRxDescrmbAfterByteDestuffingEn;
	uchar	ucPosWriteHdlcFcsFieldToRxFifo;
	uchar	ucPosRxMarkFrameWithFcsErrorsEn;
	uchar	ucPosRxReadPktFromWIS;

	uchar	ucPosRxMinPktLength;

	ushort	uiPosRxMaxPktLength;
}ixf18100_PosRxCfg_t;

typedef struct {

	uchar	ucPosTxHdlcFrmScrambleEn;
	uchar	ucPosTxHdlcAddrCtrlEn;
	uchar	ucPosTxFcsType;
	uchar	ucPosTxInsertFcsErrEn;
	uchar	ucPosTxFcsErrInAllFrmEn;
	uchar	ucPosTxFifoPktReadEn;
	uchar	ucPosTxScrmDataBeforeByteStuffingEn;

	ixfPos_RelPktGap_e	ePosTxInterPktRelativeGap;
	ulong	ulPosTxInterPktAbsoluteGap;
}ixf18100_PosTxCfg_t;

typedef struct {

	ixf18100_PosRxCfg_t	PosRxCfg;
	ixf18100_PosTxCfg_t	PosTxCfg;
}ixf18100_PosCfg_t;

#endif /* IXF18100_POS_D_H */

