/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_sonet_d.h $
 *   WORKFILE:       $Workfile: ixf18100_sonet_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 family device API
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_sonet_d.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 4     1/30/03 4:40p Pkjain2
 * Made changes for PTQ release. Added Getstatus calls for SONET and
 * GLOBAL block.
 * 
 * 3     2/07/02 4:00p Srodrig1
 * 
 * 2     1/11/02 10:30a Srodrig1
 * 
 * 1     7/18/01 10:55a Rfranz
 * Initial check in - file headers only
 * 
 * --------------------------------------------------------------------------
 */

#ifndef IXF_18100_SONET_D_H
#define IXF_18100_SONET_D_H

typedef enum
{
   ixf18100_eSET_TO_00H = 0, 
   ixf18100_eSET_TO_FFH

}ixf18100_SerialTlUnByte_t;


typedef enum
{
   ixf18100_eNOT_AFFECT_DATA = 0, 
   ixf18100_eAFFECT_DATA
}ixf18100_SerialTlErrEn_t;

typedef enum
{     
   ixf18100_eDISABLE_AIS = 0, 
   ixf18100_eAIS_PREVIOUS_VALUE
}ixf18100_SerialTlTalErrAis_t;

typedef enum
{
   
   ixf18100_eREGISTER_VALUE = 0,
   ixf18100_eLAST_CAPTURED_VALUE 

}ixf18100_SerialTlTalErr_t;


typedef enum
{
   ixf18100_eCONTRA_DIRECTIONAL = 0,
   ixf18100_eCO_DIRECTIONAL

}ixf18100_SerialTlTalPort_t;

typedef enum
{
    ixf18100_eUSE_RISING_EDGE = 0,
    ixf18100_eUSE_FALLING_EDGE

}ixf18100_SerialTlPrtOWRClk_t;


typedef enum
{
    ixf18100_eOW_PULSE_MSB = 0,
    ixf18100_eOW_PULSE_LSB

}ixf18100_SerialTlPrtOWRSync_t;

typedef enum
{
    ixf18100_eTOH = 0,
    ixf18100_eDCC

}ixf18100_SerialTlPrtMux_t;

typedef struct
{
  ixf18100_SerialTlPrtMux_t      SerPrtMuxCnfg;
  ixf18100_SerialTlPrtOWRSync_t  OrdWireSyncPulseCnfg;
  ixf18100_SerialTlPrtOWRClk_t   OrdWireClkCnfg;
  ixf18100_SerialTlTalPort_t     TtalCnfg;
  ixf18100_SerialTlTalErr_t      TtalErrCnfg;
  ixf18100_SerialTlTalErrAis_t   TtalErrAisCnfg;
  ixf18100_SerialTlErrEn_t    CrcErrEnCnfg;
  ixf18100_SerialTlErrEn_t    ClkErrEnCnfg;
  ixf18100_SerialTlErrEn_t    FrmErrEnCnfg;
  ixf18100_SerialTlUnByte_t      UnByteCnfg;
   
}ixf18100_SerialPortTxTranspCnfg_t;

typedef enum
{
    ixf18100_eTTAL_PORT = 0,
    ixf18100_eTOH_PORT
}ixf18100_SerialTlPrtSrc_t;

typedef struct
{
    ixf18100_SerialTlPrtSrc_t M1SerSrc;
    ixf18100_SerialTlPrtSrc_t S1SerSrc;
    ixf18100_SerialTlPrtSrc_t K2RdiSerSrc;
    ixf18100_SerialTlPrtSrc_t K2ApsSecSrc;
    ixf18100_SerialTlPrtSrc_t K1SerSrc;
    ixf18100_SerialTlPrtSrc_t M0SerSrc;
}ixf18100_SerialPortRxTranspPrtSel_t;

typedef struct
{
  ixf18100_SerialPortTxTranspCnfg_t    TxTranspCnfg;
  ixf18100_SerialPortRxTranspPrtSel_t  TxTranspPrtSel; 
}ixf18100_SerialTxTranspor_t;


typedef enum
{
    ixf18100_eUSE_OWS_FALLING_EDGE = 0,
    ixf18100_eUSE_OWS_RISING_EDGE,

}ixf18100_SerialRlOrdwClk_t;

typedef enum
{
    ixf18100_eOWS_PULSE_MSB = 0,
    ixf18100_eOWS_PULSE_LSB,

}ixf18100_SerialRlOrdwSync_t;


typedef enum
{
    ixf18100_eTRANSPORT_OH_AVAIL = 0,
    ixf18100_eDCC_OW_AVAIL,
}ixf18100_SerialPortMuxCfg_t;


typedef struct
{
    unsigned char               GenPurpByte;
    unsigned char               GenPurpInt;
    ixf18100_SerialRlOrdwClk_t  OwClk;
    ixf18100_SerialRlOrdwSync_t OwSync;
    ixf18100_SerialPortMuxCfg_t PortMuxCnfg;   
}ixf18100_SerialPortRxTranspCnfg_t;



typedef enum
{
    ixf18100_eINSERT_NORMAL_DATA = 0,
    ixf18100_eINSERT_ALL_ONES,
    ixf18100_eINSERT_7F = ixf18100_eINSERT_ALL_ONES

}ixf18100_SerialDataOnAisEn_t;

typedef enum
{
    ixf18100_eINSERT_7F_SONET = 0,
    ixf18100_eINSERT_FF_SDH
}ixf18100_SerialOrdDataOnAisEn_t;



typedef struct
{
    ixf18100_SerialOrdDataOnAisEn_t  RtOwdQuietCfg;
    ixf18100_SerialDataOnAisEn_t     RlOwdQuietCfg;
    ixf18100_SerialDataOnAisEn_t     RsDccQuiet;
    ixf18100_SerialDataOnAisEn_t     RlDccQuiet;

}ixf18100_SerialPortRxTranspDatSel_t;


typedef struct
{
    ixf18100_SerialPortRxTranspCnfg_t    RxTranspCnfg;
    ixf18100_SerialPortRxTranspDatSel_t  RxTranspDataSel;

}ixf18100_SerialRxTransport_t;


typedef struct
{
    ixf18100_SerialTxTranspor_t Transmit;
    ixf18100_SerialRxTransport_t Receive;

}ixf18100_SonetSerialPortTransport_t;



typedef enum
{
    ixf18100_eERR_NO_AFFECTS_DATA= 0,
    ixf18100_eERR_AFFECTS_DATA

}ixf18100_SerialPortErrEn_t;

typedef enum
{
    ixf18100_eAISP_CONTROL_DIS= 0,
    ixf18100_eAISP_CONTROL_BY_TPAL    
}ixf18100_SerialTpalGenAisCnfg_t;


typedef enum
{
    ixf18100_eCONTRA_DIRECTIONAL_PORT = 0,
    ixf18100_eCO_DIRECTIONAL_PORT

}ixf18100_SerialTpalClkFrmSrc_t;


typedef enum
{ 
    ixf18100_eTX_REG_VALUE = 0,
    ixf18100_eTX_LAST_VALUE
}ixf18100_SerialTpalErrDatCnfg_t;


typedef struct
{
    ixf18100_SerialPortErrEn_t          FrErrEn;
    ixf18100_SerialPortErrEn_t          ClkErrEn;
    ixf18100_SerialPortErrEn_t          CrcErrEn;
    ixf18100_SerialTpalGenAisCnfg_t     TpalGenAisCnfg;
    ixf18100_SerialTpalErrDatCnfg_t     TpalErrDatCnfg;
    ixf18100_SerialTpalClkFrmSrc_t      TpalClkSrcCnfg;

}ixf18100_SerialPortTxPathCnfg_t;


typedef enum
{
    ixf18100_eSERIAL_POH_PORT = 0,
    ixf18100_eSERIAL_TPAL_PORT

}ixf18100_SerialPortSourceBit_t;

typedef struct
{
    ixf18100_SerialPortSourceBit_t G1ReiSerSrc;
    ixf18100_SerialPortSourceBit_t G1Rdi3SerSrc;
    ixf18100_SerialPortSourceBit_t G1Rdi21SerSrc;
    ixf18100_SerialPortSourceBit_t G1SpareSerSrc;

}ixf18100_SerialPortTxPathSel_t;

typedef struct
{
    ixf18100_SerialPortTxPathCnfg_t PathCnfg;
    ixf18100_SerialPortTxPathSel_t PathSel;

}ixf18100_SonetSerialPortPath_t;


typedef struct
{
    ixf18100_SonetSerialPortTransport_t   Transport;
    ixf18100_SonetSerialPortPath_t        Path;   
}ixf18100_SonetSerialCfg_t;

/************************************************************
* Pointer justification
**************************************************************/
typedef enum
{
    ixf18100_eGENERATE_STREAM = 0,
    ixf18100_eNO_STREAM
}ixf18100_SonetLopAisDownStreamEn_t;


typedef enum
{
    ixf18100_eSDH_PTR_JUST = 0,
    ixf18100_eSONET_PTR_JUST

}ixf18100_SonetPtrJustCnfg_t;

typedef enum
{
    ixf18100_eSONET_MODE = 0,
    ixf18100_eSDH_MODE
}ixf18100_SonetPtrSsEn_t;



typedef struct
{
    ixf18100_SonetLopAisDownStreamEn_t   Ais2pAisEn;
    ixf18100_SonetLopAisDownStreamEn_t   Lop2pAisEn;
    ixf18100_SonetLopAisDownStreamEn_t   Aisc2pAisEn;
    ixf18100_SonetLopAisDownStreamEn_t   Lopc2pAisEn;
    ixf18100_SonetPtrJustCnfg_t          PtrJustCnfg;
    unsigned int                         ExpcPtrSs;
    ixf18100_SonetPtrSsEn_t              PtrSsEn;

}ixf18100_SonetPointerCfg_t;

typedef struct 
{
    bb_PathOhBytes_t            PathTxOhBytes;
    bb_PathOhBytes_t            PathRxOhBytes;
} ixf18100_SonetApsCfg_t;

typedef struct 
{
    bb_RstMstBytes_t            RstTxMstBytes;
    bb_RstMstBytes_t            RstRxMstBytes;
    bb_PathOhBytes_t            PathTxOhBytes;
    bb_PathOhBytes_t            PathRxOhBytes;
    ixf18100_SonetApsCfg_t      SonetApsPathOhBytes;
    ixf18100_SonetSerialCfg_t   SerialCfg;
	ixf18100_SonetPointerCfg_t  PointerCfg;

} ixf18100_SonetCfg_t;

typedef struct
{
    uchar       ucPRBSSyncState;
} ixf18100_SonetMiscStatus_t;

typedef struct
{
    uchar       ucOOFDetected;
    uchar       ucLOFDetected;
    uchar       ucExtLOSDetected;
    uchar       ucIntLOSDetected;
    uchar       ucJ0CRC7ErrDetected;
    uchar       ucJ0Mismatch;
    uchar       ucJ0RxUnstableTrace;
} ixf18100_SonetRxSectionOhStatus_t;

typedef struct
{
    uchar       ucAISLineDetected;
    uchar       ucExcessiveBERDetected;
    uchar       ucRDILineDetected;
    uchar       ucSigFailDetected;
    uchar       ucDegSigDetected;
    uchar       ucK2UnstableDeteted;
    uchar       ucK1UnstableDeteted;
    uchar       ucS1UnstableDeteted;
} ixf18100_SonetRxLineOhStatus_t;

typedef struct
{
    uchar       ucNonConcatAISPDetected;
    uchar       ucNonConcatLossOfPointer;
    uchar       ucConcatAISPDetected;
    uchar       ucConcatLossOfPointer;
} ixf18100_SonetRxPtrTrackerStatus_t;

typedef struct
{
    uchar       ucVCAISDetected;
    uchar       ucPldLabelMismatch;
    uchar       ucUnequipped;
    uchar       ucC2UnstableDetected;
    uchar       ucPDIPAlarmActive;
    uchar       ucJ1CRC7ErrDetected;
    uchar       ucJ1Mismatch;
    uchar       ucJ1RxUnstableTrace;
    uchar       ucJ1RxTraceAllZero;
} ixf18100_SonetRxPathOhStatus_t;

typedef struct
{
    ushort      usOutgoingPtrValue;
    uchar       ucOutgoingSyncStatus;
    uchar       ucOutgoingNewDataFlag;
} ixf18100_SonetTxPtrTrackerStatus_t;

typedef struct
{
    uchar       ucOOFDetected;
    uchar       ucLOFDetected;
    uchar       ucIntLOSDetected;
    uchar       ucJ0CRC7ErrDetected;
    uchar       ucJ0Mismatch;
    uchar       ucJ0RxUnstableTrace;
} ixf18100_SonetAPSRxSectionOhStatus_t;

typedef struct
{
    uchar       ucAISLineDetected;
    uchar       ucExcessiveBERDetected;
    uchar       ucRDILineDetected;
    uchar       ucSigFailDetected;
    uchar       ucDegSigDetected;
    uchar       ucK2UnstableDeteted;
    uchar       ucK1UnstableDeteted;
    uchar       ucS1UnstableDeteted;
} ixf18100_SonetAPSRxLineOhStatus_t;

typedef struct
{
    ixf18100_SonetRxSectionOhStatus_t       SOHStat;
    ixf18100_SonetRxLineOhStatus_t          LOHStat;
    ixf18100_SonetRxPathOhStatus_t          POHStat;
    ixf18100_SonetRxPtrTrackerStatus_t      PtrStat;
    ixf18100_SonetAPSRxSectionOhStatus_t    APSSOHStat;
    ixf18100_SonetAPSRxLineOhStatus_t       APSLOHStat;
} ixf18100_SonetRxStatus_t;

typedef struct
{
    ixf18100_SonetTxPtrTrackerStatus_t      PtrStat;
} ixf18100_SonetTxStatus_t;

typedef struct
{
    ixf18100_SonetMiscStatus_t  SonetMiscStat;
    ixf18100_SonetRxStatus_t    SonetRxStat;
    ixf18100_SonetTxStatus_t    SonetTxStat;
} ixf18100_SonetStatus_t;

#endif
