/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001-2004 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/08/04 1:57p $
*   LAST MODIFIED:  $Modtime: 3/05/04 3:13p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_spi4_b.h $
*   WORKFILE:       $Workfile: ixf18100_spi4_b.h $
*
* --------------------------------------------------------------------------
* Project: ixf18101/3 spi4 API
*
* Purpose: spi4 Register offsets, shifts, masks, defaults, values 
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_spi4_b.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
*/

#ifndef SPI4BIT_DEFINES_H
#define SPI4BIT_DEFINES_H

#ifndef ixf18100_REG_SHIFT
#define ixf18100_REG_SHIFT  0x0
#endif

/* Block Offset for SPI 4 */
#ifndef ixf18100_SPI4_BASE
#define ixf18100_SPI4_BASE		0x3000
#endif

#define SPI4_REG_OFFSET(offset) ((ixf18100_SPI4_BASE + offset) << ixf18100_REG_SHIFT)

/******************************************************************************/
/* SIF_TX_MAXBURST1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_MAXBURST1_OFFSET	SPI4_REG_OFFSET(0x0000)
#define ixf18100_SIF_TX_MAXBURST1_DFLT		0x0200

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_MAXBURST1 *MaxBurst1 for SPI-4 Phase 2 Transmit. */
#define ixf18100_sSIF_TX_MAXBURST1	0
#define ixf18100_mSIF_TX_MAXBURST1	(0x0FFF << ixf18100_sSIF_TX_MAXBURST1)

/******************************************************************************/
/* SIF_TX_MAXBURST2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_MAXBURST2_OFFSET	SPI4_REG_OFFSET(0x0001)
#define ixf18100_SIF_TX_MAXBURST2_DFLT		0x0100

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_MAXBURST2 *MaxBurst2 for SPI-4 Phase 2 Transmit. */
#define ixf18100_sSIF_TX_MAXBURST2	0
#define ixf18100_mSIF_TX_MAXBURST2	(0x0FFF << ixf18100_sSIF_TX_MAXBURST2)

/******************************************************************************/
/* SIF_RX_MAXBURST1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_MAXBURST1_OFFSET	SPI4_REG_OFFSET(0x0002)
#define ixf18100_SIF_RX_MAX_BURST1_DFLT		0x0200

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_MAXBURST1 *MaxBurst1 for SPI-4 Phase 2 Transmit. */
#define ixf18100_sSIF_RX_MAXBURST1	0
#define ixf18100_mSIF_RX_MAXBURST1	(0x0FFF << ixf18100_sSIF_RX_MAXBURST1)

/******************************************************************************/
/* SIF_RX_MAXBURST2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_MAXBURST2_OFFSET	SPI4_REG_OFFSET(0x0003)
#define ixf18100_SIF_RX_MAX_BURST2_DFLT		0x0100

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_MAXBURST2 *MaxBurst2 for SPI-4 Phase 2 Transmit. */
#define ixf18100_sSIF_RX_MAXBURST2	0
#define ixf18100_mSIF_RX_MAXBURST2	(0x0FFF << ixf18100_sSIF_RX_MAXBURST2)

/******************************************************************************/
/* SIF_TX_SYNC Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_SYNC_OFFSET	SPI4_REG_OFFSET(0x0004)
#define ixf18100_SIF_TX_SYNC_DFLT	0x0020

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_SYNC *No of Tx DIP-4 consecutive passes required to gain lock */
#define ixf18100_sSIF_TX_SYNC		0
#define ixf18100_mSIF_TX_SYNC		(0xF << ixf18100_sSIF_TX_SYNC)

/*SIF_TX_NOSYNC *No of Tx DIP-4 fails required to lose lock */
#define ixf18100_sSIF_TX_NOSYNC		4
#define ixf18100_mSIF_TX_NOSYNC		(0xF << ixf18100_sSIF_TX_NOSYNC)

/******************************************************************************/
/* SIF_RX_CFG1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_CFG1_OFFSET	SPI4_REG_OFFSET(0x0005)
#define ixf18100_SIF_RX_CFG1_DFLT	0x8010

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_ALPHA *Alpha parameter for number of training pattern repeats of the receive data */
#define ixf18100_sSIF_RX_ALPHA		0
#define ixf18100_mSIF_RX_ALPHA		(0xFF << ixf18100_sSIF_RX_ALPHA)

/*SIF_RX_MAXTLS(7:0) *Training interval on receive data path */
#define ixf18100_sSIF_RX_MAXTLS		8
#define ixf18100_mSIF_RX_MAXTLS		(0xFF << ixf18100_sSIF_RX_MAXTLS)

/******************************************************************************/
/* SIF_RX_CFG2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_CFG2_OFFSET	SPI4_REG_OFFSET(0x0006)
#define ixf18100_SIF_RX_CFG2_DFLT	0x061A

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_MAXTMS(23:8) *Training interval on receive data path */
#define ixf18100_sSIF_RX_MAXTMS	0
#define ixf18100_mSIF_RX_MAXTMS	(0xFFFF << ixf18100_sSIF_RX_MAXTMS)

/******************************************************************************/
/* SIF_TX_INTFCFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_INTFCFG_OFFSET	SPI4_REG_OFFSET(0x0007)
#define ixf18100_SIF_TX_INTFCFG_DFLT	0x0980

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DIP4_MODE *DIP-4 parity mode */
#define ixf18100_sSIF_TX_DIP4_MODE		4

/*SIF_TX_FSTAT_TEST *Tests the output of FIFO status */
#define ixf18100_sSIF_TX_FSTAT_TEST		5

/*SIF_TX_FSTAT_DIS *Disables transmiting FIFO status channel */
#define ixf18100_sSIF_TX_FSTAT_DIS		6

/*SIF_TX_PARITY_ERASE *Packet erase for parity failures */
#define ixf18100_sSIF_TX_PARITY_ERASE	7

/*SIF_TX_ERROR_ERASE *Packet erase for SPI-4 Phase 2 errors */
#define ixf18100_sSIF_TX_ERROR_ERASE	8

/*SIF_TX_ERROR_MASK *Enabling prevents non dropped erroneous packets to assert parallel bus error */
#define ixf18100_sSIF_TX_ERROR_MASK		9

/*SIF_TX_LVC_STAT_MODE *Status output timing mode select */
#define ixf18100_sSIF_TX_LVC_STAT_MODE	10

/*SIF_TX_FSTAT_REPEATS *Number of training repeats */
#define ixf18100_sSIF_TX_FSTAT_REPEATS	11

/******************************************************************************/
/* SIF_RX_INTFCFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_INTFCFG_OFFSET	SPI4_REG_OFFSET(0x0008)
#define ixf18100_SIF_RX_INTFCFG_DFLT	0x2400

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_SPI4_ADDR *SPI4 Address */
#define ixf18100_sSIF_RX_SPI4_ADDR		0
#define ixf18100_mSIF_RX_SPI4_ADDR		(0xFF << ixf18100_sSIF_RX_SPI4_ADDR)

/*SIF_RX_BIT_REV *Bit reverse for the SPI-4 Phase 2 receive input bus */
#define ixf18100_sSIF_RX_BIT_REV		8

/*SIF_RX_ERROR_ERASE *Packet erase for Internal Parallel Bus Errors */
#define ixf18100_sSIF_RX_ERROR_ERASE	10

/*SIF_RX_ERROR_MASK *Enabling prevents non-dropped internal bus errors from asserting SPI-4 Phase 2 errors */
#define ixf18100_sSIF_RX_ERROR_MASK		11

/*SIF_RX_DIP2_MASK *Enabling ignores the parity on DIP-2 input */
#define ixf18100_sSIF_RX_DIP2_MASK		12

/*SIF_RX_FSTAT_REPEATS *Number of Training pattern repeats */
#define ixf18100_sSIF_RX_FSTAT_REPEATS	13

/*SIF_RX_FSTAT_CLK_INV *Inverts the clock on FIFO status channel */
#define ixf18100_sSIF_RX_FSTAT_CLK_INV	14

/******************************************************************************/
/* SIF_STATUS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_STATUS_OFFSET	SPI4_REG_OFFSET(0x0009)
/*Default value not defined. */

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_FSTAT_ON *FIFO status interface has received a valid message */
#define ixf18100_sSIF_RX_FSTAT_ON			0

/*SIF_TX_TRAIN_DETECT *Set to 1, when train detected */
#define ixf18100_sSIF_TX_TRAIN_DETECTED		1

/*SIF_TX_DESKEW_LOCKED *Set to 1, when Deskew is locked */
#define ixf18100_sSIF_TX_DESKEW_LOCKED		2

/*SIF_TX_FIFO_STATUS *FIFO Status */
#define ixf18100_sSIF_TX_FIFO_STATUS		3
#define ixf18100_mSIF_TX_FIFO_STATUS		(0x03 << ixf18100_sSIF_TX_FIFO_STATUS)

/******************************************************************************/
/* SIF_RX_BURSTLEN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_BURSTLEN_OFFSET	SPI4_REG_OFFSET(0x000A)
#define ixf18100_SIF_RX_BURSTLEN_DFLT	0x0008

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_MAXBURSTLEN *Receive burst length in units */
#define ixf18100_sSIF_RX_BURSTLEN	0
#define ixf18100_mSIF_RX_BURSTLEN	(0xFF << ixf18100_sSIF_RX_BURSTLEN)

/******************************************************************************/
/* SIF_IRPT_STAT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_IRPT_STAT_OFFSET	SPI4_REG_OFFSET(0x000B)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_BUSERR_INT *Transmit Bus Error */
#define ixf18100_sSIF_TX_BUSERR_INT		0

/*SIF_TX_PARERR_INT *Transmit Parity Error */
#define ixf18100_sSIF_TX_PARERR_INT		1

/*SIF_TX_FULLERR_INT *Transmit FIFO Full Error */
#define ixf18100_sSIF_TX_FULLERR_INT	2

/*SIF_TX_NOEOPERR_INT *Transmit No EOP Error */
#define ixf18100_sSIF_TX_NOEOPERR_INT	3

/*SIF_RX_BUSERR_INT *Receive Bus Error */
#define ixf18100_sSIF_RX_BUSERR_INT		4

/*SIF_RX_FULLERR_INT *Receive FIFO Full Error */
#define ixf18100_sSIF_RX_FULLERR_INT	5

/*SIF_RX_NOEOPERR_INT *Receive No EOP Error */
#define ixf18100_sSIF_RX_NOEOPERR_INT	6

/*SIF_RX_DIP2FAIL_INT *Receive DIP2 parity failure */
#define ixf18100_sSIF_RX_DIP2FAIL_INT	7

/******************************************************************************/
/* SIF_IRPT_ENABLE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_IRPT_ENABLE_OFFSET	SPI4_REG_OFFSET(0x000C)
#define ixf18100_SIF_IRPT_ENABLE_DFLT	0x0000

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_BUSERR_INT_EN *Transmit Bus Error Enabled */
#define ixf18100_sSIF_TX_BUSERR_INT_EN		0

/*SIF_TX_PARERR_INT_EN *Transmit Parity Error Enabled */
#define ixf18100_sSIF_TX_PARERR_INT_EN		1

/*SIF_TX_FULLERR_INT_EN *Transmit FIFO Full Error Enabled */
#define ixf18100_sSIF_TX_FULLERR_INT_EN	2

/*SIF_TX_NOEOPERR_INT_EN *Transmit No EOP Error Enabled */
#define ixf18100_sSIF_TX_NOEOPERR_INT_EN	3

/*SIF_RX_BUSERR_INT_EN *Receive Bus Error Enabled */
#define ixf18100_sSIF_RX_BUSERR_INT_EN		4

/*SIF_RX_FULLERR_INT_EN *Receive FIFO Full Error Enabled */
#define ixf18100_sSIF_RX_FULLERR_INT_EN	5

/*SIF_RX_NOEOPERR_INT_EN *Receive No EOP Error Enabled */
#define ixf18100_sSIF_RX_NOEOPERR_INT_EN	6

/*SIF_RX_DIP2FAIL_INT_EN *Receive DIP2 parity failure Enabled */
#define ixf18100_sSIF_RX_DIP2FAIL_INT_EN	7

/******************************************************************************/
/* SIF_TEST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TEST_OFFSET	SPI4_REG_OFFSET(0x000D)
#define ixf18100_SIF_TEST_DFLT		0x0000

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_PI_LOOPBACK *System interface loopback after the system FIFOs and at the parallel interface */
#define ixf18100_sSIF_RX_PI_LOOPBACK	0

/*SIF_RX_LOOPBACK *System Interface Loopback near the SPI-4 Phase 2 high speed interface */
#define ixf18100_sSIF_RX_LOOPBACK		1

/*SIF_TX_LOCK_DISABLE *When enabled, transmit lock function is ignored. */
#define ixf18100_sSIF_TX_LOCK_DISABLE	3

/******************************************************************************/
/* SIF_MAC_THRESHOLD1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_MAC_THRESHOLD1_OFFSET	SPI4_REG_OFFSET(0x000E)
#define ixf18100_SIF_MAC_THRESHOLD1_DFLT	0x0400

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_MAXBURST1 *MaxBurst1 for SPI-4 Phase 2 Transmit. */
#define ixf18100_sSIF_MAC_THRESHOLD1	0
#define ixf18100_mSIF_MAC_THRESHOLD1	(0x07FF << ixf18100_sSIF_MAC_THRESHOLD1)

/******************************************************************************/
/* SIF_TX_MAXBURST2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_MAC_THRESHOLD2_OFFSET	SPI4_REG_OFFSET(0x000F)
#define ixf18100_SIF_MAC_THRESHOLD2_DFLT	0x06C0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_MAXBURST2 *MaxBurst2 for SPI-4 Phase 2 Transmit. */
#define ixf18100_sSIF_MAC_THRESHOLD2	0
#define ixf18100_mSIF_MAC_THRESHOLD2	(0x07FF << ixf18100_sSIF_MAC_THRESHOLD2)

/******************************************************************************/
/* SIF_RX_BIT_POLARITY Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_BIT_POLARITY_OFFSET	SPI4_REG_OFFSET(0x0010)
#define ixf18100_SIF_RX_BIT_POLARITY_DFLT	0x0000

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_POLARITY *Inverts the polarity of SPI-4 Phase 2 output */
#define ixf18100_sSIF_RX_POLARITY	0
#define ixf18100_mSIF_RX_POLARITY	(0xFFFF << ixf18100_sSIF_RX_POLARITY)

/******************************************************************************/
/* SIF_TX_BUSERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_BUSERR_W0_OFFSET	SPI4_REG_OFFSET(0x0020)
#define ixf18100_SIF_TX_BUSERR_W1_OFFSET	SPI4_REG_OFFSET(0x0021)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_BUSERR *Transmit Bus Error Counter */
#define ixf18100_sSIF_TX_BUSERR_W0		0
#define ixf18100_mSIF_TX_BUSERR_W0		(0xFFFF << ixf18100_sSIF_TX_BUSERR_W0)
#define ixf18100_sSIF_TX_BUSERR_W1		0
#define ixf18100_mSIF_TX_BUSERR_W1		(0xFFFF << ixf18100_sSIF_TX_BUSERR_W1)

/******************************************************************************/
/* SIF_TX_PARERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_PARERR_W0_OFFSET	SPI4_REG_OFFSET(0x0022)
#define ixf18100_SIF_TX_PARERR_W1_OFFSET	SPI4_REG_OFFSET(0x0023)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_PARERR *Transmit Parity Error Counter */
#define ixf18100_sSIF_TX_PARERR_W0		0
#define ixf18100_mSIF_TX_PARERR_W0		(0xFFFF << ixf18100_sSIF_TX_PARERR_W0)
#define ixf18100_sSIF_TX_PARERR_W1		0
#define ixf18100_mSIF_TX_PARERR_W1		(0xFFFF << ixf18100_sSIF_TX_PARERR_W1)

/******************************************************************************/
/* SIF_TX_FULLERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_FULLERR_W0_OFFSET	SPI4_REG_OFFSET(0x0024)
#define ixf18100_SIF_TX_FULLERR_W1_OFFSET	SPI4_REG_OFFSET(0x0025)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_FULLERR *Transmit FIFO Full Error Counter */
#define ixf18100_sSIF_TX_FULLERR_W0		0
#define ixf18100_mSIF_TX_FULLERR_W0		(0xFFFF << ixf18100_sSIF_TX_FULLERR_W0)
#define ixf18100_sSIF_TX_FULLERR_W1		0
#define ixf18100_mSIF_TX_FULLERR_W1		(0xFFFF << ixf18100_sSIF_TX_FULLERR_W1)

/******************************************************************************/
/* SIF_TX_NOEOPERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_NOEOPERR_W0_OFFSET	SPI4_REG_OFFSET(0x0026)
#define ixf18100_SIF_TX_NOEOPERR_W1_OFFSET	SPI4_REG_OFFSET(0x0027)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_NOEOPERR *Transmit FIFO Full Error Counter */
#define ixf18100_sSIF_TX_NOEOPERR_W0		0
#define ixf18100_mSIF_TX_NOEOPERR_W0		(0xFFFF << ixf18100_sSIF_TX_NOEOPERR_W0)
#define ixf18100_sSIF_TX_NOEOPERR_W1		0
#define ixf18100_mSIF_TX_NOEOPERR_W1		(0xFFFF << ixf18100_sSIF_TX_NOEOPERR_W1)

/******************************************************************************/
/* SIF_RX_BUSERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_BUSERR_W0_OFFSET	SPI4_REG_OFFSET(0x0028)
#define ixf18100_SIF_RX_BUSERR_W1_OFFSET	SPI4_REG_OFFSET(0x0029)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_BUSERR *Receive Bus Error Counter */
#define ixf18100_sSIF_RX_BUSERR_W0		0
#define ixf18100_mSIF_RX_BUSERR_W0		(0xFFFF << ixf18100_sSIF_RX_BUSERR_W0)
#define ixf18100_sSIF_RX_BUSERR_W1		0
#define ixf18100_mSIF_RX_BUSERR_W1		(0xFFFF << ixf18100_sSIF_RX_BUSERR_W1)

/******************************************************************************/
/* SIF_RX_FULLERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_FULLERR_W0_OFFSET	SPI4_REG_OFFSET(0x002A)
#define ixf18100_SIF_RX_FULLERR_W1_OFFSET	SPI4_REG_OFFSET(0x002B)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_FULLERR *Receive FIFO Full Error Counter */
#define ixf18100_sSIF_RX_FULLERR_W0		0
#define ixf18100_mSIF_RX_FULLERR_W0		(0xFFFF << ixf18100_sSIF_RX_FULLERR_W0)
#define ixf18100_sSIF_RX_FULLERR_W1		0
#define ixf18100_mSIF_RX_FULLERR_W1		(0xFFFF << ixf18100_sSIF_RX_FULLERR_W1)

/******************************************************************************/
/* SIF_RX_DIP2ERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_DIP2ERR_W0_OFFSET	SPI4_REG_OFFSET(0x002C)
#define ixf18100_SIF_RX_DIP2ERR_W1_OFFSET	SPI4_REG_OFFSET(0x002D)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_DIP2ERR *Recieve Parity Error Counter */
#define ixf18100_sSIF_RX_DIP2ERR_W0		0
#define ixf18100_mSIF_RX_DIP2ERR_W0		(0xFFFF << ixf18100_sSIF_RX_DIP2ERR_W0)
#define ixf18100_sSIF_RX_DIP2ERR_W1		0
#define ixf18100_mSIF_RX_DIP2ERR_W1		(0xFFFF << ixf18100_sSIF_RX_DIP2ERR_W1)

/******************************************************************************/
/* SIF_RX_NOEOPERR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_RX_NOEOPERR_W0_OFFSET	SPI4_REG_OFFSET(0x002E)
#define ixf18100_SIF_RX_NOEOPERR_W1_OFFSET	SPI4_REG_OFFSET(0x002F)
/*Default value not applicable to this register*/

/* -------- Bit, shift and mask defines.-------- */

/*SIF_RX_NOEOPERR *Receive No End of Packet Error Counter */
#define ixf18100_sSIF_RX_NOEOPERR_W0		0
#define ixf18100_mSIF_RX_NOEOPERR_W0		(0xFFFF << ixf18100_sSIF_RX_NOEOPERR_W0)
#define ixf18100_sSIF_RX_NOEOPERR_W1		0
#define ixf18100_mSIF_RX_NOEOPERR_W1		(0xFFFF << ixf18100_sSIF_RX_NOEOPERR_W1)

/******************************************************************************/
/* SIF_TX_DSK_DAT_0 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_0_OFFSET	SPI4_REG_OFFSET(0x0030)
#define ixf18100_SIF_TX_DSK_DAT_0_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D0 *Controls write phase of data line 0 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D0		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D0		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D0)

/*SIF_TX_DSK_OFFSET_D0 *Offset of data line 0 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D0			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D0			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D0)

/******************************************************************************/
/* SIF_TX_DSK_DAT_1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_1_OFFSET	SPI4_REG_OFFSET(0x0031)
#define ixf18100_SIF_TX_DSK_DAT_1_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D1 *Controls write phase of data line 1 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D1		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D1		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D1)

/*SIF_TX_DSK_OFFSET_D1 *Offset of data line 1 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D1			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D1			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D1)

/******************************************************************************/
/* SIF_TX_DSK_DAT_2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_2_OFFSET	SPI4_REG_OFFSET(0x0032)
#define ixf18100_SIF_TX_DSK_DAT_2_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D2 *Controls write phase of data line 2 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D2		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D2		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D2)

/*SIF_TX_DSK_OFFSET_D2 *Offset of data line 2 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D2			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D2			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D2)

/******************************************************************************/
/* SIF_TX_DSK_DAT_3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_3_OFFSET	SPI4_REG_OFFSET(0x0033)
#define ixf18100_SIF_TX_DSK_DAT_3_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D3 *Controls write phase of data line 3 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D3		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D3		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D3)

/*SIF_TX_DSK_OFFSET_D3 *Offset of data line 3 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D3			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D3			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D3)

/******************************************************************************/
/* SIF_TX_DSK_DAT_4 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_4_OFFSET	SPI4_REG_OFFSET(0x0034)
#define ixf18100_SIF_TX_DSK_DAT_4_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D4 *Controls write phase of data line 4 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D4		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D4		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D4)

/*SIF_TX_DSK_OFFSET_D4 *Offset of data line 4 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D4			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D4			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D4)

/******************************************************************************/
/* SIF_TX_DSK_DAT_5 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_5_OFFSET	SPI4_REG_OFFSET(0x0035)
#define ixf18100_SIF_TX_DSK_DAT_5_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D5 *Controls write phase of data line 5 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D5		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D5		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D5)

/*SIF_TX_DSK_OFFSET_D5 *Offset of data line 5 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D5			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D5			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D5)

/******************************************************************************/
/* SIF_TX_DSK_DAT_6 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_6_OFFSET	SPI4_REG_OFFSET(0x0036)
#define ixf18100_SIF_TX_DSK_DAT_6_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D6 *Controls write phase of data line 6 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D6		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D6		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D6)

/*SIF_TX_DSK_OFFSET_D6 *Offset of data line 6 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D6			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D6			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D6)

/******************************************************************************/
/* SIF_TX_DSK_DAT_7 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_7_OFFSET	SPI4_REG_OFFSET(0x0037)
#define ixf18100_SIF_TX_DSK_DAT_7_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D7 *Controls write phase of data line 7 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D7		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D7		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D7)

/*SIF_TX_DSK_OFFSET_D7 *Offset of data line 7 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D7			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D7			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D7)

/******************************************************************************/
/* SIF_TX_DSK_DAT_8 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_8_OFFSET	SPI4_REG_OFFSET(0x0038)
#define ixf18100_SIF_TX_DSK_DAT_8_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D8 *Controls write phase of data line 8 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D8		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D8		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D8)

/*SIF_TX_DSK_OFFSET_D8 *Offset of data line 8 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D8			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D8			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D8)

/******************************************************************************/
/* SIF_TX_DSK_DAT_9 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_9_OFFSET	SPI4_REG_OFFSET(0x0039)
#define ixf18100_SIF_TX_DSK_DAT_9_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D9 *Controls write phase of data line 9 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D9		0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D9		(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D9)

/*SIF_TX_DSK_OFFSET_D9 *Offset of data line 9 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D9			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D9			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D9)

/******************************************************************************/
/* SIF_TX_DSK_DAT_10 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_10_OFFSET	SPI4_REG_OFFSET(0x003A)
#define ixf18100_SIF_TX_DSK_DAT_10_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D10 *Controls write phase of data line 10 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D10	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D10	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D10)

/*SIF_TX_DSK_OFFSET_D10 *Offset of data line 10 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D10			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D10			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D10)

/******************************************************************************/
/* SIF_TX_DSK_DAT_11 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_11_OFFSET	SPI4_REG_OFFSET(0x003B)
#define ixf18100_SIF_TX_DSK_DAT_11_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D11 *Controls write phase of data line 11 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D11	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D11	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D11)

/*SIF_TX_DSK_OFFSET_D11 *Offset of data line 11 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D11			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D11			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D11)

/******************************************************************************/
/* SIF_TX_DSK_DAT_12 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_12_OFFSET	SPI4_REG_OFFSET(0x003C)
#define ixf18100_SIF_TX_DSK_DAT_12_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D12 *Controls write phase of data line 12 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D12	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D12	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D12)

/*SIF_TX_DSK_OFFSET_D12 *Offset of data line 12 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D12			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D12			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D12)

/******************************************************************************/
/* SIF_TX_DSK_DAT_13 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_13_OFFSET	SPI4_REG_OFFSET(0x003D)
#define ixf18100_SIF_TX_DSK_DAT_13_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D13 *Controls write phase of data line 13 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D13	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D13	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D13)

/*SIF_TX_DSK_OFFSET_D13 *Offset of data line 13 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D13			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D13			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D13)

/******************************************************************************/
/* SIF_TX_DSK_DAT_14 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_14_OFFSET	SPI4_REG_OFFSET(0x003E)
#define ixf18100_SIF_TX_DSK_DAT_14_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D14 *Controls write phase of data line 14 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D14	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D14	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D14)

/*SIF_TX_DSK_OFFSET_D14 *Offset of data line 14 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D14			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D14			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D14)

/******************************************************************************/
/* SIF_TX_DSK_DAT_15 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DAT_15_OFFSET	SPI4_REG_OFFSET(0x003F)
#define ixf18100_SIF_TX_DSK_DAT_15_DFLT		0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_D15 *Controls write phase of data line 15 */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_D15	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_D15	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_D15)

/*SIF_TX_DSK_OFFSET_D15 *Offset of data line 15 */
#define ixf18100_sSIF_TX_DSK_OFFSET_D15			5
#define ixf18100_mSIF_TX_DSK_OFFSET_D15			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_D15)

/******************************************************************************/
/* SIF_TX_DSK_CTL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_CTL_OFFSET	SPI4_REG_OFFSET(0x0040)
#define ixf18100_SIF_TX_DSK_CTL_DFLT	0x00A0

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_WRITE_PHASE_CTL *Controls write phase of Control line */
#define ixf18100_sSIF_TX_DSK_WRITE_PHASE_CTL	0
#define ixf18100_mSIF_TX_DSK_WRITE_PHASE_CTL	(0x1F << ixf18100_sSIF_TX_DSK_WRITE_PHASE_CTL)

/*SIF_TX_DSK_OFFSET_CTL *Offset of Control line */
#define ixf18100_sSIF_TX_DSK_OFFSET_CTL			5
#define ixf18100_mSIF_TX_DSK_OFFSET_CTL			(0x07 << ixf18100_sSIF_TX_DSK_OFFSET_CTL)

/******************************************************************************/
/* SIF_TX_DSK_DISABLE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_DSK_DISABLE_OFFSET	SPI4_REG_OFFSET(0x0041)
#define ixf18100_SIF_TX_DSK_DISABLE_DFLT	0x0000

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_DSK_DISABLE *Enables or disable deskew */
#define ixf18100_sSIF_TX_DSK_ENABLE		0

/*SIF_TX_BIT_REVERSE *Reverses the order of bits on the SPI-4 input */
#define ixf18100_sSIF_TX_BIT_REVERSE	1

/******************************************************************************/
/* SIF_TX_BIT_POLARITY Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SIF_TX_BIT_POLARITY_OFFSET	SPI4_REG_OFFSET(0x0042)
#define ixf18100_SIF_TX_BIT_POLARITY_DFLT	0x0000

/* -------- Bit, shift and mask defines.-------- */

/*SIF_TX_POLARITY *Inverts the polarity of SPI-4 Phase 2 input to Calypso */
#define ixf18100_sSIF_TX_POLARITY	0
#define ixf18100_mSIF_TX_POLARITY	(0xFFFF << ixf18100_sSIF_TX_POLARITY)
/******************************************************************************/

#endif /* SPI4BIT_DEFINES_H */

