/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_spi4_d.h $
 *   WORKFILE:       $Workfile: ixf18100_spi4_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: 
 *
 * Purpose: 
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_spi4_d.h $
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     7/08/02 1:37p Pkjain2
 * Moved Calypso specific data stuctures into Calypso block specific data
 * structure file.
 * 
 * --------------------------------------------------------------------------
 */

#ifndef __IXF18100_SPI4_D_H__
#define __IXF18100_SPI4_D_H__

typedef enum {

	e_DATA_LINE_0,
	e_DATA_LINE_1,
	e_DATA_LINE_2,
	e_DATA_LINE_3,
	e_DATA_LINE_4,
	e_DATA_LINE_5,
	e_DATA_LINE_6,
	e_DATA_LINE_7,
	e_DATA_LINE_8,
	e_DATA_LINE_9,
	e_DATA_LINE_10,
	e_DATA_LINE_11,
	e_DATA_LINE_12,
	e_DATA_LINE_13,
	e_DATA_LINE_14,
	e_DATA_LINE_15,
	e_CTRL_LINE,
	e_ALL_LINES
}ixf18100_Spi4TxDeskew_e;

typedef struct {

	ushort		uiSIFUpperThresholdForMacPause;

	ushort		uiSIFLowerThresholdForMacPause;

} ixf18100_Spi4GlbCfg_t;

typedef struct {

	ushort		uiSIFRxMaxBurst1;

	ushort		uiSIFRxMaxBurst2;

	uchar		ucSIFRxTrainPatternRepeats;

	ulong		ulSIFRxMaxTrainInterval;

	uchar		ucSIFRxSpi4Address;
	uchar		ucSIFRxReverseBit;
	uchar		ucSIFRxErasePktOnParallelBusErr;
	uchar		ucSIFRxPreventSpi4Err;
	uchar		ucSIFIgnoreParityOnDip2Input;
	uchar		ucSIFRxNumTrainingPatternRepeats;
	uchar		ucSIFRxFifoInvClkEn;

	uchar		ucSIFRxBurstLen;

	ushort		uiSIFRxBitWisePolarity;

} ixf18100_Spi4RxCfg_t;

typedef struct {

	ushort		uiSIFTxMaxBurst1;

	ushort		uiSIFTxMaxBurst2;

	uchar		ucSIFTxReqDip4PassToGainLock;
	uchar		ucSIFTxReqDip4FailToLoseLock;

	uchar		ucSIFDip4ModeEn;
	uchar		ucSIFTxTestFifoStatus;
	uchar		ucSIFTxFifoStatusChnEn;
	uchar		ucSIFTxErasePktOnParityErr;
	uchar		ucSIFTxErasePktOnSpi4Err;
	uchar		ucSIFTxPreventParallelBusErr;
	uchar		ucSIFTxAddHoldTimeModeEn;
	uchar		ucSIFTxNumTrainingPatternRepeats;

	uchar		ucSIFTxDeskewEnable;
	uchar		ucSIFTxBitReverseEn;

	ushort		uiSIFTxBitWisePolarity;

} ixf18100_Spi4TxCfg_t;

typedef struct {

	uchar		ucSIFTxDeskewWritePhase[17];
	uchar		ucSIFTxDeskewOffset[17];
} ixf18100_Spi4TxDskCfg_t;


typedef struct {

	ixf18100_Spi4GlbCfg_t		Spi4GlbCfg;
	ixf18100_Spi4RxCfg_t		Spi4RxCfg;
	ixf18100_Spi4TxCfg_t		Spi4TxCfg;
	ixf18100_Spi4TxDskCfg_t	Spi4TxDskCfg;
} ixf18100_Spi4Cfg_t;

typedef struct {

	uchar		ucFifoStatChnRcvdMsg;
	uchar		ucTxTrainDetected;
	uchar		ucTxDeskewLockEn;
	ushort		uiTxFifoStatus;
} ixf18100_Spi4Status_t;

#endif /* __IXF18100_SPI4_D_H__ */

