/*---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:56p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf_api_error_d.h $
 *   WORKFILE:       $Workfile: ixf_api_error_d.h $
 *
 * --------------------------------------------------------------------------
 * Project: IXF API
 *
 * Purpose: IXF API error code definitions
 *          
 * Notes:
 *          
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 *   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf_api_error_d.h $
 * 
 * 1     3/08/04 1:56p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 1     4/18/03 4:22p Jaalliso
 * Created
 * 
 * --------------------------------------------------------------------------
 */

#ifndef IXF_API_ERROR_D_H
#define IXF_API_ERROR_D_H

/*****************************************************************************/
/* Error code definitions.  NOTE - New error codes are added at the end of   */
/* this table (and end of table marker is incremented by one                 */
/*****************************************************************************/
#define bb_NO_ERROR                             0x0000                            
#define bb_FATAL_ERROR                          0x0001                         
#define bb_GENERAL_ERROR                        0x0002                       
#define bb_NULL_ADDRESS_ASSIGNED                0x0003               
#define bb_INSUFFICIENT_MEMORY                  0x0004                 
#define bb_NO_CHIP_DATA                         0x0005                        
#define bb_NULL_BASE_ADDR                       0x0006            
#define bb_INV_BASE_ADDR                        0x0007            
#define bb_INV_CHIP_TYPE                        0x0008            
#define bb_NO_CHIP_CFG                          0x0009            
#define bb_NO_ALARM_CFG                         0x000A            
#define bb_UNDEF_ALARM_BITS                     0x000B            
#define bb_STM_MODE_MISMATCH                    0x000C            
#define bb_INV_SEL_OH_BYTE                      0x000D            
#define bb_INV_SEL_OH_BYTES                     0x000E            
#define bb_INV_SEL_COUNTERS                     0x000F            
#define bb_INV_CHAN_TEST                        0x0010            
#define bb_INV_PARAMETER                        0x0011            
#define bb_INV_CHIP_SEGMENT                     0x0012            
#define bb_NULL_ARG                             0x0013            
#define bb_INV_BLOCK_OPERATION                  0x0014            
#define bb_FN_NOT_SUPPORTED                     0x0015            
#define bb_INV_CHANNEL                          0x0016            
#define bb_INV_FLOW                             0x0017            
#define bb_JN_TRACE_WRITE_FAIL                  0x0018            
#define bb_INV_EXP_JN_FMT                       0x0019            
#define bb_TX_J1_FOR_RPTR                       0x001A            
#define bb_POH_PASSTHRU                         0x001B            
#define bb_OHT_NOT_IN_TEST                      0x001C            
#define bb_TX_J0_NOT_CPU                        0x001D            
#define bb_INV_EXP_J1_FMT                       0x001E            
#define bb_INV_TX_J1_FMT                        0x001F            
#define bb_NO_OHT_NU_CFG                        0x0020            
#define bb_NOT_PROTECTING_MAIN                  0x0021            
#define bb_NOT_TERM_ADM                         0x0022            
#define bb_INV_BKUP_OHT                         0x0023            
#define bb_INV_SEL_OHT_CFG                      0x0024            
#define bb_TRACE_ACCESS_FAIL                    0x0025            
#define bb_INV_TRACE_FORMAT                     0x0026            
#define bb_INV_TRACE_TYPE                       0x0027            
#define bb_INV_PORT_NUM                         0x0028            
#define bb_NO_MPR_CFG                           0x0029            
#define bb_INV_ALM_SPEC                         0x002A            
#define bb_NO_ADM_CFG                           0x002B            
#define bb_NOT_ADM                              0x002C            
#define bb_INV_TIMESLOT                         0x002D            
#define bb_GET_J2_TYP_ERR                       0x002E            
#define bb_SET_J2_TYP_ERR                       0x002F            
#define bb_SET_J2_LEN_ERR                       0x0030            
#define bb_PORT_NOT_N2_ENBLD                    0x0031            
#define bb_INV_SIG_LBL                          0x0032            
#define bb_INV_SEL_AUTO_FDBK                    0x0033            
#define bb_INV_TEST_CNFG                        0x0034            
#define bb_NO_CHIP_LEVEL_CFG                    0x0035            
#define bb_INV_RESET_TYPE                       0x0036            
#define bb_INV_SEL_STATUS_TYPE                  0x0037            
#define bb_INV_SEL_CFG_TYPE                     0x0038            
#define bb_INVALID_NUM_CHAN_CFG                 0x0039            
#define bb_INVALID_CHAN_CFG                     0x003A            
#define bb_INV_UTOPIA_INTERFACE_USED            0x003B            
#define bb_INV_UTOPIA_MULTI_PHY_USED            0x003C
#define bb_INV_ORDERWIRE_PULSE_BYTE_LOCN_USED   0x003D
#define bb_INV_UNUSED_UTOPIA_PINS_IMP_USED      0x003E
#define bb_INV_POS_UTOPIA_INTERFACE_USED        0x003F
#define bb_INV_POS_FA_STATUS_USED               0x0040
#define bb_INV_POS_RX_VAL_DEASSERT_AT_EOP_USED  0x0041
#define bb_INV_POS_RX_FA_DEASSERT_ON_LOW_USED   0x0042
#define bb_INV_CHANEL_MODE_USED                 0x0043
#define bb_INV_CHAN_IF_CFG_USED                 0x0044
#define bb_INV_SONET_SDH_CHAN_CFG_USED          0x0045
#define bb_INV_ATM_CHAN_CFG_USED                0x0046
#define bb_INV_POS_CHAN_CFG_USED                0x0047
#define bb_INV_LINE_SPEED_USED                  0x0048
#define bb_LOOPBACK_MODE_RX_TX_MISMATCH         0x0049
#define bb_INV_MAPSLOT_SELECTION                0x004A
#define bb_INV_INITIAL_DATA                     0x004B
#define bb_ALARMS_NOT_USED                      0x004C
#define bb_INV_CHIP_SECTION                     0x004D
#define bb_WORD_SIZE_UNSUPPORTED                0x004E
#define bb_INV_POINTER                          0x004F
#define bb_SIF_FPGA_TPMISMATCH                  0x0050
#define bb_INV_PATH_SELECTION                   0x0051
#define bb_FIRST_J0_BYTE_NOTFOUND               0x0052
#define bb_INV_GROUP                            0x0053
#define bb_INV_GROUP_TYPE                       0x0054
#define bb_INV_PAYLOAD_TYPE                     0x0055
#define bb_INV_MEMBER                           0x0056
#define bb_VC_CFG_ERROR                         0x0057
/**************************************************************/
/* Add new error codes above here and increment MAX_ERRORCODE */
/**************************************************************/
#define bb_MAX_ERRORCODE                        0x0058


#ifdef INCLUDE_IXF_ERROR_TABLE

/* IXF API error table element structure definition */
typedef struct
{
    ushort ErrCode;     /* Error Code */
    char *ShortStr;     /* Short version of error string (label from #define) */
    char *LongStr;      /* Optional long version of error string */

} IxfErrorTableElement;

/* IXF Api error lookup table */
static const IxfErrorTableElement IxfErrorTable[bb_MAX_ERRORCODE + 1] =
{
    {bb_NO_ERROR,                               "bb_NO_ERROR",                              ""},
    {bb_FATAL_ERROR,                            "bb_FATAL_ERROR",                           ""},
    {bb_GENERAL_ERROR,                          "bb_GENERAL_ERROR",                         ""},
    {bb_NULL_ADDRESS_ASSIGNED,                  "bb_NULL_ADDRESS_ASSIGNED",                 ""},
    {bb_INSUFFICIENT_MEMORY,                    "bb_INSUFFICIENT_MEMORY",                   "Memory allocation (malloc) failed"},
    {bb_NO_CHIP_DATA,                           "bb_NO_CHIP_DATA",                          ""},
    {bb_NULL_BASE_ADDR,                         "bb_NULL_BASE_ADDR",                        ""},
    {bb_INV_BASE_ADDR,                          "bb_INV_BASE_ADDR",                         "Invalid base address"},
    {bb_INV_CHIP_TYPE,                          "bb_INV_CHIP_TYPE",                         "Invalid chip type"},
    {bb_NO_CHIP_CFG,                            "bb_NO_CHIP_CFG",                           "No Chip configuration"},
    {bb_NO_ALARM_CFG,                           "bb_NO_ALARM_CFG",                          "No Alarm configuration"},
    {bb_UNDEF_ALARM_BITS,                       "bb_UNDEF_ALARM_BITS",                      "Undefined alarm bits"},
    {bb_STM_MODE_MISMATCH,                      "bb_STM_MODE_MISMATCH",                     ""},
    {bb_INV_SEL_OH_BYTE,                        "bb_INV_SEL_OH_BYTE",                       ""},
    {bb_INV_SEL_OH_BYTES,                       "bb_INV_SEL_OH_BYTES",                      ""},
    {bb_INV_SEL_COUNTERS,                       "bb_INV_SEL_COUNTERS",                      ""},
    {bb_INV_CHAN_TEST,                          "bb_INV_CHAN_TEST",                         ""},
    {bb_INV_PARAMETER,                          "bb_INV_PARAMETER",                         "Invalid parameter"},
    {bb_INV_CHIP_SEGMENT,                       "bb_INV_CHIP_SEGMENT",                      "Invalid chip segment"},
    {bb_NULL_ARG,                               "bb_NULL_ARG",                              "Null argument"},
    {bb_INV_BLOCK_OPERATION,                    "bb_INV_BLOCK_OPERATION",                   "Invalid block operation"},
    {bb_FN_NOT_SUPPORTED,                       "bb_FN_NOT_SUPPORTED",                      "Function not supported"},
    {bb_INV_CHANNEL,                            "bb_INV_CHANNEL",                           "Invalid channel number"},
    {bb_INV_FLOW,                               "bb_INV_FLOW",                              "Invalid segment block.flow"},
    {bb_JN_TRACE_WRITE_FAIL,                    "bb_JN_TRACE_WRITE_FAIL",                   ""},
    {bb_INV_EXP_JN_FMT,                         "bb_INV_EXP_JN_FMT",                        ""},
    {bb_TX_J1_FOR_RPTR,                         "bb_TX_J1_FOR_RPTR",                        ""},
    {bb_POH_PASSTHRU,                           "bb_POH_PASSTHRU",                          ""},
    {bb_OHT_NOT_IN_TEST,                        "bb_OHT_NOT_IN_TEST",                       ""},
    {bb_TX_J0_NOT_CPU,                          "bb_TX_J0_NOT_CPU",                         ""},
    {bb_INV_EXP_J1_FMT,                         "bb_INV_EXP_J1_FMT",                        "Invalid expected J1 format"},
    {bb_INV_TX_J1_FMT,                          "bb_INV_TX_J1_FMT",                         "Invalid tx J1 format"},
    {bb_NO_OHT_NU_CFG,                          "bb_NO_OHT_NU_CFG",                         ""},
    {bb_NOT_PROTECTING_MAIN,                    "bb_NOT_PROTECTING_MAIN",                   ""},
    {bb_NOT_TERM_ADM,                           "bb_NOT_TERM_ADM",                          ""},
    {bb_INV_BKUP_OHT,                           "bb_INV_BKUP_OHT",                          ""},
    {bb_INV_SEL_OHT_CFG,                        "bb_INV_SEL_OHT_CFG",                       ""},
    {bb_TRACE_ACCESS_FAIL,                      "bb_TRACE_ACCESS_FAIL",                     ""},
    {bb_INV_TRACE_FORMAT,                       "bb_INV_TRACE_FORMAT",                      "Invalid trace format"},
    {bb_INV_TRACE_TYPE,                         "bb_INV_TRACE_TYPE",                        "Invalid trace type"},
    {bb_INV_PORT_NUM,                           "bb_INV_PORT_NUM",                          "Invalid port number"},
    {bb_NO_MPR_CFG,                             "bb_NO_MPR_CFG",                            "No mapper configuration"},
    {bb_INV_ALM_SPEC,                           "bb_INV_ALM_SPEC",                          ""},
    {bb_NO_ADM_CFG,                             "bb_NO_ADM_CFG",                            ""},
    {bb_NOT_ADM,                                "bb_NOT_ADM",                               ""},
    {bb_INV_TIMESLOT,                           "bb_INV_TIMESLOT",                          "Invalid timeslot"},
    {bb_GET_J2_TYP_ERR,                         "bb_GET_J2_TYP_ERR",                        ""},
    {bb_SET_J2_TYP_ERR,                         "bb_SET_J2_TYP_ERR",                        ""}, 
    {bb_SET_J2_LEN_ERR,                         "bb_SET_J2_LEN_ERR",                        ""},
    {bb_PORT_NOT_N2_ENBLD,                      "bb_PORT_NOT_N2_ENBLD",                     ""},
    {bb_INV_SIG_LBL,                            "bb_INV_SIG_LBL",                           ""},
    {bb_INV_SEL_AUTO_FDBK,                      "bb_INV_SEL_AUTO_FDBK",                     ""},
    {bb_INV_TEST_CNFG,                          "bb_INV_TEST_CNFG",                         "Invalid test configuration"},
    {bb_NO_CHIP_LEVEL_CFG,                      "bb_NO_CHIP_LEVEL_CFG",                     "No chip level configuration"},
    {bb_INV_RESET_TYPE,                         "bb_INV_RESET_TYPE",                        "Invalid reset type"},
    {bb_INV_SEL_STATUS_TYPE,                    "bb_INV_SEL_STATUS_TYPE",                   "Invalid selstatus type"},
    {bb_INV_SEL_CFG_TYPE,                       "bb_INV_SEL_CFG_TYPE",                      "Invalid selcfg type"},
    {bb_INVALID_NUM_CHAN_CFG,                   "bb_INVALID_NUM_CHAN_CFG",                  ""},
    {bb_INVALID_CHAN_CFG,                       "bb_INVALID_CHAN_CFG",                      "Invalid channel configuration"},
    {bb_INV_UTOPIA_INTERFACE_USED,              "bb_INV_UTOPIA_INTERFACE_USED",             ""},
    {bb_INV_UTOPIA_MULTI_PHY_USED,              "bb_INV_UTOPIA_MULTI_PHY_USED",             ""},
    {bb_INV_ORDERWIRE_PULSE_BYTE_LOCN_USED,     "bb_INV_ORDERWIRE_PULSE_BYTE_LOCN_USED",    ""},
    {bb_INV_UNUSED_UTOPIA_PINS_IMP_USED,        "bb_INV_UNUSED_UTOPIA_PINS_IMP_USED",       ""},
    {bb_INV_POS_UTOPIA_INTERFACE_USED,          "bb_INV_POS_UTOPIA_INTERFACE_USED",         ""},
    {bb_INV_POS_FA_STATUS_USED,                 "bb_INV_POS_FA_STATUS_USED",                ""},
    {bb_INV_POS_RX_VAL_DEASSERT_AT_EOP_USED,    "bb_INV_POS_RX_VAL_DEASSERT_AT_EOP_USED",   ""},
    {bb_INV_POS_RX_FA_DEASSERT_ON_LOW_USED,     "bb_INV_POS_RX_FA_DEASSERT_ON_LOW_USED",    ""},
    {bb_INV_CHANEL_MODE_USED,                   "bb_INV_CHANEL_MODE_USED",                  "Invalid channel mode"},
    {bb_INV_CHAN_IF_CFG_USED,                   "bb_INV_CHAN_IF_CFG_USED",                  ""},
    {bb_INV_SONET_SDH_CHAN_CFG_USED,            "bb_INV_SONET_SDH_CHAN_CFG_USED",           ""},
    {bb_INV_ATM_CHAN_CFG_USED,                  "bb_INV_ATM_CHAN_CFG_USED",                 "Invalid ATM channel configuration"},
    {bb_INV_POS_CHAN_CFG_USED,                  "bb_INV_POS_CHAN_CFG_USED",                 "Invalid POS channel configuration"},
    {bb_INV_LINE_SPEED_USED,                    "bb_INV_LINE_SPEED_USED",                   "Invalid line speed"},
    {bb_LOOPBACK_MODE_RX_TX_MISMATCH,           "bb_LOOPBACK_MODE_RX_TX_MISMATCH",          "Loopback Rx/Tx mismatch"},
    {bb_INV_MAPSLOT_SELECTION,                  "bb_INV_MAPSLOT_SELECTION",                 ""},
    {bb_INV_INITIAL_DATA,                       "bb_INV_INITIAL_DATA",                      ""},
    {bb_ALARMS_NOT_USED,                        "bb_ALARMS_NOT_USED",                       "Alarms not used"},
    {bb_INV_CHIP_SECTION,                       "bb_INV_CHIP_SECTION",                      "Invalid chip section"},
    {bb_WORD_SIZE_UNSUPPORTED,                  "bb_WORD_SIZE_UNSUPPORTED",                 ""},
    {bb_INV_POINTER,                            "bb_INV_POINTER",                           "Invalid pointer"},
    {bb_SIF_FPGA_TPMISMATCH,                    "bb_SIF_FPGA_TPMISMATCH",                   "SIF FPGA test pattern mismatch"},
    {bb_INV_PATH_SELECTION,                     "bb_INV_PATH_SELECTION",                    "Invalid path selection"},
    {bb_FIRST_J0_BYTE_NOTFOUND,                 "bb_FIRST_J0_BYTE_NOTFOUND",                ""},
    {bb_INV_GROUP,                              "bb_INV_GROUP",                             "Invalid group"},
    {bb_INV_GROUP_TYPE,                         "bb_INV_GROUP_TYPE",                        "Invalid group type"},
    {bb_INV_PAYLOAD_TYPE,                       "bb_INV_PAYLOAD_TYPE",                      "Invalid payload type"},
    {bb_INV_MEMBER,                             "bb_INV_MEMBER",                            "Invalid member"},
    {bb_VC_CFG_ERROR,                           "bb_VC_CFG_ERROR",                          "VC configuration structure error"},
    /* This markes the end of the table.  All additions to be made above here */
    {bb_MAX_ERRORCODE,                          "",                                         ""}
};

#endif  /* INCLUDE_IXF_ERROR_TABLE */


#endif /* #ifndef IXF_API_ERROR_D_H */
