/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/08/04 1:56p $
*   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf_api_ether.h $
*   WORKFILE:       $Workfile: ixf_api_ether.h $
*
* --------------------------------------------------------------------------
* Project: IXF API
*
* Purpose: XGMAC portion of the IXF API
*          
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf_api_ether.h $
 * 
 * 1     3/08/04 1:56p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 4     4/25/03 6:12p Pkjain2
 * Merged Celestica Release 2.0
* 
* 1     10/21/02 1:57p Snunes
* IxfApi Baseline for ixf30009 Development (Intel v1.6 Release)
*
* --------------------------------------------------------------------------
*/


#ifndef __IXF_API_ETHER_H__
#define __IXF_API_ETHER_H__

/******************************************************************
* Function : IxfApiGetMacAddress
*-----------------------------------------------------------------
* Description  : 
*-----------------------------------------------------------------
* Inputs  : 
* Outputs : 
*-----------------------------------------------------------------
* Returns : 
*-----------------------------------------------------------------
* Access Globals : 
*-----------------------------------------------------------------
* Comments : 
******************************************************************/

/* The types below define the XGMAC prototypes */
extern bb_Error_e
IxfApiGetMacAddress(bb_ChipData_t* pChipData,
                    bb_ChipSegment_t *section,
                    IxfApi_MacAddress_t *address);



/******************************************************************
* Function : IxfApiSetMacAddress
*-----------------------------------------------------------------
* Description  : 
*-----------------------------------------------------------------
* Inputs  : pChipData : Initialized Chip Data
*           section   : Determines the section(block) to set the
*  						window size.
*           mode      : The clearing/setting mode.
*           
* Outputs : None.
*-----------------------------------------------------------------
* Returns : Status
*-----------------------------------------------------------------
* Access Globals : None.
*-----------------------------------------------------------------
* Comments : None.
******************************************************************/
extern bb_Error_e
IxfApiSetMacAddress(bb_ChipData_t* pChipData,
                    bb_ChipSegment_t  *section,
                    IxfApi_MacAddress_t *address);

#endif

