/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001-2004 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/08/04 1:56p $
*   LAST MODIFIED:  $Modtime: 3/05/04 3:16p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/linux_int.c $
*   WORKFILE:       $Workfile: linux_int.c $
*
* --------------------------------------------------------------------------
* Project: ixf18101/3 
*
* Notes:
*          
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/linux_int.c $
 * 
 * 1     3/08/04 1:56p Tepulkow
*/
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/interrupt.h>
#include <linux/init.h>
#include <asm/system.h>
#include <asm/types.h>
#include <asm/irq.h>
#include <asm/hardware.h>
#include <asm/io.h>

#include "common_def.h"
#include "devlib.h"
#include "ixf_api.h"
#include "ixf_api_d.h"

typedef struct _chip_desc
{
	bb_ChipData_t *chipdata;
	int	irq;
} chip_desc_t;

static chip_desc_t chipDesc;

static void __ISR(int irq, void *dev_id, struct pt_regs *reg)
{
	printk("Got interrupt\n");
	*IXP2000_INTCTL_REG(0x54) = 0;
//	IxfApiChipIsr(chipDesc.chipdata);

}
void IxfRegisterInterrupt(unsigned int irq, void *chipData, void (*handler)(bb_ChipData_t *))
{
	int err;
	chipDesc.chipdata = chipData;

	err = request_irq(irq, __ISR, SA_INTERRUPT, "IXF Device", (void *)&chipDesc);

	chipDesc.irq = irq;
	if (err < 0)
		printk(KERN_ERR "IXF: unable to request IRQ %d for IXF: %d\n",irq, err);
}

void IxfDeleteISRChipData(bb_ChipData_t *chipData)
{
	free_irq(chipDesc.irq,&chipDesc);
}
