/*
*---------------------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*---------------------------------------------------------------------------
*
*
*   AUTHOR:         $Author: Tepulkow $
*   DATE:           $Date: 3/08/04 1:56p $
*   LAST MODIFIED:  $Modtime: 3/05/04 3:10p $
*   REV#:           $Revision: 1 $
*   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/test18101.c $
*   WORKFILE:       $Workfile: test18101.c $
*
* --------------------------------------------------------------------------
* Project: IXF API
*
* Purpose: Provides a simple driver to drive the driver :)
*			
* Notes:
*			
* --------------------------------------------------------------------------
* CompilerFlags: 
* --------------------------------------------------------------------------
* --------------------------------------------------------------------------
*   $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/test18101.c $
 * 
 * 1     3/08/04 1:56p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
*   Revision 1.9  2002/10/28 20:53:39  machambe
*   no message
*
*   Revision 1.8  2002/10/28 20:33:28  machambe
*   no message
*
*   Revision 1.7  2002/10/28 19:58:14  machambe
*   no message
*
*   Revision 1.6  2002/10/28 13:58:57  machambe
*   no message
*
*   Revision 1.5  2002/10/27 18:20:44  machambe
*   no message
*
*   Revision 1.4  2002/10/26 00:40:05  machambe
*   no message
*
*   Revision 1.3  2002/10/25 20:24:49  machambe
*   no message
*
*   Revision 1.2  2002/10/14 09:41:04  machambe
*   no message
*
*   Revision 1.1  2002/10/05 00:08:39  machambe
*   no message
*
*   Revision 1.3  2002/07/22 23:23:28  machambe
*   no message
*
*   Revision 1.2  2002/07/21 03:19:41  machambe
*   no message
*
 * 
 * 27    5/17/02 1:54p Machambe
 * 
 * 26    5/02/02 4:47p Srodrig1
 * Added Generic Lib.
 * 
 * 25    5/01/02 4:37p Machambe
* 
* 24    1/29/02 1:22p Machambe
* Modified test driver to support multiple chip testing
* 
* 23    1/07/02 9:46a Machambe
* 
* 22    12/04/01 4:23p Pkjain2
* 
* 21    12/01/01 6:35p Machambe
* 
* 20    11/15/01 6:41p Machambe
* 
* 19    11/15/01 10:03a Machambe
* Changing bb_util.h to ixf_api_d.h
* 
* 18    8/15/01 4:46p Machambe
* 
* 17    7/26/01 3:22p Machambe
* 
* 16    6/25/01 10:53a Machambe
* 
* 15    5/30/01 9:56a Rsood
* 
* 14    5/03/01 3:54p Machambe
* 
* --------------------------------------------------------------------------
*/
#include <linux/kernel.h>
#include <linux/module.h>
#include <asm/io.h>
#include <asm/hardware.h>
#include <asm/irq.h>
#include "common_types.h"
#include "common_def.h"
#include "ixf_api_d.h" /* BroadBand Utility Definitions and Function headers */
#include "ixf_api_sonet_d.h"
#include "ixf_api.h"
#include "ixf_api_sonet.h"
#include "bld18100.h"
#include "ixf18100_global_b.h"
#include "hal.h"

typedef void       (*ISRFuncPtr_t)(void *pChipData);

extern void IxfRegisterInterrupt();
extern void IxfDeleteISRChipData();

InitRegTable_t RegInitIXF18101Table[] =
{
	{ (bb_RegPointer_type) 0x0003, 0x000f},	/* global reset */
	{ (bb_RegPointer_type) 0x0000, 0x0002},	/* global cfg1 */
	{ (bb_RegPointer_type) 0x0006, 0xa000},	/* global clk cfg1 */
//	{ (bb_RegPointer_type) 0x0008, 0x0003},	/* global clk cfg2 */
	{ (bb_RegPointer_type) 0x000A, 0x0004},	/* global line */
//	{ (bb_RegPointer_type) 0x0010, 0x0001},	/* global spi-4 */
	{ (bb_RegPointer_type) 0x0003, 0x0000}, /* global reset */
//	{ (bb_RegPointer_type) 0x300c, 0x00ff},	/* spi-4 int enable */
//	{ (bb_RegPointer_type) 0x300d, 0x0000},	/* spi-4 test */
//	{ (bb_RegPointer_type) 0x300e, 0x000a},	/* spi-4 mac upper threshold */
//	{ (bb_RegPointer_type) 0x300f, 0x0400},	/* spi-4 mac lower treashold */
//	{ (bb_RegPointer_type) 0x3100, 0x7ffb}, /* xgmac ctl1 */
//	{ (bb_RegPointer_type) 0x3101, 0x3804},	/* "" */
//	{ (bb_RegPointer_type) 0x3200, 0x2840},	/* pcs ctl1 */
//	{ (bb_RegPointer_type) 0x3207, 0x0002},	/* pcs 10G ctl2 */
//	{ (bb_RegPointer_type) 0x3231, 0x000d},	/* pcs ixf18101 misc ctl */
//	{ (bb_RegPointer_type) 0x3233, 0x0120},	/* pcs ixf18101 rx fifo ctl */
//	{ (bb_RegPointer_type) 0x3234, 0x503c},	/* pcs ixf18101 tx fifo ctl */
//	{ (bb_RegPointer_type) 0x3200, 0x2040},	/* pcs ctl1 */
//	{ (bb_RegPointer_type) 0x1840, 0x0000}, /* tx line POH */
//	{ (bb_RegPointer_type) 0x1841, 0x0003}, /* "" */
//	{ (bb_RegPointer_type) 0x1842, 0x0002}, /* "" */
//	{ (bb_RegPointer_type) 0x1843, 0x0002}, /* "" */
//	{ (bb_RegPointer_type) 0x1821, 0x0000}, /* tx line POH ctl */
//	{ (bb_RegPointer_type) 0x1882, 0x0000}, /* tx line src cfg1 TOH */
//	{ (bb_RegPointer_type) 0x11c1, 0x0000}, /* rx line rx POH cfg2 */
//	{ (bb_RegPointer_type) 0x3302, 0x7fff}, /* ? */
	{ (bb_RegPointer_type) 0x3300, 0x047d}, /* pos rx cfg */
	{ (bb_RegPointer_type) 0x3330, 0x004d}, /* pos tx cfg */
	{ (bb_RegPointer_type) 0x11c1, 0x0001}, /* rx line rx POH cfg2 */
	{ (bb_RegPointer_type) 0x1821, 0x0000}, /* tx line POH ctl */
	{ (bb_RegPointer_type) 0x1841, 0x0003}, /* tx line POH */
	{ (bb_RegPointer_type) 0x1842, 0x0002}, /* tx line POH */
	{ (bb_RegPointer_type) 0x1843, 0x0002}, /* tx line POH */
	{ (bb_RegPointer_type) 0x1832, 0x0001}, /* c2 byte value */
	{ (bb_RegPointer_type) 0x1833, 0x0000}, /* g1 byte value */
	{ (bb_RegPointer_type) 0x1882, 0x0000}, /* g1 byte value */
	{ (bb_RegPointer_type) 0xffff, 0xa5a5}	/* end marker */
};

void TestAlarmCallback (ushort *BaseAddress, void *AlarmType,
		void *pAlarmStatus)
{
	printk("Got to alarm callback function.\n");
	/* clear the SOFT_INT that got us here */
	*IXP2000_INTCTL_REG(0x54) = 0;
}

void TestIxfApiMain (void)
{

    ulong  sz=0;
    ulong  set_sz=0;
    bb_ChipData_t chipData;
    char string64[] = "Expected J0 String that is longer than 64 bytes in length and should be truncated ";
    bb_RegPointer_type pReg;
    bb_ChipInfo_t         ChipInfo;
    uchar                      J0String[64];
    ushort usTest1;
    ushort usTest2;
    bb_ChipSegment_t section;
    ushort len;
    int i;
    bb_Error_e ixfStatus;
    char dataBuf[64];
    char myArray[512];
#ifdef INTERRUPT_SYSTEM_MODE
    ushort regVal;
#endif
    char *baseAddr;

    /* Setup a generic section parameter */
    section.block.block = 0;
    section.block.side = 0;
    section.block.flow = 0;
    section.group.channel = 0;
    section.indirect.slot = 0;
    section.value = 0;


    /***************/
    /* Test Case 1 */
    /***************/

    baseAddr = (char *)ioremap_nocache(0xc6000000,0x00800000);
    /* Test IxfApiInit */
    ixfStatus = IxfApiInit((bb_RegPointer_type)baseAddr , bb_18101_CHIP, &chipData);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIINIT TEST                     : PASSED\n");
    }
    else
    {
        printk("IXFAPIINIT TEST                     : FAILED\n");
    }

    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiAllocDataStructureMem(&chipData);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIALLOCDATASTRUCTMEM TEST       : PASSED\n");
    }
    else
    {
        printk("IXFAPIALLOCDATASTRUCTMEM TEST       : FAILED\n");
    }

    /* Test Alloc Data Structure Memory */
    ixfStatus = IxfApiDeAllocMemory(&chipData);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIDEALLOCMEMORY TEST            : PASSED\n");
    }
    else
    {
        printk("IXFAPIDEALLOCMEMORY TEST            : FAILED\n");
    }
    /* Test IxfApiInitChip */
    ixfStatus = IxfApiInitChip(&chipData, RegInitIXF18101Table);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIINITCHIP TEST                 : PASSED\n");
    }
    else
    {
        printk("IXFAPIINITCHIP TEST                 : FAILED\n");
    }
    /***************/
    /* Test Case 2 */
    /***************/

    /* Get h/w info for chip  */
    ixfStatus = IxfApiGetChipInfo(&chipData, &ChipInfo);

    if (ixfStatus == bb_NO_ERROR)
    {
        if ((ChipInfo.ChipId == 0x46b5) && (ChipInfo.ChipVersion == 0))
            printk("IXFAPIGETCHIPINFO TEST              : PASSED\n");
        else {
            printk("IXFAPIGETCHIPINFO TEST              : FAILED\n");
	    printk("Read ChipId: 0x%x, ChipVersion: 0x%x\n",ChipInfo.ChipId,ChipInfo.ChipVersion);
	    }
    }
    else
    {
        printk("IXFAPIGETCHIPINFO TEST              : FAILED\n");
    }



    /* Get Build Version */
    ixfStatus = IxfApiGetBuildVersion(&chipData, bb_SW_VERSION_CHIP_TYPE, dataBuf, myArray, &usTest1, &usTest2);

    if (ixfStatus == bb_NO_ERROR)
    {
        if (!(strcmp(dataBuf,IXF18100_BUILD_DRIVER_NAME)))
        {
            printk("IXFAPIGETBUILDVERSION TEST          : PASSED\n");
        }
	else
	{
	    printk("IXFAPIGETBUILDVERSION TEST FAILED: %s\n",dataBuf);
	}
    }
    else
    {
        printk("IXFAPIGETBUILDVERSION TEST          : FAILED\n");
    }
    /***************/
    /* Test Case 3 */
    /***************/
    /* Set WindowSize */
    set_sz = 0x12345678;
    ixfStatus = IxfApiSetWindowSize(&chipData, &section, CLEARING, set_sz);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPISETWINDOWSIZE TEST            : PASSED\n");
    }
    else
    {
        printk("IXFAPISETWINDOWSIZE TEST            : FAILED\n");
    }

    /* Get WindowSize */
    ixfStatus = IxfApiGetWindowSize(&chipData, &section, CLEARING, &sz);

    if (ixfStatus == bb_NO_ERROR)
    {
        if (sz == 0xACE)
        {
            printk("IXFAPIGETWINDOWSIZE TEST            : PASSED\n");
        }
        else
        {
            printk("IXFAPIGETWINDOWSIZE TEST            : FAILED: 0x%x\n",sz);
        }
    }
    else
    {
        printk("IXFAPIGETWINDOWSIZE TEST            : FAILED\n");
    }
    /***************/
    /* Test Case 4 */
    /***************/
    /* Test Generic Write */
    dataBuf[0] = 0xA;
    dataBuf[1] = 0xB;
    ixfStatus = IxfApiGenericWrite(&chipData, 2, 0x8, 1, dataBuf);

    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test Generic Read */
        memset(dataBuf,0,64);

        ixfStatus = IxfApiGenericRead(&chipData, 2, 0x8, 1, dataBuf);
        if ((dataBuf[0] == 0xA) && (dataBuf[1] == 0xB))
        {
            printk("IXFAPIGENERICREAD  TEST             : PASSED\n");
            printk("IXFAPIGENERICWRITE TEST             : PASSED\n");
        }
        else
        {
            printk("IXFAPIGENERICREAD TEST              : FAILED\n");
            printk("IXFAPIGENERICWRITE TEST             : FAILED\n");
        }
    }
    else
    {
        printk("IXFAPIGENERICWRITE TEST              : FAILED\n");
    }

    /***************/
    /* Test Case 5 */
    /***************/
    /* Set Overhead Bytes*/
    section.group.channel = 0;
    ixfStatus = IxfApiSetOhByte(&chipData, &section, bb_EXPECTED_C2, 0x13);

    if (ixfStatus == bb_NO_ERROR)
    {
        /* Get Overhead Bytes*/
        section.group.channel = 0;
        ixfStatus = IxfApiGetOhBytes(&chipData, &section, bb_EXPECTED_C2, myArray);
        if (*((uchar *) myArray) == 0x13)
        {
            printk("IXFAPIGETOHBYTE TEST                : PASSED\n");
            printk("IXFAPISETOHBYTE TEST                : PASSED\n");
        }
        else
        {
            printk("IXFAPIGETOHBYTE TEST                : FAILED\n");
            printk("IXFAPISETOHBYTE TEST                : FAILED\n");
        }
    }
    else
    {
        printk("IXFAPIGETOHBYTE TEST                : FAILED\n");
    }

#if 0
    /***************/
    /* Test Case 6 */
    /***************/
    /* Test SetTrace */
    /* Set J0 trace for chan 0 */
#ifdef DREW
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) BDExtLoopbackArray);
#elif WALLACE    
    /* Setup the device in a external loopback running PRBS on channel 0 */
    IxfApiInitChip(&chipData, (InitRegTable_t*) BWExtLoopbackArray);
#else
    printk("YOU DID NOT SPECIFY DREW OR WALLACE\n");
#endif

    section.group.channel = 0;
    ixfStatus = IxfApiSetTrace(&chipData, &section, bb_EXPECTED_J0, bb_64_BYTE_WITH_LF_CR, string64);

    if (ixfStatus == bb_NO_ERROR)
    {
        /* Test GetTrace */
        section.group.channel = 0;
        ixfStatus = IxfApiGetTrace(&chipData, &section, bb_EXPECTED_J0,  (char*) J0String, &len);

        if (!(strncmp(string64, J0String, 10)))
        {
            printk("IXFAPISETTRACE TEST                 : PASSED\n");
            printk("IXFAPIGETTRACE TEST                 : PASSED\n");
        }
        else
        {
            printk("IXFAPISETTRACE TEST                 : FAILED\n");
            printk("IXFAPIGETTRACE TEST                 : FAILED\n");
        }
    }
    else
    {
        printk("IXFAPISETTRACE TEST                 : FAILED\n");
    }

    /***************/
    /* Test Case 7 */
    /***************/
    /* Get OHT Counters */
    ixfStatus = IxfApiGetCounters(&chipData, &section, bb_OOF_CNT, myArray);

    if (ixfStatus == bb_NO_ERROR)
    {
        printk("IXFAPIGETCOUNTERS TEST              : PASSED\n");
    }
    else
    {
        printk("IXFAPIGETCOUNTERS TEST              : FAILED\n");
    }



    /***************/
    /* Test Case 8 */
    /***************/
    i = 0;

    /* Write different values to the chip*/
    ixfStatus = IxfApiInitChip(&chipData, (InitRegTable_t *) RegInitIXF6048Table);

    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */

    /* Now Read and check the default values */
    while ((defaultArray[i].offset != (bb_RegPointer_type)0xFFFF) &&
        (defaultArray[i].value != IXF_INIT_DATA_DELIMITER))
    {
        /* Form the address */
        pReg = (chipData.BaseAddress + (int) defaultArray[i].offset);

        if (READ_FROM_HW(pReg) != defaultArray[i].value)
        {
            printk("BA = %08x", (unsigned int) chipData.BaseAddress);
            printk("MISMATCH on addr = %08x", (unsigned int) pReg);
            printk(" EXPECTED=0x%04x", defaultArray[i].value);
            printk(" ACTUAL=0x%04x\n", READ_FROM_HW(pReg));

            break;
        }

        i++;
    }

    /* Successful if we reached the delimiter */
    if ((defaultArray[i].offset == (bb_RegPointer_type)0xFFFF) &&
        (defaultArray[i].value == IXF_INIT_DATA_DELIMITER))
    {
        printk("IXFAPIRESET TEST                    : PASSED\n");
    }
    else
    {
        printk("IXFAPIRESET TEST                    : FAILED\n");
    }

    /***************/
    /* Test Case 9 */
    /***************/

    /* ChipIsr Test */
    /* If we are executing this test, then system software enabling
    interrupts must be running */
#endif

    /* Reset Chip, Sections & Fifos */
    ixfStatus = IxfApiReset(&chipData, &section, bb_RESET_CHIP);    /* Reset chip */


    IxfApiInitAlarmCallback(&chipData, (AlarmCallBack) TestAlarmCallback);
//    IxfRegisterInterrupt(IRQ_IXDP2800_MEDIA,&chipData, (ISRFuncPtr_t) IxfApiChipIsr);
//    IxfRegisterInterrupt(IRQ_IXP2000_SWI,&chipData, (ISRFuncPtr_t) IxfApiChipIsr);

    printk("Registering is complete\n");

    IxfApiInitChip(&chipData, (InitRegTable_t*) RegInitIXF18101Table);

    /* Now, if an interrupt happens, the callback should be called
    and the callback will release the flag to complete this test */
    *IXP2000_INTCTL_REG(0x54) = 1;

    printk("IRQ test complete\n");

    /* Remove the entries in ISR Table for this pChipData */
    IxfDeleteISRChipData(&chipData);

    IxfApiReset(&chipData, &section, bb_RESET_CHIP);
}

int init_module(void)
{
	TestIxfApiMain();
	return 0;
}

void cleanup_module(void)
{
}


