/*
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *   AUTHOR:         $Author: Tepulkow $
 *   DATE:           $Date: 3/08/04 1:57p $
 *   LAST MODIFIED:  $Modtime: 3/05/04 2:07p $
 *   REV#:           $Revision: 1 $
 *   LOGFILE:        $Logfile: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_sonet_b.h $
 *   WORKFILE:       $Workfile: ixf18100_sonet_b.h $
 *
 * --------------------------------------------------------------------------
 * Project: ixf18100 API 
 * 
 * Purpose: This file contains register and bit defines for the Sonet receive 
 *          block of registers in the ixf18100.
 *
 * Notes:
 *
 *   
 * --------------------------------------------------------------------------
 * CompilerFlags: 
 * --------------------------------------------------------------------------
 * --------------------------------------------------------------------------
 * $Log: /IXDP2800_BoardSupport_3.5_FCS_310D/linux/MediaCardDrivers/ixd28192/IXF/ixf1810x/ixf18100_sonet_b.h $ 
 * 
 * 1     3/08/04 1:57p Tepulkow
 * 
 * 1     6/27/03 4:44p Daly
 * 
 * 64    1/30/03 4:40p Pkjain2
 * Made changes for PTQ release. Added Getstatus calls for SONET and
 * GLOBAL block.
 * 
 * 63    8/22/02 5:29p Jjchin
 * Fixed Tibet bug 1017537
 * 
 * 62    6/17/02 4:53p Jaalliso
 * Adding mask values
 * 
 * 61    6/03/02 2:16p Jjchin
 * Added "SONET Tx TOH Broadcast" frame.
 * 
 * 60    5/31/02 12:55p Jaalliso
 * Adding mask values
 * 
 * 59    5/24/02 11:04a Jjchin
 * Added 198Fh, 1A8Fh and 1B8Fh registers.
 * 
 * 58    5/24/02 7:06a Jaalliso
 * Adding mask values
 * 
 * 57    5/20/02 5:04p Jaalliso
 * Adding mask values
 * 
 * 56    5/16/02 4:35p Jjchin
 * Added TL_TOH_BYPASS (188Fh) register.
 * 
 * 55    4/09/02 4:21p Kssaepha
 * Changed ixf18100_PRBS_SEEDA_DFLT value
 * 
 * 54    3/06/02 10:37a Pkjain2
 * Updated to EAS 0.5
 * 
 * 53    2/01/02 1:39p Kssaepha
 * Corrected ixf18100_RL_J1_ASTRA_OFFSET
 * 
 * 52    1/18/02 10:33a Jjchin
 * Calypso GUI cleanup
 * 
 * 51    1/14/02 5:48p Jjchin
 * Added registers APS_RL_J0_ESTRA and APS_RL_J0_ASTRA.
 * 
 * 50    1/14/02 2:08p Kssaepha
 * Changed default value for RL_PT_CFG Register
 * 
 * 49    1/04/02 10:59a Kssaepha
 * 
 * 48    12/18/01 11:27a Kssaepha
 * Changed ixf18100_GLOBAL_INT to  ixf18100_WIS_INT
 * 
 * 47    12/12/01 2:46p Jjchin
 * Added 'TL_TOH_FIFO_SPILL, TL_TOH_FIFO_STATUS' registers.
 * 
 * 46    12/04/01 4:24p Pkjain2
 * 
 * 45    11/30/01 4:14p Rsood
 * 
 * 44    11/26/01 2:26p Jjchin
 * Included 'ixf18100_d.h' to Calypso.
 * 
 * 43    11/20/01 2:32p Srodrig1
 * 
 * 42    11/16/01 4:21p Jjchin
 * Updated SONET TX and APS
 * 
 * 41    11/14/01 4:36p Pkjain2
 * 
 * 40    11/14/01 4:30p Pkjain2
 * 
 * 39    11/14/01 4:24p Rsood
 * 
 * 38    11/14/01 4:06p Srodrig1
 * 
 * 37    10/02/01 11:32a Kssaepha
 * Moved OofCfg from RL_LOF_LMN to RL_SOH_CFG
 * 
 * 36    9/17/01 5:15p Jjchin
 * Added PRBS to 'SONET CNFG' registers.
 * 
 * 35    9/13/01 2:38p Kssaepha
 * Fixed default value for register TT_SER_PRT_CFG
 * 
 * 34    9/10/01 1:57p Kssaepha
 * Added SONET Serial Port Registers
 * 
 * 33    9/10/01 11:09a Srodrig1
 * 
 * 32    8/30/01 11:05a Jjchin
 * Added 'SONET APS' register definition.
 * 
 * 31    8/28/01 3:40p Jjchin
 * Corrected 'SONET Configuration' register offset.
 * 
 * 30    8/27/01 1:05p Kssaepha
 * Updated to match register spec.
 * 
 * 29    8/23/01 2:24p Jjchin
 * Added register block for 'SONET TX TOH'.
 * 
 * 28    8/21/01 9:29a Jjchin
 * Mapped 'SONET TX GEN' controls to registers
 * 
 * 27    8/14/01 2:32p Jjchin
 * Added register block for 'CalypsoSONETTxGenRegs'
 * 
 * 26    8/14/01 9:22a Kssaepha
 * Changed J1_ALL_ZERO_EN to J1_ALLZERO_EN
 * 
 * 25    8/09/01 11:07a Kssaepha
 * Added RL_J1_CFG default value
 * 
 * 24    8/08/01 11:14a Kssaepha
 * Added value defines for receive H1H2 Pointer SS expected value
 * 
 * 23    8/06/01 2:16p Kssaepha
 * Fixed some invalid bit defines
 * 
 * 22    8/03/01 3:57p Rfranz
 * fixed some incorrect shifts
 * 
 * 21    8/03/01 11:07a Kssaepha
 * Changed J1 Config trace format to use J0 Config trace format
 * 
 * 20    8/02/01 5:52p Jjchin
 * Sonet configuration - map controls to registers
 * 
 * 19    8/02/01 1:21p Kssaepha
 * Fixed some bit value defines
 * 
 * 18    8/01/01 1:19p Kssaepha
 * Modified bit definitions for some 32-bit registers
 * 
 * 17    7/30/01 7:02p Kssaepha
 * Fixed some bit shifts and masks
 * 
 * 16    7/30/01 5:01p Jjchin
 * Added register block for Calypso SONET Configuration
 * 
 * 15    7/27/01 4:15p Kssaepha
 * Inserted ixf18100_SONET_BASE and ixf18100_REG_SHIFT again
 * 
 * 14    7/27/01 4:04p Rfranz
 * ixf18100_sonet.c compiles without errors or warnings
 * 
 * 13    7/27/01 2:11p Rfranz
 * Check in before first attempt to compile
 * 
 * 12    7/26/01 12:57p Rfranz
 * removed duplicate ixf18100_sRDIP_GEN_ENH_CFG #define
 * 
 * 11    7/25/01 5:23p Rfranz
 * WIP
 * Updated RL registers as per update from Stephen Horn on 7/23
 * 
 * 10    7/25/01 3:57p Rfranz
 * WIP
 * 
 * 9     7/24/01 1:23p Rfranz
 * WIP
 * 
 * 8     7/23/01 3:10p Rfranz
 * Added alias for RL k1 k2 register to allow consistent naming between RL
 * and TL.
 * 
 * 7     7/23/01 2:08p Rfranz
 * Fixed K1 K2 register naming
 * 
 * 6     7/19/01 11:04a Kssaepha
 * Fixed some macro redefinition conflicts
 * 
 * 5     7/19/01 10:02a Rfranz
 * Added transmit registers.
 * Changed bit defines to shifts
 * updated device number
 * no other changes/checks made
 * 
 * 4     7/19/01 9:13a Kssaepha
 * modified some bit descriptions to match datasheet
 * 
 * 3     7/18/01 3:28p Kssaepha
 * updated to accommodate changes to Calypso_MAS_0.3 specification that
 * was released 7-18-01
 * 
 * 2     7/18/01 1:56p Kssaepha
 * Intial revision
 * --------------------------------------------------------------------------
 */ 

#ifndef __ixf18100_SONET_B_H__
#define __ixf18100_SONET_B_H__

#include "ixf18100_d.h"


#define ixf18100_SONET_REG(offset) ((ixf18100_SONET_BASE + offset) << ixf18100_REG_SHIFT)

/* START --- SONET CONFIGURATION REGISTERS */
/******************************************************************************/
/* WISIP_ID Register*/

/*Offset/Default definition for register.*/
#define ixf18100_WISIP_ID_OFFSET	ixf18100_SONET_REG(0x0000)

/*Default value for register.*/
#define ixf18100_WISIP_ID_DFLT		0x0000

/*---------------- Shift and mask defines.----------------------*/
/*WISIP Identification: This field contains the identification number. */
#define ixf18100_sWISIP_ID          0    
#define ixf18100_mWISIP_ID		    (0xFF << ixf18100_sWISIP_ID)

/*15:8 WISIPVer[7:0] 
 *WISIP Version: This field contains the version number.
 */
#define ixf18100_sWISIP_VER         8     
#define ixf18100_mWISIP_VER			(0xFF << ixf18100_sWISIP_VER)


/******************************************************************************/

/******************************************************************************/
/* SRESET Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SRESET_OFFSET		ixf18100_SONET_REG(0x0001)

/*Default value for register.*/
#define ixf18100_SRESET_DFLT		0x0000

/*-------------------Shift and mask defines.------------------------------*/

/*Software reset of all blocks.*/
#define ixf18100_sSRESET_ALL        0
#define ixf18100_mSRESET_ALL        (0x01 << ixf18100_sSRESET_ALL)

/*15:1 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* PRBS_SEEDA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PRBS_SEEDA_OFFSET      ixf18100_SONET_REG(0x0003)
#define ixf18100_PRBS_SEEDA_DFLT        0x007F

/*----------Shift and mask defines.--------*/

/*Upper seven bits of the PRBS seed value. */
#define ixf18100_sSEED_UPPER            0    
#define ixf18100_mSEED_UPPER            (0x7F << ixf18100_sSEED_UPPER)


/*15:7 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* PRBS_SEEDB Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PRBS_SEEDB_OFFSET      ixf18100_SONET_REG(0x0004)
#define ixf18100_PRBS_SEEDB_DFLT        0xFFFF

/*-----------Shift and mask defines.---------------*/
/*Lower seven bits of the PRBS seed value.*/
#define ixf18100_sSEED_LOWER            0    
#define ixf18100_mSEED_LOWER            (0xFFFF << ixf18100_sSEED_LOWER)


/******************************************************************************/

/******************************************************************************/
/* PRBS_SYNC_CNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PRBS_SYNC_CNT_OFFSET   ixf18100_SONET_REG(0x0005)
#define ixf18100_PRBS_SYNC_CNT_DFLT     0x0063

/*---------Shift and mask defines.-----------------*/
/*Represents a count from 1-32 (00 = 32) of the necessary matching SPE
 *PRBS frames before the transition from out-of-sync to in-sync */
#define ixf18100_sSYNC_ON               0    
#define ixf18100_mSYNC_ON               (0x1F << ixf18100_sSYNC_ON)

/*Represents a count from 1-32 (00 = 32) of the necessary mismatching
 *SPE PRBS frames before the transition from in-sync to out-of-sync */
#define ixf18100_sSYNC_OFF              5    
#define ixf18100_mSYNC_OFF              (0x1F << ixf18100_sSYNC_OFF)


/*15:10 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* PRBS_SYNC_STATE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PRBS_SYNC_STATE_OFFSET ixf18100_SONET_REG(0x0006)
#define ixf18100_PRBS_SYNC_STATE_DFLT   0x0000

/*---------Shift and mask defines.------*/

/*PRBS_State*/
#define ixf18100_sPRBS_STATE            0    


/*15:1 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* PRBS_ERR_CNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_PRBS_ERR_CNT_OFFSET    ixf18100_SONET_REG(0x0007)
#define ixf18100_PRBS_ERR_CNT_DFLT      0x0000

/*-------- Shift and mask defines.-------------*/

/*Number of mismatching bits */
#define ixf18100_sPRBS_ERR              0    
#define ixf18100_mPRBS_ERR              (0xFFFF << ixf18100_sPRBS_ERR)


/******************************************************************************/

/******************************************************************************/
/* WISLOOP_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_WISLOOP_CFG_OFFSET		ixf18100_SONET_REG(0x0009)
#define ixf18100_WISLOOP_CFG_DFLT		0x0000

/*-----------------------------Shift and mask defines.----------------------*/
/*Mapper_test_loop*/
#define ixf18100_sMAPPER_TEST_LOOP      0               
#define ixf18100_mMAPPER_TEST_LOOP	    (0x3 << ixf18100_sMAPPER_TEST_LOOP)

#define ixf18100_RMAP_LPBK_DIS          (0x0 << ixf18100_sMAPPER_TEST_LOOP)
#define ixf18100_RMAP_LPBK_ALL          (0x2 << ixf18100_sMAPPER_TEST_LOOP)


/*15:2 Reserved
 */               		
/******************************************************************************/

/******************************************************************************/
/* WISDPCFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_WISDPCFG_OFFSET		ixf18100_SONET_REG(0x000A)
#define ixf18100_WISDPCFG_DFLT		    0x0000

/*---------Shift and mask defines.------*/
/*This bit selects either software or the APS bit of the TAL port to control
 *which provisioned configuration controls the Rx data mux.*/
#define ixf18100_sRX_SELMUX_CTRL        0              

/*This bit selects either software or the APS bit of the TAL port to control
 *which provisioned configuration controls the Tx data mux.*/
#define ixf18100_sTX_SELMUX_CTRL        1

/*This bit selects either software or the APS bit of the TAL port to control
 *which provisioned configuration controls the Tx APS data mux.*/
#define ixf18100_sTXAPS_SELMUX_CTRL     2               

/*When software control of Rx APS mux is selected, this bit selects which
 *provisioned configuration controls the Rx APS mux.*/
#define ixf18100_sRX_CFGMUX_SWCTRL      3               

/*When software control of Tx data mux is selected, this bit selects which
 *provisioned configuration controls the Tx data mux.*/
#define ixf18100_sTX_CFGMUX_SWCTRL      4

/*When software control of Tx APS mux is selected, this bit selects which
 *provisioned configuration controls the Tx APS mux.*/
#define ixf18100_sTXAPS_CFGMUX_SWCTRL   5

/*This bit is configuration option 1 for the Rx data mux. This bit is used
 *when the selected control (SW or APS bit of TAL) is equal to 0.*/
#define ixf18100_sRX_MUX_CFG            6

/*This bit is configuration option 1 for the Tx data mux. This bit is used
 *when the selected control (SW or APS bit of TAL) is equal to 0.*/
#define ixf18100_sTX_MUX_CFG            7


/*This bit is configuration option 1 for the Tx APS data mux. This bit is used
 *when the selected control (SW or APS bit of TAL) is equal to 0.*/
#define ixf18100_sTXAPS_MUX_CFG         8


/*This bit is configuration option 2 for the Rx data mux. This bit is used
 *when the selected control (SW or APS bit of TAL) is equal to 1.*/
#define ixf18100_sRX_MUX_CFG_SHAD       9


/*This bit is configuration option 2 for the Tx data mux. This bit is used
 *when the selected control (SW or APS bit of TAL) is equal to 1.*/
#define ixf18100_sTX_MUX_CFG_SHAD       10


/*This bit is configuration option 2 for the Tx APS data mux. This bit is used
 *when the selected control (SW or APS bit of TAL) is equal to 1.*/
#define ixf18100_sTXAPS_MUX_CFG_SHAD    11


/*This bit selects either software or the APS bit of the TAL port to control
 which provisioned configuration controls the clock muxes*/
#define ixf18100_sCLK_SELMUX_CTRL       12

/*When software control of clock muxes is selected, this bit selects  which 
provisioned configuration controls the clock muxes. */
#define ixf18100_sCLK_CFGMUX_SWCTRL     13

/*15:14 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* WMAP_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_WMAP_CFG_OFFSET		ixf18100_SONET_REG(0x000B)
#define ixf18100_WMAP_CFG_DFLT		    0x0000

/*---------Shift and mask defines.------*/
/*Enables PRBS generation for outgoing SPE data.*/
#define ixf18100_sTX_JITTER_TEST		0
#define ixf18100_mTX_JITTER_TEST		(0x01 << ixf18100_sTX_JITTER_TEST)

/*Controls whether a AIS-P condition is asserted while a data alarm
 *persists.*/
#define ixf18100_sTX_ALARM_DIS			1

/*Controls whether valid data is inserted into stuff bytes 16-63, i.e., 48
 *bytes for each row.*/
#define ixf18100_sTX_USE_STUFF			2

/*Selects the Jitter pattern*/
#define ixf18100_sJITTER_PATTERN_SEL    3
#define ixf18100_mJITTER_PATTERN_SEL    (0x01 << ixf18100_sJITTER_PATTERN_SEL)

/*Enables PRBS detection on incoming SPE data.*/
#define ixf18100_sRX_JITTER_TEST		4
#define ixf18100_mRX_JITTER_TEST		(0x01 << ixf18100_sRX_JITTER_TEST)

/*Controls whether o_wis_rx_valid is asserted while i_rx_alarm is active.*/
#define ixf18100_sRX_VALID_DIS			5

/*Controls whether valid data is extracted from stuff bytes 16-63, i.e., 48
 *bytes, for each row.
 *NOTE: Selected when i_wis_loopbk is 00.*/
#define ixf18100_sRX_USE_STUFF			6

/*15:7 Reserved*/            
/******************************************************************************/

/******************************************************************************/
/* WIS_INT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_WIS_INT_OFFSET		ixf18100_SONET_REG(0x0010)
#define ixf18100_WIS_INT_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*Set to 1 when there is an active interrupt in the Receive POH interrupt
 *register.*/
#define ixf18100_sRX_POH_INT            0

/*Set to 1 when there is an active interrupt in the Receive J1 interrupt
 *register. */
#define ixf18100_sRX_J1_INT             1

/*Set to 1 when there is an active interrupt in the Pointer tracker.*/
#define ixf18100_sRX_PT_INT             2

/*Set to 1 when there is an active interrupt in the line processing register
 *(LOH). */
#define ixf18100_sRX_LOH_INT            3

/*Set to 1 when there in an active interrupt in the framing and section
 *processing register (framer and Rx SOH).*/
#define ixf18100_sFRSOHP_INT            4

/*One or more interrupts are active in the TX_TIM_AL_INT register*/
#define ixf18100_sTX_TIM_AL_INT         6

/*One or more interrupts are active in the SER_AL_INT register */
#define ixf18100_sSER_AL_INT            7

/*Set to 1 when there is an active interrupt in the TT_SER_PRT_INT
 *register */
#define ixf18100_sTT_SER_PRT_INT        8


/*Value defines*/

/*15:9 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* WIS_INT_EN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_WIS_INT_EN_OFFSET		ixf18100_SONET_REG(0x0011)
#define ixf18100_WIS_INT_EN_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*Interrupt enable for RX_POH_INT */
#define ixf18100_sRX_POH_INT_EN             0

/*Interrupt enable for RX_J1_INT */
#define ixf18100_sRX_J1_INT_EN              1

/*Interrupt enable for RX_PT_INT */
#define ixf18100_sRX_PT_INT_EN              2

/*Interrupt enable for RX_LOH_INT */
#define ixf18100_sRX_LOH_INT_EN             3

/*Interrupt enable for FRSOHP_INT */
#define ixf18100_sFRSOHP_INT_EN             4

/*Interrupt enable for TX_TIM_AL_INT */
#define ixf18100_sTX_TIM_AL_INT_EN          6

/*Interrupt enable for SER_AL_INT */
#define ixf18100_sSER_AL_INT_EN             7

/*Interrupt enable for TT_SER_PRT_INT */
#define ixf18100_sTT_SER_PRT_INT_EN         8

/*Value defines*/

/*15:9 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* FRM_AL_INT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_FRM_AL_INT_OFFSET		ixf18100_SONET_REG(0x0020)
#define ixf18100_FRM_AL_INT_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*15:0 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TX_TIM_AL_INT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TX_TIM_AL_INT_OFFSET	ixf18100_SONET_REG(0x0021)
#define ixf18100_TX_TIM_AL_INT_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*Set to 1 when there is a change in the Tx_LOFP_S bit in register
 *TX_TIM_AL_INT_ST  It is cleared when read. The system
 *clock must be active to access this register.*/
#define ixf18100_sTX_LOFP_IS           0

/*Set to 1 when there is a change in the Tx_ReSync_S bit in register
 *TX_TIM_AL_INT_ST. It is cleared when read. The system
 *clock must be active to access this register.*/
#define ixf18100_sTX_FPERR_IS          1

/*Set to 1 when there is a change in the Tx_FBAlign_S bit in register
 *TX_TIM_AL_INT_ST . It is cleared when read. The system
 *clock must be active to access this register.*/
#define ixf18100_sTX_FBALIGN_IS        2

/*Value defines*/

/*15:3 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* SER_AL_INT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SER_AL_INT_OFFSET		ixf18100_SONET_REG(0x0022)
#define ixf18100_SER_AL_INT_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*This bit is set to logic level one when there is a change in the
 *TalDataChSt bit in register SER_AL_S */
#define ixf18100_sTAL_DATA_CH           0

/*This bit is set to logic level one when there is a change in the TalLofpSt
 *bit in register SER_AL_S (page 178). This interrupt bit is only used when
 *the transmit section alarm bus is configured in co-directional mode.*/
#define ixf18100_sTAL_LOFP_INT          1

/*This bit is set to logic level one when there is a change in the TalLocSt bit
 *in register SER_AL_S (page 178). This interrupt bit is only used when the
 *transmit section alarm bus is configured in co-directional mode. */
#define ixf18100_sTAL_LOC_INT           2

/*TalCrcInt is set to logic level one when a CRC-4 error in the transmit line
 *section alarm bus for the line is detected.*/
#define ixf18100_sTAL_CRC_INT           3

/*This bit is set to logic level one when there is a change in the
 *PalDataChSt bit in register SER_AL_S */
#define ixf18100_sPAL_DATA_CH_INT       4

/*This bit is set to logic level one when there is a change in the PalLofpSt
 *bit in register SER_AL_S (page 178). This interrupt bit is only used when
 *the transmit section alarm bus is configured in co-directional mode. */
#define ixf18100_sPAL_LOFP_INT          5

/*This bit is set to logic level one when there is a change in the PalLocSt bit
 *in register SER_AL_S (page 178). This interrupt bit is only used when the
 *transmit section alarm bus is configured in co-directional mode. */
#define ixf18100_sPAL_LOC_INT           6

/*PalCrcInt is set to logic level one when a CRC-4 error in the transmit line
 *section alarm bus for the path is detected. */
#define ixf18100_sPAL_CRC_INT           7


/*Value defines*/

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* FRM_AL_INT_EN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_FRM_AL_INT_EN_OFFSET		ixf18100_SONET_REG(0x0030)
#define ixf18100_FRM_AL_INT_EN_DFLT		    0x0000

/*---------Shift and mask defines.------*/

/*15:0 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TX_TIM_AL_INT_EN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TX_TIM_AL_INT_EN_OFFSET	ixf18100_SONET_REG(0x0031)
#define ixf18100_TX_TIM_AL_INT_EN_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*Active-high interrupt enable for the Tx_ LOFP_IS bit in TX_TIM_AL_INT */
#define ixf18100_sTX_LOFP_IE               0

/*Active-high interrupt enable for the Tx_ FPERR_IS bit in
 *TX_TIM_AL_INT */
#define ixf18100_sTX_FPERR_IE              1

/*Active-high interrupt enable for the Tx_ FBAlign_IS bit in
 *TX_TIM_AL_INT. */
#define ixf18100_sTX_FBALIGN_IE            2


/*Value defines*/

/*15:3 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* SER_AL_INT_EN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SER_AL_INT_EN_OFFSET		ixf18100_SONET_REG(0x0032)
#define ixf18100_SER_AL_INT_EN_DFLT		    0x0000

/*---------Shift and mask defines.------*/

/*Interrupt enable for TalDataCh in SER_AL_INT. */
#define ixf18100_sTAL_DATA_CH_EN            0

/*Interrupt enable for TalLofpInt in SER_AL_INT.*/
#define ixf18100_sTAL_LOFP_INT_EN           1

/*Interrupt enable for TalLocInt in SER_AL_INT */
#define ixf18100_sTAL_LOC_INT_EN            2

/*Interrupt enable for TalCrcInt in SER_AL_INT */
#define ixf18100_sTAL_CRC_INT_EN            3

/*Interrupt enable for PalDataChInt in SER_AL_INT */
#define ixf18100_sPAL_DATA_CH_EN            4

/*Interrupt enable for PalLofpInt in SER_AL_INT */
#define ixf18100_sPAL_LOFP_INT_EN           5

/*Interrupt enable for PalLocInt in SER_AL_INT */
#define ixf18100_sPAL_LOC_INT_EN            6

/*Interrupt enable for PalCrcInt in SER_AL_INT */
#define ixf18100_sPAL_CRC_INT_EN            7


/*Value defines*/

/*15:8 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* FRM_AL_INT_ST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_FRM_AL_INT_ST_OFFSET		ixf18100_SONET_REG(0x0040)
#define ixf18100_FRM_AL_INT_ST_DFLT		    0x0000

/*---------Shift and mask defines.------*/

/*15:0 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TX_TIM_AL_INT_ST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TX_TIM_AL_INT_ST_OFFSET		ixf18100_SONET_REG(0x0041)
#define ixf18100_TX_TIM_AL_INT_ST_DFLT		    0x0000

/*---------Shift and mask defines.------*/

/*This bit is set to 1 when input REF_FPI_P/N  has no frame
 *pulse during any timeslot for three consecutive frames, and it clears on
 *the next reception of a frame pulse.
 *In internal timing mode, the corresponding interrupt bit may need to be
 *disabled for some applications.
 *The system clock must be active to access this register. */
#define ixf18100_sTX_LOFP_S                0

/*This bit is set to 1 when the external frame pulse input REF_FPI_P/N
 *is missing or occurs in an unexpected timeslot, and it clears
 *when REF_FPI occurs in the expected timeslot.
 *In internal timing mode, the corresponding interrupt bit may need to be
 *disabled for some applications.
 *The system clock must be active to access this register.*/
#define ixf18100_sTX_FPERR_S               1

/*This bit is set to 1 when the frame boundary at the Tx Line interface
 *realign due to a transmit frame counter resync, and this bit clears when
 *the selected sync input is aligned as expected.
 *The system clock must be active to access this register.*/
#define ixf18100_sTX_FBALIGN_S             2


/*Value defines*/

/*15:3 Unused 
 */
/******************************************************************************/

/******************************************************************************/
/* SER_AL_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_SER_AL_S_OFFSET		ixf18100_SONET_REG(0x0042)
#define ixf18100_SER_AL_S_DFLT		    0x0000

/*---------Shift and mask defines.------*/

/*This bit is set to logic level one when TalLofpSt, TalLocSt, or TalCrcSt is
 *active and enabled to affect data out of the serial port interface via
 *register RT_SER_PRT_CFG. */
#define ixf18100_sTAL_DATA_CH_ST        0

/*This bit is set to a logic level when the absence of a delineation pulse in
 *the transmit line section alarm serial port is detected. This bit is only used
 *when the transmit section alarm serial port is configured in co-directional
 *mode.*/
#define ixf18100_sTAL_LOFP_ST           1

/*This bit is set to a logic level one when the absence of a clock in the
 *transmit line section alarm serial port is detected. This bit is only used
 *when the transmit section alarm serial port is configured in co-directional
 *mode. */
#define ixf18100_sTAL_LOC_ST            2

/*TalCrcSt is set to logic level one when a CRC-4 error is detected in the
 *transmit line section alarm serial port. */
#define ixf18100_sTAL_CRC_ST            3

/*This bit is set to logic level one when PalLofpSt, PalLocSt, or PalCrcSt is
 *active and enabled to affect data out of the serial port interface via
 *register RP_SER_PRT_CFG. */
#define ixf18100_sPAL_DATA_CH_ST        4

/*This bit is set to a logic level when the absence of a delineation pulse in
 *the transmit path section alarm serial port is detected. This bit is only
 *used when the transmit section alarm serial port is configured in co-
 *directional mode. */
#define ixf18100_sPAL_LOFP_ST           5

/*This bit is set to a logic level one when the absence of a clock in the
 *transmit path section alarm serial port is detected. This bit is only used
 *when the transmit section alarm serial port is configured in co-directional
 *mode. */
#define ixf18100_sPAL_LOC_ST            6

/*PalCrcSt is set to logic level one when a CRC-4 error is detected in the
 *transmit path section alarm serial port. */
#define ixf18100_sPAL_CRC_ST            7


/*Value defines*/

/*15:8 Unused
 */
/******************************************************************************/
/* END --- SONET CONFIGURATION REGISTERS */


/* START --- SONET SERIAL PORT REGISTERS */
/******************************************************************************/
/* TT_SER_PRT_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_CFG_OFFSET		ixf18100_SONET_REG(0x0050)
#define ixf18100_TT_SER_PRT_CFG_DFLT	    0x0008

/*---------Shift and mask defines.------*/

/*This bit controls the logical multiplexing of serial ports and the
 *configuration of the Bidirectional ports. */
#define ixf18100_sTAL_SER_PRT_CFG           0

/*Configures the Transmit Transport orderwire sync pulse. */
#define ixf18100_sTAL_OWS_CFG               1

/*Configures the Transmit Transport orderwire clock.*/
#define ixf18100_sTAL_OWC_CFG               2

/*Configures the TTAL port clock and frame source. */
#define ixf18100_sTAL_CFG                   3

/*Configures the TTAL port data transmission during enabled error. */
#define ixf18100_sTAL_ERR_DATA_CFG          4

/*Configures the TTAL port generation of AIS control during qualified error. */
#define ixf18100_sTAL_ERR_AIS_CFG           5

/*Enables CRC error detected on TTAL to affect data transmitted by TTAL. */
#define ixf18100_sTAL_CRC_ERR_EN            6

/*Enables clock error detected on TTAL to affect data transmitted by TTAL. */
#define ixf18100_sTAL_CLK_ERR_EN            7 

/*Enables frame pulse error detected on TTAL to affect data transmitted by
 *TTAL. */ 
#define ixf18100_sTAL_FR_ERR_EN             8

/*Configures unused value of unused Transport OH bytes when
 *TT_SER_PRT_CFG selects dedicated port access. */
#define ixf18100_sTAL_UNBY_CFG              9

/*15:10 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_SEL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_SEL_OFFSET		ixf18100_SONET_REG(0x0051)
#define ixf18100_TT_SER_PRT_SEL_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*This bit configures the source of M1 REI from the serial port:
 *SerPrtCfg (in TT_SER_PRT_CFG) = 0: TOH and TTAL both
 *available */
#define ixf18100_sM1_SER_SRC           0

/*This bit configures the source of the S1 byte from the serial port:
 *SerPrtCfg (in TT_SER_PRT_CFG) = 0: TOH and TTAL both
 *available */
#define ixf18100_sS1_SER_SRC           1

/*This bit configures the source of RDI bits in K2 byte (bits [2:0]) from the
 *serial port. */
#define ixf18100_sK2_RDI_SER_SRC       2

/*This bit configures the source of APS bits in K2 byte (bits[7:3]) from the
 *serial port.*/
#define ixf18100_sK2_APS_SER_SRC       3

/*This bit configures the source of K1 APS from the serial port. */
#define ixf18100_sK1_SER_SRC           4

/*This bit configures the source of M0 REI from the serial port. */
#define ixf18100_sM0_SER_SRC           5

/*15:6 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_B1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_B1_OFFSET		ixf18100_SONET_REG(0x0053)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Encoded B1 error value*/
#define ixf18100_sB1ENC     0
#define ixf18100_mB1ENC	    (0xF << ixf18100_sB1ENC)

/*15:4 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_B2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_B2_OFFSET		ixf18100_SONET_REG(0x0054)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Encoded B2 error value [7:0], can be reflected as M1 byte for REI-L. */
#define ixf18100_sB2ENC     0
#define ixf18100_mB2ENC	    (0xFF << ixf18100_sB2ENC)

/*Encoded B2 error value [15:8], can be reflected as M0 byte when
 *configured for 2-byte REI-L. */
#define ixf18100_sB2END     8
#define ixf18100_mB2END	    (0xFF << ixf18100_sB2END)

/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_K1K2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_K1K2_OFFSET		ixf18100_SONET_REG(0x0055)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*K2 byte value */
#define ixf18100_sTT_SER_PRT_K2     0
#define ixf18100_mTT_SER_PRT_K2	    (0xFF << ixf18100_sTT_SER_PRT_K2)

/*K1 byte value */
#define ixf18100_sTT_SER_PRT_K1     8
#define ixf18100_mTT_SER_PRT_K1	    (0xFF << ixf18100_sTT_SER_PRT_K1)

/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_S1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_S1_OFFSET		ixf18100_SONET_REG(0x0056)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*S1 byte value */
#define ixf18100_sTT_SER_PRT_S1     0
#define ixf18100_mTT_SER_PRT_S1	    (0xFF << ixf18100_sTT_SER_PRT_S1)

/*15:8 Unused */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_GP Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_GP_OFFSET		ixf18100_SONET_REG(0x0057)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*General Purpose byte value */
#define ixf18100_sTT_SER_PRT_GP     0
#define ixf18100_mTT_SER_PRT_GP	    (0xFF << ixf18100_sTT_SER_PRT_GP)

/*15:8 Unused */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_INT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_INT_OFFSET		ixf18100_SONET_REG(0x0058)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Indicates an active interrupt in TT_SER_PRT_1_IS. */
#define ixf18100_sTT_SERPRT_1_INT     0

/*Indicates an active interrupt in TT_SER_PRT_2_IS. */
#define ixf18100_sTT_SERPRT_2_INT     1

/*15:2 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_INT_EN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_INT_EN_OFFSET		ixf18100_SONET_REG(0x0059)
#define ixf18100_TT_SER_PRT_INT_EN_DFLT		    0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active high interrupt enable for TT_SerPrt_1_Int in
 *TT_SER_PRT_INT. */
#define ixf18100_sTT_SER_PRT_1_INT_EN     0

/*This bit is an active high interrupt enable for TT_SerPrt_2_Int in
 *TT_SER_PRT_INT.*/
#define ixf18100_sTT_SER_PRT_2_INT_EN     1

/*15:2 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_1_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_1_IS_OFFSET		ixf18100_SONET_REG(0x005A)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the Tal_GenRdilSt bit in register
 *TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_GEN_RDIL	      0

/*This bit is set when there is a change in the Tal_LOSSt bit in register
 *TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_LOS             1

/*This bit is set when there is a change in the Tal_OOFSt bit in register
 *TT_SER_PRT_1_S. */
#define ixf18100_sTAL_OOF             2

/*This bit is set when there is a change in the Tal_LOFSt bit in register
 *TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_LOF             3

/*This bit is set when there is a change in the Tal_J0mmSt bit in register
 *TT_SER_PRT_1_S. */
#define ixf18100_sTAL_J0MM            4

/*This bit is set when there is a change in the Tal_J0UnstableSt bit in
 *register TT_SER_PRT_1_S. */
#define ixf18100_sTAL_J0_UNSTABLE     5

/*This bit is set when there is a change in the Tal_J0CRC7ErrSt bit in
 *register TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_J0CRC7ERR       6

/*This bit is set when there is a change in the Tal_DetAislSt bit in register
 *TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_DET_AISL        7

/*This bit is set when there is a change in the Tal_GenAislSt bit in register
 *TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_GEN_AISL        8

/*This bit is set when there is a change in the Tal_DRSTAISSt bit in register
 *TT_SER_PRT_1_S.*/
#define ixf18100_sTAL_DRSTAIS         9

/*This bit is set when there is a change in the Tal_DMSTAISSt bit in
 *register TT_SER_PRT_1_S. */
#define ixf18100_sTAL_DMSTAIS         10

/*This bit is set when there is a change in the Tal_DetRdilSt bit in register
 *TT_SER_PRT_1_S. */
#define ixf18100_sTAL_DET_RDIL        11

/*This bit is set when there is a change in the Tal_S1UnstableSt bit in
 *register TT_SER_PRT_1_S. */
#define ixf18100_sTAL_S1_UNSTABLE     12

/*This bit is the S1 Change bit received on the TTAL. */
#define ixf18100_sTAL_S1_CHG          13

/*15:14 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_2_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_2_IS_OFFSET		ixf18100_SONET_REG(0x005B)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the Tal_APSCtrlSt bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_APS_CTRL              0

/*This bit is set when there is a change in the Tal_APSLinkFailSt bit in
 *register TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_APS_LINK_FAIL         1

/*This bit is set when there is a change in the Tal_uPClkFailSt bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_UP_CLK_FAIL           2

/*This bit is set when there is a change in the Tal_SelTXClkFailSt bit in
 *register TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_SEL_TX_CLK_FAIL       3

/*This bit is set when there is a change in the Tal_GP0St bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_GP0                   4

/*This bit is set when there is a change in the Tal_GP1St bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_GP1                   5

/*This bit is set when there is a change in the Tal_GP2St bit in register
 *TT_SER_PRT_2_S. */
#define ixf18100_sTAL_GP2                   6

/*This bit is set when there is a change in the Tal_SFSt bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_SF                    7

/*This bit is set when there is a change in the Tal_EEDSt bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_EED                   8

/*This bit is set when there is a change in the Tal_DSDSt bit in register
 *TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_DSD                   9

/*This bit is set when there is a change in the Tal_K1UnstableSt bit in
 *register TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_K1_UNSTABLE           10

/*This bit is set when there is a change in the Tal_K2UnstableSt bit in
 *register TT_SER_PRT_2_S.*/
#define ixf18100_sTAL_K2_UNSTABLE           11

/*This bit is the K1 Change bit received on the TTAL.*/
#define ixf18100_sTAL_K1_CHG                12

/*This bit is the K2 Change bit received on the TTAL.*/
#define ixf18100_sTAL_K2_CHG                13

/*15:14 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_1_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_1_IE_OFFSET		ixf18100_SONET_REG(0x005C)
#define ixf18100_TT_SER_PRT_1_IE_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active high enable for the Tal_GenRdil interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_GEN_RDIL_EN       0

/*This bit is an active high enable for the Tal_LOS interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_LOS_EN            1

/*This bit is an active high enable for the Tal_OOF interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_OOF_EN            2

/*This bit is an active high enable for the Tal_LOF interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_LOF_EN            3

/*This bit is an active high enable for the Tal_J0mm interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_J0MM_EN           4

/*This bit is an active high enable for the Tal_J0Unstable interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_J0_UNSTABLE_EN    5

/*This bit is an active high enable for the Tal_J0CRC7Err interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_J0CRC7ERR_EN      6

/*This bit is an active high enable for the Tal_DetAisl interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_DET_AISL_EN       7

/*This bit is an active high enable for the Tal_GenAisl interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_GEN_AISL_EN       8

/*This bit is an active high enable for the Tal_DRSTAIS interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_DRSTAIS_EN        9

/*This bit is an active high enable for the Tal_DMSTAIS interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_DMSTAIS_EN        10

/*This bit is an active high enable for the Tal_DetRdil interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_DET_RDIL_EN       11

/*This bit is an active high enable for the Tal_S1Unstable interrupt bit in
 *register TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_S1_UNSTABLE_EN    12

/*This bit is an active high enable for the Tal_S1Chg interrupt bit in register
 *TT_SER_PRT_1_IS.*/
#define ixf18100_sTAL_S1_CHG_EN         13

/*15:14 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_2_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_2_IE_OFFSET		ixf18100_SONET_REG(0x005D)
#define ixf18100_TT_SER_PRT_2_IE_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active high enable for the Tal_APSCtrl interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_APS_CTRL_EN           0

/*This bit is an active high enable for the Tal_APSLinkFail interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_APS_LINK_FAIL_EN      1

/*This bit is an active high enable for the Tal_uPClkFail interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_UP_CLK_FAIL_EN        2

/*This bit is an active high enable for the Tal_SelTXClkFail interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_SEL_TX_CLK_FAIL_EN    3

/*This bit is an active high enable for the Tal_GP0 interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_GP0_EN                4

/*This bit is an active high enable for the Tal_GP1 interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_GP1_EN                5

/*This bit is an active high enable for the Tal_GP2 interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_GP2_EN                6

/*This bit is an active high enable for the Tal_SF interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_SF_EN                 7

/*This bit is an active high enable for the Tal_EED interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_EED_EN                8

/*This bit is an active high enable for the Tal_DSD interrupt bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_DSD_EN                9

/*This bit is an active high enable for the Tal_K1Unstable bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_K1_UNSTABLE_EN        10

/*This bit is an active high enable for the Tal_K2Unstable bit in
 *register TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_K2_UNSTABLE_EN        11

/*This bit is an active high enable for the Tal_K1Chg interrupt bit in register
 *TT_SER_PRT_2_IS.*/
#define ixf18100_sTAL_K1_CHG_EN             12

/*This bit is an active high enable for the Tal_K2Chg interrupt bit in register
 *TT_SER_PRT_2_IS. */
#define ixf18100_sTAL_K2_CHG_EN             13

/*15:14 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_1_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_1_S_OFFSET		ixf18100_SONET_REG(0x005E)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Indicates generated RDI-L alarm received on the TTAL. */
#define ixf18100_sTAL_GEN_RDIL_ST       0

/*Indicates LOS alarm received on the TTAL. */
#define ixf18100_sTAL_LOS_ST            1

/*Indicates OOF alarm received on the TTAL. */
#define ixf18100_sTAL_OOF_ST            2

/*Indicates LOF alarm received on the TTAL. */
#define ixf18100_sTAL_LOF_ST            3

/*Indicates J0 Mismatch alarm received on the TTAL. */
#define ixf18100_sTAL_J0MM_ST           4

/*Indicates J0 Unstable alarm received on the TTAL. */
#define ixf18100_sTAL_J0_UNSTABLE_ST    5

/*Indicates J0 CRC-7 Error alarm received on the TTAL. */
#define ixf18100_sTAL_J0CRC7ERR_ST      6

/*Indicates detected AIS-L alarm received on the TTAL. */
#define ixf18100_sTAL_DET_AISL_ST       7

/*This bit provides the status of bit of the serial stream defined to control
 *AIS-L insertion. */
#define ixf18100_sTAL_GEN_AISL_ST       8

/*Indicates generated AIS-L due to RSOH processing alarm received
 *on the TTAL. */
#define ixf18100_sTAL_DRSTAIS_ST        9

/*Indicates generated AIS-L due to MSOH processing alarm received
 *on the TTAL. */
#define ixf18100_sTAL_DMSTAIS_ST        10

/*Indicates detected RDI-L alarm received on the TTAL.*/
#define ixf18100_sTAL_DET_RDIL_ST       11

/*Indicates an S1 unstable alarm received on the TTAL. */
#define ixf18100_sTAL_S1_UNSTABLE_ST    12

/*15:13 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_PRT_2_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_PRT_2_S_OFFSET		ixf18100_SONET_REG(0x005F)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit controls the active data path selection.*/
#define ixf18100_sTAL_APS_CTRL_ST           0

/*Indicates an APS Link failure alarm received on the TTAL. */
#define ixf18100_sTAL_APS_LINK_FAIL_ST      1

/*Indicates uP clock failure alarm received on the TTAL. */
#define ixf18100_sTAL_UP_CLK_FAIL_ST        2

/*Indicates a selected Tx clock failure alarm received on the TTAL. */
#define ixf18100_sTAL_SEL_TX_CLK_FAIL_ST    3

/*Value of General Purpose bit 0 received on the TTAL. */
#define ixf18100_sTAL_GP0_ST                4

/*Value of General Purpose bit 1 received on the TTAL. */
#define ixf18100_sTAL_GP1_ST                5

/*Value of General Purpose bit 2 received on the TTAL.*/
#define ixf18100_sTAL_GP2_ST                6

/*Indicates Signal Fail alarm received on the TTAL. */
#define ixf18100_sTAL_SF_ST                 7

/*Indicates EED alarm received on the TTAL. */
#define ixf18100_sTAL_EED_ST	            8

/*Indicates DSD alarm received on the TTAL. */
#define ixf18100_sTAL_DSD_ST                9

/*Indicates that a K1 unstable alarm received on the TTAL. */
#define ixf18100_sTAL_K1_UNSTABLE_ST        10

/*Indicates that a K2 unstable alarm received on the TTAL. */
#define ixf18100_sTAL_K2_UNSTABLE_ST        11

/*15:12 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TT_SER_DEF_K1K2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_DEF_K1K2_OFFSET		ixf18100_SONET_REG(0x0060)
#define ixf18100_TT_SER_DEF_K1K2_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*K2 byte value provided by the uP is inserted when there is an error
 *on the serial Alarm Data stream received via the TTAL interface.  */
#define ixf18100_sTT_SER_DEF_K2     0
#define ixf18100_mTT_SER_DEF_K2	    (0xFF << ixf18100_sTT_SER_DEF_K2)

/*K1 byte value provided by the uP is inserted when there is an error
 *on the serial Alarm Data stream received via the TTAL interface.  */
#define ixf18100_sTT_SER_DEF_K1     8
#define ixf18100_mTT_SER_DEF_K1	    (0xFF << ixf18100_sTT_SER_DEF_K1)

/******************************************************************************/

/******************************************************************************/
/* TT_SER_DEF_M0M1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_DEF_M0M1_OFFSET		ixf18100_SONET_REG(0x0061)
#define ixf18100_TT_SER_DEF_M0M1_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*M1 byte value provided by the uP is inserted when there is an error
 *on the serial Alarm Data stream received via the TTAL interface.  */
#define ixf18100_sTT_SER_DEF_M1     0
#define ixf18100_mTT_SER_DEF_M1	    (0xFF << ixf18100_sTT_SER_DEF_M1)

/*M0 byte value provided by the uP is inserted when there is an error
 *on the serial Alarm Data stream received via the TTAL interface.  */
#define ixf18100_sTT_SER_DEF_M0     8
#define ixf18100_mTT_SER_DEF_M0	    (0xFF << ixf18100_sTT_SER_DEF_M0)

/******************************************************************************/

/******************************************************************************/
/* TT_SER_DEF_S1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TT_SER_DEF_S1_OFFSET		ixf18100_SONET_REG(0x0062)
#define ixf18100_TT_SER_DEF_S1_DFLT			0x0000

/*---------Shift and mask defines.------*/

/*S1 byte value provided by the uP is inserted when there is an error
 *on the serial Alarm Data stream received via the TTAL interface.  */
#define ixf18100_sTT_SER_DEF_S1     0
#define ixf18100_mTT_SER_DEF_S1	    (0xFF << ixf18100_sTT_SER_DEF_S1)

/*15:8 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TP_SER_PRT_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TP_SER_PRT_CFG_OFFSET		ixf18100_SONET_REG(0x0068)
#define ixf18100_TP_SER_PRT_CFG_DFLT	    0x0001

/*---------Shift and mask defines.------*/

/*Configures the TPAL port clock and frame source. */
#define ixf18100_sPAL_CFG           0  

/*Configures the TPAL port data transmission during qualified error. */
#define ixf18100_sPAL_ERR_DATA_CFG  1

/*Configures the TPAL port generation of AIS control during qualified error. */
#define ixf18100_sPAL_ERR_AIS_CFG   2

/*Enables CRC error detected on TPAL to affect data transmitted by TPAL. */
#define ixf18100_sPAL_CRC_ERR_EN    3

/*Enables clock error detected on TPAL to affect data transmitted by TPAL. */
#define ixf18100_sPAL_CLK_ERR_EN    4

/*Enables frame pulse error detected on TPAL to affect data transmitted by
 *TPAL. */
#define ixf18100_sPAL_FR_ERR_EN     5

/*15:6 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TP_SER_PRT_SEL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TP_SER_PRT_SEL_OFFSET		ixf18100_SONET_REG(0x0069)
#define ixf18100_TP_SER_PRT_SEL_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*This bit configures the source of G1 spare bit in G1 byte (bit [0]) from the
 *serial port. */
#define ixf18100_sG1_SPARE_SER_SRC     0

/*This bit configures the source of RDI bit[1:0] in G1 byte (bits [2:1]) from
 *the serial port. */
#define ixf18100_sG1_RDI_2_1_SER_SRC   1

/*This bit configures the source of RDI bit[2] in G1 byte (bit [3]) from the
 *serial port. */
#define ixf18100_sG1_RDI_3_SER_SRC     2

/*This bit configures the source of REI bits in G1 byte (bits [7:4]) from the
 *serial port. */
#define ixf18100_sG1_REI_SER_SRC       3

/*15:4 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TP_SER_DEF_G1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TP_SER_DEF_G1_OFFSET		ixf18100_SONET_REG(0x006A)
#define ixf18100_TP_SER_DEF_G1_DFLT			0x0000

/*---------Shift and mask defines.------*/

/*G1 byte value provided by the uP is inserted when there is an error
 *on the serial Alarm Data stream received via the TPAL interface. */
#define ixf18100_sTT_SER_DEF_G1     0
#define ixf18100_mTT_SER_DEF_G1	    (0xFF << ixf18100_sTT_SER_DEF_G1)

/*15:8 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_SER_PRT_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_SER_PRT_CFG_OFFSET		ixf18100_SONET_REG(0x0070)
#define ixf18100_RL_SER_PRT_CFG_DFLT	    0x0000

/*---------Shift and mask defines.------*/

/*These bit controls logical multiplexing of serial ports. */
#define ixf18100_sRL_SER_PRT_CFG     0

/*This bit configures the Receive Line orderwire sync pulse. */
#define ixf18100_sOWS_CFG            1

/*This bit configures the Receive Line orderwire clock. */
#define ixf18100_sOWC_CFG            2

/*These bits configure the General Purpose Interrupt bits which will be
 *transmitted, once every 125 us, on the RTAL output. When connected via
 *TAL interfaces to a second IXF18101, these bits will be capable of
 *generating an interrupt.  */
#define ixf18100_sGEN_PURP_INT       3
#define ixf18100_mGEN_PURP_INT	     (0x7 << ixf18100_sGEN_PURP_INT)

/*13:6 GenPurpByte[7:0]
 *This bit configures a General Purpose Byte which will be serial
 *transmitted, once every 125 us, on the RTAL output. When connected via
 *TAL interfaces to a second IXF18101, this byte will be available via
 *status register.
 */
#define ixf18100_sGEN_PURP_BYTE      6
#define ixf18100_mGEN_PURP_BYTE	     (0xFF << ixf18100_sGEN_PURP_BYTE)

/*15:14 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_SER_QUIET_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_SER_QUIET_CFG_OFFSET		ixf18100_SONET_REG(0x0071)
#define ixf18100_RL_SER_QUIET_CFG_DFLT			0x0007

/*---------Shift and mask defines.------*/

/*On receiving an Assert Down Stream AIS, on the outgoing serial
 *Line DCC data */
#define ixf18100_sRLDCC_AIS_QUIET     0

/*On receiving an Assert Down Stream AIS, on the outgoing serial
 *Section DCC data */
#define ixf18100_sRSDCC_QUIET         1

/*On receiving an Assert Down Stream AIS, on the outgoing serial
 *Orderwire data */
#define ixf18100_sRTOWD_QUIET         2

/*This bit configures the Orderwire Data inserted on an Assert AIS, if
 *configured to do so by the RtowdQuiet, for a SONET and a SDH
 *frame. */
#define ixf18100_sRTOWD_QUIET_CFG     3

/*15:4 Unused
 */
/******************************************************************************/
/* END --- SONET SERIAL PORT REGISTERS */


/* START --- SONET RX REGISTERS */
/******************************************************************************/
/*RL_SOH_CFG Register*/

/*Offset/Default definition.*/
#define ixf18100_RL_SOH_CFG_OFFSET   ixf18100_SONET_REG(0x0100)
#define ixf18100_RL_SOH_CFG_DFLT     0x0200

/*---------Shift and mask defines.------*/

/*RxLineXLOS controls the polarity of input external LOS */
#define ixf18100_sRX_LINE_XLOS_CFG   0
  
/*This bit enables/disables automatic AIS generation by the LOH
 *processor because of an active J0MsMtchSt (page 219). */
#define ixf18100_sAIS_JOMM_EN        3

/*This bit forces AIS generation by the LOH process via software. */
#define ixf18100_sSOH_AIS_FRC        4
 
/*This bit enables/disables automatic AIS generation by the LOH
 *processor because of a external Loss of Signal (xLOS) condition. */
#define ixf18100_sAIS_XLOS_EN        5

/*This bit enables/disables automatic AIS generation by the LOH
 *processor because of the internally detected Loss of Signal condition. */
#define ixf18100_sAIS_LOS_EN         6

/*This bit enables/disables automatic AIS generation by the LOH
 *processor because of a Loss of Frame condition. */
#define ixf18100_sAIS_LOF_EN         7

/*These bits configure the internally generated LOS alarm:  */
#define ixf18100_sLOS_CFG            9
#define ixf18100_mLOS_CFG            (0x03 << ixf18100_sLOS_CFG)

#define ixf18100_LOS_CFG_All_0_20_US        (0x0 << ixf18100_sLOS_CFG)
#define ixf18100_LOS_CFG_NO_TRANS_20_US     (0x1 << ixf18100_sLOS_CFG)
#define ixf18100_LOS_CFG_All_0_25_US        (0x2 << ixf18100_sLOS_CFG)
#define ixf18100_LOS_CFG_NO_TRANS_25_US     (0x3 << ixf18100_sLOS_CFG)

/*This bit configures the number of consecutive erroneous frame words
 *to be detected before going to an Out of Frame condition after the frame
 *has been synchronized: */
#define ixf18100_sOOF_CFG            12
#define ixf18100_mOOF_CFG            (0x03 << ixf18100_sOOF_CFG)

#define ixf18100_OOF_CFG_TWO_FRAMES         (0x0 << ixf18100_sOOF_CFG)
#define ixf18100_OOF_CFG_THREE_FRAMES       (0x1 << ixf18100_sOOF_CFG)
#define ixf18100_OOF_CFG_FOUR_FRAMES        (0x2 << ixf18100_sOOF_CFG)
#define ixf18100_OOF_CFG_FIVE_FRAMES        (0x3 << ixf18100_sOOF_CFG)

/*This bit is used to disable the receive descrambler operation. */
#define ixf18100_sDESCRMBL_DSBL      15

/******************************************************************************/

/******************************************************************************/
/*RL_FRM_OFFSET Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_FRM_OFFSET_OFFSET    ixf18100_SONET_REG(0x0101)
#define ixf18100_RL_FRM_OFFSET_DFLT      0x0000

/*---------Shift and mask defines.------*/

/*Bits 15:0 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/*RL_LOF_LMN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_LOF_LMN_OFFSET       ixf18100_SONET_REG(0x0102)
#define ixf18100_RL_LOF_LMN_DFLT         0x6058

/*---------Shift and mask defines.------*/

/*After an LOF event is observed (indicated by an LofSt = RL_SOH_S[0] =
 *1), this number represents the N parameter. N is the number
 *of frames having OofSt = 0 that result in re-entering the
 *NORM state from the LOF state (indicated by an LofSt = RL_SOH_S[1] =
 *0). Note that a value of 0 behaves like a value of 32.*/
#define ixf18100_sN                     0
#define ixf18100_mN                     (0x1F << ixf18100_sN)

/*After an OOF event is observed (indicated by OofSt = RL_SOH_S[0] = 1
 *), this number represents the M parameter. M is the number of
 *frames having OofSt = 0 that result in re-entering the NORM
 *state before entering the LOF state. Note that a value of 0 behaves like a
 *value of 32.*/
#define ixf18100_sM                     5
#define ixf18100_mM                     (0x1F << ixf18100_sM)

/*After an OOF event is observed (indicated by OofSt = RL_SOH_S[0] = 1),
 *this number represents the L parameter. L is the number of
 *frames having OofSt = RL_SOH_S[0] = 1 status that result in
 *entering the LOF state (indicated by an LofSt = RL_SOH_S[1] = 1).
 *Note that a value of 0 behaves like a value of 32.*/
#define ixf18100_sL                     10
#define ixf18100_mL                     (0x1F << ixf18100_sL)

/******************************************************************************/

/******************************************************************************/
/* Receive J0 trace access registers */
/*RL_JO_ESTRA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J0_ESTRA_OFFSET         ixf18100_SONET_REG(0x0103)
#define ixf18100_RL_J0_ESTRA_DFLT           0x0000

/*RL_J0_ASTRA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J0_ASTRA_OFFSET			ixf18100_SONET_REG(0x0104)
#define ixf18100_RL_J0_ASTRA_DFLT			0x0000


/*---------Shift and mask defines.------*/

/*Bits [7:0] represent the data value.*/
#define ixf18100_sRL_TRACE_DATA         0
#define ixf18100_mRL_TRACE_DATA         (0xFF << ixf18100_sRL_TRACE_DATA)

/*Bits [5:0] represent the string pointer value (RAM address). */
#define ixf18100_sRL_TRACE_ADDR         8
#define ixf18100_mRL_TRACE_ADDR         (0x3F << ixf18100_sRL_TRACE_ADDR)

/*ExpcJ0StrgRead is the Read Command operational bit for
 *the expected J0 string internal RAM. */
#define ixf18100_sRL_TRACE_READ			14
#define ixf18100_mRL_TRACE_READ			(0x01 << ixf18100_sRL_TRACE_READ)

/*ExpcJ0 StrgWrite is the Write Command operational bit for
 *the expected J0 string internal RAM. */
#define ixf18100_sRL_TRACE_WRITE        15

/******************************************************************************/


/******************************************************************************/
/* RL_J0_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J0_CFG_OFFSET       ixf18100_SONET_REG(0x0105)
#define ixf18100_RL_J0_CFG_DFLT         0x0002

/*---------Shift and mask defines.------*/

/*These bits configure the J0 Receive Trace Identifier format. */
#define ixf18100_sRL_TRACE_CFG             0
#define ixf18100_mRL_TRACE_CFG             (0x7 << ixf18100_sRL_TRACE_CFG)

#define ixf18100_RL_TRACE_CFG_1_BYTE              (0x0 << ixf18100_sRL_TRACE_CFG)    /*0x00X*/
#define ixf18100_RL_TRACE_CFG_NO_TRACE            (0x2 << ixf18100_sRL_TRACE_CFG)    /*0x01X*/
#define ixf18100_RL_TRACE_CFG_16_CRC7             (0x4 << ixf18100_sRL_TRACE_CFG)    /*0x10X*/
#define ixf18100_RL_TRACE_CFG_FREE_64             (0x6 << ixf18100_sRL_TRACE_CFG)    /*0x110*/
#define ixf18100_RL_TRACE_CFG_FRAMED_64_LF_CR     (0x7 << ixf18100_sRL_TRACE_CFG)    /*0x111*/ 

/*This bit configures the number of identical received
 *consecutive Section Traces needed for the bit J0UnstableSt
 *in register RL_SOH_S alarm to be cleared and for the
 *received section trace to be declared stable and accepted. */
#define ixf18100_sJ0_STABLE_CFG         3

/*This bit configures the setting of the Rs-Tim alarm (ie:
 *J0MsMtchSt) when the trace is unstable. */
#define ixf18100_sJ0MM_ON_UNSTABLE_EN   4

/*This bit configures the setting of the Rst-Tim alarm (ie:
 *J0MsMtchSt) when the CRC7 is wrong. */
#define ixf18100_sJ0MM_ON_CRC7_ERR_DSBL 5 

/******************************************************************************/

/******************************************************************************/
/* RL_SOH_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_SOH_IS_OFFSET   ixf18100_SONET_REG(0x0110)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the OofSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sOOF               0
#define ixf18100_mOOF               (0x1 << ixf18100_sOOF)

/*Lof This bit is set when there is a change in the LofSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sLOF               1
#define ixf18100_mLOF               (0x1 << ixf18100_sLOF)

/*This bit is set when there is a change in the ExtLosSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sEXT_LOS           2
#define ixf18100_mEXT_LOS           (0x1 << ixf18100_sEXT_LOS)

/*IntLos This bit is set when there is a change in the IntLosSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sINT_LOS           3
#define ixf18100_mINT_LOS           (0x1 << ixf18100_sINT_LOS)

/*This bit is set when there is a change in the J0Crc7ErrSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sJ0_CRC7_ERR       4

/*This bit is set when there is a change in the J0MsMtchSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sJ0_MSMTCH         5

/*This bit is set when there is a change in the J0UnstableSt bit (register
 *RL_SOH_S). It is cleared when this register is read. */
#define ixf18100_sJ0_UNSTABLE       6

/*This bit is set when the RL_B1BLK_ECNT error counter rollover occurs.
 *It is cleared when this register is read. */
#define ixf18100_sB1_BLK_OVRFLW     7

/*This bit is set when the RL_B1BIP_ECNT error counter rollover occurs. It
 *is cleared when this register is read. */
#define ixf18100_sB1_BIP_OVRFLW     8

/*This bit is set when the RL_OOF_ECNT error counter rollover occurs. It
 *is cleared when this register is read. */
#define ixf18100_sOOF_OVRFLW        9

/******************************************************************************/

/******************************************************************************/
/* RL_SOH_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_SOH_IE_OFFSET   ixf18100_SONET_REG(0x0111)
#define ixf18100_RL_SOH_IE_DFLT     0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active-high enable for the Oof interrupt bit.  */
#define ixf18100_sOOF_EN                0

/*This bit is an active-high enable for the Lof interrupt bit. */
#define ixf18100_sLOF_EN                1

/*This bit is an active-high enable for the ExtLos interrupt bit. */
#define ixf18100_sEXT_LOS_EN            2

/*This bit is an active-high enable for the IntLos interrupt bit. */
#define ixf18100_sINT_LOS_EN            3

/*This bit is an active-high enable for the J0Crc7Err interrupt bit. */
#define ixf18100_sJ0_CRC7_ERR_EN        4

/*This bit is an active-high enable for the J0MsMtch interrupt bit. */
#define ixf18100_sJ0_MSMTCH_EN      5

/*This bit is an active-high enable for the J0Unstable interrupt bit. */
#define ixf18100_sJ0_UNSTABLE_EN        6

/*This bit is an active-high enable for the B1BlkOvrFlw interrupt
 *bit. */
#define ixf18100_sB1_BLK_OVRFLW_EN      7

/*This bit is an active-high enable for the B1BitOvrFlw interrupt
 *bit. */
#define ixf18100_sB1_BIP_OVRFLW_EN      8

/*This bit is an active-high enable for the OofOvrFlw interrupt bit.*/
#define ixf18100_sOOF_OVERFLW_EN        9
/******************************************************************************/

/******************************************************************************/
/* RL_SOH_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_SOH_S_OFFSET        ixf18100_SONET_REG(0x0112)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit marks the present status of Out of Frame detect */
#define ixf18100_sOOF_ST            0
#define ixf18100_mOOF_ST            (0x1 << ixf18100_sOOF_ST)

/*This bit marks the present status of Loss of Frame detect */
#define ixf18100_sLOF_ST            1
#define ixf18100_mLOF_ST            (0x1 << ixf18100_sLOF_ST)

/*This bit marks the present status of external Loss of Signal (xLOS) input
 *alarm */
#define ixf18100_sEXT_LOS_ST        2
#define ixf18100_mEXT_LOS_ST        (0x1 << ixf18100_sEXT_LOS_ST)

/*This bit marks the present status of Internal Loss of Signal detect */
#define ixf18100_sINT_LOS_ST        3
#define ixf18100_mINT_LOS_ST        (0x1 << ixf18100_sINT_LOS_ST)

/*This bit marks the present status of comparison between received and
 *calculated J0 string CRC-7 value (if 16 byte trace format) */
#define ixf18100_sJ0_CRC7_ERR_ST    4

/*This bit marks the present status of comparison between received and
 *expected J0 string (Trace Identifier Mismatch) */
#define ixf18100_sJ0_MSMTCH_ST      5

/*This bit marks the present status of receive unstable/stable section trace
 *detect (accepted trace when stable). */
#define ixf18100_sJ0_UNSTABLE_ST    6
/******************************************************************************/

/******************************************************************************/
/* RL_OOF_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_OOF_ECNT_OFFSET     ixf18100_SONET_REG(0x0113)
/*Default value not applicable tothis register*/

/*---------Shift and mask defines.------*/

/*This field indicates the OOF error count value.  */
#define ixf18100_sOOF_CNT               0
#define ixf18100_mOOF_CNT               (0x1FFF << ixf18100_sOOF_CNT)

/*15:13 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_B1BIP_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_B1BIP_ECNT_OFFSET   ixf18100_SONET_REG(0x0114)
#define ixf18100_RL_B1BIP_ECNT_DFLT     0x0000

/*---------Shift and mask defines.------*/

/*This field indicates the B1 error count value. */
#define ixf18100_sB1_ERR_CNT             0
#define ixf18100_mB1_ERR_CNT             (0xFFFF << ixf18100_sB1_ERR_CNT)

/******************************************************************************/

/******************************************************************************/
/* RL_B1BLK_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_B1BLK_ECNT_OFFSET    ixf18100_SONET_REG(0x0115)
#define ixf18100_RL_B1BLK_ECNT_DFLT      0x0000

/*---------Shift and mask defines.------*/

/*This field indicates the B1 block error count value. */
#define ixf18100_sB1_BLK_CNT             0
#define ixf18100_mB1_BLK_CNT             (0x1FFF << ixf18100_sB1_BLK_CNT)

/*15:13 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_LOH_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_LOH_CFG_OFFSET      ixf18100_SONET_REG(0x0140)
#define ixf18100_RL_LOH_CFG_DFLT        0x0180

/*---------Shift and mask defines.------*/

/*This bit configures the block size of a concatenated frame for B2
 *detected errored blocks and REI generated errored block (see
 *GenReiCnf bit). */
#define ixf18100_sBLK_ERR_CFG               0

/*This bit forces the generation of RDI-L (to be inserted in
 *outgoing transmit K2[2:0] = 110). */
#define ixf18100_sRDI_FRC                   1

/*This bit enables the generation RDI-L (to be inserted in
 *outgoing transmit K2[2:0] = 110) during active ExcB2ErrSt. */
#define ixf18100_sRDI_ON_EXC_B2_EN          2

/*This bit configures the REI-L byte(s) generated for reflection as 1-byte or
 *2-bytes. */
#define ixf18100_sENH_REI_CFG               3

/*This bit configures generated REI (based on B2 BIP detected errors) for
 *reflection, as block or bip for STS-192c frame formats. */
#define ixf18100_sGEN_REI_CNF               4

/*This bit enables/disables automatic AIS generation from the LOH section
 *to the PT section. */
#define ixf18100_sAIS_EN                    5

/*This bit forces AIS generation from the LOH section to the PT section via
 *software. */
#define ixf18100_sAIS_FRC                   6

/*This bit enables the insertion of AIS from LOH section towards PT
 *section and generation of SF when ExcB2ErrSt bit (register
 *RL_LOH_S[3]) is set. */
#define ixf18100_sAIS_ON_EXC_B2_EN          7

/*RdiSt Alarm */
#define ixf18100_sRDI_DET_CNT               8
#define ixf18100_mRDI_DET_CNT               (0x3 << ixf18100_sRDI_DET_CNT)

#define ixf18100_MRS_ALARM_3_FRAMES  (0x0 << ixf18100_sRDI_DET_CNT)
#define ixf18100_MRS_ALARM_5_FRAMES  (0x1 << ixf18100_sRDI_DET_CNT)     
#define ixf18100_MRS_ALARM_10_FRAMES (0x2 << ixf18100_sRDI_DET_CNT)     
#define ixf18100_MRS_ALARM_16_FRAMES (0x3 << ixf18100_sRDI_DET_CNT)     
    
/*This bit configures the number of consecutive received K2 bytes
 *that must have the RDI bits equal to or different from 111 for the
 *AisSt alarm in register RL_LOH_S to be updated. */
#define ixf18100_sAIS_DET_CNT               10

/*This bit configures the basis for detecting DSD (Degraded Signal
 Defect). */
#define ixf18100_sDSD_DET_CFG               11

/*This bit configures the basis for detecting EED (Excessive Error
 *Defect). */
#define ixf18100_sEED_DET_CFG               12

/*This bit configures the filtering of the receive K1 and K2 APS bytes
 *(either a single APS channel or two independent channels). */
#define ixf18100_sAPS_FILT_CFG              13

/******************************************************************************/

/******************************************************************************/
/* RL_WINSZ_SB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_WINSZ_SB2_OFFSET        ixf18100_SONET_REG(0x0141)
#define ixf18100_RL_WINSZ_SB2_DFLT          0x0000

/*---------Shift and mask defines.------*/

/*These bits configure the number of frames per window. */
#define ixf18100_sEXC_B2_SET_WIN_SZ     0
#define ixf18100_mEXC_B2_SET_WIN_SZ     (0x7FF << ixf18100_sEXC_B2_SET_WIN_SZ)

/*15:11 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_CWIN_SB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_CWIN_SB2_OFFSET     ixf18100_SONET_REG(0x0142)
#define ixf18100_RL_CWIN_SB2_DFLT       0x0003

/*---------Shift and mask defines.------*/

/*The value placed in this register sets the number of
 *consecutive windows that must be excessively errored
 *in order to set the ExcB2ErrSt bit (register RL_LOH_S).
 *Note: If ExcB2ErrSt is clear and this register is set to
 *zero, ExcB2ErrSt will never be set.*/
#define ixf18100_sEXC_B2_SET_WIN_NUM        0               
#define ixf18100_mEXC_B2_SET_WIN_NUM        (0x7F << ixf18100_sEXC_B2_SET_WIN_NUM)

/*15:7 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_ENUM_EXCWIN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_ENUM_EXCWIN_OFFSET  ixf18100_SONET_REG(0x0143)
#define ixf18100_RL_ENUM_EXCWIN_DFLT    0x002B

/*---------Shift and mask defines.------*/

/*This value configures the minimum number of errors
 *that a window must contain to be considered an
 *excessively errored window. Note: Setting this value to
 *zero will cause every window to be considered an
 *excessively errored window.*/
#define ixf18100_sEXC_B2_MIN             0
#define ixf18100_mEXC_B2_MIN             (0x3FFF << ixf18100_sEXC_B2_MIN)

/*15:14 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_WINSZ_CB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_WINSZ_CB2_OFFSET    ixf18100_SONET_REG(0x0144)
#define ixf18100_RL_WINSZ_CB2_DFLT      0x0000

/*---------Shift and mask defines.------*/

/*This value configures the number of frames per window */
#define ixf18100_sEXC_B2_CLR_WIN_SZ     0     
#define ixf18100_mEXC_B2_CLR_WIN_SZ     (0x7FF << ixf18100_sEXC_B2_CLR_WIN_SZ)

/*15:11 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_CWIN_CB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_CWIN_CB2_OFFSET     ixf18100_SONET_REG(0x0145)
#define ixf18100_RL_CWIN_CB2_DFLT       0x0003

/*This value configures the number of consecutive non-excessively
 *errored windows needed for the excessive
 *error condition to be cleared. Note: If the ExcB2ErrSt bit
 *(register RL_LOH_S) is set and this register is set to zero,
 *bit ExcB2ErrSt will never be cleared.  */
#define ixf18100_sEXC_B2_CLR_WIN_NUM     0
#define ixf18100_mEXC_B2_CLR_WIN_NUM     (0x7F << ixf18100_sEXC_B2_CLR_WIN_NUM)

/*15:7 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_ENUM_NEXCWIN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_ENUM_NEXCWIN_OFFSET  ixf18100_SONET_REG(0x0146)
#define ixf18100_RL_ENUM_NEXCWIN_DFLT    0x0008

/*---------Shift and mask defines.------*/

/*This value configures the maximum number of errors that
 *a window can contain and be considered a
 *NonExcessively Errored window. Note: Setting this value
 *to zero will cause every window to be considered a non-excessively
 *errored window.  */
#define ixf18100_sNON_EXC_B2_MAX         0
#define ixf18100_mNON_EXC_B2_MAX         (0x3FFF << ixf18100_sNON_EXC_B2_MAX)

/*15:14 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_WINSZ_SDEGB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_WINSZ_SDEGB2_W0_OFFSET      ixf18100_SONET_REG(0x0148)
#define ixf18100_RL_WINSZ_SDEGB2_W1_OFFSET      ixf18100_SONET_REG(0x0147)
#define ixf18100_RL_WINSZ_SDEGB2_DFLT           0x0000

/*---------Shift and mask defines.------*/

/*This value configures the number of frames per window. */
#define ixf18100_sDEG_B2_SET_WIN_SZ_W0  0             
#define ixf18100_mDEG_B2_SET_WIN_SZ_W0 (0xFFFF << ixf18100_sDEG_B2_SET_WIN_SZ_W0)

#define ixf18100_sDEG_B2_SET_WIN_SZ_W1  0             
#define ixf18100_mDEG_B2_SET_WIN_SZ_W1 (0x7F << ixf18100_sDEG_B2_SET_WIN_SZ_W1)

/*31:23 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_CWIN_SDEGB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_CWIN_SDEGB2_OFFSET  ixf18100_SONET_REG(0x0149)
#define ixf18100_RL_CWIN_SDEGB2_DFLT    0x0003

/*---------Shift and mask defines.------*/

/*This value configures the number of consecutive
 *windows that must be error degraded (Degraded Signal
 *Defect) in order to set the DegB2ErrSt bit (register
 *RL_LOH_S). Note: If DegB2ErrSt is clear and this
 *register is set to zero, DegB2ErrSt will never be set. */
#define ixf18100_sDEG_B2_SET_WIN_NUM    0
#define ixf18100_mDEG_B2_SET_WIN_NUM    (0x7F << ixf18100_sDEG_B2_SET_WIN_NUM)

/*15:7 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_ENUM_DEGWIN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_ENUM_DEGWIN_OFFSET      ixf18100_SONET_REG(0x014A)
#define ixf18100_RL_RL_ENUM_DEGWIN_DFLT     0x002B

/*---------Shift and mask defines.------*/

/*This value configures the number of consecutive
 *windows that must be error degraded (Degraded Signal
 *Defect) in order to set the DegB2ErrSt bit (register
 *RL_LOH_S). Note: If DegB2ErrSt is clear and this
 *register is set to zero, DegB2ErrSt will never be set. */
#define ixf18100_sDEG_B2_MIN                0
#define ixf18100_mDEG_B2_MIN                (0x3FFF << ixf18100_sDEG_B2_MIN)

/*15:14 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_WINSZ_CDEGB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_WINSZ_CDEGB2_W0_OFFSET      ixf18100_SONET_REG(0x014C)
#define ixf18100_RL_WINSZ_CDEGB2_W1_OFFSET      ixf18100_SONET_REG(0x014B)
#define ixf18100_RL_WINSZ_CDEGB2_DFLT           0x0000

/*---------Shift and mask defines.------*/

/*DegB2ClrWinSz[22:0] This value configures the number of frames per window
 *equal to 8*(DegB2ClrWinSz[22:0]+1).
 */
#define ixf18100_sDEG_B2_CLR_WIN_SZ_W0         0
#define ixf18100_mDEG_B2_CLR_WIN_SZ_W0         (0xFFFF << ixf18100_sDEG_B2_CLR_WIN_SZ_W0)

#define ixf18100_sDEG_B2_CLR_WIN_SZ_W1         0
#define ixf18100_mDEG_B2_CLR_WIN_SZ_W1         (0x7F << ixf18100_sDEG_B2_CLR_WIN_SZ_W1)

/*31:23 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_CWIN_CDEGB2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_CWIN_CDEGB2_OFFSET      ixf18100_SONET_REG(0x014D)
#define ixf18100_RL_CWIN_CDEGB2_DFLT        0x0003

/*---------Shift and mask defines.------*/

/*This value configures the number of consecutive non-degraded
 *Error Rate windows needed for the Degraded
 *error rate condition to be cleared. Note: If the DegB2ErrSt
 *bit (register RL_LOH_S) is set and this register is set to
 *zero, bit DegB2ErrSt will never be cleared. */
#define ixf18100_sDEG_B2_CLR_WIN_NUM         0
#define ixf18100_mDEG_B2_CLR_WIN_NUM         (0x7F << ixf18100_sDEG_B2_CLR_WIN_NUM)

/*15:7 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_ENUM_NDEGWIN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_ENUM_NDEGWIN_OFFSET    ixf18100_SONET_REG(0x014E)
#define ixf18100_RL_ENUM_NDEGWIN_DFLT      0x0008

/*---------Shift and mask defines.------*/

/*This value configures the maximum number of errors that
 *a window can contain and be considered a
 *NonDegraded Error Rate window. Note: Setting this
 *value to zero will cause every window to be considered a
 *non-degraded error rate window. */
#define ixf18100_sDEG_B2_MAX               0
#define ixf18100_mDEG_B2_MAX               (0x3FFF << ixf18100_sDEG_B2_MAX)

/*15:14 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_LOH_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_LOH_IS_OFFSET       ixf18100_SONET_REG(0x0150)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the AislSt bit (register
 *RL_LOH_S). It is cleared when this register is read. */
#define ixf18100_sAISL              0
#define ixf18100_mAISL              (0x1 << ixf18100_sAISL)

/*This bit is set when there is a change in the ExcB2ErrSt bit (register
 *RL_LOH_S). It is cleared when this register is read. */
#define ixf18100_sEXC_B2_ERR        1
#define ixf18100_mEXC_B2_ERR        (0x1 << ixf18100_sEXC_B2_ERR)

/*This bit is set when there is a change in the RdilSt bit (register
 *RL_LOH_S). It is cleared when this register is read.*/
#define ixf18100_sRDIL              2
#define ixf18100_mRDIL              (0x1 << ixf18100_sRDIL)

/*This bit is set when there is a change in the SFSt bit (register
 *RL_LOH_S). It is cleared when this register is read. */
#define ixf18100_sSF                3
#define ixf18100_mSF                (0x1 << ixf18100_sSF)

/*This bit is set when there is a change in the DegB2ErrSt bit (register
 *RL_LOH_S). It is cleared when this register is read */
#define ixf18100_sDEG_B2_ERR        4

/*This bit is set when there is a change in K2UnstableSt bit (register
 *RL_LOH_S). It is cleared when this register is read.  */
#define ixf18100_sK2_UNSTABLE       5

/*This bit is set when there is a change in K1UnstableSt bit (register
 *RL_LOH_S). It is cleared when this register is read. */
#define ixf18100_sK1_UNSTABLE       6

/*This bit is set when there is a change in S1UnstableSt bit (register
 *RL_LOH_S). It is cleared when this register is read. */
#define ixf18100_sS1_UNSTABLE       7

/*This bit is set when a RL_REIL_BLK_CNT error counter rollover
 *occurs. It is cleared when this register is read. */
#define ixf18100_sREIL_BLK_OVRFLW   8

/*This bit is set when a RL_REIL_BIP_CNT error counter rollover
 *occurs. It is cleared when this register is read. */
#define ixf18100_sREIL_BIP_OVRFLW   9

/*This bit is set when a RL_B2BLK_ECNT error counter rollover
 *occurs. It is cleared when this register is read. */
#define ixf18100_sB2_BLK_OVRFLW     10

/*This bit is set when a RL_B2BIP_ECNT error counter rollover
 *occurs. It is cleared when this register is read. */
#define ixf18100_sB2_BIP_OVRFLW     11

/*This bit is set when there is a change in the RL_K2K1 register
 register. It is cleared when that register is read. */
#define ixf18100_sK2_CHG            12

/*This bit is set when there is a change in RL_K2K1 register register. It
 *is cleared when that register is read. */
#define ixf18100_sK1_CHG            13

/*This bit is set when there is a change in the RL_S1 register. It is
 *cleared when that register is read.  */
#define ixf18100_sS1_CHG            14

/*Value defines*/

/*15 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_LOH_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_LOH_IE_OFFSET       ixf18100_SONET_REG(0x0151)
#define ixf18100_RL_LOH_IE_DFLT         0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active-high enable for the Aisl interrupt bit.  */
#define ixf18100_sAISL_EN               0

/*This bit is an active-high enable for the ExcB2Err interrupt bit.  */
#define ixf18100_sEXC_B2_ERR_EN         1

/*This bit is an active-high enable for the Rdil interrupt bit.  */
#define ixf18100_sRDIL_EN               2

/*This bit is an active-high enable for the SF interrupt bit.  */
#define ixf18100_sSF_EN                 3

/*DegB2ErrEn (SDEn) This bit is an active-high enable for the DegB2Err interrupt bit */
#define ixf18100_sDEG_B2_ERR_EN         4

/*This bit is an active-high enable for the K2Unstable interrupt bit. */
#define ixf18100_sK2_UNSTABLE_EN        5

/*This bit is an active-high enable for the K1Unstable interrupt bit. */
#define ixf18100_sK1_UNSTABLE_EN        6

/*This bit is an active-high enable for the S1Unstable interrupt bit. */
#define ixf18100_sS1_UNSTABLE_EN        7

/*This bit is an active-high enable for the ReilBlkOvrFlw interrupt
 *bit. */
#define ixf18100_sREIL_BLK_OVRFLW_EN    8

/*This bit is an active-high enable for the ReilBitOvrFlw interrupt bit.  */
#define ixf18100_sREIL_BIP_OVRFLW_EN    9

/*This bit is an active-high enable for the B2BlkOvrFlw interrupt bit. */
#define ixf18100_sB2_BLK_OVRFLW_EN      10

/*This bit is an active-high enable for the B2BitOvrFlw interrupt bit. */
#define ixf18100_sB2_BIP_OVRFLW_EN      11

/*This bit is an active-high enable for the K2Chg interrupt bit. */
#define ixf18100_sK2_CHG_EN             12

/*This bit is an active-high enable for the K1Chg interrupt bit. */
#define ixf18100_sK1_CHG_EN             13

/*This bit is an active-high enable for the S1Chg interrupt bit. */
#define ixf18100_sS1_CHG_EN             14

/*15 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_LOH_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_LOH_S_OFFSET        ixf18100_SONET_REG(0x0152)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*This bit marks the present status of Detection of 111 in K2[2:0]
 *bits. */
#define ixf18100_sAISL_ST           0
#define ixf18100_mAISL_ST           (0x1 << ixf18100_sAISL_ST)

/*This bit marks the present status of excessive BER detects */
#define ixf18100_sEXC_B2_ERR_ST     1
#define ixf18100_mEXC_B2_ERR_ST     (0x1 << ixf18100_sEXC_B2_ERR_ST)

/*This bit indicates detection of 110 in K2[2:0] bits. */
#define ixf18100_sRDIL_ST           2
#define ixf18100_mRDIL_ST           (0x1 << ixf18100_sRDIL_ST)

/*This bit indicates the present status of the Signal Fail detect. */
#define ixf18100_sSF_ST             3
#define ixf18100_mSF_ST             (0x1 << ixf18100_sSF_ST)

/*This bit indicates the present status of the Degraded Signal Defect
 *detection (Degraded BER detects).*/
#define ixf18100_sDEG_B2_ERR_ST     4
#define ixf18100_mDEG_B2_ERR_ST     (0x1 << ixf18100_sDEG_B2_ERR_ST)

/*This bit marks the present status of receive unstable/stable K1
 *APS detect */
#define ixf18100_sK2_UNSTABLE_ST    5

/*This bit marks the present status of receive unstable/stable K1
 *APS detect  */
#define ixf18100_sK1_UNSTABLE_ST    6

/*This bit marks the present status of receive unstable/stable S1
 *Synchronization Message detect  */
#define ixf18100_sS1_UNSTABLE_ST    7

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_K2_K1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_K2_K1_OFFSET        ixf18100_SONET_REG(0x0153)
/* The following alias is included to allow consistent
** naming between RL and TL Registers. */
#define ixf18100_RL_K1_K2_OFFSET        ixf18100_RL_K2_K1_OFFSET
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*7:0 K2[7:0] 
 *These bits are the filtered K2 byte
 */
#define ixf18100_sK2                0
#define ixf18100_mK2                (0xFF << ixf18100_sK2)

/*15:8 K1[7:0] 
 *These bits are the filtered K1 byte
 */
#define ixf18100_sK1                8
#define ixf18100_mK1                (0xFF << ixf18100_sK1)

/******************************************************************************/

/******************************************************************************/
/* RL_S1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_S1_OFFSET       ixf18100_SONET_REG(0x0154)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*7:0  S1[7:0] 
 *These bits are the filtered S1 byte
 */
#define ixf18100_sS1             0
#define ixf18100_mS1             (0xFF << ixf18100_sS1)

/*15:8 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_B2BLK_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_B2BLK_ECNT_W0_OFFSET        ixf18100_SONET_REG(0x0161)
#define ixf18100_RL_B2BLK_ECNT_W1_OFFSET        ixf18100_SONET_REG(0x0160)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*These bits are the B2 Block Error Count Value.  */
#define ixf18100_sB2_BLK_CNT_W0        0               
#define ixf18100_mB2_BLK_CNT_W0        (0xFFFF << ixf18100_sB2_BLK_CNT_W0)
#define ixf18100_sB2_BLK_CNT_W1        0               
#define ixf18100_mB2_BLK_CNT_W1        (0xFFFF << ixf18100_sB2_BLK_CNT_W1)

/******************************************************************************/

/******************************************************************************/
/* RL_B2BIP_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_B2BIP_ECNT_W0_OFFSET    ixf18100_SONET_REG(0x0163)
#define ixf18100_RL_B2BIP_ECNT_W1_OFFSET    ixf18100_SONET_REG(0x0162)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*23:0  B2BipCnt[23:0] 
 *These bits are the B2 BIP Error Count Value.
 */
#define ixf18100_sB2_BIP_CNT_W0             0
#define ixf18100_mB2_BIP_CNT_W0             (0xFFFF << ixf18100_sB2_BIP_CNT_W0)

#define ixf18100_sB2_BIP_CNT_W1             0
#define ixf18100_mB2_BIP_CNT_W1             (0xFFFF << ixf18100_sB2_BIP_CNT_W1)

/******************************************************************************/

/******************************************************************************/
/* RL_REIL_BLK_CNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_REIL_BLK_CNT_W0_OFFSET      ixf18100_SONET_REG(0x0165)
#define ixf18100_RL_REIL_BLK_CNT_W1_OFFSET      ixf18100_SONET_REG(0x0164)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*These bits are the REI-L Block Count Value. */
#define ixf18100_sREIL_BLK_CNT_W0           0
#define ixf18100_mREIL_BLK_CNT_W0           (0xFFFF << ixf18100_sREIL_BLK_CNT_W0)
                                 
#define ixf18100_sREIL_BLK_CNT_W1           0
#define ixf18100_mREIL_BLK_CNT_W1           (0xFFFF << ixf18100_sREIL_BLK_CNT_W1)

/******************************************************************************/

/******************************************************************************/
/* RL_REIL_BIP_CNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_REIL_BIP_CNT_W0_OFFSET  ixf18100_SONET_REG(0x0167)
#define ixf18100_RL_REIL_BIP_CNT_W1_OFFSET  ixf18100_SONET_REG(0x0166)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*These bits are the REI-L BIP Count Value.  */
#define ixf18100_sREIL_BIP_CNT_W0        0  
#define ixf18100_mREIL_BIP_CNT_W0       (0xFFFF << ixf18100_sREIL_BIP_CNT_W0)

#define ixf18100_sREIL_BIP_CNT_W1        0  
#define ixf18100_mREIL_BIP_CNT_W1       (0xFFFF << ixf18100_sREIL_BIP_CNT_W1)

/******************************************************************************/

/******************************************************************************/
/* RL_PT_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_PT_CFG_OFFSET   ixf18100_SONET_REG(0x0180)
#define ixf18100_RL_PT_CFG_DFLT     0x0008

/*---------Shift and mask defines.------*/

/*This bit enables consideration of H1H2 pointer SS bits during
 *pointer processing. If enabled the SS bits must be set to the
 *expected value ExpcPntrSS[1:0], or a LOP alarm will be
 *generated. */
#define ixf18100_sPNTR_SS_EN        0

/*Bits [1:0] represent the expected value of the receive H1H2
 *Pointer SS two bits when PntrSSEn is Enabled. */
#define ixf18100_sEXPC_PNTR_SS      1
#define ixf18100_mEXPC_PNTR_SS      (0x3 << ixf18100_sEXPC_PNTR_SS)

#define ixf18100_H1H2_Pointer_SS_Value_00 (0x0 << ixf18100_sEXPC_PNTR_SS)
#define ixf18100_H1H2_Pointer_SS_Value_01 (0x1 << ixf18100_sEXPC_PNTR_SS)     
#define ixf18100_H1H2_Pointer_SS_Value_10 (0x2 << ixf18100_sEXPC_PNTR_SS)     
#define ixf18100_H1H2_Pointer_SS_Value_11 (0x3 << ixf18100_sEXPC_PNTR_SS)

/*This bit configures the justification rule (pointer increments/
 *decrements).*/
#define ixf18100_sPNTR_JUST_CFG     3

/*This bit controls whether to generate down-stream path
 *AIS or not in case LOP-c in slave slot is detected. */
#define ixf18100_sLOPC2P_AIS_EN     4

/*This bit controls whether to generate down-stream path
 *AIS or not in case AIS in slave slot is detected. */
#define ixf18100_sAISC2P_AIS_EN     5

/*This bit controls whether to generate down-stream path
 *AIS or not in case LOP in master slot is detected. */
#define ixf18100_sLOP2P_AIS_EN      6

/*This bit controls whether to generate down-stream path
 *AIS or not in case AIS in master slot is detected. */
#define ixf18100_sAIS2P_AIS_EN      7

/*15:8 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_IN_PTR Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_IN_PTR_OFFSET       ixf18100_SONET_REG(0x0181)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*These bits are the incoming pointer value.  */
#define ixf18100_sIN_H1H2_PTR      0
#define ixf18100_mIN_H1H2_PTR      (0x3FF << ixf18100_sIN_H1H2_PTR)

/*15:10 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_IN_PJC Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_IN_PJC_OFFSET   ixf18100_SONET_REG(0x0185)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*10:0  InPJCnt[10:0] 
 *Accumulated justification count value.
 */
#define ixf18100_sIN_PJ_CNT         0
#define ixf18100_mIN_PJ_CNT         (0x7FF << ixf18100_sIN_PJ_CNT)

/*15:11 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_IN_NJC Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_IN_NJC_OFFSET       ixf18100_SONET_REG(0x0186)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*These bits are the accumulated justification count value. */
#define ixf18100_sIN_NJ_CNT             0
#define ixf18100_mIN_NJ_CNT             (0x7FF << ixf18100_sIN_NJ_CNT)

/*15:11 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* RL_PT_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_PT_IS_OFFSET        ixf18100_SONET_REG(0x0190)
/*Default values are not applicable to this register.*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the AispSt bit (register
 *RL_PT_S[0]). */
#define ixf18100_sAISP          0
#define ixf18100_mAISP          (0x1 << ixf18100_sAISP)

/*This bit is set when there is a change in the LopSt bit (register
 *RL_PT_S[1]). */
#define ixf18100_sLOP           1
#define ixf18100_mLOP           (0x1 << ixf18100_sLOP)

/*This bit is set when chip detects NDF on incoming side. */
#define ixf18100_sIN_NDF        3

/*This bit is set when a RL_IN_NJC counter rollover occurs. */
#define ixf18100_sIN_NJ_COVFL   4

/*This bit is set when a RL_IN_PJC counter rollover occurs. */
#define ixf18100_sIN_PJ_COVFL   5

/*This bit is set when there is a change in the AispcSt bit (register
 *RL_PT_S[10]). */
#define ixf18100_sAISPC         10

/*This bit is set when there is a change in the LopcSt bit (register
 *RL_PT_S[11]). */
#define ixf18100_sLOPC          11

/*9:7   Unused
 *15:12 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_PT_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_PT_IE_OFFSET        ixf18100_SONET_REG(0x01A0)
#define ixf18100_RL_PT_IE_DFLT			0x0000

/*---------Shift and mask defines.------*/

/*Active-high enable for the Pais interrupt bit. */
#define ixf18100_sAISP_EN       0

/*Active-high enable for the Lop interrupt bit.*/
#define ixf18100_sLOP_EN        1

/*Active-high enable for the In_NDF interrupt bit. */
#define ixf18100_sIN_NDF_EN     3

/*Active-high enable for the In_NJCovfl interrupt bit. */
#define ixf18100_sEN_NJO_EN     4

/*Active-high enable for the In_PJCovfl interrupt bit. */
#define ixf18100_sIN_PJO_EN     5

/*Active-high enable for the Paisc interrupt bit. */
#define ixf18100_sAISPC_EN      10

/*Active-high enable for the Lopc interrupt bit. */
#define ixf18100_sLOPC_EN       11

/*15:12 Unused
 *9:7   Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_PT_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_PT_S_OFFSET     ixf18100_SONET_REG(0x01B0)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Present status of non-concatenated (master) Pointer processing
 *path AIS defect */
#define ixf18100_sAISP_ST           0
#define ixf18100_mAISP_ST           (0x1 << ixf18100_sAISP_ST)

/*Present status of non-concatenated (master) Loss of Pointer
 *defect */
#define ixf18100_sLOP_ST            1
#define ixf18100_mLOP_ST            (0x1 << ixf18100_sLOP_ST)

/*Present status of concatenated AIS defect. */
#define ixf18100_sAISPC_ST          10

/*Present status of concatenated (slave) Loss of Pointer defect.*/
#define ixf18100_LOPC_ST            11

/*9:2   Unused
 *15:12 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* RL_POH_CFG1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_POH_CFG1_OFFSET     ixf18100_SONET_REG(0x01C0)
#define ixf18100_RL_POH_CFG1_DFLT       0x6002

/*---------Shift and mask defines.------*/
                                                                         
/*Configures the generation of RDI-P (enhanced or not) 
 *for reflection and for output at RPAL interface */
#define ixf18100_sRDIP_GEN_ENH_CFG      0
#define ixf18100_mRDIP_GEN_ENH_CFG      (0x3 << ixf18100_sRDIP_GEN_ENH_CFG)

#define ixf18100_RDIP_GEN_ENH_CFG_ENH_RDPI_GEN       (0x02 << ixf18100_sRDIP_GEN_ENH_CFG)
#define ixf18100_RDIP_GEN_ENH_CFG_NON_GEN_111         (0x01 << ixf18100_sRDIP_GEN_ENH_CFG)  
#define ixf18100_RDIP_GEN_ENH_CFG_NON_GEN_100         (0x00 << ixf18100_sRDIP_GEN_ENH_CFG)

/*Enables generation of reflected RDI-P during AIS-P.*/
#define ixf18100_sAIS2P_RDI_EN          2

/*Enables generation of reflected RDI-P during Concatenated AIS-P. */
#define ixf18100_sAISC2P_RDI_EN         3

/*Enables generation of reflected RDI-P during LOP. */
#define ixf18100_sLOP2P_RDI_EN          4

/*Enables generation of reflected RDI-P during LOPC. */
#define ixf18100_sLOPC2P_RDI_EN         5

/*Enables generation of reflected RDI-P during Uneq. */
#define ixf18100_sUNEQ2P_RDI_EN         6

/*Enables generation of reflected RDI-P during TIM-P. */
#define ixf18100_sTIM2P_RDI_EN          7

/*Enables and configures the reflection of RDI-P during PLM-P.*/
#define ixf18100_sPLMP2P_RDI_EN         8
#define ixf18100_mPLMP2P_RDI_EN         (0x3 << ixf18100_sPLMP2P_RDI_EN)

#define ixf18100_PLMP2P_RDI_EN_PAY_DEF     (0x02 << ixf18100_sPLMP2P_RDI_EN)    
#define ixf18100_PLMP2P_RDI_EN_CON_DEF     (0x01 << ixf18100_sPLMP2P_RDI_EN)    
#define ixf18100_PLMP2P_RDI_EN_NOT_GEN     (0x00 << ixf18100_sPLMP2P_RDI_EN)

/*Enables generation of reflected RDI-P during LCD. */
#define ixf18100_sLCD2P_RDI_EN          10

/*This bit configures the setting of the PLM-P alarm (ie: PlmpSt)
 *when the receive C2 is unstable. */
#define ixf18100_sPLMP_ON_C2_UNSTABLE_EN    11

/*This bit configure both the number of consecutive received C2
 *bytes that must have the same value to update the C2 accepted
 *value (register RL_RCV_C2), and the number of different
 *received C2 bytes to activate the C2Unstable alarm (bit 5 in the
 *S register) */
#define ixf18100_sC2_RCV_CFG            12

/*This bit configures the detection of received HPM RDI
 *(considered enhanced or not). */
#define ixf18100_sRDIP_DET_ENH_CFG      13

/*These bits configure the number of received G1 bytes that must have the
 *same value in the RDI bit(s) for the Rdi[2:0] bit(s) (register
 *RL_RCV_G1[3:1]) to be updated. The received G1 RDI bits + spare can
 *be retrieved via register RL_RCV_G1[3:0]. Note that if received RDI is
 *not enhanced (see RdiDetEnhCfg) only bit #3 of G1 is considered in the
 *algorithm. */
#define ixf18100_sRDIP_DET_CNT          14
#define ixf18100_mRDIP_DET_CNT          (0x3 << ixf18100_sRDIP_DET_CNT)

#define ixf18100_RDIP_DET_CNT_16           (0x3 << ixf18100_sRDIP_DET_CNT)
#define ixf18100_RDIP_DET_CNT_10           (0x2 << ixf18100_sRDIP_DET_CNT)      
#define ixf18100_RDIP_DET_CNT_5            (0x1 << ixf18100_sRDIP_DET_CNT)      
#define ixf18100_RDIP_DET_CNT_3            (0x0 << ixf18100_sRDIP_DET_CNT) 
     
/******************************************************************************/


/******************************************************************************/
/* RL_POH_CFG2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_POH_CFG2_OFFSET     ixf18100_SONET_REG(0x01C1)
#define ixf18100_RL_POH_CFG2_DFLT       0x0001

/*---------Shift and mask defines.------*/

/*This bit enables forcing down-stream AIS-P. */
#define ixf18100_sFRC_AIS_EN        0

/*This bit enables generation of down-stream AIS-P during */
#define ixf18100_sUNEQ2P_AIS_EN     1

/*This bit enables generation of down-stream AIS-P during
 *TIM-P. */
#define ixf18100_sTIM2P_AIS_EN      2

/*This bit enables generation of down-stream AIS-P during
 *PLM-P. */
#define ixf18100_sPLMP2P_AIS_EN     3

/*Enables use of fixed stuff in payload mapping. */
#define ixf18100_sPDL_MAP_CNFG      4

/*Enables use of fixed stuff columns in B3 calculation
 *according to. */
#define ixf18100_sB3_CALC_CNFG      5


/*Sets the value of the G1 spare Bit on the RPAL output */
#define ixf18100_sG1_SP_ON_RPAL_CNF 6

/*Configures generation of PLM-P alarm when receiving PDI-P. */
#define ixf18100_sPLMP_ON_PDIP_CFG  7
#define ixf18100_mPLMP_ON_PDIP_CFG  (0x3 << ixf18100_sPLMP_ON_PDIP_CFG)

#define ixf18100_PLMP_ON_PDIP_CFG_NO_PLMP_ALARM    (0x02 << ixf18100_sPLMP_ON_PDIP_CFG)    
#define ixf18100_PLMP_ON_PDIP_CFG_NO_PLMP          (0x01 << ixf18100_sPLMP_ON_PDIP_CFG)    
#define ixf18100_PLMP_ON_PDIP_CFG_PLMP_ALARM       (0x00 << ixf18100_sPLMP_ON_PDIP_CFG)

/*Configures generation of PLM-P and UNEQ-P alarms when receiving. */
#define ixf18100_sC2_EQUAL_FF_CFG   9
#define ixf18100_mC2_EQUAL_FF_CFG   (0x3 << ixf18100_sC2_EQUAL_FF_CFG)

#define ixf18100_C2_EQUAL_FF_CFG_TERMIN     (0x02 << ixf18100_sC2_EQUAL_FF_CFG)    
#define ixf18100_C2_EQUAL_FF_CFG_FROZEN     (0x01 << ixf18100_sC2_EQUAL_FF_CFG)    
#define ixf18100_C2_EQUAL_FF_CFG_NOT_AFF    (0x00 << ixf18100_sC2_EQUAL_FF_CFG)

/*15:11 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* Receive J1 trace access registers */
/* RL_J1_ESTRA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J1_ESTRA_OFFSET     ixf18100_SONET_REG(0x01C2)
#define ixf18100_RL_J1_ESTRA_DFLT       0x0000

/* RL_J1_ASTRA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J1_ASTRA_OFFSET     ixf18100_SONET_REG(0x01C3)
#define ixf18100_RL_J1_ASTRA_DFLT       0x0000

/*---------Shift and mask defines.------*/


/*These defines are shared by all receive trace access registers,
and are defined with the J0 access registers.

#define ixf18100_sRL_TRACE_DATA         0      
#define ixf18100_mRL_TRACE_DATA         (0xFF << ixf18100_sRL_TRACE_DATA)

#define ixf18100_sRL_TRACE_ADDR         8      
#define ixf18100_mRL_TRACE_ADDR         (0x3F << ixf18100_sRL_TRACE_ADDR)

#define ixf18100_sRL_TRACE_READ         14

#define ixf18100_sRL_TRACE_WRITE        15

*/

/******************************************************************************/
/* RL_J1_CFG register */

/*Offset/Default definition for register.*/
#define ixf18100_RL_J1_CFG_OFFSET     ixf18100_SONET_REG(0x01C4)
#define ixf18100_RL_J1_CFG_DFLT       0x0002

/*---------Shift and mask defines.------*/

/*These bits configure the J1 Receive Trace Identifier format. */
#define ixf18100_sJ1_CFG              0
#define ixf18100_mJ1_CFG              (0x7 << ixf18100_sJ1_CFG)
#define ixf18100_vJ1_CFG_CRC7         0x04

/* The values for J1_CFG are defined with ixf18100_RL_J0_CFG_OFFSET. */

/*This bit configures the number of identical received
 *consecutive Path Traces needed for the J1UnstableSt
 *(register S_ HPM bit#5) alarm to be cleared and for the
 *received path trace to be declared stable and accepted. */
#define ixf18100_sJ1_STABLE_CFG       3

/* This bit configures the setting of the J1MsMtchSt bit when
 * the trace is unstable. */
#define ixf18100_sJ1_MM_ON_UNSTABLE   4

/* This bit configures the setting of the J1MsMtchSt when the CRC7 is  
 * wrong. */
#define ixf18100_sJ1_MM_ON_CRC7_ERR   5

/* This bit configures the setting of the J1MsMtchSt when an all zero state   
 * is declared. */
#define ixf18100_sJ1_MM_ON_ALL_ZERO   6


/*15:7 reserved 
 */
/******************************************************************************/


/******************************************************************************/
/* RL_EXP_C2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_EXP_C2_OFFSET   ixf18100_SONET_REG(0x01C5)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*These bits are the expected C2[7:0] byte. */
#define ixf18100_sEXP_C2            0
#define ixf18100_mEXP_C2            (0xFF << ixf18100_sEXP_C2)

/*15:8 Reserved
 */
/******************************************************************************/


/******************************************************************************/
/* RL_RCV_C2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_C2_OFFSET       ixf18100_SONET_REG(0x01C6)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*These bits are the received C2[7:0] byte. */
#define ixf18100_sC2                    0
#define ixf18100_mC2                    (0xFF << ixf18100_sC2)

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_RCV_G1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_G1_OFFSET   ixf18100_SONET_REG(0x01C7)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit corresponds to the received G1 Spare bit. */
#define ixf18100_sG1_SP             0

/*These bits correspond to the filtered, received Remote Defect Indication
 *bits */
#define ixf18100_sRDI               1
#define ixf18100_mRDI               (0x7 << ixf18100_sRDI)

/*These bits correspond to the received Remote Error Indication bits */
#define ixf18100_sREI               4
#define ixf18100_mREI               (0xF << ixf18100_sREI)

/* Entire value mask/shift for this register*/
#define ixf18100_sG1                0
#define ixf18100_mG1                (0xFF << ixf18100_sG1)

/*15:8 Reserved
 */
/******************************************************************************/


/******************************************************************************/
/* RL_B3_BLK_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_B3_BLK_ECNT_OFFSET  ixf18100_SONET_REG(0x01C8)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Receive B3 Block Error Count Value. */
#define ixf18100_sB3_BLK_CNT            0
#define ixf18100_mB3_BLK_CNT            (0xFFFF << ixf18100_sB3_BLK_CNT)

/******************************************************************************/

/******************************************************************************/
/* RL_B3_BIP_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_B3_BIP_ECNT_OFFSET  ixf18100_SONET_REG(0x01C9)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*B3 BIP Error Count Value. */
#define ixf18100_sB3_BIP_CNT            0
#define ixf18100_mB3_BIP_CNT            (0xFFFF << ixf18100_sB3_BIP_CNT)

/******************************************************************************/

/******************************************************************************/
/* RL_REIP_BLK_CNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_REIP_BLK_CNT_OFFSET     ixf18100_SONET_REG(0x01CA)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*REI-P Block Count Value. */
#define ixf18100_sREIP_BLK_CNT              0
#define ixf18100_mREIP_BLK_CNT              (0xFFFF << ixf18100_sREIP_BLK_CNT)

/******************************************************************************/


/******************************************************************************/
/* RL_REIPBIP_CNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_REIP_BIP_CNT_OFFSET     ixf18100_SONET_REG(0x01CB)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*REI-P BIP Count Value. */
#define ixf18100_sREIP_BIP_CNT              0
#define ixf18100_mREIP_BIP_CNT              (0xFFFF << ixf18100_sREIP_BIP_CNT)

/******************************************************************************/


/******************************************************************************/
/* RL_POH_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_POH_IS_OFFSET       ixf18100_SONET_REG(0x01D0)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the VcAisSt bit in register
 *RL_POH_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sVC_AIS            0

/*This bit is set when there is a change in the PlmpSt bit in register
 *RL_POH_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sPLMP_CHG          1
#define ixf18100_mPLMP_CHG          (0x1 << ixf18100_sPLMP_CHG)

/*This bit is set when there is a change in the UnEqpSt bit in register
 *RL_POH_S It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sUN_EQP_CHG        2

/*This bit is set when there is a change in the C2UnstableSt bit in
 *register RL_POH_S. It is cleared when this register RL_POH_IS is
 *read. */
#define ixf18100_sC2_UNSTABLE       3

/*This bit is set when there is a change in the Pdipst bit in register
 *RL_POH_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sPDIP_CHG          4

/*This bit is set when there is a change in the RL_RCV_C2 register. It is
 *cleared when this register RL_POH_IS is read. */
#define ixf18100_sC2_CHG            5

/*This bit is set when the value in the RL_B3BLK_ECNT block counter
 *rollover. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sB3_BLK_OVRFLW     6

/*This bit is set when the value in the RL_B3BIP_ECNT bit counter
 *rollover. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sB3_BIP_OVRFLW     7

/*This bit is set when the value in the RL_REIBLK_CNT block counter
 *rolls over. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sREIP_BLK_OVRFLW   8

/*This bit is set when the value in the RL_REIBIP_CNT bit counter rolls
 *over. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sREIP_BIP_OVRFLW   9

/*This bit is set when the register RL_RCV_G1[3:1] bits (filtered
 *received G1 RDI bits) change (see RdipDetCnt in register
 *RL_POH_CFG1). It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sRDIP_CHG          10
#define ixf18100_mRDIP_CHG          (0x1 << ixf18100_sRDIP_CHG)

/*This bit is set when there is a change in the RL_RCV_Z4/K3 register.
 *It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sZ4_K3_CHG         11

/*This bit is set when there is a change in the RL_RCV_F2 register. It is
 *cleared when this register RL_POH_IS is read. */
#define ixf18100_sF2_CHG            12

/*This bit is set when there is a change in the RL_RCV_H4 register. It is
 *cleared when this register RL_POH_IS is read. */
#define ixf18100_sH4_CHG            13

/*This bit is set when there is a change in the RL_RCV_Z3/F3 register.
 *It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sZ3_F3_CHG         14

/*This bit is set when there is a change in the RL_RCV_Z5/N1 register.
 *It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sZ5_N1_CHG         15

/******************************************************************************/


/******************************************************************************/
/* RL_J1_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J1_IS_OFFSET        ixf18100_SONET_REG(0x01D1)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit is set when there is a change in the J1Crc7St bit in register
 *RL_J1_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sJ1_CRC7_ERR   0

/*This bit is set when there is a change in the J1MsMtchSt bit in register
 *RL_ J1_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sJ1_MSMTCH     1

/*This bit is set when there is a change in the J1UnstableSt bit in
 *register RL_ J1_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sJ1_UNSTABLE   2

/*This bit is set when there is a change in the J1allzeroSt bit in register
 *RL_ J1_S. It is cleared when this register RL_POH_IS is read. */
#define ixf18100_sJ1_ALLZERO    3

/*15:4 Reserved
 */
/******************************************************************************/


/******************************************************************************/
/* RL_POH_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_POH_IE_OFFSET       ixf18100_SONET_REG(0x01D2)
#define ixf18100_RL_POH_IE_DFLT         0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active-high enable for the VcAis interrupt bit. */
#define ixf18100_sVC_AIS_EN             0

/*This bit is an active-high enable for the PlmpChg interrupt bit. */
#define ixf18100_sPLMP_EN               1

/*This bit is an active-high enable for the HpmUnEqp interrupt bit. */
#define ixf18100_sUN_EQP_EN             2

/*This bit is an active-high enable for the C2Unstable interrupt bit. */
#define ixf18100_sC2_UNSTABLE           3

/*This bit is an active-high enable for the PdipChg interrupt bit. */
#define ixf18100_sPDIP_CHG_EN           4

/*This bit is an active-high enable for the C2Chg interrupt bit. */
#define ixf18100_sC2_CHG_EN             5

/*This bit is an active-high enable for the B3BlkOvrFlw interrupt bit. */
#define ixf18100_sB3_BLK_OVRFLW_EN      6

/*This bit is an active-high enable for the B3BitOvrFlw interrupt bit. */
#define ixf18100_sB3_BIP_OVRFLW_EN      7

/*This bit is an active-high enable for the HpmReiBlkOvrFlw
 *interrupt bit. */
#define ixf18100_sREIP_BLK_OVRFLW_EN    8

/*This bit is an active-high enable for the HpmReiBitOvrFlw
 *interrupt bit. */
#define ixf18100_sREIP_BIP_OVRFLW_EN    9

/*This bit is an active-high enable for the Rdip interrupt bit. */
#define ixf18100_sRDIP_CHG_EN           10

/*This bit is an active-high enable for the Z4/K3 interrupt bit. */
#define ixf18100_sZ4_K3_CHG_EN          11

/*This bit is an active-high enable for the F2Chg interrupt bit. */
#define ixf18100_sF2_CHG_EN             12

/*This bit is an active-high enable for the H4Chg interrupt bit. */
#define ixf18100_sH4_CHG_EN             13

/*This bit is an active-high enable for the Z3/F3Chg interrupt bit. */
#define ixf18100_sZ3_F3_CHG_EN          14

/*This bit is an active-high enable for the Z5/N1Chg interrupt bit. */
#define ixf18100_sZ5_N1_CHG_EN          15

/******************************************************************************/


/******************************************************************************/
/* RL_J1_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J1_IE_OFFSET        ixf18100_SONET_REG(0x01D3)
#define ixf18100_RL_J1_IE_DFLT			0x0000

/*---------Shift and mask defines.------*/

/*This bit is an active-high enable for the J1Crc7Err interrupt bit. */
#define ixf18100_sJ1_CRC7_ERR_EN     0

/*This bit is an active-high enable for the J1MsMtch interrupt bit. */
#define ixf18100_sJ1_MSMTCH_EN       1

/*This bit is an active-high enable for the J1Unstable interrupt bit. */
#define ixf18100_sJ1_UNSTABLE_EN     2

/*This bit is an active-high enable for the J1allzero interrupt bit. */
#define ixf18100_sJ1_ALLZERO_EN      3

/*15:4 Reserved
 */
/******************************************************************************/



/******************************************************************************/
/* RL_POH_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_POH_S_OFFSET        ixf18100_SONET_REG(0x01D4)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit indicates the present status of VC AIS detect. */
#define ixf18100_sVC_AIS_ST         0

/*This bit indicates the present status of Signal Label Mismatch
 *detection. */
#define ixf18100_sPLMP_ST           1
#define ixf18100_mPLMP_ST           (0x1 << ixf18100_sPLMP_ST)

/*This bit indicates the present status of unequipped status detection. */
#define ixf18100_sUN_EQP_ST         2

/*This bit indicates the present status of receive unstable/stable path
 *signal label detect. */
#define ixf18100_sC2_UNSTABLE_ST    3

/*This bit indicates the present status of PDI-P detection. */
#define ixf18100_sPDIP_ST           4

/*15:5 Reserved
 */
/******************************************************************************/


/******************************************************************************/
/* RL_J1_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_J1_S_OFFSET     ixf18100_SONET_REG(0x01D5)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*This bit indicates the present status of comparison between received
 *and calculated J1 string CRC-7 value (16 byte string format only). */
#define ixf18100_sJ1_CRC7_ERR_ST        0

/*This bit indicates the present status of comparison between received
 *and expected J1 string. */
#define ixf18100_sJ1_MSMTCH_ST          1

/*This bit indicates the present status of receive unstable/stable path
 *trace detect (accepted trace when stable)*/
#define ixf18100_sJ1_UNSTABLE_ST        2

/*This bit indicates the present status of the detection of an all zero
 *receive stable path trace (accepted trace = all zero). */
#define ixf18100_sJ1_ALLZERO_ST         3

/*15:4 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_POH_CFG3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_POH_CFG3_OFFSET     ixf18100_SONET_REG(0x01DF)
#define ixf18100_RL_POH_CFG3_DFLT       0x1249

/*---------Shift and mask defines.------*/

/*These bits configure the number of received F2 bytes that must
 *have the same value for register RL_RCV_F2 to be updated. */
#define ixf18100_sF2_FLTR_CNT               0 
#define ixf18100_mF2_FLTR_CNT               (0x7 << ixf18100_sF2_FLTR_CNT)

#define ixf18100_F2_FLTR_CNT_20_UPDATE      (0x5 << ixf18100_sF2_FLTR_CNT)      
#define ixf18100_F2_FLTR_CNT_16_UPDATE      (0x4 << ixf18100_sF2_FLTR_CNT)      
#define ixf18100_F2_FLTR_CNT_10_UPDATE      (0x3 << ixf18100_sF2_FLTR_CNT)      
#define ixf18100_F2_FLTR_CNT_5_UPDATE       (0x2 << ixf18100_sF2_FLTR_CNT)      
#define ixf18100_F2_FLTR_CNT_3_UPDATE       (0x1 << ixf18100_sF2_FLTR_CNT)      
#define ixf18100_F2_FLTR_CNT_0_UPDATE       (0x0 << ixf18100_sF2_FLTR_CNT)      

/*These bits configure the number of received H4bytes that must
 *have the same value for register RL_RCV_H4 to be updated. */
#define ixf18100_sH4_FLTR_CNT               3 
#define ixf18100_mH4_FLTR_CNT               (0x7 << ixf18100_sH4_FLTR_CNT)

#define ixf18100_H4_FLTR_CNT_20_UPDATE      (0x5 << ixf18100_sH4_FLTR_CNT)      
#define ixf18100_H4_FLTR_CNT_16_UPDATE      (0x4 << ixf18100_sH4_FLTR_CNT)      
#define ixf18100_H4_FLTR_CNT_10_UPDATE      (0x3 << ixf18100_sH4_FLTR_CNT)      
#define ixf18100_H4_FLTR_CNT_5_UPDATE       (0x2 << ixf18100_sH4_FLTR_CNT)
#define ixf18100_H4_FLTR_CNT_3_UPDATE       (0x1 << ixf18100_sH4_FLTR_CNT)      
#define ixf18100_H4_FLTR_CNT_0_UPDATE       (0x0 << ixf18100_sH4_FLTR_CNT)

/*These bits configure the number of received Z3/F3bytes that
 *must have the same value for register RL_RCV_Z3/F3 to be
 *updated. */
#define ixf18100_sZ3_FLTR_CNT               6 
#define ixf18100_mZ3_FLTR_CNT               (0x7 << ixf18100_sZ3_FLTR_CNT)

#define ixf18100_Z3_FLTR_CNT_20_UPDATE      (0x5 << ixf18100_sZ3_FLTR_CNT)      
#define ixf18100_Z3_FLTR_CNT_16_UPDATE      (0x4 << ixf18100_sZ3_FLTR_CNT)      
#define ixf18100_Z3_FLTR_CNT_10_UPDATE      (0x3 << ixf18100_sZ3_FLTR_CNT)      
#define ixf18100_Z3_FLTR_CNT_5_UPDATE       (0x2 << ixf18100_sZ3_FLTR_CNT)      
#define ixf18100_Z3_FLTR_CNT_3_UPDATE       (0x1 << ixf18100_sZ3_FLTR_CNT)      
#define ixf18100_Z3_FLTR_CNT_0_UPDATE       (0x0 << ixf18100_sZ3_FLTR_CNT)      

/*These bits configure the number of received Z4/K3 bytes that
 *must have the same value for register RL_RCV_Z4/K3 to be
 *updated. */
#define ixf18100_sZ4_FLTR_CNT               9
#define ixf18100_mZ4_FLTR_CNT               (0x7 << ixf18100_sZ4_FLTR_CNT)

#define ixf18100_Z4_FLTR_CNT_20_UPDATE      (0x5 << ixf18100_sZ4_FLTR_CNT)      
#define ixf18100_Z4_FLTR_CNT_16_UPDATE      (0x4 << ixf18100_sZ4_FLTR_CNT)      
#define ixf18100_Z4_FLTR_CNT_10_UPDATE      (0x3 << ixf18100_sZ4_FLTR_CNT)      
#define ixf18100_Z4_FLTR_CNT_5_UPDATE       (0x2 << ixf18100_sZ4_FLTR_CNT)      
#define ixf18100_Z4_FLTR_CNT_3_UPDATE       (0x1 << ixf18100_sZ4_FLTR_CNT)      
#define ixf18100_Z4_FLTR_CNT_0_UPDATE       (0x0 << ixf18100_sZ4_FLTR_CNT)      
 
/*These bits configure the number of received Z5/N1bytes that
 *must have the same value for register RL_RCV_Z5/N1 to be
 *updated. */
#define ixf18100_sZ5_FLTR_CNT               12 
#define ixf18100_mZ5_FLTR_CNT               (0x7 << ixf18100_sZ5_FLTR_CNT)

#define ixf18100_Z5_FLTR_CNT_20_UPDATE      (0x5 << ixf18100_sZ5_FLTR_CNT)      
#define ixf18100_Z5_FLTR_CNT_16_UPDATE      (0x4 << ixf18100_sZ5_FLTR_CNT)      
#define ixf18100_Z5_FLTR_CNT_10_UPDATE      (0x3 << ixf18100_sZ5_FLTR_CNT)      
#define ixf18100_Z5_FLTR_CNT_5_UPDATE       (0x2 << ixf18100_sZ5_FLTR_CNT)      
#define ixf18100_Z5_FLTR_CNT_3_UPDATE       (0x1 << ixf18100_sZ5_FLTR_CNT)      
#define ixf18100_Z5_FLTR_CNT_0_UPDATE       (0x0 << ixf18100_sZ5_FLTR_CNT)
      
/******************************************************************************/

/******************************************************************************/
/* RL_RCV_F2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_F2_OFFSET       ixf18100_SONET_REG(0x01E0)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Bits [7:0] correspond to F2[7:0], respectively. */
#define ixf18100_sF2                    0  
#define ixf18100_mF2                    (0xFF << ixf18100_sF2)

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_RCV_H4 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_H4_OFFSET       ixf18100_SONET_REG(0x01E1)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Bits [7:0] correspond to H4[7:0], respectively. */
#define ixf18100_sH4                    0  
#define ixf18100_mH4                    (0xFF << ixf18100_sH4)

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_RCV_Z3_F3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_Z3_F3_OFFSET    ixf18100_SONET_REG(0x01E2)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Bits [7:0] correspond to Z3/F3[7:0], respectively. */
#define ixf18100_sZ3_F3                 0
#define ixf18100_mZ3_F3                 (0xFF << ixf18100_sZ3_F3)

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_RCV_Z4_K3 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_Z4_K3_OFFSET    ixf18100_SONET_REG(0x01E3)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Bits [7:0] correspond to Z4/K3[7:0], respectively. */
#define ixf18100_sZ4_K3                 0 
#define ixf18100_mZ4_K3                 (0xFF << ixf18100_sZ4_K3)

/*15:8 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* RL_RCV_Z5_N1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_RL_RCV_Z5_N1_OFFSET    ixf18100_SONET_REG(0x01E4)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/

/*Bits [7:0] correspond to Z5/N1[7:0], respectively. */
#define ixf18100_sZ5_N1                 0 
#define ixf18100_mZ5_N1                 (0xFF << ixf18100_sZ5_N1)

/*15:8 Reserved
 */
/******************************************************************************/

/* END --- SONET RX REGISTERS */



/* START --- SONET TX REGISTERS */
/******************************************************************************/

/*Offset/Default definition for register.*/
#define ixf18100_TXTMG_CFG_OFFSET        ixf18100_SONET_REG(0x080D)
#define ixf18100_TXTMG_CFG_DFLT          0x1000

/*---------Shift and mask defines.------*/

/*These bits control the sync input selection */
#define ixf18100_sSYNC_SEL               0
#define ixf18100_mSYNC_SEL               (0x3 << ixf18100_sSYNC_SEL)

/*This bit is set to 0 for 8KHz Sync Input, 1 for 2KHz Sync Input */
#define ixf18100_sSYNC_IN_2K             2

/*This bit is the Resync filter parameter. */
#define ixf18100_sSYNC_FLTR              3

/*These bits are Ext Sync Multi-Frame Offset */
#define ixf18100_sMF_OFF                 4
#define ixf18100_mMF_OFF                 (0x3 << ixf18100_sMF_OFF)

/*These bits are Ext Sync Input 622 Mhz Alignment*/
#define ixf18100_sI622_OFF               6
#define ixf18100_mI622_OFF               (0x7 << ixf18100_sI622_OFF)

/*These bits are Ext Sync Output 622 Mhz Alignment*/
#define ixf18100_sO622_OFF               9
#define ixf18100_mO622_OFF               (0x7 << ixf18100_sO622_OFF)

/*Value defines*/

/*These bits are the sync input selection. */
#define ixf18100_SYNCSEL_SELF_TIMED              (0x0 << ixf18100_sSYNC_SEL)
#define ixf18100_SYNCSEL_EDGE_DETECTED_EXT       (0x1 << ixf18100_sSYNC_SEL)     
#define ixf18100_SYNCSEL_EDGE_DET_EXT_RESYNCH    (0x2 << ixf18100_sSYNC_SEL)     

/*These bits are the External Sync Multi-Frame Offset used with Reg
 *0EH. 0-3 */
#define ixf18100_MF_OFF_VAL0              (0x0 << ixf18100_sMF_OFF)
#define ixf18100_MF_OFF_VAL1              (0x1 << ixf18100_sMF_OFF)
#define ixf18100_MF_OFF_VAL2              (0x2 << ixf18100_sMF_OFF)
#define ixf18100_MF_OFF_VAL3              (0x3 << ixf18100_sMF_OFF)

/*
 *15:14 Unused
 *13 Reserved
 */     
/******************************************************************************/

/******************************************************************************/
/* OFB_OFFSET Register*/

/*Offset/Default definition for register.*/
#define ixf18100_OFB_OFFSET_OFFSET       ixf18100_SONET_REG(0x080E)
#define ixf18100_OFB_OFFSET_DFLT		 0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sOFB_STS_OFF        0      
#define ixf18100_mOFB_STS_OFF        (0xF << ixf18100_sOFB_STS_OFF )

#define ixf18100_sOFB_COL_OFF        4  
#define ixf18100_mOFB_COL_OFF        (0x7F << ixf18100_sOFB_COL_OFF)

#define ixf18100_sOFB_ROW_OFF        11               
#define ixf18100_mOFB_ROW_OFF        (0xF << ixf18100_sOFB_ROW_OFF)

/*Value defines*/

/*3:0 StsOff[3:0] These bits are the STS Counter Offset. 0-11
 *(Illegal value yields no sync)
 *
 *10:4 ColOff[7:0] These bits are the Column Counter Offset. 0-89
 *(Illegal value yields no sync)
 *
 *14:11 RowOff[3:0] These bits are the Row Counter Offset. 0-8
 *(Illegal value yields no sync)
 *
 *15 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* ESO_OFFSET Register*/

/*Offset/Default definition for register.*/
#define ixf18100_ESO_OFFSET_OFFSET       ixf18100_SONET_REG(0x080F)
#define ixf18100_ESO_OFFSET_DFLT         0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sESO_STS_OFF            0
#define ixf18100_mESO_STS_OFF            (0xF << ixf18100_sESO_STS_OFF)

#define ixf18100_sESO_COL_OFF            4            
#define ixf18100_mESO_COL_OFF            (0x7F << ixf18100_sESO_COL_OFF)

#define ixf18100_sESO_ROW_OFF            11               
#define ixf18100_mESO_ROW_OFF            (0xF << ixf18100_sESO_ROW_OFF)

/*This bit sets the Sync Output.*/
#define ixf18100_sSO2K                   15

/*Value defines*/

/*3:0 StsOff[3:0] 
 *These bits set the STS Counter Offset. 0-11
 *(Illegal value yields no sync)
 *
 *10:4 ColOff[7:0] 
 *These bits set the Column Counter Offset. 0-89
 *(Illegal value yields no sync)
 (
 *14:11 RowOff[7:0] 
 *These bits set the Row Counter Offset. 0-8
 *(Illegal value yields no sync)
 */
/******************************************************************************/

/******************************************************************************/
/* TL_SPEGEN_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_SPEGEN_CFG_OFFSET    ixf18100_SONET_REG(0x0810)
#define ixf18100_TL_SPEGEN_CFG_DFLT      0x0000

/*---------Shift and mask defines.------*/

/*B3 Configuration. */
#define ixf18100_sB3_CFG                 0

/*Value defines*/

/*15:2 Unused
 *1 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TL_H1H2_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_H1H2_CFG_OFFSET      ixf18100_SONET_REG(0x0811)
#define ixf18100_TL_H1H2_CFG_DFLT        0x620A

/*---------Shift and mask defines.------*/

#define ixf18100_sPOINTER                0               
#define ixf18100_mPOINTER                (0x3FF << ixf18100_sPOINTER)

#define ixf18100_sSS                     10
#define ixf18100_mSS                     (0x3 << ixf18100_sSS)

#define ixf18100_sNDF                    12       
#define ixf18100_mNDF                    (0xF << ixf18100_sNDF)

/*Value defines*/

/*Pointer value (the default is 0x20A hex, or 522 decimal) */
#define ixf18100_SS_SONET     (0x00 << ixf18100_sSS)
#define ixf18100_SS_SDH       (0x01 << ixf18100_sSS)     

/*New Data Flag bits */
/******************************************************************************/

/******************************************************************************/
/* TL_H1H2_STA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_H1H2_STA_OFFSET      ixf18100_SONET_REG(0x0812)
#define ixf18100_TL_H1H2_STA_DFLT        0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sPOINTER_VAL            0               
#define ixf18100_mPOINTER_VAL            (0x3FF << ixf18100_sPOINTER_VAL)

#define ixf18100_sSS_VAL                 10               
#define ixf18100_mSS_VAL                 (0x3 << ixf18100_sSS_VAL)

#define ixf18100_sNDF_VAL                12               
#define ixf18100_mNDF_VAL                (0xF << ixf18100_sNDF_VAL)


/*Value defines*/

/*Value of the outgoing Pointer. */
/******************************************************************************/

/******************************************************************************/
/* TL_POH_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_POH_CFG_OFFSET       ixf18100_SONET_REG(0x0820)
#define ixf18100_TL_POH_CFG_DFLT         0x0615

/*---------Shift and mask defines.------*/

/*This bit configures the transmit line J1 trace. */
#define ixf18100_sTL_J1_CFG              0
#define ixf18100_mTL_J1_CFG              (0x01 << ixf18100_sTL_J1_CFG)
#define ixf18100_vTL_J1_CFG_16Byte       0x00
#define ixf18100_vTL_J1_CFG_64Byte       0x01

/*Set this bit to 1 to load the contents of the J1 Compose Buffer into
 *the J1 String Buffer. When the load is complete, this bit self-clears.
 *When J1Cfg=0, CRC7 is calculated during the load if enabled. */
#define ixf18100_sLOAD_J1_CMP            1

/*For a 16-byte J1 trace (J1Cfg=0), CRC7 is calculated and inserted
 *into J1 byte #0 during the load of the J1 compose buffer into the J1
 *transmit string. */
#define ixf18100_sCRC7_EN                2
#define ixf18100_mCRC7_EN                (0x01 << ixf18100_sCRC7_EN)

/* This bit configures ERDI-P or 1-bit RDI-P mode. In 1-bit mode, only
 *G1[3]is affectedby RdiPSrc. */
#define ixf18100_sRDI_P_CFG              3

/*This bit enables reflected RDI-P override of outgoing G1[3:1] bits
 *with a higer priority RDI-P code, regardless of RdiPSrc & G1Src.
 *See receive RDI-P configuration in register RL_POH_CFG??. */
#define ixf18100_sRFL_RDI_P_EN           4

/*This bit enables serial port RDI-P override of outgoing G1[3:1] bits
 *with a higer priority RDI-P code, regardless of RdiPSrc & G1Src. */
#define ixf18100_sSER_RDI_P_EN           5

/*This bit enables processor RDI-P override of outgoing G1[3:1] bits
 *with a higer priority RDI-P code, regardless of RdiPSrc & G1Src. */
#define ixf18100_suP_RDI_EN              6

#define ixf18100_sRDI_P_SRC              7               
#define ixf18100_mRDI_P_SRC              (0x3 << ixf18100_sRDI_P_SRC)

#define ixf18100_sRDI_P_HYST             9               
#define ixf18100_mRDI_P_HYST             (0x3 << ixf18100_sRDI_P_HYST)

#define ixf18100_sREI_P_SRC              11               
#define ixf18100_mREI_P_SRC              (0x3 << ixf18100_sREI_P_SRC)

/*Value defines*/

/*These bits define the source of the G1 RDI bits; G1[3:1] for
 *enhanced mode and G1[3] for 1-bit mode. An active higher priority
 *RDI will override this selection if enabled by uP/Ser/RflRdiPEn. */
#define ixf18100_RDI_P_SRC_G1_SRC    (0x0 << ixf18100_sRDI_P_SRC)
#define ixf18100_RDI_P_SRC_SERIAL    (0x1 << ixf18100_sRDI_P_SRC)
#define ixf18100_RDI_P_SRC_RCV_DP    (0x2 << ixf18100_sRDI_P_SRC)
#define ixf18100_RDI_P_SRC_POH_RAM   (0x3 << ixf18100_sRDI_P_SRC)

/*These bits configure the hysteresis of RDI-P when inserted into the
 *outgoing G1 byte. Outgoing G1 RDI-P is stable for at least. */
#define ixf18100_RDI_P_HYST_1_FRAME         (0x0 << ixf18100_sRDI_P_HYST)     
#define ixf18100_RDI_P_HYST_5_FRAMES        (0x1 << ixf18100_sRDI_P_HYST)
#define ixf18100_RDI_P_HYST_10_FRAMES       (0x2 << ixf18100_sRDI_P_HYST)
#define ixf18100_RDI_P_HYST_20_FRAMES       (0x3 << ixf18100_sRDI_P_HYST)

/*These bits define the source of the G1 REI bits. */
#define ixf18100_REI_P_SRC_G1_SRC           (0x0 << ixf18100_sREI_P_SRC)      
#define ixf18100_REI_P_SRC_SERIAL           (0x1 << ixf18100_sREI_P_SRC)
#define ixf18100_REI_P_SRC_RCV_DP           (0x2 << ixf18100_sREI_P_SRC)
#define ixf18100_REI_P_SRC_POH_RAM          (0x3 << ixf18100_sREI_P_SRC)

/******************************************************************************/

/******************************************************************************/
/* TL_POH_CTL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_POH_CTL_OFFSET       ixf18100_SONET_REG(0x0821)
#define ixf18100_TL_POH_CTL_DFLT         0x0001

/*---------Shift and mask defines.------*/

/*Insert AIS-P */
#define ixf18100_sINS_AIS_P              0

/*Enable/Disable Assertion AIS-P Via serial port */
#define ixf18100_sEN_SP_AIS_P            1

/*Insert/Clear UNEQ-P. */
#define ixf18100_sINS_UNEQ_P             3

/*Force/Disable all ones in payload. */
#define ixf18100_sFORCE_PAYLOAD_1S       4

/*Force/Disable all zeros in payload. */
#define ixf18100_sFORCE_PAYLOAD_0S       5

/*Value defines*/

/*15:6 Unused
*/
/******************************************************************************/

/******************************************************************************/
/* Transmit J1 access registers */
/* TL_J1_CMPA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_J1_CMPA_OFFSET       ixf18100_SONET_REG(0x0822)
#define ixf18100_TL_J1_CMPA_DFLT         0x0000

/* TL_J1_STRA Register*/
/*Offset/Default definition for register.*/
#define ixf18100_TL_J1_STRA_OFFSET       ixf18100_SONET_REG(0x0823)
#define ixf18100_TL_J1_STRA_DFLT         0x0000

/* Bit, shift and mask defines.*/
/* These bit defines are common to all transmit J0 and J1 access registers. */

#define ixf18100_sTL_TRACE_DATA            0               
#define ixf18100_mTL_TRACE_DATA            (0xFF << ixf18100_sTL_TRACE_DATA)

#define ixf18100_sTL_TRACE_ADDR            8               
#define ixf18100_mTL_TRACE_ADDR            (0x3F << ixf18100_sTL_TRACE_ADDR)

/*DsblJ1CmpDataWr
 *1: For a read sequence, when writing the initial J1CmpAddr for
 *   subsequent reads, use this bit to block a transfer of J1CmpData
 *   into the J1 buffer.
 *0: During a write, the contents of J1CmpData are transferred to
 *   internal string memory.
 */
#define ixf18100_sDSBL_TL_TRACE_DATA_WR    14
#define ixf18100_mDSBL_TL_TRACE_DATA_WR    (0x01 << ixf18100_sDSBL_TL_TRACE_DATA_WR)

/*Value defines*/

/*7:0 J1CmpData[7:0] 
 *These bits hold one J1 compose string data byte.
 *
 *13:8 J1CmpAddr[5:0] 
 *These bits are an index to J1 string bytes. J1CmpAddr is
 *automatically incremented after this register is read.
 *
 *15 Unused 
 */
/******************************************************************************/


/******************************************************************************/
/* TL_POH_BVA Register
 * Transmit line path overhead byte access.  This is provided by a number of
 * registers that all provide access to an overhead byte as the low 8 bytes
 * of the register.
 */
 
 
/*Offset/Default definition for register.*/
#define ixf18100_TL_POH_BVA_J1_OFFSET       ixf18100_SONET_REG(0x0830)
#define ixf18100_TL_POH_BVA_B3_OFFSET       ixf18100_SONET_REG(0x0831)
#define ixf18100_TL_POH_BVA_C2_OFFSET       ixf18100_SONET_REG(0x0832)
#define ixf18100_TL_POH_BVA_G1_OFFSET       ixf18100_SONET_REG(0x0833)
#define ixf18100_TL_POH_BVA_F2_OFFSET       ixf18100_SONET_REG(0x0834)
#define ixf18100_TL_POH_BVA_H4_OFFSET       ixf18100_SONET_REG(0x0835)
#define ixf18100_TL_POH_BVA_Z3_OFFSET       ixf18100_SONET_REG(0x0836)
#define ixf18100_TL_POH_BVA_Z4_OFFSET       ixf18100_SONET_REG(0x0837)
#define ixf18100_TL_POH_BVA_Z5_OFFSET       ixf18100_SONET_REG(0x0838)
 
 
/* Mask and shift defines for all TL path overhead bytes */

#define ixf18100_sTL_POH_BVA                0               
#define ixf18100_mTL_POH_BVA                (0xFF << ixf18100_sTL_POH_BVA)

/*7:0 BVData[7:0] 
 *These bits hold one byte value.
 *
 *15:8 Unused
 */
 
 
/******************************************************************************/




/******************************************************************************/
/* TL_POH_SCA Registers */
/* These registers control the source of the path overhead bytes */

/*Offset/Default definition for register.*/
#define ixf18100_TL_POH_SCA_J1_OFFSET       ixf18100_SONET_REG(0x0840)
#define ixf18100_TL_POH_SCA_B3_OFFSET       ixf18100_SONET_REG(0x0841)
#define ixf18100_TL_POH_SCA_C2_OFFSET       ixf18100_SONET_REG(0x0842)
#define ixf18100_TL_POH_SCA_G1_OFFSET       ixf18100_SONET_REG(0x0843)
#define ixf18100_TL_POH_SCA_F2_OFFSET       ixf18100_SONET_REG(0x0844)
#define ixf18100_TL_POH_SCA_H4_OFFSET       ixf18100_SONET_REG(0x0845)
#define ixf18100_TL_POH_SCA_Z3_OFFSET       ixf18100_SONET_REG(0x0846)
#define ixf18100_TL_POH_SCA_Z4_OFFSET       ixf18100_SONET_REG(0x0847)
#define ixf18100_TL_POH_SCA_Z5_OFFSET       ixf18100_SONET_REG(0x0848)
/* No Defaults for these registers */

/*---------Shift and mask defines.------*/

#define ixf18100_sTL_POH_SRC               0               
#define ixf18100_mTL_POH_SRC               (0x7 << ixf18100_sTL_POH_SRC)

/*Value defines*/
#define ixf18100_POH_SRC_DATA_PATH       (0x0 << ixf18100_sTL_POH_SRC)
#define ixf18100_POH_SRC_SER_PORT        (0x1 << ixf18100_sTL_POH_SRC)
#define ixf18100_POH_SRC_MICRO_PROC      (0x2 << ixf18100_sTL_POH_SRC)
#define ixf18100_POH_SRC_HARDWARE        (0x3 << ixf18100_sTL_POH_SRC)
#define ixf18100_POH_SRC_0X00            (0x6 << ixf18100_sTL_POH_SRC)
#define ixf18100_POH_SRC_0XFF            (0x7 << ixf18100_sTL_POH_SRC)


/*2:0 SCData[2:0] 
 *These bits hold the source control for one POH byte.
 *
 *7:3 Reserved
 *
 *15:8 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TL_POH_TEST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_POH_TEST_OFFSET      ixf18100_SONET_REG(0x0850)
#define ixf18100_TL_POH_TEST_DFLT        0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sINV_B3                 0               
#define ixf18100_mINV_B3                 (0x3 << ixf18100_sINV_B3)

/*EnSP-B3ErrMsk 
 *1: Enable B3 bit Error Mask function via the serial port TPOH.
 *0: Disable assertion of B3 errors from the serial port.
 */
#define ixf18100_sEN_SP_B3_ERR_MASK      2

/*Value defines*/

/*These bits invert B3 byte (used for testing).*/
#define ixf18100_INV_B3_0_FRAME_INV       (0x0 << ixf18100_sINV_B3)
#define ixf18100_INV_B3_1_FRAME_INV       (0x1 << ixf18100_sINV_B3)
#define ixf18100_INV_B3_8_FRAME_INV       (0x2 << ixf18100_sINV_B3)
#define ixf18100_INV_B3_CONTIN_INV        (0x3 << ixf18100_sINV_B3)

/*4:3
 *Reserved
 *TstMd[1:0]
 *01/10/11 : Reserved for manufactures test.
 *00 : Must be set to SONET system mode 00 for normal operation.
 *     These bits configure test access / internal observability modes
 *11: By-pass POH insertion, observe datapath
 *10: By-pass POH insertion, observe uP OH bus
 *01: By-pass POH insertion, observe internal serial port interface
 *00: Normal System Configuration, POH insertion active
 */
/*#define ixf18100_TST_MD_NORM_CFG           (0x0 << ixf18100_sTST_MD)
#define ixf18100_TST_MD_INT_SER            (0x1 << ixf18100_sTST_MD)
#define ixf18100_TST_MD_UP_OH_BUS          (0x2 << ixf18100_sTST_MD)
#define ixf18100_TST_MD_DATAPATH           (0x3 << ixf18100_sTST_MD) */
/******************************************************************************/

/******************************************************************************/
/* TL_TOH_FIFO_RST Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_TOH_FIFO_RST_OFFSET      ixf18100_SONET_REG(0x0870)
#define ixf18100_TL_TOH_FIFO_RST_DFLT        0x0000

/*---------Shift and mask defines.------*/

/*TL_FifoRst controls the reset of the TOH skew compensation FIFO. */
#define ixf18100_sTL_FIFO_RST                0

/*Value defines*/

/*15:1 Unused
 */
/******************************************************************************/

/******************************************************************************/
/* TL_TOH_FIFO_SPILL Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_TOH_FIFO_SPILL_OFFSET	ixf18100_SONET_REG(0x0872)
#define ixf18100_TL_TOH_FIFO_SPILL_DFLT		0x0000

/*---------Shift and mask defines.------*/

/*SPILL*/
#define ixf18100_sSPILL            0    


/*15:1 Reserved 
 */
/******************************************************************************/

/******************************************************************************/
/* TL_TOH_FIFO_STATUS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_TOH_FIFO_STATUS_OFFSET    ixf18100_SONET_REG(0x0873)
#define ixf18100_TL_TOH_FIFO_STATUS_DFLT      0x0000

/*-------- Shift and mask defines.-------------*/

/*FIFOstat */
#define ixf18100_sFIFO_STAT              0    
#define ixf18100_mFIFO_STAT              (0xF << ixf18100_sFIFO_STAT)

/******************************************************************************/

/******************************************************************************/
/* TL_TOH_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_TOH_CFG_0_OFFSET       ixf18100_SONET_REG(0x0880)
#define ixf18100_TL_TOH_CFG_1_OFFSET       ixf18100_SONET_REG(0x0980)
#define ixf18100_TL_TOH_CFG_2_OFFSET       ixf18100_SONET_REG(0x0A80)
#define ixf18100_TL_TOH_CFG_3_OFFSET       ixf18100_SONET_REG(0x0B80)
#define ixf18100_TL_TOH_CFG_C_OFFSET       ixf18100_SONET_REG(0x0C80)
#define ixf18100_TL_TOH_CFG_ALL_OFFSET     ixf18100_SONET_REG(0x0C80)
#define ixf18100_TL_TOH_CFG_DFLT		   0x8080

/*---------Shift and mask defines.------*/

#define ixf18100_sINV_B1                 0
#define ixf18100_mINV_B1                 (0x3 << ixf18100_sINV_B1)

#define ixf18100_sINV_B2                 2
#define ixf18100_mINV_B2                 (0x3 << ixf18100_sINV_B2)

#define ixf18100_sINV_A1                 4
#define ixf18100_mINV_A1                 (0x3 << ixf18100_sINV_A1)

#define ixf18100_sTL_J0_CFG              6
#define ixf18100_mTL_J0_CFG              (0x3 << ixf18100_sTL_J0_CFG)

#define ixf18100_sZ0_RG_CFG              8
#define ixf18100_mZ0_RG_CFG              (0x7 << ixf18100_sZ0_RG_CFG)

/*This bit disables the insertion of 110 into the outgoing RDI bits */
#define ixf18100_sRFL_RDI_DSBL           11

/*This bit is used to disable the transmit scrambler operation. */
#define ixf18100_sSCRMBL_DSBL            12

/*This bit configures the unused overhead byte values. */
#define ixf18100_sUN_BY_CFG              13

#define ixf18100_sRDI_HYST_CFG           14    
#define ixf18100_mRDI_HYST_CFG           (0x3 << ixf18100_sRDI_HYST_CFG)

/*Value defines*/

/*These bits invert B1 byte (used for testing). */
#define ixf18100_INV_B1_NO_INV            (0x0 << ixf18100_sINV_B1)       
#define ixf18100_INV_B1_CONT_INV          (0x2 << ixf18100_sINV_B1)       
#define ixf18100_INV_B1_1_FRM_INV         (0x3 << ixf18100_sINV_B1)       

/*These bits invert B2 byte (used for testing). */
#define ixf18100_INV_B2_NO_INV            (0x0 << ixf18100_sINV_B2)      
#define ixf18100_INV_B2_CONT_INV          (0x2 << ixf18100_sINV_B2)      
#define ixf18100_INV_B2_1_FRM_INV         (0x3 << ixf18100_sINV_B2)      

/*These bits invert A1 framing bytes (used for testing). */
#define ixf18100_INV_A1_NO_INV            (0x0 << ixf18100_sINV_A1)       
#define ixf18100_INV_A1_INV_UNTIL_DEAC    (0x2 << ixf18100_sINV_A1)       
#define ixf18100_INV_A1_4_FRM_INV         (0x3 << ixf18100_sINV_A1)       

/*These bits configure the transmit line J0 byte. */
#define ixf18100_J0_CFG_1_BYTE_TRC_ID      (0x0 << ixf18100_sTL_J0_CFG)       
#define ixf18100_J0_CFG_RESERVED           (0x1 << ixf18100_sTL_J0_CFG)       
#define ixf18100_J0_CFG_16_BYTE_TRC_ID     (0x2 << ixf18100_sTL_J0_CFG)       
#define ixf18100_J0_CFG_64_BYTE_FORMAT     (0x3 << ixf18100_sTL_J0_CFG)       

/*These bits select either an STM-64 Identifier sequence or the
 *TL_NU1-2 register source for the Z0 bytes. */
#define ixf18100_Z0_RG_CFG_NU1_TL_NU1_2    (0x0 << ixf18100_sZ0_RG_CFG)       
#define ixf18100_Z0_RG_CFG_STM_64_NU1      (0x1 << ixf18100_sZ0_RG_CFG)       
#define ixf18100_Z0_RG_CFG_TEST_MODE       (0x7 << ixf18100_sZ0_RG_CFG)       

/*These bits configure the hysteresis of RDI when inserted into the
 *outgoing K2 byte. Outgoing K2 RDI is stable for at least. */
#define ixf18100_RDI_HYST_CFG_1_FRAME       (0x0 << ixf18100_sRDI_HYST_CFG)       
#define ixf18100_RDI_HYST_CFG_5_FRAMES      (0x1 << ixf18100_sRDI_HYST_CFG)       
#define ixf18100_RDI_HYST_CFG_10_FRAMES     (0x2 << ixf18100_sRDI_HYST_CFG)       
#define ixf18100_RDI_HYST_CFG_20_FRAMES     (0x3 << ixf18100_sRDI_HYST_CFG)       
/******************************************************************************/

/******************************************************************************/
/* TL_FRM_OFFSET Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_FRM_OFFSET_OFFSET        ixf18100_SONET_REG(0x0881)
#define ixf18100_TL_FRM_OFFSET_DFLT          0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sFPO_S                      0
#define ixf18100_mFPO_S                      (0x1FF << ixf18100_sFPO_S)

/*Value defines*/

/*These bits are the Frame Pulse Offset Alignment Control. 
 *STS-192 Mode - FPO is aligned with one 2-byte wide signal:
 *FPOs[8:7] 0-3 Dec: selects 1 of 4 byte ranges for the FPO position.
 *0: 96 bytes prior to 1st A1 through 96th A1
 *1: 97th A1 through 96th A2
 *2: 97th A2 through 95th Z0
 *3: 96th Z0 through 96th byte after the last Z0
 *FPOs[6:3] and FPos[2:0] select 1 of 96 STS 2-byte alignments
 *FPOs[6:3] values 12-15 disable FPO
 *Examples:
 *1st/2nd A1 bytes. FPos=h0030 8:7=0, 6:3=6, 2:0=0
 *J0 byte & 1st Z0 byte. FPos=h0130 8:7=2, 6:3=6, 2:0=0
 *Last 2 Z0 bytes. FPos=h01af 8:7=3, 6:3=5, 2:0=7
 *
 *15:9 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TL_SC1_TOH Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_SC1_TOH_0_OFFSET     ixf18100_SONET_REG(0x0882)
#define ixf18100_TL_SC1_TOH_1_OFFSET     ixf18100_SONET_REG(0x0982)
#define ixf18100_TL_SC1_TOH_2_OFFSET     ixf18100_SONET_REG(0x0A82)
#define ixf18100_TL_SC1_TOH_3_OFFSET     ixf18100_SONET_REG(0x0B82)
#define ixf18100_TL_SC1_TOH_C_OFFSET     ixf18100_SONET_REG(0x0C82)
#define ixf18100_TL_SC1_TOH_DFLT         0x8000

/*---------Shift and mask defines.------*/

#define ixf18100_sK2_APS_SRC             0        
#define ixf18100_mK2_APS_SRC             (0x3 << ixf18100_sK2_APS_SRC)

#define ixf18100_sK1_SRC                 2        
#define ixf18100_mK1_SRC                 (0x3 << ixf18100_sK1_SRC)

/*This bit specifies the source of D1-D3 RSOH DCC bytes.
 *The TOH byte is controlled with register 1882:*/
#define ixf18100_sD1_D3_SRC              4

#define ixf18100_sNU2_SRC                5        
#define ixf18100_mNU2_SRC                (0x3 << ixf18100_sNU2_SRC)

/*This bit specifies the source of the F1 orderwire byte.
 *The TOH byte is controlled with register 1882.*/
#define ixf18100_sF1_SRC                 7

/*The TOH byte is controlled with register 1882.*/
#define ixf18100_sE1_SRC                 8

#define ixf18100_sNU1_Z0_SRC             9        
#define ixf18100_mNU1_Z0_SRC             (0x3 << ixf18100_sNU1_Z0_SRC)

#define ixf18100_sJ0_SRC                 11        
#define ixf18100_mJ0_SRC                 (0x3 << ixf18100_sJ0_SRC)

/*Enable Assertion of AIS-L via Serial Alarms Port. */
#define ixf18100_sEN_AIS_L_SP            14

/*Insert/Clear AIS-L. */
#define ixf18100_sINS_AIS_L              15

/*Value defines*/

/*These bits in register 1882 specify the source of the K2-APS bits [7:3]. */
#define ixf18100_K2_APS_SRC_UP_TL_K1K2          (0x0 << ixf18100_sK2_APS_SRC)
#define ixf18100_K2_APS_SRC_SER_TOH_TAL         (0x1 << ixf18100_sK2_APS_SRC)     
#define ixf18100_K2_APS_SRC_DATAPATH            (0x2 << ixf18100_sK2_APS_SRC)     
#define ixf18100_K2_APS_SRC_RESERVED            (0x3 << ixf18100_sK2_APS_SRC)     

/*These bits in register 1882 specify the source of the K1 byte. */     
#define ixf18100_K1_SRC_UP_TL_K1K2               (0x0 << ixf18100_sK1_SRC)
#define ixf18100_K1_SRC_SER_TOH_TAL              (0x1 << ixf18100_sK1_SRC)        
#define ixf18100_K1_SRC_DATAPATH                 (0x2 << ixf18100_sK1_SRC)        
#define ixf18100_K1_SRC_RESERVED                 (0x3 << ixf18100_sK1_SRC)        

/*This bit specifies the source of National Use bytes in TOH row 2. */
#define ixf18100_NU2_SRC_UP_NU2                  (0x0 << ixf18100_sNU2_SRC)
#define ixf18100_NU2_SRC_SER_TOH                 (0x1 << ixf18100_sNU2_SRC)       
#define ixf18100_NU2_SRC_DATAPATH                (0x2 << ixf18100_sNU2_SRC)       
#define ixf18100_NU2_SRC_UN_TOH_SRC              (0x3 << ixf18100_sNU2_SRC)       

/*These bits specify the source of National Use / Z0 bytes in TOH row 1. */
#define ixf18100_NU1_Z0_SRC_Z0_RG_X_CFG          (0x0 << ixf18100_sNU1_Z0_SRC)
#define ixf18100_NU1_Z0_SRC_SER_TOH              (0x1 << ixf18100_sNU1_Z0_SRC)        
#define ixf18100_NU1_Z0_SRC_DATAPATH             (0x2 << ixf18100_sNU1_Z0_SRC)        
#define ixf18100_NU1_Z0_SRC_UN_TOH_SRC           (0x3 << ixf18100_sNU1_Z0_SRC)        

/*These bits specify the source of the J0 byte.
 *The TOH byte is controlled with register 1882. */
#define ixf18100_J0_SRC_TL_J0_STRA               (0x0 << ixf18100_sJ0_SRC)
#define ixf18100_J0_SRC_SER_TOH                  (0x1 << ixf18100_sJ0_SRC)        
#define ixf18100_J0_SRC_DATAPATH                 (0x2 << ixf18100_sJ0_SRC)        
#define ixf18100_J0_SRC_RESERVED                 (0x3 << ixf18100_sJ0_SRC)

/*14:13 Reserved 
*/      
/******************************************************************************/

/******************************************************************************/
/* TL_SC2_TOH Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_SC2_TOH_0_OFFSET     ixf18100_SONET_REG(0x0883)
#define ixf18100_TL_SC2_TOH_1_OFFSET     ixf18100_SONET_REG(0x0983)
#define ixf18100_TL_SC2_TOH_2_OFFSET     ixf18100_SONET_REG(0x0A83)
#define ixf18100_TL_SC2_TOH_3_OFFSET     ixf18100_SONET_REG(0x0B83)
#define ixf18100_TL_SC2_TOH_C_OFFSET     ixf18100_SONET_REG(0x0C83)
#define ixf18100_TL_SC2_TOH_DFLT         0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sUN_TOH_SRC             0  
#define ixf18100_mUN_TOH_SRC             (0x3 << ixf18100_sUN_TOH_SRC)

#define ixf18100_sNU9_SRC                2               
#define ixf18100_mNU9_SRC                (0x3 << ixf18100_sNU9_SRC)

/*For register 1883, this bit specifies the source of the E2 orderwire byte.*/
#define ixf18100_sE2_SRC                 4

#define ixf18100_sZ2_SRC                 5
#define ixf18100_mZ2_SRC                 (0x3 << ixf18100_sZ2_SRC)

#define ixf18100_sREI_SRC                7               
#define ixf18100_mREI_SRC                (0x3 << ixf18100_sREI_SRC)

#define ixf18100_sZ1_SRC                 9               
#define ixf18100_mZ1_SRC                 (0x3 << ixf18100_sZ1_SRC)

#define ixf18100_sS1_SRC                 11               
#define ixf18100_mS1_SRC                 (0x3 << ixf18100_sS1_SRC)

/*For register 1883, these bits specify the source of D4-D12 DCC bytes. */
#define ixf18100_sD4_D1_SRC              13

#define ixf18100_sK2_RDI_SRC             14               
#define ixf18100_mK2_RDI_SRC             (0x3 << ixf18100_sK2_RDI_SRC)

/*Value defines*/

/*These bits specify the source of unused bytes in TOH.
 *Individual OH byte controls take precedence over this control. */
#define ixf18100_UN_TOH_SRC_TL_TOH_CFG     (0x0 << ixf18100_sUN_TOH_SRC)      
#define ixf18100_UN_TOH_SRC_SER_TOH        (0x1 << ixf18100_sUN_TOH_SRC)      
#define ixf18100_UN_TOH_SRC_DATAPATH       (0x2 << ixf18100_sUN_TOH_SRC)      
#define ixf18100_UN_TOH_SRC_RESERVED       (0x3 << ixf18100_sUN_TOH_SRC)      

/*These bits specify the source of TOH National Use (NU) bytes in row 9. */
#define ixf18100_NU9_SRC_UP_TL_NU9         (0x0 << ixf18100_sNU9_SRC)     
#define ixf18100_NU9_SRC_SER_TOH           (0x1 << ixf18100_sNU9_SRC)     
#define ixf18100_NU9_SRC_DATAPATH          (0x2 << ixf18100_sNU9_SRC)     
#define ixf18100_NU9_SRC_TL_TOH_CFG        (0x3 << ixf18100_sNU9_SRC)

/*These bits specify the source of Z2 bytes. */
#define ixf18100_Z2_SRC_TL_SC2_TOH         (0x0 << ixf18100_sZ2_SRC)      
#define ixf18100_Z2_SRC_SER_TOH            (0x1 << ixf18100_sZ2_SRC)      
#define ixf18100_Z2_SRC_DATAPATH           (0x2 << ixf18100_sZ2_SRC)      
#define ixf18100_Z2_SRC_RESERVED           (0x3 << ixf18100_sZ2_SRC)      

/*For register 1883, these bits specify the source of the M1 REI byte. */
#define ixf18100_REI_SRC_HARDWARE           (0x0 << ixf18100_sREI_SRC)        
#define ixf18100_REI_SRC_SER_TOH_TAL        (0x1 << ixf18100_sREI_SRC)        
#define ixf18100_REI_SRC_DATAPATH           (0x2 << ixf18100_sREI_SRC)        
#define ixf18100_REI_SRC_TL_M1              (0x3 << ixf18100_sREI_SRC)        

/*These bits specify the source of Z1 bytes. */
#define ixf18100_Z1_SRC_TL_SC2_TOH          (0x0 << ixf18100_sZ1_SRC)     
#define ixf18100_Z1_SRC_SER_TOH             (0x1 << ixf18100_sZ1_SRC)     
#define ixf18100_Z1_SRC_DATAPATH            (0x2 << ixf18100_sZ1_SRC)     
#define ixf18100_Z1_SRC_RESERVED            (0x3 << ixf18100_sZ1_SRC)     

/*For register 1883, these bits specify the source of the S1 byte.*/
#define ixf18100_S1_SRC_UP_TL_S1             (0x0 << ixf18100_sS1_SRC)        
#define ixf18100_S1_SRC_SER_TOH_TAL          (0x1 << ixf18100_sS1_SRC)        
#define ixf18100_S1_SRC_DATAPATH             (0x2 << ixf18100_sS1_SRC)        
#define ixf18100_S1_SRC_RESERVED             (0x3 << ixf18100_sS1_SRC)        
        
/*These bits in register 1883H define the source of the K2 RDI bits. */
#define ixf18100_K2_RDI_SRC_000               (0x0 << ixf18100_sK2_RDI_SRC)       
#define ixf18100_K2_RDI_SRC_SER_TOH_TAL       (0x1 << ixf18100_sK2_RDI_SRC)       
#define ixf18100_K2_RDI_SRC_DATAPATH          (0x2 << ixf18100_sK2_RDI_SRC)       
#define ixf18100_K2_RDI_SRC_UP_TL_K1K2        (0x3 << ixf18100_sK2_RDI_SRC)       
/******************************************************************************/

/******************************************************************************/
/* TL_SC3_TOH Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_SC3_TOH_OFFSET       ixf18100_SONET_REG(0x0887)
#define ixf18100_TL_SC3_TOH_DFLT         0x0000

/*---------Shift and mask defines.------*/

/*This bit configures the outgoing REI bytes(s). */
#define ixf18100_sREI_CFG                 0


/******************************************************************************/

/******************************************************************************/
/* TL_J0_STRA Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_J0_STRA_OFFSET       ixf18100_SONET_REG(0x0888)
#define ixf18100_TL_J0_STRA_DFLT         0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sJ0_STRG_DATA             0               
#define ixf18100_mJ0_STRG_DATA             (0xFF << ixf18100_sJ0_STRG_DATA)

#define ixf18100_sJ0_STRG_ADDR             8               
#define ixf18100_mJ0_STRG_ADDR             (0x3F << ixf18100_sJ0_STRG_ADDR)

/*1: During a write, the contents of J0StrgData is not transferred
 *   to internal string memory. The J0StrgAddr is written to
 *   determine the starting address for subsequent reads.
 *0: During a write the contents of J0StrgData is transferred to
 *   internal string memory.*/
#define ixf18100_sDSBL_J0_STRG_DATA_WR     14
#define ixf18100_mDSBL_J0_STRG_DATA_WR     (0x01 << ixf18100_sDSBL_J0_STRG_DATA_WR)

/*Value defines*/

/*7:0 J0StrgData[7:0] 
 *These bits are the J0 string data byte.
 *
 *13:8 J0StrgAddr[5:0] 
 *These bits are the index into internal J0 string. Whenever the
 *microprocessor reads this register, J0StrgAddr is automatically
 *incremented.
 *
 *15 Reserved NA
 */
/******************************************************************************/

/******************************************************************************/
/* TL_K1K2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_K1_K2_OFFSET      ixf18100_SONET_REG(0x0889)
#define ixf18100_TL_K1_K2_DFLT        0x0000

/*---------Shift and mask defines.------*/

/*These shifts and masks are used by both the Transmit and Receive register 
  blocks. Having been defined in the Receive block they do not need to be 
  defined again.
*/
#define ixf18100_sK2                 0               
#define ixf18100_mK2                 (0xFF << ixf18100_sK2)

#define ixf18100_sK1                 8               
#define ixf18100_mK1                 (0xFF << ixf18100_sK1)


/*Value defines*/

/*7:0 J0StrgData[7:0] 
 *These bits are the J0 string data byte.
 *
 *13:8 J0StrgAddr[5:0] 
 *These bits are the index into internal J0 string. Whenever the
 *microprocessor reads this register, J0StrgAddr is automatically
 *incremented.
 *
 *15 Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TL_S1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_S1_OFFSET        ixf18100_SONET_REG(0x088A)
#define ixf18100_TL_S1_DFLT          0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sS1                 0               
#define ixf18100_mS1                 (0xFF << ixf18100_sS1)

/*Value defines*/

/*[7:0] S1[7:0] 
 *These bits are the Synchronization Status Byte
 *
 *[15:8] Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TL_M0M1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_M0_M1_OFFSET        ixf18100_SONET_REG(0x088B)
#define ixf18100_TL_M0_M1_DFLT          0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sM0                 8        
#define ixf18100_mM0                 (0xFF << ixf18100_sM0)

#define ixf18100_sM1                 0               
#define ixf18100_mM1                 (0xFF << ixf18100_sM1)
/*Value defines*/

/*[7:0] M1[7:0] 
 *These bits are the Section REI Byte
 *
 *[15:8] M0[7:0]
 */
/******************************************************************************/

/******************************************************************************/
/* TL_NU9 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_NU9_0_OFFSET     ixf18100_SONET_REG(0x088C)
#define ixf18100_TL_NU9_1_OFFSET     ixf18100_SONET_REG(0x098C)
#define ixf18100_TL_NU9_2_OFFSET     ixf18100_SONET_REG(0x0A8C)
#define ixf18100_TL_NU9_3_OFFSET     ixf18100_SONET_REG(0x0B8C)
#define ixf18100_TL_NU9_C_OFFSET     ixf18100_SONET_REG(0x0C8C)
#define ixf18100_TL_NU9_DFLT         0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sNU9                0               
#define ixf18100_mNU9                (0xFF << ixf18100_sNU9)

/*Value defines*/

/*[7:0] NU9[7:0] 
 *These bits are the National Use Byte in row 9.
 *
 *[15:8] Reserved
 */
/******************************************************************************/

/******************************************************************************/
/* TL_NU1_2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_NU1_2_0_OFFSET   ixf18100_SONET_REG(0x088D)
#define ixf18100_TL_NU1_2_1_OFFSET   ixf18100_SONET_REG(0x098D)
#define ixf18100_TL_NU1_2_2_OFFSET   ixf18100_SONET_REG(0x0A8D)
#define ixf18100_TL_NU1_2_3_OFFSET   ixf18100_SONET_REG(0x0B8D)
#define ixf18100_TL_NU1_2_C_OFFSET   ixf18100_SONET_REG(0x0C8D)
#define ixf18100_TL_NU1_2_DFLT       0xAA00

/*---------Shift and mask defines.------*/

#define ixf18100_sNU2                0               
#define ixf18100_mNU2                (0xFF << ixf18100_sNU2)

#define ixf18100_sNU1                8
#define ixf18100_mNU1                (0xFF << ixf18100_sNU1)

/*Value defines*/

/*[7:0] NU2[7:0] 
 *These bits are the National Use Byte in row 2.
 *
 *[15:8] NU1[7:0] 
 *These bits are the National Use Byte in row 1.
 */
/******************************************************************************/

/******************************************************************************/
/* TL_TOH_BYPASS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_TL_TOH_BYPASS_0_OFFSET   ixf18100_SONET_REG(0x088F)
#define ixf18100_TL_TOH_BYPASS_1_OFFSET   ixf18100_SONET_REG(0x098F)
#define ixf18100_TL_TOH_BYPASS_2_OFFSET   ixf18100_SONET_REG(0x0A8F)
#define ixf18100_TL_TOH_BYPASS_3_OFFSET   ixf18100_SONET_REG(0x0B8F)
#define ixf18100_TL_TOH_BYPASS_C_OFFSET   ixf18100_SONET_REG(0x0C8F)
#define ixf18100_TL_TOH_BYPASS_DFLT       0x0000

/*---------Shift and mask defines.------*/

#define ixf18100_sTOH_BYPASS         0               
#define ixf18100_mTOH_BYPASS         (0x3 << ixf18100_sTOH_BYPASS)

/*Value defines*/

/*TOH Insertion Bypass Mode. */
#define ixf18100_TOH_INSERTION_ACTIVE     (0x0 << ixf18100_sTOH_BYPASS)       
#define ixf18100_ALL_DATA_PASS_THROUGH    (0x3 << ixf18100_sTOH_BYPASS)       

/*[1:0] TOHBypass[1:0] 
 *These bits are the TOH insertion bypass mode.
 *
 *[15:2] Unused
 */
/******************************************************************************/

/* END --- SONET TX REGISTERS */


/* START --- SONET APS-LITE REGISTERS */
/******************************************************************************/
/* APS_SRESET Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_SRESET_OFFSET		 ixf18100_SONET_REG(0x1001)
#define ixf18100_APS_SRESET_DFLT		 0x0000

/*---------Shift and mask defines.------*/
/*Use SRESET Register definition.*/
/*Bits 0-3, 6-8 only */

/******************************************************************************/

/******************************************************************************/
/* APS_GLOBAL_INT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_GLOBAL_INT_OFFSET		ixf18100_SONET_REG(0x1010)
#define ixf18100_APS_GLOBAL_INT_DFLT		0x0000

/*---------Shift and mask defines.------*/
/*Use WIS_INT Register definition.*/
/*Bits 3-4 only */         

/******************************************************************************/

/******************************************************************************/
/* APS_GLOBAL_INT_EN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_GLOBAL_INT_EN_OFFSET		ixf18100_SONET_REG(0x1011)
#define ixf18100_APS_GLOBAL_INT_EN_DFLT		    0x0000

/*---------Shift and mask defines.------*/
/*Use WIS_INT_EN Register definition.*/
/*Bits 3-4 only */         

/******************************************************************************/

/******************************************************************************/
/* APS_RL_SOH_CFG Register*/

/*Offset/Default definition.*/
#define ixf18100_APS_RL_SOH_CFG_OFFSET   ixf18100_SONET_REG(0x1100)
#define ixf18100_APS_RL_SOH_CFG_DFLT     0x0200

/*---------Shift and mask defines.------*/
/*Use RL_SOH_CFG Register definition.*/
/*Bits 4, 6-7, 9-10, 14-15 only */

/******************************************************************************/

/******************************************************************************/
/*APS_RL_LOF_LMN Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_LOF_LMN_OFFSET       ixf18100_SONET_REG(0x1102)
#define ixf18100_APS_RL_LOF_LMN_DFLT         0x6058 

/*Bit defines and mask defines.*/
/*Use RL_LOF_LMN Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_RL_J0_ESTRA Register */

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_J0_ESTRA_OFFSET      ixf18100_SONET_REG(0x1103)
#define ixf18100_APS_RL_J0_ESTRA_DFLT        0x0000

/*Bit defines and mask defines.*/
/*Use RL_J0_ESTRA Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_RL_J0_ASTRA Register */

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_J0_ASTRA_OFFSET      ixf18100_SONET_REG(0x1104)
#define ixf18100_APS_RL_J0_ASTRA_DFLT        0x0000

/*Bit defines and mask defines.*/
/*Use RL_J0_ASTRA Register definition.*/

/******************************************************************************/

/******************************************************************************/
/*APS_RL_J0_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_J0_CFG_OFFSET       ixf18100_SONET_REG(0x1105)
#define ixf18100_APS_RL_J0_CFG_DFLT         0x0002 

/*Bit defines and mask defines.*/
/*Use RL_J0_CFG Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_RL_SOH_IS Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_SOH_IS_OFFSET    ixf18100_SONET_REG(0x1110)
/*Default value not applicable tothis register*/

/*---------Shift and mask defines.------*/
/*Use RL_SOH_IS Register definition.*/
/*Bits 0-1, 3, 7-9 only */

/******************************************************************************/

/******************************************************************************/
/* APS_RL_SOH_IE Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_SOH_IE_OFFSET    ixf18100_SONET_REG(0x1111)
#define ixf18100_APS_RL_SOH_IE_DFLT      0x0000 

/*---------Shift and mask defines.------*/
/*Use RL_SOH_IE Register definition.*/
/*Bits 0-1, 3, 7-9 only */

/******************************************************************************/

/******************************************************************************/
/* APS_RL_SOH_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_SOH_S_OFFSET     ixf18100_SONET_REG(0x1112)
/*Default value not applicable to this register*/

/*---------Shift and mask defines.------*/
/*Use RL_SOH_S Register definition.*/
/*Bits 0-1, 3 only */

/******************************************************************************/

/******************************************************************************/
/* APS_RL_OOF_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_OOF_ECNT_OFFSET      ixf18100_SONET_REG(0x1113)
/*Default value not applicable tothis register*/

/*---------Shift and mask defines.------*/
/*Use RL_OOF_ECNT Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_RL_B1BIP_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_B1BIP_ECNT_OFFSET    ixf18100_SONET_REG(0x1114)
#define ixf18100_APS_RL_B1BIP_ECNT_DFLT      0x0000 

/*---------Shift and mask defines.------*/
/*Use RL_B1BIP_ECNT Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_RL_B1BLK_ECNT Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_B1BLK_ECNT_OFFSET    ixf18100_SONET_REG(0x1115)
#define ixf18100_APS_RL_B1BLK_ECNT_DFLT      0x0000 

/*---------Shift and mask defines.------*/
/*Use RL_B1BLK_ECNT Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_RL_LOH_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_LOH_CFG_OFFSET   ixf18100_SONET_REG(0x1140)
#define ixf18100_APS_RL_LOH_CFG_DFLT     0x0180 

/*---------Shift and mask defines.------*/
/*Use RL_LOH_CFG Register definition.*/
/******************************************************************************/

/******************************************************************************/
/*APS_RL_WINSZ_SB2 .. APS_RL_ENUM_NEXCWIN Registers*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_WINSZ_SB2_OFFSET    ixf18100_SONET_REG(0x1141)
#define ixf18100_APS_RL_CWIN_SB2_OFFSET     ixf18100_SONET_REG(0x1142)
#define ixf18100_APS_RL_ENUM_EXCWIN_OFFSET  ixf18100_SONET_REG(0x1143)
#define ixf18100_APS_RL_WINSZ_CB2_OFFSET    ixf18100_SONET_REG(0x1144)
#define ixf18100_APS_RL_CWIN_CB2_OFFSET     ixf18100_SONET_REG(0x1145)
#define ixf18100_APS_RL_ENUM_NEXCWIN_OFFSET ixf18100_SONET_REG(0x1146)

/*Use RL_WINSZ_SB2_DFLT .. RL_ENUM_NEXCWIN_DFLT register default */

/*Bit defines and mask defines.*/
/*Use RL_WINSZ_SB2 .. RL_RNUM_NEXCWIN Register definition.*/
/******************************************************************************/

/******************************************************************************/
/*APS_RL_WINSZ_SDEGB2 .. APS_RL_ENUM_NDEGWIN Registers*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_WINSZ_SDEGB2_W0_OFFSET  ixf18100_SONET_REG(0x1148)
#define ixf18100_APS_RL_WINSZ_SDEGB2_W1_OFFSET  ixf18100_SONET_REG(0x1147)

#define ixf18100_APS_RL_CWIN_SDEGB2_OFFSET      ixf18100_SONET_REG(0x1149)
#define ixf18100_APS_RL_ENUM_DEGWIN_OFFSET      ixf18100_SONET_REG(0x114A)

#define ixf18100_APS_RL_WINSZ_CDEGB2_W0_OFFSET  ixf18100_SONET_REG(0x114C)
#define ixf18100_APS_RL_WINSZ_CDEGB2_W1_OFFSET  ixf18100_SONET_REG(0x114B)

#define ixf18100_APS_RL_CWIN_CDEGB2_OFFSET      ixf18100_SONET_REG(0x114D)
#define ixf18100_APS_RL_ENUM_NDEGWIN_OFFSET     ixf18100_SONET_REG(0x114E)

/*Use RL_WINSZ_SDEGB2_DFLT .. RL_ENUM_NDEGWIN_DFLT register default */

/*Bit defines and mask defines.*/
/*Use RL_WINSZ_SDEGB2 .. RL_RNUM_NDEGWIN Register definition.*/
/******************************************************************************/

/******************************************************************************/
/* APS_RL_LOH_IS, APS_RL_LOH_IE, APS_RL_LOH_S Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_LOH_IS_OFFSET   ixf18100_SONET_REG(0x1150)
#define ixf18100_APS_RL_LOH_IE_OFFSET   ixf18100_SONET_REG(0x1151)
#define ixf18100_APS_RL_LOH_S_OFFSET    ixf18100_SONET_REG(0x1152)
/*Default values are not applicable to this register.*/

/*Shift and mask defines.*/
/*Use RL_LOH_IS, RL_LOH_IE, RL_LOH_S Register definition.*/
/******************************************************************************/

/******************************************************************************/
/* APS_RL_K2_K1 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_RL_K2_K1_OFFSET            ixf18100_SONET_REG(0x1153)
#define ixf18100_APS_RL_S1_OFFSET               ixf18100_SONET_REG(0x1154)

#define ixf18100_APS_RL_B2BLK_ECNT_W0_OFFSET    ixf18100_SONET_REG(0x1161)
#define ixf18100_APS_RL_B2BLK_ECNT_W1_OFFSET    ixf18100_SONET_REG(0x1160)

#define ixf18100_APS_RL_B2BIP_ECNT_W0_OFFSET    ixf18100_SONET_REG(0x1163)
#define ixf18100_APS_RL_B2BIP_ECNT_W1_OFFSET    ixf18100_SONET_REG(0x1162)

#define ixf18100_APS_RL_REIL_BLK_CNT_W0_OFFSET  ixf18100_SONET_REG(0x1165)
#define ixf18100_APS_RL_REIL_BLK_CNT_W1_OFFSET  ixf18100_SONET_REG(0x1164)

#define ixf18100_APS_RL_REIL_BIP_CNT_W0_OFFSET  ixf18100_SONET_REG(0x1167)
#define ixf18100_APS_RL_REIL_BIP_CNT_W1_OFFSET  ixf18100_SONET_REG(0x1166)


/* The following alias is included to allow consistent
** naming between RL and TL Registers. */
#define ixf18100_APS_RL_K1_K2_OFFSET    ixf18100_APS_RL_K2_K1_OFFSET
/*Default values are not applicable to this register.*/

/*Shift and mask defines.*/
/*Use RL_K2_K1,RL_S1,RL_B2BLK_ECNT,RL_B2BIP_ECNT,RL_REIL_BLK_CNT,RL_REIL_BIP_CNT Register definition.*/

/******************************************************************************/

/******************************************************************************/
/* APS_TL_TOH_CFG Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_TL_TOH_CFG_OFFSET       ixf18100_SONET_REG(0x1880)
#define ixf18100_APS_TL_TOH_CFG_DFLT         0x8080

/*---------Shift and mask defines.------*/
/*Use TL_TOH_CFG Register definition.*/
/*Bits 0-1, 4-5, 12 only */

/******************************************************************************/

/******************************************************************************/
/* APS_TL_SC1_TOH Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_TL_SC1_TOH_OFFSET       ixf18100_SONET_REG(0x1882)
#define ixf18100_APS_TL_SC1_TOH_DFLT         0x8001

/*---------Shift and mask defines.------*/
/*Use TL_SC1_TOH Register definition.*/
/*Bit 15 only */

#define ixf18100_sK1K2_SRC                   0

/******************************************************************************/

/******************************************************************************/
/* APS_TL_K1K2 Register*/

/*Offset/Default definition for register.*/
#define ixf18100_APS_TL_K1_K2_OFFSET      ixf18100_SONET_REG(0x1889)
#define ixf18100_APS_TL_K1_K2_DFLT        0x0000

/*---------Shift and mask defines.------*/
/*Use TL_K1K2 Register definition.*/

/******************************************************************************/

/* END --- SONET APS-LITE REGISTERS */




#endif /* ifndef __ixf18100_SONET_B_H__ */
